/*
 Promitnuti zmeny uctu na polozce faktury na navazane doklady

 Autor:        Jan Besta
*/
create or replace function dPolFakUpdateUcty() returns trigger as $$
declare typPohyb character varying(50);
        nelzeZmena int;
        idDokl int;
begin
  -- test zda smi dojit ke zmene na dokladu
  if ((select zamek from dDoklFak where idDoklFak = NEW.idDoklFak) = true) then
    raise exception 'dDoklFakUpdateUcty(): Dochz ke zmn na poloce faktury, kter je zamen.';
  end if;

  if (NEW.typPolozkyK = 'typPolozky.katalog') then
      -- nacteni typu pohybu
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;

      -- prijata faktura
      if (typPohyb = 'typPohybu.vydej') then
        -- zjistime zda neexistujou nake co nesmime zmenit
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl');
        -- pokud smime zmenit vsechny polozky co potrebujeme menime
        if (nelzeZmena = 0) then
          update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and idPolSklad in
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl');
        else
          raise exception 'dPolFakUpdateUcty(): Nelze zmnit et u navzan poloky.';
        end if;
      end if;
  end if;

  if (NEW.typPolozkyK in ('typPolozky.odpocetZdd','typPolozky.odpocetZalohy')) then
      -- nacteni typu pohybu
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;

      -- vydana faktura
      if (typPohyb = 'typPohybu.prijem') then
        -- meni se ucet zakladu
        if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false) then
          -- polozka odpocitava zdd
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and 
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklDalUcet) = false)
            loop
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklDalUcet);
            end loop;
          end if;
          -- polozka odpocitava zalohu
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklDalUcet) = false and idDoklInt in
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))
            loop
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklDalUcet);
            end loop;
          end if;
        end if;    -- konec zmena uctu zakladu

        -- meni se ucet dane
        if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then
          -- polozka odpocitava zdd
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then
            -- dph je zakladni
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and 
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)
              loop
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphDalUcet);
              end loop;
            end if;   -- konec dph zakladni

            -- dph je snizena
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and 
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)
              loop
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphDalUcet);
              end loop;
            end if;-- konec dph snizena
          end if;  -- konec odpocet zdd
        end if;    -- konec zmena uctu dane

      end if;      -- konec jedna se o vydanou fakturu

      --------------------------------------------------------------------------
      -- prijata faktura
      if (typPohyb = 'typPohybu.vydej') then
        -- meni se ucet zakladu
        if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false) then
          -- polozka odpocitava zdd
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and 
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklMdUcet) = false)
            loop
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklMdUcet);
            end loop;
          end if;

          -- polozka odpocitava zalohu
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklMdUcet) = false and idDoklInt in
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))
            loop
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklMdUcet);
            end loop;
          end if;
        end if;    -- konec zmena uctu zakladu

        -- meni se ucet dane
        if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then
          -- polozka odpocitava zdd
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then
            -- dph je zakladni
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and 
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)
              loop
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphMdUcet);
              end loop;

            end if;   -- konec dph zakladni

            -- dph je snizena
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and 
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)
              loop
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphMdUcet);
              end loop;
            end if;-- konec dph snizena
          end if;  -- konec odpocet zdd
        end if;    -- konec zmena uctu dane

      end if;      -- konec jedna se o prijatou fakturu

  end if;       -- konec podminky na typ dokladu

  return NEW;
end;
$$ LANGUAGE plpgsql;


drop trigger if exists dPolFakUpdateUcty on dpolfak;

create trigger dPolFakUpdateUcty after update on dpolfak
for each row execute procedure dPolFakUpdateUcty();