-- trigger volany pri vytvoreni nebo zmene obchodni polozky
CREATE OR REPLACE FUNCTION dpolobchupdaterezer()
  RETURNS trigger AS $$
begin
  if (tg_op = 'UPDATE') then
    -- pokud se jedna o update a meni se realizovane mnozstvi, postara se o to trigger na skladu
    if (OLD.mnozMjReal <> NEW.mnozMjReal) then
      return NEW;
    end if;
  end if;

  perform rezervujPolObch(NEW.idPolObch);
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolobchupdaterezer() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulku položek obchodnich dokladů
CREATE TRIGGER dpolobchupdaterezer AFTER INSERT OR UPDATE ON dpolobch
  FOR EACH ROW EXECUTE PROCEDURE dpolobchupdaterezer();
  