/**
 * odecte obrat stare hodnoty odpisu v tabulce uObraty
 * pricte obrat nove hodnoty odpisu v tabulce uObraty
 *
 * @author jdrahos
 */
create or replace function mMajetekUpdateUcto() returns trigger as $$
begin
  -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu
  -- dosazujeme -1 a za sumZklMen 0.0
  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,
       -1, OLD.idStred, -OLD.sumZkl, 0.0);

  -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu
  -- dosazujeme null a za sumZklMen 0.0
  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,
       -1, NEW.idStred, NEW.sumZKl, 0.0);
       
  return NEW;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists mOdpisUpdateUcto on mdanodpisy;
drop trigger if exists mOdpisUpdateUcto on mucetodpisy;
drop trigger if exists mMajetekUpdateUcto on mdanodpisy;
drop trigger if exists mMajetekUpdateUcto on mucetodpisy;
drop trigger if exists mMajetekUpdateUcto on mudalosti;

create trigger mMajetekUpdateUcto before update on mdanodpisy
for each row execute procedure mMajetekUpdateUcto();

create trigger mMajetekUpdateUcto before update on mucetodpisy
for each row execute procedure mMajetekUpdateUcto();

create trigger mMajetekUpdateUcto before update on mUdalosti
for each row execute procedure mMajetekUpdateUcto();