﻿/*
 Vrací počet MJ, který byl na dané skladové kartě zaúčtován k danému dni
 a před danou položkou (tj. ignorují se skladové pohyby následující
 za danou položkou ve stejný den).

 @param i_skladkartaid - id skladové karty
 @param i_datum - datum, ke kterému chceme zjistit stav na skladové kartě
 @param i_polskladid - id položky sklad

 Autor:  Martin Šour
*/
CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer)
  RETURNS numeric AS
$BODY$
declare
  _pocMj numeric(19,6);
  _obratMj numeric(19,6);
  _stavMj numeric(19,6);
begin
  SELECT pocatMj INTO _pocMj
  FROM sKarty
  WHERE idKarty = i_skladkartaid;
  
  if (i_datum is null) then
    raise exception '0005:dGetStavNaSklade : Vstupni parametr datum je null.'; 
  end if;

  if (i_polSkladId < 0) then
    SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj
    FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad
    WHERE idkarty = i_skladkartaid AND ps.datUcto <= i_datum;
  else
    SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj
    FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad
    WHERE idkarty = i_skladkartaid AND ps.datUcto <= i_datum AND ps.idPolSklad < i_polskladid;
  end if;
  if(_obratMj is null) then _obratMj = 0.0; end if;
  if(_pocMj is null) then _pocMj = 0.0; end if; 
  _stavMj = _pocMj + _obratMj;

  RETURN _stavMj;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;