CREATE OR REPLACE FUNCTION dupdatedoklintjakuhrk (in _iddoklint integer)
  RETURNS void AS $$
DECLARE
  _jakuhrk character varying(50);
BEGIN

  _jakuhrk := null;

select jakuhrk into _jakuhrk
from (

select di_iddoklint, di_kod, di_sumcelkem, di_sumcelkemmen, di_sparovano,
  sum(v_castka) as v_sumcastka,
  count(df_kod) as pocetdf, count(df_sumcelkem) as pocetdfazb,
  sum(df_sumcelkem) as df_sumcelkem, sum(df_sumcelkemmen) as df_sumcelkemmen,

  (case when (
      (di_sumcelkem <> 0 and di_sumcelkem = sum(v_castka) and sum(v_castka) = sum(df_sumcelkem)) or
      (di_sumcelkemmen <> 0 and di_sumcelkemmen = sum(v_castka) and sum(v_castka) = sum(df_sumcelkemmen)))
   then
      (case when (count(df_kod) = 1) then 'jakUhrazeno.rucne1' else 'jakUhrazeno.rucneN' end)
   else
      (case when (
        (di_sumcelkem <> 0 and di_sumcelkem = sum(v_castka)
           and ((sum(df_sumcelkem) > 0 and sum(v_castka) < sum(df_sumcelkem)) or
                (sum(df_sumcelkem) < 0 and sum(v_castka) > sum(df_sumcelkem))))
        or
        (di_sumcelkemmen <> 0 and di_sumcelkemmen = sum(v_castka)
           and ((sum(df_sumcelkemmen) > 0 and sum(v_castka) < sum(df_sumcelkemmen)) or
                (sum(df_sumcelkemmen) < 0 and sum(v_castka) > sum(df_sumcelkemmen))))
      ) then 'jakUhrazeno.rucneCast' else null end)
   end) as jakuhrk

 from (
    select di.iddoklint as di_iddoklint, di.kod as di_kod, di.sumcelkem as di_sumcelkem, di.sumcelkemmen as di_sumcelkemmen,
      di.sparovano as di_sparovano, di.jakuhrk as di_jakuhrk,
      v.typvazbyk as v_typvazbyk, v.castka as v_castka,
      df.kod as df_kod,
      df.sumcelkem as df_sumcelkem, df.sumcelkemmen as df_sumcelkemmen
    from ddoklint di inner join (dvazebtab v inner join ddoklfak df on v.idtaba = df.iddoklfak) on di.iddoklint = v.idtabb
    where di.iddoklint = _iddoklint
      and (v.typvazbyk in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY'))
    union
    select di.iddoklint as di_iddoklint, di.kod as di_kod, di.sumcelkem as di_sumcelkem, di.sumcelkemmen as di_sumcelkemmen,
      di.sparovano as di_sparovano, di.jakuhrk as di_jakuhrk,
      v.typvazbyk as v_typvazbyk, v.castka as v_castka,
      null as df_kod,
      (case when (v.castka  > 0) then zb.sumcelkem else -zb.sumcelkem end) as df_sumcelkem,
      (case when (v.castka  > 0) then zb.sumcelkemmen else -zb.sumcelkemmen end) as df_sumcelkemmen
    from ddoklint di inner join (dvazebtab v inner join ddoklint zb on v.idtabb = zb.iddoklint) on di.iddoklint = v.idtaba
    where di.iddoklint = _iddoklint
      and (v.typvazbyk in ('typVazbyDokl.ZB'))
    ) as iq
group by di_iddoklint, di_kod, di_sumcelkem, di_sumcelkemmen, di_sparovano, di_jakuhrk

) as iq2;


update ddoklint
set jakuhrk = _jakuhrk
where iddoklint = _iddoklint;

END;
$$ LANGUAGE plpgsql;

ALTER FUNCTION public.dupdatedoklintjakuhrk (integer) OWNER TO %firmaRole%;

-- -----------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dvazebtabupdatedoklintjakuhrk()
  RETURNS trigger AS
$BODY$
declare
  ZAZNAM record;
  _iddoklint integer;
begin
  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;
  else
    ZAZNAM := NEW;
  end if;

  _iddoklint := null;
  if (ZAZNAM.typvazbyk in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY')) then
    _iddoklint := ZAZNAM.idtabb;
  end if;
  if (ZAZNAM.typvazbyk in ('typVazbyDokl.ZB')) then
    _iddoklint := ZAZNAM.idtaba;
  end if;

  if (_iddoklint is not null) then
    perform dupdatedoklintjakuhrk(_iddoklint);
  end if;

  return ZAZNAM;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;

ALTER FUNCTION dvazebtabupdatedoklintjakuhrk() OWNER TO %firmaRole%;

-- -----------------------------------------------------------------------------

DROP TRIGGER IF EXISTS dvazebtabupdatedoklintjakuhrk ON dvazebtab;

CREATE TRIGGER dvazebtabupdatedoklintjakuhrk
  AFTER INSERT OR UPDATE OR DELETE
  ON dvazebtab
  FOR EACH ROW
  EXECUTE PROCEDURE dvazebtabupdatedoklintjakuhrk();
