--------------------------------------------------
-- Bug 46583 - Při inicializaci a převodu skladu se smažou skladové položky - Sady a komplety 
--------------------------------------------------

CREATE OR REPLACE FUNCTION createPolSkladSada(_idPolDokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare
  _polDokl record;
  _doklad record;
  _polozkaSady record;
  _skladKarta record;
  _cenik record;
  _sklad record;
  _idDoklSklad integer;
  _idDoklad integer;
  _idMeny integer;
  _idUcetObdobi integer;
  _idPolSklad integer;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _i integer;
  _cisRad integer;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _cenaMj numeric(19,6);
  _kurz numeric(19,6);
  _isCiziMena boolean;
  _nasobic integer;
  _idSkladu integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _idTypUcOp integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _typPohybuSkladKVydej character varying;
  _skupZboz record;
  _datUcto date; 
  _datPosl date;
begin

  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak;
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt;
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if;
 
  if(_polDokl.datVyst >= '2014-01-01') then
    _datUcto = _polDokl.datUcto;
    if(_datUcto is null) then
      _datUcto = _polDokl.datVyst;
    end if;
  else
    _datUcto = _polDokl.datVyst;
  end if;


  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;

  _i = 0;

  select findIdUcetniObdobiKDatu(_datUcto) into _iducetobdobi;

  FOR _polozkaSady IN
    select * from cSady where idCenikSada = _polDokl.idCenik
  LOOP
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik;

    if(_cenik.skladove) then
      _i = _i + 1;
      _cisRad = 100 * _polDokl.cisRad + _i;

      _idSkladu = _polDokl.idBspSkl;

      select * into _skladKarta from skarty 
        where idSkladu = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi;

      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu
      if(_skladKarta is null) then
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu;
        select * into _skladKarta from skarty
          where idSkladu = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi;
        if(_skladKarta is null) then
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev;
        end if;
      else
        _idSkladu = _skladKarta.idSkladu;
      end if;

      select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true, _idSkladu) into _idDoklSklad;  
   
      if(_idDoklSklad is null) then  
        select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
        if(_idDoklSklad is null) then 
          return; 
        end if; 
      end if; 
 
      select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
      select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
 
      select idMeny, idTypUcOp, idstred, idcinnost, idZakazky 
        into _idMeny, _idTypUcOp, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad  
        from dDoklSklad where idDoklSklad = _idDoklSklad;  
 
      _nasobic = 1;
      if(_typDoklK like 'typDokladu.dobropis') then
        _nasobic = -1;
      end if;
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic;
      _cenaMj = _skladKarta.prumCenaTuz / _kurz;
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz;
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if;
    
      -- nastaveni uctu pro polSklad vydej 
      _kopZklMdUcet = false;
      _kopZklDalUcet = false;
      if(_typDoklK like 'typDokladu.dobropis') then
        -- dal ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven
        select idProtiUcetSklV into _idZklDalUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;
        if(_idZklDalUcet is null) then
          select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklDalUcet = true;
        end if;
        -- md ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklMdUcet from dBsp where idBsp = _idSkladu;
      else
        -- nastaveni uctu pro polSklad vydej 
        select typPohybuSkladK into _typPohybuSkladKVydej from ddoklsklad where iddoklsklad = _idDoklSklad;
        select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik); 
    
        if(_skupzboz.idskupzboz is not null) then
          -- Úpravy dle Bug 32848 – [WinStrom] - nerespektování upřesnění typu pohybu při tvorbě výdejky
          if(_typPohybuSkladKVydej is null) then
            _idZklMdUcet = _skupZboz.idprotiucetsklv;
          -- typPohybuSklad.vydejHoly -  Holý" výdej  - idprotiucetsklholyv
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejHoly') then
            _idZklMdUcet = _skupZboz.idprotiucetsklholyv;
          -- typPohybuSklad.vydejPoFak - Výdej po faktuře  - idprotiucetsklv
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoFak') then
            _idZklMdUcet = _skupZboz.idprotiucetsklv;
          -- typPohybuSklad.vydejPolot - Výdej polotovaru - idprotiucetsklholyv
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPolot') then
            _idZklMdUcet = _skupZboz.idprotiucetsklholyv;
          -- typPohybuSklad.vydejPoObch - Výdej po objednávce  -  idprotiucetsklv
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoObch') then
            _idZklMdUcet = _skupZboz.idprotiucetsklv;
          -- typPohybuSklad.vydejPrevod -  Výdej pro převodku  - idprotiucetsklprevv
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPrevod') then
            _idZklMdUcet = _skupZboz.idprotiucetsklprevv;
          -- typPohybuSklad.vydejProFakCenik - Výdej pro fakturaci (ceny z ceníku) - idprotiucetsklv
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakCenik') then
            _idZklMdUcet = _skupZboz.idprotiucetsklv;
          -- typPohybuSklad.vydejProFakRucne - Výdej pro fakturaci (ceny ručně) - idprotiucetsklv
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakRucne') then
            _idZklMdUcet = _skupZboz.idprotiucetsklv; 
          --typPohybuSklad.vydejVyrob - Výdej výrobku  - idprotiucetsklholyv
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejVyrob') then
            _idZklMdUcet = _skupZboz.idprotiucetsklholyv; 
          end if;
        end if; 
    
        if(_idZklMdUcet is null) then
          -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
          select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklMdUcet = true;
        end if;
        -- dal ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklDalUcet from dBsp where idBsp = _idSkladu;
      end if; 
 
      _kopStred = true;
      if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
        _kopStred = false;
      end if;
      _kopCinnost = true;
      if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
        _kopCinnost = false;
      end if;
      _kopZakazku = true;
      if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
        _kopZakazku = false;
      end if;

      select nextval('seq_dpolsklad') into _idPolSklad;
      insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, kopDatUcto, modul, typPolozkyK, idDoklSklad,
          mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
          nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni, eanKod, 
          idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp)
        values (_idPolSklad, LOCALTIMESTAMP, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, LOCALTIMESTAMP, _datUcto, _polDokl.kopDatUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad,    
          _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, 0.0, _cenik.idmj1,
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _polDokl.datTrvan, _polDokl.datVyroby, _cisRad, true, _cenik.eanKod,
          _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp);

      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)  
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');  

      _datPosl = greatest(_datPosl, (select datposl from skarty where idkarty = _skladKarta.idkarty));
    end if; 
  END LOOP; 
  
  _datPosl = coalesce(_datPosl, _polDokl.datVyst);
  update skarty set datposl = _datPosl where idSkladu = _polDokl.idBspSkl and idCenik = _polDokl.idCenik and idUcetObdobi = _idUcetObdobi;

  execute sprepoctiSumyDokladu(_idDoklSklad); 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSkladSada(integer, character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION fillPolSkladSada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
  _datUcto date;
begin
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 
 
  if(_polDokl.datVyst >= '2014-01-01') then
    _datUcto = _polDokl.datUcto;
    if(_datUcto is null) then
      _datUcto = _polDokl.datVyst;
    end if;
  else
    _datUcto = _polDokl.datVyst;
  end if; 

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if;

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  update skarty set datposl = _polDokl.datVyst where idSkladu = _polDokl.idBspSkl and idCenik = _polDokl.idCenik and idUcetObdobi = _idUcetObdobi;

  for _polSklad in  
    select * from dPolSklad where idPolSklad in ( 
      select idTabB from dvazebtab where 
        typVazbyK like 'typVazbyDokl.polozkaSklSada'  
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    ) 
  loop 
    select typPohybuK, idStred, idCinnost, idZakazky
      into _typPohybuSklad, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad
      from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;
     
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi; 
    select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
   
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _mnozMj = _polSklad.mnozMj; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    --TODO doresit zklMdUcet;
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
   
    _kopStred = _polSklad.kopStred;
    if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
      _kopStred = false;
    end if;
    _kopCinnost = _polSklad.kopCinnost;
    if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
      _kopCinnost = false;
    end if;
    _kopZakazku = _polSklad.kopZakazku;
    if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
      _kopZakazku = false;
    end if;

    update dPolSklad set  
      lastUpdate = LOCALTIMESTAMP,  
      cenaMj = _cenaMj,  
      mnozMj = _mnozMj,  
      sumZkl = _sumZkl,  
      sumZklMen = _sumZklMen,  
      --nazev = _polDokl.nazev,  
      --nazevA = _polDokl.nazevA,  
      --nazevB = _polDokl.nazevB,  
      --nazevC = _polDokl.nazevC,  
      datVyst = _polDokl.datVyst,  
      datUcto = _datUcto,
      kopDatUcto = _polDokl.kopDatUcto,
      baleniId = _polDokl.baleniId,  
      mnozBaleni = _polDokl.mnozBaleni,  
      --sarze = _polDokl.sarze,  
      --expirace = _polDokl.expirace,  
      --cisRad = _polDokl.cisRad,  
      --eankod = _polDokl.eanKod,  
      --idmj = _polDokl.idmj,
      datTrvan = _polDokl.datTrvan,
      datVyroby = _polDokl.datVyroby,
      idStred = _polDokl.idStred,  
      kopStred = _kopStred,
      idCinnost = _polDokl.idCinnost,
      kopCinnost = _kopCinnost,   
      idMeny = _polSklad.idMeny,  
      idZakazky = _polDokl.idZakazky,  
      kopZakazku = _kopZakazku,   
      --idZklMdUcet = _idZklMdUcet,  
      --idZklDalUcet = _idZklDalUcet,
      ucetni = true 
      where idPolSklad = _polSklad.idPolSklad; 
  end loop;
  --return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION skladprevedskladkarty(i_iducetobdobizdroj integer, i_iducetobdobicil integer, i_idskladkarty integer, i_limit integer, i_potvrzovatVynechani boolean, i_idskladkartyvynechat integer[], i_vynechatNulove boolean, i_minDatPosl date)
  RETURNS integer AS
$BODY$  
declare 
  _skladKartaZdroj record;
  _skladKartaCil record;
  _pocet integer;
  _resultId integer;
  _pocetSkladKaret integer;

  _sumPohybMj numeric(19,6);
  _sumPohybTuz numeric(19,6);
  _sumPohybMen numeric(19,6);
  _pozadavkyCil numeric(19,6);

  _pocatMj numeric(19,6);
  _pocatTuz numeric(19,6);
  _pocatMen numeric(19,6);
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _pozadavkyMj numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _stavMjSPozadavky numeric(19,6);
  _datPosl date;
  _rezervmj numeric(19,6);

  _skladPlatiDo date;
  _ucetObdobiCilOd date;
  _cenikPlatiDo integer;
begin 
  _pocet = 0; 
  _resultId = null; 

  if(i_idskladkarty = -1) then
    -- nejprve pokud v minulém účetním období došlo ke smazání skladové karty s nenulovým zůstatkem upravíme počátek
    -- skladové karty v novém účetním období
    update skarty set stavMj = stavMj - pocatMj, stavMjSPozadavky = stavMjSPozadavky - pocatMj, stavTuz = stavTuz - pocatTuz, stavMen = stavMen - pocatMen, pocatMj = 0.0, pocatTuz = 0.0, pocatMen = 0.0
      where idkarty in
       (select s2.idkarty
         from skarty s2
         left join skarty s1 on s2.idcenik = s1.idcenik and s2.idskladu = s1.idskladu and s1.iducetobdobi = i_iducetobdobizdroj
         where s2.iducetobdobi = i_iducetobdobicil and s1.iducetobdobi is null and (s2.pocatMj <> 0.0 or s2.pocatTuz <> 0.0));
  end if;
  
  for _skladKartaZdroj in (
    select * from skarty k where k.iducetobdobi = i_iducetobdobizdroj and k.idkarty > i_idskladkarty and (not i_potvrzovatVynechani or not k.idkarty = any(i_idskladkartyvynechat))
    order by idkarty limit i_limit) loop
      --select 1 into _pocetSkladKaret from sKarty k where k.idKarty = _skladKartaZdroj.idKarty limit 1; 
      --continue when _pocetSkladKaret is null; 

      _pocet = _pocet + 1; 
      --exit when _pocet > i_limit; 
      _resultId = _skladKartaZdroj.idKarty;

      -- zjistime zda v novem obdobi existuje karta
      select * into _skladKartaCil from skarty k 
        where k.idcenik = _skladKartaZdroj.idcenik and k.idskladu = _skladKartaZdroj.idskladu and k.iducetobdobi = i_iducetobdobicil;
      --raise exception '%', _skladKartaCil;
      if(_skladKartaCil.idKarty is not null) then
        _sumPohybMj = _skladKartaCil.stavMj - _skladKartaCil.pocatMj;
        _sumPohybTuz = _skladKartaCil.stavTuz - _skladKartaCil.pocatTuz;
        _sumPohybMen = _skladKartaCil.stavMen - _skladKartaCil.pocatMen;
        select coalesce(sum(p.mnozMjPlan), 0.0) into _pozadavkyCil from dpolsklad p 
          where p.mnozMj = 0.0 and p.mnozMjPlan <> 0.0 and p.idkarty = _skladKartaCil.idkarty and p.storno = false;

        _stavMj = _skladKartaZdroj.stavMj + _sumPohybMj;
        _pocatMj = _skladKartaZdroj.stavMj;
        _pocatTuz = _skladKartaZdroj.stavTuz;
        _pocatMen = _skladKartaZdroj.stavMen;
        _stavTuz = _skladKartaZdroj.stavTuz + _sumPohybTuz;
        _stavMen = _skladKartaZdroj.stavMen + _sumPohybMen;
        _pozadavkyMj = _skladKartaZdroj.pozadavkyMj + _pozadavkyCil;
        _prumCenaTuz = (case when _stavMj is null or _stavMj = 0 then _skladKartaCil.prumCenaTuz else round((_skladKartaZdroj.stavTuz + _sumPohybTuz) / _stavMj, 6) end);
        _prumCenaMen = (case when _stavMj is null or _stavMj = 0 then _skladKartaCil.prumCenaMen else round((_skladKartaZdroj.stavMen + _sumPohybMen) / _stavMj, 6) end);
        _stavMjSPozadavky = _stavMj - (_skladKartaZdroj.pozadavkyMj + _pozadavkyCil);
        _datPosl = greatest((select max(datVyst) from dpolsklad where idkarty = _skladKartaCil.idKarty), _skladKartaZdroj.datPosl, _skladKartaCil.datposl);
        _rezervmj = _skladKartaZdroj.rezervmj;

        if(
            (not comparenumeric(_pocatMj, _skladKartaCil.pocatMj)) or
            (not comparenumeric(_pocatTuz, _skladKartaCil.pocatTuz)) or
            (not comparenumeric(_pocatMen, _skladKartaCil.pocatMen)) or
            (not comparenumeric(_stavMj, _skladKartaCil.stavMj)) or
            (not comparenumeric(_stavTuz, _skladKartaCil.stavTuz)) or
            (not comparenumeric(_stavMen, _skladKartaCil.stavMen)) or
            (not comparenumeric(_pozadavkyMj, _skladKartaCil.pozadavkyMj)) or
            (not comparenumeric(_prumCenaTuz, _skladKartaCil.prumCenaTuz)) or
            (not comparenumeric(_prumCenaMen, _skladKartaCil.prumCenaMen)) or
            (not comparenumeric(_stavMjSPozadavky, _skladKartaCil.stavMjSPozadavky)) or
            (not comparedate(_datPosl, _skladKartaCil.datPosl)) or
            (not comparenumeric(_rezervmj, _skladKartaCil.rezervmj)) 
          ) then
          update skarty k set
              pocatMj = _pocatMj,
              pocatTuz = _pocatTuz,
              pocatMen = _pocatMen,
              stavMj = _stavMj,
              stavTuz = _stavTuz,
              stavMen = _stavMen,
              pozadavkyMj = _pozadavkyMj,
              prumCenaTuz = _prumCenaTuz,
              prumCenaMen = _prumCenaMen,
              stavMjSPozadavky = _stavMjSPozadavky,
              datPosl = _datPosl,
              rezervmj = _rezervmj
            where k.idkarty = _skladKartaCil.idKarty;
         end if;
      else
      
        -- podmínka "_skladKartaZdroj.datPosl is null" je tu, protože se mi při nenaskladnění na jeden ze skladů povedlo mít datPosl null 
        if(not i_potvrzovatVynechani and i_vynechatNulove and _skladKartaZdroj.stavMj = 0.0 and i_minDatPosl is not null and (_skladKartaZdroj.datPosl is null or _skladKartaZdroj.datPosl <= i_minDatPosl)) then
              --raise notice 'vynechavam - stavMj %, datPosl %, i_minDatPosl %', _skladKartaZdroj.stavMj, _skladKartaZdroj.datPosl, i_minDatPosl;
              -- vynechame nulove, ktere maji posledni pohyb pred vice nez x dny (bug 41190)
         else 

            select platiOdData into _ucetObdobiCilOd from nucetobdobi where iducetobdobi = i_iducetobdobicil;
            select platiDoData into _skladPlatiDo from nucetobdobi where iducetobdobi = (select iducetobdobido from dbsp where idbsp = _skladKartaZdroj.idskladu);
            if((_skladPlatiDo is not null) and (_skladPlatiDo < _ucetObdobiCilOd)) then
              -- pokud sklad již v novém účetním období neplatí nebudeme pro něj vytváře skladovou kartu
              continue;
            end if;

            select platiDo into _cenikPlatiDo from ccenik where idcenik = _skladKartaZdroj.idcenik;
            _cenikPlatiDo := least(_cenikPlatiDo, 9999);
            if(to_date(_cenikPlatiDo || '-12-31', 'YYYY-MM-DD') < _ucetObdobiCilOd) then
              -- pokud ceník již v novém účetním období neplatí nebudeme pro něj vytváře skladovou kartu
              continue;
            end if;
             
              --raise notice 'stavMj %, datPosl %, i_minDatPosl %', _skladKartaZdroj.stavMj, _skladKartaZdroj.datPosl, i_minDatPosl;
            insert into skarty(idskladu, idcenik, iducetobdobi,
                        stavmj, stavmjspozadavky, pozadavkymj, stavmen, stavtuz,
                        pocatmj, pocatmen, pocattuz, prumcenatuz, prumcenamen,
                        datposl, maxmj, minmj, poslcenamen, poslcenatuz,
                        nazev, nazeva, nazevb, nazevc,
                        popis, popisa, popisb, popisc, poznamvelka,
                        cenpopis, cenpopisa, cenpopisb, cenpopisc, cenpoznam,
                        idmistnost, idregal, idpolice, rezervmj )
                   values (_skladKartaZdroj.idskladu, _skladKartaZdroj.idcenik, i_iducetobdobicil,
                        _skladKartaZdroj.stavmj, _skladKartaZdroj.stavmjspozadavky, _skladKartaZdroj.pozadavkymj, _skladKartaZdroj.stavmen, _skladKartaZdroj.stavtuz,
                        _skladKartaZdroj.stavmj, _skladKartaZdroj.stavmen, _skladKartaZdroj.stavtuz, _skladKartaZdroj.prumcenatuz, _skladKartaZdroj.prumcenamen,
                        _skladKartaZdroj.datposl, _skladKartaZdroj.maxmj, _skladKartaZdroj.minmj, _skladKartaZdroj.poslcenamen, _skladKartaZdroj.poslcenatuz,
                        _skladKartaZdroj.nazev, _skladKartaZdroj.nazeva, _skladKartaZdroj.nazevb, _skladKartaZdroj.nazevc,
                        _skladKartaZdroj.popis, _skladKartaZdroj.popisa, _skladKartaZdroj.popisb, _skladKartaZdroj. popisc, _skladKartaZdroj.poznamvelka,
                        _skladKartaZdroj.cenpopis, _skladKartaZdroj.cenpopisa, _skladKartaZdroj.cenpopisb, _skladKartaZdroj.cenpopisc, _skladKartaZdroj.cenpoznam,
                        _skladKartaZdroj.idmistnost, _skladKartaZdroj.idregal, _skladKartaZdroj.idpolice, _skladKartaZdroj.rezervmj
                        );
          end if;
        end if;

  end loop;
  
  return _resultId; 
end;     
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION skladprevedskladkarty(integer, integer, integer, integer, boolean, integer[], boolean, date) OWNER TO %firmaRole%;

 -- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1094, 't', %appVersion%, clock_timestamp());