-----------------------------------------------------------------------
-- Bug 44706 - ccenik.eankod nemá index, ale v prodejní kase se podle EAN hledá
-----------------------------------------------------------------------

drop index if exists ccenik_eankod_upper_index;
drop index if exists ccenik_baleniean1_upper_index;
drop index if exists ccenik_baleniean2_upper_index;
drop index if exists ccenik_baleniean3_upper_index;
drop index if exists ccenik_baleniean4_upper_index;
drop index if exists ccenik_baleniean5_upper_index;
create index ccenik_eankod_upper_index on ccenik (upper(eankod::text)) where eankod is not null;
create index ccenik_baleniean1_upper_index on ccenik (upper(BaleniEan1::text)) where BaleniEan1 is not null;
create index ccenik_baleniean2_upper_index on ccenik (upper(BaleniEan2::text)) where BaleniEan2 is not null;
create index ccenik_baleniean3_upper_index on ccenik (upper(BaleniEan3::text)) where BaleniEan3 is not null;
create index ccenik_baleniean4_upper_index on ccenik (upper(BaleniEan4::text)) where BaleniEan4 is not null;
create index ccenik_baleniean5_upper_index on ccenik (upper(BaleniEan5::text)) where BaleniEan5 is not null;

-----------------------------------------------------------------------
-- Bug 44811 - Přidat index s podmínkou nad řazenou hodnotu dbversion v tabulce dbversion
-----------------------------------------------------------------------
 
drop index if exists dbversion_dbversion_index;
CREATE INDEX dbversion_dbversion_index ON dbversion(dbversion desc) WHERE needreimport = 't';

-----------------------------------------------------------------------
-- Bug 44813 - Zvážit přidání indexu nad sloupce iduzivatel, beankey u tabulky wcolumn  
-----------------------------------------------------------------------

drop index if exists wcolumn_iduzivatel_beankey_index;
CREATE INDEX wcolumn_iduzivatel_beankey_index ON wcolumn(iduzivatel, (upper(beankey::text))); 

-----------------------------------------------------------------------
-- Bug 44831 - Zvážit přidání indexu nad normalizovanou hodnotu sloupce varsym v tabulce ddoklfak  
-----------------------------------------------------------------------
drop index if exists ddoklfak_varsym;
drop index if exists ddoklfak_varsym_upper_index;
create index ddoklfak_varsym_upper_index on ddoklfak (upper(varsym::text));

drop index if exists ddoklint_varsym;
drop index if exists ddoklint_varsym_upper_index;
create index ddoklint_varsym_upper_index on ddoklint (upper(varsym::text));

drop index if exists ddoklsklad_varsym_upper_index;
create index ddoklsklad_varsym_upper_index on ddoklsklad (upper(varsym::text));

drop index if exists ddoklobch_varsym_upper_index;
create index ddoklobch_varsym_upper_index on ddoklobch (upper(varsym::text));


drop index if exists ddoklfak_cisobj_upper_index;
create index ddoklfak_cisobj_upper_index on ddoklfak (upper(cisobj::text)) where cisobj is not null;

-----------------------------------------------------------------------
-- Bug 44882 - Přidat index nad normalizované hodnoty sloupců ic a dic v tabulce aadresar   
-----------------------------------------------------------------------
drop index if exists aadresar_ic_upper_index;
CREATE INDEX aadresar_ic_upper_index ON aadresar(upper(ic::text));

drop index if exists aadresar_dic_upper_index;
CREATE INDEX aadresar_dic_upper_index ON aadresar(upper(dic::text));

drop index if exists ddoklfak_uuid_index;
drop index if exists ddoklint_uuid_index;
drop index if exists ddoklobch_uuid_index;
drop index if exists ddoklsklad_uuid_index;
 
-----------------------------------------------------------------------
-- Bug 44878 - Zvážit přidání indexu nad normalizovanou hodnotu sloupce buc v tabulce abanspoj
-----------------------------------------------------------------------
drop index if exists abanspoj_buc_index;
drop index if exists abanspoj_buc_upper_index;
CREATE INDEX abanspoj_buc_upper_index ON abanspoj USING btree (upper(buc::text));

-----------------------------------------------------------------------
-- Bug 44976 - Redukovat objem indexů pro tabulku wpriloha    
-----------------------------------------------------------------------
drop index if exists wPriloha_IdDoklFak_index;
CREATE INDEX wPriloha_IdDoklFak_index ON wPriloha USING btree (IdDoklFak) where IdDoklFak is not null;
drop index if exists wPriloha_IdDoklInt_index;
CREATE INDEX wPriloha_IdDoklInt_index ON wPriloha USING btree (IdDoklInt) where IdDoklInt is not null;
drop index if exists wPriloha_IdDoklObch_index;
CREATE INDEX wPriloha_IdDoklObch_index ON wPriloha USING btree (IdDoklObch) where IdDoklObch is not null;
drop index if exists wPriloha_IdDoklSklad_index;
CREATE INDEX wPriloha_IdDoklSklad_index ON wPriloha USING btree (IdDoklSklad) where IdDoklSklad is not null;
drop index if exists wPriloha_IdAdresar_index;
CREATE INDEX wPriloha_IdAdresar_index ON wPriloha USING btree (IdAdresar) where IdAdresar is not null;
drop index if exists wPriloha_IdKontakt_index;
CREATE INDEX wPriloha_IdKontakt_index ON wPriloha USING btree (IdKontakt) where IdKontakt is not null;
drop index if exists wPriloha_IdKonektor_index;
CREATE INDEX wPriloha_IdKonektor_index ON wPriloha USING btree (IdKonektor) where IdKonektor is not null;
drop index if exists wPriloha_IdNastav_index;
CREATE INDEX wPriloha_IdNastav_index ON wPriloha USING btree (IdNastav) where IdNastav is not null;
drop index if exists wPriloha_IdCenik_index;
CREATE INDEX wPriloha_IdCenik_index ON wPriloha USING btree (IdCenik) where IdCenik is not null;
drop index if exists wPriloha_IdUziv_index;
CREATE INDEX wPriloha_IdUziv_index ON wPriloha USING btree (IdUziv) where IdUziv is not null;
drop index if exists wPriloha_IdData_index;
CREATE INDEX wPriloha_IdData_index ON wPriloha USING btree (IdData) where IdData is not null;
drop index if exists wPriloha_IdReport_index;
CREATE INDEX wPriloha_IdReport_index ON wPriloha USING btree (IdReport) where IdReport is not null;
drop index if exists wpriloha_idadrudalost_index;
CREATE INDEX wpriloha_idadrudalost_index ON wpriloha USING btree (idadrudalost) where idadrudalost is not null;
drop index if exists wpriloha_idzakazky_index;
CREATE INDEX wpriloha_idzakazky_index ON wpriloha USING btree (idzakazky) where idzakazky is not null;
drop index if exists wpriloha_idmajetek_index;
CREATE INDEX wpriloha_idmajetek_index ON wpriloha USING btree (idmajetek) where idmajetek is not null;
drop index if exists wpriloha_idleasing_index;
CREATE INDEX wpriloha_idleasing_index ON wpriloha USING btree (idleasing) where idleasing is not null;
drop index if exists wpriloha_idosoba_index;
create index wpriloha_idosoba_index on wpriloha using btree (idosoba) where idosoba is not null;
drop index if exists wpriloha_iduzel_index;
create index wpriloha_iduzel_index on wpriloha using btree (iduzel) where iduzel is not null;
drop index if exists wpriloha_idpolsml_index;
create index wpriloha_idpolsml_index on wpriloha using btree (idpolsml) where idpolsml is not null;
drop index if exists wpriloha_idsmlouvy_index;
create index wpriloha_idsmlouvy_index on wpriloha using btree (idsmlouvy) where idsmlouvy is not null;

-----------------------------------------------------------------------
-- Bug 44899 - Zvážit přidání indexů zrychlujících získání dat pro boxíky Pohledávky a Závazky v Základním přehledu
----------------------------------------------------------------------- 
drop index if exists ddoklfak_dashboard_zavazky_index;
create index ddoklfak_dashboard_zavazky_index on ddoklfak (datvyst desc) where not prodejka and Modul = 'FAV' and not storno
 and ucetni and datsplat is not null and (StavUhrK is null or (StavUhrK is not null) and StavUhrK = 'stavUhr.castUhr');
 
drop index if exists ddoklfak_dashboard_pohledavky_index;
create index ddoklfak_dashboard_pohledavky_index on ddoklfak (datvyst desc) where not prodejka and Modul = 'FAP' and not storno
 and ucetni and (StavUhrK is null or (StavUhrK is not null) and StavUhrK = 'stavUhr.castUhr');
        
-----------------------------------------------------------------------
-- Bug 46782 - Zrušit primary key constraint nad tabulkou wzurnal
----------------------------------------------------------------------- 
alter table wzurnal drop constraint wzurnal_pkey;

-----------------------------------------------------------------------
-- Bug 44788 - Zmenšit rozsah vybraných indexů tabulky aadresar pro zmenšení zabraného místa
----------------------------------------------------------------------- 
drop index if exists aadresar_kod_index;
drop index if exists aadresar_idfastatu_index;
create index aadresar_idfastatu_index on aadresar(idfastatu) where idfastatu is not null;
drop index if exists aadresar_idformauhradycis_index;
create index aadresar_idformauhradycis_index on aadresar(idformauhradycis) where idformauhradycis is not null;
drop index if exists aadresar_idskupcen_index;
create index aadresar_idskupcen_index on aadresar(idskupcen) where idskupcen is not null;
drop index if exists aadresar_idstred_index;
create index aadresar_idstred_index on aadresar(idstred) where idstred is not null;
drop index if exists aadresar_idzodposoba_index;
create index aadresar_idzodposoba_index on aadresar(idzodposoba) where idzodposoba is not null;
drop index if exists aadresar_idskupfir_index;
create index aadresar_idskupfir_index on aadresar(idskupfir) where idskupfir is not null;

-----------------------------------------------------------------------
-- Bug 44780 - Zmenšit rozsah vybraných indexů tabulky dpolfak pro zmenšení zabraného místa 
----------------------------------------------------------------------- 
drop index if exists dpolfak_idcenhlad_index;
create index dpolfak_idcenhlad_index on dpolfak(idcenhlad) where idcenhlad is not null;
drop index if exists dpolfak_idcinnost_index;
create index dpolfak_idcinnost_index on dpolfak(idcinnost) where idcinnost is not null;
drop index if exists dpolfak_iddphpren_index;
create index dpolfak_iddphpren_index on dpolfak(iddphpren) where iddphpren is not null;
drop index if exists dpolfak_idfirmy_index;
create index dpolfak_idfirmy_index on dpolfak(idfirmy) where idfirmy is not null;
drop index if exists dpolfak_idmjobjem_index;
create index dpolfak_idmjobjem_index on dpolfak(idmjobjem) where idmjobjem is not null;
drop index if exists dpolfak_idpolfakpoplatek_index;
create index dpolfak_idpolfakpoplatek_index on dpolfak(idpolfakpoplatek) where idpolfakpoplatek is not null;
drop index if exists dpolfak_idzakazky_index;
create index dpolfak_idzakazky_index on dpolfak(idzakazky) where idzakazky is not null;
drop index if exists dpolfak_idbspskl_index;
create index dpolfak_idbspskl_index on dpolfak(idbspskl) where idbspskl is not null;
drop index if exists dpolfak_idcenik_index;
create index dpolfak_idcenik_index on dpolfak(idcenik) where idcenik is not null;
drop index if exists dpolfak_idclenkonvykdph_index;
create index dpolfak_idclenkonvykdph_index on dpolfak(idclenkonvykdph) where idclenkonvykdph is not null;
drop index if exists dpolfak_idmj_index;
create index dpolfak_idmj_index on dpolfak(idmj) where idmj is not null;
drop index if exists dpolfak_idsazbydphpuv_index;
create index dpolfak_idsazbydphpuv_index on dpolfak(idsazbydphpuv) where idsazbydphpuv is not null;
drop index if exists dpolfak_datucto;
CREATE INDEX dpolfak_datucto ON dpolfak(datucto);

-----------------------------------------------------------------------
-- Bug 44792 - Zmenšit rozsah vybraných indexů tabulky ddoklfak pro zmenšení zabraného místa 
----------------------------------------------------------------------- 
drop index if exists ddoklfak_dattermin;
create index ddoklfak_dattermin on ddoklfak(dattermin) where dattermin is not null;
drop index if exists ddoklfak_idbanspojdod_index;
create index ddoklfak_idbanspojdod_index on ddoklfak(idbanspojdod) where idbanspojdod is not null;
drop index if exists ddoklfak_idbsp_index;
create index ddoklfak_idbsp_index on ddoklfak(idbsp) where idbsp is not null;
drop index if exists ddoklfak_idcinnost_index;
create index ddoklfak_idcinnost_index on ddoklfak(idcinnost) where idcinnost is not null;
drop index if exists ddoklfak_idclenkonvykdph_index;
create index ddoklfak_idclenkonvykdph_index on ddoklfak(idclenkonvykdph) where idclenkonvykdph is not null;
drop index if exists ddoklfak_iddodatna_index;
create index ddoklfak_iddodatna_index on ddoklfak(iddodatna) where iddodatna is not null;
drop index if exists ddoklfak_idformadopravy_index;
create index ddoklfak_idformadopravy_index on ddoklfak(idformadopravy) where idformadopravy is not null;
drop index if exists ddoklfak_idformauhradyciskasa_index;
create index ddoklfak_idformauhradyciskasa_index on ddoklfak(idformauhradyciskasa) where idformauhradyciskasa is not null;
drop index if exists ddoklfak_idkontaktosoba_index;
create index ddoklfak_idkontaktosoba_index on ddoklfak(idkontaktosoba) where idkontaktosoba is not null;
drop index if exists ddoklfak_idmur_index;
create index ddoklfak_idmur_index on ddoklfak(idmur) where idmur is not null;
drop index if exists ddoklfak_idsmerkod_index;
create index ddoklfak_idsmerkod_index on ddoklfak(idsmerkod) where idsmerkod is not null;
drop index if exists ddoklfak_idsmlouvy_index;
create index ddoklfak_idsmlouvy_index on ddoklfak(idsmlouvy) where idsmlouvy is not null;
drop index if exists ddoklfak_idzakazky_index;
create index ddoklfak_idzakazky_index on ddoklfak(idzakazky) where idzakazky is not null;
drop index if exists ddoklfak_danevidk;
create index ddoklfak_danevidk on ddoklfak(danevidk) where danevidk is not null;
drop index if exists ddoklfak_iddphsniz2ucet_index;
create index ddoklfak_iddphsniz2ucet_index on ddoklfak(iddphsniz2ucet) where iddphsniz2ucet is not null;
drop index if exists ddoklfak_idfastatu_index;
create index ddoklfak_idfastatu_index on ddoklfak(idfastatu) where idfastatu is not null;
drop index if exists ddoklfak_idsazbydphsniz2_index;
create index ddoklfak_idsazbydphsniz2_index on ddoklfak(idsazbydphsniz2) where idsazbydphsniz2 is not null;
drop index if exists ddoklfak_index;

-----------------------------------------------------------------------
-- Bug 44784 - Zmenšit rozsah vybraných indexů tabulky dpolint pro zmenšení zabraného místa  
----------------------------------------------------------------------- 
drop index if exists dpolint_idbspskl_index;
create index dpolint_idbspskl_index on dpolint(idbspskl) where idbspskl is not null;
drop index if exists dpolint_idcenhlad_index;
create index dpolint_idcenhlad_index on dpolint(idcenhlad) where idcenhlad is not null;
drop index if exists dpolint_idcenik_index;
create index dpolint_idcenik_index on dpolint(idcenik) where idcenik is not null;
drop index if exists dpolint_idcinnost_index;
create index dpolint_idcinnost_index on dpolint(idcinnost) where idcinnost is not null;
drop index if exists dpolint_idclenkonvykdph_index;
create index dpolint_idclenkonvykdph_index on dpolint(idclenkonvykdph) where idclenkonvykdph is not null;
drop index if exists dpolint_iddphdalucet_index;
create index dpolint_iddphdalucet_index on dpolint(iddphdalucet) where iddphdalucet is not null;
drop index if exists dpolint_iddphmducet_index;
create index dpolint_iddphmducet_index on dpolint(iddphmducet) where iddphmducet is not null;
drop index if exists dpolint_iddphpren_index;
create index dpolint_iddphpren_index on dpolint(iddphpren) where iddphpren is not null;
drop index if exists dpolint_idfirmy_index;
create index dpolint_idfirmy_index on dpolint(idfirmy) where idfirmy is not null;
drop index if exists dpolint_idmj_index;
create index dpolint_idmj_index on dpolint(idmj) where idmj is not null;
drop index if exists dpolint_idmjobjem_index;
create index dpolint_idmjobjem_index on dpolint(idmjobjem) where idmjobjem is not null;
drop index if exists dpolint_idpolintpoplatek_index;
create index dpolint_idpolintpoplatek_index on dpolint(idpolintpoplatek) where idpolintpoplatek is not null;
drop index if exists dpolint_idsazbydphpuv_index;
create index dpolint_idsazbydphpuv_index on dpolint(idsazbydphpuv) where idsazbydphpuv is not null;
drop index if exists dpolint_idtypucop_index;
create index dpolint_idtypucop_index on dpolint(idtypucop) where idtypucop is not null;
drop index if exists dpolint_idzakazky_index;
create index dpolint_idzakazky_index on dpolint(idzakazky) where idzakazky is not null;
drop index if exists dpolint_datucto;
CREATE INDEX dpolint_datucto ON dpolint(datucto);

-----------------------------------------------------------------------
-- Bug 44790 - Zmenšit rozsah vybraných indexů tabulky ddoklint pro zmenšení zabraného místa   
----------------------------------------------------------------------- 
drop index if exists ddoklint_danevidk;
CREATE INDEX ddoklint_danevidk ON ddoklint(danevidk) where danevidk is not null;
drop index if exists ddoklint_dattermin;
CREATE INDEX ddoklint_dattermin ON ddoklint(dattermin) where dattermin is not null;
drop index if exists ddoklint_idbanspojdod_index;
CREATE INDEX ddoklint_idbanspojdod_index ON ddoklint USING btree (idbanspojdod) where idbanspojdod is not null;
drop index if exists ddoklint_idbspban_index;
CREATE INDEX ddoklint_idbspban_index ON ddoklint USING btree (idbspban) where idbspban is not null;
drop index if exists ddoklint_idcinnost_index;
CREATE INDEX dDoklInt_IdCinnost_index ON dDoklInt USING btree (IdCinnost) where idcinnost is not null;
drop index if exists ddoklint_idclenkonvykdph_index;
CREATE INDEX dDoklInt_IdClenKonVykDph_index ON dDoklInt USING btree (IdClenKonVykDph) where IdClenKonVykDph is not null;
drop index if exists ddoklint_iddodatna_index;
CREATE INDEX dDoklInt_IdDodatNa_index ON dDoklInt USING btree (IdDodatNa) where iddodatna is not null;
drop index if exists ddoklint_iddphsniz2ucet_index;
CREATE INDEX ddoklint_iddphsniz2ucet_index ON ddoklint USING btree (iddphsniz2ucet) where iddphsniz2ucet is not null;
drop index if exists ddoklint_iddphsnizucet_index;
CREATE INDEX ddoklint_iddphsnizucet_index ON ddoklint USING btree (iddphsnizucet) where iddphsnizucet is not null;
drop index if exists ddoklint_iddphzaklucet_index;
CREATE INDEX ddoklint_iddphzaklucet_index ON ddoklint USING btree (iddphzaklucet) where iddphzaklucet is not null;
drop index if exists ddoklint_idfastatu_index;
CREATE INDEX ddoklint_idfastatu_index ON ddoklint USING btree (idfastatu) where idfastatu is not null;
drop index if exists ddoklint_idformadopravy_index;
CREATE INDEX dDoklInt_IdFormaDopravy_index ON dDoklInt USING btree (IdFormaDopravy) where IdFormaDopravy is not null;
drop index if exists ddoklint_idformauhradycis_index;
CREATE INDEX dDoklInt_IdFormaUhradyCis_index ON dDoklInt USING btree (IdFormaUhradyCis) where IdFormaUhradyCis is not null;
drop index if exists ddoklint_idkontaktosoba_index;
CREATE INDEX dDoklInt_IdKontaktOsoba_index ON dDoklInt USING btree (IdKontaktOsoba) where idkontaktosoba is not null;
drop index if exists ddoklint_idmur_index;
CREATE INDEX ddoklint_idmur_index ON ddoklint USING btree (idmur) where idmur is not null;
drop index if exists ddoklint_idsmlouvy_index;
CREATE INDEX ddoklint_idsmlouvy_index ON ddoklint USING btree (idsmlouvy) where idsmlouvy is not null;
drop index if exists ddoklint_idtypdoklskl_index;
CREATE INDEX ddoklint_idtypdoklskl_index ON ddoklint USING btree (idtypdoklskl) where idtypdoklskl is not null;
drop index if exists ddoklint_idtypucop_index;
CREATE INDEX dDoklInt_IdTypUcOp_index ON dDoklInt USING btree (IdTypUcOp) where idtypucop is not null;
drop index if exists ddoklint_idzakazky_index;
CREATE INDEX ddoklint_idzakazky_index ON ddoklint USING btree (idzakazky) where idzakazky is not null;
drop index if exists ddoklint_idsazbydphsniz2_index;
CREATE INDEX ddoklint_idsazbydphsniz2_index ON ddoklint USING btree (idsazbydphsniz2) where idsazbydphsniz2 is not null;
drop index if exists ddoklint_index;

-----------------------------------------------------------------------
-- Bug 44787 - Zmenšit rozsah vybraných indexů tabulky dpolsklad pro zmenšení zabraného místa   
----------------------------------------------------------------------- 
drop index if exists dpolsklad_idcenhlad_index;
CREATE INDEX dpolsklad_idcenhlad_index ON dpolsklad USING btree (idcenhlad) where idcenhlad is not null;
drop index if exists dpolsklad_idcinnost_index;
CREATE INDEX dPolSklad_IdCinnost_index ON dPolSklad USING btree (IdCinnost) where idcinnost is not null;
drop index if exists dpolsklad_idclendph_index;
CREATE INDEX dpolsklad_idclendph_index ON dpolsklad USING btree (idclendph) where idclendph is not null;
drop index if exists dpolsklad_idclenkonvykdph_index;
CREATE INDEX dPolSklad_IdClenKonVykDph_index ON dPolSklad USING btree (IdClenKonVykDph) where idclenkonvykdph is not null;
drop index if exists dpolsklad_iddphdalucet_index;
CREATE INDEX dpolsklad_iddphdalucet_index ON dpolsklad USING btree (iddphdalucet) where iddphdalucet is not null;
drop index if exists dpolsklad_iddphmducet_index;
CREATE INDEX dpolsklad_iddphmducet_index ON dpolsklad USING btree (iddphmducet) where iddphmducet is not null;
drop index if exists dpolsklad_iddphpren_index;
CREATE INDEX dPolSklad_IdDphPren_index ON dPolSklad USING btree (IdDphPren) where iddphpren is not null;
drop index if exists dpolsklad_idmjobjem_index;
CREATE INDEX dpolsklad_idmjobjem_index ON dpolsklad USING btree (idmjobjem) where idmjobjem is not null;
drop index if exists dpolsklad_idsazbydphpuv_index;
CREATE INDEX dPolSklad_IdSazbyDphPuv_index ON dPolSklad USING btree (IdSazbyDphPuv) where idsazbydphpuv is not null;
drop index if exists dpolsklad_idzakazky_index;
CREATE INDEX dpolsklad_idzakazky_index ON dpolsklad USING btree (idzakazky) where idzakazky is not null;
drop index if exists dpolsklad_idsazbydph_index;
CREATE INDEX dpolsklad_idsazbydph_index ON dpolsklad USING btree (idsazbydph) where idsazbydph is not null;
drop index if exists dpolsklad_idfirmy_index;
CREATE INDEX dpolsklad_idfirmy_index ON dpolsklad USING btree (idfirmy) where idfirmy is not null;

-----------------------------------------------------------------------
-- Bug 44791 - Zmenšit rozsah vybraných indexů tabulky ddoklsklad pro zmenšení zabraného místa   
----------------------------------------------------------------------- 
drop index if exists ddoklsklad_idbanspojdod_index;
CREATE INDEX ddoklsklad_idbanspojdod_index ON ddoklsklad USING btree (idbanspojdod) where idbanspojdod is not null;
drop index if exists ddoklsklad_idbspban_index;
CREATE INDEX ddoklsklad_idbspban_index ON ddoklsklad USING btree (idbspban) where idbspban is not null;
drop index if exists ddoklsklad_idcinnost_index;
CREATE INDEX dDoklSklad_IdCinnost_index ON dDoklSklad USING btree (IdCinnost) where idcinnost is not null;
drop index if exists ddoklsklad_idclendph_index;
CREATE INDEX ddoklsklad_idclendph_index ON ddoklsklad USING btree (idclendph) where idclendph is not null;
drop index if exists ddoklsklad_idclenkonvykdph_index;
CREATE INDEX dDoklSklad_IdClenKonVykDph_index ON dDoklSklad USING btree (IdClenKonVykDph) where idclenkonvykdph is not null;
drop index if exists ddoklsklad_iddodatna_index;
CREATE INDEX dDoklSklad_IdDodatNa_index ON dDoklSklad USING btree (IdDodatNa) where iddodatna is not null;
drop index if exists ddoklsklad_iddphsniz2ucet_index;
CREATE INDEX ddoklsklad_iddphsniz2ucet_index ON ddoklsklad USING btree (iddphsniz2ucet) where iddphsniz2ucet is not null;
drop index if exists ddoklsklad_iddphsnizucet_index;
CREATE INDEX ddoklsklad_iddphsnizucet_index ON ddoklsklad USING btree (iddphsnizucet) where iddphsnizucet is not null;
drop index if exists ddoklsklad_iddphzaklucet_index;
CREATE INDEX ddoklsklad_iddphzaklucet_index ON ddoklsklad USING btree (iddphzaklucet) where iddphzaklucet is not null;
drop index if exists ddoklsklad_idfastatu_index;
CREATE INDEX ddoklsklad_idfastatu_index ON ddoklsklad USING btree (idfastatu) where idfastatu is not null;
drop index if exists ddoklsklad_idformadopravy_index;
CREATE INDEX dDoklSklad_IdFormaDopravy_index ON dDoklSklad USING btree (IdFormaDopravy) where IdFormaDopravy is not null;
drop index if exists ddoklsklad_idinventura_index;
CREATE INDEX dDoklSklad_IdInventura_index ON dDoklSklad USING btree (IdInventura) where IdInventura is not null;
drop index if exists ddoklsklad_idkonsym_index;
CREATE INDEX ddoklsklad_idkonsym_index ON ddoklsklad USING btree (idkonsym) where idkonsym is not null;
drop index if exists ddoklsklad_idkontaktosoba_index;
CREATE INDEX dDoklSklad_IdKontaktOsoba_index ON dDoklSklad USING btree (IdKontaktOsoba) where idkontaktosoba is not null;
drop index if exists ddoklsklad_idmur_index;
CREATE INDEX ddoklsklad_idmur_index ON ddoklsklad USING btree (idmur) where idmur is not null;
drop index if exists ddoklsklad_idsazbydphosv_index;
CREATE INDEX ddoklsklad_idsazbydphosv_index ON ddoklsklad USING btree (idsazbydphosv) where idsazbydphosv is not null;
drop index if exists ddoklsklad_idsazbydphsniz2_index;
CREATE INDEX ddoklsklad_idsazbydphsniz2_index ON ddoklsklad USING btree (idsazbydphsniz2) where idsazbydphsniz2 is not null;
drop index if exists ddoklsklad_idsazbydphsniz_index;
CREATE INDEX ddoklsklad_idsazbydphsniz_index ON ddoklsklad USING btree (idsazbydphsniz) where idsazbydphsniz is not null;
drop index if exists ddoklsklad_idsazbydphzakl_index;
CREATE INDEX ddoklsklad_idsazbydphzakl_index ON ddoklsklad USING btree (idsazbydphzakl) where idsazbydphzakl is not null;
drop index if exists ddoklsklad_idskladcil_index;
CREATE INDEX dDoklSklad_IdSkladCil_index ON dDoklSklad USING btree (IdSkladCil) where IdSkladCil is not null;
drop index if exists ddoklsklad_idsmerkod_index;
CREATE INDEX ddoklsklad_idsmerkod_index ON ddoklsklad USING btree (idsmerkod) where idsmerkod is not null;
drop index if exists ddoklsklad_idsmlouvy_index;
CREATE INDEX ddoklsklad_idsmlouvy_index ON ddoklsklad USING btree (idsmlouvy) where idsmlouvy is not null;
drop index if exists ddoklsklad_idstatdph_index;
CREATE INDEX ddoklsklad_idstatdph_index ON ddoklsklad USING btree (idstatdph) where idstatdph is not null;
drop index if exists ddoklsklad_idtypdoklskl_index;
CREATE INDEX ddoklsklad_idtypdoklskl_index ON ddoklsklad USING btree (idtypdoklskl) where idtypdoklskl is not null;
drop index if exists ddoklsklad_idzakazky_index;
CREATE INDEX ddoklsklad_idzakazky_index ON ddoklsklad USING btree (idzakazky) where idzakazky is not null;
drop index if exists ddoklsklad_index;

-----------------------------------------------------------------------
--Bug 46786 - Odstranit duplicitní indexy   
----------------------------------------------------------------------- 
drop index if exists changelog_seq_index;
drop index if exists dkonsym_kod_index;
drop index if exists ikrajurc_kod_index;
drop index if exists umeny_kod_index;
drop index if exists ustrediska_kod_index;
drop index if exists msazby_kod_index;
drop index if exists mumisteni_kod_index;
drop index if exists nnastav_idmenydual_index;
drop index if exists mleasing_kod_index;
drop index if exists inomen_kod_index;
drop index if exists astaty_kod_index;
drop index if exists delbanformat_kod_index;
drop index if exists drady_kod_index;
drop index if exists idobpodm_kod_index;
drop index if exists idruhdopr_kod_index;
drop index if exists iintrmerjed_kod_index;
drop index if exists iobchtrans_kod_index;
drop index if exists izvlpoh_kod_index;
drop index if exists wvybklice_kod_index;
drop index if exists nucetobdobi_kod_index;
drop index if exists wuzivatel_kod_index;
drop index if exists cmerjed_kod_index;
drop index if exists mmajetek_kod_index;
drop index if exists uzakazky_kod_index;
--Profizoo
drop index if exists sfifovazby_idpolskladprijem;
drop index if exists sfifovazby_idpolskladvydej;


-----------------------------------------------------------------------
--Bug 46792 - Zmenšit rozsah vybraných indexů tabulky wextid pro zmenšení zabraného místa    
-----------------------------------------------------------------------
drop index if exists wExtId_IdAdresar_index;
CREATE INDEX wExtId_IdAdresar_index ON wExtId USING btree (IdAdresar) WHERE IdAdresar is not null;
drop index if exists wExtId_IdCenik_index;
CREATE INDEX wExtId_IdCenik_index ON wExtId USING btree (IdCenik) WHERE IdCenik is not null;
drop index if exists wExtId_IdDoklFak_index;
CREATE INDEX wExtId_IdDoklFak_index ON wExtId USING btree (IdDoklFak) WHERE IdDoklFak is not null;
drop index if exists wExtId_IdDoklInt_index;
CREATE INDEX wExtId_IdDoklInt_index ON wExtId USING btree (IdDoklInt) WHERE IdDoklInt is not null;
drop index if exists wExtId_IdDoklObch_index;
CREATE INDEX wExtId_IdDoklObch_index ON wExtId USING btree (IdDoklObch) WHERE IdDoklObch is not null;
drop index if exists wExtId_IdDoklSklad_index;
CREATE INDEX wExtId_IdDoklSklad_index ON wExtId USING btree (IdDoklSklad) WHERE IdDoklSklad is not null;
drop index if exists wExtId_IdKurz_index;
CREATE INDEX wExtId_IdKurz_index ON wExtId USING btree (IdKurz) WHERE IdKurz is not null;
drop index if exists wExtId_IdPolFak_index;
CREATE INDEX wExtId_IdPolFak_index ON wExtId USING btree (IdPolFak) WHERE IdPolFak is not null;
drop index if exists wExtId_IdPolInt_index;
CREATE INDEX wExtId_IdPolInt_index ON wExtId USING btree (IdPolInt) WHERE IdPolInt is not null;
drop index if exists wExtId_IdPolObch_index;
CREATE INDEX wExtId_IdPolObch_index ON wExtId USING btree (IdPolObch) WHERE IdPolObch is not null;
drop index if exists wExtId_IdPolSklad_index;
CREATE INDEX wExtId_IdPolSklad_index ON wExtId USING btree (IdPolSklad) WHERE IdPolSklad is not null;
drop index if exists wExtId_IdSkladKarty_index;
CREATE INDEX wExtId_IdSkladKarty_index ON wExtId USING btree (IdSkladKarty) WHERE IdSkladKarty is not null;
drop index if exists wExtId_IdOdberatel_index;
CREATE INDEX wExtId_IdOdberatel_index ON wExtId USING btree (IdOdberatel) WHERE IdOdberatel is not null;
drop index if exists wExtId_IdDodavatel_index;
CREATE INDEX wExtId_IdDodavatel_index ON wExtId USING btree (IdDodavatel) WHERE IdDodavatel is not null;
drop index if exists wExtId_IdSady_index;
CREATE INDEX wExtId_IdSady_index ON wExtId USING btree (IdSady) WHERE IdSady is not null;
drop index if exists wExtId_IdPoplatek_index;
CREATE INDEX wExtId_IdPoplatek_index ON wExtId USING btree (IdPoplatek) WHERE IdPoplatek is not null;
drop index if exists wExtId_IdPodobne_index;
CREATE INDEX wExtId_IdPodobne_index ON wExtId USING btree (IdPodobne) WHERE IdPodobne is not null;
drop index if exists wExtId_IdKusovnik_index;
CREATE INDEX wExtId_IdKusovnik_index ON wExtId USING btree (IdKusovnik) WHERE IdKusovnik is not null;
drop index if exists wExtId_IdPriloha_index;
CREATE INDEX wExtId_IdPriloha_index ON wExtId USING btree (IdPriloha) WHERE IdPriloha is not null;
drop index if exists wExtId_IdCenHlad_index;
CREATE INDEX wExtId_IdCenHlad_index ON wExtId USING btree (IdCenHlad) WHERE IdCenHlad is not null;
drop index if exists wExtId_IdStredisko_index;
CREATE INDEX wExtId_IdStredisko_index ON wExtId USING btree (IdStredisko) WHERE IdStredisko is not null;
drop index if exists wExtId_IdCinnost_index;
CREATE INDEX wExtId_IdCinnost_index ON wExtId USING btree (IdCinnost) WHERE IdCinnost is not null;
drop index if exists wExtId_IdMerJed_index;
CREATE INDEX wExtId_IdMerJed_index ON wExtId USING btree (IdMerJed) WHERE IdMerJed is not null;
drop index if exists wExtId_IdVybKlic_index;
CREATE INDEX wExtId_IdVybKlic_index ON wExtId USING btree (IdVybKlic) WHERE IdVybKlic is not null;
drop index if exists wExtId_IdTypUcOp_index;
CREATE INDEX wExtId_IdTypUcOp_index ON wExtId USING btree (IdTypUcOp) WHERE IdTypUcOp is not null;
drop index if exists wExtId_IdText_index;
CREATE INDEX wExtId_IdText_index ON wExtId USING btree (IdText) WHERE IdText is not null;
drop index if exists wExtId_IdAdrUdalost_index;
CREATE INDEX wExtId_IdAdrUdalost_index ON wExtId USING btree (IdAdrUdalost) WHERE IdAdrUdalost is not null;
drop index if exists wExtId_IdBanSpoj_index;
CREATE INDEX wExtId_IdBanSpoj_index ON wExtId USING btree (IdBanSpoj) WHERE IdBanSpoj is not null;
drop index if exists wExtId_IdMistUrc_index;
CREATE INDEX wExtId_IdMistUrc_index ON wExtId USING btree (IdMistUrc) WHERE IdMistUrc is not null;
drop index if exists wExtId_IdKontakt_index;
CREATE INDEX wExtId_IdKontakt_index ON wExtId USING btree (IdKontakt) WHERE IdKontakt is not null;
drop index if exists wExtId_IdSkupFir_index;
CREATE INDEX wExtId_IdSkupFir_index ON wExtId USING btree (IdSkupFir) WHERE IdSkupFir is not null;
drop index if exists wExtId_IdSkupZboz_index;
CREATE INDEX wExtId_IdSkupZboz_index ON wExtId USING btree (IdSkupZboz) WHERE IdSkupZboz is not null;
drop index if exists wExtId_IdTypDokl_index;
CREATE INDEX wExtId_IdTypDokl_index ON wExtId USING btree (IdTypDokl) WHERE IdTypDokl is not null;
drop index if exists wExtId_IdMapSklad_index;
CREATE INDEX wExtId_IdMapSklad_index ON wExtId USING btree (IdMapSklad) WHERE IdMapSklad is not null;
drop index if exists wExtId_IdZakazka_index;
CREATE INDEX wExtId_IdZakazka_index ON wExtId USING btree (IdZakazka) WHERE IdZakazka is not null;
drop index if exists wExtId_IdUcet_index;
CREATE INDEX wExtId_IdUcet_index ON wExtId USING btree (IdUcet) WHERE IdUcet is not null;
drop index if exists wExtId_IdReport_index;
CREATE INDEX wExtId_IdReport_index ON wExtId USING btree (IdReport) WHERE IdReport is not null;
drop index if exists wExtId_IdUzel_index;
CREATE INDEX wExtId_IdUzel_index ON wExtId USING btree (IdUzel) WHERE IdUzel is not null;
drop index if exists wExtId_IdVazUzel_index;
CREATE INDEX wExtId_IdVazUzel_index ON wExtId USING btree (IdVazUzel) WHERE IdVazUzel is not null;
drop index if exists wExtId_IdSazbyDph_index;
CREATE INDEX wExtId_IdSazbyDph_index ON wExtId USING btree (idSazbaDph) WHERE idSazbaDph is not null;
drop index if exists wExtId_IdBsp_index;
CREATE INDEX wExtId_IdBsp_index ON wExtId USING btree (idBsp) WHERE idBsp is not null;
drop index if exists wExtId_IdDotaz_index;
CREATE INDEX wExtId_IdDotaz_index ON wExtId USING btree (idDotaz) WHERE idDotaz is not null;
drop index if exists wExtId_IdDotazParam_index;
CREATE INDEX wExtId_IdDotazParam_index ON wExtId USING btree (idDotazParam) WHERE idDotazParam is not null;
drop index if exists wExtId_IdDotazProp_index;
CREATE INDEX wExtId_IdDotazProp_index ON wExtId USING btree (idDotazProp) WHERE idDotazProp is not null;
drop index if exists wExtId_IdSmlouvy_index;
CREATE INDEX wExtId_IdSmlouvy_index ON wExtId USING btree (idSmlouvy) WHERE idSmlouvy is not null;
drop index if exists wExtId_IdPolSml_index;
CREATE INDEX wExtId_IdPolSml_index ON wExtId USING btree (idPolSml) WHERE idPolSml is not null;
drop index if exists wExtId_IdTypSml_index;
CREATE INDEX wExtId_IdTypSml_index ON wExtId USING btree (idTypSml) WHERE idTypSml is not null;
drop index if exists wExtId_IdStavSml_index;
CREATE INDEX wExtId_IdStavSml_index ON wExtId USING btree (idStavSml) WHERE idStavSml is not null;
drop index if exists wExtId_IdUzivatel_index;
CREATE INDEX wExtId_IdUzivatel_index ON wExtId USING btree (idUzivatel) WHERE idUzivatel is not null;
drop index if exists wExtId_IdTypAkt_index;
CREATE INDEX wExtId_IdTypAkt_index ON wExtId USING btree (idTypAkt) WHERE idTypAkt is not null;
drop index if exists wExtId_IdTypNaklAkt_index;
CREATE INDEX wExtId_IdTypNaklAkt_index ON wExtId USING btree (idTypNaklAkt) WHERE idTypNaklAkt is not null;
drop index if exists wExtId_IdTypZakazky_index;
CREATE INDEX wExtId_IdTypZakazky_index ON wExtId USING btree (idTypZakazky) WHERE idTypZakazky is not null;
drop index if exists wExtId_IdVazbaTyp_index;
CREATE INDEX wExtId_IdVazbaTyp_index ON wExtId USING btree (IdVazbaTyp) WHERE IdVazbaTyp is not null;
drop index if exists wExtId_IdVazba_index;
CREATE INDEX wExtId_IdVazba_index ON wExtId USING btree (IdVazba) WHERE IdVazba is not null;
drop index if exists wExtId_IdSkupVybKlic_index;
CREATE INDEX wExtId_IdSkupVybKlic_index ON wExtId USING btree (IdSkupVybKlic) WHERE IdSkupVybKlic is not null;
drop index if exists wextid_idzastupnost_index;
CREATE INDEX wextid_idzastupnost_index ON wextid USING btree (idzastupnost) WHERE idzastupnost is not null;
drop index if exists wExtId_IdCustomButton_index;
CREATE INDEX wExtId_IdCustomButton_index ON wExtId USING btree (IdCustomButton) WHERE IdCustomButton is not null;

drop index if exists wExtId_IdBanSpojMzdy_index;
CREATE INDEX wExtId_IdBanSpojMzdy_index ON wExtId USING btree (idBanSpojMzdy) WHERE idBanSpojMzdy is not null;
drop index if exists wExtId_IdDite_index;
CREATE INDEX wExtId_IdDite_index ON wExtId USING btree (idDite) WHERE idDite is not null;
drop index if exists wExtId_IdNepritomnost_index;
CREATE INDEX wExtId_IdNepritomnost_index ON wExtId USING btree (idNepritomnost) WHERE idNepritomnost is not null;
drop index if exists wExtId_IdOsoba_index;
CREATE INDEX wExtId_IdOsoba_index ON wExtId USING btree (idOsoba) WHERE idOsoba is not null;
drop index if exists wExtId_IdOsobaHlav_index;
CREATE INDEX wExtId_IdOsobaHlav_index ON wExtId USING btree (idOsobaHlav) WHERE idOsobaHlav is not null;
drop index if exists wExtId_IdPracPom_index;
CREATE INDEX wExtId_IdPracPom_index ON wExtId USING btree (idPracPom) WHERE idPracPom is not null;
drop index if exists wExtId_IdPracPomHlav_index;
CREATE INDEX wExtId_IdPracPomHlav_index ON wExtId USING btree (idPracPomHlav) WHERE idPracPomHlav is not null;
drop index if exists wExtId_IdSkupOsob_index;
CREATE INDEX wExtId_IdSkupOsob_index ON wExtId USING btree (idSkupOsob) WHERE idSkupOsob is not null;
drop index if exists wExtId_IdSmeny_index;
CREATE INDEX wExtId_IdSmeny_index ON wExtId USING btree (idSmeny) WHERE idSmeny is not null;
drop index if exists wExtId_IdSrazka_index;
CREATE INDEX wExtId_IdSrazka_index ON wExtId USING btree (idSrazka) WHERE idSrazka is not null;
drop index if exists wExtId_IdStalaMzdSloz_index;
CREATE INDEX wExtId_IdStalaMzdSloz_index ON wExtId USING btree (idStalaMzdSloz) WHERE idStalaMzdSloz is not null;
drop index if exists wExtId_IdPraceStred_index;
CREATE INDEX wExtId_IdPraceStred_index ON wExtId USING btree (idPraceStred) WHERE idPraceStred is not null;
drop index if exists wExtId_IdMzdSloz_index;
CREATE INDEX wExtId_IdMzdSloz_index ON wExtId USING btree (IdMzdSloz) WHERE IdMzdSloz is not null;

drop index if exists wExtId_IdTypMaj_index;
CREATE INDEX wExtId_IdTypMaj_index ON wExtId USING btree (idTypMaj) WHERE idTypMaj is not null;
drop index if exists wExtId_IdMajetek_index;
CREATE INDEX wExtId_IdMajetek_index ON wExtId USING btree (idMajetek) WHERE idMajetek is not null;
drop index if exists wExtId_IdTypLeas_index;
CREATE INDEX wExtId_IdTypLeas_index ON wExtId USING btree (idTypLeas) WHERE idTypLeas is not null;
drop index if exists wExtId_IdLeasing_index;
CREATE INDEX wExtId_IdLeasing_index ON wExtId USING btree (idLeasing) WHERE idLeasing is not null;
drop index if exists wExtId_IdUmisteni_index;
CREATE INDEX wExtId_IdUmisteni_index ON wExtId USING btree (idUmisteni) WHERE idUmisteni is not null;

-----------------------------------------------------------------------
-- Bug 44883 - Přidat index nad normalizovanou hodnotu sloupce eankod v tabulce aadresar, pokud je eankod uveden 
-----------------------------------------------------------------------
drop index if exists aadresar_eankod_upper_index;
create index aadresar_eankod_upper_index on aadresar (upper(eankod::text)) where eankod is not null;


 -- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1100, 't', %appVersion%, clock_timestamp());