-----------------------------------------------------------------------
-- Bug 14302 - [WinStrom] Seznam "Cenové úrovně"
-----------------------------------------------------------------------
-- vytvoreni tabulky pro cenove hladiny

CREATE SEQUENCE seq_ccenhlad
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_ccenhlad OWNER TO %firmaRole%;

CREATE TABLE ccenhlad (
    idcenhlad integer DEFAULT nextval('seq_ccenhlad'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis character varying(255),
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,

    docasnost boolean DEFAULT false NOT NULL,
    platioddata date,
    platidodata date,
    typcenyvychozik character varying(50),
    typvypcenyk character varying(50) NOT NULL,
    typcenyvychozi25k character varying(50),
    typvypceny25k character varying(50),
    limmnoz2 numeric(19,6) DEFAULT 0.0 NOT NULL,
    limmnoz3 numeric(19,6) DEFAULT 0.0 NOT NULL,
    limmnoz4 numeric(19,6) DEFAULT 0.0 NOT NULL,
    limmnoz5 numeric(19,6) DEFAULT 0.0 NOT NULL,
    proczakl numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento3 numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento4 numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento5 numeric(6,2) DEFAULT 0.0 NOT NULL,
    zaokrjakk character varying(50),
    zaokrnak character varying(50),
    uuid character varying(50),
    CONSTRAINT ccenhlad_pkey PRIMARY KEY (idcenhlad)
);

ALTER TABLE public.ccenhlad OWNER TO %firmaRole%;

--------------------------------------------------------------------------------

CREATE TABLE cchl_skz
(
  idcenhlad integer NOT NULL,
  idskupzboz integer NOT NULL,
  CONSTRAINT cchl_skz_pkey PRIMARY KEY (idcenhlad, idskupzboz),
  CONSTRAINT cchl_skz_idcenhlad FOREIGN KEY (idcenhlad)
      REFERENCES ccenhlad (idcenhlad)
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT cchl_skz_idskupzboz FOREIGN KEY (idskupzboz)
      REFERENCES cskupzboz (idskupzboz)
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE cchl_skz OWNER TO %firmaRole%;

CREATE INDEX cchl_skz_idcenhlad_index ON cchl_skz USING btree (idcenhlad);
CREATE INDEX cchl_skz_idskupzboz_index ON cchl_skz USING btree (idskupzboz);


CREATE TABLE cchl_skf
(
  idcenhlad integer NOT NULL,
  idskupfir integer NOT NULL,
  CONSTRAINT cchl_skf_pkey PRIMARY KEY (idcenhlad, idskupfir),
  CONSTRAINT cchl_skf_idcenhlad FOREIGN KEY (idcenhlad)
      REFERENCES ccenhlad (idcenhlad)
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT cchl_skf_idskupfir FOREIGN KEY (idskupfir)
      REFERENCES askupfir (idskupfir)
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE cchl_skf OWNER TO %firmaRole%;

CREATE INDEX cchl_skf_idcenhlad_index ON cchl_skf USING btree (idcenhlad);
CREATE INDEX cchl_skf_idskupfir_index ON cchl_skf USING btree (idskupfir);

--------------------------------------------------------------------------------

insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 116, 't');
