--------------------------------------------------------------------------------
-- Bug 14823 – [WinStrom] Přijaté objednávky - % realizovatelnosti
--------------------------------------------------------------------------------

-- Trigger přepočítávající realizovatelnost obchodních dokladů při změně na skladě
CREATE OR REPLACE FUNCTION dpolskladupdaterealizovatelnost()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
begin
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;

  update ddoklobch set procReal=obchodrealizovatelnost(idDoklObch) where (stavUzivK is null or stavUzivK <> 'stavDoklObch.hotovo') and idDoklObch in
    (select iddoklobch from dpolobch where modul in ('PPP', 'NAV', 'OBP') and (mnozmj-mnozmjreal) > 0 and idcenik = ZAZNAM.idcenik);
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolskladupdaterealizovatelnost() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulku položek skladových dokladů
CREATE TRIGGER dpolskladupdaterealizovatelnost AFTER INSERT OR UPDATE OR DELETE ON dpolsklad
  FOR EACH ROW EXECUTE PROCEDURE dpolskladupdaterealizovatelnost();

-- zvýšení verze databáze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 127, 't');
