-------------------------------------------------
-- Bug 15857 – [WinStrom] Stromovy cenik
-------------------------------------------------

-- seznam stromu
CREATE SEQUENCE seq_wstrom
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
    
ALTER TABLE public.seq_wstrom OWNER TO %firmaRole%;

CREATE TABLE wstrom (
    idstrom integer DEFAULT nextval('seq_wstrom'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    tabulka character varying(63) NOT NULL,
    primarni boolean DEFAULT true NOT NULL,
    idzaznamu integer,
    iduziv integer,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    popis character varying(255),
    poznam text,
    "show" boolean NOT NULL DEFAULT true,
    CONSTRAINT wstrom_pkey PRIMARY KEY (idstrom),
    CONSTRAINT wstrom_iduziv FOREIGN KEY (iduziv)
      REFERENCES wuzivatel (iduzivatel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wstrom OWNER TO %firmaRole%;

CREATE INDEX wstrom_idzaznamu_index ON wstrom USING btree (idzaznamu);
CREATE INDEX wstrom_iduziv_index ON wstrom USING btree (iduziv);

-- struktura stromu
CREATE SEQUENCE seq_wuzel
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
    
ALTER TABLE public.seq_wuzel OWNER TO %firmaRole%;

CREATE TABLE wuzel (
    iduzel integer DEFAULT nextval('seq_wuzel'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20),
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    idstrom integer NOT NULL,
    idotec integer,
    strobr text,
    hladina integer NOT NULL DEFAULT 0,
    poradi integer NOT NULL DEFAULT 0,
    cesta character varying(255) NOT NULL,
    CONSTRAINT wuzel_pkey PRIMARY KEY (iduzel),
    CONSTRAINT wuzel_idstrom FOREIGN KEY (idstrom)
      REFERENCES wstrom (idstrom) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wuzel_idotec FOREIGN KEY (idotec)
      REFERENCES wuzel (iduzel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wuzel OWNER TO %firmaRole%;

CREATE INDEX wuzel_idstrom_index ON wuzel USING btree (idstrom);
CREATE INDEX wuzel_idotec_index ON wuzel USING btree (idotec);

-- vazebni tabulka na list stromu
CREATE SEQUENCE seq_wvazuzel
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_wvazuzel OWNER TO %firmaRole%;

CREATE TABLE wvazuzel (
    idvazuzel integer DEFAULT nextval('seq_wvazuzel'::regclass) NOT NULL,
    iduzlu integer NOT NULL,
    idzaznamu integer NOT NULL,
    CONSTRAINT wvazuzel_pkey PRIMARY KEY (idvazuzel),
    CONSTRAINT wvazuzel_iduzlu FOREIGN KEY (iduzlu)
      REFERENCES wuzel (iduzel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wvazuzel OWNER TO %firmaRole%;

CREATE INDEX wvazuzel_iduzlu_index ON wvazuzel USING btree (iduzlu);
CREATE INDEX wvazuzel_idzaznamu_index ON wvazuzel USING btree (idzaznamu);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 158, 't');
