-------------------------------------------------------
-- Bug 15943 – [WinStrom] Dokladové řady - díry
-------------------------------------------------------

CREATE OR REPLACE FUNCTION ddokldelraddiru() RETURNS trigger
    AS $$
declare
  _datum date;
  _idUcetObdobi integer;
begin
  /* Kontrola na bug 9288. Po vyreseni mozno odstranit.*/
  /* Zakomentovano z duvodu importu z WinStromu 6
  if (NEW.idPolRady is null) then
    raise exception 'dDoklDelRadDiru(): idPolRady je null';
  end if;*/

  if (NEW.ucetni = true) then
    _datum = NEW.datUcto;
  else
    _datum = NEW.datVyst;
  end if;

  select idUcetObdobi into _idUcetObdobi from nUcetObdobi where platiOdData <= _datum and platiDoData >= _datum;

  delete from dRadyDiry where CisDira = NEW.Kod and idRadyRok =
    (select idRadyRok from dRadyRok where idRady = NEW.idRady and idUcetObdobi = _idUcetObdobi group by idRadyRok);

  return NEW;
end;
$$ LANGUAGE plpgsql;

ALTER FUNCTION public.ddokldelraddiru() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 161, 't');