---------------------------------------------------------------------------
-- Bug 15999 – [WinStrom] Přidání polí pro mzdy do nastavení
---------------------------------------------------------------------------

-- sloupce
ALTER TABLE nnastav ADD COLUMN mzddnudovolabs numeric(10,6) DEFAULT 0.0;
ALTER TABLE nnastav ADD COLUMN mzdpenzprip boolean DEFAULT false NOT NULL;
ALTER TABLE nnastav ADD COLUMN mzdpenzpripproc numeric(10,6) DEFAULT 0.0;
ALTER TABLE nnastav ADD COLUMN mzdproczdpojneplvol numeric(10,6) DEFAULT 0.0;
ALTER TABLE nnastav ADD COLUMN idmzdadrdansra integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdzavdansra integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdintnahrad integer;
ALTER TABLE nnastav ADD COLUMN idmzdadrsocpoj integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdzavzdrav integer;
ALTER TABLE nnastav ADD COLUMN idmzdtuozavsoczam integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdzavdanzal integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdzavdanrez integer;
ALTER TABLE nnastav ADD COLUMN idmzdtuozavzdrfir integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdinthruba integer;
ALTER TABLE nnastav ADD COLUMN idmzdadrdanzal integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdzavsrazka integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdzavsoc integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdzavzaloha integer;
ALTER TABLE nnastav ADD COLUMN idmzdtuozavzdrzam integer;
ALTER TABLE nnastav ADD COLUMN idmzdadrdanrez integer;
ALTER TABLE nnastav ADD COLUMN idmzdtdzavdobirka integer;
ALTER TABLE nnastav ADD COLUMN idmzdtuozavsocfir integer;

-- vazby
ALTER TABLE nnastav ADD CONSTRAINT fk4594649715965e78 FOREIGN KEY (idmzdtuozavzdrfir)
    REFERENCES utypucop (idtypucop) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk459464971596a88f FOREIGN KEY (idmzdtuozavzdrzam)
    REFERENCES utypucop (idtypucop) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497273dc0d5 FOREIGN KEY (idmzdadrsocpoj)
    REFERENCES aadresar (idfirmy) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk4594649745c6d3f2 FOREIGN KEY (idmzdtdzavzdrav)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk4594649746e91a51 FOREIGN KEY (idmzdtdzavdanrez)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk4594649746e91f8c FOREIGN KEY (idmzdtdzavdansra)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk4594649746e937cf FOREIGN KEY (idmzdtdzavdanzal)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk459464975c0e477b FOREIGN KEY (idmzdtdintnahrad)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497616b9109 FOREIGN KEY (idmzdtdzavsrazka)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk459464976c72c43e FOREIGN KEY (idmzdtdzavzaloha)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497a38a319 FOREIGN KEY (idmzdtuozavsocfir)
    REFERENCES utypucop (idtypucop) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497a38ed30 FOREIGN KEY (idmzdtuozavsoczam)
    REFERENCES utypucop (idtypucop) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497a6fcedeb FOREIGN KEY (idmzdtdzavdobirka)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497b22eb9f FOREIGN KEY (idmzdtdinthruba)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497ce4cce7 FOREIGN KEY (idmzdadrdanrez)
    REFERENCES aadresar (idfirmy) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497ce4d222 FOREIGN KEY (idmzdadrdansra)
    REFERENCES aadresar (idfirmy) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497ce4ea65 FOREIGN KEY (idmzdadrdanzal)
    REFERENCES aadresar (idfirmy) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk45946497f77f0bfc FOREIGN KEY (idmzdtdzavsoc)
    REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

-- indexy
CREATE INDEX nNastav_IdMzdAdrSocPoj_index ON nNastav USING btree (IdMzdAdrSocPoj);
CREATE INDEX nNastav_IdMzdAdrDanZal_index ON nNastav USING btree (IdMzdAdrDanZal);
CREATE INDEX nNastav_IdMzdAdrDanSra_index ON nNastav USING btree (IdMzdAdrDanSra);
CREATE INDEX nNastav_IdMzdAdrDanRez_index ON nNastav USING btree (IdMzdAdrDanRez);
CREATE INDEX nNastav_IdMzdTdZavSoc_index ON nNastav USING btree (IdMzdTdZavSoc);
CREATE INDEX nNastav_IdMzdTuoZavSocZam_index ON nNastav USING btree (IdMzdTuoZavSocZam);
CREATE INDEX nNastav_IdMzdTuoZavSocFir_index ON nNastav USING btree (IdMzdTuoZavSocFir);
CREATE INDEX nNastav_IdMzdTdZavZdrav_index ON nNastav USING btree (IdMzdTdZavZdrav);
CREATE INDEX nNastav_IdMzdTuoZavZdrZam_index ON nNastav USING btree (IdMzdTuoZavZdrZam);
CREATE INDEX nNastav_IdMzdTuoZavZdrFir_index ON nNastav USING btree (IdMzdTuoZavZdrFir);
CREATE INDEX nNastav_IdMzdTdZavDanZal_index ON nNastav USING btree (IdMzdTdZavDanZal);
CREATE INDEX nNastav_IdMzdTdZavDanSra_index ON nNastav USING btree (IdMzdTdZavDanSra);
CREATE INDEX nNastav_IdMzdTdZavDanRez_index ON nNastav USING btree (IdMzdTdZavDanRez);
CREATE INDEX nNastav_IdMzdTdZavZaloha_index ON nNastav USING btree (IdMzdTdZavZaloha);
CREATE INDEX nNastav_IdMzdTdZavSrazka_index ON nNastav USING btree (IdMzdTdZavSrazka);
CREATE INDEX nNastav_IdMzdTdZavDobirka_index ON nNastav USING btree (IdMzdTdZavDobirka);
CREATE INDEX nNastav_IdMzdTdIntHruba_index ON nNastav USING btree (IdMzdTdIntHruba);
CREATE INDEX nNastav_IdMzdTdIntNahrad_index ON nNastav USING btree (IdMzdTdIntNahrad);

-- doplneni dvou chybejicich vazeb v nastaveni
UPDATE nnastav SET iducetzaokrnaklad = null WHERE iducetzaokrnaklad NOT IN (select iducet from uucty);
UPDATE nnastav SET iducetzaokrvynos = null WHERE iducetzaokrvynos NOT IN (select iducet from uucty);

ALTER TABLE nnastav ADD CONSTRAINT fk45946497e6d28bff FOREIGN KEY (iducetzaokrnaklad)
    REFERENCES uucty (iducet) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT fk4594649749e3c8e9 FOREIGN KEY (iducetzaokrvynos)
    REFERENCES uucty (iducet) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 162, 't');