-----------------------------------------------------------------------
-- Bug 16594 – [WinStrom] Rozšířit přílohy o velikost souboru
-----------------------------------------------------------------------
CREATE OR REPLACE FUNCTION countAttachmentSizes() RETURNS void as
$BODY$    
declare
  prilohaSize bigint;
  priloha Record;
begin
  for priloha in select idpriloha, iddata from wpriloha
  loop
        select (case when blobdata is not null
                then (select sum(octet_length(data)) from pg_largeobject 
	                where loid = blobdata group by loid)
                else octet_length(bytedata) end) 
                into prilohaSize
        from wprilohadata d where d.idprilohadata = priloha.iddata;
        
        update wpriloha set datasize = prilohaSize 
                where idpriloha = priloha.idpriloha;
  end loop;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION countAttachmentSizes() OWNER TO %firmaRole%;

alter table wpriloha add column dataSize bigint NOT NULL default 0;
select countAttachmentSizes();
drop function if exists countAttachmentSizes();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 171, 't');
