--------------------------------------------------------------------------------
-- Bug 17278 – [WinStrom] Kusovnik pod komponentou zobrazovat a editovat celek
--------------------------------------------------------------------------------

-- Function: cankusovnikhavecenik(integer, integer)

-- DROP FUNCTION cankusovnikhavecenik(integer, integer);

CREATE OR REPLACE FUNCTION cankusovnikhavecenik(_idparkus integer, _idpotcenik integer)
  RETURNS boolean AS
$BODY$
declare
  _kus record;
  _IdParCenik integer;
begin
  if (_idParKus is null) then
    return true;
  end if;

  -- nalezneme si kusovnik otce
  select * into _kus from ckusovnik ckus where ckus.idkusovnik = _idParKus;
  -- obsahuje stejny cenik jako cenik potomka
  if (_kus.idcenik = _idPotCenik) then
    return false;
  end if;

  _IdParCenik = _kus.idcenik;
  -- najdeme vsechny vyskyty ceniku otce a podivame se jestli jejich otec
  -- nema cenik stejny jako cenik potomka
  for _kus in (select * from ckusovnik ckus where ckus.idcenik = _IdParCenik) loop
	if (not canKusovnikHaveCenik(_kus.idotec, _idPotCenik)) then
	  return false;
	end if;
  end loop;

  return true;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION cankusovnikhavecenik(integer, integer) OWNER TO %firmaRole%;


-- Function: findkusovniky(integer)

-- DROP FUNCTION findkusovniky(integer);

CREATE OR REPLACE FUNCTION findkusovniky(_idoteccenik integer)
  RETURNS SETOF integer AS
$BODY$
declare
  _kus record;
  _subcursor refcursor;
  _subkus record;
begin
  for _kus in (select * from ckusovnik where idoteccenik = _idoteccenik) loop
    return next _kus.idkusovnik;

    if (_kus.idcenik != _idoteccenik) then
      open _subcursor for select * from findKusovniky(_kus.idcenik);

      loop
        fetch _subcursor into _subkus;
        if NOT FOUND then
          exit;
        end if;

	return next _subkus.findKusovniky;
      end loop;
      close _subcursor;
    end if;
  end loop;
  return;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION findkusovniky(integer) OWNER TO %firmaRole%;


-- zvyseni cisla verze db
insert into dbversion(iddbversion, dbversion, needreimport)
        values (nextval('seq_dbversion'), 208, 't');