--------------------------------------------------------------------------------
-- Bug 17551 – [WinStrom] Přidat pojišťovny do adresáře
--------------------------------------------------------------------------------

-- rozsireni tabulky adresare
ALTER TABLE aadresar ADD COLUMN kodpojistovny character varying(20);
ALTER TABLE aadresar ADD COLUMN uuid character varying(50);

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy, pro vsechny ostatni ji smazeme
  if (stat = 'CZ_CZ') then

-- pridani pojistoven pro mzdy do adresare
-- zdravotka
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, ulice, mesto, psc, tel, email, www, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2010-01-14 00:00:00.000', generateuniquekod('VZP', 'aadresar', ' '), 'Všeobecná zdravotní pojišťovna České republiky ', true, 0, 9999, 'Orlická 2020/4 ', 'Praha-Vinohrady', '130 00  ', ' +420 844 117 777', ' EMAILinfo@vzp.cz', 'http://www.vzp.cz', true, 0, 0.0, false, 0, 'typVztahu.zdravotka', '111', 0, 'CZ_ZDR_111');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, ulice, mesto, psc, tel, fax, email, www, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('201', 'aadresar', ' '), 'Vojenská zdravotní pojišťovna České republiky', true, 0, 9999, 'Drahobejlova 1404/4', 'Praha 9', '190 03', '266 311 911', '266310723', 'info@vozp.cz', 'www.vozp.cz', true, 0, 0.0, false, 0, 'typVztahu.zdravotka', '201', 0, 'CZ_ZDR_201');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, ulice, mesto, psc, tel, email, www, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('205', 'aadresar', ' '), 'Česká průmyslová zdravotní pojišťovna', true, 0, 9999, 'Jeremenkova 11', 'Ostrava - Víktovice', '703 00', '261 387 222 (Čechy) 810 800 000 (Morava)', 'posta@cpzp.cz', 'www.cpzp.cz', true, 0, 0.0, false, 0, 'typVztahu.zdravotka', '205', 0, 'CZ_ZDR_205');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, ulice, mesto, psc, tel, fax, email, www, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('207', 'aadresar', ' '), 'Oborová zdravotní pojišťovna zaměstnanců bank, pojišťoven a stavebnictví', true, 0, 9999, 'Roškotova 1225/1', 'Praha 4', '140 21', '261105555', '261105300', 'https://portal.ozp.cz/', 'www.ozp.cz', true, 0, 0.0, false, 0, 'typVztahu.zdravotka', '207', 0, 'CZ_ZDR_207');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, ulice, mesto, psc, tel, fax, email, www, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('209', 'aadresar', ' '), 'Zaměstnanecká pojišťovna Škoda', true, 0, 9999, 'Husova 302', 'Mladá Boleslav', '293 01', '326 579 111, 326 579 120, 800 209 000', '326579009', 'zpskoda@zpskoda.cz', 'www.zpskoda.cz', true, 0, 0.0, false, 0, 'typVztahu.zdravotka', '209', 0, 'CZ_ZDR_209');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, ulice, mesto, psc, tel, fax, email, www, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('211', 'aadresar', ' '), 'Zdravotní pojišťovna ministerstva vnitra České republiky', true, 0, 9999, 'Na Míčánkách 2', 'Praha 10', '101 00', '272 095 111, 844 121 121', '272732430', 'info@zpmvcr.cz', 'www.zpmvcr.cz', true, 0, 0.0, false, 0, 'typVztahu.zdravotka', '211', 0, 'CZ_ZDR_211');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, ulice, mesto, psc, tel, fax, email, www, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('213', 'aadresar', ' '), 'Revírní bratrská pokladna', true, 0, 9999, 'Michálkovická 108', 'Slezská Ostrava', '710 15', '596256111', '596256205', 'https://portal.rbp-zp.cz/cpod825ano.phtml', 'www.rbp-zp.cz', true, 0, 0.0, false, 0, 'typVztahu.zdravotka', '213', 0, 'CZ_ZDR_213');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, ulice, mesto, psc, tel, fax, email, www, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('217', 'aadresar', ' '), 'Zdravotní pojišťovna METAL-ALIANCE', true, 0, 9999, 'Čermákova 1951', 'Kladno', '272 00', '312 247 678, 844 125 124', '312249323', 'info@zpma.cz', 'www.zpma.cz', true, 0, 0.0, false, 0, 'typVztahu.zdravotka', '217', 0, 'CZ_ZDR_217');
-- socialka 
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('110', 'aadresar', ' '), 'Praha 10', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '110', 0, 'CZ_SOC_110');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('111', 'aadresar', ' '), 'Praha 1', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '111', 0, 'CZ_SOC_111');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('112', 'aadresar', ' '), 'Praha 2', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '112', 0, 'CZ_SOC_112');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('113', 'aadresar', ' '), 'Praha 3', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '113', 0, 'CZ_SOC_113');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('114', 'aadresar', ' '), 'Praha 4', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '114', 0, 'CZ_SOC_114');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('115', 'aadresar', ' '), 'Praha 5', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '115', 0, 'CZ_SOC_115');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('116', 'aadresar', ' '), 'Praha 6', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '116', 0, 'CZ_SOC_116');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('117', 'aadresar', ' '), 'Praha 7', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '117', 0, 'CZ_SOC_117');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('118', 'aadresar', ' '), 'Praha 8', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '118', 0, 'CZ_SOC_118');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('119', 'aadresar', ' '), 'Praha 9', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '119', 0, 'CZ_SOC_119');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('121', 'aadresar', ' '), 'Jihozápadní Město', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '121', 0, 'CZ_SOC_121');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('122', 'aadresar', ' '), 'Modřany', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '122', 0, 'CZ_SOC_122');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('123', 'aadresar', ' '), 'Praha 23 - Jižní Město', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '123', 0, 'CZ_SOC_123');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('220', 'aadresar', ' '), 'Benešov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '220', 0, 'CZ_SOC_220');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('221', 'aadresar', ' '), 'Beroun', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '221', 0, 'CZ_SOC_221');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('222', 'aadresar', ' '), 'Kladno', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '222', 0, 'CZ_SOC_222');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('223', 'aadresar', ' '), 'Kolín', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '223', 0, 'CZ_SOC_223');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('224', 'aadresar', ' '), 'Kutná Hora', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '224', 0, 'CZ_SOC_224');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('225', 'aadresar', ' '), 'Mělník', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '225', 0, 'CZ_SOC_225');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('226', 'aadresar', ' '), 'Mladá Boleslav', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '226', 0, 'CZ_SOC_226');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('227', 'aadresar', ' '), 'Nymburk', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '227', 0, 'CZ_SOC_227');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('228', 'aadresar', ' '), 'Praha - východ', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '228', 0, 'CZ_SOC_228');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('229', 'aadresar', ' '), 'Praha - západ', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '229', 0, 'CZ_SOC_229');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('230', 'aadresar', ' '), 'Příbram', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '230', 0, 'CZ_SOC_230');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('231', 'aadresar', ' '), 'Rakovník', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '231', 0, 'CZ_SOC_231');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('332', 'aadresar', ' '), 'České Budějovice', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '332', 0, 'CZ_SOC_332');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('333', 'aadresar', ' '), 'Český Krumlov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '333', 0, 'CZ_SOC_333');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('334', 'aadresar', ' '), 'Jindřichův Hradec', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '334', 0, 'CZ_SOC_334');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('335', 'aadresar', ' '), 'Pelhřimov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '335', 0, 'CZ_SOC_335');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('336', 'aadresar', ' '), 'Písek', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '336', 0, 'CZ_SOC_336');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('337', 'aadresar', ' '), 'Prachatice', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '337', 0, 'CZ_SOC_337');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('338', 'aadresar', ' '), 'Strakonice', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '338', 0, 'CZ_SOC_338');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('339', 'aadresar', ' '), 'Tábor', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '339', 0, 'CZ_SOC_339');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('440', 'aadresar', ' '), 'Domažlice', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '440', 0, 'CZ_SOC_440');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('441', 'aadresar', ' '), 'Cheb', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '441', 0, 'CZ_SOC_441');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('442', 'aadresar', ' '), 'Karlovy Vary', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '442', 0, 'CZ_SOC_442');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('443', 'aadresar', ' '), 'Klatovy', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '443', 0, 'CZ_SOC_443');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('444', 'aadresar', ' '), 'Plzeň - město', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '444', 0, 'CZ_SOC_444');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('445', 'aadresar', ' '), 'Plzeň - jih', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '445', 0, 'CZ_SOC_445');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('446', 'aadresar', ' '), 'Plzeň - sever', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '446', 0, 'CZ_SOC_446');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('447', 'aadresar', ' '), 'Rokycany', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '447', 0, 'CZ_SOC_447');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('448', 'aadresar', ' '), 'Sokolov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '448', 0, 'CZ_SOC_448');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('449', 'aadresar', ' '), 'Tachov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '449', 0, 'CZ_SOC_449');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('550', 'aadresar', ' '), 'Česká Lípa', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '550', 0, 'CZ_SOC_550');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('551', 'aadresar', ' '), 'Děčín', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '551', 0, 'CZ_SOC_551');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('552', 'aadresar', ' '), 'Chomutov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '552', 0, 'CZ_SOC_552');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('553', 'aadresar', ' '), 'Jablonec nad Nisou', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '553', 0, 'CZ_SOC_553');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('554', 'aadresar', ' '), 'Liberec', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '554', 0, 'CZ_SOC_554');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('555', 'aadresar', ' '), 'Litoměřice', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '555', 0, 'CZ_SOC_555');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('556', 'aadresar', ' '), 'Louny', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '556', 0, 'CZ_SOC_556');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('557', 'aadresar', ' '), 'Most', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '557', 0, 'CZ_SOC_557');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('558', 'aadresar', ' '), 'Teplice', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '558', 0, 'CZ_SOC_558');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('559', 'aadresar', ' '), 'Ústí nad Labem', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '559', 0, 'CZ_SOC_559');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('660', 'aadresar', ' '), 'Havlíčkův Brod', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '660', 0, 'CZ_SOC_660');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('661', 'aadresar', ' '), 'Hradec Králové', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '661', 0, 'CZ_SOC_661');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('662', 'aadresar', ' '), 'Chrudim', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '662', 0, 'CZ_SOC_662');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('663', 'aadresar', ' '), 'Jičín', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '663', 0, 'CZ_SOC_663');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('664', 'aadresar', ' '), 'Náchod', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '664', 0, 'CZ_SOC_664');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('665', 'aadresar', ' '), 'Pardubice', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '665', 0, 'CZ_SOC_665');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('666', 'aadresar', ' '), 'Rychnov nad Kněžnou', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '666', 0, 'CZ_SOC_666');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('667', 'aadresar', ' '), 'Semily', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '667', 0, 'CZ_SOC_667');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('668', 'aadresar', ' '), 'Svitavy', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '668', 0, 'CZ_SOC_668');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('669', 'aadresar', ' '), 'Trutnov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '669', 0, 'CZ_SOC_669');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('670', 'aadresar', ' '), 'Ústí nad Orlicí', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '670', 0, 'CZ_SOC_670');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('771', 'aadresar', ' '), 'Blansko', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '771', 0, 'CZ_SOC_771');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('772', 'aadresar', ' '), 'Brno - město', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '772', 0, 'CZ_SOC_772');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('773', 'aadresar', ' '), 'Brno - venkov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '773', 0, 'CZ_SOC_773');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('774', 'aadresar', ' '), 'Břeclav', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '774', 0, 'CZ_SOC_774');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('775', 'aadresar', ' '), 'Zlín', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '775', 0, 'CZ_SOC_775');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('776', 'aadresar', ' '), 'Hodonín', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '776', 0, 'CZ_SOC_776');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('777', 'aadresar', ' '), 'Jihlava', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '777', 0, 'CZ_SOC_777');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('778', 'aadresar', ' '), 'Kroměříž', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '778', 0, 'CZ_SOC_778');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('779', 'aadresar', ' '), 'Prostějov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '779', 0, 'CZ_SOC_779');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('780', 'aadresar', ' '), 'Třebíč', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '780', 0, 'CZ_SOC_780');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('781', 'aadresar', ' '), 'Uherské Hradiště', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '781', 0, 'CZ_SOC_781');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('782', 'aadresar', ' '), 'Vyškov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '782', 0, 'CZ_SOC_782');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('783', 'aadresar', ' '), 'Znojmo', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '783', 0, 'CZ_SOC_783');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('784', 'aadresar', ' '), 'Žďár nad Sázavou', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '784', 0, 'CZ_SOC_784');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('884', 'aadresar', ' '), 'Jeseník', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '884', 0, 'CZ_SOC_884');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('885', 'aadresar', ' '), 'Bruntál', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '885', 0, 'CZ_SOC_885');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('886', 'aadresar', ' '), 'Frýdek - Místek', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '886', 0, 'CZ_SOC_886');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('887', 'aadresar', ' '), 'Karviná', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '887', 0, 'CZ_SOC_887');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('888', 'aadresar', ' '), 'Nový Jičín', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '888', 0, 'CZ_SOC_888');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('889', 'aadresar', ' '), 'Olomouc', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '889', 0, 'CZ_SOC_889');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('890', 'aadresar', ' '), 'Opava', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '890', 0, 'CZ_SOC_890');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('891', 'aadresar', ' '), 'Ostrava - město', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '891', 0, 'CZ_SOC_891');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('892', 'aadresar', ' '), 'Přerov', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '892', 0, 'CZ_SOC_892');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('893', 'aadresar', ' '), 'Šumperk', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '893', 0, 'CZ_SOC_893');
INSERT INTO aadresar (lastUpdate, kod, nazev, show, platiod, platido, postovnishodna, splatdny, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, pocetpriloh, uuid)
 VALUES ('2009-12-11 00:00:00.000', generateuniquekod('894', 'aadresar', ' '), 'Vsetín', true, 0, 9999, true, 0, 0.0, false, 0, 'typVztahu.socialka', '894', 0, 'CZ_SOC_894');
-- financak

  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 223, 't');
