--------------------------------------------------------------------------------
-- Bug 17570 – [WinStrom] Výrazný pokles výkonu při vytváření dokladu
--------------------------------------------------------------------------------

-- uprava triggeru menici uzaverku ucetniho obdobi
CREATE OR REPLACE FUNCTION uobratyinsertupdate() RETURNS trigger AS $$
begin
  update nUcetObdobi set zmenaZaver = true where idUcetObdobi = NEW.idUcetObdobi and zmenaZaver = false;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.uobratyinsertupdate() OWNER TO %firmaRole%;

-- uprava trigger generujici mzdove slozky pri zmene ucetniho obdobi
CREATE OR REPLACE FUNCTION nucetobdobiupdatemzdsloz() RETURNS trigger AS $$
declare
  ZAZNAM record;
begin
  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;
  else
    ZAZNAM := NEW;
  end if;
  
  if (tg_op = 'UPDATE') then
    if (NEW.platioddata <> OLD.platioddata or NEW.platidodata <> OLD.platidodata) then
      perform pgeneratemzdslozforpracpom(-1);
    end if;
  else
    perform pgeneratemzdslozforpracpom(-1);
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.nucetobdobiupdatemzdsloz() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 227, 't');
