--------------------------------------------------------------------------------
-- Bug 17809 - Účetní závěrka - na účtě 710 se v novém období ukazuje zůstatek který tam nemá co dělat
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION uuzavriucetniobdobi(idoldobdobi integer, idnewobdobi integer, iducet701 integer, iducet702 integer, iducet710 integer, iducet431 integer)
  RETURNS void AS
$BODY$
declare
  nDatum date;
  newObrat record;
  pom integer;
begin
  select platiOdData into nDatum from nUcetObdobi where idUcetObdobi = idNewObdobi;
  /*smazani pripadne predchozi zaverky*/
  delete from uObraty where idUcetObdobi = idOldObdobi and obdobi = 99;
  delete from uObraty where idUcetObdobi = idNewObdobi and obdobi = 0;

  /* [1] Sesumovani obratu MD/D a zauctovani uzavreni vsech uctu v obdobi 99 */
  /* Protistranou techto ucetnich operaci bude pro rozvahove ucty ucet 702 (viz bod [3])
     a pro vysledkove ucty ucet 710 (viz bod [4]) */
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,O.idUcet,O.idStred,min(O.Rok) as Rok,99 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,O.idUcetObdobi,now() as LastUpdate from
      uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet where
      O.idUcetObdobi = idOldObdobi and U.typUctuK <> 'typUctu.zaverkovy'
      group by O.idMeny,O.idUcet,O.idStred,O.idUcetObdobi);

  /* [2] Presun zustatku rozvahovych uctu do obdobi 0 noveho roku */
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,O.idUcet,O.idStred,date_part('year', nDatum) as Rok,0 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,idNewObdobi as idUcetObdobi,now() as LastUpdate from
      uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet where
      O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and U.typUctuK in( 'typUctu.rozvahovy','typUctu.podrozvahovy','typUctu.vnitropodnikovy')
      group by O.idMeny,O.idUcet,O.idStred,O.idUcetObdobi,U.typUctuK);

  /* [3] Sumace na zaverkovy ucet 702 - protistrana k ucetnim operacim z bodu [1a] */
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,idUcet702 as idUcet,O.idStred,min(Rok) as Rok,99 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,O.idUcetObdobi,now() as LastUpdate from
      uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet where
      O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and U.typUctuK in( 'typUctu.rozvahovy','typUctu.podrozvahovy','typUctu.vnitropodnikovy')
      group by O.idMeny,O.idStred,O.idUcetObdobi);

  /* [4] Sumace na zaverkovy ucet 710 - protistrana k ucetnim operacim z bodu [1b] */
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,idUcet710 as idUcet,O.idStred,min(Rok) as Rok,99 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,O.idUcetObdobi,now() as LastUpdate from
      uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet where
      O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and U.typUctuK = 'typUctu.vysledkovy'
      group by O.idMeny,O.idStred,O.idUcetObdobi);

  /* [5] Presun uctu 702 na ucet 701 v novem roce */
  insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select idMeny,idUcet701 as idUcet,idStred,date_part('year', nDatum) as Rok,0 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,idNewObdobi as idUcetObdobi,now() as LastUpdate from
      uObraty as O where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and O.idUcet = idUcet702 group by O.idMeny,O.idStred,O.idUcetObdobi);

  /* [6] Presun zustatku uctu 710 ze stareho roku na ucet 701 v novem roce (s prohozenim stran) */
  for newObrat in (select idMeny,idUcet701 as idUcet,idStred,date_part('year', nDatum) as Rok,0 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,idNewObdobi as idUcetObdobi,now() as LastUpdate from
      uObraty as O where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and O.idUcet = idUcet710 group by O.idMeny,O.idStred,O.idUcetObdobi) loop
	select count(1) into pom from uObraty
		where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
		and iducet = newObrat.idUcet and idstred = newObrat.idStred and iducetobdobi = newObrat.idUcetObdobi;
	if (pom > 0) then
		update uObraty set obrdal = obrdal + newObrat.ObrDal, obrmd = obrmd + newObrat.ObrMd
			where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
			and iducet = newObrat.idUcet and idstred = newObrat.idStred and iducetobdobi = newObrat.idUcetObdobi;
	else
		insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate)
			values (newObrat.idMeny, newObrat.idUcet, newObrat.idStred, newObrat.Rok, newObrat.Obdobi, newObrat.ObrDal, newObrat.ObrMd, newObrat.idUcetObdobi, newObrat.LastUpdate);
	end if;
  end loop;

  /* [7] Presun zustatku uctu 710 ze stareho roku na ucet 431 v novem roce (bez prohozeni stran) */
  for newObrat in (select idMeny,idUcet431 as idUcet,idStred,date_part('year', nDatum) as Rok,0 as Obdobi,sum(O.ObrDal) as ObrDal,sum(O.ObrMd) as ObrMd,idNewObdobi as idUcetObdobi,now() as LastUpdate from
      uObraty as O where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and O.idUcet = idUcet710 group by O.idMeny,O.idStred,O.idUcetObdobi) loop
	/** idUcet je 431 a ten jiz mohl byt zalozen, pokud na nej jiz uctovali */
	select count(1) into pom from uObraty
		where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
		and iducet = newObrat.idUcet and idstred = newObrat.idStred and iducetobdobi = newObrat.idUcetObdobi;
	if (pom > 0) then
		update uObraty set obrdal = obrdal + newObrat.ObrDal, obrmd = obrmd + newObrat.ObrMd
			where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
			and iducet = newObrat.idUcet and idstred = newObrat.idStred and iducetobdobi = newObrat.idUcetObdobi;
	else
		insert into uObraty( idMeny,idUcet,idStred,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate)
			values (newObrat.idMeny, newObrat.idUcet, newObrat.idStred, newObrat.Rok, newObrat.Obdobi, newObrat.ObrDal, newObrat.ObrMd, newObrat.idUcetObdobi, newObrat.LastUpdate);
	end if;
  end loop;

end;
$BODY$
  LANGUAGE 'plpgsql';

ALTER FUNCTION uuzavriucetniobdobi(idoldobdobi integer, idnewobdobi integer, iducet701 integer, iducet702 integer, iducet710 integer, iducet431 integer) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 234, 't');
