--------------------------------------------------------------------------------
-- Bug 19814 – [winstrom] - Peníze - maloobchodní prodej
--------------------------------------------------------------------------------

ALTER TABLE ddoklfak ADD COLUMN prodejka boolean NOT NULL DEFAULT false;
ALTER TABLE dpolfak ADD COLUMN prodejka boolean NOT NULL DEFAULT false;
ALTER TABLE dtypdokl ADD COLUMN prodejka boolean NOT NULL DEFAULT false;


ALTER TABLE dtypdokl ADD COLUMN idtypdoklpok integer;
ALTER TABLE dtypdokl ADD COLUMN idtypdoklskl integer;

ALTER TABLE dtypdokl ADD CONSTRAINT dtypdokl_idtypdoklpok FOREIGN KEY (idtypdoklpok)
  REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE dtypdokl ADD CONSTRAINT dtypdokl_idtypdoklskl FOREIGN KEY (idtypdoklskl)
  REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dTypDokl_IdTypDoklPok_index ON dTypDokl USING btree (IdTypDoklPok);
CREATE INDEX dTypDokl_IdTypDoklSkl_index ON dTypDokl USING btree (IdTypDoklSkl);

-- přidání řady a typu dokladu
create or replace function runupgrade()
    returns void as $$
declare
    _idtyporgread integer;
begin
  select idtyporg into _idtyporgread from nnastav limit 1;

  -- sestavy aktualizujeme jen pro cechy
  if (_idtyporgread = 1) then
-- zacatek bloku ceskych podnikatelu
INSERT INTO drady (lastupdate, kod, nazev, show, platiod, platido, modul, uuid)
 VALUES ('2010-07-22 00:00:00.000', generateuniquekod('KASA', 'dRady', '_'), 'Kasa', true, 0, 9999, 'FAV', 'CZ_KASA');
INSERT INTO dradyrok (lastupdate, cisdelka, zobraznuly, cisakt, cispoc, prefix, postfix, idrady, iducetobdobi)
 VALUES ('2010-07-22 00:00:00.000', 4, true, 1, 1, 'KASA-', '/%YYYY%', (select IdRady from dRady where uuid = 'CZ_KASA'), (select max(iducetobdobi) from nucetobdobi));

INSERT INTO dtypdokl (lastupdate, kod, nazev, show, modul, ucetni, typdoklk, primarni, slevadokl, generovatskl, buckonverze, bucprimarni, tiskfaktura, tiskdodak, tiskpokldokl, tiskdodakvydejka, tiskvydejka, tiskautomat, prodejka, platiod, platido, idradyprijem, idmeny, idstatdph, idtyporg, uuid)
 VALUES ('2010-07-22 00:00:00.000', generateuniquekod('KASA', 'dTypDokl', '_'), 'Kasa', true, 'FAV', false, 'typDokladu.prodejka', false, 0.0, true, false, false, true, false, false, false, false, false, true, 0, 9999, (select IdRady from dRady where uuid = 'CZ_KASA'), (select IdMeny from uMeny where uuid = 'CZ_CZK'), (select IdStatu from aStaty where uuid like '%_CZ'), 1, 'CZ_POD_KASA');
  end if;
  -- konec ceskeho bloku
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 336, 't');
