--------------------------------------------------------------------------------
-- Bug 20282 – [WinStrom] Překlad výkazů do angličtiny
-- Bug 19360 – [WinStrom] Chyby v rozvaze pro příspěvkové organizace
-- Bug 19357 – [WinStrom] Opravit řádky rozvahy - pro Slováky
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    _idtyporgread integer;
begin
  select idtyporg into _idtyporgread from nnastav limit 1;

  -- sestavy aktualizujeme jen pro cechy
  if (_idtyporgread = 1) then
-- zacatek bloku ceskych podnikatelu

-- doplneni chybejicich uuid
UPDATE usestavy SET uuid = 'CZ_PODNIKATELE_IFRS_BS' WHERE IdSestavy = 201;
UPDATE usestavy SET uuid = 'CZ_PODNIKATELE_IFRS_PL' WHERE IdSestavy = 202;

-- dolneny anglicke texty na sestavy
UPDATE usestavy SET nazeva = 'THE BALANCE SHEET', nazevsloupa1 = 'Gross', nazevsloupa2 = 'Adjustments', nazevsloupa3 = 'Net', nazevsloupa6 = 'Prev. Acc. Period Net' WHERE IdSestavy = 1;
UPDATE usestavy SET nazeva = 'INCOME STATEMENT', nazevsloupa1 = 'Current Accounting Period', nazevsloupa4 = 'Prev. Accounting Period' WHERE IdSestavy = 2;

-- na radky
UPDATE usesradky SET nazeva = 'Receivables for subscribed share capital' WHERE IdSesRadky = 1;
UPDATE usesradky SET nazeva = 'Start up (incorporation) expenses' WHERE IdSesRadky = 2;
UPDATE usesradky SET nazeva = 'Research & development (intangible profit/loss)' WHERE IdSesRadky = 3;
UPDATE usesradky SET nazeva = 'Software' WHERE IdSesRadky = 4;
UPDATE usesradky SET nazeva = 'Licenses, know-how, copyright and other valuable' WHERE IdSesRadky = 5;
UPDATE usesradky SET nazeva = 'Goodwill (+/-)' WHERE IdSesRadky = 6;
UPDATE usesradky SET nazeva = 'Other intangible fixed assets' WHERE IdSesRadky = 7;
UPDATE usesradky SET nazeva = 'Incomplete intangible fixed assets' WHERE IdSesRadky = 8;
UPDATE usesradky SET nazeva = 'Payments on account of intangible fixed assets' WHERE IdSesRadky = 9;
UPDATE usesradky SET nazeva = 'Tangible fixed assets' WHERE IdSesRadky = 10;
UPDATE usesradky SET nazeva = 'Land' WHERE IdSesRadky = 11;
UPDATE usesradky SET nazeva = 'Constructions' WHERE IdSesRadky = 12;
UPDATE usesradky SET nazeva = 'Other chattels - items and sets' WHERE IdSesRadky = 13;
UPDATE usesradky SET nazeva = 'Permanent crop stands' WHERE IdSesRadky = 14;
UPDATE usesradky SET nazeva = 'Livestock and draught animals' WHERE IdSesRadky = 15;
UPDATE usesradky SET nazeva = 'Other tangible fixed assets' WHERE IdSesRadky = 16;
UPDATE usesradky SET nazeva = 'Incomplete tangible fixed assets' WHERE IdSesRadky = 17;
UPDATE usesradky SET nazeva = 'Payments on account of tangible fixed assets' WHERE IdSesRadky = 18;
UPDATE usesradky SET nazeva = 'Adjustments to acquired assets (+/-)' WHERE IdSesRadky = 19;
UPDATE usesradky SET nazeva = 'Investments in controlled entities (over 50 %)' WHERE IdSesRadky = 20;
UPDATE usesradky SET nazeva = 'Investments in accounting entities under' WHERE IdSesRadky = 21;
UPDATE usesradky SET nazeva = 'Other long-term investments, shares and' WHERE IdSesRadky = 22;
UPDATE usesradky SET nazeva = 'Loans to group entities - controlling entities/significant influence' WHERE IdSesRadky = 23;
UPDATE usesradky SET nazeva = 'Other long-term investments' WHERE IdSesRadky = 24;
UPDATE usesradky SET nazeva = 'Pending acquisitions' WHERE IdSesRadky = 25;
UPDATE usesradky SET nazeva = 'Payments on account of long-term investments' WHERE IdSesRadky = 26;
UPDATE usesradky SET nazeva = 'Raw materials' WHERE IdSesRadky = 27;
UPDATE usesradky SET nazeva = 'WIP and semi-finished goods' WHERE IdSesRadky = 28;
UPDATE usesradky SET nazeva = 'Finished goods' WHERE IdSesRadky = 29;
UPDATE usesradky SET nazeva = 'Livestock' WHERE IdSesRadky = 30;
UPDATE usesradky SET nazeva = 'Goods for resale' WHERE IdSesRadky = 31;
UPDATE usesradky SET nazeva = 'Payments on account of inventories' WHERE IdSesRadky = 32;
UPDATE usesradky SET nazeva = 'Receivables - subsidiaries' WHERE IdSesRadky = 33;
UPDATE usesradky SET nazeva = 'Deferred tax receivable' WHERE IdSesRadky = 34;
UPDATE usesradky SET nazeva = 'Trade receivables' WHERE IdSesRadky = 35;
UPDATE usesradky SET nazeva = 'Receivables - controlling entities (50%)' WHERE IdSesRadky = 36;
UPDATE usesradky SET nazeva = 'Receivables from partners, cooperative members and participants' WHERE IdSesRadky = 37;
UPDATE usesradky SET nazeva = 'Social security and health insurance receivables' WHERE IdSesRadky = 38;
UPDATE usesradky SET nazeva = 'State: Tax receivables' WHERE IdSesRadky = 39;
UPDATE usesradky SET nazeva = 'Anticipated assets' WHERE IdSesRadky = 40;
UPDATE usesradky SET nazeva = 'Other receivables' WHERE IdSesRadky = 41;
UPDATE usesradky SET nazeva = 'Cash in hand' WHERE IdSesRadky = 42;
UPDATE usesradky SET nazeva = 'Bank at bank' WHERE IdSesRadky = 43;
UPDATE usesradky SET nazeva = 'Short-term securities and shares' WHERE IdSesRadky = 44;
UPDATE usesradky SET nazeva = 'Pending acquisitions' WHERE IdSesRadky = 45;
UPDATE usesradky SET nazeva = 'Prepaid expenses' WHERE IdSesRadky = 46;
UPDATE usesradky SET nazeva = 'Total prepaid expenses' WHERE IdSesRadky = 47;
UPDATE usesradky SET nazeva = 'Anticipated accruals and receivables' WHERE IdSesRadky = 48;
UPDATE usesradky SET nazeva = 'Share capital' WHERE IdSesRadky = 49;
UPDATE usesradky SET nazeva = 'Own shares and ownership interests (-)' WHERE IdSesRadky = 50;
UPDATE usesradky SET nazeva = 'Changes in the registered capital (+/-)' WHERE IdSesRadky = 51;
UPDATE usesradky SET nazeva = 'Share premium' WHERE IdSesRadky = 52;
UPDATE usesradky SET nazeva = 'Other capital funds' WHERE IdSesRadky = 53;
UPDATE usesradky SET nazeva = 'Asset and liabilities revaluation differences (+/-)' WHERE IdSesRadky = 54;
UPDATE usesradky SET nazeva = 'Changes in the capital stock revaluation differences (+/-)' WHERE IdSesRadky = 55;
UPDATE usesradky SET nazeva = 'Statutory reserve fund, non-distributable reserves' WHERE IdSesRadky = 56;
UPDATE usesradky SET nazeva = 'Statutory and other funds' WHERE IdSesRadky = 57;
UPDATE usesradky SET nazeva = 'Retained profits from prior years' WHERE IdSesRadky = 58;
UPDATE usesradky SET nazeva = 'Loss from prior years (-)' WHERE IdSesRadky = 59;
UPDATE usesradky SET nazeva = 'Profit (loss) for the current year' WHERE IdSesRadky = 60;
UPDATE usesradky SET nazeva = 'Special regulatory provisions' WHERE IdSesRadky = 61;
UPDATE usesradky SET nazeva = 'Old-age pension provision and similar liabilities' WHERE IdSesRadky = 62;
UPDATE usesradky SET nazeva = 'Income tax provision' WHERE IdSesRadky = 63;
UPDATE usesradky SET nazeva = 'Liabilities - controlling entities (50%)' WHERE IdSesRadky = 64;
UPDATE usesradky SET nazeva = 'Liabilities - entities with a significant interest' WHERE IdSesRadky = 65;
UPDATE usesradky SET nazeva = 'Advances received' WHERE IdSesRadky = 66;
UPDATE usesradky SET nazeva = 'Deferred tax liability' WHERE IdSesRadky = 67;
UPDATE usesradky SET nazeva = 'Trade payables' WHERE IdSesRadky = 68;
UPDATE usesradky SET nazeva = 'Payables to controlling legal entities (50%)' WHERE IdSesRadky = 69;
UPDATE usesradky SET nazeva = 'Payables to legal entities with a significant interest' WHERE IdSesRadky = 70;
UPDATE usesradky SET nazeva = 'Payables to partners, cooperative members and participants' WHERE IdSesRadky = 71;
UPDATE usesradky SET nazeva = 'Liabilities to employees' WHERE IdSesRadky = 72;
UPDATE usesradky SET nazeva = 'Liabilities for social security and health insurance' WHERE IdSesRadky = 73;
UPDATE usesradky SET nazeva = 'State: Taxes payable and subsidies payable' WHERE IdSesRadky = 74;
UPDATE usesradky SET nazeva = 'Advances received' WHERE IdSesRadky = 75;
UPDATE usesradky SET nazeva = 'Debenture bonds issued' WHERE IdSesRadky = 76;
UPDATE usesradky SET nazeva = 'Anticipated liabilities' WHERE IdSesRadky = 77;
UPDATE usesradky SET nazeva = 'Other payables' WHERE IdSesRadky = 78;
UPDATE usesradky SET nazeva = 'Bank loans - long term' WHERE IdSesRadky = 79;
UPDATE usesradky SET nazeva = 'Bank loans - short-term' WHERE IdSesRadky = 80;
UPDATE usesradky SET nazeva = 'Short-term loans (other than bank loans)' WHERE IdSesRadky = 81;
UPDATE usesradky SET nazeva = 'Accrued expenses' WHERE IdSesRadky = 82;
UPDATE usesradky SET nazeva = 'Deferred revenue' WHERE IdSesRadky = 83;
UPDATE usesradky SET nazeva = 'TOTAL ASSETS' WHERE IdSesRadky = 84;
UPDATE usesradky SET nazeva = 'Fixed assets' WHERE IdSesRadky = 85;
UPDATE usesradky SET nazeva = 'Current assets' WHERE IdSesRadky = 86;
UPDATE usesradky SET nazeva = 'Accruals and deferrals' WHERE IdSesRadky = 87;
UPDATE usesradky SET nazeva = 'Intangible fixed assets' WHERE IdSesRadky = 88;
UPDATE usesradky SET nazeva = 'Long-term investments' WHERE IdSesRadky = 89;
UPDATE usesradky SET nazeva = 'Inventories' WHERE IdSesRadky = 90;
UPDATE usesradky SET nazeva = 'Long-term receivables' WHERE IdSesRadky = 91;
UPDATE usesradky SET nazeva = 'Short-term receivables' WHERE IdSesRadky = 92;
UPDATE usesradky SET nazeva = 'Financial assets' WHERE IdSesRadky = 93;
UPDATE usesradky SET nazeva = 'Trade receivables' WHERE IdSesRadky = 94;
UPDATE usesradky SET nazeva = 'Receivables - controlling entities (50%)' WHERE IdSesRadky = 95;
UPDATE usesradky SET nazeva = 'Receivables from partners, cooperative members and participants' WHERE IdSesRadky = 96;
UPDATE usesradky SET nazeva = 'Long-term advances paid' WHERE IdSesRadky = 97;
UPDATE usesradky SET nazeva = 'Anticipated assets' WHERE IdSesRadky = 98;
UPDATE usesradky SET nazeva = 'Other receivables' WHERE IdSesRadky = 99;
UPDATE usesradky SET nazeva = 'Short-term advances paid' WHERE IdSesRadky = 100;
UPDATE usesradky SET nazeva = 'Receivables - significant influence' WHERE IdSesRadky = 101;
UPDATE usesradky SET nazeva = 'Control summary-ASSETS' WHERE IdSesRadky = 102;
UPDATE usesradky SET nazeva = 'TOTAL LIABILITIES' WHERE IdSesRadky = 103;
UPDATE usesradky SET nazeva = 'Equity' WHERE IdSesRadky = 104;
UPDATE usesradky SET nazeva = 'External liabilities' WHERE IdSesRadky = 105;
UPDATE usesradky SET nazeva = 'Accruals' WHERE IdSesRadky = 106;
UPDATE usesradky SET nazeva = 'Retained earnings from prior years' WHERE IdSesRadky = 107;
UPDATE usesradky SET nazeva = 'Reserve funds, non-distributable reserves and other reserves' WHERE IdSesRadky = 108;
UPDATE usesradky SET nazeva = 'Share capital' WHERE IdSesRadky = 109;
UPDATE usesradky SET nazeva = 'Capital contributions' WHERE IdSesRadky = 110;
UPDATE usesradky SET nazeva = 'Provisions' WHERE IdSesRadky = 111;
UPDATE usesradky SET nazeva = 'Long term liabilities' WHERE IdSesRadky = 112;
UPDATE usesradky SET nazeva = 'Short-term liabilities' WHERE IdSesRadky = 113;
UPDATE usesradky SET nazeva = 'Bank loans and other accommodations' WHERE IdSesRadky = 114;
UPDATE usesradky SET nazeva = 'Other provisions' WHERE IdSesRadky = 115;
UPDATE usesradky SET nazeva = 'Long-dated bills payable' WHERE IdSesRadky = 116;
UPDATE usesradky SET nazeva = 'Other payables' WHERE IdSesRadky = 117;
UPDATE usesradky SET nazeva = 'Anticipated liabilities' WHERE IdSesRadky = 118;
UPDATE usesradky SET nazeva = 'Debenture bonds issued' WHERE IdSesRadky = 119;
UPDATE usesradky SET nazeva = 'Liabilities to partners, cooperative members and participants' WHERE IdSesRadky = 120;
UPDATE usesradky SET nazeva = 'Trade payables' WHERE IdSesRadky = 121;
UPDATE usesradky SET nazeva = 'Control summary-LIABILITIES' WHERE IdSesRadky = 122;
UPDATE usesradky SET nazeva = 'Sale of goods' WHERE IdSesRadky = 123;
UPDATE usesradky SET nazeva = 'Cost of goods sold' WHERE IdSesRadky = 124;
UPDATE usesradky SET nazeva = 'Sales of own products and services' WHERE IdSesRadky = 125;
UPDATE usesradky SET nazeva = 'Change in inventory and WIP' WHERE IdSesRadky = 126;
UPDATE usesradky SET nazeva = 'Own work capitalised' WHERE IdSesRadky = 127;
UPDATE usesradky SET nazeva = 'Raw materials and consumables' WHERE IdSesRadky = 128;
UPDATE usesradky SET nazeva = 'Services' WHERE IdSesRadky = 129;
UPDATE usesradky SET nazeva = 'Wages and salaries' WHERE IdSesRadky = 130;
UPDATE usesradky SET nazeva = 'Remuneration of board members' WHERE IdSesRadky = 131;
UPDATE usesradky SET nazeva = 'Social security and health insurance costs' WHERE IdSesRadky = 132;
UPDATE usesradky SET nazeva = 'Other social cost' WHERE IdSesRadky = 133;
UPDATE usesradky SET nazeva = 'Taxes and charges' WHERE IdSesRadky = 134;
UPDATE usesradky SET nazeva = 'Depreciation of long-term assets' WHERE IdSesRadky = 135;
UPDATE usesradky SET nazeva = 'Sale of long-term assets' WHERE IdSesRadky = 136;
UPDATE usesradky SET nazeva = 'Sale of material' WHERE IdSesRadky = 137;
UPDATE usesradky SET nazeva = 'Net book value of long-term assets sold' WHERE IdSesRadky = 138;
UPDATE usesradky SET nazeva = 'Material sold' WHERE IdSesRadky = 139;
UPDATE usesradky SET nazeva = 'Increase / (decrease) in operating provisions and complex prepaid expenses' WHERE IdSesRadky = 140;
UPDATE usesradky SET nazeva = 'Other operating income' WHERE IdSesRadky = 141;
UPDATE usesradky SET nazeva = 'Other operating charges' WHERE IdSesRadky = 142;
UPDATE usesradky SET nazeva = 'Transfer of operating income' WHERE IdSesRadky = 143;
UPDATE usesradky SET nazeva = 'Transfer of operating charges' WHERE IdSesRadky = 144;
UPDATE usesradky SET nazeva = 'Revenue from securities and shares sold' WHERE IdSesRadky = 145;
UPDATE usesradky SET nazeva = 'Book value of securities and shares sold' WHERE IdSesRadky = 146;
UPDATE usesradky SET nazeva = 'Income from investments in group companies (controlled legal entities and accou)' WHERE IdSesRadky = 147;
UPDATE usesradky SET nazeva = 'Income from short-term investments' WHERE IdSesRadky = 148;
UPDATE usesradky SET nazeva = 'Costs of short-term investments' WHERE IdSesRadky = 149;
UPDATE usesradky SET nazeva = 'Income from re-evaluation of securities and derivatives' WHERE IdSesRadky = 150;
UPDATE usesradky SET nazeva = 'Costs of re-evaluation of securities and derivatives' WHERE IdSesRadky = 151;
UPDATE usesradky SET nazeva = 'Release or reserves related to financial items' WHERE IdSesRadky = 152;
UPDATE usesradky SET nazeva = 'Interest income' WHERE IdSesRadky = 153;
UPDATE usesradky SET nazeva = 'Interest charge' WHERE IdSesRadky = 154;
UPDATE usesradky SET nazeva = 'Other financial income' WHERE IdSesRadky = 155;
UPDATE usesradky SET nazeva = 'Other financial costs' WHERE IdSesRadky = 156;
UPDATE usesradky SET nazeva = 'Transfer of financial earnings' WHERE IdSesRadky = 157;
UPDATE usesradky SET nazeva = 'Transfer of financial costs' WHERE IdSesRadky = 158;
UPDATE usesradky SET nazeva = '-current' WHERE IdSesRadky = 159;
UPDATE usesradky SET nazeva = '-deferred' WHERE IdSesRadky = 160;
UPDATE usesradky SET nazeva = 'Extraordinary income' WHERE IdSesRadky = 161;
UPDATE usesradky SET nazeva = 'Extraordinary charges' WHERE IdSesRadky = 162;
UPDATE usesradky SET nazeva = '-current' WHERE IdSesRadky = 163;
UPDATE usesradky SET nazeva = '-deferred' WHERE IdSesRadky = 164;
UPDATE usesradky SET nazeva = 'Share of profit (loss) transferred to partners (+/-)' WHERE IdSesRadky = 165;
UPDATE usesradky SET nazeva = 'Gross profit' WHERE IdSesRadky = 166;
UPDATE usesradky SET nazeva = 'Sales of production' WHERE IdSesRadky = 167;
UPDATE usesradky SET nazeva = 'Cost of sale' WHERE IdSesRadky = 168;
UPDATE usesradky SET nazeva = 'Added value' WHERE IdSesRadky = 169;
UPDATE usesradky SET nazeva = 'Staff costs' WHERE IdSesRadky = 170;
UPDATE usesradky SET nazeva = 'Sale of long-term assets and material' WHERE IdSesRadky = 171;
UPDATE usesradky SET nazeva = 'Net book value of long-term assets and material sold' WHERE IdSesRadky = 172;
UPDATE usesradky SET nazeva = 'Operating result' WHERE IdSesRadky = 173;
UPDATE usesradky SET nazeva = 'Income from long-term investments' WHERE IdSesRadky = 174;
UPDATE usesradky SET nazeva = 'Income from other long-term investments' WHERE IdSesRadky = 175;
UPDATE usesradky SET nazeva = 'Income from other equity investments' WHERE IdSesRadky = 176;
UPDATE usesradky SET nazeva = 'Financial result' WHERE IdSesRadky = 177;
UPDATE usesradky SET nazeva = 'Tax on income from ordinary activities' WHERE IdSesRadky = 178;
UPDATE usesradky SET nazeva = 'Profit (loss) on ordinary activities' WHERE IdSesRadky = 179;
UPDATE usesradky SET nazeva = 'Income tax on extraordinary activities' WHERE IdSesRadky = 180;
UPDATE usesradky SET nazeva = 'Extraordinary profit (loss)' WHERE IdSesRadky = 181;
UPDATE usesradky SET nazeva = 'Profit (loss) for the financial period (+/-)' WHERE IdSesRadky = 182;
UPDATE usesradky SET oznaceni = '  ****', nazeva = 'Profit (loss) before taxation' WHERE IdSesRadky = 183;
UPDATE usesradky SET nazeva = 'Control summary' WHERE IdSesRadky = 184;
UPDATE usesradky SET nazeva = 'Company changes differences' WHERE IdSesRadky = 185;

-- konec ceskeho bloku
  end if;
  
  if (_idtyporgread = 2) then
-- zacatek bloku ceskych prispevkovek

INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (10318, '2010-08-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 10054, (select IdStdUcet from uStdUcty where uuid = 'CZ_ROZ_395'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (10319, '2010-08-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 10054, (select IdStdUcet from uStdUcty where uuid = 'CZ_ROZ_396'));


-- konec ceskeho bloku
  end if;

  if (_idtyporgread = 3) then
-- zacatek bloku slovenskych podnikatelu

-- zmena standartni ucetni osnovy
UPDATE ustducty SET druhuctuk = 'druhUctu.pasivni' WHERE uuid = 'SK_POD_230';
UPDATE ustducty SET druhuctuk = 'druhUctu.pasivni' WHERE uuid = 'SK_POD_249';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_252';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_255';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktivni' WHERE uuid = 'SK_POD_256';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktivni' WHERE uuid = 'SK_POD_257';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_330';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_331';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_333';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_340';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_346';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_347';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_353';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_370';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_480';
UPDATE ustducty SET druhuctuk = 'druhUctu.aktpasvy' WHERE uuid = 'SK_POD_481';

-- zmena ovlivnenych uctu
UPDATE uucty SET druhuctuk = 'druhUctu.pasivni' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_230');
UPDATE uucty SET druhuctuk = 'druhUctu.pasivni' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_249');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_252');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_255');
UPDATE uucty SET druhuctuk = 'druhUctu.aktivni' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_256');
UPDATE uucty SET druhuctuk = 'druhUctu.aktivni' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_257');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_330');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_331');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_333');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_340');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_346');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_347');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_353');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_370');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_480');
UPDATE uucty SET druhuctuk = 'druhUctu.aktpasvy' WHERE idstducet = (select idstducet from ustducty where uuid = 'SK_POD_481');

-- uprava standardnich predpisu sestavy
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1217;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1229;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1236;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1238;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1239;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1240;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1242;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1249;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1288;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1299;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1303;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1343;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1354;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1356;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1372;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1378;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1379;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1380;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1381;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1382;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1383;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1385;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1390;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1402;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1405;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1609;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1610;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1624;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1648;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1652;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1653;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1657;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1661;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1662;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1663;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1664;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1665;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1666;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1673;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1733;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1736;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1737;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1738;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1739;
UPDATE usesstdpred SET jenkladne = true WHERE IdSesStdPred = 1745;
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (1746, '2010-08-04 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, true, 301, (select IdStdUcet from uStdUcty where uuid = 'SK_POD_380'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (1747, '2010-08-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 226, (select IdStdUcet from uStdUcty where uuid = 'SK_POD_395'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (1748, '2010-08-04 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 267, (select IdStdUcet from uStdUcty where uuid = 'SK_POD_430'));
INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (1749, '2010-08-04 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 267, (select IdStdUcet from uStdUcty where uuid = 'SK_POD_431'));
DELETE FROM usesstdpred WHERE IdSesStdPred = 1224;
DELETE FROM usesstdpred WHERE IdSesStdPred = 1674;

-- konec slovenskeho bloku
  end if;

end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 354, 't');
