--------------------------------------------------------------------------------
-- Bug 20626 – [WinStrom] Použitelnost hromadné objednávky pro objednání pouze u jedné firmy
--------------------------------------------------------------------------------

-- oprava triggeru pri smazani dodavatele
CREATE OR REPLACE FUNCTION cdodavateledeletedodavatel()
  RETURNS trigger AS $$
begin
  if (getglotxvariable('dodavatelDisableTrigger') is not null) then
    return OLD;
  end if;
  perform putglotxvariable('dodavatelDisableTrigger', '1');
  
  if OLD.primarni = true then       -- pokud je primarni nastavime na cenik prazdny
    update ccenik set iddodavatel = null where idcenik = OLD.idcenik;
  end if;
  
  perform removeglotxvariable('dodavatelDisableTrigger');
  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.cdodavateledeletedodavatel() OWNER TO %firmaRole%;

DROP TRIGGER cdodavateledeletedodavatel ON cdodavatele;

CREATE TRIGGER cdodavateledeletedodavatel AFTER DELETE ON cdodavatele
  FOR EACH ROW EXECUTE PROCEDURE cdodavateledeletedodavatel();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 371, 't');
