--------------------------------------------------------------------------------
-- Bug 21198 – [WinStrom] Do nastavení organizací jako je FÚ, OSSZ, 
-- ZP doplnit splatnost na konkrétní den v měsíci
--------------------------------------------------------------------------------

ALTER TABLE nnastav ADD COLUMN mzdsplatdanzal integer;
ALTER TABLE nnastav ADD COLUMN mzdsplatdansra integer;
ALTER TABLE nnastav ADD COLUMN mzdsplatdanrez integer;
ALTER TABLE nnastav ADD COLUMN mzdsplatdobirka integer;
ALTER TABLE nnastav ADD COLUMN mzdsplatsocpoj integer;
ALTER TABLE nnastav ADD COLUMN mzdsplatzdravpoj integer;

ALTER TABLE psrazka ADD COLUMN splatnost integer;

--------------------------------------------------------------------------------
-- Bug 21251 – [WinStrom] umožnit v nastavení vybrat např. u FÚ správnou daň
--------------------------------------------------------------------------------

-- pridani sloupcu
ALTER TABLE nnastav ADD COLUMN idmzdadrdan integer;
ALTER TABLE nnastav ADD COLUMN idmzdbandanzal integer;
ALTER TABLE nnastav ADD COLUMN idmzdbandansra integer;
ALTER TABLE nnastav ADD COLUMN idmzdbandanrez integer;

ALTER TABLE nnastav ADD CONSTRAINT nnastav_idmzdadrdan FOREIGN KEY (idmzdadrdan)
  REFERENCES aadresar (idfirmy) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT nnastav_idmzdbandanzal FOREIGN KEY (idmzdbandanzal)
  REFERENCES abanspoj (idbanspoj) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT nnastav_idmzdbandansra FOREIGN KEY (idmzdbandansra)
  REFERENCES abanspoj (idbanspoj) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT nnastav_idmzdbandanrez FOREIGN KEY (idmzdbandanrez)
  REFERENCES abanspoj (idbanspoj) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX nNastav_IdMzdAdrDan_index ON nNastav USING btree (IdMzdAdrDan);
CREATE INDEX nNastav_IdMzdBanDanZal_index ON nNastav USING btree (IdMzdBanDanZal);
CREATE INDEX nNastav_IdMzdBanDanSra_index ON nNastav USING btree (IdMzdBanDanSra);
CREATE INDEX nNastav_IdMzdBanDanRez_index ON nNastav USING btree (IdMzdBanDanRez);

-- uprava nastaveni
-- adresu vezmem od zalohove dane
update nnastav as N set idmzdadrdan = idmzdadrdanzal,
-- bankovni spojeni od vybranych adres pokud jsou
   idmzdbandanzal = (select idbanspoj from abanspoj where idfirmy = coalesce(N.idmzdadrdanzal, -1) order by primarni desc limit 1),
   idmzdbandansra = (select idbanspoj from abanspoj where idfirmy = coalesce(N.idmzdadrdansra, -1) order by primarni desc limit 1),
   idmzdbandanrez = (select idbanspoj from abanspoj where idfirmy = coalesce(N.idmzdadrdanrez, -1) order by primarni desc limit 1);

-- vybrane bankovni spojeni prevazeme na firmu
update abanspoj as B set idfirmy = 
    coalesce((select idmzdadrdan from nnastav where idmzdbandansra = B.idbanspoj 
      or idmzdbandanrez = B.idbanspoj limit 1), idfirmy) 
  where idbanspoj in (select idmzdbandansra from nnastav union
                      select idmzdbandanrez from nnastav);

-- odebrani sloupcu
ALTER TABLE nnastav DROP COLUMN idmzdadrdanzal;
ALTER TABLE nnastav DROP COLUMN idmzdadrdansra;
ALTER TABLE nnastav DROP COLUMN idmzdadrdanrez;

--------------------------------------------------------------------------------
-- Bug 21247 – [WinStrom] Upravit účtování, aby se nechalo účtovat i ZP a SP odlišně pro společníky
--------------------------------------------------------------------------------

ALTER TABLE pskuposob ADD COLUMN idtuozavsoczam integer;
ALTER TABLE pskuposob ADD COLUMN idtuozavzdrfir integer;
ALTER TABLE pskuposob ADD COLUMN idtuozavzdrzam integer;
ALTER TABLE pskuposob ADD COLUMN idtuozavsocfir integer;

ALTER TABLE pskuposob ADD CONSTRAINT pskuposob_idtuozavsoczam FOREIGN KEY (idtuozavsoczam)
  REFERENCES utypucop (idtypucop) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE pskuposob ADD CONSTRAINT pskuposob_idtuozavsocfir FOREIGN KEY (idtuozavsocfir)
  REFERENCES utypucop (idtypucop) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE pskuposob ADD CONSTRAINT pskuposob_idtuozavzdrzam FOREIGN KEY (idtuozavzdrzam)
  REFERENCES utypucop (idtypucop) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE pskuposob ADD CONSTRAINT pskuposob_idtuozavzdrfir FOREIGN KEY (idtuozavzdrfir)
  REFERENCES utypucop (idtypucop) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX pSkupOsob_IdTuoZavSocZam_index ON pSkupOsob USING btree (IdTuoZavSocZam);
CREATE INDEX pSkupOsob_IdTuoZavSocFir_index ON pSkupOsob USING btree (IdTuoZavSocFir);
CREATE INDEX pSkupOsob_IdTuoZavZdrZam_index ON pSkupOsob USING btree (IdTuoZavZdrZam);
CREATE INDEX pSkupOsob_IdTuoZavZdrFir_index ON pSkupOsob USING btree (IdTuoZavZdrFir);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 417, 't', %appVersion%, clock_timestamp());
