--------------------------------------------------------------------------------
-- Bug 21714 – [WinStrom] Výdejka - při vydání výrobku ze skladu výrobků se aut.nastavuje stav dokladu Výroba
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION errorininsertkusovnik(_iddoklsklad integer, _datvyst date, _idcenik integer, _idskladu integer, _prevodka boolean)
  RETURNS character varying AS
$BODY$
declare
  _typPohybuK character varying;
  _typPohybuSkladK character varying;
  _typZasobyK character varying;
  _idKusovnik integer;
  potKus record;
  _cenik record;
  _sklKarta record;
  _iducetobdobi integer;
  _idSkladPotKus integer;
begin
  -- napriklad pokud se jedna o prevodku mezi sklady nebudeme z prijemky vytvaret prevodku
  if (_prevodka = true) then
    return null;
  end if;

  -- typem pohybu musi byt prijem a to prijem vyrobku
  select typpohybuk, typpohybuskladk into _typPohybuK, _typPohybuSkladK from ddoklsklad d where d.iddoklsklad = _iddoklsklad;
  if (_typPohybuK <> 'typPohybu.prijem' and _typPohybuSkladK <> 'typPohybuSklad.prijemVyrob') then
    return null;
  end if;

  -- idcenik odkazuje na neco co je soucasti kusovniku.
  select ckus.idkusovnik into _idKusovnik from ckusovnik ckus where ckus.idcenik = _idcenik
    and exists (select 1 from ckusovnik cPot where cPot.idotec = ckus.idkusovnik);
  if (_idKusovnik is null) then
    return null;
  end if;

  -- pro vsechny kusovniky, ktere jsou pod nasim kusovnikem a jsou skladove nebo vyroba
  for potKus in (select * from ckusovnik cPot where cPot.idotec = _idKusovnik) loop
    select * into _cenik from cCenik where idCenik = potKus.idCenik;

    if (not _cenik.skladove) then
        continue;
    end if;

    select findIdUcetniObdobiKDatu(_datvyst) into _iducetobdobi;
    -- vybereme skladovou kartu podle preferovaneho skladu
    select null into _sklKarta;
    _idSkladPotKus = null;

    select getPrefIdSkladu(
	(select idstred from ddoklsklad where iddoklsklad = _iddoklsklad),
	_cenik.idskupzboz, potKus.idcenik) into _idSkladPotKus;

    if (_idSkladPotKus is not null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idSkladPotKus and iducetobdobi = _iducetobdobi;
    end if;

    -- sklad karta nebyla nalezena podle preferovaneho skladu, vezmeme sklad stejny jako z vytvarene polozky
    if (_sklKarta is null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idskladu and iducetobdobi = _iducetobdobi;
    end if;

    -- skladovou kartu k tomuhle ceniku nelze nalezt
    if (_sklKarta is null) then
	return _cenik.kod;
    end if;
  end loop;

  return null;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION errorininsertkusovnik(integer, date, integer, integer, boolean) OWNER TO %firmaRole%;

--------------------------------------------------------------------------------
-- Bug 21344 – [WinStrom] Doplnění sloupečků 3
--------------------------------------------------------------------------------

alter table codberatele
	drop constraint codberatele_unique_key;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 429, 't', %appVersion%, clock_timestamp());