--------------------------------------------------------------------------------
-- Bug 22659 – [WinStrom] Přenos účtů mezi doklady
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpolskladupdateucty() RETURNS trigger AS $$
declare
  nelzeZmena int;
  _modul character varying;
begin
  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then
    -- z prijemky se pres vazbu polozkaSklPrevod ma prenaset ucet zklDal na vydejku zklMd
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and 
          idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and 
            idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  else
    -- z vydejky se ma pres vazbu polozkaSklPrevod ma prenaset ucet zklMd na ucet zklDal
    if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and NEW.kopZklMdUcet = false) then
      select modulB into _modul from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and 
          idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and 
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  end if;

  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then 
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl';
      if(_modul like 'POK') then
        select count(*) into nelzeZmena from dPolInt where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
          idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        
        if (nelzeZmena = 0) then
          update dPolInt set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
            idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        else
          raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
        end if;
      else
        if _modul = 'FAP' then
          select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
          
          if (nelzeZmena = 0) then
            update dPolFak set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
              idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
          else
            raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
          end if;
        end if;
      end if;

    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolskladupdateucty() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 442, 't', %appVersion%, clock_timestamp());
