--------------------------------------------------------------------------------
-- Bug 22758 – [WinStrom] Problém s kurzovým rozdílem u Jelínka
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION ddoklintupdateucty() RETURNS trigger
    AS $$
declare idPoloz int;
        idDokl int;
        kopirovat boolean;
        ucPrij int;
        ucVyd int;
begin
  --pokud dojde ke zmene protiuctu
  if (compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then

    -- uprava faktur vazbami uhrada a vazbaZDD, pouze pokud ucet nesouhlasi aby nedochazelo k zacykleni
    for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idProtiUcet) = false and idDoklFak in
        (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhrada','typVazbyDokl.vazbaZDD')))
    loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idProtiUcet);
    end loop;

    -- odpocet zalohy - polozka dokladu
    for idPoloz in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabB in
            (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK = 'typVazbyDokl.uhradaZALOHY')) loop
      if (NEW.typPohybuK = 'typPohybu.prijem') then
        update dPolFak set idZklDalUcet = NEW.idProtiUcet where idPolFak = idPoloz and compareId(idZklDalUcet, NEW.idProtiUcet) = false and compareId(idZklDalUcet, OLD.idProtiUcet) = true;
      else
        update dPolFak set idZklMdUcet  = NEW.idProtiUcet where idPolFak = idPoloz and compareId(idZklMdUcet,  NEW.idProtiUcet) = false and compareId(idZklMdUcet,  OLD.idProtiUcet) = true;
      end if;
    end loop;

    -- uhradaKR, preceneni
    kopirovat = false;
    if not compareId(OLD.idPrimUcet, OLD.idProtiUcet) then                    -- ucty na internim dokladu nebyli stejne
      kopirovat = true;
    else
      select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = NEW.iddoklint;
      if (ucPrij is null and ucVyd is not null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
        kopirovat = true;
      end if;
    end if;
    
    if kopirovat then
      for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idProtiUcet) = false and compareId(idPrimUcet, OLD.idProtiUcet) = true and idDoklFak in
          (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
      loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idProtiUcet);
      end loop;
    end if;
  end if;

  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false) then
    -- uhradaKR, preceneni
    kopirovat = false;
    if not compareId(OLD.idPrimUcet, OLD.idProtiUcet) then                    -- ucty na internim dokladu nebyli stejne
      kopirovat = true;
    else
      select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = NEW.iddoklint;
      if (ucPrij is not null and ucVyd is null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
        kopirovat = true;
      end if;
    end if;
    
    if kopirovat then
      for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idPrimUcet) = false and compareId(idPrimUcet, OLD.idPrimUcet) = true and idDoklFak in
          (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
      loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idPrimUcet);
      end loop;
    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklintupdateucty() OWNER TO %firmaRole%;



CREATE OR REPLACE FUNCTION ddoklfakupdateucty() RETURNS trigger AS $$  
declare nelzeZmena int;  
        idDokl int;  
        dokl record;
        ucPrij int;
        ucVyd int;
begin  
  nelzeZmena := 0;  
    
  --pokud dojde ke zmene primarniho uctu  
  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false) then  
    -- uprava banka/pokladna vazbami uhrada a vazbaZDD, pouze pokud ucet nesouhlasi aby nedochazelo k zacykleni  
    for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhrada','typVazbyDokl.vazbaZDD')))  
    loop  
        execute dNastavUcetDokladu(1, idDokl, 1, NEW.idPrimUcet);  
    end loop;  
  
    -- uhradaKR, preceneni - u kurzoveho rozdilu a preceneni nevim na ktere strane je hledany ucet, testuji oba  
    for dokl in (select * from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and compareId(idProtiUcet, OLD.idPrimUcet) = true and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))  
    loop  
      if (not compareid(dokl.idProtiUcet, dokl.idPrimUcet)) then
        execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
      else
        select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = dokl.iddoklint;
        if (ucPrij is null and ucVyd is not null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
          execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
        end if;
      end if;
    end loop;  
  
    for dokl in (select * from dDoklInt where compareId(idPrimUcet,  NEW.idPrimUcet) = false and compareId(idPrimUcet,  OLD.idPrimUcet) = true and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))  
    loop  
      if (not compareid(dokl.idProtiUcet, dokl.idPrimUcet)) then
        execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
      else
        select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = dokl.iddoklint;
        if (ucPrij is not null and ucVyd is null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
          execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
        end if;
      end if;
    end loop;  
  end if;  
  
  --pokud dojde ke zmene protiuctu (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idZklDalUcet, NEW.idProtiUcet) = false and kopZklDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idZklDalUcet = NEW.idProtiUcet where compareId(idZklDalUcet, NEW.idProtiUcet) = false and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idProtiUcet) = false and kopZklMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idZklMdUcet = NEW.idProtiUcet where compareId(idZklMdUcet, NEW.idProtiUcet) = false and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
  
      -- vazba na sklad  
      for idDokl in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = NEW.idDoklFak and   
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)  
      loop  
        execute dNastavUcetDokladu(2, idDokl, 1, NEW.idProtiUcet);  
      end loop;  
    end if;  
  end if;  
  
  --pokud dojde ke zmene protiuctu zakladni sazby dph (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idDphZaklUcet, OLD.idDphZaklUcet) = false and nelzeZmena = 0) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idDphDalUcet = NEW.idDphZaklUcet where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idDphMdUcet = NEW.idDphZaklUcet where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  end if;  
  
  --pokud dojde ke zmene protiuctu snizene sazby dph (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idDphSnizUcet, OLD.idDphSnizUcet) = false and nelzeZmena = 0) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idDphDalUcet = NEW.idDphSnizUcet where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idDphMdUcet = NEW.idDphSnizUcet where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  end if;  
  
  if (nelzeZmena > 0) then  
    raise exception '0008:dDoklFakUpdateUcty(): Nelze zmenit ucet u navazane polozky.';  
  end if;  
  
  return NEW;  
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklfakupdateucty() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 470, 't', %appVersion%, clock_timestamp());
