--------------------------------------------------------------------------------
-- Bug 21375 – [WinStrom] Upravit vypocet stavu skladu na polozce faktury
--------------------------------------------------------------------------------

-- Function: dgetstavnasklade(integer, date, integer, character varying, date)
-- DROP FUNCTION dgetstavnasklade(integer, date, integer, character varying, date);
CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_sarze character varying, i_expirace date)
  RETURNS numeric AS
$BODY$      
declare     
  _pocMj numeric(19,6);     
  _obratMj numeric(19,6);     
  _stavMj numeric(19,6);     
  _idcenik integer;   
  _idskladu integer;   
  _typPohybuK character varying(50);   
  _sadaItemCount integer; 
  _polozkaSady record; 
  _idSkladKarty integer; 
  _iducetniobdobi integer; 
  _idPolSklad integer; 
  _stavSkladuSady numeric(19,6); 
  _mnozMj numeric(19,6); 
  _stavMjKarty numeric(19,6);
begin     
  SELECT pocatMj INTO _pocMj     
  FROM sKarty     
  WHERE idKarty = i_skladkartaid;     
     
  if (i_datum is null) then     
    raise exception '0005:dGetStavNaSklade : Vstupni parametr datum je null.';      
  end if;   
   
  _typPohybuK := null;   
  if (i_polskladid >= 0) then   
    select typPohybuK into _typPohybuK from ddoklsklad    
      where iddoklsklad = (select iddoklsklad from dpolsklad where idpolsklad = i_polskladid);   
  end if;   
   
  select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid; 
 
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet 
  select count(*) into _sadaItemCount from csady where idceniksada = _idCenik; 
  -- pokud se nejedna o sadu tak funguju normalne 
  if(_sadaItemCount = 0) then 
    if ((i_sarze is null or i_sarze = '') and i_expirace is null) then
      -- zkusime zjistit stav skladu k datu    
      if (i_polSkladId < 0) then       
        SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj       
        FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad       
        WHERE idkarty = i_skladkartaid AND ps.storno <> true AND ps.datUcto <= i_datum;       
      else       
        SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj       
        FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad       
        WHERE idkarty = i_skladkartaid AND ps.storno <> true AND (ps.datUcto < i_datum OR (ps.datUcto = i_datum AND ps.idPolSklad < i_polskladid));       
      end if;    
      if(_obratMj is null) then _obratMj = 0.0; end if;       
      if(_pocMj is null) then _pocMj = 0.0; end if;        
      _stavMj = _pocMj + _obratMj; 
      -- zkusime vypocitat stav na vrcholu
      select stavMj into _stavMjKarty from skarty where idkarty = i_skladkartaid;
      _mnozMj = 0.0;
      if(i_polSkladId >= 0) then
        select mnozMj into _mnozMj from dPolSklad where idPolSklad = i_polSkladId; 
        if(_typPohybuK = 'typPohybu.vydej') then
          _stavMjKarty = _stavMjKarty + _mnozMj;
        else
          _stavMjKarty = _stavMjKarty - _mnozMj;
        end if;
      end if;

      -- spravna hodnota dle bugu 21375 minimum z obou hodnot
      if(_typPohybuK = 'typPohybu.vydej') then
        select minValue(_stavMj, _stavMjKarty) into _stavMj;  
      end if;
    else    
      if ((i_sarze is not null and i_sarze <> '') and (i_expirace is null)) then    
        --raise exception 'idCenik = % and idSkladu = %', _idCenik, _idSkladu;   
       
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze;    
      elsif ((i_sarze is null or i_sarze = '') and (i_expirace is not null)) then    
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and expirace = i_expirace;    
      else    
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze and expirace = i_expirace;    
      end if;    
      if (_typPohybuK is not null and _typPohybuK = 'typPohybu.prijem') then    
        select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid;    
        if(_stavMj is null) then    
          _stavMj := -_obratMj;    
        else    
          _stavMj := _stavMj - _obratMj;    
        end if;    
      elsif (_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej') then    
        select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid;    
        if(_stavMj is null) then    
          _stavMj := _obratMj;    
        else    
          _stavMj := _stavMj + _obratMj;    
        end if;    
      end if;    
    end if;   
  else 
    for _polozkaSady in 
      select * from cSady where idCenikSada = _idCenik 
    loop 
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = _idskladu and idUcetObdobi = _iducetniobdobi; 
      if(_idSkladKarty is not null) then  
        if(_stavMj is null) then 
          _stavMj = 9999999999999.0; -- vic uz pretejka 
        end if; 
        _idPolSklad = -1; 
        --TODO nejak doresit _idPolSklad, sarze a expirace; 
        select dgetstavnasklade(_idSkladKarty, i_datum, -1, i_sarze, i_expirace) into _stavSkladuSady; 
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj; 
	if(i_polskladid > 0) then 
	  select mnozMj into _mnozMj from dPolSklad where idPolSklad = i_polSkladId; 
          _stavSkladuSady = _stavSkladuSady + (_mnozMj/_polozkaSady.mnozMj); 
        end if; 
        select minValue(_stavMj, _stavSkladuSady) into _stavMj; 
      end if; 
    end loop; 
  end if;  
  
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni  
  if(_stavMj is null) then  
    _stavMj := 0;  
  end if;  
    
  RETURN _stavMj;      
end      
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, character varying, date) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 472, 't', %appVersion%, clock_timestamp());
