--------------------------------------------------------------------------------
-- bug none - prepocet skladu prepocitava i nasledujici obdobi
--------------------------------------------------------------------------------

-- Function: skladgenerujrozsirenepolozky(date, integer, integer)
-- DROP FUNCTION skladgenerujrozsirenepolozky(date, integer, integer);
CREATE OR REPLACE FUNCTION skladgenerujrozsirenepolozky(i_datum date, i_idpolsklad integer, i_idskladkarty integer)
  RETURNS boolean AS
$BODY$ 
declare 
  tmp_skladovekarty_exists boolean; 
  tmp_rozsirenepolozky_exists boolean; 
  _polSklad record; 
  _skladKarta record; 
  _pocetSkladKarty integer; 
  _result boolean; 
  _idUcetObd integer; 
begin 
  -- pokud se zde nebyli tabulky vytvoreny tak se vrati false a pokud ano tak se true 
  _result = false; 
 
  -- vytvoreni temporary tabulky pro ulozeni seznamu skladovych karet na kterych dochazi k prepoctu 
  tmp_skladovekarty_exists := (select istableexist('tmp_SkladoveKarty')); 
  if(tmp_skladovekarty_exists <> true) then 
    --raise exception 'tmp_skladoveKarty se vytvari'; 
    CREATE TEMPORARY TABLE tmp_SkladoveKarty ( 
      idskladkarty integer 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 
  end if; 
 
  -- vytvoreni temporary tabulky pro ulozeni seznamu polozek, ktere budou prepocitavat skladove karty 
  tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
  if(tmp_rozsirenepolozky_exists <> true) then 
    CREATE TEMPORARY TABLE tmp_RozsirenePolozky ( 
      idpolsklad integer, 
      iddoklskladMaster integer, 
      iddoklskladpolozky integer, 
      datum date, 
      skupina integer, 
      typPohybuK character varying, 
      idskladkarty integer, 
      storno boolean 
      --mnozMj numeric(19,6), 
      --cenaMj numeric(19,6), 
      --sumZkl numeric(19,6) 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 
 
    -- tabulky zde byli vytvoreny tim padem se musi vracet true 
    _result = true; 
  end if; 
   
  if(i_idSkladKarty is not null and i_idSkladKarty <> -1) then 
    -- pokud se jedna o prepocet po vlozeni jedna polozky nebo o rekurzi tak se vse dela jen s jednou skladovou kartou 
    select count(*) into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = i_idSkladKarty; 
    if(_pocetSkladKarty = 0) then 
      insert into tmp_SkladoveKarty (idskladkarty) values (i_idSkladKarty); 
      for _polSklad in (select * from dpolsklad where datVyst >= i_datum and idkarty = i_idSkladKarty) loop 
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
      end loop; 
    else 
      -- do something stupid - kdyz je skladkarta v seznamu 
    end if; 
  else 
    -- pokud se jedna o celkovy prepocet skladu tak do tmp tabulky skladovych karet dam vsechny pro dane obdobi 
    select iducetobdobi into _idUcetObd from nucetobdobi where platioddata <= i_datum and platidodata >= i_datum; 
    for _skladKarta in (select * from skarty where iducetobdobi = _idUcetObd) loop 
      insert into tmp_SkladoveKarty(idskladkarty) values (_skladKarta.idKarty); 
      --for _polSklad in (select * from dpolsklad where datVyst >= i_datum and idkarty = _skladKarta.idKarty) loop 
      -- tento for cyklus je spatne protoze pokud jsou spatna data (dat vyst je 2010 a karta 2011) tak k prepoctu nedojde
      for _polSklad in (select * from dpolsklad where idkarty = _skladKarta.idKarty) loop 
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
      end loop; 
    end loop; 
  end if; 
 
  return _result; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladgenerujrozsirenepolozky(date, integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 473, 't', %appVersion%, clock_timestamp());
