--------------------------------------------------------------------------------
-- Bug 23815 – [WinStrom] DE - chybný přenos platby z kasy do výkazu daňové evidence
--------------------------------------------------------------------------------

-- Uložená procedura aktualizující tabulku daňové evidence pro interní doklad se zadaným id
create or replace function uUpdateDanEvid (in _idDoklInt integer) returns void as $$
declare
  doklInt record;
  tempRec record;
  podvoj boolean;
  navazaneDotaz varchar;
  vazeb integer;
  _danEvidK character varying(50);
  _idTypUcOp integer;
  _idStred integer;
  _idZakazky integer;
  nespadaDph character varying(50);
  _idDanEvid integer;
  _idDoklFak integer;
  castka numeric(15,2);
  castkaMen numeric(15,2);
  castkaZbyva numeric(15,2);
  castkaZbyvaMen numeric(15,2);
  castkaOdpocet numeric(15,2);
  castkaOdpocetMen numeric(15,2);
  zapocteno numeric(15,2);
  zapoctenoMen numeric(15,2);
  domaciMena integer;
  ciziMena boolean;
  menpost varchar;
begin
  nespadaDph := 'danEvid.NeDanEvid';

  select * into doklInt from ddoklint where iddoklint = _idDoklInt;
  select podvojucto, idmeny into podvoj, domaciMena from nnastav where (platioddata is null or platioddata <= doklInt.datUcto) 
    order by coalesce(platioddata, '0001-01-01') desc limit 1;
  
  ciziMena := (doklInt.idMeny is not null and domaciMena <> doklInt.idMeny);
  
  if (doklInt.modul not in ('BAN', 'POK')) then
    return;
  end if;
  
  menpost = '';
  if cizimena then
    menpost = 'men';
  end if;

  if (podvoj = false and doklInt.ucetni = true) then
    -- dotaz ktery nalezne veschny navazane faktury a navazane castky
    navazaneDotaz := '(select V.idDoklFak, sum(V.castka) as castka from
         (select idTabA as idDoklFak, castka from dvazebtab where typvazbyk in (''typVazbyDokl.uhrada'', ''typVazbyDokl.vazbaZDD'', ''typVazbyDokl.zaucProdejky'') and idtabb = ' || doklInt.idDoklInt || '
          union
          select idTabA as idDoklFak, (castka +
            (select coalesce(sum(P.sumzkl' || menpost || ' + P.sumdph' || menpost || '), 0) from dpolfak as P inner join dVazebTab as V2 
                on P.idPolFak = V2.idtaba and V2.typVazbyK = ''typVazbyDokl.odpocetZALOHY'' where V2.idtabb = V.idtaba))
              as castka 
            from dvazebtab as V where typvazbyk = ''typVazbyDokl.uhradaZALOHY'' and idtabb = ' || doklInt.idDoklInt || '
              and (select count(*) from dvazebtab where typvazbyk = ''typVazbyDokl.vazbaZDD'' and idtabb = V.idtabb) = 0
          union
          select P.idDoklFak, coalesce(sum(-P.sumzkl' || menpost || ' - P.sumdph' || menpost || '), 0) as castka from dpolfak as P inner join dVazebTab as VOdp 
            on VOdp.idtaba = P.idpolfak and VOdp.typVazbyK = ''typVazbyDokl.odpocetZALOHY''
             inner join dVazebTab as VUhr on VUhr.idtaba = VOdp.idtabb and VUhr.typvazbyk = ''typVazbyDokl.uhradaZALOHY'' where VUhr.idtabb = ' || doklInt.idDoklInt || ' group by P.idDoklFak
          ) as V group by V.idDoklFak having sum(V.castka) <> 0)';
    
    execute 'select count(*) from ' || navazaneDotaz || ' as D' into vazeb;
  
    if (vazeb = 0) then			-- pro interni doklad neni vazba
      DELETE from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak is not null;           -- vymazeme ty co byli vytvorene pres vazbu
      UPDATE uDanEvid set sumZkl = 0, sumDph = 0, sumZklMen = 0, sumDphMen = 0 where idDoklInt = doklInt.idDoklInt;     -- vynulujeme ostatni
             
      -- DPH
      for _idStred, _idZakazky, castka, castkaMen in select idStred, idZakazky, sum(sumDph), sum(sumDphMen) 
                from dPolInt where idDoklInt = doklInt.idDoklInt and storno = false group by idStred, idZakazky loop
        select idDanEvid into _idDanEvid from uDanEvid where danEvidK = nespadaDph and idDoklInt = doklInt.idDoklInt
          and compareid(_idStred, idStred) and compareid(_idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
        
        if (_idDanEvid is null) then              -- zaznam jeste nebyl vytvoren
          INSERT into uDanEvid (danEvidK, sumDph, sumDphMen, kurz, kurzMnozstvi, idDoklInt, idMeny, idStred, idZakazky) 
            VALUES (nespadaDph, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny, _idStred, _idZakazky);
        else                                     -- zaznam jiz byl vytvoren, vynulujeme i zaklad pokud by jiz nebyl pouzit
          UPDATE uDanEvid SET sumDph = castka, sumDphMen = castkaMen, sumZkl = 0, sumZklMen = 0, kurz = doklInt.kurz, 
            kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny, idDoklFak = null WHERE idDanEvid = _idDanEvid;
        end if;
      end loop;
    
      -- Zaklad
      for _danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen in select danEvidK, idTypUcOp, idStred, idZakazky, sum(sumZkl), sum(sumZklMen) 
                from dPolInt where idDoklInt = doklInt.idDoklInt and storno = false group by danEvidK, idTypUcOp, idStred, idZakazky loop 
        select idDanEvid into _idDanEvid from uDanEvid where danEvidK = _danEvidK and idDoklInt = doklInt.idDoklInt
          and compareid(_idTypUcOp, idTypUcOp) and compareid(_idStred, idStred) and compareid(_idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
        
        if (_idDanEvid is null) then              -- zaznam jeste nebyl vytvoren
          INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
            VALUES (_danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
        else                                     -- zaznam jiz byl vytvoren
          UPDATE uDanEvid SET sumZkl = castka, sumZklMen = castkaMen, kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi,
            idMeny = doklInt.idMeny, idDoklFak = null WHERE idDanEvid = _idDanEvid;
        end if;
      end loop; 
    else				            -- pro interni doklad je vazba
      DELETE from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak is null;           -- smazeme polozky co nemaji vazbu na fakturu
      UPDATE uDanEvid set sumZkl = 0, sumDph = 0, sumZklMen = 0, sumDphMen = 0 where idDoklInt = doklInt.idDoklInt;     -- vynulujeme ostatni
      
      drop table if exists tempDanEvid;
      
      CREATE TEMPORARY TABLE tempDanEvid
        (idDoklFak integer NOT NULL,
         danEvidK character varying(50),
         idTypUcOp integer,
         idStred integer,
         idZakazky integer,
         dan boolean DEFAULT false,
         kUhrade numeric(15,2) DEFAULT 0.0 NOT NULL,
         kUhradeMen numeric(15,2) DEFAULT 0.0 NOT NULL,
         uhrazeno numeric(15,2) DEFAULT 0.0 NOT NULL,
         uhrazenoMen numeric(15,2) DEFAULT 0.0 NOT NULL,
         vazbaFak numeric(15,2) DEFAULT 0.0 NOT NULL
        );

      for tempRec in execute 'select * from ' || navazaneDotaz || ' as D' loop
        _idDoklFak = tempRec.idDoklFak;
        castka = tempRec.castka;
      
        select * into tempRec from dDoklFak where idDoklFak = _idDoklFak;
        if ((ciziMena = true and (tempRec.idMeny is null or tempRec.idMeny <> doklInt.idMeny)) 
         or (ciziMena = false and tempRec.idMeny is not null and tempRec.idMeny <> domaciMena)) then
          raise exception 'uUpdateDanEvid: Nesouhlasi meny dokladu';
        end if;
      
        -- zjistime kolik je treba na fakture uhradit a kolik je uhrazeno
        insert into tempDanEvid (idDoklFak, danEvidK, idTypUcOp, idStred, idZakazky, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) 
          select _idDoklFak, danEvidK, idTypUcOp, idStred, idZakazky, castka, sum(sumZkl), sum(sumZklMen), 
               (select coalesce(sum(sumZkl),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK and 
                 compareid(P.idTypUcOp, idTypUcOp) and compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky)),
               (select coalesce(sum(sumZklMen),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK and
                 compareid(P.idTypUcOp, idTypUcOp) and compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky))
           from dPolFak as P where idDoklFak = _idDoklFak and storno = false
             and typPolozkyK not in ('typPolozky.odpocetZalohy') group by danEvidK, idTypUcOp, idStred, idZakazky;
           
        -- dan
        insert into tempDanEvid (idDoklFak, danEvidK, dan, idStred, idZakazky, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) -- dan si oznacime jako null
          select _idDoklFak, null, true, idStred, idZakazky, castka, sum(sumDph), sum(sumDphMen),
               (select coalesce(sum(sumDph),0) from uDanEvid where idDoklFak = _idDoklFak and 
                 compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky)),                             -- uhrazena dan dokladu
               (select coalesce(sum(sumDphMen),0) from uDanEvid where idDoklFak = _idDoklFak and 
                 compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky))
           from dPolFak as P left outer join uclendph as C on P.idclendph = C.idclendph where idDoklFak = _idDoklFak and storno = false
             and ((C.typplnenik is null) or (C.typplnenik not in ('typPlneni.prijataRCH', 'typPlneni.uskutecnenaRCH', 'typPlneni.obojiRCH')))
             and typPolozkyK not in ('typPolozky.odpocetZalohy') group by idStred, idZakazky;
      end loop;
      
      zapocteno := 0;
      zapoctenoMen := 0;
      
      for _idDoklFak,castka in select idDoklFak,vazbaFak from tempDanEvid group by idDoklFak,vazbaFak loop           -- prochazime navazene faktury
        castkaMen := castka;

        for tempRec in select * from tempDanEvid where idDoklFak = _idDoklFak order by (case when (kUhrade-uhrazeno) < 0 then -1 else 1 end), -- napred zaporny 
                                                                                              dan desc, danEvidK desc loop    -- sestupne aby null (dan) bylo prvni
        
          if ((ciziMena = false and castka <> 0) or (ciziMena = true and castkaMen <> 0)) then                -- pokud jeste mame nejakou castku
            castkaZbyva := tempRec.kUhrade - tempRec.uhrazeno;
            castkaZbyvaMen := tempRec.kUhradeMen - tempRec.uhrazenoMen;
            
            if ((ciziMena = false and castkaZbyva <> 0) or (ciziMena = true and castkaZbyvaMen <> 0)) then    -- pokud na aktualnim zaznamu zbyva neco uhradit
              if ((ciziMena = false and castka > 0 and castkaZbyva > 0) or (ciziMena = true and castkaMen > 0 and castkaZbyvaMen > 0)) then
                castkaOdpocet := minValue(castka, castkaZbyva);      -- spocteme kolik budeme "odpocitavat"
                castkaOdpocetMen := minValue(castkaMen, castkaZbyvaMen);
              else
                if ((ciziMena = false and castka < 0 and castkaZbyva < 0) or (ciziMena = true and castkaMen < 0 and castkaZbyvaMen < 0)) then
                  castkaOdpocet := maxValue(castka, castkaZbyva);
                  castkaOdpocetMen := maxValue(castkaMen, castkaZbyvaMen);
                else
                  castkaOdpocet := castkaZbyva;
                  castkaOdpocetMen := castkaZbyvaMen;
                end if;
              end if;
              
              castka := castka - castkaOdpocet;                    -- odebereme to z odpocitatelne castky
              castkaMen := castkaMen - castkaOdpocetMen;
              zapocteno := zapocteno + castkaOdpocet;
              zapoctenoMen := zapoctenoMen + castkaOdpocetMen;
              
              if (ciziMena = true) then
                castkaOdpocet := castkaOdpocetMen * doklInt.kurz / doklInt.kurzmnozstvi;
              else
                castkaOdpocetMen := 0;
              end if;
              
              if (tempRec.dan) then        -- pokud se jedna o dan
                select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak and danEvidK = nespadaDph
                  and compareid(tempRec.idStred, idStred) and compareid(tempRec.idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
                
                if (_idDanEvid is null) then            -- zaznam jeste nebyl vytvoren
                  INSERT into uDanEvid (danEvidK, idStred, idZakazky, sumDph, sumDphMen, kurz, kurzMnozstvi, idDoklInt, idDoklFak, idMeny) 
                    VALUES (nespadaDph, tempRec.idStred, tempRec.idZakazky, castkaOdpocet, castkaOdpocetMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, tempRec.idDoklFak, doklInt.idMeny);
                else                                    -- zaznam jiz byl vytvoren
                  UPDATE uDanEvid SET sumDph = castkaOdpocet, sumDphMen = castkaOdpocetMen, 
                    kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny WHERE idDanEvid = _idDanEvid;
                end if;
              else                                      -- pokud se nejedna o dan
                select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak 
                  and ((tempRec.danEvidK is null and danEvidK is null) or (danEvidK = tempRec.danEvidK))
                  and compareid(tempRec.idTypUcOp, idTypUcOp) and compareid(tempRec.idStred, idStred) and compareid(tempRec.idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
                
                if (_idDanEvid is null) then            -- zaznam jeste nebyl vytvoren
                  INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idDoklFak, idMeny) 
                    VALUES (tempRec.danEvidK, tempRec.idTypUcOp, tempRec.idStred, tempRec.idZakazky, castkaOdpocet, castkaOdpocetMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, tempRec.idDoklFak, doklInt.idMeny);
                else                                    -- zaznam jiz byl vytvoren
                  UPDATE uDanEvid SET sumZkl = castkaOdpocet, sumZklMen = castkaOdpocetMen, 
                    kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny WHERE idDanEvid = _idDanEvid;
                end if;
              end if;
            
              --select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak and
              --   ((tempRec.danEvidK is not null and danEvidK = tempRec.danEvidK) or (tempRec.danEvidK is null and danEvidK = nespadaDph));  -- zjistime zda uz zaznam existuje
            end if;
          end if;
        
        end loop;
        
        if ((ciziMena = false and castka <> 0) or (ciziMena = true and castkaMen <> 0)) then
          if (ciziMena = true) then
            castka := castkaMen * doklInt.kurz / doklInt.kurzmnozstvi;
          else
            castkaMen := 0;
          end if;
        
          -- vybereme typ pro ktery je nejvetsi castka, pokud takovy neni nechame castku viset, protoze se jedna o celou castku
          select danEvidK, idTypUcOp, idStred, idZakazky into _danEvidK, _idTypUcOp, _idStred, _idZakazky from uDanEvid 
            where idDoklFak = _idDoklFak order by sumZkl desc limit 1;
          if _danEvidK is not null then
            INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
              VALUES (_danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
            zapocteno = zapocteno + castka;
            zapoctenoMen = zapoctenoMen + castkaMen;
          end if;
        end if;
      end loop;
      
      if ((ciziMena = false and zapocteno < doklInt.sumCelkem) or (ciziMena = true and zapoctenoMen < doklInt.sumCelkemMen)) then     -- pokud neni komplet sparovan
        castka = doklInt.sumCelkem - zapocteno;
        castkaMen = doklInt.sumCelkemMen - zapoctenoMen;
        if (ciziMena = true) then
          castka := castkaMen * doklInt.kurz / doklInt.kurzmnozstvi;
        else
          castkaMen := 0;
        end if;
        
        -- vybereme typ pro ktery je nejvetsi castka, pokud takovy neni nechame castku viset, protoze se jedna o celou castku
        select danEvidK, idTypUcOp, idStred, idZakazky into _danEvidK, _idTypUcOp, _idStred, _idZakazky from uDanEvid 
          where idDoklInt = doklInt.idDoklInt order by sumZkl desc limit 1;
        if _danEvidK is not null then
          INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
            VALUES (_danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
        end if;
        
      end if;
      
    end if;
  end if;
  
  DELETE from uDanEvid WHERE idDoklInt = doklInt.idDoklInt and sumZkl = 0 and sumZklMen = 0 and sumDph = 0 and sumDphMen = 0;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.uUpdateDanEvid(integer) OWNER TO %firmaRole%;

-- trigger volaný při změně položky faktury - aktualizuje položky v daňové evidenci
CREATE OR REPLACE FUNCTION dpolfakupdatedanevid()
  RETURNS trigger AS $$
declare
  idDoklInt integer;
begin
  for idDoklInt in (
    select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY', 'typVazbyDokl.vazbaZDD', 'typVazbyDokl.zaucProdejky')
    union
    select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in
      (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabA in
        (select idPolFak from dPolFak where idDoklFak = NEW.idDoklFak))
  ) loop
    perform uUpdateDanEvid(idDoklInt);
  end loop;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolfakupdatedanevid() OWNER TO %firmaRole%;

-- trigger volaný při vytváření a mazání vazby mezi doklady - aktualizuje položky v daňové evidenci pokud se jedná o úhradu
CREATE OR REPLACE FUNCTION dvazebtabinsertdeletedanevid()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
  _idDoklInt integer;
begin
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;
  _idDoklInt := null;
  
  if (ZAZNAM.typvazbyk in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY', 'typVazbyDokl.vazbaZDD', 'typVazbyDokl.zaucProdejky')) then
    _idDoklInt := ZAZNAM.idTabB;
  end if;
  if (ZAZNAM.typvazbyk = 'typVazbyDokl.odpocetZALOHY') then
    select idTabB into _idDoklInt from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA = ZAZNAM.idTabB;
  end if;
  
  if (_idDoklInt is not null) then
    perform uUpdateDanEvid(_idDoklInt);
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dvazebtabinsertdeletedanevid() OWNER TO %firmaRole%;

-- trigger volaný při aktualizaci faktury - pokud se jedná o prodejku, je zaúčtovaná a dojde ke změně ovlivňující zaúčtování, odnastaví stav zaúčtováno
CREATE OR REPLACE FUNCTION ddoklfaktupdateprodejky()
  RETURNS trigger AS $$
begin
  if (OLD.prodejka = true and NEW.prodejka = false) then      -- delame z prodejky fakturu
    NEW.stavuzivk = null;
    delete from dvazebtab where idtaba = NEW.iddoklfak and modula = 'FAV' and typvazbyk = 'typVazbyDokl.zaucProdejky';  -- zrusime vazbu prodejky
  end if;
  
  if (NEW.prodejka = true and NEW.stavuzivk = 'stavUziv.zauctovano' and OLD.stavuzivk = 'stavUziv.zauctovano') then
    if (NEW.sumcelkem <> OLD.sumcelkem or NEW.sumcelkemmen <> OLD.sumcelkemmen or NEW.datvyst <> OLD.datvyst) then
      NEW.stavuzivk = 'stavUziv.zaucZmena';
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklfaktupdateprodejky() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulku faktur
CREATE TRIGGER ddoklfaktupdateprodejky BEFORE UPDATE ON ddoklfak
  FOR EACH ROW EXECUTE PROCEDURE ddoklfaktupdateprodejky();

-- trigger volaný při smazání vazby prodejky
CREATE OR REPLACE FUNCTION dvazebtabdeletevazbaprodejky()
  RETURNS trigger AS $$
begin
  if OLD.typvazbyk = 'typVazbyDokl.zaucProdejky' then
    update ddoklfak set stavuzivk = null where iddoklfak = OLD.idtaba;
  end if;
  
  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dvazebtabdeletevazbaprodejky() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulku vazeb
CREATE TRIGGER dvazebtabdeletevazbaprodejky AFTER DELETE ON dvazebtab
  FOR EACH ROW EXECUTE PROCEDURE dvazebtabdeletevazbaprodejky();

-- opravime existujici vazby
create or replace function runupgrade()
    returns void as $$
declare
    iddommena integer;
    doklInt record;
    sumaFak numeric;
    newStav varchar;
    stat character varying(10);
begin
  select idmeny into iddommena from nnastav where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  update dvazebtab set castka = (select (case when (D.idmeny is null or D.idmeny = iddommena) then D.sumcelkem else D.sumcelkemmen end) as cast
      from ddoklfak as D where iddoklfak = idtaba) 
    where typvazbyk = 'typVazbyDokl.zaucProdejky';
  
  -- nastavime pokladnim dokladum ze jsou generovany z prodejek
  update ddoklint set stavuzivk = 'stavUziv.genKasa' where iddoklint in (select idtabb from dvazebtab where typvazbyk = 'typVazbyDokl.zaucProdejky');
  
  -- pokud je nekde vazba prodejky na dokladu prevedenem na fakturu tak ji zrusime
  delete from dvazebtab as V where modula = 'FAV' and typvazbyk = 'typVazbyDokl.zaucProdejky' and 
    (select prodejka from ddoklfak where iddoklfak = V.idtaba) = false;
  
  -- nastavime stav prodejkam
  for doklInt in select * from ddoklint where stavuzivk = 'stavUziv.genKasa' loop
    select sum(case when (D.idmeny is null or D.idmeny = iddommena) then D.sumcelkem else D.sumcelkemmen end) into sumaFak from ddoklfak as D where iddoklfak in 
      (select idtaba from dvazebtab where typvazbyk = 'typVazbyDokl.zaucProdejky' and idtabb = doklInt.iddoklint);
    
    newStav = 'stavUziv.zauctovano';
    if (doklInt.idmeny is null or doklInt.idmeny = iddommena) then
      if sumafak <> doklInt.sumcelkem then
        newStav = 'stavUziv.zaucZmena';
      end if;
    else
      if sumfak <> doklInt.sumcelkemmen then
        newStav = 'stavUziv.zaucZmena';
      end if;
    end if;
    
    update ddoklfak set stavuzivk = newStav where prodejka = true and iddoklfak in 
      (select idtaba from dvazebtab where typvazbyk = 'typVazbyDokl.zaucProdejky' and idtabb = doklInt.iddoklint);
  end loop;
  
  
  -- oprava pocitani odmeny
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek
-- update hlavicky kalkulacky
-- update inicializacnich radek kalkulacky
-- update radek kalkulacky
UPDATE pmzdcalc SET cisrad = 156 WHERE idmzdcalc = 1117;
UPDATE pmzdcalc SET cisrad = 120 WHERE idmzdcalc = 1118;
UPDATE pmzdcalc SET cisrad = 121 WHERE idmzdcalc = 1119;
UPDATE pmzdcalc SET cisrad = 122 WHERE idmzdcalc = 1120;
UPDATE pmzdcalc SET cisrad = 123 WHERE idmzdcalc = 1121;
UPDATE pmzdcalc SET cisrad = 124 WHERE idmzdcalc = 1122;
UPDATE pmzdcalc SET cisrad = 125 WHERE idmzdcalc = 1123;
UPDATE pmzdcalc SET cisrad = 126 WHERE idmzdcalc = 1124;
UPDATE pmzdcalc SET cisrad = 127 WHERE idmzdcalc = 1125;
UPDATE pmzdcalc SET cisrad = 128 WHERE idmzdcalc = 1126;
UPDATE pmzdcalc SET cisrad = 129 WHERE idmzdcalc = 1127;
UPDATE pmzdcalc SET cisrad = 130 WHERE idmzdcalc = 1128;
UPDATE pmzdcalc SET cisrad = 131 WHERE idmzdcalc = 1129;
UPDATE pmzdcalc SET cisrad = 132 WHERE idmzdcalc = 1130;
UPDATE pmzdcalc SET cisrad = 133 WHERE idmzdcalc = 1131;
UPDATE pmzdcalc SET cisrad = 134 WHERE idmzdcalc = 1132;
UPDATE pmzdcalc SET cisrad = 135 WHERE idmzdcalc = 1133;
UPDATE pmzdcalc SET cisrad = 136 WHERE idmzdcalc = 1134;
UPDATE pmzdcalc SET cisrad = 137 WHERE idmzdcalc = 1135;
UPDATE pmzdcalc SET cisrad = 138 WHERE idmzdcalc = 1136;
UPDATE pmzdcalc SET cisrad = 139 WHERE idmzdcalc = 1137;
UPDATE pmzdcalc SET cisrad = 140 WHERE idmzdcalc = 1138;
UPDATE pmzdcalc SET cisrad = 141 WHERE idmzdcalc = 1139;
UPDATE pmzdcalc SET cisrad = 142 WHERE idmzdcalc = 1140;
UPDATE pmzdcalc SET cisrad = 143 WHERE idmzdcalc = 1141;
UPDATE pmzdcalc SET cisrad = 144 WHERE idmzdcalc = 1142;
UPDATE pmzdcalc SET cisrad = 145 WHERE idmzdcalc = 1143;
UPDATE pmzdcalc SET cisrad = 146 WHERE idmzdcalc = 1144;
UPDATE pmzdcalc SET cisrad = 147 WHERE idmzdcalc = 1145;
UPDATE pmzdcalc SET cisrad = 148 WHERE idmzdcalc = 1146;
UPDATE pmzdcalc SET cisrad = 149 WHERE idmzdcalc = 1147;
UPDATE pmzdcalc SET cisrad = 150 WHERE idmzdcalc = 1148;
UPDATE pmzdcalc SET cisrad = 151 WHERE idmzdcalc = 1149;
UPDATE pmzdcalc SET cisrad = 152 WHERE idmzdcalc = 1150;
UPDATE pmzdcalc SET cisrad = 153 WHERE idmzdcalc = 1151;
UPDATE pmzdcalc SET cisrad = 154 WHERE idmzdcalc = 1152;
UPDATE pmzdcalc SET cisrad = 155 WHERE idmzdcalc = 1153;

-- pracovni pomery
-- parametry pro typ prac pom

-- konec ceskeho bloku
  end if; 
  
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 478, 't', %appVersion%, clock_timestamp());
