--------------------------------------------------------------------------------
-- Bug 19691 – [WinStrom] Kurz pro Slovensko se nemá násobit, ale dělit.
-- Oprava fixopie
--------------------------------------------------------------------------------

ALTER TABLE ddoklfak
  ALTER COLUMN kurzmnozstvi TYPE numeric(19,6),
  ALTER COLUMN kurzmnozstvi SET DEFAULT 0.0;

ALTER TABLE ddoklint
  ALTER COLUMN kurzmnozstvi TYPE numeric(19,6),
  ALTER COLUMN kurzmnozstvi SET DEFAULT 0.0;

ALTER TABLE ddoklobch
  ALTER COLUMN kurzmnozstvi TYPE numeric(19,6),
  ALTER COLUMN kurzmnozstvi SET DEFAULT 0.0;

ALTER TABLE ddoklsklad
  ALTER COLUMN kurzmnozstvi TYPE numeric(19,6),
  ALTER COLUMN kurzmnozstvi SET DEFAULT 0.0;


ALTER TABLE ukurzy
  ALTER COLUMN kurzmnozstvi TYPE numeric(19,6),
  ALTER COLUMN kurzmnozstvi SET DEFAULT 0.0;

ALTER TABLE umeny
  ALTER COLUMN kurzmnozstvi TYPE numeric(19,6),
  ALTER COLUMN kurzmnozstvi SET DEFAULT 0.0;

ALTER TABLE uDanEvid
  ALTER COLUMN kurzmnozstvi TYPE numeric(19,6),
  ALTER COLUMN kurzmnozstvi SET DEFAULT 0.0;


ALTER TABLE dformauhradycis
  ALTER COLUMN kurzmnozstvi TYPE numeric(19,6);

ALTER TABLE dformauhrady
  ALTER COLUMN kurzmnozstvi TYPE numeric(19,6);


--------------------------------------------------------------------------------


CREATE OR REPLACE FUNCTION getkurzfromdoklad(i_doklskladid integer, i_datvyst date) RETURNS numeric
    AS $$   
declare   
  idMenyTuzemsko integer;  
  idMenyDoklad integer;  
  _kurzMnozstvi numeric(19,6);  
  _nbStred numeric(10,6);  
  _result numeric(19,6);  
    
begin   
  /* pokud je doklad v tuzemske mene vrati se kurz 1*/  
  select idMeny into idMenyTuzemsko from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;  
  if (idMenyTuzemsko is null) then  
    select idMeny into idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;   
  end if;  
  select idMeny into idMenyDoklad from dDoklSklad where idDoklSklad = i_doklSkladId;  
  
  if(idMenyDoklad is null or idMenyDoklad = idMenyTuzemsko) then  
    return 1;  
  end if;   
  /* jinak se nacte z dokladu */  
  select kurz, kurzMnozstvi into _nbStred, _kurzMnozstvi from ddoklsklad where idDoklSklad = i_doklSkladId;  
  
  if _kurzMnozstvi = 0 then  
    _result := 0;  
  else  
    _result := _nbStred / _kurzMnozstvi;  
  end if;  
    
  return _result;   
end;   
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.getkurzfromdoklad(i_doklskladid integer, i_datvyst date) OWNER TO %firmaRole%;

--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION getkurzfromsklad(i_skladid integer, i_datvyst date) RETURNS numeric
    AS $$   
declare   
  idMenyTuzemsko integer;  
  idMenySklad integer;  
  _kurzMnozstvi numeric(19,6);  
  _nbStred numeric(10,6);  
  _result numeric(19,6);  
    
begin   
  select idMeny into idMenyTuzemsko from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;  
  if (idMenyTuzemsko is null) then  
    select idMeny into idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;   
  end if;  
  select idMeny into idMenySklad from dBsp where idBsp = i_skladId;
  
  if(idMenySklad is null or idMenySklad = idMenyTuzemsko) then  
    return 1;  
  end if;   
    
  select nbStred, kurzMnozstvi into _nbStred, _kurzMnozstvi from uKurzy 
  where idMeny = idMenySklad and i_DatVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny'
  order by PlatiOdData desc limit 1;  
  if(_nbStred is null) then  
    select nbStred, kurzMnozstvi into _nbStred, _kurzMnozstvi from uKurzy
    where idMeny = idMenySklad and PlatiOdData is null and typkurzuk = 'typKurzu.obecny'
    limit 1;  
  end if;  
  if(_nbStred is null) then  
    raise exception '0001:getKurzFromSklad : neexistuje kurz!';  
    /*_nbStred := 0;  
    _kurzMnozstvi := 0;*/  
  end if;  
  
  if _kurzMnozstvi = 0 then  
    _result := 0;  
  else  
    _result := _nbStred / _kurzMnozstvi;  
  end if;  
    
  return _result;   
end;    
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.getkurzfromsklad(i_skladid integer, i_datvyst date) OWNER TO %firmaRole%;

--------------------------------------------------------------------------------


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 530, 't', %appVersion%, clock_timestamp());