---------------------------------------------------------------------------------------
-- Bug 25819 – [WinStrom] Vytvořit základní indexy nad datumy
---------------------------------------------------------------------------------------

-- Indexy nad hlavičkami dokladů

CREATE INDEX ddoklfak_datvyst ON ddoklfak(datvyst);
CREATE INDEX ddoklfak_datsplat ON ddoklfak(datsplat);
CREATE INDEX ddoklfak_datucto ON ddoklfak(datucto);
CREATE INDEX ddoklfak_datuhr ON ddoklfak(datuhr);
CREATE INDEX ddoklfak_dattermin ON ddoklfak(dattermin);
CREATE INDEX ddoklfak_duzppuv ON ddoklfak(duzppuv);
CREATE INDEX ddoklfak_duzpucto ON ddoklfak(duzpucto);
CREATE INDEX ddoklfak_stavUhrK ON ddoklfak(stavUhrK);
CREATE INDEX ddoklfak_danEvidK ON ddoklfak(danEvidK);

CREATE INDEX ddoklint_datvyst ON ddoklint(datvyst);
CREATE INDEX ddoklint_datucto ON ddoklint(datucto);
CREATE INDEX ddoklint_dattermin ON ddoklint(dattermin);
CREATE INDEX ddoklint_duzppuv ON ddoklint(duzppuv);
CREATE INDEX ddoklint_duzpucto ON ddoklint(duzpucto);
CREATE INDEX ddoklint_danevidk ON ddoklint(danevidk);
CREATE INDEX ddoklint_typpohybuk ON ddoklint(typpohybuk);

CREATE INDEX ddoklsklad_datvyst ON ddoklsklad(datvyst);
CREATE INDEX ddoklsklad_datucto ON ddoklsklad(datucto);
CREATE INDEX ddoklsklad_datsklad ON ddoklsklad(datsklad);
CREATE INDEX ddoklsklad_stavskladk ON ddoklsklad(stavskladk);
CREATE INDEX ddoklsklad_typpohybuskladk ON ddoklsklad(typpohybuskladk);

CREATE INDEX ddoklobch_datvyst ON ddoklobch(datvyst);
CREATE INDEX ddoklobch_datobj ON ddoklobch(datobj);
CREATE INDEX ddoklobch_dattermin ON ddoklobch(dattermin);
CREATE INDEX ddoklobch_datreal ON ddoklobch(datreal);
CREATE INDEX ddoklobch_stavuzivk ON ddoklobch(stavuzivk);


-- Indexy nad položkami dokladů

CREATE INDEX dpolobch_datvyst ON dpolobch(datvyst);

CREATE INDEX dpolfak_datucto ON dpolobch(datucto);
CREATE INDEX dpolint_datucto ON dpolobch(datucto);
CREATE INDEX dpolsklad_datucto ON dpolsklad(datucto);


-- Indexy pro modul nad hlavičkami dokladů a jejich položkami

CREATE INDEX ddoklfak_modul ON ddoklfak(modul);
CREATE INDEX ddoklint_modul ON ddoklint(modul);
CREATE INDEX ddoklsklad_modul ON ddoklsklad(modul);
CREATE INDEX ddoklobch_modul ON ddoklobch(modul);

CREATE INDEX dpolfak_modul ON dpolfak(modul);
CREATE INDEX dpolint_modul ON dpolint(modul);
CREATE INDEX dpolsklad_modul ON dpolsklad(modul);
CREATE INDEX dpolobch_modul ON dpolobch(modul);


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 545, 't', %appVersion%, clock_timestamp());
