--------------------------------------------------------------------------------
-- Bug 27903 – [WinStrom] Předpis zaúčtování na položku smlouvy
--------------------------------------------------------------------------------

ALTER TABLE dsmlouvy
    ADD COLUMN datumPodepsani date,

    ADD COLUMN idfirmyfakt integer,
    ADD CONSTRAINT dsmlouvy_idfirmyfakt FOREIGN KEY (idfirmyfakt)
        REFERENCES aadresar (idfirmy) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dsmlouvy_idfirmyfakt_index ON dsmlouvy USING btree (idfirmyfakt);


ALTER TABLE dpolsml
    ADD COLUMN popis text,
    ADD COLUMN poznam text,
    ADD COLUMN idmisto integer,
    ADD COLUMN idtypucop integer,
    ADD COLUMN idcinnost integer,
    ADD COLUMN idzakazky integer,

    ADD CONSTRAINT dpolsml_idmisto FOREIGN KEY (idmisto)
        REFERENCES amisturc(idmur) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dpolsml_idtypucop FOREIGN KEY (idtypucop)
        REFERENCES utypucop(idtypucop) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dpolsml_idcinnost FOREIGN KEY (idcinnost)
        REFERENCES ucinnost (idcinnost) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dpolsml_idzakazky FOREIGN KEY (idzakazky)
        REFERENCES uzakazky(idzakazky) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dpolsml_idmisto_index ON dpolsml USING btree (idmisto);
CREATE INDEX dpolsml_idtypucop_index ON dpolsml USING btree (idtypucop);
CREATE INDEX dpolsml_idcinnost_index ON dPolSml USING btree (idcinnost);
CREATE INDEX dpolsml_idzakazky_index ON dPolSml USING btree (idzakazky);


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 584, 't', %appVersion%, clock_timestamp());
