----------------------------------------------------------------------------------------------
-- Bug 29639 – [WinStrom] Forma uhrady Inkasem
----------------------------------------------------------------------------------------------

-- pridani vazby na doklfak
ALTER TABLE ddoklfak ADD COLUMN idformauhradycis integer;
ALTER TABLE ddoklfak ADD CONSTRAINT ddoklfak_idformauhradycis FOREIGN KEY (idformauhradycis)
  REFERENCES dformauhradycis (idformauhradycis) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX dDoklFak_IdFormaUhradyCis_index ON dDoklFak USING btree (IdFormaUhradyCis);

-- pridani vazby na doklint
ALTER TABLE ddoklint ADD COLUMN idformauhradycis integer;
ALTER TABLE ddoklint ADD CONSTRAINT ddoklint_idformauhradycis FOREIGN KEY (idformauhradycis)
  REFERENCES dformauhradycis (idformauhradycis) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX dDoklInt_IdFormaUhradyCis_index ON dDoklInt USING btree (IdFormaUhradyCis);

-- pridani vazby na doklobch
ALTER TABLE ddoklobch ADD COLUMN idformauhradycis integer;
ALTER TABLE ddoklobch ADD CONSTRAINT ddoklobch_idformauhradycis FOREIGN KEY (idformauhradycis)
  REFERENCES dformauhradycis (idformauhradycis) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX dDoklObch_IdFormaUhradyCis_index ON dDoklObch USING btree (IdFormaUhradyCis);

-- pridani vazby na typ dokladu
ALTER TABLE dtypdokl ADD COLUMN idformauhradycis integer;
ALTER TABLE dtypdokl ADD CONSTRAINT dtypdokl_idformauhradycis FOREIGN KEY (idformauhradycis)
  REFERENCES dformauhradycis (idformauhradycis) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX dTypDokl_IdFormaUhradyCis_index ON dTypDokl USING btree (IdFormaUhradyCis);

-- pridani sloupcu na formu uhrady
ALTER TABLE dformauhradycis ADD COLUMN vsbfak boolean NOT NULL DEFAULT false;
ALTER TABLE dformauhradycis ADD COLUMN vsbkasa boolean NOT NULL DEFAULT false;
ALTER TABLE dformauhradycis ADD COLUMN vsbpok boolean NOT NULL DEFAULT false;

-- soucasne formy uhrady jsou pro kasu
UPDATE dformauhradycis SET vsbkasa = true;
UPDATE dformauhradycis SET vsbfak = true, vsbpok = true WHERE uuid = 'HOTOVE' or uuid = 'KARTA';

-- nove formy uhrady
INSERT INTO dformauhradycis (lastupdate, kod, nazev, show, platiod, platido, formauhrk, kurz, kurzmnozstvi, limitvratky, vsbfak, vsbpok, vsbkasa, uuid)
 VALUES ('2012-06-01 00:00:00.000', generateuniquekod('PREVOD', 'dformauhradycis', '_'), 'Převodem', true, 0, 9999, 'formaUhr.prevod', 0.0, 0.0, 0.0, true, false, false, 'PREVOD');
INSERT INTO dformauhradycis (lastupdate, kod, nazev, show, platiod, platido, formauhrk, kurz, kurzmnozstvi, limitvratky, vsbfak, vsbpok, vsbkasa, uuid)
 VALUES ('2012-06-01 00:00:00.000', generateuniquekod('SLOZENKA', 'dformauhradycis', '_'), 'Složenkou', true, 0, 9999, 'formaUhr.slozenka', 0.0, 0.0, 0.0, true, false, false, 'SLOZENKA');
INSERT INTO dformauhradycis (lastupdate, kod, nazev, show, platiod, platido, formauhrk, kurz, kurzmnozstvi, limitvratky, vsbfak, vsbpok, vsbkasa, uuid)
 VALUES ('2012-06-01 00:00:00.000', generateuniquekod('DOBIRKA', 'dformauhradycis', '_'), 'Dobírkou', true, 0, 9999, 'formaUhr.dobirka', 0.0, 0.0, 0.0, true, false, false, 'DOBIRKA');
INSERT INTO dformauhradycis (lastupdate, kod, nazev, show, platiod, platido, formauhrk, kurz, kurzmnozstvi, limitvratky, vsbfak, vsbpok, vsbkasa, uuid)
 VALUES ('2012-06-01 00:00:00.000', generateuniquekod('ZAPOCET', 'dformauhradycis', '_'), 'Zápočtem', true, 0, 9999, 'formaUhr.zapocet', 0.0, 0.0, 0.0, true, false, false, 'ZAPOCET');
INSERT INTO dformauhradycis (lastupdate, kod, nazev, show, platiod, platido, formauhrk, kurz, kurzmnozstvi, limitvratky, vsbfak, vsbpok, vsbkasa, uuid)
 VALUES ('2012-06-01 00:00:00.000', generateuniquekod('NESPECIFIKOVANO', 'dformauhradycis', '_'), 'Nespecifikováno', true, 0, 9999, 'formaUhr.jina', 0.0, 0.0, 0.0, true, false, false, 'NESPECIFIKOVANO');
INSERT INTO dformauhradycis (lastupdate, kod, nazev, show, platiod, platido, formauhrk, kurz, kurzmnozstvi, limitvratky, vsbfak, vsbpok, vsbkasa, uuid)
 VALUES ('2012-06-01 00:00:00.000', generateuniquekod('SEK', 'dformauhradycis', '_'), 'Šekem', true, 0, 9999, 'formaUhr.sek', 0.0, 0.0, 0.0, true, false, false, 'SEK');

-- zakazani triggeru na dokladech z duvodu rychlosti
ALTER TABLE ddoklfak DISABLE TRIGGER ALL;
ALTER TABLE ddoklint DISABLE TRIGGER ALL;
ALTER TABLE ddoklobch DISABLE TRIGGER ALL;

-- spojeni jina s nespecifikovano
UPDATE ddoklfak SET formauhrk = 'formaUhr.jina' WHERE formauhrk = 'formaUhr.nespec';
UPDATE ddoklint SET formauhrk = 'formaUhr.jina' WHERE formauhrk = 'formaUhr.nespec';
UPDATE ddoklobch SET formauhrk = 'formaUhr.jina' WHERE formauhrk = 'formaUhr.nespec';
UPDATE dtypdokl SET formauhrk = 'formaUhr.jina' WHERE formauhrk = 'formaUhr.nespec';

-- doplneni vazby na ciselnik na doklady/typy
UPDATE ddoklfak SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'PREVOD') WHERE formauhrk = 'formaUhr.prevod';
UPDATE ddoklfak SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'HOTOVE') WHERE formauhrk = 'formaUhr.hotove';
UPDATE ddoklfak SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'SLOZENKA') WHERE formauhrk = 'formaUhr.slozenka';
UPDATE ddoklfak SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'DOBIRKA') WHERE formauhrk = 'formaUhr.dobirka';
UPDATE ddoklfak SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'KARTA') WHERE formauhrk = 'formaUhr.platKart';
UPDATE ddoklfak SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'ZAPOCET') WHERE formauhrk = 'formaUhr.zapocet';
UPDATE ddoklfak SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'NESPECIFIKOVANO') WHERE formauhrk = 'formaUhr.jina';
UPDATE ddoklfak SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'SEK') WHERE formauhrk = 'formaUhr.sek';

UPDATE ddoklint SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'HOTOVE') WHERE formauhrk = 'formaUhr.hotove';
UPDATE ddoklint SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'KARTA') WHERE formauhrk = 'formaUhr.platKart';

UPDATE ddoklobch SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'PREVOD') WHERE formauhrk = 'formaUhr.prevod';
UPDATE ddoklobch SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'HOTOVE') WHERE formauhrk = 'formaUhr.hotove';
UPDATE ddoklobch SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'SLOZENKA') WHERE formauhrk = 'formaUhr.slozenka';
UPDATE ddoklobch SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'DOBIRKA') WHERE formauhrk = 'formaUhr.dobirka';
UPDATE ddoklobch SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'KARTA') WHERE formauhrk = 'formaUhr.platKart';
UPDATE ddoklobch SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'ZAPOCET') WHERE formauhrk = 'formaUhr.zapocet';
UPDATE ddoklobch SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'NESPECIFIKOVANO') WHERE formauhrk = 'formaUhr.jina';
UPDATE ddoklobch SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'SEK') WHERE formauhrk = 'formaUhr.sek';

UPDATE dtypdokl SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'PREVOD') WHERE formauhrk = 'formaUhr.prevod';
UPDATE dtypdokl SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'HOTOVE') WHERE formauhrk = 'formaUhr.hotove';
UPDATE dtypdokl SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'SLOZENKA') WHERE formauhrk = 'formaUhr.slozenka';
UPDATE dtypdokl SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'DOBIRKA') WHERE formauhrk = 'formaUhr.dobirka';
UPDATE dtypdokl SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'KARTA') WHERE formauhrk = 'formaUhr.platKart';
UPDATE dtypdokl SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'ZAPOCET') WHERE formauhrk = 'formaUhr.zapocet';
UPDATE dtypdokl SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'NESPECIFIKOVANO') WHERE formauhrk = 'formaUhr.jina';
UPDATE dtypdokl SET idformauhradycis = (select idformauhradycis from dformauhradycis where uuid = 'SEK') WHERE formauhrk = 'formaUhr.sek';

-- povoleni triggeru
ALTER TABLE ddoklfak ENABLE TRIGGER ALL;
ALTER TABLE ddoklint ENABLE TRIGGER ALL;
ALTER TABLE ddoklobch ENABLE TRIGGER ALL;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 619, 't', %appVersion%, clock_timestamp());

