--------------------------------------------------------------------------------
-- Bug 31160 – [WinStrom] - Evidence odpadu EkoKom
-- potrebujeme specialni generovani id
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION bigid(ekokomk character varying, typobaluk character varying, typvznikuk character varying, typpouzitik character varying, materialk character varying)
  RETURNS bigint AS
$BODY$   
declare   
  idekokomk int;
  idtypobaluk int;
  idtypvznikuk int;
  idtyppouzitik int;
  idmaterialk int;
  minekokomk int;
  mintypvznikuk int;
  mintyppouzitik int;
  mintypobaluk int;
  minmaterialk int;
  pocet int;
  bigId bigint;   
begin   
  select idlokcis      into idekokomk      from wlokcis where ciselnik = 'ekokom'     and kod = ekokomk;
  select min(idlokcis) into minekokomk     from wlokcis where ciselnik = 'ekokom';
  select idlokcis      into idtypvznikuk   from wlokcis where ciselnik = 'typVzniku'  and kod = typvznikuk;
  select min(idlokcis) into mintypvznikuk  from wlokcis where ciselnik = 'typVzniku';
  select idlokcis      into idtyppouzitik  from wlokcis where ciselnik = 'typPouziti' and kod = typpouzitik;
  select min(idlokcis) into mintyppouzitik from wlokcis where ciselnik = 'typPouziti';
  select idlokcis      into idtypobaluk    from wlokcis where ciselnik = 'typObalu'   and kod = typobaluk;
  select min(idlokcis) into mintypobaluk   from wlokcis where ciselnik = 'typObalu';
  select idlokcis      into idmaterialk    from wlokcis where ciselnik = 'material'   and kod = materialk;
  select min(idlokcis) into minmaterialk   from wlokcis where ciselnik = 'material';

  if(idekokomk is null)     then idekokomk =     minekokomk - 1;     end if;
  if(idtypvznikuk is null)  then idtypvznikuk =  mintypvznikuk - 1;  end if;
  if(idtyppouzitik is null) then idtyppouzitik = mintyppouzitik - 1; end if;
  if(idtypobaluk is null)   then idtypobaluk =   mintypobaluk - 1;   end if;
  if(idmaterialk is null)   then idmaterialk =   minmaterialk - 1;   end if;
  
  pocet = 100;
  bigid = (idekokomk - minekokomk + 1)*pocet*pocet*pocet*pocet
        + (idtypobaluk - mintypobaluk + 1)*pocet*pocet*pocet
        + (idtypvznikuk - mintypvznikuk + 1)*pocet*pocet
        + (idtyppouzitik - mintyppouzitik + 1)*pocet
        + (idmaterialk - minmaterialk + 1)
        ;

  return bigId;   
end;   
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION bigid(character varying, character varying, character varying, character varying, character varying) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 719, 't', %appVersion%, clock_timestamp());

