--------------------------------------------------------------------------------
-- Bug 32835 – [WinStrom] Datum posledního pohybu na skladové kartě
--------------------------------------------------------------------------------

-- Function: dpolskladupdate()
-- DROP FUNCTION dpolskladupdate();
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$ 
declare 
  tmp_rozsirenepolozky_exists boolean; 
  _updatuj boolean; 
  _pocetPolozek integer; 
  _rozsirenaPolozka record; 
  _sklFifo boolean; 
  _vypnutySklad character varying;
  _mazatTmpTable boolean; 
  _polSklad record;
  _datPosl date;
  _newDatPosl date;
begin 

  if(NEW.idBspSkl = OLD.idBspSkl and NEW.idCenik = OLD.idCenik
    and comparevarchar(NEW.typPolozkyK, OLD.typPolozkyK)
    and comparevarchar(NEW.sarze, OLD.sarze) and comparedate(NEW.expirace, OLD.expirace)
    and NEW.mnozMj = OLD.mnozMj and NEW.cenaMj = OLD.cenaMj and NEW.sumZkl = OLD.sumZkl and NEW.sumZklMen = OLD.sumZklMen
    and NEW.storno = OLD.storno 
  ) then
    if(not comparedate(NEW.datVyst, OLD.datVyst)) then
      -- pokud se nezmenilo nic jinyho jen datum vystaveni
      select datPosl into _datPosl from skarty where idkarty = NEW.idkarty;
      select max(datVyst) into _newDatPosl from dPolSklad where idKarty = NEW.idKarty;
      
      if(_newDatPosl is not null and _datPosl is not null and _newDatPosl <> _datPosl) then
        update skarty set datPosl = _newDatPosl where idKarty = NEW.idKarty;
      end if;
    end if;
    return NEW;
  end if;

  /* 
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky 
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat 
  */ 
  select getglotxvariable('vypniSklad') into _vypnutySklad; 
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then 
    _updatuj = true; 
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
    if(tmp_rozsirenepolozky_exists = true) then 
      select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad; 
      if(_pocetPolozek > 0) then 
        _updatuj = false; 
      end if; 
    end if; 
 
    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then 
      _updatuj = false; 
    end if; 
   
    if (OLD.storno=false and NEW.storno=true) then
      execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);
    end if;

    _sklfifo := (select isfifosklad(NEW.datVyst));   
    if (_sklfifo) then   
      --fifo   
      if (OLD.cenamj <> NEW.cenamj) then   
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);   
      end if;     
      --fifo konec   
    end if;   
 
    -- tohle musi byt i pro prumerne ceny protoze jinak se negeneruji fifo vazby
    if (OLD.mnozMj = 0.0 and NEW.mnozMj != 0.0) then
      execute sfifovydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idkarty, NEW.mnozMjPlan, NEW.cenyRucne);
    end if;
    
    if(_updatuj) then 
 
      -- generuji rozsirene polozky 
      select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
     
      execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
  
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          if(_rozsirenaPolozka.cenyRucne = true) then
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
            end if;
          else 
            execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
          end if;
        end if; 
      end loop; 

      if(OLD.storno = false) then
        execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1);
      end if;

      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          if(_rozsirenaPolozka.cenyRucne = true) then
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
            end if;
          else
            execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
          end if;
        else
          if(NEW.storno = false) then
            execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1);
          end if;
        end if;
      end loop; 
 
      if(_mazatTmpTable) then 
        drop table tmp_RozsirenePolozky; 
        drop table tmp_SkladoveKarty; 
        execute removeglotxvariable('zurnalTxName'); 
      end if; 
        
    end if; 
  end if;

  execute sprepoctisumydokladu(NEW.idDoklSklad); 

  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 720, 't', %appVersion%, clock_timestamp());

