----------------------------------------------------------------------------------------------------
-- Bug 35731 – Na příjemce vygenerované z dobropisu je jiné množství MJ než je v položce dobropisu
----------------------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION createpolskladdobropis(_iddobropisovanepolsklad integer, _iddobropisujicipoldokl integer, _modul character varying, _typVazbyK character varying)
  RETURNS integer AS
$BODY$ 
declare
  _idPolSklad integer;
  _idDoklad integer;
  _idDoklSklad integer; 
  _dobropisovanaPolSklad record;
  _kopZakazku boolean;
  _kopStred boolean;
  _kopCinnost boolean;
  _polDokl record;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _iducetobdobi integer;
  _idkarty integer;
  _mnozMj numeric(19,6); 
  _pomer numeric(19,12);
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _mnozMjDobropisovane numeric(19,6);
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _idMeny integer;
  _idTypUcOp integer; 
  _kurz numeric(19,6); 
  _ciziMena boolean;
  _typPohybuK character varying;
  _nasobic numeric(19,6);
  _skupZboz record;
begin
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _iddobropisujicipoldokl;
    _idDoklad = _polDokl.idDoklFak;
    select mnozMj into _mnozMjDobropisovane from dPolFak where idPolFak = _polDokl.idPolDobropis;
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad;
  else 
    select * into _polDokl from dPolInt where idPolInt = _iddobropisujicipoldokl;
    _idDoklad = _polDokl.idDoklInt;
    select mnozMj into _mnozMjDobropisovane from dPolInt where idPolInt = _polDokl.idPolDobropis;
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad;
  end if; 

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true, _polDokl.idBspSkl) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_iddobropisujicipoldokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then 
      return null; 
    end if; 
  end if; 

  select * into _dobropisovanaPolSklad from dpolsklad where idpolsklad = _iddobropisovanepolsklad;
  select idstred, idcinnost, idZakazky, idMeny
      into _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad, _idMeny 
      from dDoklSklad where idDoklSklad = _idDoklSklad;  

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _dobropisovanaPolSklad.idcenik and idskladu = _dobropisovanaPolSklad.idbspskl and iducetobdobi = _iducetobdobi;
  if(_idkarty is null) then
    raise exception 'idkarty je null protoze neexistuje skladova karta pro ucetni obdobi';
  end if;
  
  _nasobic = 1;
  if(_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej')then
    _nasobic = -1;
  end if;
  _mnozMj = _nasobic * _dobropisovanaPolSklad.mnozMj;
  _sumZkl = _nasobic * _dobropisovanaPolSklad.sumZkl;
  
  if((-1 * _polDokl.mnozMj) <> _mnozMjDobropisovane) then
    _pomer = -1 * _polDokl.mnozMj / _mnozMjDobropisovane;
    _mnozMj = _mnozMj * _pomer;
    _sumZkl = _sumZkl * _pomer;
  end if;
  --raise exception '% % %', _polDokl.mnozMj, _mnozMjDobropisovane, _mnozMj;
  -- zohledneni meny
  select ismenacizi(_idMeny, _polDokl.datvyst) into _ciziMena;
  if(_ciziMena) then
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
    _sumZklMen = _sumZkl / _kurz;
    _cenaMj = _sumZklMen / _mnozMj;
  else
    _sumZklMen = 0.0;
    _cenaMj = _sumZkl / _mnozMj;
  end if;
    
  _kopStred = true; 
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
    _kopStred = false; 
  end if; 
  _kopCinnost = true; 
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
    _kopCinnost = false; 
  end if; 
  _kopZakazku = true; 
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
    _kopZakazku = false; 
  end if;  

  select idprimucet into _idZklMdUcet from dbsp where idbsp = _dobropisovanaPolSklad.idbspskl;
  _kopZklMdUcet = false;

  _kopZklDalUcet = false;
  if(_modul like 'FAV') then
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _dobropisovanaPolSklad.idCenik); 
    if(_skupZboz.idProtiUcetSklV is not null) then 
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false; 
      _idZklDalUcet = _skupZboz.idProtiUcetSklV; 
    else 
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
      select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
      _kopZklDalUcet = true;
    end if; 
  else
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if;

  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad, 
      mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
      nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni,  
      idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp,
      idPolDobropis) 
    values (_idPolSklad, LOCALTIMESTAMP, _dobropisovanaPolSklad.idcenik, _dobropisovanaPolSklad.idbspskl, _idkarty, _polDokl.datVyst, /*_dobropisovanaPolSklad.datSklad + interval '0.000001'*/ LOCALTIMESTAMP, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad, 
      _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _dobropisovanaPolSklad.idmj, 
      _dobropisovanaPolSklad.nazev, _dobropisovanaPolSklad.nazevA, _dobropisovanaPolSklad.nazevB, _dobropisovanaPolSklad.nazevC, _dobropisovanaPolSklad.sarze, _dobropisovanaPolSklad.expirace, _dobropisovanaPolSklad.datTrvan, _dobropisovanaPolSklad.datVyroby, _dobropisovanaPolSklad.cisRad, true,  
      _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp,
      _iddobropisovanepolsklad); 

  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _iddobropisujicipoldokl, _idPolSklad, _modul, 'SKL', false, _typVazbyK); 

  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 

  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createpolskladdobropis(integer, integer, character varying, character varying) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 777, 't', %appVersion%, clock_timestamp());
