--------------------------------------------------------------------------------
-- Bug 37258 – flexibee mzdy - automatické zkrácení náhrady za nemoc
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek
ALTER TABLE pmzdsloz DISABLE TRIGGER pmzdslozupdatedatumvypoctu;

UPDATE pcismzdsloz SET kod = 'NÁHR.NEMOC 4-10 2010', uuid = 'NAHR.NEMOC_4-10_2010' WHERE idcismzdsloz = 70;
UPDATE pcismzdsloz SET kod = 'NÁHR.KARAN.4-10 2010', uuid = 'NAHR.KARAN.4-10_2010' WHERE idcismzdsloz = 177;
UPDATE pcismzdsloz SET platido = '2013-12-31' WHERE idcismzdsloz = 337;
UPDATE pcismzdsloz SET platido = '2013-12-31' WHERE idcismzdsloz = 338;
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, show, platiod, cisrad, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni, ukladatnulove, paskamala, paskavelka, paskapole, zapoctovylist, uuid)
 VALUES (378, '2013-12-19 00:00:00.000', 'NÁHR.NEMOC 4-10', 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', true, '2014-01-01', 2130, 'typSlozky.kopie', 'skupinaSlozky.nepritNemoc', false, false, false, true, true, true, true, true, true, false, false, false, false, true, true, false, false, false, false, false, 7.0, 15.0, 0.0, 0.0, 0.0, 0.0, 0.6, 0.0, false, 0.0, false, 0.0, 0.0, false, false, false, false, 'hodiny;castMzd', false, 'NAHR.NEMOC_4-10');
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, show, platiod, cisrad, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni, ukladatnulove, paskamala, paskavelka, paskapole, zapoctovylist, uuid)
 VALUES (379, '2013-12-19 00:00:00.000', 'NÁHR.KARANTÉNA 4-10', 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', true, '2014-01-01', 2080, 'typSlozky.kopie', 'skupinaSlozky.nepritKaran', false, false, false, true, true, true, true, true, false, false, false, false, false, true, true, false, false, false, false, false, 7.0, 15.0, 0.0, 0.0, 0.0, 0.0, 0.6, 0.0, false, 0.0, false, 0.0, 0.0, false, false, false, false, 'hodiny;castMzd', false, 'NAHR.KARANTENA_4-10');

ALTER TABLE pmzdsloz ENABLE TRIGGER pmzdslozupdatedatumvypoctu;
PERFORM pg_catalog.setval('seq_pcismzdsloz', 379, true);

-- radky
UPDATE pmzdcalc SET kod = 'NÁHR.NEMOC 4-10 ', idmzdslozout = 378 WHERE idmzdcalc = 5431;
UPDATE pmzdcalc SET kod = 'NÁHR.NEMOC 4-10 ', nazev = 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', idmzdslozin = 378, idmzdslozin2 = 378, idmzdslozout = 378 WHERE idmzdcalc = 5432;
UPDATE pmzdcalc SET kod = 'NÁHR.NEMOC 4-10 ', nazev = 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', idmzdslozin = 378, idmzdslozout = 378 WHERE idmzdcalc = 5433;
UPDATE pmzdcalc SET kod = 'NÁHR.KARANTÉNA 4-10', idmzdslozout = 379 WHERE idmzdcalc = 5438;
UPDATE pmzdcalc SET kod = 'NÁHR.KARANTÉNA 4-10', nazev = 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', idmzdslozin = 379, idmzdslozin2 = 379, idmzdslozout = 379 WHERE idmzdcalc = 5439;
UPDATE pmzdcalc SET kod = 'NÁHR.KARANTÉNA 4-10', nazev = 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', idmzdslozin = 379, idmzdslozout = 379 WHERE idmzdcalc = 5440;
UPDATE pmzdcalc SET nazev = 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', idmzdslozin = 379 WHERE idmzdcalc = 5468;
UPDATE pmzdcalc SET nazev = 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', idmzdslozin = 378 WHERE idmzdcalc = 5470;
UPDATE pmzdcalc SET nazev = 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', idmzdslozin = 378 WHERE idmzdcalc = 5607;
UPDATE pmzdcalc SET nazev = 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', idmzdslozin = 378 WHERE idmzdcalc = 5608;
UPDATE pmzdcalc SET nazev = 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', idmzdslozin = 379 WHERE idmzdcalc = 5611;
UPDATE pmzdcalc SET nazev = 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', idmzdslozin = 379 WHERE idmzdcalc = 5612;

-- parametry pomeru
-- hromadne

-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 807, 't', %appVersion%, clock_timestamp());
