--------------------------------------------------------------------------------
-- Bug 38219 – [Bug+Legis] Zmena ceny na FAP nezmeni cenu na dobropisu teto FAP
--------------------------------------------------------------------------------

ALTER TABLE ddoklfak ADD COLUMN dobropisovano boolean NOT NULL DEFAULT FALSE;

UPDATE ddoklfak as D SET dobropisovano = true FROM dvazebtab as V
  WHERE D.dobropisovano = false and V.idtaba = D.iddoklfak and V.modula = D.modul and V.typvazbyk = 'typVazbyDokl.hlavaDobropis';

CREATE OR REPLACE FUNCTION dvazebtabinsdeldobropis() RETURNS trigger
    AS $$
declare
  vazeb integer;
  ZAZNAM record;  
begin
  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;
  else
    ZAZNAM := NEW;
  end if;
  
  if (ZAZNAM.typvazbyk = 'typVazbyDokl.hlavaDobropis') then
    if (tg_op = 'DELETE') then
      SELECT count(*) into vazeb FROM dvazebtab as V WHERE V.idtaba = ZAZNAM.idtaba and V.modula = ZAZNAM.modula and V.typvazbyk = 'typVazbyDokl.hlavaDobropis' and ZAZNAM.idvazby <> V.idvazby;
      if (vazeb = 0) then
        UPDATE ddoklfak SET dobropisovano = false WHERE iddoklfak = ZAZNAM.idtaba and modul = ZAZNAM.modula and dobropisovano = true;
      end if;
    else
      UPDATE ddoklfak SET dobropisovano = true WHERE iddoklfak = NEW.idtaba and modul = NEW.modula and dobropisovano = false;
    end if;
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dvazebtabinsdeldobropis() OWNER TO %firmaRole%;

-- DROP TRIGGER dvazebtabinsdeldobropis ON dvazebtab;
CREATE TRIGGER dvazebtabinsdeldobropis
  AFTER INSERT OR DELETE
  ON dvazebtab
  FOR EACH ROW
  EXECUTE PROCEDURE dvazebtabinsdeldobropis();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 843, 't', %appVersion%, clock_timestamp());
