--------------------------------------------------------------------------------
-- Bug 39343  [Bug] Dobropis + jin sklad, ne ze kterho bylo vyskladnno
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpoldoklupdatesklad() RETURNS trigger AS
$BODY$
declare
  _idPolDokl integer;
  _idDoklad integer;
  _idPolSklad integer;
  _idDoklSklad integer;
  _dokladGenerovatSkl boolean;
  _typDoklGenerovatSkl boolean;
  _typZasobyK character varying;
  _skladove boolean;
  _vyrobniCislo record;
  _typPohybuK character varying;
  _sadaItemCount integer;
  _vypnutySklad character varying; 
  _typDoklK character varying;
  _idPolSkladProPrepocetDokladu integer;
  _idPolSkladPuvodni integer;
  _idDoklSkladPuvodni integer;
  _pocetPolozekSklDokl integer;
  _datUcto date;
  _idPolSkladDobropis integer;
begin
  select getglotxvariable('vypniSklad') into _vypnutySklad;
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then
    --raise exception 'sem sem se nemel dostat';
    if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then
      return NEW;
    end if;

    _typDoklK = '';

    if(NEW.modul like 'POK') then
      _idPolDokl = NEW.idPolInt;
      _idDoklad = NEW.idDoklInt;
      select generovatSkl, datUcto into _dokladGenerovatSkl, _datUcto from dDoklInt where idDoklInt = NEW.idDoklInt;
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt);
    elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then
      _idPolDokl = NEW.idPolFak;
      _idDoklad = NEW.idDoklFak;
      select generovatSkl, datUcto into _dokladGenerovatSkl, _datUcto from dDoklFak where idDoklFak = NEW.idDoklFak;
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak);
    else 
      return NEW;  
    end if;

    -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace
    -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu
    if((not compareId(NEW.idBspSkl, OLD.idBspSkl)
       or not compareId(NEW.idCenik, OLD.idCenik)
       or not compareVarchar(NEW.typPolozkyK, OLD.typPolozkyK)
       or NEW.mnozMj <> OLD.mnozMj
       or not compareVarchar(NEW.sarze, OLD.sarze)
       or not compareDate(NEW.expirace, OLD.expirace)
       )
       and _dokladGenerovatSkl and NEW.zdrojProSkl) then  
           
      -- Bug 38144  [FlexiBee] Pi zmn skladu zstane doklad bez hlaviky (emeldi) (P2)
      if (not compareId(NEW.idBspSkl, OLD.idBspSkl)) then
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSkladPuvodni;
        select idDoklSklad into _idDoklSkladPuvodni from dPolSklad where idPolSklad = _idPolSkladPuvodni;
      end if;
      
      --raise exception 'mazu polSklad';
      execute deleteNavazanePolSklad(_idPolDokl, NEW.modul);
      
      -- Bug 38144  [FlexiBee] Pi zmn skladu zstane doklad bez hlaviky (emeldi) (P2)
      if (not compareId(NEW.idBspSkl, OLD.idBspSkl)) then
        -- Vyma skladov doklad pokud zstal po zmn skladu na poloce przdn.
        -- ( zmna skladu = pehozen poloky na nov skladov doklad, resp. na ji existujc doklad pro nov sklad )
        -- Oekvme, e se vznikl dra pouije pro nov vytven doklad, ppadn zstane voln pro pt pouit.
        SELECT count(*) into _pocetPolozekSklDokl from dPolSklad where idDoklSklad = _idDoklSkladPuvodni;
        
        if _pocetPolozekSklDokl = 0 then
          DELETE from dVazebTab where modulA = NEW.modul and idTabA = _idDoklad and modulB = 'SKL' and idTabB = _idDoklSkladPuvodni and typVazbyK = 'typVazbyDokl.hlavaSkl';   
          DELETE from dDoklSklad where idDoklSklad = _idDoklSkladPuvodni;
        elseif _pocetPolozekSklDokl > 0 then
          -- Po vmazu poloky pi zmn skladu je teba pepotat pvodn (neprzdn) doklad.
          EXECUTE sprepoctiSumyDokladu(_idDoklSkladPuvodni);
        end if;
      end if;
    end if;

    if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then  
      select skladove into _skladove from cCenik where idCenik = NEW.idCenik;
    
      if (_skladove and NEW.idBspSkl is not null) then
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;
        if(_idPolSklad is null) then
          if(NEW.idPolDobropis is not null and NEW.idPolDobropis > 0) then 
            -- kdyz je to dobropis 
            select idtabb into _idPolSkladDobropis from dvazebtab  
                where idtaba = NEW.idPolDobropis and modulA = NEW.modul and modulB = 'SKL'  
              and typVazbyK = 'typVazbyDokl.polozkaSkl'; 
            if(_idPolSkladDobropis is not null) then 
               -- z dobropisovane polozky byl vygenerovan skladovy doklad nesadovy 
               select createpolskladdobropis(_idPolSkladDobropis, _idPolDokl, NEW.modul, 'typVazbyDokl.polozkaSkl') into _idPolSklad; 
            else 
               -- pripadne zohledneni vsech sadovych rozpadu 
               for _idPolSkladDobropis in (select idtabb from dvazebtab  
                 where idtaba = NEW.idPolDobropis and modulA = NEW.modul and modulB = 'SKL'  
                     and typVazbyK = 'typVazbyDokl.polozkaSklSada') loop 
                 select createpolskladdobropis(_idPolSkladDobropis, _idPolDokl, NEW.modul, 'typVazbyDokl.polozkaSklSada') into _idPolSklad; 
               end loop; 
            end if; 
          else
            --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
            if(_sadaItemCount > 0) then
              execute createPolSkladSada(_idPolDokl, NEW.modul);
            else
              select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
            end if;
          end if;
        else
          if(_sadaItemCount > 0) then
            execute fillPolSkladSada(_idPolDokl, NEW.modul);
          else
            select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad; 
          end if;
        end if;
        -- provedeni upgradu vyrobnich cisel
        if((NEW.modul like 'FAV' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAP' and _typDoklK like 'typDokladu.dobropis')) then
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
          end loop;
        end if;
        if((NEW.modul like 'FAP' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAV' and _typDoklK like 'typDokladu.dobropis')) then
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
          end loop;
        end if;
        if(NEW.modul like 'POK') then
          select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad;
          if(_typPohybuK like 'typPohybu.prijem') then
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop
              update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
            end loop;
          else
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop
              update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
            end loop;
          end if;
        end if;

      end if;
      -- prepocteni sum na dokladu
      --select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad;
      select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSkladProPrepocetDokladu;
      select idDoklSklad into _idDoklSklad from dPolSklad where idPolSklad = _idPolSkladProPrepocetDokladu;
      if(NEW.datVyst >= '2014-01-01') then
        execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst, _datUcto);
      else
        execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst, NEW.datVyst);
      end if;
    end if;
  end if;

  return NEW;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION createpolskladdobropis(_iddobropisovanepolsklad integer, _iddobropisujicipoldokl integer, _modul character varying, _typVazbyK character varying)
  RETURNS integer AS
$BODY$ 
declare
  _idPolSklad integer;
  _idDoklad integer;
  _idDoklSklad integer; 
  _dobropisovanaPolSklad record;
  _kopZakazku boolean;
  _kopStred boolean;
  _kopCinnost boolean;
  _polDokl record;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _iducetobdobi integer;
  _idkarty integer;
  _mnozMj numeric(19,6); 
  _pomer numeric(19,12);
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _mnozMjDobropisovane numeric(19,6);
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _idMeny integer;
  _idTypUcOp integer; 
  _kurz numeric(19,6); 
  _ciziMena boolean;
  _typPohybuK character varying;
  _nasobic numeric(19,6);
  _skupZboz record;
  _datUcto date;
  _idBspSkl integer; 
begin
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _iddobropisujicipoldokl;
    _idDoklad = _polDokl.idDoklFak;
    select mnozMj into _mnozMjDobropisovane from dPolFak where idPolFak = _polDokl.idPolDobropis;
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad;
  else 
    select * into _polDokl from dPolInt where idPolInt = _iddobropisujicipoldokl;
    _idDoklad = _polDokl.idDoklInt;
    select mnozMj into _mnozMjDobropisovane from dPolInt where idPolInt = _polDokl.idPolDobropis;
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad;
  end if; 

  if(_polDokl.datVyst >= '2014-01-01') then
    _datUcto = _polDokl.datUcto;
    if(_datUcto is null) then
      _datUcto = _polDokl.datVyst;
    end if;
  else
    _datUcto = _polDokl.datVyst;
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true, _polDokl.idBspSkl) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_iddobropisujicipoldokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then 
      return null; 
    end if; 
  end if; 

  select * into _dobropisovanaPolSklad from dpolsklad where idpolsklad = _iddobropisovanepolsklad;
  select idstred, idcinnost, idZakazky, idMeny
      into _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad, _idMeny 
      from dDoklSklad where idDoklSklad = _idDoklSklad;  

  select findIdUcetniObdobiKDatu(_datUcto) into _iducetobdobi; 
  _idBspSkl = _dobropisovanaPolSklad.idbspskl; -- puvodni stav
  _idBspSkl = _polDokl.idBspSkl; -- dle Bug 39343  [Bug] Dobropis + jin sklad, ne ze kterho bylo vyskladnno
  select idkarty into _idkarty from skarty where idcenik = _dobropisovanaPolSklad.idcenik and idskladu = _idBspSkl and iducetobdobi = _iducetobdobi;
  if(_idkarty is null) then
    raise exception 'idkarty je null protoze neexistuje skladova karta pro ucetni obdobi';
  end if;
  
  _nasobic = 1;
  if(_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej')then
    _nasobic = -1;
  end if;
  if(_dobropisovanaPolSklad.mnozMj = 0) then
    _mnozMj = _nasobic * _dobropisovanaPolSklad.mnozMjPlan; 
  else
    _mnozMj = _nasobic * _dobropisovanaPolSklad.mnozMj; 
  end if;
  _sumZkl = _nasobic * _dobropisovanaPolSklad.sumZkl;
  
  if((-1 * _polDokl.mnozMj) <> _mnozMjDobropisovane) then
    _pomer = -1 * _polDokl.mnozMj / _mnozMjDobropisovane;
    _mnozMj = _mnozMj * _pomer;
    _sumZkl = _sumZkl * _pomer;
  end if;
  --raise exception '% % %', _polDokl.mnozMj, _mnozMjDobropisovane, _mnozMj;
  -- zohledneni meny
  select ismenacizi(_idMeny, _polDokl.datvyst) into _ciziMena;
  if(_ciziMena) then
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
    _sumZklMen = _sumZkl / _kurz;
    _cenaMj = _sumZklMen / _mnozMj;
  else
    _sumZklMen = 0.0;
    _cenaMj = _sumZkl / _mnozMj;
  end if;
    
  _kopStred = true; 
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
    _kopStred = false; 
  end if; 
  _kopCinnost = true; 
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
    _kopCinnost = false; 
  end if; 
  _kopZakazku = true; 
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
    _kopZakazku = false; 
  end if;  

  select idprimucet into _idZklMdUcet from dbsp where idbsp = _idBspSkl;
  _kopZklMdUcet = false;

  _kopZklDalUcet = false;
  if(_modul like 'FAV') then
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _dobropisovanaPolSklad.idCenik); 
    if(_skupZboz.idProtiUcetSklV is not null) then 
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false; 
      _idZklDalUcet = _skupZboz.idProtiUcetSklV; 
    else 
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
      select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
      _kopZklDalUcet = true;
    end if; 
  else
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if;

  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, kopDatUcto, modul, typPolozkyK, idDoklSklad, 
      mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
      nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni, eanKod,  
      idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp,
      idPolDobropis) 
    values (_idPolSklad, LOCALTIMESTAMP, _dobropisovanaPolSklad.idcenik, _idBspSkl, _idkarty, _polDokl.datVyst, /*_dobropisovanaPolSklad.datSklad + interval '0.000001'*/ LOCALTIMESTAMP, _datUcto, _polDokl.kopDatUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad, 
      _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _dobropisovanaPolSklad.idmj, 
      _dobropisovanaPolSklad.nazev, _dobropisovanaPolSklad.nazevA, _dobropisovanaPolSklad.nazevB, _dobropisovanaPolSklad.nazevC, _dobropisovanaPolSklad.sarze, _dobropisovanaPolSklad.expirace, _dobropisovanaPolSklad.datTrvan, _dobropisovanaPolSklad.datVyroby, _dobropisovanaPolSklad.cisRad, true, _dobropisovanaPolSklad.eanKod, 
      _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp,
      _iddobropisovanepolsklad); 

  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _iddobropisujicipoldokl, _idPolSklad, _modul, 'SKL', false, _typVazbyK); 

  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 

  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createpolskladdobropis(integer, integer, character varying, character varying) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 858, 't', %appVersion%, clock_timestamp());
