--------------------------------------------------------------------------------
-- Bug 40239 - [Bug] Sada s položkou s množstvím 0 (edit) 
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dgetstavnaskladeaktualni(i_idcenik integer, i_idsklad integer, i_datum date)
  RETURNS numeric AS
$BODY$       
declare      
  _iducetniobdobi integer;  
  _stavMj numeric(19,6);      
  _idSkladKarty integer;  
  _sadaItemCount integer;  
  _polozkaSady record;  
  _stavSkladuSady numeric(19,6);  
  _pocetPozadavku numeric(19,6);
  _skladove boolean; 
begin      
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet  
  select count(*) into _sadaItemCount from csady where idceniksada = i_idCenik;  
  if(_sadaItemCount = 0) then
    -- pokud se nejedna o sadu tak funguju normalne  
    select skladove into _skladove from ccenik where idcenik = i_idcenik;
    if(_skladove) then
      -- zkusime vypocitat stav na vrcholu  
      select idUcetObdobi into _iducetniobdobi from nUcetObdobi where platiOdData <= i_datum and platiDoData >= i_datum;
      select idKarty into _idSkladKarty from sKarty where idCenik = i_idCenik and idSkladu = i_idsklad and idUcetObdobi = _iducetniobdobi;  
      select stavMj into _stavMj from skarty where idkarty = _idSkladKarty;  
      select sum(mnozMjPlan) into _pocetPozadavku from dpolsklad where mnozMjPlan <> 0.0 and mnozMj = 0.0 and idkarty = _idSkladKarty and storno = false;
      if(_pocetPozadavku is not null) then
        _stavMj = _stavMj - _pocetPozadavku;
      end if;
    else  
      _stavMj = 9999999999999.0; -- vic uz pretejka
    end if;
  else
    --pokud se jedna o sadu spoustim rekurzi
    for _polozkaSady in  
      select * from cSady where idCenikSada = i_idCenik  
    loop  
      select dGetStavNaSkladeAktualni(_polozkaSady.idCenik, i_idsklad, i_datum) into _stavSkladuSady;
      if(_polozkaSady.mnozMj <> 0) then
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj;
        if(_stavMj is null) then  
          _stavMj = 9999999999999.0; -- vic uz pretejka  
        end if;  
        select minValue(_stavMj, _stavSkladuSady) into _stavMj;  
      end if;
    end loop;  
  end if;   
   
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni   
  if(_stavMj is null) then   
    _stavMj := 0;   
  end if;   
     
  RETURN _stavMj;       
end       
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnaskladeaktualni(integer, integer, date) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 870, 't', %appVersion%, clock_timestamp());
