--------------------------------------------------------------------------------
-- Bug 40283 - [Bug] Smazání dobropisu nesmaže příjemku (edit)  
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpoldoklinsertsklad() RETURNS trigger AS
$BODY$
declare
  pocetNavazanychDokladu integer;
  _idPolFak integer;
  _idDoklFak integer;
  _idPolSklad integer;
  _dokladGenerovatSkl boolean;
  _typDoklGenerovatSkl boolean;
  _typZasobyK character varying;
  _skladove boolean;
  _sadaItemCount integer; 
  _cenaMjNakup numeric(19,6);  
  _typDoklK character varying;
  _idPolDobropis integer;
  _idPolSkladDobropis integer;
begin

  if(NEW.typPolozkyK like 'typPolozky.katalog') then 
    if(NEW.modul like 'POK') then 
      _idPolFak = NEW.idPolInt; 
      _idDoklFak = NEW.idDoklInt; 
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt; 
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolint where idpolint = NEW.idPolInt); 
    else 
      _idPolFak = NEW.idPolFak; 
      _idDoklFak = NEW.idDoklFak; 
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak; 
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
    end if; 
 
    select skladove into _skladove from cCenik where idCenik = NEW.idCenik;

    if(NEW.idBspSkl is not null and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.idPolDobropis is not null and NEW.idPolDobropis > 0) then
      -- kdyz je to dobropis
      if(NEW.modul like 'POK') then 
        _idPolFak = NEW.idPolInt; 
      else
        _idPolFak = NEW.idPolFak; 
      end if;
      select idtabb into _idPolSkladDobropis from dvazebtab 
          where idtaba = NEW.idPolDobropis and modulA = NEW.modul and modulB = 'SKL' 
                and typVazbyK = 'typVazbyDokl.polozkaSkl';
      if(_idPolSkladDobropis is not null) then
        -- z dobropisovane polozky byl vygenerovan skladovy doklad nesadovy
        select createpolskladdobropis(_idPolSkladDobropis, _idPolFak, NEW.modul, 'typVazbyDokl.polozkaSkl') into _idPolSklad;
      else
        -- pripadne zohledneni vsech sadovych rozpadu
        for _idPolSkladDobropis in (select idtabb from dvazebtab 
          where idtaba = NEW.idPolDobropis and modulA = NEW.modul and modulB = 'SKL' 
                and typVazbyK = 'typVazbyDokl.polozkaSklSada') loop
          select createpolskladdobropis(_idPolSkladDobropis, _idPolFak, NEW.modul, 'typVazbyDokl.polozkaSklSada') into _idPolSklad;
        end loop;
      end if;
    else
      if (_skladove and NEW.idBspSkl is not null
        and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then
        select count(*) into pocetNavazanychDokladu from dvazebtab where
          typVazbyK like 'typVazbyDokl.hlavaSkl'
          and (
          (idTabA = _idDoklFak and modulA like NEW.modul)
          or
          (idTabB = _idDoklFak and modulB like NEW.modul));

        --if(pocetNavazanychDokladu > 1) then
          --neco jeste nevim co
        --else
          if(_sadaItemCount > 0) then
            execute createPolSkladSada(_idPolFak, NEW.modul);
          else
            select createPolSklad(_idPolFak, NEW.modul) into _idPolSklad; 
          end if;
        --end if;
  
        execute putglotxvariable('vypniSklad', 'true');
        if(NEW.modul = 'FAV' and _typDoklK != 'typDokladu.dobropis') then
          select skladGetCenaMjNakup(_idPolFak, NEW.modul, NEW.mnozMj) into _cenaMjNakup;
          update dpolfak set cenaMjNakup = _cenaMjNakup where idpolfak = _idPolFak;
        elsif(NEW.modul = 'POK') then
          select skladGetCenaMjNakup(_idPolFak, NEW.modul, NEW.mnozMj) into _cenaMjNakup;
          update dpolint set cenaMjNakup = _cenaMjNakup where idpolint = _idPolFak;
        end if;
        execute removeglotxvariable('vypniSklad');
      end if;
    end if; 
  end if;
 
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklinsertsklad() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 871, 't', %appVersion%, clock_timestamp());
