-- Bug 41932 - Přepočet skladu při FIFO počítá i s příjemkami z jiného účetního období II.

drop view dpolskladf;

CREATE OR REPLACE VIEW dpolskladf AS 
         SELECT p.idpolsklad, 
                CASE
                    WHEN p.typpohybuk::text = 'typPohybu.prijem'::text THEN p.mnozmj - jevydano(p.idpolsklad)
                    ELSE (- p.mnozmj) - jevydano(p.idpolsklad)
                END AS pocet, p.cenamj, p.datvyst, p.datsklad, p.dattrvan, p.datvyroby, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, NULL::integer AS idvyrobnicislo, c.evidvyrcis, c.evidSarze, c.evidexpir, p.typpohybuk, p.cenamjtuz, p.idkarty
           FROM dpolskladdoklad p
      JOIN ccenik c ON c.idcenik = p.idcenik
     WHERE (p.typpohybuk::text = 'typPohybu.prijem'::text AND p.mnozmj >= 0.0 AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric OR p.typpohybuk::text = 'typPohybu.vydej'::text AND p.mnozmj < 0.0 AND ((- p.mnozmj) - jevydano(p.idpolsklad)) > 0::numeric) AND c.evidvyrcis = false AND p.storno <> true
UNION ALL 
         SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.datsklad, p.dattrvan, p.datvyroby, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo, c.evidvyrcis, c.evidSarze, c.evidexpir, p.typpohybuk, p.cenamjtuz, p.idkarty
           FROM svyrobnicislo v
      JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolskladprijem
   JOIN ccenik c ON c.idcenik = p.idcenik
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND c.evidvyrcis = true  AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
         FROM sfifovazby
        WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;
ALTER TABLE dpolskladf OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric, _cenyRucne boolean, _prepocitatDobropis boolean)
  RETURNS void AS
$BODY$     
declare      
  _zaznam Record;      
  _vybrano numeric(19,6);    
  _i integer;    
  _novevydcelkem numeric(19,6);    
  _pocet numeric(19,6);    
  _cenamjP numeric(19,6); 
  _cenaMjPomoc numeric(19,6);
  _sumZklP numeric(19,2);
  _cenaMjPMen numeric(19,6); 
  _kurzDokladuP numeric(19,6);  
  _kurzDokladuV numeric(19,6);  
  _idDoklSkladP integer;   
  _idDoklSkladV integer;  
  _datVystV date;  
  _idrozlozeni integer;    
  _vydexpir boolean;    
  _vyrcis character varying(255);    
  _sklfifo boolean; 
  _sarze character varying(255); 
  _expirace date;      
  _evidVyrCis boolean;   
  _typPohybuK character varying(255);
  _sumZklVysl numeric(19,6);

  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _cenaMj numeric(19,6);
begin      
  -- pokud ma byt vydane mnozstvi 0.0 tak i cena byt tomu mela odpovidat -> 0.0  
  -- a tim samozrejme skoncime
  if(vyd = 0.0) then
    update dpolsklad set
      lastUpdate = LOCALTIMESTAMP, 
      cenaMj = 0.0,
      sumZkl = 0.0,
      sumZklMen = 0.0
      where idPolSklad = idvydej;
    return;
  end if;

  -- pokud se sem dostane zaporna vydejka tak to je jako prijemka a nefifuje se
  select ds.typpohybuk, ps.datVyst, sarze,  expirace,  ps.iddoklsklad 
      into _typPohybuK, _datVystV,  _sarze, _expirace, _idDoklSkladV 
      from ddoklsklad ds join dpolsklad ps on ds.iddoklsklad = ps.iddoklsklad and ps.idpolsklad = idvydej;
  if(_typPohybuK = 'typPohybu.vydej' and vyd < 0.0) then
    return;
  end if;

  _vybrano := 0;    
  _i := 1;    
  _novevydcelkem := vyd;    
  -- vynásobím -1, aby se s tím snáze pracovalo - aby se mi snáze podařilo získat správnou cenu 
  if(_prepocitatDobropis and _typPohybuK = 'typPohybu.prijem' and _noveVydCelkem < 0.0) then
	_novevydcelkem := (-1) * _noveVydCelkem;
  end if;
  _sumZklVysl = 0.0;
  _sklfifo := (select isfifosklad(_datVystV));      
  _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   

  -- pro polozky na kterych se eviduji vyrobni cisla je samostatny trigger na vyrobnich cislech
  select evidVyrCis into _evidVyrCis from ccenik where idcenik = idcenikvydej; 
  if (not _evidVyrCis) then 
    select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1; 

    if (not _vydexpir) then
      --pořadí výdeje dle datvyst (dále se bude řesit upřednostněný výdej mimo FIFO)
-- napřed nás zajímají ty nejstarší podle účetního období skladové karty, až pak budeme řadit podleDatSklad
      for _zaznam in select * from dPolSkladF psf 
          inner join skarty k on psf.idkarty = k.idkarty
          inner join nucetobdobi uo on k.iducetobdobi = uo.iducetobdobi
          where psf.idCenik=idCenikVydej and psf.idSkladu=idSkladVydej 
          order by uo.platioddata, psf.datSklad,psf.idpolsklad loop
        if(not _zaznam is null) then
          -- pokud je nejaka sarze nebo expirace musime vyfiltrovat danou sarzi nebo expiraci pokud ne tak nas to netrapi
          if((_sarze is null or _sarze ~ '^\s*$' or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then
            -- pokud je doted rozfifovane mnozstvi mensi nez celkove ktere ma byt vydano
            if(_vybrano<_novevydcelkem) then
              _pocet := _zaznam.pocet;
              if( _vybrano+_pocet) > _novevydcelkem then
                _pocet := _novevydcelkem-_vybrano;
              end if;
              _vybrano := _vybrano+_pocet;
              
              if (_sklfifo and not _cenyRucne) then
                -- pokud se jedna o fifo sklad musime spravne fifalne urcit cenu
                select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);    
                select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);   
                if (_kurzDokladuP <> 0.0) then 
                  _cenamjP := _cenamjP * _kurzDokladuP;    
                end if;

                _cenaMjPomoc := _cenaMjP;

                _cenamjP := _cenamjP / _kurzDokladuV; 
                _cenaMjPMen := 0.0; 
                if(_kurzDokladuV <> 1.0) then 
                  _cenaMjPMen := _cenaMjP; 
                end if; 
                _sumZklP = _pocet*_cenamjP*_kurzDokladuV;

                if(_zaznam.pocet = _pocet) then
                  select (case when _zaznam.typPohybuK = 'typPohybu.vydej' then -pp.sumZkl else pp.sumZkl end)
                     - coalesce(((select sum(round(kusu * _cenaMjPomoc, 2)) from sfifoVazby where idpolskladprijem = _zaznam.idpolsklad)), 0.0)
                    into _sumZklP
                  from dpolsklad pp where idpolsklad = _zaznam.idpolsklad;
                else  
                end if;

                _sumZklVysl = _sumZklVysl + _sumZklP;
              end if;  
              insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo);
            else
              if (_vybrano>_novevydcelkem) then
                _pocet := -_zaznam.pocet;
                if(( _vybrano+_pocet) < _novevydcelkem) then
                  _pocet := _novevydcelkem-_vybrano;
                end if;
                _vybrano := _vybrano+_pocet;
                insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;  
              end if;
            end if;
          end if;
        end if;
      end loop;
    else      
      --pořadí výdeje dle expirace (dále se bude řesit upřednostněný výdej mimo FIFO)      
      for _zaznam in select * from dPolSkladF psf 
          inner join skarty k on psf.idkarty = k.idkarty
          inner join nucetobdobi uo on k.iducetobdobi = uo.iducetobdobi
          where psf.idCenik=idCenikVydej and psf.idSkladu=idSkladVydej 
          order by uo.platioddata, psf.expirace, psf.idpolsklad loop        
        if(not _zaznam is null) then 
          -- pokud je nejaka sarze nebo expirace musime vyfiltrovat danou sarzi nebo expiraci pokud ne tak nas to netrapi
          if((_sarze is null or _sarze ~ '^\s*$' or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then
            -- pokud je doted rozfifovane mnozstvi mensi nez celkove ktere ma byt vydano
            if(_vybrano<_novevydcelkem) then
              _pocet := _zaznam.pocet;
              if( _vybrano+_pocet) > _novevydcelkem then
                _pocet := _novevydcelkem-_vybrano;
              end if;
              _vybrano := _vybrano+_pocet;
              
              if (_sklfifo and not _cenyRucne) then
                -- pokud se jedna o fifo sklad musime spravne fifalne urcit cenu
                select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);      
                select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);     
                if (_kurzDokladuP <> 0.0) then   
                  _cenamjP := _cenamjP * _kurzDokladuP;      
                end if;

                _cenaMjPomoc := _cenaMjP;

                _cenamjP := _cenamjP / _kurzDokladuV;   
                _cenaMjPMen := 0.0;   
                if(_kurzDokladuV <> 1.0) then   
                  _cenaMjPMen := _cenaMjP;   
                end if;   
                _sumZklP = _pocet*_cenamjP*_kurzDokladuV;

                if(_zaznam.pocet = _pocet) then
                  select (case when _zaznam.typPohybuK = 'typPohybu.vydej' then -pp.sumZkl else pp.sumZkl end)
                     - coalesce(((select sum(round(kusu * _cenaMjPomoc, 2)) from sfifoVazby where idpolskladprijem = _zaznam.idpolsklad)), 0.0)
                    into _sumZklP
                  from dpolsklad pp where idpolsklad = _zaznam.idpolsklad;
                else  
                end if;                


                _sumZklVysl = _sumZklVysl + _sumZklP;
              end if;  
              insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo);
            else
              if (_vybrano>_novevydcelkem) then
                _pocet := -_zaznam.pocet;
                if(( _vybrano+_pocet) < _novevydcelkem) then
                  _pocet := _novevydcelkem-_vybrano;
                end if;
                _vybrano := _vybrano+_pocet;
                insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;  
              end if;
            end if;
          end if;
        end if;
      end loop;
    end if;
  end if;
  
  -- nakonec nastavime spravne ceny na vydejce
  if((_typPohybuK = 'typPohybu.vydej' or (_prepocitatDobropis and _typPohybuK = 'typPohybu.prijem' and vyd < 0.0) ) and _sklfifo and not _cenyRucne) then
    -- _sumZklVysl - v případě dobropisu by mělo být záporné (ale pro snažší získání ceny jsem si na úvod změnila znaméno _novevydcelkem, proto si to znaménko změním ještě jednou) -> * (-1)
    if(_prepocitatDobropis and vyd < 0.0) then
	_sumZklVysl = (-1) * _sumZklVysl;
    end if;
    _sumZkl := _sumZklVysl;
    _sumZklMen := 0.0;
    _cenaMj = _sumZklVysl / vyd;
    if(_kurzDokladuV <> 1.0) then
       _sumZklMen := _sumZklVysl / _kurzDokladuV;
       _sumZkl := _sumZklVysl;
       _cenaMj := _sumZklMen / vyd;
    end if;
    update dpolsklad set
      lastUpdate = LOCALTIMESTAMP, 
      sumZkl = _sumZkl,
      sumZklMen = _sumZklMen,
      cenaMj = _cenaMj
      where idpolsklad = idvydej;
  end if;    
end;      
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric, boolean, boolean) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 911, 't', %appVersion%, clock_timestamp());
