--Bug 42238 - Řešení unikátnosti výrobních čísel - REST API

CREATE FUNCTION svyrobnicislohlavduplicitycheck() RETURNS trigger AS $$
BEGIN
    --kontrolu provedu pouze pokud u zboží evidujeme výrobní čísla a požadujeme jejich unikátnost
    IF EXISTS (select 1 from ccenik where idcenik = NEW.idCenik and evidvyrcis = true and unikvyrcis = true)  THEN
    
        --duplicita se kontroluje v rámci stejného zboží
        IF EXISTS (select 1 from svyrobnicislohlav where kod = NEW.kod and idcenik = NEW.idCenik) THEN
            RAISE EXCEPTION '0010: Duplicitní výrobní číslo::%', NEW.kod;
        END IF;
        
    END IF;
    
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER svyrobnicislohlavduplicitycheck 
    BEFORE INSERT OR UPDATE ON svyrobnicislohlav
    FOR EACH ROW
    EXECUTE PROCEDURE svyrobnicislohlavduplicitycheck();
	
-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 924, 't', %appVersion%, clock_timestamp());
