-- Bug 13645 – [WinStrom] Podpora elektronického formátu faktury ISDOC
-- Přidání tabulky pro ukládání příloh k dokladům

CREATE SEQUENCE seq_dprilohy
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_dprilohy OWNER TO %firmaRole%;

CREATE TABLE dprilohy
(
  idprilohy integer DEFAULT nextval('seq_dprilohy'::regclass) NOT NULL,
  iddoklad integer NOT NULL DEFAULT 0,
  modul character varying(3) NOT NULL,
  priloha oid,
  CONSTRAINT dprilohy_pkey PRIMARY KEY (idprilohy)
);
ALTER TABLE dprilohy OWNER TO %firmaRole%;


-- Trigger mazající přílohy při smazání dokladu
CREATE OR REPLACE FUNCTION ddoklfakdeleteprilohy()
  RETURNS trigger AS $$
begin
  delete from dprilohy where modul = OLD.modul and idDoklad = OLD.idDoklFak;
  
  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklfakdeleteprilohy() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulky dokladů
CREATE TRIGGER ddoklfakdeleteprilohy AFTER DELETE ON ddoklfak
  FOR EACH ROW EXECUTE PROCEDURE ddoklfakdeleteprilohy();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 96, 't');
