--------------------------------------------------------------------------------------------------------------------
-- Bug 44511 - V daňové evidenci se na bance a pokladně chybně plní sloupec zaúčtováno
--------------------------------------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION isdokladzuctovan(iddokl integer, doklpostfix character varying) RETURNS boolean
    AS $$ 
declare 
  _modul varchar(100);
  _podvojucto boolean; 
  _ucetni boolean; 
  _storno boolean; 
  _bezpol boolean; 
  _datUcto date;  
  _doklOk integer; 
  _polozek integer; 
  _polOk integer; 
  _idDoklVazbaArray integer[]; 
  _idPolVazbaArray integer[]; 
  _idPolVazbaArrayCnt integer; 
  _idPolVazbaArrayCntOk integer; 
  idDoklColumn varchar(100); 
  doklTable varchar(100); 
  polTable varchar(100); 
begin 
  idDoklColumn := 'idDokl' || doklPostfix; 
  doklTable := 'dDokl' || doklPostfix; 
  polTable := 'dPol' || doklPostfix; 
 
  execute 'select modul, datUcto, ucetni, bezpolozek, storno from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl 
   into _modul, _datUcto, _ucetni, _bezpol, _storno; 
  execute 'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl into _polozek; 
  _doklOk := 0; 
 
  if (_ucetni = true and _storno = false) then 
    -- zjistime zda firma vede ucetnictvi 
    select podvojucto into _podvojucto from nNastav where PlatiOdData <= _datUcto order by PlatiOdData desc limit 1; 
    if (_podvojucto is null) then 
      select podvojucto into _podvojucto from nNastav where PlatiOdData is null limit 1;  
    end if; 
 
    if (_podvojucto = true) then 
      -- ucetnictvi 
      if (_bezpol = true or _polozek = 0) then 
	if (_modul = 'INT') then
          execute
            'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and
              idstred is not null and datucto is not null and
              ((sumosv = 0 and sumzklsniz = 0 and sumzklzakl = 0) or idprimucet is not null) and
              ((sumosv = 0 and sumzklsniz = 0 and sumzklzakl = 0) or idprotiucet is not null) and
              ((sumdphsniz = 0 and sumdphzakl = 0) or (iddphsnizucet is not null and iddphzaklucet is not null))'
            into _doklOk;
	else
          execute
            'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and
              idstred is not null and datucto is not null and
              ((sumcelkem = 0) or idprimucet is not null) and
              ((sumosv = 0 and sumzklsniz = 0 and sumzklzakl = 0) or idprotiucet is not null) and
              (sumdphsniz = 0 or iddphsnizucet is not null) and
              (sumdphsniz2 = 0 or iddphsniz2ucet is not null) and 
              (sumdphzakl = 0 or iddphzaklucet is not null)'
            into _doklOk;
	end if;
      else 
        execute 
          'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and 
            (ucetni = false or  
            (idstred is not null and datucto is not null and
              (sumZkl = 0 or (idzkldalucet is not null and idzklmducet is not null)) and
              (modul = ''SKL'' or typszbdphk is null or typszbdphk = ''typSzbDph.dphOsv'' or sumDph = 0 or (
                iddphmducet is not null and iddphdalucet is not null))))' 
          into _polOk; 
        if (_polOk = _polozek) then 
          _doklOk := 1; 
        end if; 
      end if; 
    else 
      -- danova evidence 
      if (doklTable = 'dDoklFak' or doklTable = 'dDoklInt') then 
        if (_bezpol = true or _polozek = 0) then 
          execute 'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' 
            and datucto is not null and danevidk is not null' into _doklOk; 
        else 
          execute 'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' 
            and (ucetni = false or (datucto is not null and danevidk is not null))' into _polOk; 
          if (_polOk = _polozek) then
            _doklOk := 1;
          end if;
        end if; 
        
        --uhrada je zauctovana pokud jsou vsechny polozky vsech navazanych faktur zauctovany
        _idPolVazbaArrayCnt := 0;
        _idPolVazbaArrayCntOk := 0;
        if (doklTable = 'dDoklInt' and _doklOk != 1) then

          -- navazane faktury
          _idDoklVazbaArray := array(select idTabA from dVazebTab where idTabB = idDokl and typVazbyK in ('typVazbyDokl.uhrada'));
          if (coalesce(array_upper(_idDoklVazbaArray, 1), 0) != 0) then
           
            --navazane polozky
            _idPolVazbaArray := array(select idpolfak from dpolfak where iddoklfak = any(_idDoklVazbaArray));
            _idPolVazbaArrayCnt := coalesce(array_upper(_idPolVazbaArray, 1), 0);
            
            --zda jsou vsechny polozky zauctovane
            if (_idPolVazbaArrayCnt != 0) then
              _idPolVazbaArrayCntOk := (select count(*) from dpolfak where danevidk is not null and idpolfak = any(_idPolVazbaArray));
              if (_idPolVazbaArrayCnt = _idPolVazbaArrayCntOk) then
                _doklOk := 1;
              end if;
            end if;
            
          end if;
        end if;
        
      end if; 
    end if; 
  end if; 
   
  return (_doklOk = 1); 
end;  
$$
    LANGUAGE plpgsql;
ALTER FUNCTION public.isdokladzuctovan(iddokl integer, doklpostfix character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dvazebtabinsertdeletedanevid()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
  _idDoklInt integer;
  _zuctovanoNew boolean;
  _zuctovanoOld boolean;
begin
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;
  _idDoklInt := null;
  
  if (ZAZNAM.typvazbyk in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY', 'typVazbyDokl.vazbaZDD', 'typVazbyDokl.zaucProdejky')) then
    _idDoklInt := ZAZNAM.idTabB;
  end if;
  if (ZAZNAM.typvazbyk = 'typVazbyDokl.odpocetZALOHY') then
    select idTabB into _idDoklInt from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA = ZAZNAM.idTabB;
  end if;
  
  if (_idDoklInt is not null) then
    _zuctovanoOld := (select zuctovano from ddoklint where iddoklint = _idDoklInt);
    select isDokladZuctovan(_idDoklInt, 'Int') into _zuctovanoNew;

    if (_zuctovanoOld <> _zuctovanoNew) then
      update ddoklint set zuctovano = _zuctovanoNew where idDoklInt = _idDoklInt;
    end if;
  
    perform uUpdateDanEvid(_idDoklInt);
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dvazebtabinsertdeletedanevid() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 983, 't', %appVersion%, clock_timestamp());