<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />


    <xsl:variable name="radkyDoc" select="document('Uc_Doklad_Polozky.XML')"/>

    <xsl:key name="cisloKey" match="UC_DOKLAD_POLOZKY" use="Cislo_dokladu"/>

    <xsl:template match="/VFPData">
        <winstrom version="1.0" source="agnis">
            <ucet update="ignore">
                <id>ext:AGNIS:395000</id>
                <id>code:395000</id>
                <kod>395000</kod>
                <stdUcet>395</stdUcet>
                <poznam>Převodní účet pro synchronizaci s restauračním systémem Agnis</poznam>
            </ucet>
<!--            <xsl:apply-templates select="*[local-name() = 'Příjemky' and position() &lt; 100]"/> -->
            <xsl:apply-templates select="UC_DOKLAD_HLAVICKY"/>
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t prijemky-in.xslt -x prijemky.xml -o prijemky-vystup.xml
-->

    <xsl:template match="UC_DOKLAD_HLAVICKY">
        <xsl:variable name="cislo" select="Cislo_dokladu"/>

	<!--xsl:variable name="slevaDokl" select="Proc.sleva"/-->

	<!--xsl:if test="Úč.období != '201109'"-->

        <interni-doklad>
        <!--
           <UC_DOKLAD_HLAVICKY>
              <Obdobi>201202</Obdobi>
              <Subsystem>AGN</Subsystem>
              <Cislo_dokladu>1</Cislo_dokladu>
              <Zavod>1</Zavod>
              <Stredisko>0</Stredisko>
              <Uctoval>p </Uctoval>
              <Text>Kuchyňa</Text>
              <Datum_uctovani>28. 5.2012</Datum_uctovani>
            </UC_DOKLAD_HLAVICKY>
         -->
            <id>ext:AGNIS:<xsl:value-of select="Obdobi"/>-<xsl:value-of select="Cislo_dokladu"/></id>
            <typDokl>code:<xsl:value-of select="Subsystem"/></typDokl>
            <varSym><xsl:value-of select="Obdobi"/><xsl:value-of select="Cislo_dokladu"/></varSym>
            <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_uctovani, 'd.M.y')"/></datVyst>
            <stredisko>code:<xsl:value-of select="Stredisko"/></stredisko>
            <popis><xsl:value-of select="Text"/></popis>
            <bezPolozek>false</bezPolozek>
            <polozkyIntDokladu removeAll="true">
                  <xsl:for-each select="$radkyDoc">
                       <xsl:for-each select="key('cisloKey',$cislo)">
                              <interni-doklad-polozka>
                                    <!--
                                      <UC_DOKLAD_POLOZKY>
                                         <Obdobi>201202</Obdobi>
                                         *<Subsystem>AGN</Subsystem>
                                         <Cislo_dokladu>2</Cislo_dokladu>
                                         *<Zavod>1</Zavod>
                                         <Stredisko>0</Stredisko>
                                         <Ucet>610000</Ucet>
                                         <Strana>D</Strana>
                                         <Castka>3264.10</Castka>
                                         <Zakazka/>
                                         *<Vykon/>
                                         *<Polozka_kalk_vz/>
                                         <Datum_zuctovani>28. 5.2012</Datum_zuctovani>
                                         *<Danovy_zaklad>0.00</Danovy_zaklad>
                                         *<Poradi_ext_doklad>0</Poradi_ext_doklad>
                                         *<Poradi_na_dokladu>0</Poradi_na_dokladu>
                                         <Poznamka/>
                                      </UC_DOKLAD_POLOZKY>
                                    -->
                                    <!-- polozky jsou grupovany podle obdobi, cisla dokladu, středisek a účtů-->
                                    <id>ext:AGNIS-POL:<xsl:value-of select="Obdobi"/>-<xsl:value-of select="Cislo_dokladu"/>-<xsl:value-of select="Ucet"/>-<xsl:value-of select="Stredisko"/>-<xsl:value-of select="Strana"/></id>
                                    <sumZkl><xsl:value-of select="Castka"/></sumZkl>
                                    <sumDph>0.0</sumDph>
                                    <sumCelkem><xsl:value-of select="Castka"/></sumCelkem>
                                    <xsl:choose>
                                        <xsl:when test="Strana = 'D'">
                                             <zklMdUcet>code:395000</zklMdUcet>
                                             <kopZklMdUcet>false</kopZklMdUcet>
                                             <zklDalUcet if-not-found="null">code:<xsl:value-of select="Ucet"/></zklDalUcet>
                                             <kopZklDalUcet>false</kopZklDalUcet>
                                        </xsl:when>
                                        <xsl:otherwise>
                                             <zklMdUcet if-not-found="null">code:<xsl:value-of select="Ucet"/></zklMdUcet>
                                             <kopZklMdUcet>false</kopZklMdUcet>
                                             <zklDalUcet>code:395000</zklDalUcet>
                                             <kopZklDalUcet>false</kopZklDalUcet>
                                        </xsl:otherwise>
                                    </xsl:choose>

                                    <zakazka><xsl:value-of select="Zakazka"/></zakazka>
                                    <kopZakazku>false</kopZakazku>
                                    <poznam><xsl:value-of select="Stredisko"/></poznam>
                                    <kopStred>false</kopStred>
                                    <poznam><xsl:value-of select="Poznamka"/></poznam>
                              </interni-doklad-polozka>
                       </xsl:for-each>
                  </xsl:for-each>
            </polozkyIntDokladu>
        </interni-doklad>
    </xsl:template>

</xsl:stylesheet>
