<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" xmlns:diffgr="urn:schemas-microsoft-com:xml-diffgram-v1" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata" >

  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="Ceny">
    <winstrom version="1.0">
	<!-- Zalozime autorsky poplatek a poplatek za recyklaci -->
	<cenik update="ignore">
		<id>ext:ATC:Aut_Pop</id>
		<id>code:AUT_POP</id>
		<kod>AUT_POP</kod>
		<nazev>Autorský poplatek</nazev>
		<typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
		<typZasobyK>typZasoby.poplatek</typZasobyK>
		<nakupCena>1</nakupCena>
	</cenik>

	<cenik update="ignore">
		<id>ext:ATC:Rema</id>
		<id>code:RE_MA</id>
		<kod>RE_MA</kod>
		<nazev>Recyklace materiálu</nazev>
		<typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
		<typZasobyK>typZasoby.poplatek</typZasobyK>
		<nakupCena>1</nakupCena>
	</cenik>
    <xsl:apply-templates select="Zbozi"/>
    </winstrom>
  </xsl:template>

<!--
  kod
  cena
  dph
  rema
  autorsky_poplatek
-->

  <xsl:template match="Zbozi">
	<cenik create="ignore">
		<id>ext:ATC-CENIK:<xsl:value-of select="@kod"/></id>
		<id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@kod)"/></id>
		<kod><xsl:value-of select="java:flexibee.Tool.toUpper(@kod)"/></kod>
		<typSzbDphK><xsl:value-of select="java:flexibee.Tool.vatToCode(@dph)"/></typSzbDphK>

		<cenaZakl><xsl:value-of select="@cena"/></cenaZakl>
		<typCenyDphK>typCeny.bezDph</typCenyDphK>

		<xsl:if test="(@rema != '' or @autorsky_poplatek != '') and (@rema != '0' or @rema != '0.000' or @autorsky_poplatek != '0')">
		<poplatky>
			<xsl:if test="@rema != '' and @rema != '0.000' and @rema != '0'">
			<poplatek>
				<id>ext:ATC-REMA:<xsl:value-of select="@kod"/></id>
				<cenikOtec>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@kod)"/></cenikOtec>
				<cenik>[code:REMA][ext:ATC:Rema]</cenik>
				<mnozMj><xsl:value-of select="@rema"/></mnozMj>
			</poplatek>
			</xsl:if>

			<xsl:if test="@autorsky_poplatek != '' and @autorsky_poplatek != '0'">
			<poplatek>
				<id>ext:ATC-AUTPOP:<xsl:value-of select="@kod_zbozi"/></id>
				<cenikOtec>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@kod_zbozi)"/></cenikOtec>
				<cenik>[code:AUT_POP][ext:ATC:Aut_Pop]</cenik>
				<mnozMj><xsl:value-of select="@autorsky_poplatek"/></mnozMj>
			</poplatek>
			</xsl:if>
		</poplatky>
		</xsl:if>
    	</cenik>
  </xsl:template>
</xsl:stylesheet>

