<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <!-- pokladní XML pro pokladny firmy AWIS -->
    <xsl:output method="xml"  encoding="utf-8" />

    <xsl:template match="sales">
	<winstrom version="1.0">
		<pokladni-pohyb>
			<id>ext:AWIS-<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('terminal-store'))"/>:<xsl:value-of select="@period_id" /></id>
			<!-- tady musí být příjem, protože přijímáme peníze a zboží vydáváme -->
			<typPohybuK>typPohybu.prijem</typPohybuK>
			<datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(@period_start, 'y-M-d H:m')" /></datVyst>

			<bsp>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@terminal)" /></bsp>
			<typDokl>code:<xsl:choose>
			    <xsl:when test="java:flexibee.Tool.params('typ-dokl') != ''"><xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('typ-dokl'))"/></xsl:when>
			    <xsl:otherwise>STANDARD</xsl:otherwise>
			</xsl:choose></typDokl>
			<polozkyIntDokladu removeAll="true">
				<xsl:apply-templates select="item"/>
			</polozkyIntDokladu>
		</pokladni-pohyb>
	</winstrom>
    </xsl:template>
    
    <xsl:template match="item">
				<PolInt>
                    <id>ext:AWIS-POLINT-<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('terminal-store'))"/>:<xsl:value-of select="../@period_id" />-<xsl:value-of select="@itemId" /></id>
                    <xsl:choose>
                            <xsl:when test="@id != ''">
                                <typPolozkyK>typPolozky.katalog</typPolozkyK>
                                <cenik>ext:AWIS-ITEMS-<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('terminal-store'))"/>:<xsl:value-of select="@id"/></cenik>
                            </xsl:when>
                            <xsl:otherwise>
                                <typPolozkyK>typPolozky.obecny</typPolozkyK>
                                <typCenyDphK>typCeny.bezDph</typCenyDphK>
                            </xsl:otherwise>
                    </xsl:choose>
                    <mnozMj><xsl:value-of select="@quantity"/></mnozMj>
                    <cenaMj><xsl:value-of select="@sum div @quantity"/></cenaMj>

					
				</PolInt>
    </xsl:template>

</xsl:stylesheet>