<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <!-- import z ISP Admin -->
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:key name="cisloKey" match="row" use="field[@name='klient_number']"/>

<!-- 
	 flexibee2xml -x output-smlouvy.xml -t evidence-smluv-in.xslt -o smlouvy.xml
-->

    <xsl:template match="resultset">
	<winstrom version="1.0" atomic="false">
		<typ-smlouvy update="ignore">
			<id>code:SL_INTERNET</id>
			<kod>SL_INTERNET</kod>
			<nazev>Smlouva o připojení k internetu</nazev>
			<zpusFaktK>zpusobFakt.dopredu</zpusFaktK>
	   		<typDoklFak>code:FAKTURA</typDoklFak>
		</typ-smlouvy>
<!--		<xsl:apply-templates select="*[local-name() = 'row' and (position() &lt; 10 or field[@name='nazev_smlouvy'] != '' or field[@name='klient_number'] = '6030' or field[@name='klient_number'] = '1270' or field[@name='klient_number'] = '1251' or field[@name='klient_number'] = '1002')]"/>  -->
		<xsl:apply-templates />
	</winstrom>
    </xsl:template>

    <xsl:template match="row">
        <xsl:if test="generate-id(.) = generate-id(key('cisloKey', field[@name='klient_number'])[1])">
    
<!--    	<adresar update="ignore">
    		<id>ean:<xsl:value-of select="field[@name='klient_number']" /></id>
    		<xsl:if test="field[@name='dic'] != ''">
    		<id>vatid:<xsl:value-of select="field[@name='dic']" /></id>
    		</xsl:if>
    		<xsl:if test="field[@name='ico'] != ''">
    		<id>in:<xsl:value-of select="field[@name='ico']" /></id>
    		</xsl:if>
    		<eanKod>SL_<xsl:value-of select="field[@name='klient_number']" /></eanKod>
    		<nazev><xsl:value-of select="field[@name='username']" /></nazev>
    		<ulice><xsl:value-of select="field[@name='ulice_inst']" /></ulice>
    		<mesto><xsl:value-of select="field[@name='mesto_inst']" /></mesto>
    		<psc><xsl:value-of select="field[@name='psc_inst']" /></psc>
    	</adresar> -->

    	<xsl:for-each select="key('cisloKey', field[@name='klient_number'])">

    	<misto-urceni>
    		<id>ext:ISPADMIN:<xsl:value-of select="field[@name='klient_number']" />-<xsl:value-of select="field[@name='id']" /></id>
    		<nazev><xsl:value-of select="field[@name='username']" /></nazev>
    		<firma>[ean:<xsl:value-of select="field[@name='klient_number']" />]<xsl:if test="field[@name='dic'] != ''">[vatid:<xsl:value-of select="field[@name='dic']" />]</xsl:if><xsl:if test="field[@name='ico'] != ''">[in:<xsl:value-of select="field[@name='ico']" />]</xsl:if></firma>
    		<ulice><xsl:value-of select="field[@name='ulice_inst']" /></ulice>
    		<mesto><xsl:value-of select="field[@name='mesto_inst']" /></mesto>
    		<psc><xsl:value-of select="field[@name='psc_inst']" /></psc>
    	</misto-urceni>

		</xsl:for-each>

    	<smlouva>
    		<id>code:<xsl:value-of select="field[@name='klient_number']" /></id>
    		<xsl:if test="field[@name='stav'] != 0">
    			<stavSml>ext:ISPADMIN-STAV:<xsl:value-of select="field[@name='stav']" /></stavSml>
    		</xsl:if>

    		<smlouvaOd><xsl:value-of select="field[@name='fakturovat_od']" /></smlouvaOd>
    		<xsl:if test="field[@name='fakturovat_do'] != ''">
	    		<smlouvaDo><xsl:value-of select="field[@name='fakturovat_do']" /></smlouvaDo>
	    	</xsl:if>
    		<typSml>code:SL_INTERNET</typSml>
    		<xsl:if test="field[@name='nazev_smlouvy'] != ''">
	    		<nazev><xsl:value-of select="field[@name='nazev_smlouvy']" /></nazev>
	    	</xsl:if>
    		<firma>[ean:<xsl:value-of select="field[@name='klient_number']" />]<xsl:if test="field[@name='dic'] != ''">[vatid:<xsl:value-of select="field[@name='dic']" />]</xsl:if><xsl:if test="field[@name='ico'] != ''">[in:<xsl:value-of select="field[@name='ico']" />]</xsl:if></firma>
    		<kod><xsl:value-of select="field[@name='klient_number']" /></kod>
    		<varSym><xsl:value-of select="field[@name='klient_number']" /></varSym>
    		<datumPodepsani><xsl:value-of select="field[@name='max_pripojen_od']" /></datumPodepsani>
			<xsl:variable name="frekvence" select="field[@name='max_fakt_obdobi']"/>
		    <frekFakt><xsl:value-of select="$frekvence" /></frekFakt>

    		<den>1</den>
    		<polozkySmlouvy removeAll="true">
    			<xsl:for-each select="key('cisloKey', field[@name='klient_number'])">
	    			<smlouva-polozka>
	    				<id>ext:ISPADMIN-POLOZKY:<xsl:value-of select="field[@name='id']" /></id>
	    				<xsl:choose>
	    					<xsl:when test="field[@name='tarif_zkratka'] != ''">
<!--	    						<cenik>[ext:ISPADMIN:<xsl:value-of select="field[@name='tarif_id']" />]</cenik> -->
	    						<xsl:choose>
	    							<xsl:when test="field[@name='cena'] != field[@name='tarif_cena'] or field[@name='fakt_obdobi'] = 0">
					    				<xsl:choose>
					    					<xsl:when test="field[@name='fakt_obdobi'] = 0">
					    						<cenaRucne>false</cenaRucne>
					    						<cenaMj><xsl:value-of select="field[@name='cena']" /></cenaMj>	    							
					    						<sleva>100</sleva>
					    					</xsl:when>
					    					<xsl:otherwise>
					    						<cenaRucne>true</cenaRucne>
					    						<cenaMj><xsl:value-of select="field[@name='cena']" /></cenaMj>	    							
					    					</xsl:otherwise>
					    				</xsl:choose>
					    				<typCenyDphK>typCeny.sDph</typCenyDphK>
	    								<typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
	    							</xsl:when>
	    							<xsl:otherwise>
					    				<cenaRucne>false</cenaRucne>
	    							</xsl:otherwise>
	    						</xsl:choose>
	    					</xsl:when>
	    					<xsl:otherwise>
	    						<kod>OSTATNÍ</kod>
	    						<xsl:choose>
				    				<xsl:when test="field[@name='zkratka'] != ''">
					    				<nazev><xsl:value-of select="field[@name='zkratka']" /></nazev>
			    					</xsl:when>
			    					<xsl:otherwise>
			    						<nazev>Ostatní služby</nazev>
			    					</xsl:otherwise>
			    				</xsl:choose>
			    				<cenaRucne>true</cenaRucne>
					    				<xsl:choose>
					    					<xsl:when test="field[@name='fakt_obdobi'] = 0">
					    						<cenaMj><xsl:value-of select="field[@name='cena']" /></cenaMj>	    							
					    						<sleva>100</sleva>
					    					</xsl:when>
					    					<xsl:otherwise>
					    						<cenaMj><xsl:value-of select="field[@name='cena']" /></cenaMj>	    							
					    					</xsl:otherwise>
					    				</xsl:choose>
			    				<typCenyDphK>typCeny.sDph</typCenyDphK>
	    						<typSzbDphK>typSzbDph.dphZakl</typSzbDphK>	    					
	    					</xsl:otherwise>
	    				</xsl:choose>
	    				<xsl:choose>
	    					<xsl:when test="field[@name='fakt_obdobi'] != 0">
		   						<mnozMj><xsl:value-of select="field[@name='pocet'] * field[@name='fakt_obdobi']" /></mnozMj>
		   					</xsl:when>
		   					<xsl:otherwise>
		   						<mnozMj>0</mnozMj>
		   					</xsl:otherwise>
		   				</xsl:choose>

						<popis>
							<xsl:if test="field[@name='userip'] != ''">IP adresa: <xsl:value-of select="field[@name='userip']" />, </xsl:if>
							<xsl:if test="field[@name='usermac'] != ''">MAC: <xsl:value-of select="field[@name='usermac']" />, </xsl:if>
							<xsl:if test="field[@name='pripojen_od'] != ''">Připojen od: <xsl:value-of select="field[@name='pripojen_od']" />, </xsl:if>
							<xsl:if test="field[@name='inst_poplatek'] != '0' and field[@name='inst_poplatek'] != '0.00'">Instalační poplatek: <xsl:value-of select="field[@name='inst_poplatek']" /> Kč s DPH, </xsl:if>
							<xsl:if test="field[@name='vratna_zaloha'] != '0' and field[@name='vratna_zaloha'] != '0.00'">Vratná záloha: <xsl:value-of select="field[@name='vratna_zaloha']" /> Kč s DPH, </xsl:if>
							<xsl:if test="field[@name='delka_smlouvy'] != '0' and field[@name='delka_smlouvy'] != ''">Délka smlouvy: <xsl:value-of select="field[@name='delka_smlouvy']" /> měsíců, </xsl:if>
						</popis>
						<poznam>Závazek do: [<xsl:value-of select="field[@name='zavazek_do']" />], <xsl:value-of select="field[@name='poznamka']" /></poznam>
			    		<platiOdData><xsl:value-of select="field[@name='fakturovat_od']" /></platiOdData>
    					<xsl:if test="field[@name='fakturovat_do'] != ''">
	    					<platiDoData><xsl:value-of select="field[@name='fakturovat_do']" /></platiDoData>
	    				</xsl:if>

						<xsl:choose>
							<xsl:when test="field[@name='fakt_obdobi'] != 0">
					    		<frekFakt><xsl:value-of select="field[@name='fakt_obdobi']" /></frekFakt>
					    	</xsl:when>
					    	<xsl:otherwise>
				    			<frekFakt><xsl:value-of select="$frekvence" /></frekFakt>
				    		</xsl:otherwise>
				    	</xsl:choose>
						
	    				<datPoslFaktObd>2011-12-31</datPoslFaktObd>
		 		   		<misto>ext:ISPADMIN:<xsl:value-of select="field[@name='klient_number']" />-<xsl:value-of select="field[@name='id']" /></misto>
	    			</smlouva-polozka>
    			</xsl:for-each>
    			<xsl:for-each select="key('cisloKey', field[@name='klient_number'])">
    				<xsl:if test="field[@name='vernostni_sleva'] != '0.00' and field[@name='fakt_obdobi'] != 0">
		    			<smlouva-polozka>
		    				<id>ext:ISPADMIN-POLOZKY:<xsl:value-of select="field[@name='id']" />-SLEVA</id>
		    				<kod>SLEVA</kod>
		    				<xsl:choose>
		    					<xsl:when test="field[@name='vernostni_sleva_nazev'] != ''">
		    						<nazev><xsl:value-of select="field[@name='vernostni_sleva_nazev']" /></nazev>
		    					</xsl:when>
		    					<xsl:otherwise>
		    						<nazev>Věrnostní sleva</nazev>
		    					</xsl:otherwise>
		    				</xsl:choose>
		    				<cenaRucne>true</cenaRucne>
					    	<typCenyDphK>typCeny.sDph</typCenyDphK>
	    					<typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
							<xsl:choose>
								<xsl:when test="field[@name='fakt_obdobi'] != 0">
					    			<frekFakt><xsl:value-of select="field[@name='fakt_obdobi']" /></frekFakt>
					    		</xsl:when>
					    		<xsl:otherwise>
				    				<frekFakt><xsl:value-of select="$frekvence" /></frekFakt>
				    			</xsl:otherwise>
				    		</xsl:choose>						
	    					<datPoslFaktObd>2011-12-31</datPoslFaktObd>
		 		   			<misto>ext:ISPADMIN:<xsl:value-of select="field[@name='klient_number']" />-<xsl:value-of select="field[@name='id']" /></misto>
	    				<xsl:choose>
	    					<xsl:when test="field[@name='fakt_obdobi'] != 0">
		   						<mnozMj><xsl:value-of select="field[@name='pocet'] * field[@name='fakt_obdobi']" /></mnozMj>
		   					</xsl:when>
		   					<xsl:otherwise>
		   						<mnozMj>0</mnozMj>
		   					</xsl:otherwise>
		   				</xsl:choose>
					    	<cenaMj>-<xsl:value-of select="field[@name='vernostni_sleva']" /></cenaMj>
			    			<platiOdData><xsl:value-of select="field[@name='fakturovat_od']" /></platiOdData>
    						<xsl:if test="field[@name='fakturovat_do'] != ''">
	    						<platiDoData><xsl:value-of select="field[@name='fakturovat_do']" /></platiDoData>
	    					</xsl:if>

	    				</smlouva-polozka>
	    			</xsl:if>
    				<xsl:if test="field[@name='pausalni_cena'] != '0.00' and field[@name='fakt_obdobi'] != 0">
		    			<smlouva-polozka>
		    				<id>ext:ISPADMIN-POLOZKY:<xsl:value-of select="field[@name='id']" />-PAUSAL</id>
		    				<kod>PAUŠÁL</kod>
		    				<xsl:choose>
		    					<xsl:when test="field[@name='pausalni_poznamka'] != ''">
		    						<nazev><xsl:value-of select="field[@name='pausalni_poznamka']" /></nazev>
		    					</xsl:when>
		    					<xsl:otherwise>
		    						<nazev>Paušální poplatek</nazev>
		    					</xsl:otherwise>
		    				</xsl:choose>
		    				<cenaRucne>true</cenaRucne>
					    	<typCenyDphK>typCeny.sDph</typCenyDphK>
	    					<typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
							<xsl:choose>
								<xsl:when test="field[@name='fakt_obdobi'] != 0">
					    			<frekFakt><xsl:value-of select="field[@name='fakt_obdobi']" /></frekFakt>
					    		</xsl:when>
					    		<xsl:otherwise>
				    				<frekFakt><xsl:value-of select="$frekvence" /></frekFakt>
				    			</xsl:otherwise>
				    		</xsl:choose>

	    					<datPoslFaktObd>2011-12-31</datPoslFaktObd>
		 		   			<misto>ext:ISPADMIN:<xsl:value-of select="field[@name='klient_number']" />-<xsl:value-of select="field[@name='id']" /></misto>
	    					<xsl:choose>
	    						<xsl:when test="field[@name='fakt_obdobi'] != 0">
		   							<mnozMj><xsl:value-of select="field[@name='pocet'] * field[@name='fakt_obdobi']" /></mnozMj>
		   						</xsl:when>
		   						<xsl:otherwise>
		   							<mnozMj>0</mnozMj>
		   						</xsl:otherwise>
		   					</xsl:choose>
					    	<cenaMj><xsl:value-of select="field[@name='pausalni_cena']" /></cenaMj>
			    			<platiOdData><xsl:value-of select="field[@name='fakturovat_od']" /></platiOdData>
    						<xsl:if test="field[@name='fakturovat_do'] != ''">
	    						<platiDoData><xsl:value-of select="field[@name='fakturovat_do']" /></platiDoData>
	    					</xsl:if>

	    				</smlouva-polozka>
	    			</xsl:if>
	    		</xsl:for-each>
    		</polozkySmlouvy>
    	</smlouva>
    	
    	</xsl:if>
    </xsl:template>
</xsl:stylesheet>
