<?xml version="1.0" encoding="utf-8" ?>
<!-- 
 musí se použít pro import zatim restAPI 
 curl -v -u admin:heslo -X POST - -data-binary @sparovani.xml -H "Content-Type: application/xml" http://localhost:5434/c/tds/parovani-uhrad.xml 
 -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" >
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0">
      
     <xsl:apply-templates select="sparovani"/>
      
      <!--<xsl:key name="index" match="sparovani" use="CISLO"/>
      
      <xsl:for-each select="//winstrom/sparovani[generate-id() = generate-id(key('index',CISLO)[1])]">-->
        <xsl:if test="CASTKA != '0'">
          <xsl:choose>
          
            <xsl:when test="SB_KOD = 'PF'">
              <sparovani update="ignore">
                <uhrazovanaFak type="faktura-prijata">code:FP<xsl:value-of select="CISLO"/></uhrazovanaFak>
                <uhrazujiciDokl>code:FP<xsl:value-of select="CISLO"/></uhrazujiciDokl>
                <zbytek>castecnaUhrada</zbytek>
              </sparovani>
            </xsl:when>
            
            <xsl:when test="SB_KOD = 'VF'">
              <sparovani update="ignore">
                <uhrazovanaFak type="faktura-vydana">code:FV<xsl:value-of select="CISLO"/></uhrazovanaFak>
                <uhrazujiciDokl>code:FV<xsl:value-of select="CISLO"/></uhrazujiciDokl>
                <zbytek>castecnaUhrada</zbytek>
              </sparovani>
            </xsl:when>
            
          </xsl:choose>
        </xsl:if>

      <!--</xsl:for-each>-->
    </winstrom>
  </xsl:template>

    <!--


	INTER,N,8,0	ok
	STKOD,N,12,0	
	ZKKOD,N,12,0	ok
	DATUM,D		ok
	DOKLAD,C,3	ok
	CISLO,N,12,0	ok
	POPIS,C,192	ok
	CASTKA,N,14,2	ok
	MD,C,6		ok
	DAL,C,6		ok
	CISLO_ODB,C,10	ok
	NAZEV_ODB,C,64	ok
	NAZEV_OD2,C,64	
	SBORNIK,N,10,0	
	POZNAMKA,C,24	
	KOD_DPH,C,2	
	SB_KOD,C,2	
	MENA,C,3	ok
	KURS,N,18,10	ok
	M_KURS,N,5,0	ok
	ZCASTKA,N,15,2	
	IKOD,C,1	ok
	OBJEDNAVKA,C,24	
	DOD_LIST,C,24	
	ZAOK,N,4,2	
	ZAOK_ROUND,N,2,0
	VYSTAVIL,C,24	
	ULICE_ODB,C,28	ok
	PSC_ODB,C,10	ok
	MESTO_ODB,C,28	ok
	STAT_ODB,C,24	
	ICO_ODB,C,8	ok
	DIC_ODB,C,14	  ok
	PRILOHY,C,24	
	OZN_MENY,C,3	
	MENA_PRED,L	
	UC_VF,C,6	
	UC_ZA,C,6	
	MNOZSTVI,N,12,3	
	MJ,C,6		
	MATERIAL,C,20	
	INTMAT,N,8,0	
	SAZBA_DPH,N,5,2	
	CASTKA_DPH,N,15,2	
	CIZI_DPH,N,15,2	
	US_ADD,C,16	
	US_EDI,C,16	
	USD_ADD,C,16	
	USD_EDI,C,16	
	OTEVRENO,N,15,2	
	VARIABL,C,24	ok
	VAR_DAL,C,24	
	VIZE,N,2,0	
	ZUST_MD,N,15,2	
	ZUST_DAL,N,15,2	
	ZZUST_MD,N,15,2	
	ZZUST_DAL,N,15,2	
	DAN1,N,12,0	
	DAN2,N,12,0	
	DAN3,C,12	
	VAP,N,15,2	
	VAP_PR,N,7,2	
	DATUM_OD,D	
	DATUM_DO,D	
	DEN,N,2,0	
	PERIODA,N,1,0	
	RADA,C,3	
	DOPRAVA,C,24	
	CENA_SLV,N,15,2	
	SLEVA_PR,N,6,2	
	TS,C,40	
	ID,C,36	
	TYP_DOKL,C,3	
	DATUM_DPH,D	ok
	KURS_DPH,N,18,10	
	BARVA,N,8,0

    -->
    
  <xsl:template match="sparovani">
    
    <xsl:if test="CASTKA != '0'">
    <xsl:choose>
    
      <xsl:when test="SB_KOD = 'PF'">
        <sparovani update="ignore">
          <uhrazovanaFak type="faktura-prijata">code:FP<xsl:value-of select="CISLO"/></uhrazovanaFak>
          <uhrazujiciDokl>code:FP<xsl:value-of select="CISLO"/></uhrazujiciDokl>
          <zbytek>castecnaUhrada</zbytek>
        </sparovani>
      </xsl:when>
      
      <xsl:when test="SB_KOD = 'VF'">
        <sparovani update="ignore">
          <uhrazovanaFak type="faktura-vydana">code:FV<xsl:value-of select="CISLO"/></uhrazovanaFak>
          <uhrazujiciDokl>code:FV<xsl:value-of select="CISLO"/></uhrazujiciDokl>
          <zbytek>castecnaUhrada</zbytek>
        </sparovani>
      </xsl:when>
      
    </xsl:choose>
    </xsl:if>
    
  </xsl:template>
</xsl:stylesheet>