<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="MoneyData">
    <winstrom version="1.0" ignore-errors="true">
      <!-- nastaveni rad do prevodky -->
      <typ-skladovy-pohyb>
        <id>code:PŘEVODKA</id>
        <radaPrijem>code:SKLAD+</radaPrijem>
        <radaVydej>code:SKLAD-</radaVydej>
      </typ-skladovy-pohyb>
      
      <xsl:apply-templates select="SeznamZasoba"/>
    </winstrom>
  </xsl:template>
  
  <xsl:template match="SeznamZasoba">
    <!-- vynechame kvazi sklady, ktere jsou ceniky-->
    <xsl:apply-templates select="Zasoba[./Sklad/CenikSklad = '0']"/>
  </xsl:template>
  
  <xsl:template match="Zasoba">
    <sklad update="ignore">
      <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(./Sklad/KodSkladu)"/></id>
      <kod><xsl:value-of select="java:flexibee.Tool.toUpper(./Sklad/KodSkladu)"/></kod>
      <nazev><xsl:value-of select="./Sklad/Nazev"/></nazev>
      <modul>SKL</modul>
    </sklad>
    
    <xsl:if test="./Skupina">
      <skupina-zbozi update="ignore">
        <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(./Skupina/Zkratka)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.toUpper(./Skupina/Zkratka)"/></kod>
        <nazev><xsl:value-of select="./Skupina/Nazev"/></nazev>
      </skupina-zbozi>
    </xsl:if>
    
    <skladova-karta>
      <id>ext:mS3sk:<xsl:value-of select="substring(./KmKarta/GUID, 2, string-length(./KmKarta/GUID)-2)"/><xsl:value-of select="java:flexibee.Tool.toUpper(./Sklad/KodSkladu)"/></id>
      <stavMJ><xsl:value-of select="./StavZasoby/Zasoba"/></stavMJ>
      <datPosl><xsl:value-of select="java:flexibee.Tool.parseDate(Posl_Nak,'y-M-d')"/></datPosl>
      <sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(./Sklad/KodSkladu)"/></sklad>
      <cenik>ext:mS3cen:<xsl:value-of select="substring(./KmKarta/GUID, 2, string-length(./KmKarta/GUID)-2)"/></cenik>
      <ucetObdobi>code:<xsl:value-of select="substring(../../@HospRokDo, 1, 4)"/></ucetObdobi>
    </skladova-karta>
    
    <cenik>
      <id>ext:mS3cen:<xsl:value-of select="substring(./KmKarta/GUID, 2, string-length(./KmKarta/GUID)-2)"/></id>
      <nakupCena><xsl:value-of select="Nak_Cena"/></nakupCena>
      <xsl:if test="./Skupina">
        <skupZboz>code:<xsl:value-of select="java:flexibee.Tool.toUpper(./Skupina/Zkratka)"/></skupZboz>
      </xsl:if>

      <cenaZakl><xsl:value-of select="./PC/Cena1/Cena"/></cenaZakl>
      <typCenyDphK><xsl:choose><xsl:when test="./PC/SDPH = '1' and ./PC/Zaok = 'N'">typCeny.sDph</xsl:when>
        <xsl:when test="./PC/SDPH = '1' and ./PC/Zaok = 'A'">typCeny.sDphKoef</xsl:when>
        <xsl:otherwise>typCeny.bezDph</xsl:otherwise></xsl:choose>
      </typCenyDphK>
      <skladove>true</skladove>
    </cenik>
  </xsl:template>
</xsl:stylesheet>
