<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />

  <xsl:template match="MoneyData">                                  
    <winstrom version="1.0">
      <xsl:variable name="minYear" select="1990"/>

      <xsl:call-template name="createUO">  
        <xsl:with-param name="year">  
          <xsl:value-of select="java:flexibee.Tool.params('aktualniRok')"/>  
        </xsl:with-param>  
        <xsl:with-param name="minYear">  
          <xsl:value-of select="$minYear"/>  
        </xsl:with-param>  
      </xsl:call-template>
    </winstrom>
  </xsl:template>
  
  <xsl:template name="createUO">
    <xsl:param name="year"/>
    <xsl:param name="minYear"/>
    
    <ucetni-obdobi update="ignore">
      <id>code:<xsl:value-of select="$year"/></id>
      <kod><xsl:value-of select="$year"/></kod>
      <platiOdData><xsl:value-of select="$year"/>-01-01+01:00</platiOdData>
      <platiDoData><xsl:value-of select="$year"/>-12-31+01:00</platiDoData>
      <rokProRadu><xsl:value-of select="$year"/></rokProRadu>
    </ucetni-obdobi>

    <xsl:if test="$minYear &lt; $year">    
      <xsl:call-template name="createUO">  
        <xsl:with-param name="year">  
          <xsl:value-of select="$year - 1"/>  
        </xsl:with-param>  
        <xsl:with-param name="minYear">  
          <xsl:value-of select="$minYear"/>  
        </xsl:with-param>  
      </xsl:call-template>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>