<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
xmlns:rsp="http://www.stormware.cz/schema/version_2/response.xsd" 
xmlns:rdc="http://www.stormware.cz/schema/version_2/documentresponse.xsd" 
xmlns:typ="http://www.stormware.cz/schema/version_2/type.xsd" 
xmlns:dat="http://www.stormware.cz/schema/version_2/data.xsd"
xmlns:lst="http://www.stormware.cz/schema/version_2/list.xsd" 
xmlns:lStk="http://www.stormware.cz/schema/version_2/list_stock.xsd" 
xmlns:lAdb="http://www.stormware.cz/schema/version_2/list_addBook.xsd" 
xmlns:acu="http://www.stormware.cz/schema/version_2/accountingunit.xsd" 
xmlns:inv="http://www.stormware.cz/schema/version_2/invoice.xsd"
xmlns:vch="http://www.stormware.cz/schema/version_2/voucher.xsd"
xmlns:int="http://www.stormware.cz/schema/version_2/intDoc.xsd"
xmlns:stk="http://www.stormware.cz/schema/version_2/stock.xsd"
xmlns:ord="http://www.stormware.cz/schema/version_2/order.xsd"
xmlns:ofr="http://www.stormware.cz/schema/version_2/offer.xsd"
xmlns:enq="http://www.stormware.cz/schema/version_2/enquiry.xsd"
xmlns:vyd="http://www.stormware.cz/schema/version_2/vydejka.xsd"
xmlns:pri="http://www.stormware.cz/schema/version_2/prijemka.xsd"
xmlns:bal="http://www.stormware.cz/schema/version_2/balance.xsd"
xmlns:pre="http://www.stormware.cz/schema/version_2/prevodka.xsd"
xmlns:vyr="http://www.stormware.cz/schema/version_2/vyroba.xsd"
xmlns:pro="http://www.stormware.cz/schema/version_2/prodejka.xsd"
xmlns:con="http://www.stormware.cz/schema/version_2/contract.xsd"
xmlns:adb="http://www.stormware.cz/schema/version_2/addressbook.xsd"
xmlns:prm="http://www.stormware.cz/schema/version_2/parameter.xsd"
xmlns:lCon="http://www.stormware.cz/schema/version_2/list_contract.xsd"
xmlns:ctg="http://www.stormware.cz/schema/version_2/category.xsd"
xmlns:ipm="http://www.stormware.cz/schema/version_2/intParam.xsd"
xmlns:str="http://www.stormware.cz/schema/version_2/storage.xsd"
xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    
	<xsl:output method="xml" encoding="utf-8" />
	
	
	<!-- 
  flexibee2xml-cli.exe -x ucet-pohoda.xml -t ucet-in.xslt -o ucet.xml
   -->

	<xsl:template match="/">
		  <winstrom version="1.0" source="pohoda">
		    <typ-faktury-vydane update="ignore">
		      <id>code:PREVOD VF</id>
		      <kod>PREVOD VF</kod>
		      <nazev>Převedené faktury z Pohody</nazev>
		      <typDoklK>typDokladu.faktura</typDoklK>
		      <ucetni>false</ucetni>
		      <generovatSkl>false</generovatSkl>
		    </typ-faktury-vydane>

			  <xsl:apply-templates/>
	    </winstrom>	
	</xsl:template>

	<xsl:template match="dat:dataPackItem">
		  <xsl:apply-templates select="inv:invoice"/>
	</xsl:template>
	
	<xsl:template match="lst:listInvoice">
		  <xsl:apply-templates select="lst:invoice"/>
    </xsl:template>
  
  <xsl:template match="lst:invoice|inv:invoice">
	<!-- importujeme úhrady? -->
	
    <xsl:if test="inv:invoiceHeader/inv:liquidation/typ:amountHome != '' or java:flexibee.Tool.params('uhrazene') != 'false'">
    
    <xsl:if test="inv:invoiceHeader/inv:liquidation/typ:date != ''">
      <pokladna update="ignore">
        <id>code:<xsl:value-of select="java:flexibee.Tool.join('PREVOD',inv:invoiceSummary/inv:foreignCurrency/typ:currency/typ:ids,'-')"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.join('PREVOD',inv:invoiceSummary/inv:foreignCurrency/typ:currency/typ:ids,'-')"/></kod>
        <nazev>Migrace z pohody</nazev>
        <radaPrijem>code:POKLADNA+</radaPrijem>
        <radaVydej>code:POKLADNA-</radaVydej>
        
        <xsl:if test="inv:invoiceSummary/inv:foreignCurrency/typ:currency/typ:ids != ''">
          <mena>code:<xsl:value-of select="inv:invoiceSummary/inv:foreignCurrency/typ:currency/typ:ids"/></mena>
        </xsl:if>
      </pokladna>
    </xsl:if>
  
    <faktura-vydana>
		<xsl:if test="inv:invoiceHeader/inv:id">
      		<id>ext:POHODA-FV:<xsl:value-of select="substring(inv:invoiceHeader/inv:date,0,5)"/>-<xsl:value-of select="inv:invoiceHeader/inv:id"/></id>
        </xsl:if>

      <xsl:choose>
        <xsl:when test="java:flexibee.Tool.endsWith(inv:invoiceHeader/inv:date, '-01-01') and java:flexibee.Tool.endsWith(inv:invoiceHeader/inv:number/typ:numberRequested, java:flexibee.Tool.join('/',substring(java:flexibee.Tool.round(java:flexibee.Tool.params('year')-1,'0'),1,4),''))">
          <id>ext:POHODA-FV-KOD:<xsl:value-of select="substring(java:flexibee.Tool.round(java:flexibee.Tool.params('year')-1,'0'),1,4)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(substring(inv:invoiceHeader/inv:number/typ:numberRequested,-4,string-length(inv:invoiceHeader/inv:number/typ:numberRequested)))"/></id>
          <kod><xsl:value-of select="substring(java:flexibee.Tool.round(java:flexibee.Tool.params('year')-1,'0'),1,4)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(substring(inv:invoiceHeader/inv:number/typ:numberRequested,-4,string-length(inv:invoiceHeader/inv:number/typ:numberRequested)))"/></kod>
        </xsl:when>
        <xsl:otherwise>
          <id>ext:POHODA-FV-KOD:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(inv:invoiceHeader/inv:number/typ:numberRequested)"/></id>
        </xsl:otherwise>
      </xsl:choose>
      
      <typDokl>code:PREVOD VF</typDokl>
      <kod><xsl:value-of select="substring(inv:invoiceHeader/inv:date,0,5)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(inv:invoiceHeader/inv:number/typ:numberRequested)"/></kod>
      <varSym><xsl:value-of select="java:flexibee.Tool.toUpper(inv:invoiceHeader/inv:symVar)"/></varSym>
      <datVyst><xsl:value-of select="inv:invoiceHeader/inv:date"/></datVyst>
<!--      <duzpUcto><xsl:value-of select="inv:invoiceHeader/inv:dateTax"/></duzpUcto>
      <duzpPuv><xsl:value-of select="inv:invoiceHeader/inv:dateTax"/></duzpPuv>
      <datUcto><xsl:value-of select="inv:invoiceHeader/inv:dateAccounting"/></datUcto>  -->
      <datSplat><xsl:value-of select="inv:invoiceHeader/inv:dateDue"/></datSplat>
      
      <!-- inv:accounting -->
      <!-- inv:classificationVAT -->
      
      <popis><xsl:value-of select="inv:invoiceHeader/inv:text"/></popis>
      <firma if-not-found="null">
		<xsl:if test="inv:invoiceHeader/inv:partnerIdentity/typ:id">[ext:POHODA-ADR:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="inv:invoiceHeader/inv:partnerIdentity/typ:id"/>]</xsl:if>
		<xsl:if test="inv:invoiceHeader/inv:partnerIdentity/typ:extId/typ:ids">[ext:POHODA-ADR2:<xsl:value-of select="inv:invoiceHeader/inv:partnerIdentity/typ:extId/typ:ids"/>]</xsl:if>
		</firma>
      
      <nazFirmy><xsl:value-of select="inv:invoiceHeader/inv:partnerIdentity/typ:address/typ:company"/></nazFirmy>
      <mesto><xsl:value-of select="inv:invoiceHeader/inv:partnerIdentity/typ:address/typ:city"/></mesto>
      <ulice><xsl:value-of select="inv:invoiceHeader/inv:partnerIdentity/typ:address/typ:street"/></ulice>
      <psc><xsl:value-of select="inv:invoiceHeader/inv:partnerIdentity/typ:address/typ:zip"/></psc>
      <ic><xsl:value-of select="inv:invoiceHeader/inv:partnerIdentity/typ:address/typ:ico"/></ic>
      <dic><xsl:value-of select="inv:invoiceHeader/inv:partnerIdentity/typ:address/typ:dic"/></dic>
      
      <!-- adresa + misto doruceni -->
      <!-- inv:myIdentity - udaje o me -->
      <cisObj><xsl:value-of select="inv:invoiceHeader/inv:numberOrder"/></cisObj>
      <!-- inv:dateOrder - datum objednavky -->
      <!-- inv:priceLevel - neco jako cenova uroven -->
      
      <!-- inv:paymentType - jak zaplaceno ale odkazuje na ciselnik ktery nemame - to pod tim tam byt nemusi - TODO
           cash     - hotove
           draft    - prikazem
           delivery - dobirkou
           creditcard - platebni kartou
           cheque   - sek
           compensation - zapoctem
           advance - zalohou
      -->
      
      <!-- inv:account - seznam uctu nemame -->
      
	  <xsl:if test="inv:invoiceHeader/inv:symConst">
      	<konSym if-not-found="null">code:<xsl:value-of select="inv:invoiceHeader/inv:symConst"/></konSym>
  	  </xsl:if>
      
      <xsl:if test="inv:invoiceHeader/inv:paymentAccount/typ:accountNo != ''">
        <buc><xsl:value-of select="inv:invoiceHeader/inv:paymentAccount/typ:accountNo"/></buc>
      </xsl:if>
      <xsl:if test="inv:invoiceHeader/inv:paymentAccount/typ:bankCode != ''">
        <smerKod if-not-found="null">code:<xsl:value-of select="inv:invoiceHeader/inv:paymentAccount/typ:bankCode"/></smerKod>
      </xsl:if>
      
      <xsl:if test="inv:invoiceHeader/inv:centre/typ:id != ''">
        <stredisko if-not-found="null">ext:POHODA-STRED:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="inv:invoiceHeader/inv:centre/typ:id"/></stredisko>
      </xsl:if>
      <xsl:if test="inv:invoiceHeader/inv:activity/typ:id != ''">
        <cinnost if-not-found="null">ext:POHODA-CINNOST:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="inv:invoiceHeader/inv:activity/typ:id"/></cinnost>
      </xsl:if>
      <xsl:if test="inv:invoiceHeader/inv:contract/typ:id != ''">
        <zakazka if-not-found="null">ext:POHODA-ZAK:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="inv:invoiceHeader/inv:contract/typ:id"/></zakazka>
      </xsl:if>
      
<xsl:variable name="castkaDokl" select="0"/>

		<xsl:choose>
			<xsl:when test="inv:invoiceSummary">

  			<xsl:variable name="castkaDokl" select="java:flexibee.Tool.round(inv:invoiceSummary/inv:homeCurrency/typ:round/typ:priceRound + inv:invoiceSummary/inv:homeCurrency/typ:priceNone + inv:invoiceSummary/inv:homeCurrency/typ:priceLowSum + inv:invoiceSummary/inv:homeCurrency/typ:priceHighSum, '3')"/>
      
      <xsl:if test="inv:invoiceSummary/inv:foreignCurrency/typ:currency/typ:ids != ''">
        <mena>code:<xsl:value-of select="inv:invoiceSummary/inv:foreignCurrency/typ:currency/typ:ids"/></mena>
        <kurz><xsl:value-of select="inv:invoiceSummary/inv:foreignCurrency/typ:rate"/></kurz>
        <kurzMnozstvi><xsl:value-of select="inv:invoiceSummary/inv:foreignCurrency/typ:amount"/></kurzMnozstvi>
<!--        <sumCelkemMen><xsl:value-of select="inv:invoiceSummary/inv:foreignCurrency/typ:priceSum"/></sumCelkemMen>  -->
        
        <xsl:choose>
          <!-- bezpolozkova faktura -->
          <xsl:when test="count(inv:invoiceDetail/inv:invoiceItem) = 0">
            <sumCelkemMen><xsl:value-of select="java:flexibee.Tool.round((inv:invoiceSummary/inv:homeCurrency/typ:round/typ:priceRound + inv:invoiceSummary/inv:homeCurrency/typ:priceNone + inv:invoiceSummary/inv:homeCurrency/typ:priceLowSum + inv:invoiceSummary/inv:homeCurrency/typ:priceHighSum) * inv:invoiceSummary/inv:foreignCurrency/typ:amount div inv:invoiceSummary/inv:foreignCurrency/typ:rate, '3')"/></sumCelkemMen>
          </xsl:when>
          <!-- s polozkama -->
          <xsl:otherwise>
            <sumCelkemMen><xsl:value-of select="java:flexibee.Tool.round((sum(inv:invoiceDetail/inv:invoiceItem/inv:homeCurrency/typ:priceSum) + inv:invoiceSummary/inv:homeCurrency/typ:round/typ:priceRound) * inv:invoiceSummary/inv:foreignCurrency/typ:amount div inv:invoiceSummary/inv:foreignCurrency/typ:rate, '3')"/></sumCelkemMen>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
	</xsl:when> <!-- inv:invoiceSummary -->
</xsl:choose>

      <generovatDorovnavaciPolozku>true</generovatDorovnavaciPolozku>


      <xsl:choose>
        <!-- bezpolozkova faktura -->
        <xsl:when test="count(inv:invoiceDetail/inv:invoiceItem) = 0">
		<xsl:if test="inv:invoiceSummary">
          <sumCelkem><xsl:value-of select="java:flexibee.Tool.round(inv:invoiceSummary/inv:homeCurrency/typ:round/typ:priceRound + inv:invoiceSummary/inv:homeCurrency/typ:priceNone + inv:invoiceSummary/inv:homeCurrency/typ:priceLowSum + inv:invoiceSummary/inv:homeCurrency/typ:priceHighSum, '3')"/></sumCelkem>

          <polozkyFaktury removeAll="true">
            <xsl:if test="inv:invoiceSummary/inv:homeCurrency/typ:priceNone != '' and inv:invoiceSummary/inv:homeCurrency/typ:priceNone != '0'">
              <faktura-vydana-polozka>
				<xsl:if test="inv:invoiceHeader/inv:id">
                	<id>ext:POHODA-FVPOLAUTOOSV:<xsl:value-of select="substring(inv:invoiceHeader/inv:date,0,5)"/>-<xsl:value-of select="inv:invoiceHeader/inv:id"/></id>
				</xsl:if>
                <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                <sumCelkem><xsl:value-of select="inv:invoiceSummary/inv:homeCurrency/typ:priceNone"/></sumCelkem>
              </faktura-vydana-polozka>
            </xsl:if>
            <xsl:if test="inv:invoiceSummary/inv:homeCurrency/typ:priceLowSum != '' and inv:invoiceSummary/inv:homeCurrency/typ:priceLowSum != '0'">
              <faktura-vydana-polozka>
				<xsl:if test="inv:invoiceHeader/inv:id">
                	<id>ext:POHODA-FVPOLAUTOSNIZ:<xsl:value-of select="substring(inv:invoiceHeader/inv:date,0,5)"/>-<xsl:value-of select="inv:invoiceHeader/inv:id"/></id>
				</xsl:if>
                <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                <sumZkl><xsl:value-of select="inv:invoiceSummary/inv:homeCurrency/typ:priceLow"/></sumZkl>
                <sumDph><xsl:value-of select="inv:invoiceSummary/inv:homeCurrency/typ:priceLowVAT"/></sumDph>
                <sumCelkem><xsl:value-of select="inv:invoiceSummary/inv:homeCurrency/typ:priceLowSum"/></sumCelkem>
              </faktura-vydana-polozka>
            </xsl:if>
            <xsl:if test="inv:invoiceSummary/inv:homeCurrency/typ:priceHighSum != '' and inv:invoiceSummary/inv:homeCurrency/typ:priceHighSum != '0'">
              <faktura-vydana-polozka>
				<xsl:if test="inv:invoiceHeader/inv:id">
                	<id>ext:POHODA-FVPOLAUTOZAKL:<xsl:value-of select="substring(inv:invoiceHeader/inv:date,0,5)"/>-<xsl:value-of select="inv:invoiceHeader/inv:id"/></id>
				</xsl:if>
                <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
                <sumZkl><xsl:value-of select="inv:invoiceSummary/inv:homeCurrency/typ:priceHigh"/></sumZkl>
                <sumDph><xsl:value-of select="inv:invoiceSummary/inv:homeCurrency/typ:priceHighVAT"/></sumDph>
                <sumCelkem><xsl:value-of select="inv:invoiceSummary/inv:homeCurrency/typ:priceHighSum"/></sumCelkem>
              </faktura-vydana-polozka>
            </xsl:if>
          </polozkyFaktury>

		</xsl:if> <!-- inv:invoiceSummary -->

        </xsl:when>
        <!-- s polozkama -->
        <xsl:otherwise>
			<xsl:if test="inv:invoiceSummary">
          		<sumCelkem><xsl:value-of select="java:flexibee.Tool.round(sum(inv:invoiceDetail/inv:invoiceItem/inv:homeCurrency/typ:priceSum) + inv:invoiceSummary/inv:homeCurrency/typ:round/typ:priceRound, '3')"/></sumCelkem>
			</xsl:if> <!-- inv:invoiceSummary -->
      
          <polozkyFaktury removeAll="true">
            <xsl:for-each select="inv:invoiceDetail/inv:invoiceItem">
              <faktura-vydana-polozka>
				<xsl:if test="inv:invoiceHeader/inv:id">
                	<id>ext:POHODA-FVPOL:<xsl:value-of select="substring(../../inv:invoiceHeader/inv:date,0,5)"/>-<xsl:value-of select="inv:id"/></id>
				</xsl:if>
                <nazev><xsl:value-of select="inv:text"/></nazev>
                
                <xsl:if test="inv:quantity = '0.0' or inv:quantity = '-0.0'">
                  <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                </xsl:if>
                <mnozMj><xsl:value-of select="inv:quantity"/></mnozMj>
                <mj if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.toUpper(inv:unit)"/></mj>
                <!-- inv:coefficient -->
                <xsl:choose>
	                <xsl:when test="inv:rateVAT = 'high'"><typSzbDphK>typSzbDph.dphZakl</typSzbDphK></xsl:when>
	                <xsl:when test="inv:rateVAT = 'low'"><typSzbDphK>typSzbDph.dphSniz</typSzbDphK></xsl:when>
	                <xsl:when test="inv:rateVAT = 'none'"><typSzbDphK>typSzbDph.dphOsv</typSzbDphK></xsl:when>
                </xsl:choose>
            
                <slevaPol><xsl:value-of select="inv:discountPercentage"/></slevaPol>
                
                <xsl:choose>
                  <xsl:when test="(inv:payVAT = true or inv:payVAT = 'true')">
  					        <typCenyDphK>typCeny.sDph</typCenyDphK>
                  </xsl:when>
                  <xsl:otherwise>
                    <typCenyDphK>typCeny.bezDph</typCenyDphK>
                  </xsl:otherwise>
                </xsl:choose>

                <xsl:choose>
                  <xsl:when test="inv:foreignCurrency/typ:unitPrice != '' and inv:foreignCurrency/typ:unitPrice != '0'">
                    <cenaMj><xsl:value-of select="inv:foreignCurrency/typ:unitPrice"/></cenaMj>
                  </xsl:when>
                  <xsl:otherwise>
                    <cenaMj><xsl:value-of select="inv:homeCurrency/typ:unitPrice"/></cenaMj>
                  </xsl:otherwise>
                </xsl:choose>
                
				<xsl:if test="inv:homeCurrency/typ:price">
                	<sumZkl><xsl:value-of select="inv:homeCurrency/typ:price"/></sumZkl>
				</xsl:if>
				<xsl:if test="inv:homeCurrency/typ:priceVAT">
                	<sumDph><xsl:value-of select="inv:homeCurrency/typ:priceVAT"/></sumDph>
				</xsl:if>
				<xsl:if test="inv:homeCurrency/typ:priceSum">
                	<sumCelkem><xsl:value-of select="inv:homeCurrency/typ:priceSum"/></sumCelkem>
				</xsl:if>
				<xsl:if test="inv:foreignCurrency/typ:price">
                	<sumZklMen><xsl:value-of select="inv:foreignCurrency/typ:price"/></sumZklMen>
				</xsl:if>
				<xsl:if test="inv:foreignCurrency/typ:priceVAT">
                	<sumDphMen><xsl:value-of select="inv:foreignCurrency/typ:priceVAT"/></sumDphMen>
				</xsl:if>
				<xsl:if test="inv:foreignCurrency/typ:priceSum">
                	<sumCelkemMen><xsl:value-of select="inv:foreignCurrency/typ:priceSum"/></sumCelkemMen>
				</xsl:if>
            
                <poznam><xsl:value-of select="inv:note"/></poznam>
                <kod><xsl:value-of select="inv:code"/></kod>
                <!-- inv:guarantee -->
            
                <xsl:if test="inv:stockItem/typ:store/typ:id != ''">
                  <sklad if-not-found="null">ext:POHODA-SKLAD:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="inv:stockItem/typ:store/typ:id"/></sklad>
                </xsl:if>
                <xsl:if test="inv:stockItem/typ:stockItem/typ:id != ''">
                  <cenik if-not-found="null">ext:POHODA-CENIK:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="inv:stockItem/typ:stockItem/typ:id"/></cenik>
                </xsl:if>
              </faktura-vydana-polozka>
	          </xsl:for-each>
	        </polozkyFaktury>
	    
        </xsl:otherwise>
      </xsl:choose>
      
      <xsl:if test="inv:invoiceHeader/inv:liquidation/typ:date != ''">
        <hotovostni-uhrada>
          <uhrazujiciDokl>ext:POHODA-UHRADAVF:<xsl:value-of select="substring(inv:invoiceHeader/inv:date,0,5)"/>-<xsl:value-of select="inv:invoiceHeader/inv:id"/></uhrazujiciDokl>
          <pokladna>code:<xsl:value-of select="java:flexibee.Tool.join('PREVOD',inv:invoiceSummary/inv:foreignCurrency/typ:currency/typ:ids,'-')"/></pokladna>
          <typDokl>code:STANDARD</typDokl> <!-- typ vytvářeného pokladního dokladu -->
          <datumUhrady><xsl:value-of select="inv:invoiceHeader/inv:liquidation/typ:date"/></datumUhrady>
          
          <!-- inv:liquidation - zbyva uhradit -->
      <!--<inv:liquidation>
					<typ:date>-->
          <castka>
          <xsl:choose>
            <!-- mena -->
            <xsl:when test="inv:invoiceSummary/inv:foreignCurrency/typ:currency/typ:ids != ''">
            
              <xsl:choose>
                <!-- zbyva neco uhradit -->
                <xsl:when test="inv:invoiceHeader/inv:liquidation/typ:amountHome != ''">
                  <xsl:value-of select="java:flexibee.Tool.round(($castkaDokl - inv:invoiceHeader/inv:liquidation/typ:amountHome) * inv:invoiceSummary/inv:foreignCurrency/typ:amount div inv:invoiceSummary/inv:foreignCurrency/typ:rate, '3')"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="java:flexibee.Tool.round($castkaDokl * inv:invoiceSummary/inv:foreignCurrency/typ:amount div inv:invoiceSummary/inv:foreignCurrency/typ:rate, '3')"/>
                </xsl:otherwise>
              </xsl:choose>
            
            </xsl:when>
            <xsl:otherwise>
            
              <xsl:choose>
                <!-- zbyva neco uhradit -->
                <xsl:when test="inv:invoiceHeader/inv:liquidation/typ:amountHome != ''">
                  <xsl:choose>
                    <!-- bezpolozkova faktura -->
                    <xsl:when test="count(inv:invoiceDetail/inv:invoiceItem) = 0">
                      <xsl:value-of select="java:flexibee.Tool.round($castkaDokl - inv:invoiceHeader/inv:liquidation/typ:amountHome, '3')"/>
                    </xsl:when>
                    <!-- s polozkama -->
                    <xsl:otherwise>
                      <xsl:value-of select="java:flexibee.Tool.round(sum(inv:invoiceDetail/inv:invoiceItem/inv:homeCurrency/typ:priceSum) + inv:invoiceSummary/inv:homeCurrency/typ:round/typ:priceRound - inv:invoiceHeader/inv:liquidation/typ:amountHome, '3')"/>
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="$castkaDokl "/>
                </xsl:otherwise>
              </xsl:choose>
            
            </xsl:otherwise>
          </xsl:choose>
          </castka>
          
        </hotovostni-uhrada>
	    </xsl:if>
    </faktura-vydana>
    
    </xsl:if>
  </xsl:template>
  
</xsl:stylesheet>
