<?xml version="1.0" encoding="utf-8" ?>
<!--ve sloupci popis u polozky "Systémové zaokrouhlení CM" není uvedená měna-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" >
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0">
    <xsl:apply-templates select="banka"/>
    </winstrom>
  </xsl:template>

<!--
ucet	prijato	castka	mena	vs	ss	ks	protiucet	banka	nazev_protiuctu	popis	poznamka	bankovni_reference	iban	id
-->
  <xsl:template match="banka">
	<banka>
    	    <id>ext:PRIMSYS:<xsl:value-of select="java:flexibee.Tool.substring(bankovni_reference, 26)"/></id>
    	    <kod><xsl:value-of select="java:flexibee.Tool.substring(bankovni_reference, 26)"/></kod>
    	    <popis><xsl:value-of select="popis"/></popis>
    	    <xsl:if test="poznamka != ''">
    		<poznam><xsl:value-of select="poznamka"/></poznam>
    	    </xsl:if>
    	    <typPohybuK>typPohybu.prijem</typPohybuK>
	    <xsl:if test="vs != ''">
    		<varSym><xsl:value-of select="vs"/></varSym>
    	    </xsl:if>
    	    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(prijato, 'd.M.y')"/></datVyst>
    	    <sumOsv><xsl:value-of select="castka"/></sumOsv>
    	    <xsl:if test="nazev_protiuctu != ''">
    		<nazFirmy><xsl:value-of select="nazev_protiuctu"/></nazFirmy>
    	    </xsl:if>
    	    <buc><xsl:value-of select="protiucet"/></buc>
    	    <xsl:if test="ss != ''">
    		<specSym><xsl:value-of select="ss"/></specSym>
    	    </xsl:if>
    	    <typDokl>code:BANKOVNÍ ÚČET</typDokl>
    	    <xsl:if test="ks != '' and ks != '0'">
		<konSym>code:<xsl:if test="string-length(ks) = 3">0</xsl:if><xsl:value-of select="ks"/></konSym>
    	    </xsl:if>
    	    <primUcet>code:221001</primUcet>
    	    <protiUcet>code:602001</protiUcet>
    	    <smerKod>code:<xsl:if test="string-length(banka) = 3">0</xsl:if><xsl:value-of select="banka"/></smerKod>
    	    <polozkyIntDokladu>
    		<banka-polozka>
    		    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
    		    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
    		    <sumZkl><xsl:value-of select="castka"/></sumZkl>
    		</banka-polozka>
    	    </polozkyIntDokladu>
    	</banka>
  </xsl:template>
</xsl:stylesheet>
