<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="winstrom">
	<winstrom version="1.0">
		<xsl:apply-templates select="faktura-vydana"/>
	</winstrom>
    </xsl:template>

    <xsl:template match="faktura-vydana">
	<faktura-vydana>
	    <UUID_DOKLAD><xsl:value-of select="substring(id, 11)"/></UUID_DOKLAD>
	    <ID_DOKLADU><xsl:value-of select="kod"/></ID_DOKLADU>
	    <ID_DOKLAD_TYP><xsl:value-of select="substring(typDokl, 6)"/></ID_DOKLAD_TYP>
	    <ICO><xsl:value-of select="ic"/></ICO>
	    <FNAZEV><xsl:value-of select="nazFirmy"/></FNAZEV>
	    <VS><xsl:value-of select="varSym"/></VS>
	    <DATUM><xsl:value-of select="java:flexibee.Tool.formatDate(datVyst, 'd.M.yyyy')" /></DATUM>
	    <DATUM2><xsl:value-of select="java:flexibee.Tool.formatDate(datSplat, 'd.M.yyyy')" /></DATUM2>
	    <DATUM3><xsl:value-of select="java:flexibee.Tool.formatDate(duzpPuv, 'd.M.yyyy')" /></DATUM3>
	    <ZAKLADDPH0><xsl:value-of select="java:flexibee.Tool.formatMoney(sumOsv)"/></ZAKLADDPH0>
	    <ZAKLADDPH1><xsl:value-of select="java:flexibee.Tool.formatMoney(sumZklSniz)"/></ZAKLADDPH1>
	    <ZAKLADDPH2><xsl:value-of select="java:flexibee.Tool.formatMoney(sumZklZakl)"/></ZAKLADDPH2>
	    <DPH1><xsl:value-of select="java:flexibee.Tool.formatMoney(sumDphSniz)"/></DPH1>
	    <DPH2><xsl:value-of select="java:flexibee.Tool.formatMoney(sumDphZakl)"/></DPH2>
	    <KURZ><xsl:value-of select="java:flexibee.Tool.formatMoney(kurz)"/></KURZ>
	    <BezDPH><xsl:value-of select="java:flexibee.Tool.formatMoney(sumZklCelkem)"/></BezDPH>
	    <MENA><xsl:value-of select="substring(mena, 6)"/></MENA>
	    <CELKEM><xsl:value-of select="java:flexibee.Tool.formatMoney(sumCelkem)"/></CELKEM>
	    <STAV_UHRADY><xsl:value-of select="stavUhrK/@showAs"/></STAV_UHRADY>
	    <UHRAZENO><xsl:value-of select="java:flexibee.Tool.formatMoney(juhSum)"/></UHRAZENO>
	    <ZBYVA_UHRADIT><xsl:value-of select="java:flexibee.Tool.formatMoney(zbyvaUhradit)"/></ZBYVA_UHRADIT>
	</faktura-vydana>

<!--
		<UUID_DOKLAD>*SZVnUcWrmfYad0ITYQfex</UUID_DOKLAD> ok
		<ID_DOKLAD_TYP>PFA</ID_DOKLAD_TYP> ok
		<ID_DOKLADU>1060012</ID_DOKLADU> ok
		<ICO>00032433</ICO> ok
		<FNAZEV>JEDNOTA SD ZÁBŘEH</FNAZEV> ok
		<VS>1060012</VS> ok
		<DATUM>1.1.2010</DATUM> ok
		<DATUM2>10.1.2010</DATUM2> ok
		<DATUM3>1.1.2010</DATUM3> ok
		<ZAKLADDPH0>25000</ZAKLADDPH0> ok
		<ZAKLADDPH1>0</ZAKLADDPH1> ok
		<ZAKLADDPH2>0</ZAKLADDPH2> ok
		<DPH1>0</DPH1> ok
		<DPH2>0</DPH2> ok
		<BezDPH>25000</BezDPH> - ignore
		<ZPUSOB_UHRADY>Bankovním převodem</ZPUSOB_UHRADY> ok
		<ZAOKROUHLENI>0</ZAOKROUHLENI> ok
		<CELKEM>25000</CELKEM> - ignore
		<PRODEJKA>0</PRODEJKA>
		<KURZ></KURZ>
		<MENA></MENA>
-->

    </xsl:template>

</xsl:stylesheet>