--------------------------------------------------------------------------------
-- Bug 28065 – [winstrom] - Intrastat - Slovensko
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    userbankid integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);

  -- slovensky intrastat
  if (stat = 'SK_SK') then

-- nejprve odstranime spatne zaznamy vytvorene v upgradu 585
UPDATE ccenik as C SET idnomen = NULL FROM inomen as I
 WHERE C.idnomen is not null and C.idnomen = I.idnomen and I.uuid like 'SK_%';
 
DELETE from inomen where uuid like 'SK_%';

-- kody nomenklatury
INSERT INTO inomen (kod, nazev, idintrmerjed, uuid)
 VALUES
('0101', 'Živé kone, somáre, muly a mulice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0101'),
('0101:2X', '- Kone', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0101:2X'),
('01012100', '-- Plemenné čistokrvné zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01012100'),
('010129', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010129'),
('01012910', '--- Jatočné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01012910'),
('01012990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01012990'),
('01013000', '- Somáre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01013000'),
('01019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01019000'),
('0102', 'Živé hovädzie zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0102'),
('0102:2X', '- Dobytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0102:2X'),
('010221', '-- Plemenné čistokrvné zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010221'),
('01022110', '--- Jalovice (samice hovädzích zvierat, ktoré sa nikdy neotelili)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022110'),
('01022130', '--- Kravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022130'),
('01022190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022190'),
('010229', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010229'),
('01022910', '--- S hmotnosťou nepresahujúcou 80 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022910'),
('01022910:2X', '--- S hmotnosťou presahujúcou 80 kg, ale nepresahujúcou 160 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01022910:2X'),
('01022921', '---- Jatočné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022921'),
('01022929', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022929'),
('01022929:2X', '--- S hmotnosťou presahujúcou 160 kg, ale nepresahujúcou 300 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01022929:2X'),
('01022941', '---- Jatočné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022941'),
('01022949', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022949'),
('01022949:2X', '--- S hmotnosťou presahujúcou 300 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01022949:2X'),
('01022949:3X', '---- Jalovice (samice hovädzích zvierat, ktoré sa nikdy neotelili)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01022949:3X'),
('01022951', '----- Jatočné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022951'),
('01022959', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022959'),
('01022959:2X', '---- Kravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01022959:2X'),
('01022961', '----- Jatočné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022961'),
('01022969', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022969'),
('01022969:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01022969:2X'),
('01022991', '----- Jatočné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022991'),
('01022999', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01022999'),
('01022999:2X', '- Byvoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01022999:2X'),
('01023100', '-- Plemenné čistokrvné zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01023100'),
('010239', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010239'),
('01023910', '--- Domáce druhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01023910'),
('01023990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01023990'),
('010290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010290'),
('01029020', '-- Plemenné čistokrvné zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01029020'),
('01029020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01029020:2X'),
('01029091', '--- Domáce druhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01029091'),
('01029099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01029099'),
('0103', 'Živé svine', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0103'),
('01031000', '- Plemenné čistokrvné zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01031000'),
('01031000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01031000:2X'),
('010391', '-- Vážiace menej ako 50 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010391'),
('01039110', '--- Domáce druhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01039110'),
('01039190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01039190'),
('010392', '-- Vážiace 50 kg alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010392'),
('010392:2X', '--- Domáce druhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010392:2X'),
('01039211', '---- Prasnice, ktoré vrhli prasiatka aspoň raz, s hmotnosťou najmenej 160 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01039211'),
('01039219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01039219'),
('01039290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01039290'),
('0104', 'Živé ovce a kozy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0104'),
('010410', '- Ovce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010410'),
('01041010', '-- Plemenné čistokrvné zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01041010'),
('01041010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01041010:2X'),
('01041030', '--- Jahňatá (do jedného roka veku)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01041030'),
('01041080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01041080'),
('010420', '- Kozy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010420'),
('01042010', '-- Plemenné čistokrvné zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01042010'),
('01042090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01042090'),
('0105', 'Živá hydina, t. j. hydina druhu Gallus domesticus, kačice, husi, moriaky, morky a perličky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0105'),
('0105:2X', '- Vážiaca nie viac ako 185 g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0105:2X'),
('010511', '-- Hydina druhu Gallus domesticus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010511'),
('010511:2X', '--- Samičie kurence chovné a reprodukčné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010511:2X'),
('01051111', '---- Na znášanie vajec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01051111'),
('01051119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01051119'),
('01051119:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01051119:2X'),
('01051191', '---- Na znášanie vajec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01051191'),
('01051199', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01051199'),
('01051200', '-- Moriaky a morky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01051200'),
('01051300', '-- Kačice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01051300'),
('01051400', '-- Husi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01051400'),
('01051500', '-- Perličky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01051500'),
('01051500:2X', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01051500:2X'),
('01059400', '-- Hydina druhu Gallus domesticus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01059400'),
('010599', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010599'),
('01059910', '--- Kačice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01059910'),
('01059920', '--- Husi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01059920'),
('01059930', '--- Moriaky a morky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01059930'),
('01059950', '--- Perličky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01059950'),
('0106', 'Ostatné živé zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0106'),
('0106:2X', '- Cicavce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0106:2X'),
('01061100', '-- Primáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01061100'),
('01061200', '-- Veľryby, delfíny a sviňuchy (cicavce radu Cetacea); lamantíny a dugongy (cicavce radu Sirenia); tulene, uškatce a mrože (cicavce podradu Pinnipedia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01061200'),
('01061300', '-- Ťavy a ostatné ťavovité (Camelidae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01061300'),
('010614', '-- Králiky a zajace', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010614'),
('01061410', '--- Domáce králiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01061410'),
('01061490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01061490'),
('01061900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01061900'),
('01062000', '- Plazy (vrátane hadov a korytnačiek)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01062000'),
('01062000:2X', '- Vtáky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01062000:2X'),
('01063100', '-- Dravé vtáky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01063100'),
('01063200', '-- Papagájovité (vrátane papagájov, papagájcov, ara a kakadu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01063200'),
('01063300', '-- Pštrosy; emu (Dromaius novaehollandiae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01063300'),
('010639', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_010639'),
('01063910', '--- Holuby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_01063910'),
('01063980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01063980'),
('01063980:2X', '- Hmyz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01063980:2X'),
('01064100', '-- Včely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01064100'),
('01064900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01064900'),
('01069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_01069000'),
('0201', 'Mäso z hovädzích zvierat, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0201'),
('02011000', '- Trupy a polovičky trupov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02011000'),
('020120', '- Ostatné kusy nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020120'),
('02012020', '-- "Kompenzované" štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02012020'),
('02012030', '-- Neoddelené alebo oddelené predné štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02012030'),
('02012050', '-- Neoddelené alebo oddelené zadné štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02012050'),
('02012090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02012090'),
('02013000', '- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02013000'),
('0202', 'Mäso z hovädzích zvierat, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0202'),
('02021000', '- Trupy a polovičky trupov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02021000'),
('020220', '- Ostatné kusy nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020220'),
('02022010', '-- "Kompenzované" štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02022010'),
('02022030', '-- Neoddelené alebo oddelené predné štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02022030'),
('02022050', '-- Neoddelené alebo oddelené zadné štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02022050'),
('02022090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02022090'),
('020230', '- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020230'),
('02023010', '-- Predné štvrtiny, celé alebo rozdelené maximálne na päť kusov, každá štvrtina v samostatnom bloku; "kompenzované" štvrtiny v dvoch blokoch, z ktorých jeden obsahuje prednú štvrtinu, celú alebo delenú maximálne na päť kusov a druhý obsahuje zadnú štvrti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02023010'),
('02023050', '-- Predná časť, lopatka, pliecko a kusy hrude', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02023050'),
('02023090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02023090'),
('0203', 'Mäso zo svíň, čerstvé, chladené alebo mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0203'),
('0203:2X', '- Čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0203:2X'),
('020311', '-- Trupy a polovičky trupov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020311'),
('02031110', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031110'),
('02031190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031190'),
('020312', '-- Stehná, pliecka a kusy z nich, nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020312'),
('020312:2X', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020312:2X'),
('02031211', '---- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031211'),
('02031219', '---- Pliecka a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031219'),
('02031290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031290'),
('020319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020319'),
('020319:2X', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020319:2X'),
('02031911', '---- Predné časti a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031911'),
('02031913', '---- Chrbty a kusy z nich, nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031913'),
('02031915', '---- Bôčiky (prerastené) a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031915'),
('02031915:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031915:2X'),
('02031955', '----- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031955'),
('02031959', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031959'),
('02031990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031990'),
('02031990:2X', '- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02031990:2X'),
('020321', '-- Trupy a polovičky trupov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020321'),
('02032110', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032110'),
('02032190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032190'),
('020322', '-- Stehná, pliecka a kusy z nich, nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020322'),
('020322:2X', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020322:2X'),
('02032211', '---- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032211'),
('02032219', '---- Pliecka a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032219'),
('02032290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032290'),
('020329', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020329'),
('020329:2X', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020329:2X'),
('02032911', '---- Predné časti a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032911'),
('02032913', '---- Chrbty a kusy z nich, nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032913'),
('02032915', '---- Bôčiky (prerastené) a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032915'),
('02032915:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032915:2X'),
('02032955', '----- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032955'),
('02032959', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032959'),
('02032990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02032990'),
('0204', 'Mäso z oviec alebo kôz, čerstvé, chladené alebo mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0204'),
('02041000', '- Trupy a polovičky trupov z jahniat, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02041000'),
('02041000:2X', '- Ostatné mäso z oviec, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02041000:2X'),
('02042100', '-- Trupy a polovičky trupov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02042100'),
('020422', '-- Ostatné kusy nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020422'),
('02042210', '--- Krátke predné štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02042210'),
('02042230', '--- Chrbty a/alebo karé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02042230'),
('02042250', '--- Nohy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02042250'),
('02042290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02042290'),
('02042300', '-- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02042300'),
('02043000', '- Trupy a polovičky trupov z jahniat, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02043000'),
('02043000:2X', '- Ostatné mäso z oviec, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02043000:2X'),
('02044100', '-- Trupy a polovičky trupov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02044100'),
('020442', '-- Ostatné kusy nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020442'),
('02044210', '--- Krátke predné štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02044210'),
('02044230', '--- Chrbty a/alebo karé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02044230'),
('02044250', '--- Nohy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02044250'),
('02044290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02044290'),
('020443', '-- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020443'),
('02044310', '--- Z jahniat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02044310'),
('02044390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02044390'),
('020450', '- Mäso z kôz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020450'),
('020450:2X', '-- Čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020450:2X'),
('02045011', '--- Trupy a polovičky trupov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045011'),
('02045013', '--- Krátke predné štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045013'),
('02045015', '--- Chrbty a/alebo karé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045015'),
('02045019', '--- Nohy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045019'),
('02045019:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045019:2X'),
('02045031', '---- Kusy nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045031'),
('02045039', '---- Vykostené kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045039'),
('02045039:2X', '-- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045039:2X'),
('02045051', '--- Trupy a polovičky trupov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045051'),
('02045053', '--- Krátke predné štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045053'),
('02045055', '--- Chrbty a/alebo karé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045055'),
('02045059', '--- Nohy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045059'),
('02045059:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045059:2X'),
('02045071', '---- Kusy nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045071'),
('02045079', '---- Vykostené kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02045079'),
('020500', 'Mäso z koní, somárov, múl alebo mulíc, čerstvé, chladené alebo mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020500'),
('02050020', '- Čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02050020'),
('02050080', '- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02050080'),
('0206', 'Jedlé droby z hovädzích zvierat, svíň, oviec, kôz, koní, somárov, múl alebo mulíc, čerstvé, chladené alebo mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0206'),
('020610', '- Z hovädzích zvierat, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020610'),
('02061010', '-- Na výrobu farmaceutických výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02061010'),
('02061010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02061010:2X'),
('02061095', '--- Hrubá bránica a tenká bránica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02061095'),
('02061098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02061098'),
('02061098:2X', '- Z hovädzích zvierat, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02061098:2X'),
('02062100', '-- Jazyky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02062100'),
('02062200', '-- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02062200'),
('020629', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020629'),
('02062910', '--- Na výrobu farmaceutických výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02062910'),
('02062910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02062910:2X'),
('02062991', '---- Hrubá bránica a tenká bránica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02062991'),
('02062999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02062999'),
('02063000', '- Zo svíň, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02063000'),
('02063000:2X', '- Zo svíň, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02063000:2X'),
('02064100', '-- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02064100'),
('02064900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02064900'),
('020680', '- Ostatné, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020680'),
('02068010', '-- Na výrobu farmaceutických výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02068010'),
('02068010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02068010:2X'),
('02068091', '--- Z koní, somárov, múl a mulíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02068091'),
('02068099', '--- Z oviec a kôz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02068099'),
('020690', '- Ostatné, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020690'),
('02069010', '-- Na výrobu farmaceutických výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02069010'),
('02069010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02069010:2X'),
('02069091', '--- Z koní, somárov, múl a mulíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02069091'),
('02069099', '--- Z oviec a kôz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02069099'),
('0207', 'Mäso a jedlé droby, z hydiny položky 0105, čerstvé, chladené alebo mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0207'),
('0207:2X', '- Z hydiny druhu Gallus domesticus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0207:2X'),
('020711', '-- V celku, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020711'),
('02071110', '--- Ošklbané a zbavené čriev, s hlavou a nôžkami, známe ako "kurčatá 83 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071110'),
('02071130', '--- Ošklbané a vypitvané, bez hlavy a nôžok, ale s krkom, srdcom, pečeňou a svalnatým žalúdkom, známe ako "kurčatá 70 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071130'),
('02071190', '--- Ošklbané a vypitvané, bez hlavy a nôžok a bez krku, srdca, pečene a svalnatého žalúdka, známe ako "kurčatá 65 %", alebo inak predkladané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071190'),
('020712', '-- V celku, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020712'),
('02071210', '--- Ošklbané a vypitvané, bez hlavy a nôžok, ale s krkom, srdcom, pečeňou a svalnatým žalúdkom, známe ako "kurčatá 70 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071210'),
('02071290', '--- Ošklbané a vypitvané, bez hlavy a nôžok a bez krku, srdca, pečene a svalnatého žalúdka, známe ako "kurčatá 65 %", alebo inak predkladané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071290'),
('020713', '-- Kusy a droby, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020713'),
('020713:2X', '--- Kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020713:2X'),
('02071310', '---- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071310'),
('02071310:2X', '---- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071310:2X'),
('02071320', '----- Polovičky alebo štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071320'),
('02071330', '----- Celé krídla, so špičkami alebo bez špičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071330'),
('02071340', '----- Chrbty, krky, chrbty s krkmi, trtáče a špičky krídel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071340'),
('02071350', '----- Prsia a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071350'),
('02071360', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071360'),
('02071370', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071370'),
('02071370:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071370:2X'),
('02071391', '---- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071391'),
('02071399', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071399'),
('020714', '-- Kusy a droby, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020714'),
('020714:2X', '--- Kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020714:2X'),
('02071410', '---- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071410'),
('02071410:2X', '---- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071410:2X'),
('02071420', '----- Polovičky alebo štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071420'),
('02071430', '----- Celé krídla, so špičkami alebo bez špičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071430'),
('02071440', '----- Chrbty, krky, chrbty s krkmi, trtáče a špičky krídel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071440'),
('02071450', '----- Prsia a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071450'),
('02071460', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071460'),
('02071470', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071470'),
('02071470:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071470:2X'),
('02071491', '---- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071491'),
('02071499', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071499'),
('02071499:2X', '- Z moriakov a moriek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02071499:2X'),
('020724', '-- V celku, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020724'),
('02072410', '--- Ošklbané a vypitvané, bez hlavy a nôžok, ale s krkom, srdcom, pečeňou a svalnatým žalúdkom, známe ako "morky 80 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072410'),
('02072490', '--- Ošklbané a vypitvané, bez hlavy a nôžok a bez krku, srdca, pečene a svalnatého žalúdka, známe ako "morky 73 %", alebo inak predkladané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072490'),
('020725', '-- V celku, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020725'),
('02072510', '--- Ošklbané a vypitvané, bez hlavy a nôžok, ale s krkom, srdcom, pečeňou a svalnatým žalúdkom, známe ako "morky 80 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072510'),
('02072590', '--- Ošklbané a vypitvané, bez hlavy a nôžok a bez krku, srdca, pečene a svalnatého žalúdka, známe ako "morky 73 %", alebo inak predkladané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072590'),
('020726', '-- Kusy a droby, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020726'),
('020726:2X', '--- Kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020726:2X'),
('02072610', '---- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072610'),
('02072610:2X', '---- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072610:2X'),
('02072620', '----- Polovičky alebo štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072620'),
('02072630', '----- Celé krídla, so špičkami alebo bez špičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072630'),
('02072640', '----- Chrbty, krky, chrbty s krkmi, trtáče a špičky krídel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072640'),
('02072650', '----- Prsia a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072650'),
('02072650:2X', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072650:2X'),
('02072660', '------ Dolné stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072660'),
('02072670', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072670'),
('02072680', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072680'),
('02072680:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072680:2X'),
('02072691', '---- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072691'),
('02072699', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072699'),
('020727', '-- Kusy a droby, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020727'),
('020727:2X', '--- Kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020727:2X'),
('02072710', '---- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072710'),
('02072710:2X', '---- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072710:2X'),
('02072720', '----- Polovičky alebo štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072720'),
('02072730', '----- Celé krídla, so špičkami alebo bez špičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072730'),
('02072740', '----- Chrbty, krky, chrbty s krkmi, trtáče a špičky krídel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072740'),
('02072750', '----- Prsia a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072750'),
('02072750:2X', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072750:2X'),
('02072760', '------ Dolné stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072760'),
('02072770', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072770'),
('02072780', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072780'),
('02072780:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072780:2X'),
('02072791', '---- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072791'),
('02072799', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072799'),
('02072799:2X', '- Z kačíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02072799:2X'),
('020741', '-- V celku, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020741'),
('02074120', '--- Ošklbané, odkrvené, zbavené čriev, ale nie celkom vypitvané, s hlavou a nôžkami, známe ako "kačice 85 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074120'),
('02074130', '--- Ošklbané a vypitvané, bez hlavy a nôžok, ale s krkom, srdcom, pečeňou a svalnatým žalúdkom, známe ako "kačice 70 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074130'),
('02074180', '--- Ošklbané a vypitvané, bez hlavy a nôžok a bez krku srdca, pečene a svalnatého žalúdka, známe ako "kačice 63 %", alebo inak predkladané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074180'),
('020742', '-- V celku, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020742'),
('02074230', '--- Ošklbané a vypitvané, bez hlavy a nôžok, ale s krkom, srdcom, pečeňou a svalnatým žalúdkom, známe ako "kačice 70 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074230'),
('02074280', '--- Ošklbané a vypitvané, bez hlavy a nôžok a bez krku srdca, pečene a svalnatého žalúdka, známe ako "kačice 63 %", alebo inak predkladané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074280'),
('02074300', '-- Pečene z kŕmnych kačíc, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074300'),
('020744', '-- Ostatné, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020744'),
('020744:2X', '--- Kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020744:2X'),
('02074410', '---- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074410'),
('02074410:2X', '---- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074410:2X'),
('02074421', '----- Polovičky alebo štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074421'),
('02074431', '----- Celé krídla, so špičkami alebo bez špičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074431'),
('02074441', '----- Chrbty, krky, chrbty s krkmi, trtáče a špičky krídel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074441'),
('02074451', '----- Prsia a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074451'),
('02074461', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074461'),
('02074471', '----- Kačacie paletá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074471'),
('02074481', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074481'),
('02074481:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074481:2X'),
('02074491', '---- Pečene, iné ako pečene z kŕmnych kačíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074491'),
('02074499', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074499'),
('020745', '-- Ostatné, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020745'),
('020745:2X', '--- Kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020745:2X'),
('02074510', '---- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074510'),
('02074510:2X', '---- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074510:2X'),
('02074521', '----- Polovičky alebo štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074521'),
('02074531', '----- Celé krídla, so špičkami alebo bez špičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074531'),
('02074541', '----- Chrbty, krky, chrbty s krkmi, trtáče a špičky krídel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074541'),
('02074551', '----- Prsia a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074551'),
('02074561', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074561'),
('02074571', '----- Kačacie paletá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074571'),
('02074581', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074581'),
('02074581:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074581:2X'),
('02074581:3X', '---- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074581:3X'),
('02074593', '----- Pečene z kŕmnych kačíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074593'),
('02074595', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074595'),
('02074599', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074599'),
('02074599:2X', '- Z husí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02074599:2X'),
('020751', '-- V celku, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020751'),
('02075110', '--- Ošklbané, odkrvené, ale nie vypitvané, s hlavou a nôžkami, známe ako "husi 82 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075110'),
('02075190', '--- Ošklbané a vypitvané, bez hlavy a nôžok, so srdcom a svalnatým žalúdkom alebo bez nich, známe ako "husi 75 %", alebo inak predkladané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075190'),
('020752', '-- V celku, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020752'),
('02075210', '--- Ošklbané, odkrvené, ale nie vypitvané, s hlavou a nôžkami, známe ako "husi 82 %"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075210'),
('02075290', '--- Ošklbané a vypitvané, bez hlavy a nôžok, so srdcom a svalnatým žalúdkom alebo bez nich, známe ako "husi 75 %", alebo inak predkladané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075290'),
('02075300', '-- Pečene z kŕmnych husí, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075300'),
('020754', '-- Ostatné, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020754'),
('020754:2X', '--- Kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020754:2X'),
('02075410', '---- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075410'),
('02075410:2X', '---- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075410:2X'),
('02075421', '----- Polovičky alebo štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075421'),
('02075431', '----- Celé krídla, so špičkami alebo bez špičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075431'),
('02075441', '----- Chrbty, krky, chrbty s krkmi, trtáče a špičky krídel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075441'),
('02075451', '----- Prsia a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075451'),
('02075461', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075461'),
('02075471', '----- Husacie paletá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075471'),
('02075481', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075481'),
('02075481:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075481:2X'),
('02075491', '---- Pečene, iné ako pečene z kŕmnych husi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075491'),
('02075499', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075499'),
('020755', '-- Ostatné, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020755'),
('020755:2X', '--- Kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020755:2X'),
('02075510', '---- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075510'),
('02075510:2X', '---- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075510:2X'),
('02075521', '----- Polovičky alebo štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075521'),
('02075531', '----- Celé krídla, so špičkami alebo bez špičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075531'),
('02075541', '----- Chrbty, krky, chrbty s krkmi, trtáče a špičky krídel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075541'),
('02075551', '----- Prsia a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075551'),
('02075561', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075561'),
('02075571', '----- Husacie paletá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075571'),
('02075581', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075581'),
('02075581:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075581:2X'),
('02075581:3X', '---- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075581:3X'),
('02075593', '----- Pečene z kŕmnych', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075593'),
('02075595', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075595'),
('02075599', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02075599'),
('020760', '- Z perličiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020760'),
('02076005', '-- V celku, čerstvé, chladené alebo mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076005'),
('02076005:2X', '-- Ostatné, čerstvé, chladené alebo mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076005:2X'),
('02076005:3X', '--- Kusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076005:3X'),
('02076010', '---- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076010'),
('02076010:2X', '---- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076010:2X'),
('02076021', '----- Polovičky alebo štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076021'),
('02076031', '----- Celé krídla, so špičkami alebo bez špičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076031'),
('02076041', '----- Chrbty, krky, chrbty s krkmi, trtáče a špičky krídel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076041'),
('02076051', '----- Prsia a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076051'),
('02076061', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076061'),
('02076081', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076081'),
('02076081:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076081:2X'),
('02076091', '---- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076091'),
('02076099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02076099'),
('0208', 'Ostatné mäso a jedlé mäsové droby, čerstvé, chladené alebo mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0208'),
('020810', '- Z králikov alebo zajacov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020810'),
('02081010', '-- Z domácich králikov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02081010'),
('02081090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02081090'),
('02083000', '- Z primátov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02083000'),
('020840', '- Z veľrýb, delfínov a sviňúch (cicavce radu Cetacea); z lamantínov a dugongov (cicavce radu Sirenia); z tuleňov, uškatcov a mrožov (cicavce podradu Pinnipedia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020840'),
('02084010', '-- Mäso z veľrýb', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02084010'),
('02084020', '-- Mäso z tuleňov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02084020'),
('02084080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02084080'),
('02085000', '- Z plazov (vrátane hadov a korytnačiek)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02085000'),
('02086000', '- Z tiav a ostatných ťavovitých (Camelidae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02086000'),
('020890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020890'),
('02089010', '-- Z domácich holubov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02089010'),
('02089030', '-- Zo zveriny, inej ako z králikov alebo zajacov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02089030'),
('02089060', '-- Zo sobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02089060'),
('02089070', '-- Žabacie stehienka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02089070'),
('02089098', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02089098'),
('0209', 'Prasací tuk, neprerastaný chudým mäsom, a hydinový tuk, nevyškvarený ani inak neextrahovaný, čerstvý, chladený, mrazený, solený, v slanom náleve, sušený alebo údený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0209'),
('020910', '- Z prasiat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020910'),
('020910:2X', '-- Podkožný prasací tuk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_020910:2X'),
('02091011', '--- Čerstvý, chladený, mrazený, solený alebo v slanom náleve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02091011'),
('02091019', '--- Sušený alebo údený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02091019'),
('02091090', '-- Prasací tuk, iný ako tuk podpoložky 0209 10 11 alebo 0209 10 19', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02091090'),
('02099000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02099000'),
('0210', 'Mäso a jedlé mäsové droby, solené, v slanom náleve, sušené alebo údené; jedlé múčky a prášky z mäsa alebo mäsových drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0210'),
('0210:2X', '- Mäso zo svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0210:2X'),
('021011', '-- Stehná, pliecka a kusy z nich, nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021011'),
('021011:2X', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021011:2X'),
('021011:3X', '---- Solené alebo v slanom náleve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021011:3X'),
('02101111', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101111'),
('02101119', '----- Pliecka a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101119'),
('02101119:2X', '---- Sušené alebo údené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101119:2X'),
('02101131', '----- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101131'),
('02101139', '----- Pliecka a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101139'),
('02101190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101190'),
('021012', '-- Bôčiky (prerastené) a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021012'),
('021012:2X', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021012:2X'),
('02101211', '---- Solené alebo v slanom náleve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101211'),
('02101219', '---- Sušené alebo údené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101219'),
('02101290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101290'),
('021019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021019'),
('021019:2X', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021019:2X'),
('021019:3X', '---- Solené alebo v slanom náleve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021019:3X'),
('02101910', '----- Slaninové boky alebo predné tri štvrtiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101910'),
('02101920', '----- Zadné tri štvrtiny alebo stredy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101920'),
('02101930', '----- Predné časti a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101930'),
('02101940', '----- Chrbty a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101940'),
('02101950', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101950'),
('02101950:2X', '---- Sušené alebo údené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101950:2X'),
('02101960', '----- Predné časti a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101960'),
('02101970', '----- Chrbty a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101970'),
('02101970:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101970:2X'),
('02101981', '------ Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101981'),
('02101989', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101989'),
('02101990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02101990'),
('021020', '- Mäso z hovädzích zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021020'),
('02102010', '-- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02102010'),
('02102090', '-- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02102090'),
('02102090:2X', '- Ostatné, vrátane jedlých múčok a práškov z mäsa alebo mäsových drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02102090:2X'),
('02109100', '-- Z primátov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109100'),
('021092', '-- Z veľrýb, delfínov a sviňúch (cicavce radu Cetacea); z lamantínov a dugongov (cicavce radu Sirenia); z tuleňov, uškatcov a mrožov (cicavce podradu Pinnipedia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021092'),
('02109210', '--- Z veľrýb, delfínov a sviňúch (cicavce radu Cetacea); z lamantínov a dugongov (cicavce radu Sirenia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109210'),
('02109210:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109210:2X'),
('02109291', '---- Mäso', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109291'),
('02109292', '---- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109292'),
('02109299', '---- Jedlé múčky a prášky z mäsa alebo mäsových drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109299'),
('02109300', '-- Z plazov (vrátane hadov a korytnačiek)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109300'),
('021099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021099'),
('021099:2X', '--- Mäso', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_021099:2X'),
('02109910', '---- Z koní, solené, v slanom náleve alebo sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109910'),
('02109910:2X', '---- Z oviec a kôz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109910:2X'),
('02109921', '----- Nevykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109921'),
('02109929', '----- Vykostené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109929'),
('02109931', '---- Zo sobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109931'),
('02109939', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109939'),
('02109939:2X', '--- Droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109939:2X'),
('02109939:3X', '---- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109939:3X'),
('02109941', '----- Pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109941'),
('02109949', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109949'),
('02109949:2X', '---- Z hovädzích zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109949:2X'),
('02109951', '----- Hrubá bránica a tenká bránica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109951'),
('02109959', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109959'),
('02109959:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109959:2X'),
('02109959:3X', '----- Hydinová pečeň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109959:3X'),
('02109971', '------ Pečene z kŕmnych husí alebo kačíc, solené alebo v slanom náleve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109971'),
('02109979', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109979'),
('02109985', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109985'),
('02109990', '--- Jedlé múčky a prášky z mäsa alebo mäsových drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_02109990'),
('0301', 'Živé ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0301'),
('0301:2X', '- Ozdobné ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0301:2X'),
('03011100', '-- Sladkovodné ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03011100'),
('03011900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03011900'),
('03011900:2X', '- Ostatné živé ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03011900:2X'),
('030191', '-- Pstruhy (Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache a Oncorhynchus chrysogaster)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030191'),
('03019110', '--- Druhov Oncorhynchus apache alebo Oncorhynchus chrysogaster', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019110'),
('03019190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019190'),
('030192', '-- Úhory (Anguilla spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030192'),
('03019210', '--- S dĺžkou menej ako 12 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019210'),
('03019230', '--- S dĺžkou 12 cm alebo viac, ale menej ako 20 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019230'),
('03019290', '--- S dĺžkou 20 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019290'),
('03019300', '-- Kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019300'),
('030194', '-- Tuniak modroplutvý atlantický a tichomorský (Thunnus thynnus, Thunnus orientalis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030194'),
('03019410', '--- Tuniak modroplutvý atlantický (Thunnus thynnus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019410'),
('03019490', '--- Tuniak modroplutvý tichomorský (Thunnus orientalis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019490'),
('03019500', '-- Tuniaky modroplutvý južný (Thunnus maccoyii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019500'),
('030199', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030199'),
('030199:2X', '--- Sladkovodné ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030199:2X'),
('03019911', '---- Lososy tichomorské (Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou a Oncorhynchus rhodurus), losos atlantický (Salmo salar) a hlavátka obyčajná (Hucho hucho)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019911'),
('03019918', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019918'),
('03019985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03019985'),
('0302', 'Ryby, čerstvé alebo chladené, okrem rybieho filé a ostatného rybieho mäsa položky 0304', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0302'),
('0302:2X', '- Lososovité ryby, okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0302:2X'),
('030211', '-- Pstruhy (Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache a Oncorhynchus chrysogaster)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030211'),
('03021110', '--- Druhov Oncorhynchus apache a Oncorhynchus chrysogaster', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03021110'),
('03021120', '--- Druhu Oncorhynchus mykiss (pstruh dúhový), s hlavami a žiabrami, zbavené čriev, s hmotnosťou každého kusa viac ako 1,2 kg, alebo bez hláv, žiabier a čriev, s hmotnosťou každého kusa viac ako 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03021120'),
('03021180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03021180'),
('03021300', '-- Lososy tichomorské (Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou a Oncorhynchus rhodurus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03021300'),
('03021400', '-- Losos atlantický (Salmo salar) a hlavátka obyčajná (Hucho hucho)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03021400'),
('03021900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03021900'),
('03021900:2X', '- Platesovité ryby (Pleuronectidae, Bothidae, Cynoglossidae, Soleidae, Scophthalmidae a Citharidae), okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03021900:2X'),
('030221', '-- Halibuty (Reinhardtius hippoglossoides, Hippoglossus hippoglossus, Hippoglossus stenolepis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030221'),
('03022110', '--- Halibut grónsky (Reinhardtius hippoglossoides)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03022110'),
('03022130', '--- Halibut atlantický (Hippoglossus hippoglossus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03022130'),
('03022190', '--- Halibut tichomorský (Hippoglossus stenolepis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03022190'),
('03022200', '-- Platesa obyčajná (Pleuronectes platessa)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03022200'),
('03022300', '-- Morské jazyky (Solea spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03022300'),
('03022400', '-- Kambala veľká (Psetta maxima)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03022400'),
('030229', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030229'),
('03022910', '--- Kambaly (Lepidorhombus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03022910'),
('03022980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03022980'),
('03022980:2X', '- Tuniaky (rodu Thunnus), skipjack alebo bonito s pruhovaným bruchom (Euthynnus (Katsuwonus) pelamis), okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03022980:2X'),
('030231', '-- Tuniak dlhoplutvý (Thunnus alalunga)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030231'),
('03023110', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023110'),
('03023190', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023190'),
('030232', '-- Tuniak žltoplutvý (Thunnus albacares)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030232'),
('03023210', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023210'),
('03023290', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023290'),
('030233', '-- Skipjack alebo bonito s pruhovaným bruchom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030233'),
('03023310', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023310'),
('03023390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023390'),
('030234', '-- Tuniak veľkooký (Thunnus obesus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030234'),
('03023410', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023410'),
('03023490', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023490'),
('030235', '-- Tuniak modroplutvý atlantický a tichomorský (Thunnus thynnus, Thunnus orientalis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030235'),
('030235:2X', '--- Tuniak modroplutvý atlantický (Thunnus thynnus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030235:2X'),
('03023511', '---- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023511'),
('03023519', '---- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023519'),
('03023519:2X', '--- Tuniak modroplutvý tichomorský (Thunnus orientalis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023519:2X'),
('03023591', '---- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023591'),
('03023599', '---- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023599'),
('030236', '-- Tuniak modroplutvý južný (Thunnus maccoyii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030236'),
('03023610', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023610'),
('03023690', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023690'),
('030239', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030239'),
('03023920', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023920'),
('03023980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023980'),
('03023980:2X', '- Slede (Clupea harengus, Clupea pallasii), sardely (Engraulis spp.), sardinky (Sardina pilchardus, Sardinops spp.), sardinely (Sardinella spp.), šproty (Sprattus sprattus), makrely (Scomber scombrus, Scomber australasicus, Scomber japonicus), stavridy (', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03023980:2X'),
('03024100', '-- Slede (Clupea harengus, Clupea pallasii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024100'),
('03024200', '-- Sardely (Engraulis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024200'),
('030243', '-- Sardinky (Sardina pilchardus, Sardinops spp.), sardinely (Sardinella spp.), šproty (Sprattus sprattus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030243'),
('03024310', '--- Sardinky druhu Sardina pilchardus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024310'),
('03024330', '--- Sardinky rodu Sardinops; sardinely (Sardinella spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024330'),
('03024390', '--- Šproty (Sprattus sprattus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024390'),
('03024400', '-- Makrely (Scomber scombrus, Scomber australasicus, Scomber japonicus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024400'),
('030245', '-- Stavridy (Trachurus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030245'),
('03024510', '--- Stavrida ostroboká (Trachurus trachurus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024510'),
('03024530', '--- Stavrida druhu Trachurus murphyi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024530'),
('03024590', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024590'),
('03024600', '-- Kobia severná (Rachycentron canadum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024600'),
('03024700', '-- Mečiar obyčajný (Xiphias gladius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024700'),
('03024700:2X', '- Ryby čeľade Bregmacerotidae, Euclichthyidae, Gadidae, Macrouridae, Melanonidae, Merlucciidae, Moridaea Muraenolepididae, okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03024700:2X'),
('030251', '-- Tresky (Gadus morhua, Gadus ogac, Gadus macrocephalus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030251'),
('03025110', '--- Druhu Gadus morhua', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025110'),
('03025190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025190'),
('03025200', '-- Treska jednoškvrná (Melanogrammus aeglefinus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025200'),
('03025300', '-- Treska tmavá (Pollachius virens)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025300'),
('030254', '-- Merlúzy (Merluccius spp., Urophycis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030254'),
('030254:2X', '--- Merlúzy rodu Merluccius', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030254:2X'),
('03025411', '---- Merlúza plytčinová (Merluccius capensis) a merlúza hlbinná (Merluccius paradoxus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025411'),
('03025415', '---- Merlúza južná (Merluccius australis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025415'),
('03025419', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025419'),
('03025490', '--- Merlúzy rodu Urophycis', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025490'),
('03025500', '-- Treska aljašská (Theragra chalcogramma)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025500'),
('03025600', '-- Tresky modrasté (Micromesistius poutassou, Micromesistius australis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025600'),
('030259', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030259'),
('03025910', '--- Treska polárna (Boreogadus saida)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025910'),
('03025920', '--- Treska merlang (Merlangius merlangus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025920'),
('03025930', '--- Treska európska (Pollachius pollachius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025930'),
('03025940', '--- Miene (Molva spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025940'),
('03025990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025990'),
('03025990:2X', '- Tilapie (Oreochromis spp.), sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus), úhory (Anguilla spp', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03025990:2X'),
('03027100', '-- Tilapie (Oreochromis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03027100'),
('03027200', '-- Sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03027200'),
('03027300', '-- Kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03027300'),
('03027400', '-- Úhory (Anguilla spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03027400'),
('03027900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03027900'),
('03027900:2X', '- Ostatné ryby, okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03027900:2X'),
('030281', '-- Malé žraloky a ostatné žraloky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030281'),
('03028110', '--- Žralok ostnatý (Squalus acanthias)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028110'),
('03028120', '--- Žraloky druhu Scyliorhinus spp.', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028120'),
('03028130', '--- Žralok sleďový (Lamna nasus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028130'),
('03028190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028190'),
('03028200', '-- Rajotvaré (Rajidae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028200'),
('03028300', '-- Zubáče (Dissostichus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028300'),
('030284', '-- Ostrieže (Dicentrarchus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030284'),
('03028410', '--- Ostriež morský (Dicentrarchus labrax)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028410'),
('03028490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028490'),
('030285', '-- Zubaticovité (Sparidae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030285'),
('03028510', '--- Zubatice (Dentex dentex a Pagellus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028510'),
('03028530', '--- Pražma zlatá (Sparus aurata)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028530'),
('03028590', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028590'),
('030289', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030289'),
('03028910', '--- Sladkovodné ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028910'),
('03028910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028910:2X'),
('03028910:3X', '---- Ryby rodu Euthynnus, iné ako skipjack alebo bonito s pruhovaným bruchom (Euthynnus (Katsuwonus) pelamis) uvedené v podpoložke 0302 33', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028910:3X'),
('03028921', '----- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028921'),
('03028929', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028929'),
('03028929:2X', '---- Sebastesy (Sebastes spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028929:2X'),
('03028931', '----- Sebastes červený (Sebastes marinus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028931'),
('03028939', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028939'),
('03028940', '---- Pražmy (Brama spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028940'),
('03028950', '---- Čerty morské (Lophius spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028950'),
('03028960', '---- Treska kráľovská (Genypterus blacodes)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028960'),
('03028990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03028990'),
('03029000', '- Pečene, ikry a mliečie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03029000'),
('0303', 'Ryby, mrazené, okrem rybieho filé a ostatného rybieho mäsa položky 0304', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0303'),
('0303:2X', '- Lososovité ryby, okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0303:2X'),
('03031100', '-- Losos nerka (Oncorhynchus nerka)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03031100'),
('03031200', '-- Ostatné lososy tichomorské (Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou a Oncorhynchus rhodurus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03031200'),
('03031300', '-- Losos atlantický (Salmo salar) a hlavátka obyčajná (Hucho hucho)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03031300'),
('030314', '-- Pstruhy (Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache a Oncorhynchus chrysogaster)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030314'),
('03031410', '--- Druhov Oncorhynchus apache alebo Oncorhynchus chrysogaster', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03031410'),
('03031420', '--- Druhu Oncorhynchus mykiss (pstruh dúhový), s hlavou a žiabrami, zbavené čriev, s hmotnosťou každého kusa viac ako 1,2 kg, alebo bez hláv, žiabier a čriev, s hmotnosťou každého kusa viac ako 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03031420'),
('03031490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03031490'),
('03031900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03031900'),
('03031900:2X', '- Tilapie (Oreochromis spp.), sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus), úhory (Anguilla spp', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03031900:2X'),
('03032300', '-- Tilapie (Oreochromis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03032300'),
('03032400', '-- Sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03032400'),
('03032500', '-- Kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03032500'),
('03032600', '-- Úhory (Anguilla spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03032600'),
('03032900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03032900'),
('03032900:2X', '- Platesovité ryby (Pleuronectidae, Bothidae, Cynoglossidae, Soleidae, Scophthalmidae a Citharidae), okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03032900:2X'),
('030331', '-- Halibuty (Reinhardtius hippoglossoides, Hippoglossus hippoglossus, Hippoglossus stenolepis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030331'),
('03033110', '--- Halibut grónsky (Reinhardtius hippoglossoides)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033110'),
('03033130', '--- Halibut atlantický (Hippoglossus hippoglossus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033130'),
('03033190', '--- Halibut tichomorský (Hippoglossus stenolepis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033190'),
('03033200', '-- Platesa obyčajná (Pleuronectes platessa)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033200'),
('03033300', '-- Morské jazyky (Solea spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033300'),
('03033400', '-- Kambala veľká (Psetta maxima)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033400'),
('030339', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030339'),
('03033910', '--- Platesa bradavičnatá (Platichthys flesus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033910'),
('03033930', '--- Ryby rodu Rhombosolea', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033930'),
('03033950', '--- Ryby druhov Pelotreis flavilatus alebo Peltorhamphus novaezelandiae', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033950'),
('03033985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033985'),
('03033985:2X', '- Tuniaky (rodu Thunnus), skipjack alebo bonito s pruhovaným bruchom (Euthynnus (Katsuwonus) pelamis), okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03033985:2X'),
('030341', '-- Tuniak dlhoplutvý (Thunnus alalunga)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030341'),
('03034110', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034110'),
('03034190', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034190'),
('030342', '-- Tuniak žltoplutvý (Thunnus albacares)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030342'),
('030342:2X', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030342:2X'),
('030342:3X', '---- Celé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030342:3X'),
('03034212', '----- S hmotnosťou každého kusa viac ako 10 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034212'),
('03034218', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034218'),
('03034218:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034218:2X'),
('03034242', '----- S hmotnosťou každého kusa viac ako 10 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034242'),
('03034248', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034248'),
('03034290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034290'),
('030343', '-- Skipjack alebo bonito s pruhovaným bruchom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030343'),
('03034310', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034310'),
('03034390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034390'),
('030344', '-- Tuniak veľkooký (Thunnus obesus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030344'),
('03034410', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034410'),
('03034490', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034490'),
('030345', '-- Tuniak modroplutvý atlantický a tichomorský (Thunnus thynnus, Thunnus orientalis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030345'),
('030345:2X', '--- Tuniak modroplutvý atlantický (Thunnus thynnus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030345:2X'),
('03034512', '---- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034512'),
('03034518', '---- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034518'),
('03034518:2X', '--- Tuniak modroplutvý tichomorský (Thunnus orientalis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034518:2X'),
('03034591', '---- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034591'),
('03034599', '---- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034599'),
('030346', '-- Tuniak modroplutvý južný (Thunnus maccoyii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030346'),
('03034610', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034610'),
('03034690', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034690'),
('030349', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030349'),
('03034920', '--- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034920'),
('03034985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034985'),
('03034985:2X', '- Slede (Clupea harengus, Clupea pallasii), sardinky (Sardina pilchardus, Sardinops spp.), sardinely (Sardinella spp.), šproty (Sprattus sprattus), makrely (Scomber scombrus, Scomber australasicus, Scomber japonicus), stavridy (Trachurus spp.), kobia sev', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03034985:2X'),
('03035100', '-- Slede (Clupea harengus, Clupea pallasii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035100'),
('030353', '-- Sardinky (Sardina pilchardus, Sardinops spp.), sardinely (Sardinella spp.), šproty (Sprattus sprattus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030353'),
('03035310', '--- Sardinka európska (Sardina pilchardus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035310'),
('03035330', '--- Sardinky rodu Sardinops; sardinely (Sardinella spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035330'),
('03035390', '--- Šproty (Sprattus sprattus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035390'),
('030354', '-- Makrely (Scomber scombrus, Scomber australasicus, Scomber japonicus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030354'),
('03035410', '--- Makrela atlantická (Scomber scombrus) alebo makrela japonská (Scomber japonicus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035410'),
('03035490', '--- Makrela austrálska (Scomber australasicus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035490'),
('030355', '-- Stavridy (Trachurus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030355'),
('03035510', '--- Stavrida ostroboká (Trachurus trachurus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035510'),
('03035530', '--- Stavrida druhu Trachurus murphyi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035530'),
('03035590', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035590'),
('03035600', '-- Kobia severná (Rachycentron canadum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035600'),
('03035700', '-- Mečiar obyčajný (Xiphias gladius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035700'),
('03035700:2X', '- Ryby čeľade Bregmacerotidae, Euclichthyidae, Gadidae, Macrouridae, Melanonidae, Merlucciidae, Moridae a Muraenolepididae, okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03035700:2X'),
('030363', '-- Tresky (Gadus morhua, Gadus ogac, Gadus macrocephalus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030363'),
('03036310', '--- Druhu Gadus morhua', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036310'),
('03036330', '--- Druhu Gadus ogac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036330'),
('03036390', '--- Druhu Gadus macrocephalus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036390'),
('03036400', '-- Treska jednoškvrnná (Melanogrammus aeglefinus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036400'),
('03036500', '-- Treska tmavá (Pollachius virens)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036500'),
('030366', '-- Merlúzy (Merluccius spp., Urophycis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030366'),
('030366:2X', '--- Merlúzy rodu Merluccius', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030366:2X'),
('03036611', '---- Merlúza plytčinová (Merluccius capensis) a merlúza hlbinná (Merluccius paradoxus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036611'),
('03036612', '---- Merlúza argentínska (Merluccius hubbsi)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036612'),
('03036613', '---- Merlúza južná (Merluccius australis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036613'),
('03036619', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036619'),
('03036690', '--- Merlúzy rodu Urophycis', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036690'),
('03036700', '-- Treska aljašská (Theragra chalcogramma)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036700'),
('030368', '-- Tresky modrasté (Micromesistius poutassou, Micromesistius australis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030368'),
('03036810', '--- Treska modrastá (Micromesistius poutassou, Gadus poutassou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036810'),
('03036890', '--- Treska modrastá južná (Micromesistius australis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036890'),
('030369', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030369'),
('03036910', '--- Treska polárna (Boreogadus saida)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036910'),
('03036930', '--- Treska merlang (Merlangius merlangus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036930'),
('03036950', '--- Treska európska (Pollachius pollachius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036950'),
('03036970', '--- Hoki novozélandský (Macruronus novaezelandiae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036970'),
('03036980', '--- Miene (Molva spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036980'),
('03036990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036990'),
('03036990:2X', '- Ostatné ryby, okrem pečení, ikier a mliečia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03036990:2X'),
('030381', '-- Malé žraloky a ostatné žraloky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030381'),
('03038110', '--- Žralok ostnatý (Squalus acanthias)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038110'),
('03038120', '--- Žraloky druhov Scyliorhinus spp.', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038120'),
('03038130', '--- Žralok sleďový (Lamna nasus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038130'),
('03038190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038190'),
('03038200', '-- Rajotvaré (Rajidae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038200'),
('03038300', '-- Zubáče (Dissostichus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038300'),
('030384', '-- Ostrieže (Dicentrarchus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030384'),
('03038410', '--- Ostriež morský (Dicentrarchus labrax)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038410'),
('03038490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038490'),
('030389', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030389'),
('03038910', '--- Sladkovodné ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038910'),
('03038910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038910:2X'),
('03038910:3X', '---- Ryby rodu Euthynnus, iné ako skipjack alebo bonito s pruhovaným bruchom (Euthynnus (Katsuwonus) pelamis) uvedené v podpoložke 0303 43', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038910:3X'),
('03038921', '----- Na priemyselnú výrobu výrobkov položky 1604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038921'),
('03038929', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038929'),
('03038929:2X', '---- Sebastesy (Sebastes spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038929:2X'),
('03038931', '----- Sebastes červený (Sebastes marinus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038931'),
('03038939', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038939'),
('03038940', '---- Ryby druhu Orcynopsis unicolor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038940'),
('03038945', '---- Sardely (Engraulis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038945'),
('03038950', '---- Zubatice (Dentex dentex, Pagellus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038950'),
('03038955', '---- Pražma zlatá (Sparus aurata)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038955'),
('03038960', '---- Pražmy (Brama spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038960'),
('03038965', '---- Čerty morské (Lophius spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038965'),
('03038970', '---- Treska kráľovská (Genypterus blacodes)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038970'),
('03038990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03038990'),
('030390', '- Pečene, ikry a mliečie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030390'),
('03039010', '-- Tuhé a jemné ikry a mliečie na výrobu kyseliny deoxyribonukleovej alebo protamínsulfátu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03039010'),
('03039090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03039090'),
('0304', 'Rybie filé a ostatné rybie mäso (tiež mleté), čerstvé, chladené alebo mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0304'),
('0304:2X', '- Čerstvé alebo chladené filé z tilapií (Oreochromis spp.), sumcov (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), kaprov (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0304:2X'),
('03043100', '-- Tilapie (Oreochromis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03043100'),
('03043200', '-- Sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03043200'),
('03043300', '-- Ostriež nílsky (Lates niloticus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03043300'),
('03043900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03043900'),
('03043900:2X', '- Čerstvé alebo chladené filé z ostatných rýb', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03043900:2X'),
('03044100', '-- Lososy tichomorské (Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou a Oncorhynchus rhodurus), losos atlantický (Salmo salar) a hlavátka obyčajná (Hucho hucho)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044100'),
('030442', '-- Pstruhy (Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache a Oncorhynchus chrysogaster)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030442'),
('03044210', '--- Zo pstruhov druhu Oncorhynchus mykiss (pstruha dúhového), s hmotnosťou každého kusa viac ako 400 g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044210'),
('03044250', '--- Druhov Oncorhynchus apache a Oncorhynchus chrysogaster', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044250'),
('03044290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044290'),
('03044300', '-- Platesovité ryby (Pleuronectidae, Bothidae, Cynoglossidae, Soleidae, Scophthalmidae a Citharidae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044300'),
('030444', '-- Ryby čeľade Bregmacerotidae, Euclichthyidae, Gadidae, Macrouridae, Melanonidae, Merlucciidae, Moridae a Muraenolepididae', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030444'),
('03044410', '--- Tresky (Gadus morhua, Gadus ogac, Gadus macrocephalus) a treska polárna (Boreogadus saida)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044410'),
('03044430', '--- Treska tmavá (Pollachius virens)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044430'),
('03044490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044490'),
('03044500', '-- Mečiar obyčajný (Xiphias gladius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044500'),
('03044600', '-- Zubáče (Dissostichus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044600'),
('030449', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030449'),
('03044910', '--- Sladkovodné ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044910'),
('03044910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044910:2X'),
('03044950', '---- Sebastesy (Sebastes spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044950'),
('03044990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044990'),
('03044990:2X', '- Ostatné, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03044990:2X'),
('03045100', '-- Tilapie (Oreochromis spp.), sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus), úhory (Anguilla sp', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045100'),
('03045200', '-- Lososovité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045200'),
('03045300', '-- Ryby čeľade Bregmacerotidae, Euclichthyidae, Gadidae, Macrouridae, Melanonidae, Merlucciidae, Moridae a Muraenolepididae', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045300'),
('03045400', '-- Mečiar obyčajný (Xiphias gladius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045400'),
('03045500', '-- Zubáče (Dissostichus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045500'),
('030459', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030459'),
('03045910', '--- Sladkovodné ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045910'),
('03045910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045910:2X'),
('03045950', '---- Priečne rezy zo sleďov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045950'),
('03045990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045990'),
('03045990:2X', '- Mrazené filé z tilapií (Oreochromis spp.), sumcov (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), kaprov (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus), úh', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03045990:2X'),
('03046100', '-- Tilapie (Oreochromis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03046100'),
('03046200', '-- Sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03046200'),
('03046300', '-- Ostriež nílsky (Lates niloticus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03046300'),
('03046900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03046900'),
('03046900:2X', '- Mrazené filé z rýb čeľade Bregmacerotidae, Euclichthyidae, Gadidae, Macrouridae, Melanonidae, Merlucciidae, Moridae a Muraenolepididae', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03046900:2X'),
('030471', '-- Tresky (Gadus morhua, Gadus ogac, Gadus macrocephalus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030471'),
('03047110', '--- Treska druhu Gadus macrocephalus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047110'),
('03047190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047190'),
('03047200', '-- Treska jednoškvrná (Melanogrammus aeglefinus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047200'),
('03047300', '-- Treska tmavá (Pollachius virens)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047300'),
('030474', '-- Merlúzy (Merluccius spp., Urophycis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030474'),
('030474:2X', '--- Merlúzy rodu Merluccius', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030474:2X'),
('03047411', '---- Merlúza plytčinová (Merluccius capensis) a merlúza hlbinná (Merluccius paradoxus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047411'),
('03047415', '---- Merlúza argentínska (Merluccius hubbsi)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047415'),
('03047419', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047419'),
('03047490', '--- Merlúzy rodu Urophycis', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047490'),
('03047500', '-- Treska aljašská (Theragra chalcogramma)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047500'),
('030479', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030479'),
('03047910', '--- Treska polárna (Boreogadus saida)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047910'),
('03047930', '--- Treska merlang (Merlangius merlangus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047930'),
('03047950', '--- Hoki novozélandský (Macruronus novaezelandiae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047950'),
('03047980', '--- Miene (Molva spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047980'),
('03047990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047990'),
('03047990:2X', '- Mrazené filé z ostatných rýb', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03047990:2X'),
('03048100', '-- Lososy tichomorské (Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou a Oncorhynchus rhodurus), losos atlantický (Salmo salar) a hlavátka obyčajná (Hucho hucho)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048100'),
('030482', '-- Pstruhy (Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache a Oncorhynchus chrysogaster)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030482'),
('03048210', '--- Zo pstruhov druhu Oncorhynchus mykiss (pstruha dúhového), s hmotnosťou každého kusa viac ako 400 g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048210'),
('03048250', '--- Druhov Oncorhynchus apache a Oncorhynchus chrysogaster', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048250'),
('03048290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048290'),
('030483', '-- Platesovité ryby (Pleuronectidae, Bothidae, Cynoglossidae, Soleidae, Scophthalmidae a Citharidae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030483'),
('03048310', '--- Platesa veľká (Pleuronectes platessa)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048310'),
('03048330', '--- Platesa bradavičnatá (Platichthys flesus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048330'),
('03048350', '--- Kambaly (Lepidorhombus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048350'),
('03048390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048390'),
('03048400', '-- Mečiar obyčajný (Xiphias gladius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048400'),
('03048500', '-- Zubáče (Dissostichus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048500'),
('03048600', '-- Slede (Clupea harengus, Clupea pallasii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048600'),
('03048700', '-- Tuniaky (rodu Thunnus), skipjack alebo bonito s pruhovaným bruchom (Euthynnus (Katsuwonus) pelamis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048700'),
('030489', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030489'),
('03048910', '--- Sladkovodné ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048910'),
('03048910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048910:2X'),
('03048910:3X', '---- Sebastesy (Sebastes spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048910:3X'),
('03048921', '----- Sebastes červený (Sebastes marinus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048921'),
('03048929', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048929'),
('03048930', '---- Ryby rodu Euthynnus, iné ako skipjack alebo bonito s pruhovaným bruchom (Euthynnus (Katsuwonus) pelamis) uvedené v podpoložke 0304 87 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048930'),
('03048930:2X', '---- Makrely (Scomber scombrus, Scomber australasicus, Scomber japonicus) a rýb druhu Orcynopsis unicolor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048930:2X'),
('03048941', '----- Makrela austrálska (Scomber australasicus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048941'),
('03048949', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048949'),
('03048949:2X', '---- Malé žraloky a ostatné žraloky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048949:2X'),
('03048951', '----- Žralok ostnatý (Squalus acanthias) a žraloky druhu Scyliorhinus spp.', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048951'),
('03048955', '----- Žralok sleďový (Lamna nasus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048955'),
('03048959', '----- Ostatné žraloky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048959'),
('03048960', '---- Čerty morské (Lophius spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048960'),
('03048990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048990'),
('03048990:2X', '- Ostatné, zmrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03048990:2X'),
('03049100', '-- Mečiar obyčajný (Xiphias gladius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049100'),
('03049200', '-- Zubáče (Dissostichus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049200'),
('030493', '-- Tilapie (Oreochromis spp.), sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus), úhory (Anguilla sp', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030493'),
('03049310', '--- Surimi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049310'),
('03049390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049390'),
('030494', '-- Treska aljašská (Theragra chalcogramma)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030494'),
('03049410', '--- Surimi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049410'),
('03049490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049490'),
('030495', '-- Ryby čeľade Bregmacerotidae, Euclichthyidae, Gadidae, Macrouridae, Melanonidae, Merlucciidae, Moridae a Muraenolepididae, iné ako treska aljašská (Theragra chalcogramma)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030495'),
('03049510', '--- Surimi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049510'),
('03049510:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049510:2X'),
('03049510:3X', '---- Tresky (Gadus morhua, Gadus ogac, Gadus macrocephalus) a treska polárna (Boreogadus saida)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049510:3X'),
('03049521', '----- Treska druhu Gadus macrocephalus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049521'),
('03049525', '----- Treska druhu Gadus morhua', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049525'),
('03049529', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049529'),
('03049530', '---- Treska jednoškvrná (Melanogrammus aeglefinus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049530'),
('03049540', '---- Treska tmavá (Pollachius virens)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049540'),
('03049550', '---- Merlúzy rodu Merluccius', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049550'),
('03049560', '---- Tresky modrasté (Micromesistius poutassou, Gadus poutassou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049560'),
('03049590', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049590'),
('030499', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030499'),
('03049910', '--- Surimi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049910'),
('03049910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049910:2X'),
('03049921', '---- Sladkovodné ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049921'),
('03049921:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049921:2X'),
('03049923', '----- Slede (Clupea harengus, Clupea pallasii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049923'),
('03049929', '----- Sebastesy (Sebastes spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049929'),
('03049955', '----- Kambaly (Lepidorhombus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049955'),
('03049961', '----- Pražmy (Brama spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049961'),
('03049965', '----- Čerty morské (Lophius spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049965'),
('03049999', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03049999'),
('0305', 'Ryby sušené, solené alebo v slanom náleve; údené ryby, tiež varené pred údením alebo počas údenia; prášky, múčky a pelety z rýb, vhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0305'),
('03051000', '- Prášky, múčky a pelety z rýb, vhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03051000'),
('03052000', '- Pečene, ikry a mliečie z rýb, sušené, údené, solené alebo v slanom náleve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03052000'),
('03052000:2X', '- Rybie filé sušené, solené alebo v slanom náleve, ale neúdené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03052000:2X'),
('03053100', '-- Tilapie (Oreochromis spp.), sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus), úhory (Anguilla sp', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03053100'),
('030532', '-- Ryby čeľade Bregmacerotidae, Euclichthyidae, Gadidae, Macrouridae, Melanonidae, Merlucciidae, Moridae a Muraenolepididae', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030532'),
('030532:2X', '--- Tresky (Gadus morhua, Gadus ogac, Gadus macrocephalus) a treska polárna (Boreogadus saida)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030532:2X'),
('03053211', '---- Treska druhu Gadus macrocephalus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03053211'),
('03053219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03053219'),
('03053290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03053290'),
('030539', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030539'),
('03053910', '--- Lososy tichomorské (Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou a Oncorhynchus rhodurus), losos atlantický (Salmo salar) a hlavátka obyčajná (Hucho hucho), solené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03053910'),
('03053950', '--- Halibut grónsky (Reinhardtius hippoglossoides), solený alebo v slanom náleve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03053950'),
('03053990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03053990'),
('03053990:2X', '- Údené ryby, vrátane filé, okrem jedlých rybích drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03053990:2X'),
('03054100', '-- Lososy tichomorské (Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou a Oncorhynchus rhodurus), losos atlantický (Salmo salar) a hlavátka obyčajná (Hucho hucho)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054100'),
('03054200', '-- Slede (Clupea harengus, Clupea pallasii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054200'),
('03054300', '-- Pstruhy (Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache a Oncorhynchus chrysogaster)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054300'),
('030544', '-- Tilapie (Oreochromis spp.), sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus), úhory (Anguilla sp', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030544'),
('03054410', '--- Úhory (Anguilla spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054410'),
('03054490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054490'),
('030549', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030549'),
('03054910', '--- Halibut grónsky (Reinhardtius hippoglossoides)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054910'),
('03054920', '--- Halibut atlantický (Hippoglossus hippoglossus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054920'),
('03054930', '--- Makrely (Scomber scombrus, Scomber australasicus, Scomber japonicus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054930'),
('03054980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054980'),
('03054980:2X', '- Sušené ryby, okrem jedlých rybích drobov, tiež solené, ale neúdené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03054980:2X'),
('030551', '-- Tresky (Gadus morhua, Gadus ogac, Gadus macrocephalus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030551'),
('03055110', '--- Sušené, nesolené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03055110'),
('03055190', '--- Sušené, solené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03055190'),
('030559', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030559'),
('03055910', '--- Ryby druhu Boreogadus saida', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03055910'),
('03055930', '--- Slede (Clupea harengus, Clupea pallasii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03055930'),
('03055950', '--- Sardely (Engraulis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03055950'),
('03055970', '--- Halibut atlantický (Hippoglossus hippoglossus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03055970'),
('03055980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03055980'),
('03055980:2X', '- Ryby, solené, ale nesušené ani neúdené, a ryby v slanom náleve, okrem jedlých rybích drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03055980:2X'),
('03056100', '-- Slede (Clupea harengus, Clupea pallasii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03056100'),
('03056200', '-- Tresky (Gadus morhua, Gadus ogac, Gadus macrocephalus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03056200'),
('03056300', '-- Sardely (Engraulis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03056300'),
('03056400', '-- Tilapie (Oreochromis spp.), sumce (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), kapry (Cyprinus carpio, Carassius carassius, Ctenopharyngodon idellus, Hypophthalmichthys spp., Cirrhinus spp., Mylopharyngodon piceus), úhory (Anguilla sp', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03056400'),
('030569', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030569'),
('03056910', '--- Ryby druhu Boreogadus saida', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03056910'),
('03056930', '--- Halibut atlantický (Hippoglossus hippoglossus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03056930'),
('03056950', '--- Lososy tichomorské (Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou a Oncorhynchus rhodurus), losos atlantický (Salmo salar) a hlavátka obyčajná (Hucho hucho)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03056950'),
('03056980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03056980'),
('03056980:2X', '- Rybie plutvy, hlavy, chvosty, žalúdky a ostatné jedlé rybie droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03056980:2X'),
('030571', '-- Žraločie plutvy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030571'),
('03057110', '--- Údené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03057110'),
('03057190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03057190'),
('03057200', '-- Rybie hlavy, chvosty a žalúdky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03057200'),
('03057900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03057900'),
('0306', 'Kôrovce, tiež bez panciera, živé, čerstvé, chladené, mrazené, sušené, solené alebo v slanom náleve; údené kôrovce, tiež v pancieroch, tiež varené pred údením alebo počas údenia; kôrovce, v pancieroch, varené vo vode alebo v pare, tiež chladené, mrazené,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0306'),
('0306:2X', '- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0306:2X'),
('030611', '-- Langusty a ostatné morské raky (Palinurus spp., Panulirus spp., Jasus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030611'),
('03061105', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061105'),
('03061105:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061105:2X'),
('03061110', '---- Langustie chvostíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061110'),
('03061190', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061190'),
('030612', '-- Homáre (Homarus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030612'),
('03061205', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061205'),
('03061205:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061205:2X'),
('03061210', '---- Celé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061210'),
('03061290', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061290'),
('030614', '-- Kraby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030614'),
('03061405', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061405'),
('03061405:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061405:2X'),
('03061410', '---- Kraby druhov Paralithodes camchaticus, Chionoecetes spp. a Callinectes sapidus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061410'),
('03061430', '---- Kraby druhu Cancer pagurus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061430'),
('03061490', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061490'),
('030615', '-- Homáre nórske (Nephrops norvegicus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030615'),
('03061510', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061510'),
('03061590', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061590'),
('030616', '-- Studenomilné krevety a garnáty (Pandalus spp., Crangon crangon)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030616'),
('03061610', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061610'),
('03061610:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061610:2X'),
('03061691', '---- Krevety druhu Crangon crangon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061691'),
('03061699', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061699'),
('030617', '-- Ostatné krevety a garnáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030617'),
('03061710', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061710'),
('03061710:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061710:2X'),
('03061791', '---- Krevety ružové hlbinné (Parapenaeus longirostris)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061791'),
('03061792', '---- Krevety rodu Penaeus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061792'),
('03061793', '---- Krevety čeľade Pandalidae, okrem kreviet rodu Pandalus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061793'),
('03061794', '---- Krevety rodu Crangon, okrem kreviet druhu Crangon crangon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061794'),
('03061799', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061799'),
('030619', '-- Ostatné, vrátane práškov, múčok a peliet z kôrovcov, vhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030619'),
('03061905', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061905'),
('03061905:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061905:2X'),
('03061910', '---- Sladkovodné raky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061910'),
('03061990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061990'),
('03061990:2X', '- Nemrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03061990:2X'),
('030621', '-- Langusty a ostatné morské raky (Palinurus spp., Panulirus spp., Jasus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030621'),
('03062110', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062110'),
('03062190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062190'),
('030622', '-- Homáre (Homarus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030622'),
('03062210', '--- Živé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062210'),
('03062210:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062210:2X'),
('03062230', '---- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062230'),
('03062230:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062230:2X'),
('03062291', '----- Celé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062291'),
('03062299', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062299'),
('030624', '-- Kraby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030624'),
('03062410', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062410'),
('03062410:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062410:2X'),
('03062430', '---- Kraby druhu Cancer pagurus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062430'),
('03062480', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062480'),
('030625', '-- Homáre nórske (Nephrops norvegicus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030625'),
('03062510', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062510'),
('03062590', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062590'),
('030626', '-- Studenomilné krevety a garnáty (Pandalus spp., Crangon crangon)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030626'),
('03062610', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062610'),
('03062610:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062610:2X'),
('03062610:3X', '---- Krevety druhu Crangon crangon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062610:3X'),
('03062631', '----- Čerstvé alebo chladené, alebo varené vo vode alebo v pare', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062631'),
('03062639', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062639'),
('03062690', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062690'),
('030627', '-- Ostatné krevety a garnáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030627'),
('03062710', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062710'),
('03062710:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062710:2X'),
('03062791', '---- Krevety čeľade Pandalidae, okrem kreviet rodu Pandalus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062791'),
('03062795', '---- Krevety rodu Crangon, okrem kreviet druhu Crangon crangon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062795'),
('03062799', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062799'),
('030629', '-- Ostatné, vrátane práškov, múčok a peliet z kôrovcov, vhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030629'),
('03062905', '--- Údené, tiež bez panciera, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062905'),
('03062905:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062905:2X'),
('03062910', '---- Sladkovodné raky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062910'),
('03062990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03062990'),
('0307', 'Mäkkýše, tiež bez lastúr alebo ulít, živé, čerstvé, chladené, mrazené, sušené, solené alebo v slanom náleve; údené mäkkýše, tiež bez lastúr alebo ulít, tiež varené pred údením alebo počas údenia; prášky, múčky a pelety z mäkkýšov, vhodné na ľudskú konzu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0307'),
('0307:2X', '- Ustrice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0307:2X'),
('030711', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030711'),
('03071110', '--- Ustrice ploché (rodu Ostrea), živé a s hmotnosťou každého kusa (vrátane lastúry) najviac 40 g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03071110'),
('03071190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03071190'),
('030719', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030719'),
('03071910', '--- Údené, tiež bez lastúr, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03071910'),
('03071990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03071990'),
('03071990:2X', '- Hrebenatky, vrátane hrebenatky kráľovskej, rodov Pecten, Chlamys alebo Placopecten', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03071990:2X'),
('03072100', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03072100'),
('030729', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030729'),
('03072905', '--- Údené, tiež bez lastúr, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03072905'),
('03072905:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03072905:2X'),
('03072910', '---- Hrebenatky svätojakubské (Pecten maximus), mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03072910'),
('03072990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03072990'),
('03072990:2X', '- Slávky (Mytilus spp., Perna spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03072990:2X'),
('030731', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030731'),
('03073110', '--- Mytilus spp.', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03073110'),
('03073190', '--- Perna spp.', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03073190'),
('030739', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030739'),
('03073905', '--- Údené, tiež bez lastúr, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03073905'),
('03073905:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03073905:2X'),
('03073910', '---- Mytilus spp.', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03073910'),
('03073990', '---- Perna spp.', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03073990'),
('03073990:2X', '- Sépie (Sepia officinalis, Rossia macrosoma, Sepiola spp.) a kalmáre (Ommastrephes spp., Loligo spp., Nototodarus spp., Sepioteuthis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03073990:2X'),
('030741', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030741'),
('03074110', '--- Sépie (Sepia officinalis, Rossia macrosoma, Sepiola spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074110'),
('03074110:2X', '--- Kalmáre (Ommastrephes spp., Loligo spp., Nototodarus spp., Sepioteuthis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074110:2X'),
('03074191', '---- Loligo spp., Ommastrephes sagittatus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074191'),
('03074199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074199'),
('030749', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030749'),
('03074905', '--- Údené, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074905'),
('03074905:2X', '--- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074905:2X'),
('03074905:3X', '---- Sépie (Sepia officinalis, Rossia macrosoma, Sepiola spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074905:3X'),
('03074905:4X', '----- Rodu Sepiola', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074905:4X'),
('03074909', '------ Sépia menšia (Sepiola rondeleti)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074909'),
('03074911', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074911'),
('03074918', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074918'),
('03074918:2X', '---- Kalmáre (Ommastrephes spp., Loligo spp., Nototodarus spp., Sepioteuthis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074918:2X'),
('03074918:3X', '----- Loligo spp.', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074918:3X'),
('03074931', '------ Loligo vulgaris', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074931'),
('03074933', '------ Loligo pealei', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074933'),
('03074935', '------ Loligo patagonica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074935'),
('03074938', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074938'),
('03074951', '----- Ommastrephes sagittatus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074951'),
('03074959', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074959'),
('03074959:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074959:2X'),
('03074971', '---- Sépie (Sepia officinalis, Rossia macrosoma, Sepiola spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074971'),
('03074971:2X', '---- Kalmáre (Ommastrephes spp., Loligo spp., Nototodarus spp., Sepioteuthis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074971:2X'),
('03074991', '----- Loligo spp., Ommastrephes sagittatus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074991'),
('03074999', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074999'),
('03074999:2X', '- Chobotnice (Octopus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03074999:2X'),
('03075100', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03075100'),
('030759', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030759'),
('03075905', '--- Údené, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03075905'),
('03075905:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03075905:2X'),
('03075910', '---- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03075910'),
('03075990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03075990'),
('030760', '- Slimáky, iné ako morské slimáky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030760'),
('03076010', '-- Údené, tiež bez ulít, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03076010'),
('03076090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03076090'),
('03076090:2X', '- Lastúrniky, srdcovky a mušle (čeľade Arcidae, Arcticidae, Cardiidae, Donacidae, Hiatellidae, Mactridae, Mesodesmatidae, Myidae, Semelidae, Solecurtidae, Solenidae, Tridacnidae a Veneridae)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03076090:2X'),
('03077100', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03077100'),
('030779', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030779'),
('03077910', '--- Údené, tiež bez lastúr alebo ulít, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03077910'),
('03077990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03077990'),
('03077990:2X', '- Uchovce (Haliotis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03077990:2X'),
('03078100', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03078100'),
('030789', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030789'),
('03078910', '--- Údené, tiež bez ulít, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03078910'),
('03078990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03078990'),
('03078990:2X', '- Ostatné, vrátane práškov, múčok a peliet, vhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03078990:2X'),
('03079100', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03079100'),
('030799', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030799'),
('03079910', '--- Údené, tiež bez lastúr alebo ulít, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03079910'),
('03079910:2X', '--- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03079910:2X'),
('03079911', '---- Illex spp.', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03079911'),
('03079913', '---- Morské škľabky (zádenky) a ostatné druhy čeľade Veneridae', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03079913'),
('03079917', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03079917'),
('03079980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03079980'),
('0308', 'Vodné bezstavovce iné ako kôrovce a mäkkýše, živé, čerstvé, chladené, mrazené, sušené, solené alebo v slanom náleve; údené vodné bezstavovce iné ako kôrovce a mäkkýše, tiež varené pred údením alebo počas údenia; prášky, múčky a pelety z vodných bezstavo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0308'),
('0308:2X', '- Holotúrie (Stichopus japonicus, Holothurioidea)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0308:2X'),
('03081100', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03081100'),
('030819', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030819'),
('03081910', '--- Údené, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03081910'),
('03081930', '--- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03081930'),
('03081990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03081990'),
('03081990:2X', '- Ježovky (Strongylocentrotus spp., Paracentrotus lividus, Loxechinus albus, Echichinus esculentus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03081990:2X'),
('03082100', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03082100'),
('030829', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030829'),
('03082910', '--- Údené, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03082910'),
('03082930', '--- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03082930'),
('03082990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03082990'),
('030830', '- Medúzy (Rhopilema spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030830'),
('03083010', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03083010'),
('03083030', '-- Údené, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03083030'),
('03083050', '-- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03083050'),
('03083090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03083090'),
('030890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_030890'),
('03089010', '-- Živé, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03089010'),
('03089030', '-- Údené, tiež varené pred údením alebo počas údenia, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03089030'),
('03089050', '-- Mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03089050'),
('03089090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_03089090'),
('0401', 'Mlieko a smotana, nezahustené ani neobsahujúce pridaný cukor ani ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0401'),
('040110', '- S hmotnostným obsahom tuku nepresahujúcim 1 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040110'),
('04011010', '-- V bezprostrednom obale s čistým obsahom nepresahujúcim 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04011010'),
('04011090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04011090'),
('040120', '- S hmotnostným obsahom tuku presahujúcim 1 %, ale nepresahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040120'),
('040120:2X', '-- Nepresahujúcim 3 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040120:2X'),
('04012011', '--- V bezprostrednom obale s čistým obsahom nepresahujúcim 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04012011'),
('04012019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04012019'),
('04012019:2X', '-- Presahujúcim 3 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04012019:2X'),
('04012091', '--- V bezprostrednom obale s čistým obsahom nepresahujúcim 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04012091'),
('04012099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04012099'),
('040140', '- S hmotnostným obsahom tuku presahujúcim 6 %, ale nepresahujúcim 10 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040140'),
('04014010', '-- V bezprostrednom obale s čistým obsahom nepresahujúcim 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04014010'),
('04014090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04014090'),
('040150', '- S hmotnostným obsahom tuku presahujúcim 10 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040150'),
('040150:2X', '-- Nepresahujúcim 21 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040150:2X'),
('04015011', '--- V bezprostrednom obale s čistým obsahom nepresahujúcim 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04015011'),
('04015019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04015019'),
('04015019:2X', '-- Presahujúcim 21 %, ale nepresahujúcim 45 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04015019:2X'),
('04015031', '--- V bezprostrednom obale s čistým obsahom nepresahujúcim 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04015031'),
('04015039', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04015039'),
('04015039:2X', '-- Presahujúcim 45 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04015039:2X'),
('04015091', '--- V bezprostrednom obale s čistým obsahom nepresahujúcim 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04015091'),
('04015099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04015099'),
('0402', 'Mlieko a smotana, zahustené alebo obsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0402'),
('040210', '- V prášku, granulách alebo ostatných pevných formách, s hmotnostným obsahom tuku nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040210'),
('040210:2X', '-- Neobsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040210:2X'),
('04021011', '--- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04021011'),
('04021019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04021019'),
('04021019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04021019:2X'),
('04021091', '--- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04021091'),
('04021099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04021099'),
('04021099:2X', '- V prášku, granulách alebo ostatných pevných formách, s hmotnostným obsahom tuku presahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04021099:2X'),
('040221', '-- Neobsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040221'),
('040221:2X', '--- S hmotnostným obsahom tuku nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040221:2X'),
('04022111', '---- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022111'),
('04022118', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022118'),
('04022118:2X', '--- S hmotnostným obsahom tuku presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022118:2X'),
('04022191', '---- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022191'),
('04022199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022199'),
('040229', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040229'),
('040229:2X', '--- S hmotnostným obsahom tuku nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040229:2X'),
('04022911', '---- Špeciálne mlieka pre dojčatá, v hermeticky uzatvorených nádobách s čistým obsahom nepresahujúcim 500 g, s hmotnostným obsahom tuku presahujúcim 10 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022911'),
('04022911:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022911:2X'),
('04022915', '----- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022915'),
('04022919', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022919'),
('04022919:2X', '--- S hmotnostným obsahom tuku presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022919:2X'),
('04022991', '---- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022991'),
('04022999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022999'),
('04022999:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04022999:2X'),
('040291', '-- Neobsahujúce pridaný cukor ani ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040291'),
('04029110', '--- S hmotnostným obsahom tuku nepresahujúcim 8 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029110'),
('04029130', '--- S hmotnostným obsahom tuku presahujúcim 8 %, ale nepresahujúcim 10 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029130'),
('04029130:2X', '--- S hmotnostným obsahom tuku presahujúcim 10 %, ale nepresahujúcim 45 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029130:2X'),
('04029151', '---- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029151'),
('04029159', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029159'),
('04029159:2X', '--- S hmotnostným obsahom tuku presahujúcim 45 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029159:2X'),
('04029191', '---- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029191'),
('04029199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029199'),
('040299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040299'),
('04029910', '--- S hmotnostným obsahom tuku nepresahujúcim 9,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029910'),
('04029910:2X', '--- S hmotnostným obsahom tuku presahujúcim 9,5 %, ale nepresahujúcim 45 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029910:2X'),
('04029931', '---- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029931'),
('04029939', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029939'),
('04029939:2X', '--- S hmotnostným obsahom tuku presahujúcim 45 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029939:2X'),
('04029991', '---- V bezprostrednom obale s čistým obsahom nepresahujúcim 2,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029991'),
('04029999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04029999'),
('0403', 'Cmar, kyslé mlieko a smotana, jogurt, kefír a ostatné fermentované alebo acidofilné mlieko a smotana, tiež zahustené alebo obsahujúce pridaný cukor alebo ostatné sladidlá alebo ochutené alebo obsahujúce pridané ovocie, orechy alebo kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0403'),
('040310', '- Jogurt', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040310'),
('040310:2X', '-- Neochutený ani neobsahujúci pridané ovocie, orechy alebo kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040310:2X'),
('040310:3X', '--- Neobsahujúci pridaný cukor ani ostatné sladidlá, s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040310:3X'),
('04031011', '---- Nepresahujúcim 3 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031011'),
('04031013', '---- Presahujúcim 3 %, ale nepresahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031013'),
('04031019', '---- Presahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031019'),
('04031019:2X', '--- Ostatný, s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031019:2X'),
('04031031', '---- Nepresahujúcim 3 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031031'),
('04031033', '---- Presahujúcim 3 %, ale nepresahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031033'),
('04031039', '---- Presahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031039'),
('04031039:2X', '-- Ochutený alebo obsahujúci pridané ovocie, orechy alebo kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031039:2X'),
('04031039:3X', '--- V prášku, granulách alebo ostatných pevných formách, s hmotnostným obsahom mliečneho tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031039:3X'),
('04031051', '---- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031051'),
('04031053', '---- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031053'),
('04031059', '---- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031059'),
('04031059:2X', '--- Ostatný, s hmotnostným obsahom mliečneho tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031059:2X'),
('04031091', '---- Nepresahujúcim 3 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031091'),
('04031093', '---- Presahujúcim 3 %, ale nepresahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031093'),
('04031099', '---- Presahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04031099'),
('040390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040390'),
('040390:2X', '-- Neochutené ani neobsahujúce pridané ovocie, orechy alebo kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040390:2X'),
('040390:3X', '--- V prášku, granulách alebo ostatných pevných formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040390:3X'),
('040390:4X', '---- Neobsahujúce pridaný cukor ani ostatné sladidlá, s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040390:4X'),
('04039011', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039011'),
('04039013', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039013'),
('04039019', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039019'),
('04039019:2X', '---- Ostatné, s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039019:2X'),
('04039031', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039031'),
('04039033', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039033'),
('04039039', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039039'),
('04039039:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039039:2X'),
('04039039:3X', '---- Neobsahujúce pridaný cukor ani ostatné sladidlá, s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039039:3X'),
('04039051', '----- Nepresahujúcim 3 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039051'),
('04039053', '----- Presahujúcim 3 %, ale nepresahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039053'),
('04039059', '----- Presahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039059'),
('04039059:2X', '---- Ostatné, s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039059:2X'),
('04039061', '----- Nepresahujúcim 3 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039061'),
('04039063', '----- Presahujúcim 3 %, ale nepresahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039063'),
('04039069', '----- Presahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039069'),
('04039069:2X', '-- Ochutené alebo obsahujúce pridané ovocie, orechy alebo kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039069:2X'),
('04039069:3X', '--- V prášku, granulách alebo ostatných pevných formách, s hmotnostným obsahom mliečneho tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039069:3X'),
('04039071', '---- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039071'),
('04039073', '---- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039073'),
('04039079', '---- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039079'),
('04039079:2X', '--- Ostatné, s hmotnostným obsahom mliečneho tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039079:2X'),
('04039091', '---- Nepresahujúcim 3 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039091'),
('04039093', '---- Presahujúcim 3 %, ale nepresahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039093'),
('04039099', '---- Presahujúcim 6 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04039099'),
('0404', 'Srvátka, tiež zahustená alebo obsahujúca pridaný cukor alebo ostatné sladidlá; výrobky pozostávajúce z prírodných zložiek mlieka, tiež obsahujúce pridaný cukor alebo ostatné sladidlá, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0404'),
('040410', '- Srvátka a upravená srvátka, tiež zahustená alebo obsahujúca pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040410'),
('040410:2X', '-- V prášku, granulách alebo ostatných pevných formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040410:2X'),
('040410:3X', '--- Neobsahujúca pridaný cukor ani ostatné sladidlá, s hmotnostným obsahom bielkovín (obsah dusíka x 6,38)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040410:3X'),
('040410:4X', '---- Nepresahujúcim 15 % a s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040410:4X'),
('04041002', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041002'),
('04041004', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041004'),
('04041006', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041006'),
('04041006:2X', '---- Presahujúcim 15 % a s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041006:2X'),
('04041012', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041012'),
('04041014', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041014'),
('04041016', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041016'),
('04041016:2X', '--- Ostatná, s hmotnostným obsahom bielkovín (obsah dusíka × 6,38)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041016:2X'),
('04041016:3X', '---- Nepresahujúcim 15 % a s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041016:3X'),
('04041026', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041026'),
('04041028', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041028'),
('04041032', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041032'),
('04041032:2X', '---- Presahujúcim 15 % a s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041032:2X'),
('04041034', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041034'),
('04041036', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041036'),
('04041038', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041038'),
('04041038:2X', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041038:2X'),
('04041038:3X', '--- Neobsahujúca pridaný cukor ani ostatné sladidlá, s hmotnostným obsahom bielkovín (obsah dusíka x 6,38)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041038:3X'),
('04041038:4X', '---- Nepresahujúcim 15 % a s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041038:4X'),
('04041048', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041048'),
('04041052', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041052'),
('04041054', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041054'),
('04041054:2X', '---- Presahujúcim 15 % a s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041054:2X'),
('04041056', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041056'),
('04041058', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041058'),
('04041062', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041062'),
('04041062:2X', '--- Ostatná, s hmotnostným obsahom bielkovín (obsah dusíka × 6,38)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041062:2X'),
('04041062:3X', '---- Nepresahujúcim 15 % a s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041062:3X'),
('04041072', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041072'),
('04041074', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041074'),
('04041076', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041076'),
('04041076:2X', '---- Presahujúcim 15 % a s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041076:2X'),
('04041078', '----- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041078'),
('04041082', '----- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041082'),
('04041084', '----- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04041084'),
('040490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040490'),
('040490:2X', '-- Neobsahujúce pridaný cukor ani ostatné sladidlá, s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040490:2X'),
('04049021', '--- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04049021'),
('04049023', '--- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04049023'),
('04049029', '--- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04049029'),
('04049029:2X', '-- Ostatné, s hmotnostným obsahom tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04049029:2X'),
('04049081', '--- Nepresahujúcim 1,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04049081'),
('04049083', '--- Presahujúcim 1,5 %, ale nepresahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04049083'),
('04049089', '--- Presahujúcim 27 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04049089'),
('0405', 'Maslo a ostatné tuky a oleje pochádzajúce z mlieka; mliečne nátierky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0405'),
('040510', '- Maslo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040510'),
('040510:2X', '-- S hmotnostným obsahom tuku nepresahujúcim 85 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040510:2X'),
('040510:3X', '--- Prírodné maslo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040510:3X'),
('04051011', '---- V bezprostrednom obale s čistým obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04051011'),
('04051019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04051019'),
('04051030', '--- Rekombinované maslo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04051030'),
('04051050', '--- Srvátkové maslo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04051050'),
('04051090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04051090'),
('040520', '- Mliečne nátierky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040520'),
('04052010', '-- S hmotnostným obsahom tuku 39 % alebo viac, ale menej ako 60 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04052010'),
('04052030', '-- S hmotnostným obsahom tuku 60 % alebo viac, ale nepresahujúcim 75 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04052030'),
('04052090', '-- S hmotnostným obsahom tuku viac ako 75 %, ale menej ako 80 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04052090'),
('040590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040590'),
('04059010', '-- S hmotnostným obsahom tuku 99,3 % alebo viac a s hmotnostným obsahom vody nepresahujúcim 0,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04059010'),
('04059090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04059090'),
('0406', 'Syry a tvaroh', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0406'),
('040610', '- Čerstvé (nevyzreté alebo nekonzervované) syry, vrátane srvátkového syra, a tvaroh', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040610'),
('04061020', '-- S hmotnostným obsahom tuku nepresahujúcim 40 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04061020'),
('04061080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04061080'),
('040620', '- Strúhané alebo práškové syry, všetkých druhov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040620'),
('04062010', '-- Syry Glarus s bylinkami (známe ako Schabziger) vyrábané z odstredeného mlieka a miešané s jemne mletými bylinkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04062010'),
('04062090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04062090'),
('040630', '- Tavené syry, nestrúhané ani nepráškové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040630'),
('04063010', '-- Pri ich výrobe boli použité len syry Ementál, Gruyére a Appenzell a ktoré môžu obsahovať ako prísadu syr Glarus s bylinkami (známy ako Schabziger); upravené na predaj v malom, s hmotnostným obsahom tuku v sušine nepresahujúcim 56 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04063010'),
('04063010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04063010:2X'),
('04063010:3X', '--- S hmotnostným obsahom tuku nepresahujúcim 36 % a s hmotnostným obsahom tuku v sušine', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04063010:3X'),
('04063031', '---- Nepresahujúcim 48 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04063031'),
('04063039', '---- Presahujúcim 48 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04063039'),
('04063090', '--- S hmotnostným obsahom tuku presahujúcim 36 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04063090'),
('040640', '- Syry s modrou plesňou a ostatné syry obsahujúce pleseň vytvorenú pôsobením Penicillium roqueforti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040640'),
('04064010', '-- Roquefort', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04064010'),
('04064050', '-- Gorgonzola', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04064050'),
('04064090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04064090'),
('040690', '- Ostatné syry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040690'),
('04069001', '-- Na tavenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069001'),
('04069001:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069001:2X'),
('04069013', '--- Ementál', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069013'),
('04069015', '--- Gruyére, Sbrinz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069015'),
('04069017', '--- Bergkäse, Appenzell', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069017'),
('04069018', '--- Fromage fribourgeois, Vacherin Mont d''Or a Tete de Moine', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069018'),
('04069019', '--- Syry Glarus s bylinkami (známe ako Schabziger) vyrábané z odstredeného mlieka a miešané s jemne mletými bylinkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069019'),
('04069021', '--- Cheddar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069021'),
('04069023', '--- Eidam', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069023'),
('04069025', '--- Tilsit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069025'),
('04069027', '--- Butterkäse', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069027'),
('04069029', '--- Kashkaval', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069029'),
('04069032', '--- Feta', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069032'),
('04069035', '--- Kefalo-Tyri', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069035'),
('04069037', '--- Finlandia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069037'),
('04069039', '--- Jarlsberg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069039'),
('04069039:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069039:2X'),
('04069050', '---- Syry z ovčieho mlieka alebo byvolieho mlieka, v nádobách obsahujúcich slaný nálev alebo v mechoch z ovčej alebo kozej kože', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069050'),
('04069050:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069050:2X'),
('04069050:3X', '----- S hmotnostným obsahom tuku nepresahujúcim 40 % a s hmotnostným obsahom vody v beztukovej hmote', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069050:3X'),
('04069050:4X', '------ Nepresahujúcim 47 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069050:4X'),
('04069061', '------- Grana padano, Parmigiano reggiano', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069061'),
('04069063', '------- Fiore sardo, Pecorino', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069063'),
('04069069', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069069'),
('04069069:2X', '------ Presahujúcim 47 %, ale nepresahujúcim 72 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069069:2X'),
('04069073', '------- Provolone', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069073'),
('04069075', '------- Asiago, Caciocavallo, Montasio, Ragusano', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069075'),
('04069076', '------- Danbo, Fontal, Fontina, Fynbo, Havarti, Maribo, Samsö', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069076'),
('04069078', '------- Gouda', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069078'),
('04069079', '------- Esrom, Italico, Kernhem, Saint-Nectaire, Saint-Paulin, Taleggio', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069079'),
('04069081', '------- Cantal, Cheshire, Wensleydale, Lancashire, Double Gloucester, Blarney, Colby, Monterey', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069081'),
('04069082', '------- Camembert', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069082'),
('04069084', '------- Brie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069084'),
('04069085', '------- Kefalograviera, Kasseri', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069085'),
('04069085:2X', '------- Ostatné syry, s hmotnostným obsahom vody v beztukovej hmote', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069085:2X'),
('04069086', '-------- Presahujúcim 47 %, ale nepresahujúcim 52 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069086'),
('04069087', '-------- Presahujúcim 52 %, ale nepresahujúcim 62 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069087'),
('04069088', '-------- Presahujúcim 62 %, ale nepresahujúcim 72 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069088'),
('04069093', '------ Presahujúcim 72 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069093'),
('04069099', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04069099'),
('0407', 'Vtáčie vajcia, v škrupinách, čerstvé, konzervované alebo varené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0407'),
('0407:2X', '- Na násadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0407:2X'),
('04071100', '-- Z hydiny druhu Gallus domesticus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_04071100'),
('040719', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040719'),
('040719:2X', '--- Z hydiny, iné ako z hydiny druhu Gallus domesticus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040719:2X'),
('04071911', '---- Z moriek alebo husí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_04071911'),
('04071919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_04071919'),
('04071990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_04071990'),
('04071990:2X', '- Ostatné čerstvé vajcia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04071990:2X'),
('04072100', '-- Z hydiny druhu Gallus domesticus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MIL'), 'SK_04072100'),
('040729', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040729'),
('04072910', '--- Z hydiny, iné ako z hydiny druhu Gallus domesticus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MIL'), 'SK_04072910'),
('04072990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_04072990'),
('040790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040790'),
('04079010', '-- Z hydiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MIL'), 'SK_04079010'),
('04079090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_04079090'),
('0408', 'Vtáčie vajcia, bez škrupín, a vaječné žĺtky, čerstvé, sušené, varené v pare alebo vo vode, tvarované, mrazené alebo inak konzervované, tiež obsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0408'),
('0408:2X', '- Vaječné žĺtky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0408:2X'),
('040811', '-- Sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040811'),
('04081120', '--- Nevhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04081120'),
('04081180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04081180'),
('040819', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040819'),
('04081920', '--- Nevhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04081920'),
('04081920:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04081920:2X'),
('04081981', '---- Tekuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04081981'),
('04081989', '---- Ostatné, vrátane mrazených', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04081989'),
('04081989:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04081989:2X'),
('040891', '-- Sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040891'),
('04089120', '--- Nevhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04089120'),
('04089180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04089180'),
('040899', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_040899'),
('04089920', '--- Nevhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04089920'),
('04089980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04089980'),
('04090000', 'Prírodný med', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04090000'),
('04100000', 'Jedlé produkty živočíšneho pôvodu, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_04100000'),
('05010000', 'Ľudské vlasy, nespracované, tiež prané alebo čistené; odpad z ľudských vlasov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05010000'),
('0502', 'Svinské, kančie alebo diviačie štetiny a chlpy; jazvečie chlpy a ostatné chlpy na výrobu kief alebo štetcov; odpad z takýchto štetín alebo chlpov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0502'),
('05021000', '- Svinské, kančie alebo diviačie štetiny a chlpy a odpad z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05021000'),
('05029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05029000'),
('05040000', 'Zvieracie črevá, mechúre a žalúdky (iné ako rybacie), celé a ich časti, čerstvé, chladené, mrazené, solené, v slanom náleve, sušené alebo údené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05040000'),
('0505', 'Kože a ostatné časti vtákov, s perím alebo páperím, perie a časti peria (tiež s pristrihnutými okrjmi) a páperie, inak neopracované ako čistené, dezinfikované alebo pripravené na konzerváciu; prach a odpad z peria alebo jeho častí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0505'),
('050510', '- Perie z druhov používaných na vypchávanie; páperie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_050510'),
('05051010', '-- Surové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05051010'),
('05051090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05051090'),
('05059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05059000'),
('0506', 'Kosti a rohové kosti, neopracované, zbavené tuku, jednoducho upravené (avšak nenarezané do tvaru), upravené kyselinou alebo odželatinizované; prach a odpad z týchto produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0506'),
('05061000', '- Oseín a kosti upravené kyselinou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05061000'),
('05069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05069000'),
('0507', 'Slonovina, korytnačina, kostice a fúzy veľrýb, rohy, parohy, kopytá, paznechty, pazúry a zobáky, neopracované alebo jednoducho upravené, avšak nenarezané do tvaru; prach a odpad z týchto produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0507'),
('05071000', '- Slonovina; slonovinový prach a odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05071000'),
('05079000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05079000'),
('05080000', 'Koraly a podobné materiály, neopracované alebo jednoducho upravené, ale inak nespracované; panciere mäkkýšov, kôrovcov alebo ostnokožovcov a sépiové kosti, neopracované alebo jednoducho upravené, avšak nenarezané do tvaru, prach a odpad z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05080000'),
('05100000', 'Ambra, kastoreum, cibet a pižmo; kantaridy; žlč, tiež sušená; žľazy a ostatné produkty živočíšneho pôvodu používané na výrobu farmaceutických výrobkov, čerstvé, chladené, mrazené alebo inak dočasne konzervované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05100000'),
('0511', 'Živočíšne produkty inde nešpecifikované ani nezahrnuté; mŕtve zvieratá kapitoly 1 alebo 3, nespôsobilé na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0511'),
('05111000', '- Býčie spermie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_05111000'),
('05111000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05111000:2X'),
('051191', '-- Produkty z rýb alebo kôrovcov, mäkkýšov alebo ostatných vodných bezstavovcov; mŕtve zvieratá kapitoly 3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_051191'),
('05119110', '--- Rybí odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05119110'),
('05119190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05119190'),
('051199', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_051199'),
('05119910', '--- Šľachy; odrezky a podobný odpad zo surových koží alebo kožiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05119910'),
('05119910:2X', '--- Prírodné špongie živočíšneho pôvodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05119910:2X'),
('05119931', '---- Surové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05119931'),
('05119939', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05119939'),
('05119985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_05119985'),
('0601', 'Cibule, hľuzy, hľuzovité korene, pazúrovité korene a pakorene, vo vegetačnom pokoji, vo vegetácii alebo v kvete; rastliny a korene čakanky, iné ako korene položky 1212', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0601'),
('060110', '- Cibule, hľuzy, hľuzovité korene, pazúrovité korene a pakorene, vo vegetačnom pokoji', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060110'),
('06011010', '-- Hyacinty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06011010'),
('06011020', '-- Narcisy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06011020'),
('06011030', '-- Tulipány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06011030'),
('06011040', '-- Gladioly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06011040'),
('06011090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06011090'),
('060120', '- Cibule, hľuzy, hľuzovité korene, pazúrovité korene a pakorene, vo vegetácii alebo v kvete; rastliny a korene čakanky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060120'),
('06012010', '-- Rastliny a korene čakanky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06012010'),
('06012030', '-- Orchidey, hyacinty, narcisy a tulipány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06012030'),
('06012090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06012090'),
('0602', 'Ostatné živé rastliny (vrátane ich koreňov), odrezky a vrúble; podhubie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0602'),
('060210', '- Nekoreňovité odrezky a vrúble', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060210'),
('06021010', '-- Z vinnej révy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06021010'),
('06021090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06021090'),
('060220', '- Stromy, kry a kríky, tiež vrúbľované, druhov rodiacich jedlé ovocie alebo orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060220'),
('06022010', '-- Kríky vinnej révy, vrúbľované alebo koreňovité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06022010'),
('06022090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06022090'),
('06023000', '- Rododendrony a azalky, tiež vrúbľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06023000'),
('06024000', '- Ruže, tiež vrúbľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06024000'),
('060290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060290'),
('06029010', '-- Podhubie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029010'),
('06029020', '-- Rastliny ananásu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029020'),
('06029030', '-- Rastliny zeleniny a jahôd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029030'),
('06029030:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029030:2X'),
('06029030:3X', '--- Vonkajšie rastliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029030:3X'),
('06029030:4X', '---- Stromy, kry a kríky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029030:4X'),
('06029041', '----- Lesné stromy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029041'),
('06029041:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029041:2X'),
('06029045', '------ Koreňovité odrezky a mladé rastliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029045'),
('06029049', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029049'),
('06029050', '---- Ostatné vonkajšie rastliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029050'),
('06029050:2X', '--- Izbové rastliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029050:2X'),
('06029070', '---- Koreňovité odrezky a mladé rastliny, okrem kaktusov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029070'),
('06029070:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029070:2X'),
('06029091', '----- Kvitnúce rastliny s pukmi alebo kvetmi, okrem kaktusov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029091'),
('06029099', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06029099'),
('0603', 'Rezané kvetiny a kvetinové pupence druhov vhodných na kytice alebo na ozdobné účely, čerstvé, sušené, farbené, bielené, impregnované alebo inak upravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0603'),
('0603:2X', '- Čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0603:2X'),
('06031100', '-- Ruže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06031100'),
('06031200', '-- Klinčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06031200'),
('06031300', '-- Orchidey', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06031300'),
('06031400', '-- Chryzantémy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06031400'),
('06031500', '-- Ľalie (Lilium spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06031500'),
('060319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060319'),
('06031910', '--- Gladioly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06031910'),
('06031980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06031980'),
('06039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06039000'),
('0604', 'Lístie, konáre a ostatné časti rastlín, bez kvetov alebo kvetinových pupencov, a trávy, machy a lišajníky, ktoré sú tovarom druhu vhodného na kytice alebo na ozdobné účely, čerstvé, sušené, farbené, bielené, impregnované alebo inak upravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0604'),
('060420', '- Čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060420'),
('060420:2X', '-- Machy a lišajníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060420:2X'),
('06042011', '--- Lišajník sobí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06042011'),
('06042019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06042019'),
('06042020', '-- Vianočné stromčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_06042020'),
('06042040', '-- Vetvy ihličnanov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06042040'),
('06042090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06042090'),
('060490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060490'),
('060490:2X', '-- Machy a lišajníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_060490:2X'),
('06049011', '--- Lišajník sobí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06049011'),
('06049019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06049019'),
('06049019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06049019:2X'),
('06049091', '--- Neupravené inak ako sušením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06049091'),
('06049099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_06049099'),
('0701', 'Zemiaky, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0701'),
('07011000', '- Sadbové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07011000'),
('070190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070190'),
('07019010', '-- Na výrobu škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07019010'),
('07019010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07019010:2X'),
('07019050', '--- Nové, od 1. januára do 30. júna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07019050'),
('07019090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07019090'),
('07020000', 'Rajčiaky, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07020000'),
('0703', 'Cibuľa, šalotka, cesnak, pór a ostatná cibuľová zelenina, čerstvá alebo chladená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0703'),
('070310', '- Cibuľa a šalotka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070310'),
('070310:2X', '-- Cibuľa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070310:2X'),
('07031011', '--- Sadzačka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07031011'),
('07031019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07031019'),
('07031090', '-- Šalotka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07031090'),
('07032000', '- Cesnak', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07032000'),
('07039000', '- Pór a ostatná cibuľová zelenina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07039000'),
('0704', 'Kapusta, karfiol, kaleráb, kel a podobná jedlá zelenina rodu Brassica, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0704'),
('07041000', '- Karfiol a brokolica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07041000'),
('07042000', '- Ružičkový kel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07042000'),
('070490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070490'),
('07049010', '-- Kapusta biela a kapusta červená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07049010'),
('07049090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07049090'),
('0705', 'Hlávkový šalát (Lactuca sativa) a čakanka (Cichorium spp.), čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0705'),
('0705:2X', '- Šalát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0705:2X'),
('07051100', '-- Hlávkový šalát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07051100'),
('07051900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07051900'),
('07051900:2X', '- Čakanka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07051900:2X'),
('07052100', '-- Čakanka šalátová (Cichorium intybus var. foliosum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07052100'),
('07052900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07052900'),
('0706', 'Mrkva, repa, cvikla, kozia brada, zeler buľvový, reďkev a podobné jedlé korene, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0706'),
('07061000', '- Mrkva a repa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07061000'),
('070690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070690'),
('07069010', '-- Zeler buľvový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07069010'),
('07069030', '-- Chren (Cochlearia armoracia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07069030'),
('07069090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07069090'),
('070700', 'Uhorky šalátové a uhorky nakladačky, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070700'),
('07070005', '- Uhorky šalátové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07070005'),
('07070090', '- Uhorky nakladačky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07070090'),
('0708', 'Strukoviny, lúpané alebo nelúpané, čerstvé alebo chladené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0708'),
('07081000', '- Hrach (Pisum sativum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07081000'),
('07082000', '- Fazuľa (Vigna spp., Phaseolus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07082000'),
('07089000', '- Ostatné strukoviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07089000'),
('0709', 'Ostatná zelenina, čerstvá alebo chladená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0709'),
('07092000', '- Špargľa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07092000'),
('07093000', '- Baklažán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07093000'),
('07094000', '- Zeler iný ako buľvový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07094000'),
('07094000:2X', '- Huby a hľuzovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07094000:2X'),
('07095100', '-- Huby rodu Agaricus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07095100'),
('070959', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070959'),
('07095910', '--- Kuriatka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07095910'),
('07095930', '--- Hríby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07095930'),
('07095950', '--- Hľuzovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07095950'),
('07095990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07095990'),
('070960', '- Plody rodu Capsicum alebo rodu Pimenta', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070960'),
('07096010', '-- Sladká paprika', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07096010'),
('07096010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07096010:2X'),
('07096091', '--- Rodu Capsicum, na výrobu kapsicínu alebo farbiv z olejoživic', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07096091'),
('07096095', '--- Na priemyselnú výrobu silic alebo rezinoidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07096095'),
('07096099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07096099'),
('07097000', '- Špenát, novozélandský špenát a záhradný špenát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07097000'),
('07097000:2X', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07097000:2X'),
('07099100', '-- Artičoky pravé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099100'),
('070992', '-- Olivy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070992'),
('07099210', '--- Na iné účely ako na výrobu oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099210'),
('07099290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099290'),
('070993', '-- Tekvice (Cucurbita spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070993'),
('07099310', '--- Cukety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099310'),
('07099390', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099390'),
('070999', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_070999'),
('07099910', '--- Šalátová zelenina, iná ako hlávkový šalát (Lactuca sativa) a čakanka (Cichorium spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099910'),
('07099920', '--- Mangoldy a kardy (bodliakové artičoky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099920'),
('07099940', '--- Kapary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099940'),
('07099950', '--- Fenikel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099950'),
('07099960', '--- Kukurica cukrová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099960'),
('07099990', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07099990'),
('0710', 'Zelenina (nevarená alebo varená v pare alebo vo vode), mrazená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0710'),
('07101000', '- Zemiaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07101000'),
('07101000:2X', '- Strukoviny, lúpané alebo nelúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07101000:2X'),
('07102100', '-- Hrach (Pisum sativum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07102100'),
('07102200', '-- Fazuľa (Vigna spp., Phaseolus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07102200'),
('07102900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07102900'),
('07103000', '- Špenát, novozélandský špenát a záhradný špenát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07103000'),
('07104000', '- Kukurica cukrová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07104000'),
('071080', '- Ostatná zelenina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071080'),
('07108010', '-- Olivy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108010'),
('07108010:2X', '-- Plody rodu Capsicum alebo rodu Pimenta', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108010:2X'),
('07108051', '--- Sladká paprika', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108051'),
('07108059', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108059'),
('07108059:2X', '-- Huby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108059:2X'),
('07108061', '--- Rodu Agaricus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108061'),
('07108069', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108069'),
('07108070', '-- Rajčiaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108070'),
('07108080', '-- Artičoky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108080'),
('07108085', '-- Špargľa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108085'),
('07108095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07108095'),
('07109000', '- Zeleninové zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07109000'),
('0711', 'Zelenina dočasne konzervovaná (napríklad plynným oxidom siričitým, v slanom náleve, sírnej vode alebo ostatných konzervačných roztokoch), avšak v tomto stave nevhodná na bezprostrednú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0711'),
('071120', '- Olivy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071120'),
('07112010', '-- Na iné účely ako na výrobu oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07112010'),
('07112090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07112090'),
('07114000', '- Uhorky šalátové a uhorky nakladačky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07114000'),
('07114000:2X', '- Huby a hľuzovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07114000:2X'),
('07115100', '-- Huby rodu Agaricus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KGM'), 'SK_07115100'),
('07115900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07115900'),
('071190', '- Ostatná zelenina; zeleninové zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071190'),
('071190:2X', '-- Zelenina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071190:2X'),
('07119010', '--- Plody rodu Capsicum alebo rodu Pimenta, okrem sladkej papriky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07119010'),
('07119030', '--- Kukurica cukrová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07119030'),
('07119050', '--- Cibuľa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07119050'),
('07119070', '--- Kapary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07119070'),
('07119080', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07119080'),
('07119090', '-- Zeleninové zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07119090'),
('0712', 'Sušená zelenina, celá, rezaná na kúsky, rezaná na plátky, drvená alebo v prášku, ďalej však neupravená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0712'),
('07122000', '- Cibuľa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07122000'),
('07122000:2X', '- Huby, huby rodu Auricularia spp., huby rodu Tremella a hľuzovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07122000:2X'),
('07123100', '-- Huby rodu Agaricus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07123100'),
('07123200', '-- Huby rodu Auricularia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07123200'),
('07123300', '-- Huby rodu Tremella', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07123300'),
('07123900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07123900'),
('071290', '- Ostatná zelenina; zeleninové zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071290'),
('07129005', '-- Zemiaky, tiež rezané na kúsky alebo plátky, ďalej však neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07129005'),
('07129005:2X', '-- Kukurica cukrová (Zea mays var. saccharata)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07129005:2X'),
('07129011', '--- Hybridy na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07129011'),
('07129019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07129019'),
('07129030', '-- Rajčiaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07129030'),
('07129050', '-- Mrkva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07129050'),
('07129090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07129090'),
('0713', 'Sušené strukoviny, lúpané, tiež ošúpané alebo polené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0713'),
('071310', '- Hrach (Pisum sativum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071310'),
('07131010', '-- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07131010'),
('07131090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07131090'),
('07132000', '- Cícer', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07132000'),
('07132000:2X', '- Fazuľa (Vigna spp., Phaseolus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07132000:2X'),
('07133100', '-- Fazuľa druhov Vigna mungo (L.) Hepper alebo Vigna radiata (L.) Wilczek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07133100'),
('07133200', '-- Malá červená (Adzuki) fazuľa (Phaseolus alebo Vigna angularis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07133200'),
('071333', '-- Fazuľa obyčajná, vrátane malej bielej fazule (Phaseolus vulgaris)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071333'),
('07133310', '--- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07133310'),
('07133390', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07133390'),
('07133400', '-- Fazuľa druhov Vigna subterranea alebo Voandzeia subterranea', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07133400'),
('07133500', '-- Vigna čínska (Vigna unguiculata)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07133500'),
('07133900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07133900'),
('07134000', '- Šošovica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07134000'),
('07135000', '- Bôb (Vicia faba var. major) a konský bôb (Vicia faba var. equina, Vicia faba var. minor)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07135000'),
('07136000', '- Kajan indický (Cajanus cajan)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07136000'),
('07139000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07139000'),
('0714', 'Maniok, marantové korene, salepové korene, topinambur, sladké zemiaky a podobné korene a hľuzy s vysokým obsahom škrobu alebo inulínu, čerstvé, chladené, mrazené alebo sušené, tiež rezané na plátky alebo vo forme peliet; dreň ságovníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0714'),
('071410', '- Maniok (kasava)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071410'),
('07141091', '-- Druhov používaných na ľudskú konzumáciu, v bezprostrednom obale s čistým obsahom nepresahujúcim 28 kg, buď čerstvé a celé alebo ošúpané a mrazené, tiež rezané na plátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07141091'),
('07141098', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07141098'),
('071420', '- Sladké zemiaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071420'),
('07142010', '-- Čerstvé, celé, určené na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07142010'),
('07142090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07142090'),
('071430', '- Jamy (Dioscorea spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071430'),
('07143010', '-- Druhov používaných na ľudskú konzumáciu, v bezprostrednom obale s čistým obsahom nepresahujúcim 28 kg, buď čerstvé a celé alebo ošúpané a mrazené, tiež rezané na plátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07143010'),
('07143090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07143090'),
('071440', '- Kolokázia (Colocasia spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071440'),
('07144010', '-- Druhov používaných na ľudskú konzumáciu, v bezprostrednom obale s čistým obsahom nepresahujúcim 28 kg, buď čerstvé a celé alebo ošúpané a mrazené, tiež rezané na plátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07144010'),
('07144090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07144090'),
('071450', '- Xantozóma (Xanthosoma spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071450'),
('07145010', '-- Druhov používaných na ľudskú konzumáciu, v bezprostrednom obale s čistým obsahom nepresahujúcim 28 kg, buď čerstvé a celé alebo ošúpané a mrazené, tiež rezané na plátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07145010'),
('07145090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07145090'),
('071490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071490'),
('071490:2X', '-- Marantové korene, salepové a podobné korene a hľuzy s vysokým obsahom škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_071490:2X'),
('07149012', '--- Druhov používaných na ľudskú konzumáciu, v bezprostrednom obale s čistým obsahom nepresahujúcim 28 kg, buď čerstvé a celé alebo ošúpané a mrazené, tiež rezané na plátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07149012'),
('07149018', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07149018'),
('07149090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_07149090'),
('0801', 'Kokosové orechy, para orechy a kešu orechy, čerstvé alebo sušené, tiež vylúpané zo škrupiny alebo obielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0801'),
('0801:2X', '- Kokosové orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0801:2X'),
('08011100', '-- Sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08011100'),
('08011200', '-- Vo vnútornej škrupine (endokarp)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08011200'),
('08011900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08011900'),
('08011900:2X', '- Para orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08011900:2X'),
('08012100', '-- Nevylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08012100'),
('08012200', '-- Vylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08012200'),
('08012200:2X', '- Kešu orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08012200:2X'),
('08013100', '-- Nevylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08013100'),
('08013200', '-- Vylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08013200'),
('0802', 'Ostatné orechy, čerstvé alebo sušené, tiež vylúpané zo škrupiny alebo obielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0802'),
('0802:2X', '- Mandle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0802:2X'),
('080211', '-- Nevylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080211'),
('08021110', '--- Horké', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08021110'),
('08021190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08021190'),
('080212', '-- Vylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080212'),
('08021210', '--- Horké', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08021210'),
('08021290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08021290'),
('08021290:2X', '- Lieskové orechy (Corylus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08021290:2X'),
('08022100', '-- Nevylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08022100'),
('08022200', '-- Vylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08022200'),
('08022200:2X', '- Vlašské orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08022200:2X'),
('08023100', '-- Nevylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08023100'),
('08023200', '-- Vylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08023200'),
('08023200:2X', '- Jedlé gaštany (Castanea spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08023200:2X'),
('08024100', '-- Nevylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08024100'),
('08024200', '-- Vylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08024200'),
('08024200:2X', '- Pistácie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08024200:2X'),
('08025100', '-- Nevylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08025100'),
('08025200', '-- Vylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08025200'),
('08025200:2X', '- Makadamové orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08025200:2X'),
('08026100', '-- Nevylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08026100'),
('08026200', '-- Vylúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08026200'),
('08027000', '- Orechy kola (Cola spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08027000'),
('08028000', '- Arekové orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08028000'),
('080290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080290'),
('08029010', '-- Pekanové orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08029010'),
('08029050', '-- Píniové oriešky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08029050'),
('08029085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08029085'),
('0803', 'Banány, vrátane plantajnov, čerstvé alebo sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0803'),
('080310', '- Plantajny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080310'),
('08031010', '-- Čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08031010'),
('08031090', '-- Sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08031090'),
('080390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080390'),
('08039010', '-- Čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08039010'),
('08039090', '-- Sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08039090'),
('0804', 'Datle, figy, ananásy, avokáda, guavy, mangá a mangostany, čerstvé alebo sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0804'),
('08041000', '- Datle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08041000'),
('080420', '- Figy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080420'),
('08042010', '-- Čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08042010'),
('08042090', '-- Sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08042090'),
('08043000', '- Ananásy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08043000'),
('08044000', '- Avokáda', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08044000'),
('08045000', '- Guavy, mangá a mangostany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08045000'),
('0805', 'Citrusové ovocie, čerstvé alebo sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0805'),
('080510', '- Pomaranče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080510'),
('08051020', '-- Sladké pomaranče, čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08051020'),
('08051080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08051080'),
('080520', '- Mandarínky (vrátane tangeríniek a satsumov); klementínky, wilkingy a podobné citrusové hybridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080520'),
('08052010', '-- Klementínky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08052010'),
('08052030', '-- Monrealy a satsumy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08052030'),
('08052050', '-- Mandarínky a wilkingy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08052050'),
('08052070', '-- Tangerínky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08052070'),
('08052090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08052090'),
('08054000', '- Grapefruity, vrátane pomiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08054000'),
('080550', '- Citróny (Citrus limon, Citrus limonum) a limety (Citrus aurantifolia, Citrus latifolia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080550'),
('08055010', '-- Citróny (Citrus limon, Citrus limonum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08055010'),
('08055090', '-- Limety (Citrus aurantifolia, Citrus latifolia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08055090'),
('08059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08059000'),
('0806', 'Hrozno, čerstvé alebo sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0806'),
('080610', '- Čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080610'),
('08061010', '-- Stolové hrozno', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08061010'),
('08061090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08061090'),
('080620', '- Sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080620'),
('08062010', '-- Korintky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08062010'),
('08062030', '-- Sultánky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08062030'),
('08062090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08062090'),
('0807', 'Melóny (vrátane vodových melónov) a papáje, čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0807'),
('0807:2X', '- Melóny (vrátane vodových melónov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0807:2X'),
('08071100', '-- Vodové melóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08071100'),
('08071900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08071900'),
('08072000', '- Papáje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08072000'),
('0808', 'Jablká, hrušky a duly, čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0808'),
('080810', '- Jablká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080810'),
('08081010', '-- Muštové jablká, voľne ložené, od 16. septembra do 15. decembra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08081010'),
('08081080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08081080'),
('080830', '- Hrušky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080830'),
('08083010', '-- Muštové hrušky, voľne ložené, od 1. augusta do 31. decembra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08083010'),
('08083090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08083090'),
('08084000', '- Duly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08084000'),
('0809', 'Marhule, čerešne, višne, broskyne (vrátane nektáriniek), slivky a trnky, čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0809'),
('08091000', '- Marhule', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08091000'),
('08091000:2X', '- Čerešne a višne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08091000:2X'),
('08092100', '-- Višne (Prunus cerasus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08092100'),
('08092900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08092900'),
('080930', '- Broskyne, vrátane nektáriniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080930'),
('08093010', '-- Nektárinky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08093010'),
('08093090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08093090'),
('080940', '- Slivky a trnky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_080940'),
('08094005', '-- Slivky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08094005'),
('08094090', '-- Trnky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08094090'),
('0810', 'Ostatné ovocie, čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0810'),
('08101000', '- Jahody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08101000'),
('081020', '- Maliny, moruše, černice a ostružinové maliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081020'),
('08102010', '-- Maliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08102010'),
('08102090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08102090'),
('081030', '- Čierne, biele alebo červené ríbezle a egreše', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081030'),
('08103010', '-- Čierne ríbezle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08103010'),
('08103030', '-- Červené ríbezle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08103030'),
('08103090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08103090'),
('081040', '- Brusnice, čučoriedky a ostatné plody rodu Vaccinium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081040'),
('08104010', '-- Brusnice (plody druhu Vaccinium vitis-idaea)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08104010'),
('08104030', '-- Plody druhu Vaccinium myrtillus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08104030'),
('08104050', '-- Plody druhu Vaccinium macrocarpon a Vaccinium corymbosum', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08104050'),
('08104090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08104090'),
('08105000', '- Kivi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08105000'),
('08106000', '- Duriany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08106000'),
('08107000', '- Tomely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08107000'),
('081090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081090'),
('08109020', '-- Tamarindy, jabĺčka kešu, liči, jackfruit, sapoty, plody mučenky, karamboly a pitahaye', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08109020'),
('08109075', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08109075'),
('0811', 'Ovocie a orechy, nevarené alebo varené vo vode alebo v pare, mrazené, tiež obsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0811'),
('081110', '- Jahody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081110'),
('081110:2X', '-- Obsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081110:2X'),
('08111011', '--- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08111011'),
('08111019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08111019'),
('08111090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08111090'),
('081120', '- Maliny, černice, moruše, ostružinové maliny, čierne, biele alebo červené ríbezle a egreše', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081120'),
('081120:2X', '-- Obsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081120:2X'),
('08112011', '--- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08112011'),
('08112019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08112019'),
('08112019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08112019:2X'),
('08112031', '--- Maliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08112031'),
('08112039', '--- Čierne ríbezle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08112039'),
('08112051', '--- Červené ríbezle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08112051'),
('08112059', '--- Černice a moruše', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08112059'),
('08112090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08112090'),
('081190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081190'),
('081190:2X', '-- Obsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081190:2X'),
('081190:3X', '--- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081190:3X'),
('08119011', '---- Tropické ovocie a tropické orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119011'),
('08119019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119019'),
('08119019:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119019:2X'),
('08119031', '---- Tropické ovocie a tropické orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119031'),
('08119039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119039'),
('08119039:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119039:2X'),
('08119050', '--- Plody druhu Vaccinium myrtillus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119050'),
('08119070', '--- Plody druhu Vaccinium myrtilloides a Vaccinium angustifolium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119070'),
('08119070:2X', '--- Čerešne a višne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119070:2X'),
('08119075', '---- Višne (Prunus cerasus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119075'),
('08119080', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119080'),
('08119085', '--- Tropické ovocie a tropické orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119085'),
('08119095', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08119095'),
('0812', 'Ovocie a orechy, dočasne konzervované (napríklad plynným oxidom siričitým, v slanom náleve, sírnej vode alebo ostatných konzervačných roztokoch), avšak v tomto stave nevhodné na bezprostrednú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0812'),
('08121000', '- Čerešne a višne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08121000'),
('081290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081290'),
('08129025', '-- Marhule; pomaranče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08129025'),
('08129030', '-- Papáje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08129030'),
('08129040', '-- Plody druhu Vaccinium myrtillus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08129040'),
('08129070', '-- Guavy, mangá, mangostany, tamarindy, jabĺčka kešu, liči, jackfruit, sapoty, plody mučenky, karamboly, pitahaye a tropické orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08129070'),
('08129098', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08129098'),
('0813', 'Ovocie, sušené, iné ako ovocie položiek 0801 až 0806; zmesi orechov alebo sušeného ovocia tejto kapitoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0813'),
('08131000', '- Marhule', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08131000'),
('08132000', '- Slivky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08132000'),
('08133000', '- Jablká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08133000'),
('081340', '- Ostatné ovocie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081340'),
('08134010', '-- Broskyne, vrátane nektáriniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08134010'),
('08134030', '-- Hrušky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08134030'),
('08134050', '-- Papáje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08134050'),
('08134065', '-- Tamarindy, jabĺčka kešu, liči, jackfruit, sapoty, plody mučenky, karamboly a pitahaye', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08134065'),
('08134095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08134095'),
('081350', '- Zmesi orechov alebo sušeného ovocia tejto kapitoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081350'),
('081350:2X', '-- Zmesi sušeného ovocia, iného ako ovocia položiek 0801 až 0806', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081350:2X'),
('081350:3X', '--- Neobsahujúce slivky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_081350:3X'),
('08135012', '---- Z papájí, tamarínd, jabĺčok kešu, liči, jackfruitu, sapot, plodov mučenky, karamboly a pitahaye', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08135012'),
('08135015', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08135015'),
('08135019', '--- Obsahujúce slivky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08135019'),
('08135019:2X', '-- Zmesi výlučne z orechov položiek 0801 a 0802', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08135019:2X'),
('08135031', '--- Z tropických orechov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08135031'),
('08135039', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08135039'),
('08135039:2X', '-- Ostatné zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08135039:2X'),
('08135091', '--- Neobsahujúce slivky ani figy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08135091'),
('08135099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08135099'),
('08140000', 'Kôra alebo šupka citrusových plodov alebo melónov (vrátane vodových melónov), čerstvá, mrazená, sušená alebo dočasne konzervovaná v slanom náleve, sírnej vode alebo ostatných konzervačných roztokoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_08140000'),
('0901', 'Káva, tiež pražená alebo dekofeínovaná; kávové plevy a šupky; náhradky kávy obsahujúce kávu v akomkoľvek pomere', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0901'),
('0901:2X', '- Nepražená káva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0901:2X'),
('09011100', '-- S kofeínom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09011100'),
('09011200', '-- Dekofeínovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09011200'),
('09011200:2X', '- Pražená káva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09011200:2X'),
('09012100', '-- S kofeínom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09012100'),
('09012200', '-- Dekofeínovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09012200'),
('090190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_090190'),
('09019010', '-- Kávové plevy a šupky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09019010'),
('09019090', '-- Náhradky kávy obsahujúce kávu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09019090'),
('0902', 'Čaj, tiež aromatizovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0902'),
('09021000', '- Zelený čaj (nefermentovaný) v bezprostrednom obale s obsahom nepresahujúcim 3 kg hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09021000'),
('09022000', '- Ostatný zelený čaj (nefermentovaný)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09022000'),
('09023000', '- Čierny čaj (fermentovaný) a čiastočne fermentovaný čaj, v bezprostrednom obale s obsahom nepresahujúcim 3 kg hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09023000'),
('09024000', '- Ostatný čierny čaj (fermentovaný) a ostatný čiastočne fermentovaný čaj', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09024000'),
('09030000', 'Maté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09030000'),
('0904', 'Korenie rodu Piper; sušené alebo drvené alebo mleté plody rodu Capsicum alebo rodu Pimenta', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0904'),
('0904:2X', '- Korenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0904:2X'),
('09041100', '-- Nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09041100'),
('09041200', '-- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09041200'),
('09041200:2X', '- Plody rodu Capsicum alebo rodu Pimenta', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09041200:2X'),
('090421', '-- Sušené, nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_090421'),
('09042110', '--- Sladká paprika (Capsicum annuum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09042110'),
('09042190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09042190'),
('09042200', '-- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09042200'),
('0905', 'Vanilka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0905'),
('09051000', '- Nedrvená ani nemletá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09051000'),
('09052000', '- Drvená alebo mletá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09052000'),
('0906', 'Škorica a kvety škoricovníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0906'),
('0906:2X', '- Nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0906:2X'),
('09061100', '-- Škorica (Cinnamomum zeylanicum Blume)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09061100'),
('09061900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09061900'),
('09062000', '- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09062000'),
('0907', 'Klinčeky (celé plody, klinčeky a stopky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0907'),
('09071000', '- Nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09071000'),
('09072000', '- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09072000'),
('0908', 'Muškátový oriešok, muškátový kvet a kardamómy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0908'),
('0908:2X', '- Muškátový oriešok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0908:2X'),
('09081100', '-- Nedrvený ani nemletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09081100'),
('09081200', '-- Drvený alebo mletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09081200'),
('09081200:2X', '- Muškátový kvet', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09081200:2X'),
('09082100', '-- Nedrvený ani nemletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09082100'),
('09082200', '-- Drvený alebo mletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09082200'),
('09082200:2X', '- Kardamómy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09082200:2X'),
('09083100', '-- Nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09083100'),
('09083200', '-- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09083200'),
('0909', 'Semená anízu, badiánu, feniklu, koriandra, rasce alebo korenistej rasce; bobuľky borievky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0909'),
('0909:2X', '- Semená koriandra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0909:2X'),
('09092100', '-- Nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09092100'),
('09092200', '-- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09092200'),
('09092200:2X', '- Semená rasce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09092200:2X'),
('09093100', '-- Nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09093100'),
('09093200', '-- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09093200'),
('09093200:2X', '- Semená anízu, badiánu, korenistej rasce alebo feniklu; bobuľky borievky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09093200:2X'),
('09096100', '-- Nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09096100'),
('09096200', '-- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09096200'),
('0910', 'Zázvor, šafran, kurkuma, tymián, bobkový list, karí a ostatné korenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0910'),
('0910:2X', '- Zázvor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_0910:2X'),
('09101100', '-- Nedrvený ani nemletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09101100'),
('09101200', '-- Drvený alebo mletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09101200'),
('091020', '- Šafran', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_091020'),
('09102010', '-- Nedrvený ani nemletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09102010'),
('09102090', '-- Drvený alebo mletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09102090'),
('09103000', '- Kurkuma', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09103000'),
('09103000:2X', '- Ostatné korenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09103000:2X'),
('091091', '-- Zmesi uvedené v poznámke 1 b) k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_091091'),
('09109105', '--- Karí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109105'),
('09109105:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109105:2X'),
('09109110', '---- Nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109110'),
('09109190', '---- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109190'),
('091099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_091099'),
('09109910', '--- Semená senovky gréckej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109910'),
('09109910:2X', '--- Tymián', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109910:2X'),
('09109910:3X', '---- Nedrvený ani nemletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109910:3X'),
('09109931', '----- Materina dúška (Thymus serpyllum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109931'),
('09109933', '----- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109933'),
('09109939', '---- Drvený alebo mletý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109939'),
('09109950', '--- Bobkový list', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109950'),
('09109950:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109950:2X'),
('09109991', '---- Nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109991'),
('09109999', '---- Drvené alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_09109999'),
('1001', 'Pšenica a súraž', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1001'),
('1001:2X', '- Tvrdá pšenica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1001:2X'),
('10011100', '-- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10011100'),
('10011900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10011900'),
('10011900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10011900:2X'),
('100191', '-- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100191'),
('10019110', '--- Špalda', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10019110'),
('10019120', '--- Obyčajná pšenica a súraž', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10019120'),
('10019190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10019190'),
('10019900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10019900'),
('1002', 'Raž', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1002'),
('10021000', '- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10021000'),
('10029000', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10029000'),
('1003', 'Jačmeň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1003'),
('10031000', '- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10031000'),
('10039000', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10039000'),
('1004', 'Ovos', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1004'),
('10041000', '- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10041000'),
('10049000', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10049000'),
('1005', 'Kukurica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1005'),
('100510', '- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100510'),
('100510:2X', '-- Hybridná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100510:2X'),
('10051013', '--- Trikrát krížené hybridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10051013'),
('10051015', '--- Jednoduché hybridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10051015'),
('10051018', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10051018'),
('10051090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10051090'),
('10059000', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10059000'),
('1006', 'Ryža', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1006'),
('100610', '- Ryža v plevách (nelúpaná)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100610'),
('10061010', '-- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061010'),
('10061010:2X', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061010:2X'),
('10061010:3X', '--- "Parboiled"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061010:3X'),
('10061021', '---- Guľatozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061021'),
('10061023', '---- Strednozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061023'),
('10061023:2X', '---- Dlhozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061023:2X'),
('10061025', '----- S pomerom dĺžky k šírke viac ako 2, ale menej ako 3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061025'),
('10061027', '----- S pomerom dĺžky k šírke rovným 3 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061027'),
('10061027:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061027:2X'),
('10061092', '---- Guľatozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061092'),
('10061094', '---- Strednozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061094'),
('10061094:2X', '---- Dlhozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061094:2X'),
('10061096', '----- S pomerom dĺžky k šírke viac ako 2, ale menej ako 3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061096'),
('10061098', '----- S pomerom dĺžky k šírke rovným 3 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10061098'),
('100620', '- Lúpaná (hnedá) ryža', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100620'),
('100620:2X', '-- "Parboiled"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100620:2X'),
('10062011', '--- Guľatozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062011'),
('10062013', '--- Strednozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062013'),
('10062013:2X', '--- Dlhozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062013:2X'),
('10062015', '---- S pomerom dĺžky k šírke viac ako 2, ale menej ako 3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062015'),
('10062017', '---- S pomerom dĺžky k šírke rovným 3 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062017'),
('10062017:2X', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062017:2X'),
('10062092', '--- Guľatozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062092'),
('10062094', '--- Strednozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062094'),
('10062094:2X', '--- Dlhozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062094:2X'),
('10062096', '---- S pomerom dĺžky k šírke viac ako 2, ale menej ako 3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062096'),
('10062098', '---- S pomerom dĺžky k šírke rovným 3 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10062098'),
('100630', '- Polobielená alebo bielená ryža, tiež hladená alebo leštená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100630'),
('100630:2X', '-- Polobielená ryža', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100630:2X'),
('100630:3X', '--- "Parboiled"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100630:3X'),
('10063021', '---- Guľatozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063021'),
('10063023', '---- Strednozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063023'),
('10063023:2X', '---- Dlhozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063023:2X'),
('10063025', '----- S pomerom dĺžky k šírke viac ako 2, ale menej ako 3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063025'),
('10063027', '----- S pomerom dĺžky k šírke rovným 3 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063027'),
('10063027:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063027:2X'),
('10063042', '---- Guľatozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063042'),
('10063044', '---- Strednozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063044'),
('10063044:2X', '---- Dlhozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063044:2X'),
('10063046', '----- S pomerom dĺžky k šírke viac ako 2, ale menej ako 3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063046'),
('10063048', '----- S pomerom dĺžky k šírke rovným 3 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063048'),
('10063048:2X', '-- Bielená ryža', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063048:2X'),
('10063048:3X', '--- "Parboiled"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063048:3X'),
('10063061', '---- Guľatozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063061'),
('10063063', '---- Strednozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063063'),
('10063063:2X', '---- Dlhozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063063:2X'),
('10063065', '----- S pomerom dĺžky k šírke viac ako 2, ale menej ako 3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063065'),
('10063067', '----- S pomerom dĺžky k šírke rovným 3 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063067'),
('10063067:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063067:2X'),
('10063092', '---- Guľatozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063092'),
('10063094', '---- Strednozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063094'),
('10063094:2X', '---- Dlhozrnná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063094:2X'),
('10063096', '----- S pomerom dĺžky k šírke viac ako 2, ale menej ako 3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063096'),
('10063098', '----- S pomerom dĺžky k šírke rovným 3 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10063098'),
('10064000', '- Zlomková ryža', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10064000'),
('1007', 'Zrná ciroku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1007'),
('100710', '- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_100710'),
('10071010', '-- Hybridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10071010'),
('10071090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10071090'),
('10079000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10079000'),
('1008', 'Pohánka, proso a lesknica kanárska; ostatné obilniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1008'),
('10081000', '- Pohánka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10081000'),
('10081000:2X', '- Proso', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10081000:2X'),
('10082100', '-- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10082100'),
('10082900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10082900'),
('10083000', '- Lesknica kanárska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10083000'),
('10084000', '- Prstovky (Digitaria spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10084000'),
('10085000', '- Mrlík čílsky (Chenopodium quinoa)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10085000'),
('10086000', '- Tritikale', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10086000'),
('10089000', '- Ostatné obilniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_10089000'),
('110100', 'Múka z pšenice alebo zo súraže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110100'),
('110100:2X', '- Múka z pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110100:2X'),
('11010011', '-- Z tvrdej pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11010011'),
('11010015', '-- Z obyčajnej pšenice a zo špaldy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11010015'),
('11010090', '- Múka zo súraže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11010090'),
('1102', 'Múky z obilnín iných ako z pšenice alebo zo súraže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1102'),
('110220', '- Múka z kukurice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110220'),
('11022010', '-- S obsahom tuku nepresahujúcim 1,5 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11022010'),
('11022090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11022090'),
('110290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110290'),
('11029010', '-- Múka z jačmeňa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11029010'),
('11029030', '-- Múka z ovsa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11029030'),
('11029050', '-- Múka z ryže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11029050'),
('11029070', '-- Múka z raže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11029070'),
('11029090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11029090'),
('1103', 'Krúpy, krupica a pelety z obilnin', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1103'),
('1103:2X', '- Krúpy a krupica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1103:2X'),
('110311', '-- Z pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110311'),
('11031110', '--- Z tvrdej pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11031110'),
('11031190', '--- Z obyčajnej pšenice a zo špaldy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11031190'),
('110313', '-- Z kukurice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110313'),
('11031310', '--- S obsahom tuku nepresahujúcim 1,5 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11031310'),
('11031390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11031390'),
('110319', '-- Z ostatných obilnín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110319'),
('11031920', '--- Z raže alebo jačmeňa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11031920'),
('11031940', '--- Z ovsa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11031940'),
('11031950', '--- Z ryže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11031950'),
('11031990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11031990'),
('110320', '- Pelety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110320'),
('11032025', '-- Z raže alebo jačmeňa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11032025'),
('11032030', '-- Z ovsa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11032030'),
('11032040', '-- Z kukurice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11032040'),
('11032050', '-- Z ryže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11032050'),
('11032060', '-- Z pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11032060'),
('11032090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11032090'),
('1104', 'Obilné zrná inak spracované (napr. ošúpané, drvené na valcoch, vločkované, perlovité, rezané alebo šrotované), okrem ryže položky 1006; obilné klíčky, celé, drvené na valcoch, vločkované alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1104'),
('1104:2X', '- Zrná drvené na valcoch alebo vločkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1104:2X'),
('110412', '-- Z ovsa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110412'),
('11041210', '--- Drvené na valcoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041210'),
('11041290', '--- Vločkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041290'),
('110419', '-- Z ostatných obilnín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110419'),
('11041910', '--- Z pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041910'),
('11041930', '--- Z raže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041930'),
('11041950', '--- Z kukurice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041950'),
('11041950:2X', '--- Z jačmeňa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041950:2X'),
('11041961', '---- Drvené na valcoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041961'),
('11041969', '---- Vločkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041969'),
('11041969:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041969:2X'),
('11041991', '---- Ryžové vločky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041991'),
('11041999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041999'),
('11041999:2X', '- Inak spracované zrná (napr. ošúpané, perlovité, rezané alebo šrotované)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11041999:2X'),
('110422', '-- Z ovsa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110422'),
('11042240', '--- Ošúpané (zbavené šupiek alebo vylúpané), tiež rezané alebo šrotované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042240'),
('11042250', '--- Perlovité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042250'),
('11042295', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042295'),
('110423', '-- Z kukurice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110423'),
('11042340', '--- Ošúpané (zbavené šupiek alebo vylúpané), tiež rezané alebo šrotované; perlovité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042340'),
('11042398', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042398'),
('110429', '-- Z ostatných obilnín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110429'),
('110429:2X', '--- Z jačmeňa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110429:2X'),
('11042904', '---- Ošúpané (zbavené šupiek alebo vylúpané), tiež rezané alebo šrotované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042904'),
('11042905', '---- Perlovité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042905'),
('11042908', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042908'),
('11042908:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042908:2X'),
('11042917', '---- Ošúpané (zbavené šupiek alebo vylúpané), tiež rezané alebo šrotované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042917'),
('11042930', '---- Perlovité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042930'),
('11042930:2X', '---- Inak nespracované ako šrotované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042930:2X'),
('11042951', '----- Z pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042951'),
('11042955', '----- Z raže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042955'),
('11042959', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042959'),
('11042959:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042959:2X'),
('11042981', '----- Z pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042981'),
('11042985', '----- Z raže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042985'),
('11042989', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11042989'),
('110430', '- Obilné klíčky, celé, drvené na valcoch, vločkované alebo mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110430'),
('11043010', '-- Z pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11043010'),
('11043090', '-- Z ostatných obilnín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11043090'),
('1105', 'Múka, krupica, prášok, vločky, granuly a pelety zo zemiakov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1105'),
('11051000', '- Múka, krupica a prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11051000'),
('11052000', '- Vločky, granuly a pelety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11052000'),
('1106', 'Múka, krupica a prášok zo sušených strukovín položky 0713, zo sága alebo koreňov alebo hľúz položky 0714 alebo produktov kapitoly 8', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1106'),
('11061000', '- Zo sušených strukovín položky 0713', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11061000'),
('110620', '- Zo sága alebo koreňov alebo hľúz položky 0714', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110620'),
('11062010', '-- Denaturované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11062010'),
('11062090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11062090'),
('110630', '- Z produktov kapitoly 8', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110630'),
('11063010', '-- Z banánov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11063010'),
('11063090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11063090'),
('1107', 'Slad, tiež pražený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1107'),
('110710', '- Nepražený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110710'),
('110710:2X', '-- Z pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110710:2X'),
('11071011', '--- Vo forme múky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11071011'),
('11071019', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11071019'),
('11071019:2X', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11071019:2X'),
('11071091', '--- Vo forme múky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11071091'),
('11071099', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11071099'),
('11072000', '- Pražený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11072000'),
('1108', 'Škroby; inulín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1108'),
('1108:2X', '- Škroby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1108:2X'),
('11081100', '-- Pšeničný škrob', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11081100'),
('11081200', '-- Kukuričný škrob', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11081200'),
('11081300', '-- Zemiakový škrob', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11081300'),
('11081400', '-- Maniokový (kasavový) škrob', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11081400'),
('110819', '-- Ostatné škroby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_110819'),
('11081910', '--- Ryžový škrob', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11081910'),
('11081990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11081990'),
('11082000', '- Inulín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11082000'),
('11090000', 'Pšeničný lepok, tiež sušený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_11090000'),
('1201', 'Sójové bôby, tiež drvené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1201'),
('12011000', '- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12011000'),
('12019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12019000'),
('1202', 'Arašidové oriešky, nepražené ani inak tepelne neupravené, tiež lúpané alebo drvené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1202'),
('12023000', '- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12023000'),
('12023000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12023000:2X'),
('12024100', '-- Nelúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12024100'),
('12024200', '-- Lúpané, tiež drvené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12024200'),
('12030000', 'Kopra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12030000'),
('120400', 'Ľanová semená, tiež drvené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120400'),
('12040010', '- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12040010'),
('12040090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12040090'),
('1205', 'Semená repky alebo semená repky olejnej, tiež drvené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1205'),
('120510', '- Semená repky alebo repky olejnej s nízkym obsahom kyseliny erukovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120510'),
('12051010', '-- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12051010'),
('12051090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12051090'),
('12059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12059000'),
('120600', 'Slnečnicové semená, tiež drvené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120600'),
('12060010', '- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12060010'),
('12060010:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12060010:2X'),
('12060091', '-- Lúpané; nelúpané v sivobieloprúžkovanej šupke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12060091'),
('12060099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12060099'),
('1207', 'Ostatné olejnaté semená a olejnaté plody, tiež drvené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1207'),
('12071000', '- Palmové orechy a jadrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12071000'),
('12071000:2X', '- Bavilníkové semená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12071000:2X'),
('12072100', '-- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12072100'),
('12072900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12072900'),
('12073000', '- Ricíové semená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12073000'),
('120740', '- Sezamové semená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120740'),
('12074010', '-- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12074010'),
('12074090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12074090'),
('120750', '- Horčičné semená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120750'),
('12075010', '-- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12075010'),
('12075090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12075090'),
('12076000', '- Svetlicové semená (Carthamus tinctorius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12076000'),
('12077000', '- Melónové semená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12077000'),
('12077000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12077000:2X'),
('120791', '-- Makové semená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120791'),
('12079110', '--- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12079110'),
('12079190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12079190'),
('120799', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120799'),
('12079920', '--- Na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12079920'),
('12079920:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12079920:2X'),
('12079991', '---- Konopné semená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12079991'),
('12079996', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12079996'),
('1208', 'Múka a krupica z olejnatých semien alebo olejnatých plodov, z iných ako horčičných semien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1208'),
('12081000', '- Zo sójových bôbov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12081000'),
('12089000', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12089000'),
('1209', 'Semená, plody a výtrusy, druhov používaných na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1209'),
('12091000', '- Semená cukrovej repy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12091000'),
('12091000:2X', '- Semená krmovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12091000:2X'),
('12092100', '-- Semená lucerny (alfalfa)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092100'),
('120922', '-- Semená ďateliny (Trifolium spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120922'),
('12092210', '--- Semená ďateliny lúčnej (Trifolium pratense L.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092210'),
('12092280', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092280'),
('120923', '-- Semená kostravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120923'),
('12092311', '--- Semená kostravy lúčnej (Festuca pratensisHuds.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092311'),
('12092315', '--- Semená kostravy červenej (Festuca rubra L.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092315'),
('12092380', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092380'),
('12092400', '-- Semená lipnice lúčnej (Poa pratensis L.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092400'),
('120925', '-- Semená mätonoha (Lolium multiflorum Lam., Lolium perenne L.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120925'),
('12092510', '--- Semená mätonoha mnohokvetého (Lolium multiflorum Lam.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092510'),
('12092590', '--- Semená mätonoha trváceho (Lolium perenne L.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092590'),
('120929', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120929'),
('12092945', '--- Semená timotejky lúčnej; semená viky; semená rodu Poa (lipnica močiarna Poa palustris L., lipnica pospolitá Poa trivialis L.); reznačky laločnatej (Dactylis glomerata L.); psinčeka (Agrostis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092945'),
('12092950', '--- Semená vlčieho bôbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092950'),
('12092960', '--- Semená kŕmnej repy (Beta vulgaris var. alba)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092960'),
('12092980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12092980'),
('12093000', '- Semená liečivých rastlín pestovaných hlavne pre ich kvety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12093000'),
('12093000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12093000:2X'),
('120991', '-- Semená zeleniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120991'),
('12099130', '--- Semená cvikly (Beta vulgaris var. conditiva)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12099130'),
('12099180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12099180'),
('120999', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_120999'),
('12099910', '--- Semená lesných stromov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12099910'),
('12099910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12099910:2X'),
('12099991', '---- Semená rastlín pestovaných hlavne pre ich kvety, iné ako semená podpoložky 1209 30', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12099991'),
('12099999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12099999'),
('1210', 'Chmeľové šištičky, čerstvé alebo sušené, tiež mleté, v prášku alebo vo forme peliet; lupulín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1210'),
('12101000', '- Chmeľové šištičky, nemleté, ani v prášku, ani vo forme peliet', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12101000'),
('121020', '- Chmeľové šištičky, mleté, v prášku alebo vo forme peliet; lupulín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_121020'),
('12102010', '-- Chmeľové šištičky, mleté, v prášku alebo vo forme peliet, s vyšším obsahom lupulínu; lupulín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12102010'),
('12102090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12102090'),
('1211', 'Rastliny a časti rastlín (vrátane semien a plodov), druhov používaných hlavne v parfumérii, vo farmácii alebo na insekticídne, fungicídne alebo podobné účely, čerstvé alebo sušené, tiež rezané, drvené alebo v prášku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1211'),
('12112000', '- Korene ženšenu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12112000'),
('12113000', '- Listy koky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12113000'),
('12114000', '- Maková slama', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12114000'),
('121190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_121190'),
('12119030', '-- Tonkové fazule', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12119030'),
('12119085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12119085'),
('1212', 'Svätojánsky chlieb, morské riasy a ostatné riasy, cukrová repa a cukrová trstina, čerstvé, chladené, mrazené alebo sušené, tiež mleté; kôstky a jadrá plodov a ostatné rastlinné produkty (vrátane nepražených koreňov čakanky odrody Cichorium intybus sativ', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1212'),
('1212:2X', '- Morské riasy a ostatné riasy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1212:2X'),
('12122100', '-- Vhodné na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12122100'),
('12122900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12122900'),
('12122900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12122900:2X'),
('121291', '-- Cukrová repa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_121291'),
('12129120', '--- Sušená, tiež mletá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12129120'),
('12129180', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12129180'),
('12129200', '-- Svätojánsky chlieb (rohovník)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12129200'),
('12129300', '-- Cukrová trstina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12129300'),
('12129400', '-- Korene čakanky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12129400'),
('121299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_121299'),
('121299:2X', '--- Semená svätojánskeho chleba', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_121299:2X'),
('12129941', '---- Neolúpané, nedrvené ani nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12129941'),
('12129949', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12129949'),
('12129995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12129995'),
('12130000', 'Obilná slama a plevy, nespracované, tiež rezané, mleté, lisované alebo vo forme peliet', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12130000'),
('1214', 'Kvaka, kŕmna repa, kŕmne korene, seno, lucerna (alfalfa), ďatelina, vičenec (hedysárum), kŕmny kel, vlčí bôb, vika a podobné krmovinové produkty, tiež vo forme peliet', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1214'),
('12141000', '- Múka a pelety z lucerny (alfalfa)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12141000'),
('121490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_121490'),
('12149010', '-- Kŕmna repa, kvaka a ostatné kŕmne korene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12149010'),
('12149090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_12149090'),
('1301', 'Šelak; prírodné gumy, živice, gumoživice a olejoživice (napríklad balzamy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1301'),
('13012000', '- Arabská guma', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13012000'),
('13019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13019000'),
('1302', 'Rastlinné šťavy a výťažky; pektínové látky, pektináty a pektáty; agar-agar a ostatné slizy a zahusťovadlá, tiež modifikované, získané z rastlinných produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1302'),
('1302:2X', '- Rastlinné šťavy a výťažky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1302:2X'),
('13021100', '-- Ópium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13021100'),
('13021200', '-- Zo sladkého drievka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13021200'),
('13021300', '-- Z chmeľu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13021300'),
('130219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_130219'),
('13021905', '--- Olejoživica vanilky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13021905'),
('13021980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13021980'),
('130220', '- Pektínové látky, pektináty a pektáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_130220'),
('13022010', '-- V suchom stave', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13022010'),
('13022090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13022090'),
('13022090:2X', '- Slizy a zahusťovadlá, tiež modifikované, získané z rastlinných produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13022090:2X'),
('13023100', '-- Agar-agar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13023100'),
('130232', '-- Slizy a zahusťovadlá, tiež modifikované, získané zo svätojánskeho chleba, zo semien svätojánskeho chleba alebo guarových semien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_130232'),
('13023210', '--- Zo svätojánskeho chleba alebo zo semien svätojánskeho chleba', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13023210'),
('13023290', '--- Z guarových semien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13023290'),
('13023900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_13023900'),
('1401', 'Rastlinné materiály druhov používaných hlavne na pletenie (napríklad bambus, ratan, trstina, tŕstie, vŕbové prútie, rafia, čistená, bielená alebo farbená obilná slama, a lipová kôra)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1401'),
('14011000', '- Bambus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_14011000'),
('14012000', '- Ratan', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_14012000'),
('14019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_14019000'),
('1404', 'Rastlinné produkty inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1404'),
('14042000', '- Bavlníkové lintre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_14042000'),
('14049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_14049000'),
('1501', 'Prasací tuk (vrátane sadla) a hydinový tuk, iný ako tuk položky 0209 alebo 1503', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1501'),
('150110', '- Sadlo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150110'),
('15011010', '-- Na priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15011010'),
('15011090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15011090'),
('150120', '- Ostatný prasací tuk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150120'),
('15012010', '-- Na priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15012010'),
('15012090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15012090'),
('15019000', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15019000'),
('1502', 'Tuk z hovädzích zvierat, oviec alebo kôz, iný ako tuk položky 1503', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1502'),
('150210', '- Loj', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150210'),
('15021010', '-- Na priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15021010'),
('15021090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15021090'),
('150290', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150290'),
('15029010', '-- Na priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15029010'),
('15029090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15029090'),
('150300', 'Stearín zo sadla, sadlový olej, oleostearín, oleomargarín a lojový olej, nie emulgované alebo zmiešané alebo inak upravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150300'),
('150300:2X', '- Stearín a oleostearín zo sadla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150300:2X'),
('15030011', '-- Na priemyselné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15030011'),
('15030019', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15030019'),
('15030030', '- Lojový olej na priemyselné účely, iný ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15030030'),
('15030090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15030090'),
('1504', 'Tuky a oleje a ich frakcie, z rýb alebo morských cicavcov, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1504'),
('150410', '- Oleje z rybacej pečene a ich frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150410'),
('15041010', '-- S obsahom vitamínu A nepresahujúcim 2 500 IU/g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15041010'),
('15041010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15041010:2X'),
('15041091', '--- Z halibuta', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15041091'),
('15041099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15041099'),
('150420', '- Tuky a oleje a ich frakcie, z rýb, iné ako oleje z pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150420'),
('15042010', '-- Tuhé frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15042010'),
('15042090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15042090'),
('150430', '- Tuky a oleje a ich frakcie, z morských cicavcov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150430'),
('15043010', '-- Tuhé frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15043010'),
('15043090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15043090'),
('150500', 'Tuk z ovčej vlny a tukové látky z neho získané (vrátane lanolínu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150500'),
('15050010', '- Tuk z ovčej vlny, surový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15050010'),
('15050090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15050090'),
('15060000', 'Ostatné živočíšne tuky a oleje a ich frakcie, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15060000'),
('1507', 'Sójový olej a jeho frakcie, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1507'),
('150710', '- Surový olej, tiež odglejovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150710'),
('15071010', '-- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15071010'),
('15071090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15071090'),
('150790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150790'),
('15079010', '-- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15079010'),
('15079090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15079090'),
('1508', 'Arašidový olej a jeho frakcie, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1508'),
('150810', '- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150810'),
('15081010', '-- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15081010'),
('15081090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15081090'),
('150890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150890'),
('15089010', '-- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15089010'),
('15089090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15089090'),
('1509', 'Olivový olej a jeho frakcie, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1509'),
('150910', '- Panenský', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_150910'),
('15091010', '-- Lampový olivový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15091010'),
('15091090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15091090'),
('15099000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15099000'),
('151000', 'Ostatné oleje a ich frakcie, získané výlučne z olív, tiež rafinované, ale chemicky nemodifikované, vrátane zmesí týchto olejov alebo frakcií s olejmi alebo frakciami položky 1509', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151000'),
('15100010', '- Surové oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15100010'),
('15100090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15100090'),
('1511', 'Palmový olej a jeho frakcie, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1511'),
('151110', '- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151110'),
('15111010', '-- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15111010'),
('15111090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15111090'),
('151190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151190'),
('151190:2X', '-- Tuhé frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151190:2X'),
('15119011', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15119011'),
('15119019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15119019'),
('15119019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15119019:2X'),
('15119091', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15119091'),
('15119099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15119099'),
('1512', 'Slnečnicový olej, požltový olej alebo bavlníkový olej a ich frakcie, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1512'),
('1512:2X', '- Slnečnicový alebo požltový olej a ich frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1512:2X'),
('151211', '-- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151211'),
('15121110', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15121110'),
('15121110:2X', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15121110:2X'),
('15121191', '---- Slnečnicový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15121191'),
('15121199', '---- Požltový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15121199'),
('151219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151219'),
('15121910', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15121910'),
('15121990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15121990'),
('15121990:2X', '- Bavlníkový olej a jeho frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15121990:2X'),
('151221', '-- Surový olej, tiež zbavený gossypolu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151221'),
('15122110', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15122110'),
('15122190', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15122190'),
('151229', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151229'),
('15122910', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15122910'),
('15122990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15122990'),
('1513', 'Olej z kokosových orechov (koprový olej), olej z palmových jadier alebo babasový olej a ich frakcie, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1513'),
('1513:2X', '- Olej z kokosových orechov (koprový olej) a jeho frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1513:2X'),
('151311', '-- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151311'),
('15131110', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131110'),
('15131110:2X', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131110:2X'),
('15131191', '---- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131191'),
('15131199', '---- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131199'),
('151319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151319'),
('151319:2X', '--- Tuhé frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151319:2X'),
('15131911', '---- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131911'),
('15131919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131919'),
('15131919:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131919:2X'),
('15131930', '---- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131930'),
('15131930:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131930:2X'),
('15131991', '----- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131991'),
('15131999', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131999'),
('15131999:2X', '- Olej z palmových jadier alebo babassový olej a ich frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15131999:2X'),
('151321', '-- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151321'),
('15132110', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132110'),
('15132110:2X', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132110:2X'),
('15132130', '---- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132130'),
('15132190', '---- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132190'),
('151329', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151329'),
('151329:2X', '--- Tuhé frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151329:2X'),
('15132911', '---- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132911'),
('15132919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132919'),
('15132919:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132919:2X'),
('15132930', '---- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132930'),
('15132930:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132930:2X'),
('15132950', '----- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132950'),
('15132990', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15132990'),
('1514', 'Olej z repky, repky olejnej alebo horčicový olej a ich frakcie, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1514'),
('1514:2X', '- Olej z repky alebo repky olejnej s nízkym obsahom kyseliny erukovej a ich frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1514:2X'),
('151411', '-- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151411'),
('15141110', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15141110'),
('15141190', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15141190'),
('151419', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151419'),
('15141910', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15141910'),
('15141990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15141990'),
('15141990:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15141990:2X'),
('151491', '-- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151491'),
('15149110', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15149110'),
('15149190', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15149190'),
('151499', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151499'),
('15149910', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15149910'),
('15149990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15149990'),
('1515', 'Ostatné stále rastlinné tuky a oleje (vrátane jojobového oleja) a ich frakcie, tiež rafinované, ale chemicky nemodifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1515'),
('1515:2X', '- Ľanový olej a jeho frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1515:2X'),
('15151100', '-- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15151100'),
('151519', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151519'),
('15151910', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15151910'),
('15151990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15151990'),
('15151990:2X', '- Kukuričný olej a jeho frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15151990:2X'),
('151521', '-- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151521'),
('15152110', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15152110'),
('15152190', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15152190'),
('151529', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151529'),
('15152910', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15152910'),
('15152990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15152990'),
('151530', '- Ricínový olej a jeho frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151530'),
('15153010', '-- Určené na výrobu kyseliny aminoundekánovej používanej na výrobu syntetických textilných vlákien alebo umelých plastových materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15153010'),
('15153090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15153090'),
('151550', '- Sezamový olej a jeho frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151550'),
('151550:2X', '-- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151550:2X'),
('15155011', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15155011'),
('15155019', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15155019'),
('15155019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15155019:2X'),
('15155091', '--- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15155091'),
('15155099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15155099'),
('151590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151590'),
('15159011', '-- Tungový olej; jojobový a oiticikový olej; myrtový vosk a japonský vosk; ich frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159011'),
('15159011:2X', '-- Olej z tabakových semien a jeho frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159011:2X'),
('15159011:3X', '--- Surový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159011:3X'),
('15159021', '---- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159021'),
('15159029', '---- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159029'),
('15159029:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159029:2X'),
('15159031', '---- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159031'),
('15159039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159039'),
('15159039:2X', '-- Ostatné oleje a ich frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159039:2X'),
('15159039:3X', '--- Surové oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159039:3X'),
('15159040', '---- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159040'),
('15159040:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159040:2X'),
('15159051', '----- Tuhé, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159051'),
('15159059', '----- Tuhé, ostatné; tekuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159059'),
('15159059:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159059:2X'),
('15159060', '---- Na technické alebo priemyselné účely, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159060'),
('15159060:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159060:2X'),
('15159091', '----- Tuhé, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159091'),
('15159099', '----- Tuhé, ostatné; tekuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15159099'),
('1516', 'Živočíšne alebo rastlinné tuky a oleje a ich frakcie, čiastočne alebo úplne hydrogenované, interesterifikované, reesterifikované alebo elaidinizované, tiež rafinované, ale ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1516'),
('151610', '- Živočíšne tuky a oleje a ich frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151610'),
('15161010', '-- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15161010'),
('15161090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15161090'),
('151620', '- Rastlinné tuky a oleje a ich frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151620'),
('15162010', '-- Hydrogenovaný ricínový olej, tiež nazývaný "opalwax"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15162010'),
('15162010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15162010:2X'),
('15162091', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15162091'),
('15162091:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15162091:2X'),
('15162095', '---- Oleje zo semien repky, ľanu, repky olejnej, slnečnice, ilipe, karité, makore, touloucouna alebo babassu, na technické alebo na priemyselné účely iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15162095'),
('15162095:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15162095:2X'),
('15162096', '----- Oleje z podzemnice olejnej, bavlníkových semien, sójových bôbov alebo slnečnicových semien; ostatné oleje obsahujúce menej ako 50 % hmotnosti voľných mastných kyselín, okrem olejov z palmových jadier, ilipe, kokosových orechov, repky, repky olejnej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15162096'),
('15162098', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15162098'),
('1517', 'Margarín; jedlé zmesi alebo prípravky zo živočíšnych alebo rastlinných tukov alebo olejov alebo frakcií rôznych tukov alebo olejov tejto kapitoly, iné ako jedlé tuky alebo oleje alebo ich frakcie položky 1516', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1517'),
('151710', '- Margarín, okrem tekutého margarínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151710'),
('15171010', '-- Obsahujúci v hmotnosti viac ako 10 %, ale najviac 15 % mliečnych tukov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15171010'),
('15171090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15171090'),
('151790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151790'),
('15179010', '-- Obsahujúce v hmotnosti viac ako 10 %, ale najviac 15 % mliečnych tukov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15179010'),
('15179010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15179010:2X'),
('15179091', '--- Stále rastlinné oleje, tekuté, miešané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15179091'),
('15179093', '--- Jedlé zmesi alebo prípravky druhov používaných ako prípravky na vytieranie foriem', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15179093'),
('15179099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15179099'),
('151800', 'Živočíšne alebo rastlinné tuky a oleje a ich frakcie, varené, oxidované, dehydrované, sírené, fúkané, polymerizované teplom vo vákuu alebo v inertnom plyne alebo inak chemicky modifikované, okrem tukov a olejov položky 1516; nejedlé zmesi alebo prípravk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_151800'),
('15180010', '- Linoxyn', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15180010'),
('15180010:2X', '- Stále rastlinné oleje, tekuté, miešané, určené na technické alebo priemyselné použitie, iné ako na výrobu potravín na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15180010:2X'),
('15180031', '-- Surové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15180031'),
('15180039', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15180039'),
('15180039:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15180039:2X'),
('15180091', '-- Živočíšne alebo rastlinné tuky a oleje a ich frakcie, varené, oxidované, dehydrované, sírené, fúkané, polymerizované teplom vo vákuu alebo v inertnom plyne alebo inak chemicky modifikované, okrem tukov a olejov položky 1516', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15180091'),
('15180091:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15180091:2X'),
('15180095', '--- Nejedlé zmesi alebo prípravky zo živočíšnych alebo živočíšnych a rastlinných tukov a olejov a ich frakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15180095'),
('15180099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15180099'),
('15200000', 'Glycerol surový; glycerolové vody a glycerolové lúhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15200000'),
('1521', 'Rastlinné vosky (iné ako triglyceridy), včelí vosk, ostatné hmyzie vosky a spermacet, tiež rafinované alebo farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1521'),
('15211000', '- Rastlinné vosky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15211000'),
('152190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_152190'),
('15219010', '-- Spermacet, tiež rafinovaný alebo farbený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15219010'),
('15219010:2X', '-- Včelí vosk a ostatné hmyzie vosky, tiež rafinované alebo farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15219010:2X'),
('15219091', '--- Surové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15219091'),
('15219099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15219099'),
('152200', 'Degras; zvyšky zo spracovania tukových látok alebo živočíšnych alebo rastlinných voskov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_152200'),
('15220010', '- Degras', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15220010'),
('15220010:2X', '- Zvyšky zo spracovania tukových látok alebo živočíšnych alebo rastlinných voskov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15220010:2X'),
('15220010:3X', '-- Obsahujúce olej s charakteristikami olivového oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15220010:3X'),
('15220031', '--- Mydlové kaly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15220031'),
('15220039', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15220039'),
('15220039:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15220039:2X'),
('15220091', '--- Olejové zvyšky a usadeniny; mydlové kaly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15220091'),
('15220099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_15220099'),
('160100', 'Párky, salámy a podobné výrobky, z mäsa, mäsových drobov alebo krvi; potravinové prípravky na základe týchto výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160100'),
('16010010', '- Z pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16010010'),
('16010010:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16010010:2X'),
('16010091', '-- Párky a salámy, suché alebo nátierkové, nevarené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16010091'),
('16010099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16010099'),
('1602', 'Ostatné pripravené alebo konzervované mäso, mäsové droby alebo krv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1602'),
('16021000', '- Homogenizované prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16021000'),
('160220', '- Z pečene akýchkoľvek zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160220'),
('16022010', '-- Z husacej alebo kačacej pečene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16022010'),
('16022090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16022090'),
('16022090:2X', '- Z hydiny položky 0105', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16022090:2X'),
('160231', '-- Z moriakov alebo moriek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160231'),
('160231:2X', '--- Obsahujúce v hmotnosti 57 % alebo viac hydinového mäsa alebo drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160231:2X'),
('16023111', '---- Obsahujúce len nevarené morčacie mäso', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023111'),
('16023119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023119'),
('16023180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023180'),
('160232', '-- Z hydiny druhu Gallus domesticus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160232'),
('160232:2X', '--- Obsahujúce v hmotnosti 57 % alebo viac hydinového mäsa alebo drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160232:2X'),
('16023211', '---- Nevarené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023211'),
('16023219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023219'),
('16023230', '--- Obsahujúce v hmotnosti 25 % alebo viac, ale menej ako 57 % hydinového mäsa alebo drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023230'),
('16023290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023290'),
('160239', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160239'),
('160239:2X', '--- Obsahujúce v hmotnosti 57 % alebo viac hydinového mäsa alebo drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160239:2X'),
('16023921', '---- Nevarené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023921'),
('16023929', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023929'),
('16023985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023985'),
('16023985:2X', '- Zo svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16023985:2X'),
('160241', '-- Stehná a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160241'),
('16024110', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024110'),
('16024190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024190'),
('160242', '-- Pliecka a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160242'),
('16024210', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024210'),
('16024290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024290'),
('160249', '-- Ostatné, vrátane zmesí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160249'),
('160249:2X', '--- Z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160249:2X'),
('160249:3X', '---- Obsahujúce v hmotnosti 80 % alebo viac mäsa alebo mäsových drobov, akéhokoľvek druhu, vrátane tukov akéhokoľvek druhu alebo pôvodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160249:3X'),
('16024911', '----- Chrbty (s výnimkou krkovičky) a kusy z nich, vrátane zmesí z chrbtov alebo stehien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024911'),
('16024913', '----- Krkovička a kusy z nej, vrátane zmesí z krkovičky a pliecka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024913'),
('16024915', '----- Ostatné zmesi obsahujúce stehná, pliecka, chrbty alebo krkovičky, a kusy z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024915'),
('16024919', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024919'),
('16024930', '---- Obsahujúce v hmotnosti 40 % alebo viac, ale menej ako 80 % mäsa alebo mäsových drobov, akéhokoľvek druhu, vrátane tukov akéhokoľvek druhu alebo pôvodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024930'),
('16024950', '---- Obsahujúce v hmotnosti menej ako 40 % mäsa alebo mäsových drobov, akéhokoľvek druhu, vrátane tukov akéhokoľvek druhu alebo pôvodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024950'),
('16024990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16024990'),
('160250', '- Z hovädzích zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160250'),
('16025010', '-- Nevarené; zmesi vareného mäsa alebo drobov a nevareného mäsa alebo drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16025010'),
('16025010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16025010:2X'),
('16025031', '--- Solené hovädzie, v hermeticky uzavretých nádobách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16025031'),
('16025095', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16025095'),
('160290', '- Ostatné, vrátane prípravkov z krvi akýchkoľvek zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160290'),
('16029010', '-- Prípravky z krvi akýchkoľvek zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029010'),
('16029010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029010:2X'),
('16029031', '--- Zo zveriny alebo králikov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029031'),
('16029031:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029031:2X'),
('16029051', '---- Obsahujúce mäso alebo mäsové droby z domácich svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029051'),
('16029051:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029051:2X'),
('16029051:3X', '----- Obsahujúce hovädzie mäso alebo droby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029051:3X'),
('16029061', '------ Nevarené; zmesi vareného mäsa alebo drobov a nevareného mäsa alebo drobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029061'),
('16029069', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029069'),
('16029069:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029069:2X'),
('16029091', '------ Z oviec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029091'),
('16029095', '------ Z kôz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029095'),
('16029099', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16029099'),
('160300', 'Výťažky a šťavy z mäsa, rýb alebo kôrovcov, mäkkýšov alebo ostatných vodných bezstavovcov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160300'),
('16030010', '- V bezprostrednom obale s netto obsahom 1 kg alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16030010'),
('16030080', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16030080'),
('1604', 'Pripravené alebo konzervované ryby; kaviár a náhradky kaviáru z rybacích ikier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1604'),
('1604:2X', '- Ryby, celé alebo kusoch, ale nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1604:2X'),
('16041100', '-- Lososy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041100'),
('160412', '-- Slede', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160412'),
('16041210', '--- Filé, surové, len obalené cestom alebo strúhankou, tiež predsmažené v oleji, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041210'),
('16041210:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041210:2X'),
('16041291', '---- V hermeticky uzavretých obaloch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041291'),
('16041299', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041299'),
('160413', '-- Sardinky, sardinely a šproty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160413'),
('160413:2X', '--- Sardinky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160413:2X'),
('16041311', '---- V olivovom oleji', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041311'),
('16041319', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041319'),
('16041390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041390'),
('160414', '-- Tuniaky, skipjack a bonito (Sarda spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160414'),
('160414:2X', '--- Tuniaky a skipjack', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160414:2X'),
('16041411', '---- V rastlinnom oleji', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041411'),
('16041411:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041411:2X'),
('16041416', '----- Filé známe ako "chrbtové"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041416'),
('16041418', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041418'),
('16041490', '--- Bonito (Sarda spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041490'),
('160415', '-- Makrely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160415'),
('160415:2X', '--- Z druhov Scomber scombrus a Scomber japonicus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160415:2X'),
('16041511', '---- Filé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041511'),
('16041519', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041519'),
('16041590', '--- Z druhu Scomber australasicus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041590'),
('16041600', '-- Sardely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041600'),
('16041700', '-- Úhory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041700'),
('160419', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160419'),
('16041910', '--- Lososovité, iné ako lososy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041910'),
('16041910:2X', '--- Ryby rodu Euthynnus, iné ako skipjack [Euthynnus (Katsuwonus) pelamis]', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041910:2X'),
('16041931', '---- Filé známe ako "chrbtové"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041931'),
('16041939', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041939'),
('16041950', '--- Ryby druhu Orcynopsis unicolor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041950'),
('16041950:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041950:2X'),
('16041991', '---- Filé, surové, len obalené cestom alebo strúhankou, tiež predsmažené v oleji, mrazené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041991'),
('16041991:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041991:2X'),
('16041992', '----- Tresky (Gadus morhua, Gadus ogac, Gadus macrocephalus)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041992'),
('16041993', '----- Treska tmavá (Pollachius virens)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041993'),
('16041994', '----- Merlúzy (Merluccius spp., Urophycis spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041994'),
('16041995', '----- Treska aljašská (Theragra chalcogramma) a treska európska (Pollachius pollachius)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041995'),
('16041997', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16041997'),
('160420', '- Ostatné pripravené alebo konzervované ryby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160420'),
('16042005', '-- Prípravky zo surimi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16042005'),
('16042005:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16042005:2X'),
('16042010', '--- Z lososov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16042010'),
('16042030', '--- Z lososovitých rýb, iných ako lososov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16042030'),
('16042040', '--- Zo sardel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16042040'),
('16042050', '--- Zo sardiniek, bonít, makrel druhov Scomber scombrus a Scomber japonicus, z rýb druhu Orcynopsis unicolor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16042050'),
('16042070', '--- Z tuniakov, skipjack alebo ostatných rýb rodu Euthynnus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16042070'),
('16042090', '--- Z ostatných rýb', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16042090'),
('16042090:2X', '- Kaviár a náhradky kaviáru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16042090:2X'),
('16043100', '-- Kaviár', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16043100'),
('16043200', '-- Náhradky kaviáru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16043200'),
('1605', 'Kôrovce, mäkkýše a ostatné vodné bezstavovce, pripravené alebo konzervované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1605'),
('16051000', '- Kraby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16051000'),
('16051000:2X', '- Krevety a garnáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16051000:2X'),
('160521', '-- Nie v hermeticky uzavretých nádobách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160521'),
('16052110', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 2 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16052110'),
('16052190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16052190'),
('16052900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16052900'),
('160530', '- Homáre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160530'),
('16053010', '-- Mäso z homárov, nevarené, na výrobu homárieho masla alebo homárich pást, nátierok, polievok alebo omáčok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16053010'),
('16053090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16053090'),
('16054000', '- Ostatné kôrovce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16054000'),
('16054000:2X', '- Mäkkýše', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16054000:2X'),
('16055100', '-- Ustrice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055100'),
('16055200', '-- Hrebenatky, vrátane hrebenatky kráľovskej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055200'),
('160553', '-- Slávky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_160553'),
('16055310', '--- V hermeticky uzavretých nádobách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055310'),
('16055390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055390'),
('16055400', '-- Sépie a kalmáre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055400'),
('16055500', '-- Chobotnice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055500'),
('16055600', '-- Lastúrniky, srdcovky a mušle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055600'),
('16055700', '-- Uchovce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055700'),
('16055800', '-- Slimáky, iné ako morské slimáky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055800'),
('16055900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055900'),
('16055900:2X', '- Ostatné vodné bezstavovce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16055900:2X'),
('16056100', '-- Holotúrie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16056100'),
('16056200', '-- Ježovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16056200'),
('16056300', '-- Medúzy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16056300'),
('16056900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_16056900'),
('1701', 'Trstinový alebo repný cukor a chemicky čistá sacharóza, v pevnom stave', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1701'),
('1701:2X', '- Surový cukor neobsahujúci pridané ochucujúce alebo farbiace látky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1701:2X'),
('170112', '-- Repný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170112'),
('17011210', '--- Určený na rafináciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17011210'),
('17011290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17011290'),
('170113', '-- Trstinový cukor uvedený v poznámke 2 k podpoložkám tejto kapitoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170113'),
('17011310', '--- Určený na rafináciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17011310'),
('17011390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17011390'),
('170114', '-- Ostatný trstinový cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170114'),
('17011410', '--- Určený na rafináciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17011410'),
('17011490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17011490'),
('17011490:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17011490:2X'),
('17019100', '-- Obsahujúci pridané ochucujúce alebo farbiace látky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17019100'),
('170199', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170199'),
('17019910', '--- Biely cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17019910'),
('17019990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17019990'),
('1702', 'Ostatné cukry, vrátane chemicky čistej laktózy, maltózy, glukózy a fruktózy, v pevnej forme; cukrové sirupy neobsahujúce pridané ochucujúce alebo farbiace látky; umelý med, tiež zmiešaný s prírodným medom; karamel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1702'),
('1702:2X', '- Laktóza a laktózový sirup', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1702:2X'),
('17021100', '-- Obsahujúce v hmotnosti 99 % alebo viac laktózy, vyjadrenej ako bezvodá laktóza, počítané na suchú hmotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17021100'),
('17021900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17021900'),
('170220', '- Javorový cukor a javorový sirup', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170220'),
('17022010', '-- Javorový cukor v pevnej forme, obsahujúci pridané ochucujúce alebo farbiace látky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17022010'),
('17022090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17022090'),
('170230', '- Glukóza a glukózový sirup, neobsahujúce fruktózu alebo obsahujúce v sušine menej ako 20 % hmotnosti fruktózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170230'),
('17023010', '-- Izoglukóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17023010'),
('17023010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17023010:2X'),
('17023050', '--- Vo forme bieleho kryštalického prášku, tiež aglomerované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17023050'),
('17023090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17023090'),
('170240', '- Glukóza a glukózový sirup, obsahujúce v sušine najmenej 20 %, ale menej ako 50 % hmotnosti fruktózy, okrem invertného cukru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170240'),
('17024010', '-- Izoglukóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17024010'),
('17024090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17024090'),
('17025000', '- Chemicky čistá fruktóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17025000'),
('170260', '- Ostatná fruktóza a fruktózový sirup, obsahujúce v sušine viac ako 50 % hmotnosti fruktózy, okrem invertného cukru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170260'),
('17026010', '-- Izoglukóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17026010'),
('17026080', '-- Inulínový sirup', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17026080'),
('17026095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17026095'),
('170290', '- Ostatné, vrátane invertného cukru a ostatného cukru a cukrových sirupových zmesí, obsahujúcich v sušine 50 % hmotnosti fruktózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170290'),
('17029010', '-- Chemicky čistá maltóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029010'),
('17029030', '-- Izoglukóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029030'),
('17029050', '-- Maltodextrín a maltodextrínový sirup', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029050'),
('17029050:2X', '-- Karamel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029050:2X'),
('17029071', '--- Obsahujúci v sušine 50 % hmotnosti alebo viac sacharózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029071'),
('17029071:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029071:2X'),
('17029075', '---- Vo forme prášku, tiež aglomerované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029075'),
('17029079', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029079'),
('17029080', '-- Inulínový sirup', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029080'),
('17029095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17029095'),
('1703', 'Melasy získané z extrakcie alebo rafinácie cukru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1703'),
('17031000', '- Trstinová melasa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17031000'),
('17039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17039000'),
('1704', 'Cukrovinky (vrátane bielej čokolády), neobsahujúce kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1704'),
('170410', '- Žuvacia guma, tiež obalená cukrom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170410'),
('17041010', '-- Obsahujúca v hmotnosti menej ako 60 % sacharózy (vrátane invertného cukru vyjadreného ako sacharóza)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17041010'),
('17041090', '-- Obsahujúca v hmotnosti 60 % alebo viac sacharózy (vrátane invertného cukru vyjadreného ako sacharóza)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17041090'),
('170490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_170490'),
('17049010', '-- Výťažok zo sladkého drievka obsahujúci v hmotnosti viac ako 10 % sacharózy, ale neobsahujúci ostatné pridané látky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049010'),
('17049030', '-- Biela čokoláda', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049030'),
('17049030:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049030:2X'),
('17049051', '--- Cestá, vrátane marcipánu, v bezprostrednom obale s netto obsahom 1 kg alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049051'),
('17049055', '--- Zdravotné pastilky a bonbóny proti kašľu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049055'),
('17049061', '--- Cukrom potiahnutý výrobok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049061'),
('17049061:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049061:2X'),
('17049065', '---- Gumové a želatínové cukrovinky, vrátane ovocných pást vo forme cukroviniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049065'),
('17049071', '---- Tvrdé bonbóny, tiež plnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049071'),
('17049075', '---- Karamelky a podobné bonbóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049075'),
('17049075:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049075:2X'),
('17049081', '----- Lisované tabletky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049081'),
('17049099', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_17049099'),
('18010000', 'Kakaové bôby, celé alebo drvené, surové alebo pražené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18010000'),
('18020000', 'Kakaové škrupiny, šupky, kožky a ostatný kakaový odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18020000'),
('1803', 'Kakaová pasta, tiež odtučnená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1803'),
('18031000', '- Neodtučnená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18031000'),
('18032000', '- Celkom alebo čiastočne odtučnená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18032000'),
('18040000', 'Kakaové maslo, tuk a olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18040000'),
('18050000', 'Kakaový prášok, neobsahujúci pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18050000'),
('1806', 'Čokoláda a ostatné potravinové prípravky obsahujúce kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1806'),
('180610', '- Kakaový prášok, obsahujúci pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_180610'),
('18061015', '-- Neobsahujúci sacharózu alebo obsahujúci menej ako 5 % hmotnosti sacharózy (vrátane invertného cukru vyjadreného ako sacharóza) alebo izoglukózy vyjadrenej ako sacharóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18061015'),
('18061020', '-- Obsahujúci 5 % alebo viac, ale menej ako 65 % hmotnosti sacharózy (vrátane invertného cukru vyjadreného ako sacharóza) alebo izoglukózy vyjadrenej ako sacharóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18061020'),
('18061030', '-- Obsahujúci 65 % alebo viac, ale menej ako 80 % hmotnosti sacharózy (vrátane invertného cukru vyjadreného ako sacharóza) alebo izoglukózy vyjadrenej ako sacharóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18061030'),
('18061090', '-- Obsahujúci 80 % hmotnosti alebo viac sacharózy (vrátane invertného cukru vyjadreného ako sacharóza) alebo izoglukózy vyjadrenej ako sacharóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18061090'),
('180620', '- Ostatné prípravky v blokoch, tabuľkách alebo tyčinkách vážiace viac ako 2 kg, alebo tekuté, v paste, prášku, granulované alebo v ostatných voľne ložených formách, v nádobách alebo v bezprostrednom obale, s hmotnosťou obsahu presahujúcou 2 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_180620'),
('18062010', '-- Obsahujúce 31 % hmotnosti alebo viac kakaového masla alebo obsahujúce 31 % hmotnosti alebo viac kombinácie kakaového masla a mliečneho tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18062010'),
('18062030', '-- Obsahujúce 25 % alebo viac, ale menej ako 31 % hmotnosti kombinácie kakaového masla a mliečneho tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18062030'),
('18062030:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18062030:2X'),
('18062050', '--- Obsahujúce 18 % hmotnosti alebo viac kakaového masla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18062050'),
('18062070', '--- Prípravky nazývané "čokoládovo mliečne drobky" (chocolate milk crumb)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18062070'),
('18062080', '--- Čokoládové polevy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18062080'),
('18062095', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18062095'),
('18062095:2X', '- Ostatné, v blokoch, tabuľkách alebo tyčinkách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18062095:2X'),
('18063100', '-- Plnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18063100'),
('180632', '-- Neplnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_180632'),
('18063210', '--- S pridanými obilninami, ovocím alebo orechmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18063210'),
('18063290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18063290'),
('180690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_180690'),
('180690:2X', '-- Čokoláda a čokoládové výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_180690:2X'),
('180690:3X', '--- Čokoládové bonbóny (vrátane praliniek), tiež plnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_180690:3X'),
('18069011', '---- Obsahujúce alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18069011'),
('18069019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18069019'),
('18069019:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18069019:2X'),
('18069031', '---- Plnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18069031'),
('18069039', '---- Neplnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18069039'),
('18069050', '-- Cukrovinky a ich náhradky vyrobené z náhradiek cukru, obsahujúce kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18069050'),
('18069060', '-- Nátierky obsahujúce kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18069060'),
('18069070', '-- Prípravky na výrobu nápojov obsahujúce kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18069070'),
('18069090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_18069090'),
('1901', 'Sladový výťažok; potravinové prípravky z múky, krúpov, krupice, škrobu alebo zo sladového výťažku, neobsahujúce kakao alebo obsahujúce menej ako 40 % hmotnosti kakaa počítaného na celkom odtučnený základ, inde nešpecifikované ani nezahrnuté; potravinové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1901'),
('19011000', '- Prípravky na výživu detí, v balení na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19011000'),
('19012000', '- Zmesi a cestá na prípravu pekárskeho tovaru položky 1905', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19012000'),
('190190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190190'),
('190190:2X', '-- Sladový výťažok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190190:2X'),
('19019011', '--- S obsahom suchého výťažku 90 % hmotnosti alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19019011'),
('19019019', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19019019'),
('19019019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19019019:2X'),
('19019091', '--- Neobsahujúce mliečne tuky, sacharózu, izoglukózu, glukózu alebo škrob alebo obsahujúce menej ako 1,5 % mliečnych tukov, 5 % sacharózy (vrátane invertného cukru) alebo izoglukózy, 5 % glukózy alebo škrobu, okrem potravinových prípravkov v prášku z tov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19019091'),
('19019099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19019099'),
('1902', 'Cestoviny, tiež varené alebo plnené (mäsom alebo ostatnými plnkami) alebo inak upravené, také ako špagety, makaróny, rezance, široké rezance, halušky, ravioly, canneloni; kuskus, tiež pripravený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1902'),
('1902:2X', '- Cestoviny nevarené, neplnené ani inak nepripravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1902:2X'),
('19021100', '-- Obsahujúce vajcia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19021100'),
('190219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190219'),
('19021910', '--- Neobsahujúce múku alebo krupicu z obyčajnej pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19021910'),
('19021990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19021990'),
('190220', '- Plnené cestoviny, tiež varené alebo inak pripravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190220'),
('19022010', '-- Obsahujúce v hmotnosti viac ako 20 % rýb, kôrovcov, mäkkýšov alebo ostatných vodných bezstavovcov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19022010'),
('19022030', '-- Obsahujúce v hmotnosti viac ako 20 % párkov, salám a podobných výrobkov, z mäsa a mäsových drobov akéhokoľvek druhu, vrátane tukov akéhokoľvek druhu alebo pôvodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19022030'),
('19022030:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19022030:2X'),
('19022091', '--- Varené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19022091'),
('19022099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19022099'),
('190230', '- Ostatné cestoviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190230'),
('19023010', '-- Sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19023010'),
('19023090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19023090'),
('190240', '- Kuskus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190240'),
('19024010', '-- Nepripravený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19024010'),
('19024090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19024090'),
('19030000', 'Tapioka a jej náhradky pripravené zo škrobu, vo forme vločiek, zŕn, perličiek alebo v podobných formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19030000'),
('1904', 'Pripravené potraviny získané napučaním alebo pražením obilnín alebo obilných výrobkov (napríklad kukuričné vločky); obilniny (iné ako kukuričné zrná) v zrnách alebo vo forme vločiek alebo inak spracované zrná (okrem múky, krúpov a krupice), predvarené a', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1904'),
('190410', '- Pripravené potraviny získané napučaním alebo pražením obilnín alebo obilných výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190410'),
('19041010', '-- Získané z kukurice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19041010'),
('19041030', '-- Získané z ryže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19041030'),
('19041090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19041090'),
('190420', '- Pripravené potraviny získané z nepražených obilných vločiek alebo zo zmesi nepražených obilných vločiek a pražených obilných vločiek alebo napučaných obilnín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190420'),
('19042010', '-- Prípravky typu "müsli" na základe nepražených obilných vločiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19042010'),
('19042010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19042010:2X'),
('19042091', '--- Získané z kukurice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19042091'),
('19042095', '--- Získané z ryže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19042095'),
('19042099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19042099'),
('19043000', '- Pšenica bulgur', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19043000'),
('190490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190490'),
('19049010', '-- Získané z ryže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19049010'),
('19049080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19049080'),
('1905', 'Chlieb, sladké pečivo, koláče, sušienky a ostatné pekárske výrobky, tiež obsahujúce kakao; hostie, prázdne oblátky druhov používaných na farmaceutické účely, oblátky na pečenie, ryžový papier a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_1905'),
('19051000', '- Chrumkavý chlieb', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19051000'),
('190520', '- Medovník a podobné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190520'),
('19052010', '-- Obsahujúce v hmotnosti menej ako 30 % sacharózy (vrátane invertného cukru vyjadreného ako sacharóza)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19052010'),
('19052030', '-- Obsahujúce v hmotnosti 30 % alebo viac, ale menej ako 50 % sacharózy (vrátane invertného cukru vyjadreného ako sacharóza)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19052030'),
('19052090', '-- Obsahujúce v hmotnosti 50 % alebo viac sacharózy (vrátane invertného cukru vyjadreného ako sacharóza)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19052090'),
('19052090:2X', '- Sladké sušienky; wafle a oblátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19052090:2X'),
('190531', '-- Sladké sušienky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190531'),
('190531:2X', '--- Celkom alebo čiastočne potiahnuté alebo pokryté čokoládou alebo ostatnými prípravkami obsahujúcimi kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190531:2X'),
('19053111', '---- V bezprostrednom obale s netto obsahom nepresahujúcim 85 g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053111'),
('19053119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053119'),
('19053119:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053119:2X'),
('19053130', '---- Obsahujúce 8 % hmotnosti alebo viac mliečnych tukov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053130'),
('19053130:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053130:2X'),
('19053191', '----- Zlepované sušienky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053191'),
('19053199', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053199'),
('190532', '-- Wafle a oblátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190532'),
('19053205', '--- S obsahom vody presahujúcim 10 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053205'),
('19053205:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053205:2X'),
('19053205:3X', '---- Celkom alebo čiastočne potiahnuté alebo pokryté čokoládou alebo ostatnými prípravkami obsahujúcimi kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053205:3X'),
('19053211', '----- V bezprostrednom obale s netto obsahom nepresahujúcim 85 g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053211'),
('19053219', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053219'),
('19053219:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053219:2X'),
('19053291', '----- Solené, tiež plnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053291'),
('19053299', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19053299'),
('190540', '- Sucháre, opekaný chlieb a podobné opekané výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190540'),
('19054010', '-- Sucháre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19054010'),
('19054090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19054090'),
('190590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_190590'),
('19059010', '-- Macesy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19059010'),
('19059020', '-- Hostie, prázdne oblátky druhov používaných na farmaceutické účely, oblátky na pečenie, ryžový papier a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19059020'),
('19059020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19059020:2X'),
('19059030', '--- Chlieb, neobsahujúci pridaný med, vajcia, syr alebo ovocie a obsahujúci v sušine najviac 5 % hmotnosti cukrov a najviac 5 % hmotnosti tuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19059030'),
('19059045', '--- Sušienky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19059045'),
('19059055', '--- Výrobky extrudované alebo expandované, ochutené alebo solené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19059055'),
('19059055:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19059055:2X'),
('19059060', '---- S pridanými sladidlami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19059060'),
('19059090', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_19059090'),
('2001', 'Zelenina, ovocie, orechy a ostatné jedlé časti rastlín, pripravené alebo konzervované v octe alebo kyseline octovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2001'),
('20011000', '- Uhorky šalátové a uhorky nakladačky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KGM'), 'SK_20011000'),
('200190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200190'),
('20019010', '-- "Chutney" z manga', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20019010'),
('20019020', '-- Plody rodu Capsicum, iné ako sladká paprika alebo pimentos', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20019020'),
('20019030', '-- Kukurica cukrová (Zea mays var. saccharata)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20019030'),
('20019040', '-- Yamy, sladké zemiaky a podobné jedlé časti rastlín obsahujúce 5 % hmotnosti alebo viac škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20019040'),
('20019050', '-- Huby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20019050'),
('20019065', '-- Olivy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20019065'),
('20019070', '-- Sladká paprika', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20019070'),
('20019092', '-- Tropické ovocie a tropické orechy; palmové jadrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20019092'),
('20019097', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20019097'),
('2002', 'Rajčiaky pripravené alebo konzervované inak ako v octe alebo kyseline octovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2002'),
('200210', '- Rajčiaky, celé alebo pokrájané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200210'),
('20021010', '-- Lúpané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20021010'),
('20021090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20021090'),
('200290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200290'),
('200290:2X', '-- S obsahom sušiny menej ako 12 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200290:2X'),
('20029011', '--- V bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20029011'),
('20029019', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20029019'),
('20029019:2X', '-- S obsahom sušiny najmenej 12 % hmotnosti, ale najviac ako 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20029019:2X'),
('20029031', '--- V bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20029031'),
('20029039', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20029039'),
('20029039:2X', '-- S obsahom sušiny viac ako 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20029039:2X'),
('20029091', '--- V bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20029091'),
('20029099', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20029099'),
('2003', 'Huby a hľuzovky, pripravené alebo konzervované inak ako v octe alebo kyseline octovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2003'),
('200310', '- Huby rodu Agaricus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200310'),
('20031020', '-- Dočasne konzervované, celkom varené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KGM'), 'SK_20031020'),
('20031030', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KGM'), 'SK_20031030'),
('200390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200390'),
('20039010', '-- Hľuzovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20039010'),
('20039090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20039090'),
('2004', 'Ostatná zelenina pripravená alebo konzervovaná inak ako v octe alebo kyseline octovej, mrazená, iná ako výrobky položky 2006', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2004'),
('200410', '- Zemiaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200410'),
('20041010', '-- Varené, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20041010'),
('20041010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20041010:2X'),
('20041091', '--- Vo forme múky, krupice alebo vločiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20041091'),
('20041099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20041099'),
('200490', '- Ostatná zelenina a zeleninové zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200490'),
('20049010', '-- Kukurica cukrová (Zea mays var. saccharata)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20049010'),
('20049030', '-- Kapusta kvasená, kapary a olivy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20049030'),
('20049050', '-- Hrach (Pisum sativum) a zelená fazuľa druhu Phaseolus spp., v strukoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20049050'),
('20049050:2X', '-- Ostatné, vrátane zmesí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20049050:2X'),
('20049091', '--- Cibuľky, varené, inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20049091'),
('20049098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20049098'),
('2005', 'Ostatná zelenina pripravená alebo konzervovaná inak ako v octe alebo kyseline octovej, nemrazená, iná ako výrobky položky 2006', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2005'),
('20051000', '- Zelenina homogenizovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20051000'),
('200520', '- Zemiaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200520'),
('20052010', '-- Vo forme múky, krupice alebo vločiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20052010'),
('20052010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20052010:2X'),
('20052020', '--- Tenké lupienky, smažené alebo pečené, tiež solené alebo ochutené, v hermeticky uzavretých obaloch, vhodné na okamžitú spotrebu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20052020'),
('20052080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20052080'),
('20054000', '- Hrach (Pisum sativum)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20054000'),
('20054000:2X', '- Fazuľa (Vigna spp., Phaseolus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20054000:2X'),
('20055100', '-- Fazuľa, lúpaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20055100'),
('20055900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20055900'),
('20056000', '- Špargľa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20056000'),
('20057000', '- Olivy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KGM'), 'SK_20057000'),
('20058000', '- Kukurica cukrová (Zea mays var. saccharata)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20058000'),
('20058000:2X', '- Ostatná zelenina a zeleninové zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20058000:2X'),
('20059100', '-- Bambusové výhonky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20059100'),
('200599', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200599'),
('20059910', '--- Plody rodu Capsicum, iné ako sladká paprika alebo pimentos', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20059910'),
('20059920', '--- Kapary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20059920'),
('20059930', '--- Artičoky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20059930'),
('20059950', '--- Zeleninové zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20059950'),
('20059960', '--- Kapusta kvasená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20059960'),
('20059980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20059980'),
('200600', 'Zelenina, ovocie, orechy, ovocné kôry a šupy a ostatné časti rastlín, konzervované cukrom (máčaním, glazovaním alebo kandizovaním)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200600'),
('20060010', '- Zázvor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20060010'),
('20060010:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20060010:2X'),
('20060010:3X', '-- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20060010:3X'),
('20060031', '--- Čerešne a višne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20060031'),
('20060035', '--- Tropické ovocie a tropické orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20060035'),
('20060038', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20060038'),
('20060038:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20060038:2X'),
('20060091', '--- Tropické ovocie a tropické orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20060091'),
('20060099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20060099'),
('2007', 'Džemy, ovocné rôsoly, lekváre, ovocné alebo orechové pyré a ovocné alebo orechové pasty, získané varením, tiež obsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2007'),
('200710', '- Homogenizované prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200710'),
('20071010', '-- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20071010'),
('20071010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20071010:2X'),
('20071091', '--- Z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20071091'),
('20071099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20071099'),
('20071099:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20071099:2X'),
('200791', '-- Citrusové ovocie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200791'),
('20079110', '--- S obsahom cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079110'),
('20079130', '--- S obsahom cukru presahujúcim 13 % hmotnosti, ale nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079130'),
('20079190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079190'),
('200799', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200799'),
('200799:2X', '--- S obsahom cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200799:2X'),
('20079910', '---- Pyré a pasty zo sliviek a sušených sliviek, v bezprostrednom obale s netto obsahom presahujúcim 100 kg, na priemyselné spracovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079910'),
('20079920', '---- Gaštanové pyré a pasty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079920'),
('20079920:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079920:2X'),
('20079931', '----- Z čerešní a višní', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079931'),
('20079933', '----- Z jahôd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079933'),
('20079935', '----- Z malín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079935'),
('20079939', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079939'),
('20079950', '--- S obsahom cukru presahujúcim 13 % hmotnosti, ale nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079950'),
('20079950:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079950:2X'),
('20079993', '---- Z tropického ovocia a tropických orechov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079993'),
('20079997', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20079997'),
('2008', 'Ovocie, orechy a ostatné jedlé časti rastlín, inak upravené alebo konzervované, tiež obsahujúce pridaný cukor alebo ostatné sladidlá alebo alkohol, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2008'),
('2008:2X', '- Orechy, arašidy a ostatné semená, tiež spolu zmiešané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2008:2X'),
('200811', '-- Arašidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200811'),
('20081110', '--- Arašidové maslo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081110'),
('20081110:2X', '--- Ostatné, v bezprostrednom obale s netto obsahom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081110:2X'),
('20081191', '---- Presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081191'),
('20081191:2X', '---- Nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081191:2X'),
('20081196', '----- Pražené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081196'),
('20081198', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081198'),
('200819', '-- Ostatné, vrátane zmesí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200819'),
('200819:2X', '--- V bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200819:2X'),
('20081911', '---- Tropické orechy; zmesi obsahujúce v hmotnosti 50 % alebo viac tropických orechov a tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081911'),
('20081911:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081911:2X'),
('20081913', '----- Pražené mandle a pistácie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081913'),
('20081919', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081919'),
('20081919:2X', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081919:2X'),
('20081991', '---- Tropické orechy; zmesi obsahujúce v hmotnosti 50 % alebo viac tropických orechov a tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081991'),
('20081991:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081991:2X'),
('20081991:3X', '----- Pražené orechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081991:3X'),
('20081993', '------ Mandle a pistácie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081993'),
('20081995', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081995'),
('20081999', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20081999'),
('200820', '- Ananásy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200820'),
('200820:2X', '-- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200820:2X'),
('200820:3X', '--- V bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200820:3X'),
('20082011', '---- S obsahom cukru presahujúcim 17 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082011'),
('20082019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082019'),
('20082019:2X', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082019:2X'),
('20082031', '---- S obsahom cukru presahujúcim 19 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082031'),
('20082039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082039'),
('20082039:2X', '-- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082039:2X'),
('20082039:3X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082039:3X'),
('20082051', '---- S obsahom cukru presahujúcim 17 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082051'),
('20082059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082059'),
('20082059:2X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082059:2X'),
('20082071', '---- S obsahom cukru presahujúcim 19 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082071'),
('20082079', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082079'),
('20082090', '--- Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20082090'),
('200830', '- Citrusové ovocie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200830'),
('200830:2X', '-- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200830:2X'),
('200830:3X', '--- S obsahom cukru presahujúcim 9 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200830:3X'),
('20083011', '---- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083011'),
('20083019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083019'),
('20083019:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083019:2X'),
('20083031', '---- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083031'),
('20083039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083039'),
('20083039:2X', '-- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083039:2X'),
('20083039:3X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083039:3X'),
('20083051', '---- Grapefruity v kúskoch, vrátane pomiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083051'),
('20083055', '---- Mandarínky (vrátane tangeríniek a satsumov); klementínky, wilkingy a ostatné podobné citrusové hybridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083055'),
('20083059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083059'),
('20083059:2X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083059:2X'),
('20083071', '---- Grapefruity v kúskoch, vrátane pomiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083071'),
('20083075', '---- Mandarínky (vrátane tangeríniek a satsumov); klementínky, wilkingy a ostatné podobné citrusové hybridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083075'),
('20083079', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083079'),
('20083090', '--- Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20083090'),
('200840', '- Hrušky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200840'),
('200840:2X', '-- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200840:2X'),
('200840:3X', '--- V bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200840:3X'),
('200840:4X', '---- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200840:4X'),
('20084011', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084011'),
('20084019', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084019'),
('20084019:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084019:2X'),
('20084021', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084021'),
('20084029', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084029'),
('20084029:2X', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084029:2X'),
('20084031', '---- S obsahom cukru presahujúcim 15 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084031'),
('20084039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084039'),
('20084039:2X', '-- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084039:2X'),
('20084039:3X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084039:3X'),
('20084051', '---- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084051'),
('20084059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084059'),
('20084059:2X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084059:2X'),
('20084071', '---- S obsahom cukru presahujúcim 15 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084071'),
('20084079', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084079'),
('20084090', '--- Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20084090'),
('200850', '- Marhule', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200850'),
('200850:2X', '-- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200850:2X'),
('200850:3X', '--- V bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200850:3X'),
('200850:4X', '---- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200850:4X'),
('20085011', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085011'),
('20085019', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085019'),
('20085019:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085019:2X'),
('20085031', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúci 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085031'),
('20085039', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085039'),
('20085039:2X', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085039:2X'),
('20085051', '---- S obsahom cukru presahujúcim 15 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085051'),
('20085059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085059'),
('20085059:2X', '-- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085059:2X'),
('20085059:3X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085059:3X'),
('20085061', '---- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085061'),
('20085069', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085069'),
('20085069:2X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085069:2X'),
('20085071', '---- S obsahom cukru presahujúcim 15 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085071'),
('20085079', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085079'),
('20085079:2X', '--- Neobsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085079:2X'),
('20085092', '---- 5 kg alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085092'),
('20085098', '---- Menej ako 5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20085098'),
('200860', '- Čerešne a višne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200860'),
('200860:2X', '-- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200860:2X'),
('200860:3X', '--- S obsahom cukru presahujúcim 9 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200860:3X'),
('20086011', '---- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086011'),
('20086019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086019'),
('20086019:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086019:2X'),
('20086031', '---- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086031'),
('20086039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086039'),
('20086039:2X', '-- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086039:2X'),
('20086039:3X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086039:3X'),
('20086050', '---- Presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086050'),
('20086060', '---- Nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086060'),
('20086060:2X', '--- Neobsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086060:2X'),
('20086070', '---- 4,5 kg alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086070'),
('20086090', '---- Menej ako 4,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20086090'),
('200870', '- Broskyne, vrátane nektáriniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200870'),
('200870:2X', '-- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200870:2X'),
('200870:3X', '--- V bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200870:3X'),
('200870:4X', '---- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200870:4X'),
('20087011', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087011'),
('20087019', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087019'),
('20087019:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087019:2X'),
('20087031', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúci 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087031'),
('20087039', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087039'),
('20087039:2X', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087039:2X'),
('20087051', '---- S obsahom cukru presahujúcim 15 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087051'),
('20087059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087059'),
('20087059:2X', '-- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087059:2X'),
('20087059:3X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087059:3X'),
('20087061', '---- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087061'),
('20087069', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087069'),
('20087069:2X', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087069:2X'),
('20087071', '---- S obsahom cukru presahujúcim 15 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087071'),
('20087079', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087079'),
('20087079:2X', '--- Neobsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087079:2X'),
('20087092', '---- 5 kg alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087092'),
('20087098', '---- Menej ako 5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20087098'),
('200880', '- Jahody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200880'),
('200880:2X', '-- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200880:2X'),
('200880:3X', '--- S obsahom cukru presahujúcim 9 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200880:3X'),
('20088011', '---- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088011'),
('20088019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088019'),
('20088019:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088019:2X'),
('20088031', '---- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088031'),
('20088039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088039'),
('20088039:2X', '-- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088039:2X'),
('20088050', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088050'),
('20088070', '--- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088070'),
('20088090', '--- Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088090'),
('20088090:2X', '- Ostatné, vrátane zmesí iných ako podpoložky 2008 19', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20088090:2X'),
('20089100', '-- Palmové jadrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089100'),
('200893', '-- Brusnice (Vaccinium macrocarpon, Vaccinium oxycoccos, Vaccinium vitis-idaea)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200893'),
('200893:2X', '--- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200893:2X'),
('200893:3X', '---- S obsahom cukru presahujúcim 9 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200893:3X'),
('20089311', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089311'),
('20089319', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089319'),
('20089319:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089319:2X'),
('20089321', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089321'),
('20089329', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089329'),
('20089329:2X', '--- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089329:2X'),
('20089391', '---- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089391'),
('20089393', '---- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089393'),
('20089399', '---- Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089399'),
('200897', '-- Zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200897'),
('200897:2X', '--- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200897:2X'),
('200897:3X', '---- S obsahom cukru presahujúcim 9 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200897:3X'),
('200897:4X', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200897:4X'),
('20089712', '------ Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089712'),
('20089714', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089714'),
('20089714:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089714:2X'),
('20089716', '------ Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089716'),
('20089718', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089718'),
('20089718:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089718:2X'),
('20089718:3X', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089718:3X'),
('20089732', '------ Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089732'),
('20089734', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089734'),
('20089734:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089734:2X'),
('20089736', '------ Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089736'),
('20089738', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089738'),
('20089738:2X', '--- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089738:2X'),
('20089738:3X', '---- Obsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089738:3X'),
('20089738:4X', '----- V bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089738:4X'),
('20089751', '------ Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089751'),
('20089759', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089759'),
('20089759:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089759:2X'),
('20089759:3X', '------ Zmesi ovocia, v ktorých hmotnosť žiadneho jednotlivého druhu ovocia nepresahuje 50 % z celkovej hmotnosti zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089759:3X'),
('20089772', '------- Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089772'),
('20089774', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089774'),
('20089774:2X', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089774:2X'),
('20089776', '------- Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089776'),
('20089778', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089778'),
('20089778:2X', '---- Neobsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089778:2X'),
('20089778:3X', '----- 5 kg alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089778:3X'),
('20089792', '------ Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089792'),
('20089793', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089793'),
('20089793:2X', '----- 4,5 kg alebo viac, ale menej ako 5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089793:2X'),
('20089794', '------ Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089794'),
('20089796', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089796'),
('20089796:2X', '----- Menej ako 4,5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089796:2X'),
('20089797', '------ Z tropického ovocia (vrátane zmesí obsahujúcich 50 % hmotnosti alebo viac tropických orechov a tropického ovocia)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089797'),
('20089798', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089798'),
('200899', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200899'),
('200899:2X', '--- Obsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200899:2X'),
('200899:3X', '---- Zázvor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200899:3X'),
('20089911', '----- So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089911'),
('20089919', '----- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089919'),
('20089919:2X', '---- Hrozno', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089919:2X'),
('20089921', '----- S obsahom cukru presahujúcim 13 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089921'),
('20089923', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089923'),
('20089923:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089923:2X'),
('20089923:3X', '----- S obsahom cukru presahujúcim 9 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089923:3X'),
('20089923:4X', '------ So skutočným hmotnostným alkoholometrickým titrom nepresahujúci 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089923:4X'),
('20089924', '------- Tropické ovocie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089924'),
('20089928', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089928'),
('20089928:2X', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089928:2X'),
('20089931', '------- Tropické ovocie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089931'),
('20089934', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089934'),
('20089934:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089934:2X'),
('20089934:3X', '------ So skutočným hmotnostným alkoholometrickým titrom nepresahujúcim 11,85 % mas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089934:3X'),
('20089936', '------- Tropické ovocie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089936'),
('20089937', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089937'),
('20089937:2X', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089937:2X'),
('20089938', '------- Tropické ovocie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089938'),
('20089940', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089940'),
('20089940:2X', '--- Neobsahujúce pridaný alkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089940:2X'),
('20089940:3X', '---- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom presahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089940:3X'),
('20089941', '----- Zázvor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089941'),
('20089943', '----- Hrozno', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089943'),
('20089945', '----- Slivky a sušené slivky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089945'),
('20089948', '----- Tropické ovocie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089948'),
('20089949', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089949'),
('20089949:2X', '---- Obsahujúce pridaný cukor, v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089949:2X'),
('20089951', '----- Zázvor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089951'),
('20089963', '----- Tropické ovocie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089963'),
('20089967', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089967'),
('20089967:2X', '---- Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089967:2X'),
('20089967:3X', '----- Slivky a sušené slivky, v bezprostrednom obale s netto obsahom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089967:3X'),
('20089972', '------ 5 kg alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089972'),
('20089978', '------ Menej ako 5 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089978'),
('20089985', '----- Kukurica, iná ako kukurica cukrová (Zea mays var. saccharata)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089985'),
('20089991', '----- Yamy, sladké zemiaky a podobné jedlé časti rastlín obsahujúce 5 % hmotnosti alebo viac škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089991'),
('20089999', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20089999'),
('2009', 'Šťavy ovocné (vrátane hroznového muštu) a šťavy zeleninové, nekvasené a neobsahujúce pridaný alkohol, tiež obsahujúce pridaný cukor alebo ostatné sladidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2009'),
('2009:2X', '- Pomarančová šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2009:2X'),
('200911', '-- Mrazená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200911'),
('200911:2X', '--- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200911:2X'),
('20091111', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091111'),
('20091119', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091119'),
('20091119:2X', '--- S Brixovou hodnotou nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091119:2X'),
('20091191', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti a s obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091191'),
('20091199', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091199'),
('20091200', '-- Nemrazená, s Brixovou hodnotou nepresahujúcou 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091200'),
('200919', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200919'),
('200919:2X', '--- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200919:2X'),
('20091911', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091911'),
('20091919', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091919'),
('20091919:2X', '--- S Brixovou hodnotou presahujúcou 20, ale nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091919:2X'),
('20091991', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti a s obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091991'),
('20091998', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091998'),
('20091998:2X', '- Grapefruitová šťava (vrátane pomelovej šťavy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20091998:2X'),
('20092100', '-- S Brixovou hodnotou nepresahujúcou 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20092100'),
('200929', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200929'),
('200929:2X', '--- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200929:2X'),
('20092911', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20092911'),
('20092919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20092919'),
('20092919:2X', '--- S Brixovou hodnotou presahujúcou 20, ale nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20092919:2X'),
('20092991', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti a s obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20092991'),
('20092999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20092999'),
('20092999:2X', '- Šťava z akéhokoľvek jednotlivého citrusového ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20092999:2X'),
('200931', '-- S Brixovou hodnotou nepresahujúcou 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200931'),
('200931:2X', '--- S cenou presahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200931:2X'),
('20093111', '---- Obsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093111'),
('20093119', '---- Neobsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093119'),
('20093119:2X', '--- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093119:2X'),
('20093119:3X', '---- Citrónová šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093119:3X'),
('20093151', '----- Obsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093151'),
('20093159', '----- Neobsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093159'),
('20093159:2X', '---- Ostatné šťavy z citrusového ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093159:2X'),
('20093191', '----- Obsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093191'),
('20093199', '----- Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093199'),
('200939', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200939'),
('200939:2X', '--- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200939:2X'),
('20093911', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093911'),
('20093919', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093919'),
('20093919:2X', '--- S Brixovou hodnotou presahujúcou 20, ale nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093919:2X'),
('20093919:3X', '---- S cenou presahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093919:3X'),
('20093931', '----- Obsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093931'),
('20093939', '----- Neobsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093939'),
('20093939:2X', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093939:2X'),
('20093939:3X', '----- Citrónová šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093939:3X'),
('20093951', '------ S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093951'),
('20093955', '------ S obsahom pridaného cukru nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093955'),
('20093959', '------ Neobsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093959'),
('20093959:2X', '----- Šťavy z ostatného citrusového ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093959:2X'),
('20093991', '------ S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093991'),
('20093995', '------ S obsahom pridaného cukru nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093995'),
('20093999', '------ Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093999'),
('20093999:2X', '- Ananásová šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20093999:2X'),
('200941', '-- S Brixovou hodnotou nepresahujúcou 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200941'),
('20094192', '--- Obsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094192'),
('20094199', '--- Neobsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094199'),
('200949', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200949'),
('200949:2X', '--- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200949:2X'),
('20094911', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094911'),
('20094919', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094919'),
('20094919:2X', '--- S Brixovou hodnotou presahujúcou 20, ale nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094919:2X'),
('20094930', '---- S cenou presahujúcou 30 EUR za 100 kg netto hmotnosti, obsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094930'),
('20094930:2X', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094930:2X'),
('20094991', '----- S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094991'),
('20094993', '----- S obsahom pridaného cukru nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094993'),
('20094999', '----- Neobsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20094999'),
('200950', '- Rajčiaková šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200950'),
('20095010', '-- Obsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20095010'),
('20095090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20095090'),
('20095090:2X', '- Hroznová šťava (vrátane hroznového muštu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20095090:2X'),
('200961', '-- S Brixovou hodnotou nepresahujúcou 30', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200961'),
('20096110', '--- S cenou presahujúcou 18 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096110'),
('20096190', '--- S cenou nepresahujúcou 18 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096190'),
('200969', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200969'),
('200969:2X', '--- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200969:2X'),
('20096911', '---- S cenou nepresahujúcou 22 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096911'),
('20096919', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096919'),
('20096919:2X', '--- S Brixovou hodnotou presahujúcou 30, ale nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096919:2X'),
('20096919:3X', '---- S cenou presahujúcou 18 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096919:3X'),
('20096951', '----- Zahustená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096951'),
('20096959', '----- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096959'),
('20096959:2X', '---- S cenou nepresahujúcou 18 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096959:2X'),
('20096959:3X', '----- S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096959:3X'),
('20096971', '------ Zahustená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096971'),
('20096979', '------ Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096979'),
('20096990', '----- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096990'),
('20096990:2X', '- Jablčná šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20096990:2X'),
('200971', '-- S Brixovou hodnotou nepresahujúcou 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200971'),
('20097120', '--- Obsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097120'),
('20097199', '--- Neobsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097199'),
('200979', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200979'),
('200979:2X', '--- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200979:2X'),
('20097911', '---- S cenou nepresahujúcou 22 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097911'),
('20097919', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097919'),
('20097919:2X', '--- S Brixovou hodnotou presahujúcou 20, ale nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097919:2X'),
('20097930', '---- S cenou presahujúcou 18 EUR za 100 kg netto hmotnosti, obsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097930'),
('20097930:2X', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097930:2X'),
('20097991', '----- S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097991'),
('20097998', '----- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097998'),
('20097998:2X', '- Šťavy z akéhokoľvek ostatného jednotlivého ovocia alebo zeleniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20097998:2X'),
('200981', '-- Brusnicová šťava (Vaccinium macrocarpon, Vaccinium oxycoccos, Vaccinium vitis-idaea)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200981'),
('200981:2X', '--- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200981:2X'),
('20098111', '---- S hodnotou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098111'),
('20098119', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098119'),
('20098119:2X', '--- S Brixovou hodnotou nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098119:2X'),
('20098131', '---- S hodnotou presahujúcou 30 EUR za 100 kg netto hmotnosti, obsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098131'),
('20098131:2X', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098131:2X'),
('20098151', '----- S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098151'),
('20098159', '----- S obsahom pridaného cukru nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098159'),
('20098159:2X', '----- Neobsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098159:2X'),
('20098195', '------ Šťava z ovocia druhu Vaccinium macrocarpon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098195'),
('20098199', '------ Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098199'),
('200989', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200989'),
('200989:2X', '--- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200989:2X'),
('200989:3X', '---- Hrušková šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200989:3X'),
('20098911', '----- S hodnotou nepresahujúcou 22 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098911'),
('20098919', '----- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098919'),
('20098919:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098919:2X'),
('20098919:3X', '----- S hodnotou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098919:3X'),
('20098934', '------ Šťavy z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098934'),
('20098935', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098935'),
('20098935:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098935:2X'),
('20098936', '------ Šťavy z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098936'),
('20098938', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098938'),
('20098938:2X', '--- S Brixovou hodnotou nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098938:2X'),
('20098938:3X', '---- Hrušková šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098938:3X'),
('20098950', '----- S hodnotou presahujúcou 18 EUR za 100 kg netto hmotnosti, obsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098950'),
('20098950:2X', '----- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098950:2X'),
('20098961', '------ S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098961'),
('20098963', '------ S obsahom pridaného cukru nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098963'),
('20098969', '------ Neobsahujúca pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098969'),
('20098969:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098969:2X'),
('20098969:3X', '----- S hodnotou presahujúcou 30 EUR za 100 kg netto hmotnosti, obsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098969:3X'),
('20098971', '------ Čerešňová a višňová šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098971'),
('20098973', '------ Šťavy z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098973'),
('20098979', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098979'),
('20098979:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098979:2X'),
('20098979:3X', '------ S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098979:3X'),
('20098985', '------- Šťavy z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098985'),
('20098986', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098986'),
('20098986:2X', '------ S obsahom pridaného cukru nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098986:2X'),
('20098988', '------- Šťavy z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098988'),
('20098989', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098989'),
('20098989:2X', '----- Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098989:2X'),
('20098996', '------ Čerešňová a višňová šťava', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098996'),
('20098997', '------ Šťavy z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098997'),
('20098999', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20098999'),
('200990', '- Zmesi štiav', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200990'),
('200990:2X', '-- S Brixovou hodnotou presahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200990:2X'),
('200990:3X', '--- Zmesi jablčnej a hruškovej šťavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_200990:3X'),
('20099011', '---- S cenou nepresahujúcou 22 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099011'),
('20099019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099019'),
('20099019:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099019:2X'),
('20099021', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099021'),
('20099029', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099029'),
('20099029:2X', '-- S Brixovou hodnotou nepresahujúcou 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099029:2X'),
('20099029:3X', '--- Zmesi jablčnej a hruškovej šťavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099029:3X'),
('20099031', '---- S cenou nepresahujúcou 18 EUR za 100 kg netto hmotnosti a s obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099031'),
('20099039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099039'),
('20099039:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099039:2X'),
('20099039:3X', '---- S cenou presahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099039:3X'),
('20099039:4X', '----- Zmesi štiav citrusových plodov a ananásovej šťavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099039:4X'),
('20099041', '------ Obsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099041'),
('20099049', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099049'),
('20099049:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099049:2X'),
('20099051', '------ Obsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099051'),
('20099059', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099059'),
('20099059:2X', '---- S cenou nepresahujúcou 30 EUR za 100 kg netto hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099059:2X'),
('20099059:3X', '----- Zmesi štiav citrusových plodov a ananásovej šťavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099059:3X'),
('20099071', '------ S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099071'),
('20099073', '------ S obsahom pridaného cukru nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099073'),
('20099079', '------ Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099079'),
('20099079:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099079:2X'),
('20099079:3X', '------ S obsahom pridaného cukru presahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099079:3X'),
('20099092', '------- Zmesi štiav z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099092'),
('20099094', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099094'),
('20099094:2X', '------ S obsahom pridaného cukru nepresahujúcim 30 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099094:2X'),
('20099095', '------- Zmesi štiav z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099095'),
('20099096', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099096'),
('20099096:2X', '------ Neobsahujúce pridaný cukor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099096:2X'),
('20099097', '------- Zmesi štiav z tropického ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099097'),
('20099098', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_20099098'),
('2101', 'Výťažky, esencie a koncentráty z kávy, čaju alebo maté a prípravky na základe týchto výrobkov alebo na základe kávy, čaju alebo maté; čakanka pražená a ostatné pražené náhradky kávy, a výťažky, esencie a koncentráty z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2101'),
('2101:2X', '- Výťažky, esencie a koncentráty, z kávy, a prípravky na základe týchto výťažkov, esencií alebo koncentrátov alebo na základe kávy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2101:2X'),
('21011100', '-- Výťažky, esencie a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21011100'),
('210112', '-- Prípravky na základe týchto výťažkov, esencií alebo koncentrátov alebo na základe kávy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210112'),
('21011292', '--- Prípravky na základe týchto výťažkov, esencií alebo koncentrátov kávy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21011292'),
('21011298', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21011298'),
('210120', '- Výťažky, esencie a koncentráty, z čaju alebo maté, a prípravky na základe týchto výťažkov, esencií alebo koncentrátov, alebo na základe čaju alebo maté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210120'),
('21012020', '-- Výťažky, esencie alebo koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21012020'),
('21012020:2X', '-- Prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21012020:2X'),
('21012092', '--- Na základe výťažkov, esencií alebo koncentrátov z čaju alebo z maté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21012092'),
('21012098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21012098'),
('210130', '- Čakanka pražená a ostatné pražené náhradky kávy, a výťažky, esencie a koncentráty z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210130'),
('210130:2X', '-- Čakanka pražená a ostatné pražené náhradky kávy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210130:2X'),
('21013011', '--- Čakanka pražená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21013011'),
('21013019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21013019'),
('21013019:2X', '-- Výťažky, esencie a koncentráty z praženej čakanky a z ostatných pražených náhradiek kávy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21013019:2X'),
('21013091', '--- Z praženej čakanky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21013091'),
('21013099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21013099'),
('2102', 'Kvasinky (aktívne alebo neaktívne); ostatné jednobunkové mikroorganizmy, mŕtve (okrem očkovacích látok položky 3002); pripravené prášky do pečiva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2102'),
('210210', '- Aktívne kvasinky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210210'),
('21021010', '-- Kvasinkové kultúry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21021010'),
('21021010:2X', '-- Pekárske kvasinky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21021010:2X'),
('21021031', '--- Sušené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21021031'),
('21021039', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21021039'),
('21021090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21021090'),
('210220', '- Neaktívne kvasinky; ostatné jednobunkové mikroorganizmy, mŕtve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210220'),
('210220:2X', '-- Neaktívne kvasinky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210220:2X'),
('21022011', '--- V tabletách, kockách alebo podobných tvaroch, alebo v bezprostrednom obale s netto obsahom nepresahujúcim 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21022011'),
('21022019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21022019'),
('21022090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21022090'),
('21023000', '- Pripravené prášky do pečiva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21023000'),
('2103', 'Omáčky a prípravky na omáčky; nakladacie a koreniace zmesi; horčicová múka a krupica a pripravená horčica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2103'),
('21031000', '- Sójová omáčka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21031000'),
('21032000', '- Rajčiakový kečup a ostatné rajčiakové omáčky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21032000'),
('210330', '- Horčicová múka a krupica a pripravená horčica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210330'),
('21033010', '-- Horčicová múka a krupica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21033010'),
('21033090', '-- Pripravená horčica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21033090'),
('210390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210390'),
('21039010', '-- "Chutney" z manga, tekuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21039010'),
('21039030', '-- Aromatické horké prípravky s objemovým alkoholometrickým titrom od 44,2 do 49,2 % obj. obsahujúce od 1,5 do 6 % hmotnosti horca, korenín a rôznych prísad a od 4 do 10 % cukru, v nádobách s objemom 0,5 litra alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_21039030'),
('21039090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21039090'),
('2104', 'Polievky a bujóny a prípravky na ne; homogenizované zložené potravinové prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2104'),
('21041000', '- Polievky a bujóny a prípravky na ne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21041000'),
('21042000', '- Homogenizované zložené potravinové prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21042000'),
('210500', 'Zmrzlina a podobné jedlé výrobky, tiež obsahujúce kakao', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210500'),
('21050010', '- Neobsahujúce mliečne tuky alebo obsahujúce v hmotnosti menej ako 3 % takýchto tukov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21050010'),
('21050010:2X', '- S obsahom mliečnych tukov v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21050010:2X'),
('21050091', '-- 3 % alebo viac, ale menej ako 7 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21050091'),
('21050099', '-- 7 % alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21050099'),
('2106', 'Potravinové prípravky inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2106'),
('210610', '- Bielkovinové koncentráty a textúrované bielkovinové látky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210610'),
('21061020', '-- Neobsahujúce mliečne tuky, sacharózu, izoglukózu, glukózu alebo škrob alebo obsahujúce v hmotnosti menej ako 1,5 % mliečnych tukov, 5 % sacharózy alebo izoglukózy, 5 % glukózy alebo škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21061020'),
('21061080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21061080'),
('210690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_210690'),
('21069020', '-- Zložené alkoholické prípravky, iné ako výrobky na základe vonných látok, druhov používaných na výrobu nápojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_21069020'),
('21069020:2X', '-- Ochutené alebo farbené cukrové sirupy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21069020:2X'),
('21069030', '--- Izoglukózové sirupy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21069030'),
('21069030:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21069030:2X'),
('21069051', '---- Laktózový sirup', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21069051'),
('21069055', '---- Glukózový sirup a maltodextrínový sirup', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21069055'),
('21069059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21069059'),
('21069059:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21069059:2X'),
('21069092', '--- Neobsahujúce mliečne tuky, sacharózu, izoglukózu, glukózu alebo škrob alebo obsahujúce v hmotnosti menej ako 1,5 % mliečnych tukov, 5 % sacharózy alebo izoglukózy, 5 % glukózy alebo škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21069092'),
('21069098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_21069098'),
('2201', 'Vody, vrátane prírodných alebo umelých minerálnych vôd a sýtených vôd, neobsahujúce pridaný cukor alebo ostatné sladidlá ani ochucujúce látky; ľad a sneh', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2201'),
('220110', '- Minerálne vody a sýtené vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220110'),
('220110:2X', '-- Prírodné minerálne vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220110:2X'),
('22011011', '--- Bez oxidu uhličitého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22011011'),
('22011019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22011019'),
('22011090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22011090'),
('22019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22019000'),
('2202', 'Vody, vrátane minerálnych vôd a sýtených vôd, obsahujúce pridaný cukor alebo ostatné sladidlá alebo ochucujúce látky, a ostatné nealkoholické nápoje, okrem ovocných alebo zeleninových štiav položky 2009', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2202'),
('22021000', '- Vody, vrátane minerálnych vôd a sýtených vôd, obsahujúce pridaný cukor alebo ostatné sladidlá alebo ochucujúce látky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22021000'),
('220290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220290'),
('22029010', '-- Neobsahujúce produkty položiek 0401 až 0404 alebo tuk získaný z produktov položiek 0401 až 0404', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22029010'),
('22029010:2X', '-- Ostatné, obsahujúce v hmotnosti tuk získaných z produktov položiek 0401 až 0404', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22029010:2X'),
('22029091', '--- Menej ako 0,2 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22029091'),
('22029095', '--- 0,2 % alebo viac, ale menej ako 2 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22029095'),
('22029099', '--- 2 % alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22029099'),
('220300', 'Pivo vyrobené zo sladu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220300'),
('220300:2X', '- V nádobách s objemom 10 litrov alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220300:2X'),
('22030001', '-- Vo fľašiach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22030001'),
('22030009', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22030009'),
('22030010', '- V nádobách s objemom viac ako 10 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22030010'),
('2204', 'Víno z čerstvého hrozna, vrátane vína obohateného alkoholom; hroznový mušt iný ako položky 2009', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2204'),
('220410', '- Šumivé víno', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220410'),
('220410:2X', '-- Vína s chráneným označením pôvodu (ChOP)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220410:2X'),
('22041011', '--- Šampanské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22041011'),
('22041091', '--- Asti spumante', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22041091'),
('22041093', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22041093'),
('22041094', '-- Vína s chráneným zemepisným označením (ChZO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22041094'),
('22041096', '-- Ostatné odrodové vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22041096'),
('22041098', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22041098'),
('22041098:2X', '- Ostatné vína; hroznový mušt, ktorého kvasenie bolo zastavené alebo mu bolo zabránené pridaním alkoholu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22041098:2X'),
('220421', '-- V nádobách s objemom 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220421'),
('220421:2X', '--- Vína, iné ako vína podpoložky 2204 10, vo fľašiach uzavretých zátkou v tvare hríbika zachyteného pomocou svorky alebo kovovej zvierky; vína, inak balené, s pretlakom oxidu uhličitého v roztoku najmenej 1 bar, ale menej ako 3 bary, meraným pri teplote', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220421:2X'),
('22042106', '---- Vína s chráneným označením pôvodu (ChOP)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042106'),
('22042107', '---- Vína s chráneným zemepisným označením (ChZO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042107'),
('22042108', '---- Ostatné odrodové vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042108'),
('22042109', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042109'),
('22042109:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042109:2X'),
('22042109:3X', '---- Vyrobené v Spoločenstve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042109:3X'),
('22042109:4X', '----- So skutočným objemovým alkoholometrickým titrom nepresahujúcim 15 % vol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042109:4X'),
('22042109:5X', '------ Vína s chráneným označením pôvodu (ChOP)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042109:5X'),
('22042109:6X', '------- Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042109:6X'),
('22042111', '-------- Alsace', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042111'),
('22042112', '-------- Bordeaux', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042112'),
('22042113', '-------- Bourgogne (Burgundy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042113'),
('22042117', '-------- Val de Loire (Loire Valley)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042117'),
('22042118', '-------- Mosel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042118'),
('22042119', '-------- Pfalz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042119'),
('22042122', '-------- Rheinhessen', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042122'),
('22042123', '-------- Tokaj', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042123'),
('22042124', '-------- Lazio (Latium)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042124'),
('22042126', '-------- Toscana (Tuscany)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042126'),
('22042127', '-------- Trentino, Alto Adige a Friuli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042127'),
('22042128', '-------- Veneto', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042128'),
('22042132', '-------- Vinho Verde', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042132'),
('22042134', '-------- Penedés', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042134'),
('22042136', '-------- Rioja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042136'),
('22042137', '-------- Valencia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042137'),
('22042138', '-------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042138'),
('22042138:2X', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042138:2X'),
('22042142', '-------- Bordeaux', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042142'),
('22042143', '-------- Bourgogne (Burgundy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042143'),
('22042144', '-------- Beaujolais', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042144'),
('22042146', '-------- Côtes-du-Rhône', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042146'),
('22042147', '-------- Languedoc-Roussillon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042147'),
('22042148', '-------- Val de Loire (Loire Valley)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042148'),
('22042162', '-------- Piemonte (Piedmont)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042162'),
('22042166', '-------- Toscana (Tuscany)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042166'),
('22042167', '-------- Trentino a Alto Adige', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042167'),
('22042168', '-------- Veneto', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042168'),
('22042169', '-------- Dăo, Bairrada a Douro', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042169'),
('22042171', '-------- Navarra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042171'),
('22042174', '-------- Penedés', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042174'),
('22042176', '-------- Rioja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042176'),
('22042177', '-------- Valdepeńas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042177'),
('22042178', '-------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042178'),
('22042178:2X', '------ Vína s chráneným zemepisným označením (ChZO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042178:2X'),
('22042179', '------- Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042179'),
('22042180', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042180'),
('22042180:2X', '------ Ostatné odrodové vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042180:2X'),
('22042181', '------- Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042181'),
('22042182', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042182'),
('22042182:2X', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042182:2X'),
('22042183', '------- Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042183'),
('22042184', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042184'),
('22042184:2X', '----- So skutočným objemovým alkoholometrickým titrom presahujúcim 15 % vol, ale nepresahujúcim 22 % vol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042184:2X'),
('22042184:3X', '------ Vína s chráneným označením pôvodu (ChOP) alebo vína s chráneným zemepisným označením (ChZO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042184:3X'),
('22042185', '------- Madeira a Setubal muscatel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042185'),
('22042186', '------- Sherry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042186'),
('22042187', '------- Marsala', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042187'),
('22042188', '------- Samos a Muscat de Lemnos', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042188'),
('22042189', '------- Port', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042189'),
('22042190', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042190'),
('22042191', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042191'),
('22042192', '----- So skutočným objemovým alkoholometrickým titrom presahujúcim 22 % vol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042192'),
('22042192:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042192:2X'),
('22042192:3X', '----- Vína s chráneným označením pôvodu (ChOP) alebo vína s chráneným zemepisným označením (ChZO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042192:3X'),
('22042193', '------ Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042193'),
('22042194', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042194'),
('22042194:2X', '----- Ostatné odrodové vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042194:2X'),
('22042195', '------ Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042195'),
('22042196', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042196'),
('22042196:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042196:2X'),
('22042197', '------ Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042197'),
('22042198', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042198'),
('220429', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220429'),
('22042910', '--- Vína, iné ako vína podpoložky 2204 10, vo fľašiach uzavretých zátkou v tvare hríbika zachyteného pomocou svorky alebo kovovej zvierky; vína, inak balené, s pretlakom oxidu uhličitého v roztoku najmenej 1 bar, ale menej ako 3 bary, meraným pri 20 °C', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042910'),
('22042910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042910:2X'),
('22042910:3X', '---- Vyrobené v Spoločenstve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042910:3X'),
('22042910:4X', '----- So skutočným objemovým alkoholometrickým titrom nepresahujúcim 15 % vol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042910:4X'),
('22042910:5X', '------ Vína s chráneným označením pôvodu (ChOP)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042910:5X'),
('22042910:6X', '------- Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042910:6X'),
('22042911', '-------- Tokaj', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042911'),
('22042912', '-------- Bordeaux', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042912'),
('22042913', '-------- Bourgogne (Burgundy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042913'),
('22042917', '-------- Val de Loire (Loire Valley)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042917'),
('22042918', '-------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042918'),
('22042918:2X', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042918:2X'),
('22042942', '-------- Bordeaux', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042942'),
('22042943', '-------- Bourgogne (Burgundy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042943'),
('22042944', '-------- Beaujolais', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042944'),
('22042946', '-------- Côtes-du-Rhône', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042946'),
('22042947', '-------- Languedoc-Roussillon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042947'),
('22042948', '-------- Val de Loire (Loire Valley)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042948'),
('22042958', '-------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042958'),
('22042958:2X', '------ Vína s chráneným zemepisným označením (ChZO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042958:2X'),
('22042979', '------- Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042979'),
('22042980', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042980'),
('22042980:2X', '------ Ostatné odrodové vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042980:2X'),
('22042981', '------- Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042981'),
('22042982', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042982'),
('22042982:2X', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042982:2X'),
('22042983', '------- Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042983'),
('22042984', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042984'),
('22042984:2X', '----- So skutočným objemovým alkoholometrickým titrom presahujúcim 15 % vol, ale nepresahujúcim 22 % vol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042984:2X'),
('22042984:3X', '------ Vína s chráneným označením pôvodu (ChOP) alebo vína s chráneným zemepisným označením (ChZO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042984:3X'),
('22042985', '------- Madeira a Setubal muscatel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042985'),
('22042986', '------- Sherry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042986'),
('22042987', '------- Marsala', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042987'),
('22042988', '------- Samos a Muscat de Lemnos', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042988'),
('22042989', '------- Port', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042989'),
('22042990', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042990'),
('22042991', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042991'),
('22042992', '----- So skutočným objemovým alkoholometrickým titrom presahujúcim 22 % vol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042992'),
('22042992:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042992:2X'),
('22042992:3X', '----- Vína s chráneným označením pôvodu (ChOP) alebo vína s chráneným zemepisným označením (ChZO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042992:3X'),
('22042993', '------ Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042993'),
('22042994', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042994'),
('22042994:2X', '----- Ostatné odrodové vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042994:2X'),
('22042995', '------ Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042995'),
('22042996', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042996'),
('22042996:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22042996:2X'),
('22042997', '------ Biele vína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042997'),
('22042998', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22042998'),
('220430', '- Ostatný hroznový mušt', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220430'),
('22043010', '-- Kvasiaci alebo s kvasením zastaveným inak ako pridaním alkoholu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22043010'),
('22043010:2X', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22043010:2X'),
('22043010:3X', '--- S hustotou pri 20 °C 1,33 g/cm3 alebo menej a so skutočným objemovým alkoholometrickým titrom nepresahujúcim 1 % vol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22043010:3X'),
('22043092', '---- Zahustený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22043092'),
('22043094', '---- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22043094'),
('22043094:2X', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22043094:2X'),
('22043096', '---- Zahustený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22043096'),
('22043098', '---- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22043098'),
('2205', 'Vermút a ostatné vína z čerstvého hrozna ochutené bylinami alebo aromatickými látkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2205'),
('220510', '- V nádobách s objemom 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220510'),
('22051010', '-- So skutočným objemovým alkoholometrickým titrom 18 % vol alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22051010'),
('22051090', '-- So skutočným objemovým alkoholometrickým titrom presahujúcim 18 % vol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22051090'),
('220590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220590'),
('22059010', '-- So skutočným objemovým alkoholometrickým titrom 18 % vol alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22059010'),
('22059090', '-- So skutočným objemovým alkoholometrickým titrom presahujúcim 18 % vol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22059090'),
('220600', 'Ostatné kvasené nápoje (napríklad jablčné, hruškové, medovina); zmesi kvasených nápojov a zmesi kvasených nápojov a nealkoholických nápojov, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220600'),
('22060010', '- Piquette', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22060010'),
('22060010:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22060010:2X'),
('22060010:3X', '-- Šumivé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22060010:3X'),
('22060031', '--- Jablčné a hruškové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22060031'),
('22060039', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22060039'),
('22060039:2X', '-- Nešumivé, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22060039:2X'),
('22060039:3X', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22060039:3X'),
('22060051', '---- Jablčné a hruškové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22060051'),
('22060059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22060059'),
('22060059:2X', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22060059:2X'),
('22060081', '---- Jablčné a hruškové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22060081'),
('22060089', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22060089'),
('2207', 'Etylalkohol nedenaturovaný s objemovým alkoholometrickým titrom 80 % vol alebo viac; etylalkohol a ostatné destiláty, denaturované, s akýmkoľvek alkoholometrickým titrom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2207'),
('22071000', '- Etylalkohol nedenaturovaný s objemovým alkoholometrickým titrom 80 % vol alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22071000'),
('22072000', '- Etylalkohol a ostatné destiláty, denaturované, s akýmkoľvek alkoholometrickým titrom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22072000'),
('2208', 'Etylalkohol nedenaturovaný s objemovým alkoholometrickým titrom menej ako 80 % vol; destiláty, likéry a ostatné liehové nápoje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2208'),
('220820', '- Destiláty z hroznového vína alebo hroznových výliskov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220820'),
('220820:2X', '-- V nádobách s objemom 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220820:2X'),
('22082012', '--- Cognac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082012'),
('22082014', '--- Armagnac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082014'),
('22082026', '--- Grappa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082026'),
('22082027', '--- Brandy de Jerez', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082027'),
('22082029', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082029'),
('22082029:2X', '-- V nádobách s objemom viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22082029:2X'),
('22082040', '--- Surové destiláty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082040'),
('22082040:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22082040:2X'),
('22082062', '---- Cognac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082062'),
('22082064', '---- Armagnac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082064'),
('22082086', '---- Grappa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082086'),
('22082087', '---- Brandy de Jerez', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082087'),
('22082089', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22082089'),
('220830', '- Whisky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220830'),
('220830:2X', '-- Whisky Bourbon, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220830:2X'),
('22083011', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083011'),
('22083019', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083019'),
('22083019:2X', '-- Škótska whisky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22083019:2X'),
('22083030', '--- Nemiešaná sladová whisky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083030'),
('22083030:2X', '--- Miešaná sladová whisky, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22083030:2X'),
('22083041', '---- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083041'),
('22083049', '---- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083049'),
('22083049:2X', '--- Nemiešaná obilná whisky a miešaná obilná whisky, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22083049:2X'),
('22083061', '---- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083061'),
('22083069', '---- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083069'),
('22083069:2X', '--- Ostatná miešaná whisky, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22083069:2X'),
('22083071', '---- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083071'),
('22083079', '---- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083079'),
('22083079:2X', '-- Ostatná whisky, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22083079:2X'),
('22083082', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083082'),
('22083088', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22083088'),
('220840', '- Rum a ostatné destiláty získané destiláciou skvasených produktov cukrovej trstiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220840'),
('220840:2X', '-- V nádobách s objemom 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220840:2X'),
('22084011', '--- Rum s obsahom prchavých látok iných ako etylalkohol a metylalkohol rovnajúcim sa alebo presahujúcim 225 gramov na hektoliter čistého alkoholu (s toleranciou 10 %)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22084011'),
('22084011:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22084011:2X'),
('22084031', '---- S cenou presahujúcou 7,9 EUR za liter čistého alkoholu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22084031'),
('22084039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22084039'),
('22084039:2X', '-- V nádobách s objemom viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22084039:2X'),
('22084051', '--- Rum s obsahom prchavých látok iných ako etylalkohol a metylalkohol rovnajúcim sa alebo presahujúcim 225 gramov na hektoliter čistého alkoholu (s toleranciou 10 %)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22084051'),
('22084051:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22084051:2X'),
('22084091', '---- S cenou presahujúcou 2 EUR za liter čistého alkoholu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22084091'),
('22084099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22084099'),
('220850', '- Gin a borovička', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220850'),
('220850:2X', '-- Gin, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220850:2X'),
('22085011', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22085011'),
('22085019', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22085019'),
('22085019:2X', '-- Borovička, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22085019:2X'),
('22085091', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22085091'),
('22085099', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22085099'),
('220860', '- Vodka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220860'),
('220860:2X', '-- S objemovým alkoholometrickým titrom 45,4 % vol alebo menej, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220860:2X'),
('22086011', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22086011'),
('22086019', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22086019'),
('22086019:2X', '-- S objemovým alkoholometrickým titrom viac ako 45,4 % vol, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22086019:2X'),
('22086091', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22086091'),
('22086099', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22086099'),
('220870', '- Likéry a kordialy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220870'),
('22087010', '-- V nádobách s objemom 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22087010'),
('22087090', '-- V nádobách s objemom viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22087090'),
('220890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220890'),
('220890:2X', '-- Arak, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220890:2X'),
('22089011', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089011'),
('22089019', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089019'),
('22089019:2X', '-- Slivovica, hruškovica, čerešňovica alebo višňovica (okrem likérov), v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089019:2X'),
('22089033', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089033'),
('22089038', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089038'),
('22089038:2X', '-- Ostatné destiláty a ostatné liehové nápoje, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089038:2X'),
('22089038:3X', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089038:3X'),
('22089041', '---- Ouzo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089041'),
('22089041:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089041:2X'),
('22089041:3X', '----- Destiláty (okrem likérov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089041:3X'),
('22089041:4X', '------ Destilované z ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089041:4X'),
('22089045', '------- Kalvados', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089045'),
('22089048', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089048'),
('22089048:2X', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089048:2X'),
('22089054', '------- Tequila', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089054'),
('22089056', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089056'),
('22089069', '----- Ostatné liehové nápoje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089069'),
('22089069:2X', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089069:2X'),
('22089069:3X', '---- Destiláty (okrem likérov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089069:3X'),
('22089071', '----- Destilované z ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089071'),
('22089075', '----- Tequila', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089075'),
('22089077', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089077'),
('22089078', '---- Ostatné liehové nápoje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089078'),
('22089078:2X', '-- Nedenaturovaný etylalkohol s objemovým alkoholometrickým titrom menej ako 80 % vol, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22089078:2X'),
('22089091', '--- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089091'),
('22089099', '--- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LPA'), 'SK_22089099'),
('220900', 'Ocot a náhradky octu získané z kyseliny octovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220900'),
('220900:2X', '- Vínny ocot, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_220900:2X'),
('22090011', '-- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22090011'),
('22090019', '-- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22090019'),
('22090019:2X', '- Ostatné, v nádobách s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_22090019:2X'),
('22090091', '-- 2 litre alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22090091'),
('22090099', '-- Viac ako 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_LTR'), 'SK_22090099'),
('2301', 'Múčky, prášky a pelety, z mäsa alebo mäsových drobov, rýb alebo kôrovcov, mäkkýšov alebo ostatných vodných bezstavovcov, nevhodné na ľudskú konzumáciu; škvarky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2301'),
('23011000', '- Múčky, prášky a pelety, z mäsa alebo mäsových drobov; škvarky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23011000'),
('23012000', '- Múčky, prášky a pelety, z rýb alebo kôrovcov, mäkkýšov alebo ostatných vodných bezstavovcov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23012000'),
('2302', 'Otruby, vedľajšie mlynárske výrobky a ostatné zvyšky, tiež vo forme peliet, získané preosievaním, mletím alebo iným spracovaním obilnín alebo strukovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2302'),
('230210', '- Z kukurice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230210'),
('23021010', '-- S obsahom škrobu nepresahujúcim 35 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23021010'),
('23021090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23021090'),
('230230', '- Z pšenice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230230'),
('23023010', '-- S obsahom škrobu nepresahujúcim 28 % hmotnosti, a ktorých podiel prepadnutý sitom s veľkosťou ôk 0,2 mm nepresahuje 10 % hmotnosti alebo eventuálne, ktorých podiel prepadnutý sitom má obsah popola, počítaný na sušinu, rovný alebo viac ako 1,5 % hmotno', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23023010'),
('23023090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23023090'),
('230240', '- Z ostatných obilnín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230240'),
('230240:2X', '-- Z ryže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230240:2X'),
('23024002', '--- S obsahom škrobu nepresahujúcim 35 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23024002'),
('23024008', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23024008'),
('23024008:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23024008:2X'),
('23024010', '--- S obsahom škrobu nepresahujúcim 28 % hmotnosti, a ktorých podiel prepadnutý sitom s veľkosťou 0,2 mm nepresahuje 10 % hmotnosti alebo eventuálne, ktorých podiel prepadnutý sitom má obsah popola, počítaný na sušinu, rovný alebo viac ako 1,5 % hmotnost', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23024010'),
('23024090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23024090'),
('23025000', '- Zo strukovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23025000'),
('2303', 'Zvyšky z výroby škrobu a podobné zvyšky, repné rezky, bagasa a ostatný odpad z výroby cukru, pivovarnícke alebo liehovarnícke mláto a odpad, tiež vo forme peliet', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2303'),
('230310', '- Zvyšky z výroby škrobu a podobné zvyšky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230310'),
('230310:2X', '-- Zvyšky z výroby škrobu z kukurice (okrem koncentrovaných namáčacích roztokov), s obsahom proteínov počítaným na sušinu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230310:2X'),
('23031011', '--- Presahujúcim 40 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23031011'),
('23031019', '--- Nepresahujúcim 40 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23031019'),
('23031090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23031090'),
('230320', '- Repné rezky, bagasa a ostatný odpad z výroby cukru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230320'),
('23032010', '-- Repné rezky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23032010'),
('23032090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23032090'),
('23033000', '- Pivovarnícke alebo liehovarnícke mláto a odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23033000'),
('23040000', 'Pokrutiny a ostatné pevné zvyšky, tiež drvené alebo vo forme peliet, vznikajúce pri extrakcii sójového oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23040000'),
('23050000', 'Pokrutiny a ostatné pevné zvyšky, tiež drvené alebo vo forme peliet, vznikajúce pri extrakcii arašidového oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23050000'),
('2306', 'Pokrutiny a ostatné pevné zvyšky, tiež drvené alebo vo forme peliet, vznikajúce pri extrakcii rastlinných tukov alebo olejov, iné ako zvyšky položky 2304 alebo 2305', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2306'),
('23061000', '- Z bavlníkových semien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23061000'),
('23062000', '- Z ľanových semien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23062000'),
('23063000', '- Zo slnečnicových semien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23063000'),
('23063000:2X', '- Zo semien repky alebo repky olejnej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23063000:2X'),
('23064100', '-- Zo semien repky alebo repky olejnej s nízkym obsahom kyseliny erukovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23064100'),
('23064900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23064900'),
('23065000', '- Z kokosových orechov alebo kopry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23065000'),
('23066000', '- Z palmových orechov alebo jadier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23066000'),
('230690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230690'),
('23069005', '-- Z kukuričných klíčkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23069005'),
('23069005:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23069005:2X'),
('23069005:3X', '--- Pokrutiny a ostatné zvyšky vznikajúce pri extrakcii olivového oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23069005:3X'),
('23069011', '---- Obsahujúce 3 % hmotnosti alebo menej olivového oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23069011'),
('23069019', '---- Obsahujúce viac ako 3 % hmotnosti olivového oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23069019'),
('23069090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23069090'),
('230700', 'Vínny kal; vínny kameň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230700'),
('230700:2X', '- Vínny kal', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230700:2X'),
('23070011', '-- S celkovým hmotnostným alkoholometrickým titrom nepresahujúcim 7,9 % mas a obsahom sušiny nie menším ako 25 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23070011'),
('23070019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23070019'),
('23070090', '- Vínny kameň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23070090'),
('230800', 'Rastlinné materiály a rastlinný odpad, rastlinné zvyšky a vedľajšie produkty, tiež vo forme peliet, druhov používaných ako krmivo pre zvieratá, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230800'),
('230800:2X', '- Hroznové výlisky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230800:2X'),
('23080011', '-- S celkovým hmotnostným alkoholometrickým titrom nepresahujúcim 4,3 % mas a obsahom sušiny najmenej 40 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23080011'),
('23080019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23080019'),
('23080040', '- Žalude a konské gaštany; ovocné výlisky, iné ako hroznové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23080040'),
('23080090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23080090'),
('2309', 'Prípravky druhov používaných ako krmivo pre zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2309'),
('230910', '- Krmivo pre psy alebo mačky, v balení na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230910'),
('230910:2X', '-- Obsahujúce škrob, glukózu, glukózový sirup, maltodextrín alebo maltodextrínový sirup podpoložiek 1702 30 50, 1702 30 90, 1702 40 90, 1702 90 50 a 2106 90 55 alebo mliečne výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230910:2X'),
('230910:3X', '--- Obsahujúce škrob, glukózu, glukózový sirup, maltodextrín alebo maltodextrínový sirup', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230910:3X'),
('230910:4X', '---- Neobsahujúce škrob alebo obsahujúce 10 % hmotnosti alebo menej škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230910:4X'),
('23091011', '----- Neobsahujúce mliečne výrobky alebo obsahujúce menej ako 10 % hmotnosti takýchto výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091011'),
('23091013', '----- Obsahujúce nie menej ako 10 %, ale menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091013'),
('23091015', '----- Obsahujúce nie menej ako 50 %, ale menej ako 75 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091015'),
('23091019', '----- Obsahujúce nie menej ako 75 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091019'),
('23091019:2X', '---- Obsahujúce viac ako 10 %, ale nie viac ako 30 % hmotnosti škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091019:2X'),
('23091031', '----- Neobsahujúce mliečne výrobky alebo obsahujúce menej ako 10 % hmotnosti takýchto výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091031'),
('23091033', '----- Obsahujúce nie menej ako 10 %, ale menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091033'),
('23091039', '----- Obsahujúce nie menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091039'),
('23091039:2X', '---- Obsahujúce viac ako 30 % hmotnosti škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091039:2X'),
('23091051', '----- Neobsahujúce mliečne výrobky alebo obsahujúce menej ako 10 % hmotnosti takýchto výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091051'),
('23091053', '----- Obsahujúce nie menej ako 10 %, ale menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091053'),
('23091059', '----- Obsahujúce nie menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091059'),
('23091070', '--- Neobsahujúce škrob, glukózu, glukózový sirup, maltodextrín alebo maltodextrínový sirup, ale obsahujúce mliečne výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091070'),
('23091090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23091090'),
('230990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_230990'),
('23099010', '-- Rozpustné výrobky ("solubles") z rýb alebo morských cicavcov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099010'),
('23099020', '-- Výrobky uvedené v doplnkovej poznámke 5 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099020'),
('23099020:2X', '-- Ostatné, vrátane premixov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099020:2X'),
('23099020:3X', '--- Obsahujúce škrob, glukózu, glukózový sirup, maltodextrín alebo maltodextrínový sirup podpoložiek 1702 30 50, 1702 30 90, 1702 40 90, 1702 90 50 a 2106 90 55 alebo mliečne výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099020:3X'),
('23099020:4X', '---- Obsahujúce škrob, glukózu, glukózový sirup, maltodextrín alebo maltodextrínový sirup', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099020:4X'),
('23099020:5X', '----- Neobsahujúce škrob alebo obsahujúce 10 % hmotnosti alebo menej škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099020:5X'),
('23099031', '------ Neobsahujúce mliečne výrobky alebo obsahujúce menej ako 10 % hmotnosti takýchto výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099031'),
('23099033', '------ Obsahujúce nie menej ako 10 %, ale menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099033'),
('23099035', '------ Obsahujúce nie menej ako 50 %, ale menej ako 75 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099035'),
('23099039', '------ Obsahujúce nie menej ako 75 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099039'),
('23099039:2X', '----- Obsahujúce viac ako 10 %, ale nie viac ako 30 % hmotnosti škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099039:2X'),
('23099041', '------ Neobsahujúce mliečne výrobky alebo obsahujúce menej ako 10 % hmotnosti takýchto výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099041'),
('23099043', '------ Obsahujúce nie menej ako 10 %, ale menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099043'),
('23099049', '------ Obsahujúce nie menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099049'),
('23099049:2X', '----- Obsahujúce viac ako 30 % hmotnosti škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099049:2X'),
('23099051', '------ Neobsahujúce mliečne výrobky alebo obsahujúce menej ako 10 % hmotnosti takýchto výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099051'),
('23099053', '------ Obsahujúce nie menej ako 10 %, ale menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099053'),
('23099059', '------ Obsahujúce nie menej ako 50 % hmotnosti mliečnych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099059'),
('23099070', '---- Neobsahujúce škrob, glukózu, glukózový sirup, maltodextrín alebo maltodextrínový sirup, ale obsahujúce mliečne výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099070'),
('23099070:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099070:2X'),
('23099091', '---- Repné rezky s pridanou melasou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099091'),
('23099096', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_23099096'),
('2401', 'Nespracovaný tabak; tabakový zvyšok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2401'),
('240110', '- Tabak, ktorý nie je odžilovaný a nie je strips', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_240110'),
('24011035', '-- Tabak sušený prirodzenou cirkuláciou vzduchu, svetlý (light air-cured)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24011035'),
('24011060', '-- Tabak sušený na slnku (sun-cured) orientálneho typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24011060'),
('24011070', '-- Tabak sušený prirodzenou cirkuláciou vzduchu, tmavý (dark air-cured)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24011070'),
('24011085', '-- Tabak sušený regulovanou cirkuláciou teplého vzduchu (flue-cured)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24011085'),
('24011095', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24011095'),
('240120', '- Tabak, ktorý je čiastočne alebo úplne odžilovaný alebo strips', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_240120'),
('24012035', '-- Tabak sušený prirodzenou cirkuláciou vzduchu, svetlý (light air-cured)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24012035'),
('24012060', '-- Tabak sušený na slnku (sun-cured) orientálneho typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24012060'),
('24012070', '-- Tabak sušený prirodzenou cirkuláciou vzduchu, tmavý (dark air-cured)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24012070'),
('24012085', '-- Tabak sušený regulovanou cirkuláciou teplého vzduchu (flue-cured)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24012085'),
('24012095', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24012095'),
('24013000', '- Tabakový zvyšok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24013000'),
('2402', 'Cigary, cigary s odrezanými koncami, cigarky a cigarety, z tabaku alebo náhradiek tabaku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2402'),
('24021000', '- Cigary, cigary s odrezanými koncami a cigarky, obsahujúce tabak', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MIL'), 'SK_24021000'),
('240220', '- Cigarety obsahujúce tabak', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_240220'),
('24022010', '-- Obsahujúce klinčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MIL'), 'SK_24022010'),
('24022090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MIL'), 'SK_24022090'),
('24029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24029000'),
('2403', 'Ostatný spracovaný tabak a spracované náhradky tabaku; "homogenizovaný" alebo "rekonštituovaný" tabak; tabakové výťažky a esencie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2403'),
('2403:2X', '- Tabak na fajčenie, tiež obsahujúci náhradky tabaku v akomkoľvek pomere', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2403:2X'),
('24031100', '-- Tabak do vodnej fajky špecifikované poznámkou 1 k podpoložkám tejto kapitoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24031100'),
('240319', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_240319'),
('24031910', '--- V bezprostrednom obale s netto obsahom nepresahujúcim 500 g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24031910'),
('24031990', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24031990'),
('24031990:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24031990:2X'),
('24039100', '-- "Homogenizovaný" alebo "rekonštituovaný" tabak', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24039100'),
('240399', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_240399'),
('24039910', '--- Žuvací tabak a šnupací tabak', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24039910'),
('24039990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_24039990'),
('250100', 'Soľ (vrátane stolovej soli a denaturovanej soli) a čistý chlorid sodný, tiež vo vodnom roztoku alebo obsahujúci pridaný prostriedok proti spekaniu alebo na zabezpečenie tekutosti; morská voda', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_250100'),
('25010010', '- Morská voda a soľné roztoky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25010010'),
('25010010:2X', '- Soľ (vrátane stolovej soli a denaturovanej soli) a čistý chlorid sodný, tiež vo vodnom roztoku alebo obsahujúci pridaný prostriedok proti spekaniu alebo na zabezpečenie tekutosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25010010:2X'),
('25010031', '-- Na chemické spracovanie (separácia Na od Cl) na výrobu ostatných výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25010031'),
('25010031:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25010031:2X'),
('25010051', '--- Denaturovaná alebo na priemyselné použitie (vrátane rafinácie), iná ako na konzerváciu a prípravu potravín na ľudskú alebo zvieraciu konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25010051'),
('25010051:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25010051:2X'),
('25010091', '---- Soľ vhodná na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25010091'),
('25010099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25010099'),
('25020000', 'Nepražený pyrit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25020000'),
('250300', 'Síra všetkých druhov, iná ako sublimovaná síra, zrážaná síra a koloidná síra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_250300'),
('25030010', '- Surová alebo nerafinovaná síra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25030010'),
('25030090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25030090'),
('2504', 'Prírodný grafit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2504'),
('25041000', '- V prášku alebo vo vločkách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25041000'),
('25049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25049000'),
('2505', 'Prírodné piesky všetkých druhov, tiež farbené, okrem pieskov obsahujúcich kovy kapitoly 26', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2505'),
('25051000', '- Kremičité piesky a kremenné piesky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25051000'),
('25059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25059000'),
('2506', 'Kremeň (iný ako prírodný piesok); kremenec, tiež nahrubo opracovaný alebo len rozpílený alebo inak rozrezaný, na bloky alebo dosky pravouhlého (vrátane štvorcového) tvaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2506'),
('25061000', '- Kremeň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25061000'),
('25062000', '- Kremenec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25062000'),
('250700', 'Kaolín a ostatné kaolínové íly, tiež kalcinované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_250700'),
('25070020', '- Kaolín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25070020'),
('25070080', '- Ostatné kaolínové íly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25070080'),
('2508', 'Ostatné íly (okrem expandovaných ílov položky 6806), andaluzit, kyanit a silimanit, tiež kalcinované; mullit; šamotové alebo dinasové hlinky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2508'),
('25081000', '- Bentonit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25081000'),
('25083000', '- Žiaruvzdorný íl', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25083000'),
('25084000', '- Ostatné íly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25084000'),
('25085000', '- Andaluzit, kyanit a silimanit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25085000'),
('25086000', '- Mulit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25086000'),
('25087000', '- Šamotové alebo dinasové hlinky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25087000'),
('25090000', 'Krieda', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25090000'),
('2510', 'Prírodné fosfáty vápenaté, prírodné fosfáty hlinitovápenaté a krieda fosfátová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2510'),
('25101000', '- Nemleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25101000'),
('25102000', '- Mleté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25102000'),
('2511', 'Prírodný síran bárnatý (ťaživec); prírodný uhličitan bárnatý (witerit), tiež kalcinovaný, iný ako oxid bárnatý položky 2816', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2511'),
('25111000', '- Prírodný síran bárnatý (ťaživec)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25111000'),
('25112000', '- Prírodný uhličitan bárnatý (witerit)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25112000'),
('25120000', 'Kremičité fosílne múčky (napríklad kremelina, tripolit a diatomit) a podobné kremičité hlinky, tiež kalcinované, so zdanlivou špecifickou hmotnosťou 1 alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25120000'),
('2513', 'Pemza; šmirgeľ; prírodný korund, prírodný granát a ostatné prírodné brúsivá, tiež tepelne upravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2513'),
('25131000', '- Pemza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25131000'),
('25132000', '- Šmirgeľ, prírodný korund, prírodný granát a ostatné prírodné brúsivá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25132000'),
('25140000', 'Bridlica, tiež nahrubo opracovaná alebo len rozpílená alebo inak rozrezaná, na bloky alebo dosky pravouhlého (vrátane štvorcového) tvaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25140000'),
('2515', 'Mramor, travertín, ecaussin a ostatné vápenaté kamene na výtvarné alebo stavebné účely so zdanlivou špecifickou hmotnosťou 2,5 alebo viac, a alabaster, tiež nahrubo opracované alebo len rozpílené alebo inak rozrezané, na bloky alebo dosky pravouhlého (v', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2515'),
('2515:2X', '- Mramor a travertín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2515:2X'),
('25151100', '-- Surový alebo nahrubo opracovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25151100'),
('25151200', '-- Len rozpílený alebo inak rozrezaný, na bloky alebo dosky pravouhlého (vrátane štvorcového) tvaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25151200'),
('25152000', '- Ecaussin a ostatné vápenaté kamene na výtvarné alebo stavebné účely; alabaster', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25152000'),
('2516', 'Žula, porfýr, čadič, pieskovec a ostatné kamene na výtvarné alebo stavebné účely, tiež nahrubo opracované alebo len rozpílené alebo inak rozrezané, na bloky alebo dosky pravouhlého (vrátane štvorcového) tvaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2516'),
('2516:2X', '- Žula', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2516:2X'),
('25161100', '-- Surová alebo nahrubo opracovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25161100'),
('25161200', '-- Len rozpílená alebo inak rozrezaná, na bloky alebo dosky pravouhlého (vrátane štvorcového) tvaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25161200'),
('25162000', '- Pieskovec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25162000'),
('25169000', '- Ostatné kamene na výtvarné alebo stavebné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25169000'),
('2517', 'Okruhliaky, štrk, lámaný alebo drvený kameň druhov bežne používaných na betónové agregáty, štrkovanie ciest alebo železníc alebo podobné štrkopiesky, pazúrik a kremenné okruhliaky, tiež tepelne upravené; makadam z trosky, škváry alebo podobných priemyse', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2517'),
('251710', '- Okruhliaky, štrk, lámaný alebo drvený kameň druhov bežne používaných na betónové agregáty, štrkovanie ciest alebo železníc alebo podobné štrkopiesky, pazúrik a kremenné okruhliaky, tiež tepelne upravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_251710'),
('25171010', '-- Okruhliaky, štrk, kremenné okruhliaky a pazúrik', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25171010'),
('25171020', '-- Vápenec, dolomit a ostatné vápenaté kamene, lámané alebo drvené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25171020'),
('25171080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25171080'),
('25172000', '- Makadam z trosky, škváry alebo podobných priemyselných odpadov, tiež zmiešané s materiálmi uvedenými v podpoložke 2517 10', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25172000'),
('25173000', '- Dechtový makadam', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25173000'),
('25173000:2X', '- Granuly, drvina a prach z kameňov položky 2515 alebo 2516, tiež tepelne upravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25173000:2X'),
('25174100', '-- Z mramoru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25174100'),
('25174900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25174900'),
('2518', 'Dolomit, tiež kalcinovaný alebo sintrovaný, vrátane dolomitu nahrubo opracovaného alebo len rozpíleného alebo inak rozrezaného, na bloky alebo dosky pravouhlého (vrátane štvorcového) tvaru; dolomitové ubíjacie zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2518'),
('25181000', '- Dolomit nekalcinovaný alebo nesintrovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25181000'),
('25182000', '- Dolomit kalcinovaný alebo sintrovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25182000'),
('25183000', '- Dolomitové ubíjacie zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25183000'),
('2519', 'Prírodný uhličitan horečnatý (magnezit); tavená magnézia; spekaná (sintrovaná) magnézia, tiež obsahujúca malé množstvá ostatných oxidov pridaných pred spekaním; ostatné oxidy horčíka, tiež čisté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2519'),
('25191000', '- Prírodný uhličitan horečnatý (magnezit)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25191000'),
('251990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_251990'),
('25199010', '-- Oxid horečnatý, iný ako kalcinovaný prírodný uhličitan horečnatý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25199010'),
('25199030', '-- Spekaná (sintrovaná) magnézia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25199030'),
('25199090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25199090'),
('2520', 'Sadrovec; anhydrit; sadry (pozostávajúce z kalcinovaného sadrovca alebo síranu vápenatého) tiež farbené, tiež s malým množstvom urýchľovačov alebo spomaľovačov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2520'),
('25201000', '- Sadrovec; anhydrit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25201000'),
('25202000', '- Sadry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25202000'),
('25210000', 'Vápencové tavidlo; vápenec a ostatné vápenaté kamene druhov používaných na výrobu vápna alebo cementu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25210000'),
('2522', 'Vápno nehasené, vápno hasené a vápno hydraulické, iné ako oxid vápenatý a hydroxid vápenatý položky 2825', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2522'),
('25221000', '- Vápno nehasené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25221000'),
('25222000', '- Vápno hasené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25222000'),
('25223000', '- Vápno hydraulické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25223000'),
('2523', 'Cement portlandský, cement hlinitanový, cement troskový, cement supersulfátový a podobné cementy hydraulické, tiež farbené alebo vo forme slinkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2523'),
('25231000', '- Slinky cementové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25231000'),
('25231000:2X', '- Cement portlandský', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25231000:2X'),
('25232100', '-- Cement biely, tiež umelo farbený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25232100'),
('25232900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25232900'),
('25233000', '- Cement hlinitanový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25233000'),
('25239000', '- Cementy hydraulické, ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25239000'),
('2524', 'Azbest', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2524'),
('25241000', '- Krokydolit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25241000'),
('25249000', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25249000'),
('2525', 'Sľuda, vrátane splítingov; sľudový odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2525'),
('25251000', '- Sľuda surová alebo sľuda štiepaná na šupiny alebo na nepravidelné doštičky (splitingy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25251000'),
('25252000', '- Sľudový prach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25252000'),
('25253000', '- Sľudový odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25253000'),
('2526', 'Steatit prírodný, tiež nahrubo opracovaný alebo len rozpílený alebo inak rozrezaný, na bloky alebo na dosky pravouhlého (vrátane štvorcového) tvaru; mastenec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2526'),
('25261000', '- Nedrvený, nie práškový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25261000'),
('25262000', '- Drvený alebo práškový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25262000'),
('25280000', 'Prírodné boritany a ich koncentráty (tiež kalcinované), ale okrem boritanov získaných z prírodnej soľanky; prírodná kyselina boritá obsahujúca najviac 85 % hmotnosti H3BO3 počítanej na čistú hmotnosť (sušinu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25280000'),
('2529', 'Živec; leucit; nefelín a nefelinický syenit; kazivec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2529'),
('25291000', '- Živec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25291000'),
('25291000:2X', '- Kazivec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25291000:2X'),
('25292100', '-- Obsahujúci v hmotnosti 97 % alebo menej fluoridu vápenatého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25292100'),
('25292200', '-- Obsahujúci v hmotnosti viac ako 97 % fluoridu vápenatého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25292200'),
('25293000', '- Leucit; nefelín a nefelinický syenit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25293000'),
('2530', 'Nerastné látky inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2530'),
('25301000', '- Vermikulit, perlit a chlority, neexpandované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25301000'),
('25302000', '- Kieserit, epsomit (prírodné sírany horečnaté)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25302000'),
('25309000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_25309000'),
('2601', 'Železné rudy a koncentráty, vrátane pražených pyritov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2601'),
('2601:2X', '- Železné rudy a koncentráty, iné ako pražené pyrity', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2601:2X'),
('26011100', '-- Neaglomerované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26011100'),
('26011200', '-- Aglomerované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26011200'),
('26012000', '- Pražené pyrity', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26012000'),
('26020000', 'Mangánové rudy a koncentráty, vrátane mangánových rúd obsahujúcich železo a koncentrátov s obsahom mangánu 20 % alebo viac, prepočítaného na čistú hmotnosť (sušinu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26020000'),
('26030000', 'Medené rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26030000'),
('26040000', 'Niklové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26040000'),
('26050000', 'Kobaltové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26050000'),
('26060000', 'Hliníkové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26060000'),
('26070000', 'Olovené rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26070000'),
('26080000', 'Zinkové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26080000'),
('26090000', 'Cínové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26090000'),
('26100000', 'Chrómové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26100000'),
('26110000', 'Volfrámové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26110000'),
('2612', 'Uránové alebo tóriové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2612'),
('261210', '- Uránové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_261210'),
('26121010', '-- Uránové rudy a smolinec (uranín) a ich koncentráty, s obsahom uránu viac ako 5 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26121010'),
('26121090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26121090'),
('261220', '- Tóriové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_261220'),
('26122010', '-- Monazit; uranotorianit a ostatné tóriové rudy a koncentráty, s obsahom tória viac ako 20 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26122010'),
('26122090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26122090'),
('2613', 'Molybdénové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2613'),
('26131000', '- Pražené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26131000'),
('26139000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26139000'),
('26140000', 'Titánové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26140000'),
('2615', 'Nióbové, tantalové, vanádové alebo zirkóniové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2615'),
('26151000', '- Zirkóniové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26151000'),
('26159000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26159000'),
('2616', 'Rudy drahých kovov a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2616'),
('26161000', '- Strieborné rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26161000'),
('26169000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26169000'),
('2617', 'Ostatné rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2617'),
('26171000', '- Antimónové rudy a koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26171000'),
('26179000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26179000'),
('26180000', 'Granulovaná troska (troskový piesok) z výroby železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26180000'),
('261900', 'Trosky, škváry (iné ako granulovaná troska), okuje a ostatný odpad z výroby železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_261900'),
('26190020', '- Odpad vhodný na znovuzískavanie železa alebo mangánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26190020'),
('26190090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26190090'),
('2620', 'Trosky, popoly a zvyšky (iné ako z výroby železa alebo ocele) obsahujúce kovy, arzén alebo ich zlúčeniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2620'),
('2620:2X', '- Obsahujúce hlavne zinok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2620:2X'),
('26201100', '-- Tvrdý zinkový kamienok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26201100'),
('26201900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26201900'),
('26201900:2X', '- Obsahujúce hlavne olovo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26201900:2X'),
('26202100', '-- Kaly z olovnatých benzínov a kaly z olovnatých zlúčenín proti klepaniu motora', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26202100'),
('26202900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26202900'),
('26203000', '- Obsahujúce hlavne meď', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26203000'),
('26204000', '- Obsahujúce hlavne hliník', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26204000'),
('26206000', '- Obsahujúce arzén, ortuť, tálium alebo ich zmesi, druhov používaných na získavanie arzénu alebo týchto kovov alebo na výrobu ich chemických zlúčenín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26206000'),
('26206000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26206000:2X'),
('26209100', '-- Obsahujúce antimón, berýlium, kadmium, chróm alebo ich zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26209100'),
('262099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_262099'),
('26209910', '--- Obsahujúce hlavne nikel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26209910'),
('26209920', '--- Obsahujúce hlavne niób alebo tantal', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26209920'),
('26209940', '--- Obsahujúce hlavne cín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26209940'),
('26209960', '--- Obsahujúce hlavne titán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26209960'),
('26209995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26209995'),
('2621', 'Ostatné trosky a popoly, vrátane popolov z morských rias (kelp); popoly a zvyšky zo spaľovania komunálneho odpadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2621'),
('26211000', '- Popoly a zvyšky zo spaľovania komunálneho odpadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26211000'),
('26219000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_26219000'),
('2701', 'Čierne uhlie; brikety, bulety a podobné tuhé palivá vyrobené z čierneho uhlia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2701'),
('2701:2X', '- Čierne uhlie, tiež v prášku, ale neaglomerované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2701:2X'),
('27011100', '-- Antracit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27011100'),
('270112', '-- Bitúmenové uhlie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270112'),
('27011210', '--- Koksovateľné uhlie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27011210'),
('27011290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27011290'),
('27011900', '-- Ostatné uhlie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27011900'),
('27012000', '- Brikety, bulety a podobné tuhé palivá vyrobené z čierneho uhlia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27012000'),
('2702', 'Hnedé uhlie, tiež aglomerované, okrem gagátu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2702'),
('27021000', '- Hnedé uhlie, tiež v prášku, ale neaglomerované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27021000'),
('27022000', '- Aglomerované hnedé uhlie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27022000'),
('27030000', 'Rašelina (vrátane rašelinovej podstielky), tiež aglomerovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27030000'),
('270400', 'Koks a polokoks z čierneho uhlia, hnedého uhlia alebo z rašeliny, tiež aglomerovaný; retortové uhlie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270400'),
('270400:2X', '- Koks a polokoks z čierneho uhlia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270400:2X'),
('27040011', '-- Na výrobu elektród', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27040011'),
('27040019', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27040019'),
('27040030', '- Koks a polokoks z hnedého uhlia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27040030'),
('27040090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27040090'),
('27050000', 'Svietiplyn, vodný plyn, generátorový plyn a podobné plyny, iné ako ropné plyny a ostatné plynné uhľovodíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_27050000'),
('27060000', 'Decht destilovaný z čierneho uhlia, z hnedého uhlia alebo rašeliny a ostatné minerálne dechty, tiež dehydratované alebo čiastočne destilované, vrátane rekonštituovaných dechtov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27060000'),
('2707', 'Oleje a ostatné produkty destilácie vysokotepelných čiernouhoľných dechtov; podobné produkty, v ktorých hmotnosť aromatických zložiek prevažuje nad hmotnosťou nearomatických zložiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2707'),
('270710', '- Benzol (benzén)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270710'),
('27071010', '-- Na použitie v energetike alebo na vykurovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27071010'),
('27071090', '-- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27071090'),
('270720', '- Toluol (toluén)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270720'),
('27072010', '-- Na použitie v energetike alebo na vykurovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27072010'),
('27072090', '-- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27072090'),
('270730', '- Xylol (xylény)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270730'),
('27073010', '-- Na použitie v energetike alebo na vykurovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27073010'),
('27073090', '-- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27073090'),
('27074000', '- Naftalén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27074000'),
('270750', '- Ostatné zmesi aromatických uhľovodíkov, z ktorých 65 % objemu alebo viac (vrátane strát) predestiluje pri 250 °C podľa metódy ASTM D 86', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270750'),
('27075010', '-- Na použitie v energetike alebo na vykurovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27075010'),
('27075090', '-- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27075090'),
('27075090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27075090:2X'),
('27079100', '-- Kreozotové oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27079100'),
('270799', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270799'),
('270799:2X', '--- Surové oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270799:2X'),
('27079911', '---- Surové ľahké oleje, z ktorých 90 % objemu alebo viac predestiluje pri teplote do 200 °C', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27079911'),
('27079919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27079919'),
('27079920', '--- Vrchná sírnatá vrstva; antracén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27079920'),
('27079950', '--- Zásadité produkty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27079950'),
('27079980', '--- Fenoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27079980'),
('27079980:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27079980:2X'),
('27079991', '---- Na výrobu výrobkov položky 2803', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27079991'),
('27079999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27079999'),
('2708', 'Smola a smolný koks z čiernouhoľného dechtu alebo z ostatných minerálnych dechtov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2708'),
('27081000', '- Smola', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27081000'),
('27082000', '- Smolný koks', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27082000'),
('270900', 'Ropné oleje a oleje získané z bitúmenových nerastov, surové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_270900'),
('27090010', '- Kondenzáty zemného plynu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27090010'),
('27090090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27090090'),
('2710', 'Ropné oleje a oleje získané z bitúmenových nerastov, iné ako surové; prípravky inde nešpecifikované ani nezahrnuté, obsahujúce v hmotnosti 70 % alebo viac ropných olejov alebo olejov získaných z bitúmenových nerastov, ak tieto oleje sú základnými zložka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2710'),
('2710:2X', '- Ropné oleje a oleje získané z bitúmenových nerastov (iné ako surové) a prípravky inde nešpecifikované alebo nezahrnuté, obsahujúce v hmotnosti 70 % alebo viac ropných olejov alebo olejov získaných z bitúmenových nerastov, ak sú tieto oleje základnými z', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2710:2X'),
('271012', '-- Ľahké oleje a prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271012'),
('27101211', '--- Určené na špecifické spracovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101211'),
('27101215', '--- Určené na chemické spracovanie, iným procesom, ako je stanovené pre podpoložku 2710 12 11', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101215'),
('27101215:2X', '--- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101215:2X'),
('27101215:3X', '---- Špeciálne druhy benzínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101215:3X'),
('27101221', '----- Lakový benzín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101221'),
('27101225', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101225'),
('27101225:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101225:2X'),
('27101225:3X', '----- Motorový benzín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101225:3X'),
('27101231', '------ Letecký benzín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101231'),
('27101231:2X', '------ Ostatné s obsahom olova', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101231:2X'),
('27101231:3X', '------- Nepresahujúcim 0,013 g/liter', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101231:3X'),
('27101241', '-------- S oktánovým číslom (RON) menej ako 95', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KLT'), 'SK_27101241'),
('27101245', '-------- S oktánovým číslom (RON) 95 alebo viac, ale menej ako 98', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KLT'), 'SK_27101245'),
('27101249', '-------- S oktánovým číslom (RON) 98 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KLT'), 'SK_27101249'),
('27101249:2X', '------- Presahujúcim 0,013 g/liter', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101249:2X'),
('27101251', '-------- S oktánovým číslom (RON) menej ako 98', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KLT'), 'SK_27101251'),
('27101259', '-------- S oktánovým číslom (RON) 98 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KLT'), 'SK_27101259'),
('27101270', '----- Palivo pre tryskové motory benzínového typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101270'),
('27101290', '----- Ostatné ľahké oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101290'),
('271019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271019'),
('271019:2X', '--- Stredné oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271019:2X'),
('27101911', '---- Určené na špecifické spracovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101911'),
('27101915', '---- Určené na chemické spracovanie, iným procesom, ako je stanovené pre podpoložku 2710 19 11', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101915'),
('27101915:2X', '---- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101915:2X'),
('27101915:3X', '----- Kerozín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101915:3X'),
('27101921', '------ Palivo pre tryskové motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101921'),
('27101925', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101925'),
('27101929', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101929'),
('27101929:2X', '--- Ťažké oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101929:2X'),
('27101929:3X', '---- Plynové oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101929:3X'),
('27101931', '----- Určené na špecifické spracovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101931'),
('27101935', '----- Určené na chemické spracovanie, iným procesom, ako je stanovené pre podpoložku 2710 19 31', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101935'),
('27101935:2X', '----- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101935:2X'),
('27101943', '------ S obsahom síry nepresahujúcim 0,001 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101943'),
('27101946', '------ S obsahom síry presahujúcim 0,001 % hmotnosti, ale nepresahujúcim 0,002 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101946'),
('27101947', '------ S obsahom síry presahujúcim 0,002 % hmotnosti, ale nepresahujúcim 0,1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101947'),
('27101948', '------ S obsahom síry presahujúcim 0,1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101948'),
('27101948:2X', '---- Vykurovacie oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101948:2X'),
('27101951', '----- Určené na špecifické spracovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101951'),
('27101955', '----- Určené na chemické spracovanie, iným procesom, ako je stanovené pre podpoložku 2710 19 51', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101955'),
('27101955:2X', '----- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101955:2X'),
('27101962', '------ S obsahom síry nepresahujúcim 0,1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101962'),
('27101964', '------ S obsahom síry presahujúcim 0,1 % hmotnosti, ale nepresahujúcim 1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101964'),
('27101968', '------ S obsahom síry presahujúcim 1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101968'),
('27101968:2X', '---- Mazacie oleje; ostatné oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101968:2X'),
('27101971', '----- Určené na špecifické spracovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101971'),
('27101975', '----- Určené na chemické spracovanie, iným procesom, ako je stanovené pre podpoložku 2710 19 71', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101975'),
('27101975:2X', '----- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101975:2X'),
('27101981', '------ Motorové oleje, mazacie oleje pre kompresory, mazacie oleje pre turbíny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101981'),
('27101983', '------ Kvapaliny na hydraulické účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101983'),
('27101985', '------ Biele oleje, kvapalný parafín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101985'),
('27101987', '------ Prevodové oleje a redukčné oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101987'),
('27101991', '------ Prípravky používané pri obrábaní kovov, oleje na uvoľňovanie odliatkov z foriem, antikorózne oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101991'),
('27101993', '------ Elektrické izolačné oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101993'),
('27101999', '------ Ostatné mazacie oleje a ostatné oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27101999'),
('271020', '- Ropné oleje a oleje získané z bitúmenových nerastov (iné ako surové) a prípravky inde nešpecifikované ani nezahrnuté, obsahujúce v hmotnosti 70 % alebo viac ropných olejov alebo olejov získaných z bitúmenových nerastov, ak sú tieto oleje základnými zlo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271020'),
('271020:2X', '-- Plynové oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271020:2X'),
('27102011', '--- S obsahom síry nepresahujúcim 0,001 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102011'),
('27102015', '--- S obsahom síry presahujúcim 0,001 % hmotnosti, ale nepresahujúcim 0,002 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102015'),
('27102017', '--- S obsahom síry presahujúcim 0,002 % hmotnosti, ale nepresahujúcim 0,1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102017'),
('27102019', '--- S obsahom síry presahujúcim 0,1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102019'),
('27102019:2X', '-- Vykurovacie oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102019:2X'),
('27102031', '--- S obsahom síry nepresahujúcim 0,1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102031'),
('27102035', '--- S obsahom síry presahujúcim 0,1 % hmotnosti, ale nepresahujúcim 1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102035'),
('27102039', '--- S obsahom síry presahujúcim 1 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102039'),
('27102090', '-- Ostatné oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102090'),
('27102090:2X', '- Odpadové oleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27102090:2X'),
('27109100', '-- Obsahujúce polychlórované bifenyly (PCB), polychlórované terfenyly (PCT) alebo polybrómované bifenyly (PBB)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27109100'),
('27109900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27109900'),
('2711', 'Ropné plyny a ostatné plynné uhľovodíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2711'),
('2711:2X', '- Skvapalnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2711:2X'),
('27111100', '-- Zemný plyn', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_TJO'), 'SK_27111100'),
('271112', '-- Propán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271112'),
('271112:2X', '--- Propán s čistotou najmenej 99 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271112:2X'),
('27111211', '---- Na použitie v energetike alebo na vykurovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111211'),
('27111219', '---- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111219'),
('27111219:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111219:2X'),
('27111291', '---- Určené na špecifické spracovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111291'),
('27111293', '---- Určené na chemické spracovanie, iným procesom, ako je stanovené pre podpoložku 2711 12 91', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111293'),
('27111293:2X', '---- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111293:2X'),
('27111294', '----- S čistotou presahujúcou 90 %, ale menej ako 99 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111294'),
('27111297', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111297'),
('271113', '-- Butány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271113'),
('27111310', '--- Určené na špecifické spracovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111310'),
('27111330', '--- Určené na chemické spracovanie, iným procesom, ako je stanovené pre podpoložku 2711 13 10', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111330'),
('27111330:2X', '--- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111330:2X'),
('27111391', '---- S čistotou presahujúcou 90 %, ale menej ako 95 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111391'),
('27111397', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111397'),
('27111400', '-- Etylén, propylén, butylén a butadién', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111400'),
('27111900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111900'),
('27111900:2X', '- V plynnom stave', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27111900:2X'),
('27112100', '-- Zemný plyn', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_TJO'), 'SK_27112100'),
('27112900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27112900'),
('2712', 'Vazelína; parafínový vosk, mikrokryštalický ropný vosk, parafínový gáč, ozokerit, montánny vosk, rašelinový vosk, ostatné minerálne vosky a podobné výrobky získané syntézou alebo ostatnými procesmi, tiež zafarbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2712'),
('271210', '- Vazelína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271210'),
('27121010', '-- Surová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27121010'),
('27121090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27121090'),
('271220', '- Parafínový vosk obsahujúci v hmotnosti menej ako 0,75 % oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271220'),
('27122010', '-- Syntetický parafínový vosk s molekulovou hmotnosťou 460 alebo viac, ale nepresahujúcou 1 560', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27122010'),
('27122090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27122090'),
('271290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271290'),
('271290:2X', '-- Ozokerit, montánny vosk alebo rašelinový vosk (prírodné produkty)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271290:2X'),
('27129011', '--- Surové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129011'),
('27129019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129019'),
('27129019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129019:2X'),
('27129019:3X', '--- Surové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129019:3X'),
('27129031', '---- Určené na špecifické spracovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129031'),
('27129033', '---- Určené na chemické spracovanie, iným procesom, ako je stanovené pre podpoložku 2712 90 31', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129033'),
('27129039', '---- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129039'),
('27129039:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129039:2X'),
('27129091', '---- Zmes 1-alkénov obsahujúca v hmotnosti 80 % alebo viac 1-alkénov, s dĺžkou reťazca 24 atómov uhlíka alebo viac, ale nepresahujúcou 28 atómov uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129091'),
('27129099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27129099'),
('2713', 'Ropný koks, ropný bitúmen a ostatné zvyšky z ropných olejov alebo z olejov získaných z bitúmenových nerastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2713'),
('2713:2X', '- Ropný koks', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2713:2X'),
('27131100', '-- Nekalcinovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27131100'),
('27131200', '-- Kalcinovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27131200'),
('27132000', '- Ropný bitúmen', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27132000'),
('271390', '- Ostatné zvyšky z ropných olejov alebo z olejov získaných z bitúmenových nerastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_271390'),
('27139010', '-- Na výrobu výrobkov položky 2803', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27139010'),
('27139090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27139090'),
('2714', 'Prírodný bitúmén a prírodný asfalt; bitúmenové alebo olejové bridlice a dechtové piesky; asfaltity a asfaltové horniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2714'),
('27141000', '- Bitúmenové alebo olejové bridlice a dechtové piesky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27141000'),
('27149000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27149000'),
('27150000', 'Bitúmenové zmesi na základe prírodného asfaltu, prírodného bitúmenu, ropného bitúmenu, minerálneho dechtu alebo zo smoly z minerálneho dechtu (napríklad bitúmenový tmel, spätné frakcie)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27150000'),
('27160000', 'Elektrická energia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MWH'), 'SK_27160000'),
('27160000:2X', 'I. CHEMICKÉ PRVKY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_27160000:2X'),
('2801', 'Fluór, chlór, bróm a jód', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2801'),
('28011000', '- Chlór', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28011000'),
('28012000', '- Jód', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28012000'),
('280130', '- Fluór; bróm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_280130'),
('28013010', '-- Fluór', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28013010'),
('28013090', '-- Bróm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28013090'),
('28020000', 'Síra, sublimovaná alebo zrážaná; koloidná síra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28020000'),
('28030000', 'Uhlík (uhlíkové sadze a ostatné formy uhlíka inde nešpecifikované ani nezahrnuté)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28030000'),
('2804', 'Vodík, vzácne plyny a ostatné nekovy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2804'),
('28041000', '- Vodík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_28041000'),
('28041000:2X', '- Vzácne plyny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28041000:2X'),
('28042100', '-- Argón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_28042100'),
('280429', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_280429'),
('28042910', '--- Hélium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_28042910'),
('28042990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_28042990'),
('28043000', '- Dusík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_28043000'),
('28044000', '- Kyslík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_28044000'),
('280450', '- Bór; telúr', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_280450'),
('28045010', '-- Bór', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28045010'),
('28045090', '-- Telúr', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28045090'),
('28045090:2X', '- Kremík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28045090:2X'),
('28046100', '-- Obsahujúci v hmotnosti najmenej 99,99 % kremíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28046100'),
('28046900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28046900'),
('28047000', '- Fosfor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28047000'),
('28048000', '- Arzén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28048000'),
('28049000', '- Selén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28049000'),
('2805', 'Alkalické kovy alebo kovy alkalických zemín; kovy vzácnych zemín, skandium a ytrium, tiež vzájomne zmiešané alebo vzájomne legované; ortuť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2805'),
('2805:2X', '- Alkalické kovy alebo kovy alkalických zemín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2805:2X'),
('28051100', '-- Sodík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28051100'),
('28051200', '-- Vápnik', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28051200'),
('280519', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_280519'),
('28051910', '--- Stroncium a bárium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28051910'),
('28051990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28051990'),
('280530', '- Kovy vzácnych zemín, skandium a ytrium, tiež vzájomne zmiešané alebo vzájomne legované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_280530'),
('28053010', '-- Vzájomne zmiešané alebo vzájomne legované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28053010'),
('28053090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28053090'),
('280540', '- Ortuť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_280540'),
('28054010', '-- Vo fľašiach s čistým obsahom 34,5 kg (štandardná hmotnosť) s fob hodnotou za fľašu nepresahujúcou EUR 224', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28054010'),
('28054090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28054090'),
('28054090:2X', 'II. ANORGANICKÉ KYSELINY A ANORGANICKÉ KYSLÍKATÉ ZLÚČENINY NEKOVOV', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28054090:2X'),
('2806', 'Chlórovodík (kyselina chlórovodíková); kyselina chlórsírová (chlórsulfónová)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2806'),
('28061000', '- Chlórovodík (kyselina chlórovodíková)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28061000'),
('28062000', '- Kyselina chlórsírová (chlórsulfónová)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28062000'),
('28070000', 'Kyselina sírová; oleum', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28070000'),
('28080000', 'Kyselina dusičná; zmes kyseliny sírovej a dusičnej (nitričná zmes)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28080000'),
('2809', 'Oxid fosforečný; kyselina fosforečná a kyseliny polyfosforečné, tiež chemicky definované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2809'),
('28091000', '- Oxid fosforečný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPP'), 'SK_28091000'),
('28092000', '- Kyselina fosforečná a kyseliny polyfosforečné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPP'), 'SK_28092000'),
('281000', 'Oxidy bóru; kyseliny borité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_281000'),
('28100010', '- Oxid boritý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28100010'),
('28100090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28100090'),
('2811', 'Ostatné anorganické kyseliny a ostatné anorganické kyslíkaté zlúčeniny nekovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2811'),
('2811:2X', '- Ostatné anorganické kyseliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2811:2X'),
('28111100', '-- Fluorovodík (kyselina fluorovodíková)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28111100'),
('281119', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_281119'),
('28111910', '--- Kyselina bromovodíková', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28111910'),
('28111920', '--- Kyselina kyanovodíková', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28111920'),
('28111980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28111980'),
('28111980:2X', '- Ostatné anorganické kyslíkaté zlúčeniny nekovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28111980:2X'),
('28112100', '-- Oxid uhličitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28112100'),
('28112200', '-- Oxid kremičitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28112200'),
('281129', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_281129'),
('28112905', '--- Oxid síričitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28112905'),
('28112910', '--- Oxid sírový (anhydrid kyseliny sírovej); oxid arzenitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28112910'),
('28112930', '--- Oxidy dusíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28112930'),
('28112990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28112990'),
('28112990:2X', 'III. HALOGÉNOVÉ ALEBO SÍRNE ZLÚČENINY NEKOVOV', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28112990:2X'),
('2812', 'Halogenidy a halogenid-oxidy nekovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2812'),
('281210', '- Chloridy a chlorid-oxidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_281210'),
('281210:2X', '-- Fosforu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_281210:2X'),
('28121011', '--- Trichlorid-oxid fosforečný (trichlorid fosforylu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121011'),
('28121015', '--- Chlorid fosforitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121015'),
('28121016', '--- Chlorid fosforečný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121016'),
('28121018', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121018'),
('28121018:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121018:2X'),
('28121091', '--- Chlorid sírny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121091'),
('28121093', '--- Chlorid sírnatý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121093'),
('28121094', '--- Fosgén (chlorid karbonylu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121094'),
('28121095', '--- Tionyl dichlorid (chlorid tionylu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121095'),
('28121099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28121099'),
('28129000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28129000'),
('2813', 'Sulfidy nekovov; komerčný sulfid fosforitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2813'),
('28131000', '- Sírouhlík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28131000'),
('281390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_281390'),
('28139010', '-- Sulfidy fosforu, komerčný sulfid fosforitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28139010'),
('28139090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28139090'),
('28139090:2X', 'IV. ANORGANICKÉ ZÁSADY A OXIDY, HYDROXIDY A PEROXIDY KOVOV', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28139090:2X'),
('2814', 'Amoniak (čpavok) bezvodý alebo vo vodnom roztoku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2814'),
('28141000', '- Bezvodý amoniak (čpavok)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28141000'),
('28142000', '- Amoniak (čpavok) vo vodnom roztoku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28142000'),
('2815', 'Hydroxid sodný (žieravá sóda); hydroxid draselný (žieravá potaš); peroxidy sodíka alebo draslíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2815'),
('2815:2X', '- Hydroxid sodný (žieravá sóda)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2815:2X'),
('28151100', '-- Tuhý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28151100'),
('28151200', '-- Vo vodnom roztoku (sodný lúh alebo kvapalná sóda)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSH'), 'SK_28151200'),
('28152000', '- Hydroxid draselný (žieravá potaš)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPH'), 'SK_28152000'),
('28153000', '- Peroxidy sodíka alebo draslíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28153000'),
('2816', 'Hydroxid a peroxid horčíka; oxidy, hydroxidy a peroxidy stroncia alebo bária', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2816'),
('28161000', '- Hydroxid a peroxid horčíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28161000'),
('28164000', '- Oxidy, hydroxidy a peroxidy stroncia alebo bária', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28164000'),
('28170000', 'Oxid zinočnatý; peroxid zinku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28170000'),
('2818', 'Umelý korund, tiež chemicky definovaný; oxid hlinitý; hydroxid hlinitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2818'),
('281810', '- Umelý korund, tiež chemicky definovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_281810'),
('281810:2X', '-- S obsahom oxidu hlinitého 98,5 % hmotnosti alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_281810:2X'),
('28181011', '--- S obsahom častíc s veľkosťou viac ako 10 mm menej ako 50 % z celkovej hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28181011'),
('28181019', '--- S obsahom častíc s veľkosťou viac ako 10 mm 50 % alebo viac z celkovej hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28181019'),
('28181019:2X', '-- S obsahom oxidu hlinitého menej ako 98,5 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28181019:2X'),
('28181091', '--- S obsahom častíc s veľkosťou viac ako 10 mm menej ako 50 % z celkovej hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28181091'),
('28181099', '--- S obsahom častíc s veľkosťou viac ako 10 mm 50 % alebo viac z celkovej hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28181099'),
('28182000', '- Oxid hlinitý, iný ako umelý korund', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28182000'),
('28183000', '- Hydroxid hlinitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28183000'),
('2819', 'Oxidy a hydroxidy chrómu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2819'),
('28191000', '- Oxid chrómový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28191000'),
('281990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_281990'),
('28199010', '-- Oxid chromičitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28199010'),
('28199090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28199090'),
('2820', 'Oxidy mangánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2820'),
('28201000', '- Oxid manganičitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28201000'),
('282090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_282090'),
('28209010', '-- Oxid manganatý obsahujúci v hmotnosti 77 % alebo viac mangánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28209010'),
('28209090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28209090'),
('2821', 'Oxidy a hydroxidy železa; farebné hlinky obsahujúce v hmotnosti 70 % alebo viac viazaného železa vyjadreného ako Fe2O3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2821'),
('28211000', '- Oxidy a hydroxidy železa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28211000'),
('28212000', '- Farebné hlinky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28212000'),
('28220000', 'Oxidy a hydroxidy kobaltu; komerčné oxidy kobaltu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28220000'),
('28230000', 'Oxidy titánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28230000'),
('2824', 'Oxidy olova; červené olovo a oranžové olovo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2824'),
('28241000', '- Oxid olovnatý (glieda, masikot)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28241000'),
('28249000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28249000'),
('2825', 'Hydrazín a hydroxylamín a ich anorganické soli; ostatné anorganické zásady; ostatné oxidy, hydroxidy a peroxidy kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2825'),
('28251000', '- Hydrazín a hydroxylamín a ich anorganické soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28251000'),
('28252000', '- Oxid lítny a hydroxid lítny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28252000'),
('28253000', '- Oxidy a hydroxidy vanádu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28253000'),
('28254000', '- Oxidy a hydroxidy niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28254000'),
('28255000', '- Oxidy a hydroxidy medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28255000'),
('28256000', '- Oxidy germánia a oxid zirkoničitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28256000'),
('28257000', '- Oxidy a hydroxidy molybdénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28257000'),
('28258000', '- Oxidy antimónu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28258000'),
('282590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_282590'),
('282590:2X', '-- Oxid, hydroxid a peroxid vápenatý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_282590:2X'),
('28259011', '--- Hydroxid vápenatý s čistotou 98 % alebo viac, počítanou na čistú hmotnosť sušiny, vo forme častíc, z ktorých:- najviac 1 % hmotnosti má veľkosť presahujúcu 75 mikrometrov a- najviac 4 % hmotnosti má veľkosť menej ako 1,3 mikrometra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28259011'),
('28259019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28259019'),
('28259020', '-- Oxid a hydroxid berýlia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28259020'),
('28259040', '-- Oxidy a hydroxidy volfrámu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28259040'),
('28259060', '-- Oxid kadmia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28259060'),
('28259085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28259085'),
('28259085:2X', 'V. SOLI A PEROXOSOLI ANORGANICKÝCH KYSELÍN A KOVOV', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28259085:2X'),
('2826', 'Fluoridy; fluorokremičitany, fluorohlinitany a ostatné komplexné soli fluóru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2826'),
('2826:2X', '- Fluoridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2826:2X'),
('28261200', '-- Hlinitý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28261200'),
('282619', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_282619'),
('28261910', '--- Amónny alebo sodný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28261910'),
('28261990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28261990'),
('28263000', '- Hexafluorohlinitan sodný (syntetický kryolit)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28263000'),
('282690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_282690'),
('28269010', '-- Hexafluorozirkoničitan draselný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28269010'),
('28269080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28269080'),
('2827', 'Chloridy, chlorid-oxidy a chlorid-hydroxidy; bromidy a bromid-oxidy; jodidy a jodid-oxidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2827'),
('28271000', '- Chlorid amónny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28271000'),
('28272000', '- Chlorid vápenatý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28272000'),
('28272000:2X', '- Ostatné chloridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28272000:2X'),
('28273100', '-- Horčíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28273100'),
('28273200', '-- Hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28273200'),
('28273500', '-- Niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28273500'),
('282739', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_282739'),
('28273910', '--- Cínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28273910'),
('28273920', '--- Železa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28273920'),
('28273930', '--- Kobaltu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28273930'),
('28273985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28273985'),
('28273985:2X', '- Chlorid-oxidy a chlorid-hydroxidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28273985:2X'),
('28274100', '-- Medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28274100'),
('282749', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_282749'),
('28274910', '--- Olova', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28274910'),
('28274990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28274990'),
('28274990:2X', '- Bromidy a bromid-oxidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28274990:2X'),
('28275100', '-- Bromidy sodíka alebo draslíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28275100'),
('28275900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28275900'),
('28276000', '- Jodidy a jodid-oxidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28276000'),
('2828', 'Chlórnany; komerčný chlórnan vápenatý; chloritany; brómnany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2828'),
('28281000', '- Komerčný chlórnan vápenatý a ostatné chlórnany vápenaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28281000'),
('28289000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28289000'),
('2829', 'Chlorečnany a chloristany; bromičnany a bromistany; jodičnany a jodistany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2829'),
('2829:2X', '- Chlorečnany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2829:2X'),
('28291100', '-- Sodné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28291100'),
('28291900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28291900'),
('282990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_282990'),
('28299010', '-- Chloristany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28299010'),
('28299040', '-- Bromičnan draselný alebo sodný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28299040'),
('28299080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28299080'),
('2830', 'Sulfidy; polysulfidy, tiež chemicky definované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2830'),
('28301000', '- Sodné sulfidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28301000'),
('283090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_283090'),
('28309011', '-- Sulfidy vápnika, antimónu alebo železa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28309011'),
('28309085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28309085'),
('2831', 'Ditioničitany a sulfoxyláty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2831'),
('28311000', '- Sodíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28311000'),
('28319000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28319000'),
('2832', 'Siričitany; tiosírany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2832'),
('28321000', '- Sodné siričitany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28321000'),
('28322000', '- Ostatné siričitany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28322000'),
('28323000', '- Tiosírany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28323000'),
('2833', 'Sírany; kamence; peroxosírany (persírany)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2833'),
('2833:2X', '- Sírany sodné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2833:2X'),
('28331100', '-- Síran sodný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28331100'),
('28331900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28331900'),
('28331900:2X', '- Ostatné sírany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28331900:2X'),
('28332100', '-- Horčíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28332100'),
('28332200', '-- Hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28332200'),
('28332400', '-- Niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28332400'),
('28332500', '-- Medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28332500'),
('28332700', '-- Bária', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28332700'),
('283329', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_283329'),
('28332920', '--- Kadmia; chrómu; zinku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28332920'),
('28332930', '--- Kobaltu, titánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28332930'),
('28332960', '--- Olova', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28332960'),
('28332980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28332980'),
('28333000', '- Kamence', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28333000'),
('28334000', '- Peroxosírany (persírany)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28334000'),
('2834', 'Dusitany; dusičnany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2834'),
('28341000', '- Dusitany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28341000'),
('28341000:2X', '- Dusičnany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28341000:2X'),
('28342100', '-- Draslíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28342100'),
('283429', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_283429'),
('28342920', '--- Bária; berýlia; kadmia; kobaltu; niklu; olova', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28342920'),
('28342940', '--- Medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28342940'),
('28342980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28342980'),
('2835', 'Fosfornany (hypofosfity), fosforitany (fosfity) a fosforečnany; polyfosforečnany, tiež chemicky definované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2835'),
('28351000', '- Fosfornany (hypofosfity) a fosforitany (fosfity)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28351000'),
('28351000:2X', '- Fosforečnany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28351000:2X'),
('28352200', '-- Mono- alebo disodné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28352200'),
('28352400', '-- Draselné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28352400'),
('28352500', '-- Hydrogénfosforečnan vápenatý (fosfát vápenatý)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28352500'),
('28352600', '-- Ostatné fosforečnany vápnika', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28352600'),
('283529', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_283529'),
('28352910', '--- Triamónne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28352910'),
('28352930', '--- Trisodné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28352930'),
('28352990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28352990'),
('28352990:2X', '- Polyfosforečnany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28352990:2X'),
('28353100', '-- Trifosforečnan sodný (tripolyfosfát sodný)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28353100'),
('28353900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28353900'),
('2836', 'Uhličitany; peroxouhličitany (peruhličitany); komerčný uhličitan amónny obsahujúci karbamát amónny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2836'),
('28362000', '- Uhličitan sodný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28362000'),
('28363000', '- Hydrogénuhličitan sodný (sodium bikarbonát)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28363000'),
('28364000', '- Uhličitany draselné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28364000'),
('28365000', '- Uhličitan vápenatý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28365000'),
('28366000', '- Uhličitan bárnatý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28366000'),
('28366000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28366000:2X'),
('28369100', '-- Uhličitany lítia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28369100'),
('28369200', '-- Uhličitan strontnatý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28369200'),
('283699', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_283699'),
('283699:2X', '--- Uhličitany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_283699:2X'),
('28369911', '---- Horčíka; medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28369911'),
('28369917', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28369917'),
('28369990', '--- Peroxouhličitany (peruhličitany)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28369990'),
('2837', 'Kyanidy, kyanid-oxidy a komplexné kyanidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2837'),
('2837:2X', '- Kyanidy a kyanid oxidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2837:2X'),
('28371100', '-- Sodíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28371100'),
('28371900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28371900'),
('28372000', '- Komplexné kyanidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28372000'),
('2839', 'Kremičitany (silikáty); komerčné kremičitany alkalických kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2839'),
('2839:2X', '- Sodíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2839:2X'),
('28391100', '-- Metakremičitany sodné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28391100'),
('28391900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28391900'),
('28399000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28399000'),
('2840', 'Boritany; peroxoboritany (perboritany)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2840'),
('2840:2X', '- Tetraboritan sodný (rafinovaný borax)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2840:2X'),
('28401100', '-- Bezvodý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28401100'),
('284019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284019'),
('28401910', '--- Pentahydrát tetraboritanu sodného', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28401910'),
('28401990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28401990'),
('284020', '- Ostatné boritany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284020'),
('28402010', '-- Boritany sodíka, bezvodé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28402010'),
('28402090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28402090'),
('28403000', '- Peroxoboritany (perboritany)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28403000'),
('2841', 'Soli oxokovových alebo peroxokovových kyselín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2841'),
('28413000', '- Dichróman sodný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28413000'),
('28415000', '- Ostatné chrómany a dichrómany; peroxochrómany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28415000'),
('28415000:2X', '- Manganitany, manganany a manganistany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28415000:2X'),
('28416100', '-- Manganistan draselný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28416100'),
('28416900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28416900'),
('28417000', '- Molybdénany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28417000'),
('28418000', '- Volfrámany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28418000'),
('284190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284190'),
('28419030', '-- Zinočnatany a vanadičnany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28419030'),
('28419085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28419085'),
('2842', 'Ostatné soli anorganických kyselín alebo peroxokyselín (vrátane hlinitokremičitanov, tiež chemicky definovaných), iné ako azidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2842'),
('28421000', '- Podvojné alebo komplexné kremičitany, vrátané hlinitokremičitanov, tiež chemicky definovaných', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28421000'),
('284290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284290'),
('28429010', '-- Soli, podvojné soli alebo komplexné soli kyseliny seleničitej alebo teluričitej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28429010'),
('28429080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28429080'),
('28429080:2X', 'VI. RÔZNE', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28429080:2X'),
('2843', 'Drahé kovy v koloidnom stave; anorganické alebo organické zlúčeniny drahých kovov, tiež chemicky definované; amalgámy drahých kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2843'),
('284310', '- Drahé kovy v koloidnom stave', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284310'),
('28431010', '-- Striebro', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28431010'),
('28431090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28431090'),
('28431090:2X', '- Zlúčeniny striebra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28431090:2X'),
('28432100', '-- Dusičnan strieborný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28432100'),
('28432900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28432900'),
('28433000', '- Zlúčeniny zlata', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_28433000'),
('284390', '- Ostatné zlúčeniny; amalgámy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284390'),
('28439010', '-- Amalgámy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28439010'),
('28439090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_28439090'),
('2844', 'Rádioaktívne chemické prvky a rádioaktívne izotopy (vrátane štiepnych alebo štiepiteľných chemických prvkov a izotopov) a ich zlúčeniny; zmesi a zvyšky obsahujúce tieto produkty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2844'),
('284410', '- Prírodný urán a jeho zlúčeniny; zliatiny, disperzie (vrátane cermetov), keramické výrobky a zmesi obsahujúce prírodný urán alebo zlúčeniny prírodného uránu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284410'),
('284410:2X', '-- Prírodný urán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284410:2X'),
('28441010', '--- Surový; odpad a úlomky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KUR'), 'SK_28441010'),
('28441030', '--- Spracovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KUR'), 'SK_28441030'),
('28441050', '-- Ferourán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KUR'), 'SK_28441050'),
('28441090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KUR'), 'SK_28441090'),
('284420', '- Urán obohatený o U 235 a jeho zlúčeniny; plutónium a jeho zlúčeniny; zliatiny, disperzie (vrátane cermetov), keramické výrobky a zmesi obsahujúce urán obohatený o U 235, plutónium alebo zlúčeniny týchto produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284420'),
('284420:2X', '-- Urán obohatený o U 235 a jeho zlúčeniny; zliatiny, disperzie (vrátane cermetov), keramické výrobky a zmesi obsahujúce urán obohatený o U 235 alebo zlúčeniny týchto produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284420:2X'),
('28442025', '--- Ferourán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GFI'), 'SK_28442025'),
('28442035', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GFI'), 'SK_28442035'),
('28442035:2X', '-- Plutónium a jeho zlúčeniny; zliatiny, disperzie (vrátane cermetov), keramické výrobky a zmesi obsahujúce plutónium alebo zlúčeniny týchto produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28442035:2X'),
('28442035:3X', '--- Zmesi uránu a plutónia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28442035:3X'),
('28442051', '---- Ferourán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GFI'), 'SK_28442051'),
('28442059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GFI'), 'SK_28442059'),
('28442099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GFI'), 'SK_28442099'),
('284430', '- Urán ochudobnený o U 235 a jeho zlúčeniny; tórium a jeho zlúčeniny; zliatiny, disperzie (vrátane cermetov), keramické výrobky a zmesi obsahujúce urán ochudobnený o U 235, tórium alebo zlúčeniny týchto produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284430'),
('284430:2X', '-- Urán ochudobnený o U 235; zliatiny, disperzie (vrátane cermetov), keramické výrobky a zmesi obsahujúce urán ochudobnený o U 235 alebo zlúčeniny tohto produktu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284430:2X'),
('28443011', '--- Cermety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443011'),
('28443019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443019'),
('28443019:2X', '-- Tórium; zliatiny, disperzie (vrátane cermetov), keramické výrobky a zmesi obsahujúce tórium alebo zlúčeniny tohto produktu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443019:2X'),
('28443051', '--- Cermety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443051'),
('28443051:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443051:2X'),
('28443055', '---- Surové; odpad a úlomky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443055'),
('28443055:2X', '---- Spracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443055:2X'),
('28443061', '----- Tyče, prúty, uholníky, tvarovky a profily, drôty, dosky a pásy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443061'),
('28443069', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443069'),
('28443069:2X', '-- Zlúčeniny uránu ochudobneného o U 235 alebo zlúčeniny tória, tiež navzájom zmiešané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443069:2X'),
('28443091', '--- Zlúčeniny tória alebo uránu ochudobneného o U 235, tiež navzájom zmiešané , iné ako tóriové soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443091'),
('28443099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28443099'),
('284440', '- Rádioaktívne prvky a izotopy a zlúčeniny, iné ako podpoložiek 2844 10, 2844 20 alebo 2844 30; zliatiny, disperzie (vrátane cermetov), keramické výrobky a zmesi obsahujúce tieto prvky, izotopy alebo zlúčeniny; rádioaktívne zvyšky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284440'),
('28444010', '-- Urán získaný z U 233 a jeho zlúčeniny; zliatiny, disperzie (vrátane cermetov), keramické výrobky a zmesi a zlúčeniny získané z U 233 alebo zlúčeniny tohto produktu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28444010'),
('28444010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28444010:2X'),
('28444020', '--- Umelé rádioaktívne izotopy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28444020'),
('28444030', '--- Zlúčeniny umelých rádioaktívnych izotopov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28444030'),
('28444080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28444080'),
('28445000', '- Vyhorené (vyžiarené) palivové články (kazety) jadrových reaktorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GFI'), 'SK_28445000'),
('2845', 'Izotopy, iné ako položky 2844; ich anorganické alebo organické zlúčeniny, tiež chemicky definované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2845'),
('28451000', '- Ťažká voda (oxid deutéria)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28451000'),
('284590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284590'),
('28459010', '-- Deutérium a jeho zlúčeniny; vodík a jeho zlúčeniny, obohatené deutériom; zmesi a roztoky obsahujúce tieto produkty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28459010'),
('28459090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28459090'),
('2846', 'Anorganické alebo organické zlúčeniny kovov vzácnych zemín, ytria alebo skandia alebo zmesi týchto kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2846'),
('28461000', '- Zlúčeniny céru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28461000'),
('28469000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28469000'),
('28470000', 'Peroxid vodíka, tiež stužený močovinou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNS'), 'SK_28470000'),
('28480000', 'Fosfidy, tiež chemicky definované, okrem ferofosforu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28480000'),
('2849', 'Karbidy, tiež chemicky definované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2849'),
('28491000', '- Vápnika', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28491000'),
('28492000', '- Kremíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28492000'),
('284990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_284990'),
('28499010', '-- Bóru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28499010'),
('28499030', '-- Volfrámu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28499030'),
('28499050', '-- Hliníka; chrómu; molybdénu; vanádu; tantalu; titánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28499050'),
('28499090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28499090'),
('285000', 'Hydridy, nitridy, azidy, silicidy a boridy, tiež chemicky definované, iné ako zlúčeniny, ktoré sú tiež karbidmi položky 2849', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_285000'),
('28500020', '- Hydridy; nitridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28500020'),
('28500060', '- Azidy; silicidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28500060'),
('28500090', '- Boridy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28500090'),
('2852', 'Anorganické alebo organické zlúčeniny ortute, tiež chemicky definované, okrem amalgámov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2852'),
('28521000', '- Chemicky definované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28521000'),
('28529000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28529000'),
('285300', 'Ostatné anorganické zlúčeniny (vrátane destilovanej vody alebo vodivostnej vody a vody podobnej čistoty); kvapalný vzduch (tiež po odstránení vzácnych plynov); stlačený vzduch; amalgámy, iné ako amalgámy vzácnych kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_285300'),
('28530010', '- Destilovaná a vodivostná voda a voda podobnej čistoty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28530010'),
('28530030', '- Kvapalný vzduch (tiež po odstránení vzácnych plynov); stlačený vzduch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28530030'),
('28530050', '- Chlórkyán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28530050'),
('28530090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28530090'),
('28530090:2X', 'I. UHĽOVODÍKY A ICH HALOGÉN-, SULFO-, NITRO- ALEBO NITRÓZODERIVÁTY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_28530090:2X'),
('2901', 'Acyklické uhľovodíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2901'),
('29011000', '- Nasýtené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29011000'),
('29011000:2X', '- Nenasýtené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29011000:2X'),
('29012100', '-- Etylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29012100'),
('29012200', '-- Propén (propylén)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29012200'),
('29012300', '-- Butén (butylén) a jeho izoméry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29012300'),
('29012400', '-- 1,3-butadién a izopropén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29012400'),
('29012900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29012900'),
('2902', 'Cyklické uhľovodíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2902'),
('2902:2X', '- Cykloalkány, cykloalkény a cykloterpény', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2902:2X'),
('29021100', '-- Cyklohexán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29021100'),
('29021900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29021900'),
('29022000', '- Benzén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29022000'),
('29023000', '- Toluén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29023000'),
('29023000:2X', '- Xylény', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29023000:2X'),
('29024100', '-- o-xylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29024100'),
('29024200', '-- m-xylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29024200'),
('29024300', '-- p-xylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29024300'),
('29024400', '-- Zmesi izomérov xylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29024400'),
('29025000', '- Styrén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29025000'),
('29026000', '- Etylbenzén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29026000'),
('29027000', '- Kumén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29027000'),
('29029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29029000'),
('2903', 'Halogénderiváty uhľovodíkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2903'),
('2903:2X', '- Nasýtené chlórderiváty acyklických uhľovodíkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2903:2X'),
('29031100', '-- Chlórometán (metylchlorid) a chlóretán (etylchlorid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29031100'),
('29031200', '-- Dichlórometán (metylénchlorid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29031200'),
('29031300', '-- Chloroform (trichlórmetán)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29031300'),
('29031400', '-- Tetrachlórmetán (chlorid uhličitý)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29031400'),
('29031500', '-- Etyléndichlorid (ISO) (1,2-dichlóretán)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29031500'),
('290319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290319'),
('29031910', '--- 1,1,1-trichlóretán (metylchloroform)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29031910'),
('29031980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29031980'),
('29031980:2X', '- Nenasýtené chlórderiváty acyklických uhľovodíkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29031980:2X'),
('29032100', '-- Vinylchlorid (chlóretylén)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29032100'),
('29032200', '-- Trichlóretylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29032200'),
('29032300', '-- Tetrachlóretylén (perchlóretylén)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29032300'),
('29032900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29032900'),
('29032900:2X', '- Fluórderiváty, brómderiváty alebo jódderiváty acyklických uhľovodíkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29032900:2X'),
('29033100', '-- Etyléndibromid (ISO) (1,2-dibrómetán)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29033100'),
('290339', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290339'),
('290339:2X', '--- Bromidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290339:2X'),
('29033911', '---- Brómmetán (metylbromid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29033911'),
('29033915', '---- Dibrómmetán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29033915'),
('29033919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29033919'),
('29033990', '--- Fluoridy a jodidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29033990'),
('29033990:2X', '- Halogénderiváty acyklických uhľovodíkov obsahujúce dva alebo viac rôzných halogénov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29033990:2X'),
('29037100', '-- Difluórchlórmetán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037100'),
('29037200', '-- Trifluórdichlóretány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037200'),
('29037300', '-- Fluórdichlóretány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037300'),
('29037400', '-- Difluórchlóretány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037400'),
('29037500', '-- Pentafluórdichlórpropány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037500'),
('290376', '-- Brómdifluórchlórmetán, brómtrifluórmetán a dibrómtetrafluóretány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290376'),
('29037610', '--- Brómchlórdifluórmetán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037610'),
('29037620', '--- Brómtrifluórmetán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037620'),
('29037690', '--- Dibrómtetrafluóretány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037690'),
('290377', '-- Ostatné, perhalogénované iba fluórom a chlórom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290377'),
('29037710', '--- Trichlórfluórmetán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037710'),
('29037720', '--- Dichlórdifluórmetán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037720'),
('29037730', '--- Trichlórtrifluóretány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037730'),
('29037740', '--- Dichlórtetrafluóretány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037740'),
('29037750', '--- Chlórpentafluóretán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037750'),
('29037790', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037790'),
('29037800', '-- Ostatné perhalogénované deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037800'),
('290379', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290379'),
('290379:2X', '--- Halogénované iba s fluórom a chlórom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290379:2X'),
('29037911', '---- Metánu, etánu alebo propánu (HCFC)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037911'),
('29037919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037919'),
('29037919:2X', '--- Halogénované iba s fluórom a brómom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037919:2X'),
('29037921', '---- Metánu, etánu alebo propánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037921'),
('29037929', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037929'),
('29037990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037990'),
('29037990:2X', '- Halogénderiváty cykloalkanických, cykloalkenických alebo cykloterpenických uhľovodíkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29037990:2X'),
('29038100', '-- 1,2,3,4,5,6-hexachlórcyklohexán (HCH (ISO)), vrátane lindánu (ISO, INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29038100'),
('29038200', '-- Aldrín (ISO), chlórdan (ISO) a heptachlór (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29038200'),
('290389', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290389'),
('29038910', '--- 1,2-dibróm-4-(1,2-dibrómetyl)cyklohexán; tetrabrómcyklooktány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29038910'),
('29038990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29038990'),
('29038990:2X', '- Halogénderiváty aromatických uhľovodíkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29038990:2X'),
('29039100', '-- Chlórbenzén, o-dichlórbenzén a p-dichlórbenzén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29039100'),
('29039200', '-- Hexachlórbenzén (ISO) a DDT (ISO) (klofenotán (INN), 1,1,1-trichlór-2,2-bis(p-chlórfenyl)etán)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29039200'),
('290399', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290399'),
('29039910', '--- 2,3,4,5,6-pentabrómetylbenzén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29039910'),
('29039990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29039990'),
('2904', 'Sulfo-, nitro-, alebo nitrózoderiváty uhľovodíkov, tiež halogénované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2904'),
('29041000', '- Deriváty obsahujúce len sulfoskupiny, ich soli a etylestery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29041000'),
('29042000', '- Deriváty obsahujúce len nitro- alebo len nitrózo skupiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29042000'),
('290490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290490'),
('29049040', '-- Trichlórnitrometán (chlórpikrin)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29049040'),
('29049095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29049095'),
('29049095:2X', 'II. ALKOHOLY A ICH HALOGÉN-, SULFO-, NITRO- ALEBO NITRÓZODERIVÁTY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29049095:2X'),
('2905', 'Acyklické alkoholy a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2905'),
('2905:2X', '- Nasýtené jednosýtne alkoholy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2905:2X'),
('29051100', '-- Metanol (metylalkohol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051100'),
('29051200', '-- 1-propanol (propylalkohol) a 2-propanol (izopropylalkohol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051200'),
('29051300', '-- 1-butanol (n-butylalkohol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051300'),
('290514', '-- Ostatné butanoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290514'),
('29051410', '--- 2-metyl-2-propanol (terc-butylalkohol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051410'),
('29051490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051490'),
('290516', '-- Oktanol (oktylalkohol) a jeho izoméry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290516'),
('29051620', '--- 2-oktanol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051620'),
('29051685', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051685'),
('29051700', '-- 1-dodekanol (laurylalkohol), 1-hexadekanol (cetylalkohol) a 1-oktadekanol (stearylalkohol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051700'),
('29051900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051900'),
('29051900:2X', '- Nenasýtené jednosýtne alkoholy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29051900:2X'),
('29052200', '-- Acyklické terpenické alkoholy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29052200'),
('290529', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290529'),
('29052910', '--- Alylalkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29052910'),
('29052990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29052990'),
('29052990:2X', '- Dioly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29052990:2X'),
('29053100', '-- Etylénglykol (etándiol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29053100'),
('29053200', '-- Propylénglykol (1,2-propándiol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29053200'),
('290539', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290539'),
('29053920', '--- 1,3-butándiol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29053920'),
('29053925', '--- 1,4-butándiol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29053925'),
('29053930', '--- 2,4,7,9-tetrametyldek-5-yn-4,7-diol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29053930'),
('29053995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29053995'),
('29053995:2X', '- Ostatné viacsýtne alkoholy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29053995:2X'),
('29054100', '-- 2-etyl-2-(hydroxymetyl)-1,3-propándiol (trimetylolpropán)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054100'),
('29054200', '-- Pentaerytritol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054200'),
('29054300', '-- Manitol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054300'),
('290544', '-- D-glucitol (sorbitol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290544'),
('290544:2X', '--- Vo vodnom roztoku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290544:2X'),
('29054411', '---- S obsahom D-manitolu 2 % hmotnosti alebo menej, počítaným na obsah D-glucitolu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054411'),
('29054419', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054419'),
('29054419:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054419:2X'),
('29054491', '---- S obsahom D-manitolu 2 % hmotnosti alebo menej, počítaným na obsah D-glucitolu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054491'),
('29054499', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054499'),
('29054500', '-- Glycerol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054500'),
('29054900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054900'),
('29054900:2X', '- Halogén-, sulfo-, nitro- alebo nitrózoderiváty acyklických alkoholov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29054900:2X'),
('29055100', '-- Etchlórvynol (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29055100'),
('290559', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290559'),
('29055991', '--- 2,2-bis(brómmetyl)propándiol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29055991'),
('29055998', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29055998'),
('2906', 'Cyklické alkoholy a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2906'),
('2906:2X', '- Cykloalkanické, cykloalkenické alebo cykloterpenické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2906:2X'),
('29061100', '-- Mentol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29061100'),
('29061200', '-- Cyklohexanol, metylcyklohexanoly a dimetylcyklohexanoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29061200'),
('290613', '-- Steroly a inozitoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290613'),
('29061310', '--- Steroly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29061310'),
('29061390', '--- Inozitoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29061390'),
('29061900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29061900'),
('29061900:2X', '- Aromatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29061900:2X'),
('29062100', '-- Benzylalkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29062100'),
('29062900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29062900'),
('29062900:2X', 'III. FENOLY, FENOLALKOHOLY A ICH HALOGÉN-, SULFO-, NITRO- ALEBO NITRÓZODERIVÁTY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29062900:2X'),
('2907', 'Fenoly; fenolalkoholy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2907'),
('2907:2X', '- Monofenoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2907:2X'),
('29071100', '-- Fenol (hydroxybenzén) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29071100'),
('29071200', '-- Kreozoly a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29071200'),
('29071300', '-- Oktylfenol, nonylfenol a ich izoméry; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29071300'),
('290715', '-- Naftoly a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290715'),
('29071510', '--- 1-naftol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29071510'),
('29071590', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29071590'),
('290719', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290719'),
('29071910', '--- Xylenoly a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29071910'),
('29071990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29071990'),
('29071990:2X', '- Polyfenoly; fenolalkoholy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29071990:2X'),
('29072100', '-- Rezorcinol a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29072100'),
('29072200', '-- Hydrochinón (chinol) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29072200'),
('29072300', '-- 4,4''-izopropylidéndifenol (bisfenol A, difenylolpropán) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29072300'),
('29072900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29072900'),
('2908', 'Halogén-, sulfo-, nitro- alebo nitrózoderiváty fenolov alebo fenolalkoholov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2908'),
('2908:2X', '- Deriváty obsahujúce len halogénové substituenty a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2908:2X'),
('29081100', '-- Pentachlórfenol (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29081100'),
('29081900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29081900'),
('29081900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29081900:2X'),
('29089100', '-- Dinoseb (ISO) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29089100'),
('29089200', '-- 4,6-dinitro-o-krezol (DNOC (ISO)) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29089200'),
('29089900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29089900'),
('29089900:2X', 'IV. ÉTERY, ALKOHOLPEROXIDY, ÉTERPEROXIDY, KETOPEROXIDY, EPOXIDY S TROJČLENNÝM KRUHOM, ACETÁLY A POLOACETÁLY, A ICH HALOGÉN-, SULFO-, NITRO- ALEBO NITRÓZODERIVÁTY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29089900:2X'),
('2909', 'Étery, éteralkoholy, éterfenoly, éteralkoholfenoly, alkoholperoxidy, éterperoxidy, ketoperoxidy (tiež chemicky definované), a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2909'),
('2909:2X', '- Acyklické étery a ich halogén, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2909:2X'),
('29091100', '-- Dietyléter', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29091100'),
('290919', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290919'),
('29091910', '--- Terc-butyletyléter (etyl-terc-butyléter= ETBE)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29091910'),
('29091990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29091990'),
('29092000', '- Cykloalkanické, cykloalkenické alebo cykloterpenické étery a ich halogén, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29092000'),
('290930', '- Aromatické étery a ich halogén, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290930'),
('29093010', '-- Difenyléter', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29093010'),
('29093010:2X', '-- Deriváty halogenované len brómom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29093010:2X'),
('29093031', '--- Pentabrómdifenyléter; 1,2,4,5-tetrabróm-3,6-bis(pentabrómfenoxy)benzén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29093031'),
('29093035', '--- 1,2-bis(2,4,6-tribrómfenoxy)etán na výrobu akrylonitrilbutadiénstyrénu (ABS)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29093035'),
('29093038', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29093038'),
('29093090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29093090'),
('29093090:2X', '- Éteralkoholy a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29093090:2X'),
('29094100', '-- 2,2''-oxydietanol (dietylénglykol, digol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29094100'),
('29094300', '-- Monobutylétery etylénglykolu alebo dietylénglykolu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29094300'),
('29094400', '-- Ostatné monoalkylétery etylénglykolu alebo dietylénglykolu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29094400'),
('290949', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_290949'),
('29094911', '--- 2-(2-chlóretoxy)etanol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29094911'),
('29094980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29094980'),
('29095000', '- Éterfenoly, éteralkoholfenoly a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29095000'),
('29096000', '- Alkoholperoxidy, éterperoxidy, ketoperoxidy a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29096000'),
('2910', 'Epoxidy, epoxyalkoholy, epoxyfenoly a epoxyétery, s trojčlenným kruhom a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2910'),
('29101000', '- Oxirán (etylénoxid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29101000'),
('29102000', '- Metyloxirán (propylénoxid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29102000'),
('29103000', '- 1-chlór-2,3-epoxypropán (epichlórhydrín)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29103000'),
('29104000', '- Dieldrín (ISO, INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29104000'),
('29109000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29109000'),
('29110000', 'Acetály a poloacetály (hemiacetály), tiež s ďaľšou kyslíkatou funkciou, a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29110000'),
('29110000:2X', 'V. ZLÚČENINY S ALDEHYDOVOU FUNKCIOU', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29110000:2X'),
('2912', 'Aldehydy, tiež s ďalšou kyslíkatou funkciou; cyklické polyméry aldehydov; paraformaldehyd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2912'),
('2912:2X', '- Acyklické aldehydy bez ďalšej kyslíkatej funkcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2912:2X'),
('29121100', '-- Metanal (formaldehyd)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29121100'),
('29121200', '-- Etanal (acetaldehyd)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29121200'),
('29121900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29121900'),
('29121900:2X', '- Cyklické aldehydy bez ďalšej kyslíkatej funkcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29121900:2X'),
('29122100', '-- Benzaldehyd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29122100'),
('29122900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29122900'),
('29122900:2X', '- Aldehydalkoholy, aldehydétery, aldehydfenoly a aldehydy s inou kyslíkatou funkčnou skupinou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29122900:2X'),
('29124100', '-- Vanilín (4-hydroxy-3-metoxybenzaldehyd)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29124100'),
('29124200', '-- Etylvanilín (3-etoxy-4-hydroxybenzaldehyd)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29124200'),
('29124900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29124900'),
('29125000', '- Cyklické polyméry aldehydov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29125000'),
('29126000', '- Paraformaldehyd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29126000'),
('29130000', 'Halogén-, sulfo-, nitro- alebo nitrózoderiváty výrobkov položky 2912', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29130000'),
('29130000:2X', 'VI. ZLÚČENINY S KETÓNOVOU FUNKCIOU A ZLÚČENINY S CHINÓNOVOU FUNKCIOU', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29130000:2X'),
('2914', 'Ketóny a chinóny, tiež s ďaľšou kyslíkatou funkciou, a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2914'),
('2914:2X', '- Acyklické ketóny bez ďaľšej kyslíkatej funkcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2914:2X'),
('29141100', '-- Acetón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29141100'),
('29141200', '-- Butanón (metyletylketón)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29141200'),
('29141300', '-- 4-metyl-2-pentanón (metylizobutylketón)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29141300'),
('291419', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291419'),
('29141910', '--- 5-metyl-2-hexanón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29141910'),
('29141990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29141990'),
('29141990:2X', '- Cykloalkanické, cykloalkenické alebo cykloterpenické ketóny bez ďaľšej kyslíkatej funkcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29141990:2X'),
('29142200', '-- Cyklohexanón a metylcyklohexanóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29142200'),
('29142300', '-- Ionóny a metylionóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29142300'),
('29142900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29142900'),
('29142900:2X', '- Aromatické ketóny bez ďaľšej kyslíkatej funkcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29142900:2X'),
('29143100', '-- Fenylacetón (fenyl-2-propánón)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29143100'),
('29143900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29143900'),
('291440', '- Keto-alkoholy a keto-aldehydy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291440'),
('29144010', '-- 4-hydroxy-4-metyl-2-pentanón (diacetónalkohol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29144010'),
('29144090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29144090'),
('29145000', '- Keto-fenoly a ketóny s ďaľšou kyslíkatou funkciou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29145000'),
('29145000:2X', '- Chinóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29145000:2X'),
('29146100', '-- Antrachinón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29146100'),
('291469', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291469'),
('29146910', '--- 1,4-naftochinón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29146910'),
('29146990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29146990'),
('29147000', '- Halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29147000'),
('29147000:2X', 'VII. KARBOXYLOVÉ KYSELINY A ICH ANHYDRIDY, HALOGENIDY, PEROXIDY A PEROXOKYSELINY, A ICH HALOGÉN-, SULFO-, NITRO- ALEBO NITRÓZODERIVÁTY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29147000:2X'),
('2915', 'Nasýtené acyklické monokarboxylové kyseliny a ich anhydridy, halogenidy, peroxidy a peroxokyseliny; ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2915'),
('2915:2X', '- Kyselina mravčia a jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2915:2X'),
('29151100', '-- Kyselina mravčia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29151100'),
('29151200', '-- Soli kyseliny mravčej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29151200'),
('29151300', '-- Estery kyseliny mravčej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29151300'),
('29151300:2X', '- Kyselina octová a jej soli; acetanhydrid', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29151300:2X'),
('29152100', '-- Kyselina octová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29152100'),
('29152400', '-- Acetanhydrid', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29152400'),
('29152900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29152900'),
('29152900:2X', '- Estery kyseliny octovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29152900:2X'),
('29153100', '-- Etylacetát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29153100'),
('29153200', '-- Vinylacetát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29153200'),
('29153300', '-- n-butylacetát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29153300'),
('29153600', '-- Dinosebacetát (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29153600'),
('29153900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29153900'),
('29154000', '- Mono-, di- alebo trichlóroctové kyseliny, ich soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29154000'),
('29155000', '- Kyselina propánová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29155000'),
('291560', '- Kyseliny butánové, kyseliny pentánové, ich soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291560'),
('291560:2X', '-- Kyseliny butánové, ich soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291560:2X'),
('29156011', '--- 1-izopropyl-2,2-dimetyltrimetylén diizobutyrát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29156011'),
('29156019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29156019'),
('29156090', '-- Kyseliny pentánové a ich soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29156090'),
('291570', '- Kyselina palmitová, kyselina stearová, ich soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291570'),
('29157040', '-- Kyselina palmitová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29157040'),
('29157050', '-- Kyselina stearová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29157050'),
('291590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291590'),
('29159030', '-- Kyselina laurová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29159030'),
('29159070', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29159070'),
('2916', 'Nenasýtené acyklické monokarboxylové kyseliny, cyklické monokarboxylové kyseliny, ich anhydridy, halogenidy, peroxidy a peroxokyseliny; ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2916'),
('2916:2X', '- Nenasýtené acyklické monokarboxylové kyseliny, ich anhydridy, halogenidy, peroxidy a peroxokyseliny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2916:2X'),
('29161100', '-- Kyselina akrylová a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29161100'),
('29161200', '-- Estery kyseliny akrylovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29161200'),
('29161300', '-- Kyselina metakrylová a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29161300'),
('29161400', '-- Estery kyseliny metakrylovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29161400'),
('29161500', '-- Kyselina olejová, linolová alebo linolénová, ich soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29161500'),
('29161600', '-- Binapakryl (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29161600'),
('291619', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291619'),
('29161910', '--- Kyseliny undekánové a ich soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29161910'),
('29161940', '--- Kyselina krotónová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29161940'),
('29161995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29161995'),
('29162000', '- Cykloalkanické, cykloalkenické alebo cykloterpenické monokarboxylové kyseliny, ich anhydridy, halogenidy, peroxidy a peroxokyseliny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29162000'),
('29162000:2X', '- Aromatické monokarboxylové kyseliny, ich anhydridy, halogenidy, peroxidy a peroxokyseliny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29162000:2X'),
('29163100', '-- Kyselina benzoová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29163100'),
('29163200', '-- Benzoylperoxid a benzoylchlorid', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29163200'),
('29163400', '-- Kyselina fenyloctová a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29163400'),
('291639', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291639'),
('29163910', '--- Estery kyseliny fenyloctovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29163910'),
('29163990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29163990'),
('2917', 'Polykarboxylové kyseliny, ich anhydridy, halogenidy, peroxidy a peroxokyseliny; ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2917'),
('2917:2X', '- Acyklické polykarboxylové kyseliny, ich anhydridy, halogenidy, peroxidy a peroxokyseliny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2917:2X'),
('29171100', '-- Kyselina šťaveľová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29171100'),
('29171200', '-- Kyselina adipová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29171200'),
('291713', '-- Kyselina azelaová, kyselina sebaková, ich soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291713'),
('29171310', '--- Kyselina sebaková', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29171310'),
('29171390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29171390'),
('29171400', '-- Anhydrid kyseliny maleínovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29171400'),
('291719', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291719'),
('29171910', '--- Kyselina malonová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29171910'),
('29171990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29171990'),
('29172000', '- Cykloalkanické, cykloalkenické alebo cykloterpenické polykarboxylové kyseliny, ich anhydridy, halogenidy, peroxidy a peroxokyseliny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29172000'),
('29172000:2X', '- Aromatické polykarboxylové kyseliny, ich anhydridy, halogenidy, peroxidy a peroxokyseliny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29172000:2X'),
('29173200', '-- Dioktylortoftaláty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29173200'),
('29173300', '-- Dinonyl alebo didecylortoftaláty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29173300'),
('29173400', '-- Ostatné estery kyseliny ortoftalovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29173400'),
('29173500', '-- Anhydrid kyseliny ftalovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29173500'),
('29173600', '-- Kyselina tereftalová a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29173600'),
('29173700', '-- Dimetyltereftalát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29173700'),
('291739', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291739'),
('29173920', '--- Estery alebo anhydrid kyseliny tetrabrómftalovej; kyselina benzén-1,2,4-trikarboxylová; izoftaloyl dichlorid obsahujúci v hmotnosti 0,8 % alebo menej tetraftaloyl dichloridu; kyselina naftalén-1,4,5,8-tetrakarboxylová; anhydrid kyseliny tetrachlórfta', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29173920'),
('29173995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29173995'),
('2918', 'Karboxylové kyseliny s pridanou kyslíkatou funkciou a ich anhydridy, halogenidy, peroxidy a peroxokyseliny; ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2918'),
('2918:2X', '- Karboxylové kyseliny s alkoholovou funkciou, ale bez ďaľšej kyslíkatej funkcie, ich anhydridy, halogenidy, peroxidy a peroxokyseliny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2918:2X'),
('29181100', '-- Kyselina mliečna, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181100'),
('29181200', '-- Kyselina vínna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181200'),
('29181300', '-- Soli a estery kyseliny vínnej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181300'),
('29181400', '-- Kyselina citrónová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181400'),
('29181500', '-- Soli a estery kyseliny citrónovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181500'),
('29181600', '-- Kyselina glukónová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181600'),
('29181800', '-- Chlórbenzilát (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181800'),
('291819', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291819'),
('29181930', '--- Kyselina cholová, 3-alfa,12-alfa-dihydroxy-5-beta-24-cholanová (kyselina deoxycholová), ich soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181930'),
('29181940', '--- Kyselina 2,2-bis(hydroxymetyl)-propánová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181940'),
('29181950', '--- Kyselina 2,2-difenyl-2-hydroxyoctová (kyselina benzylová)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181950'),
('29181998', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181998'),
('29181998:2X', '- Karboxylové kyseliny s fenolovou funkciou, ale bez ďalšej kyslíkatej funkcie, ich anhydridy, halogenidy, peroxidy a peroxokyseliny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29181998:2X'),
('29182100', '-- Kyselina salicylová a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29182100'),
('29182200', '-- Kyselina o-acetylsalicylová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29182200'),
('29182300', '-- Ostatné estery kyseliny salicylovej a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29182300'),
('29182900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29182900'),
('29183000', '- Karboxylové kyseliny s aldehydovou alebo ketonovou funkciou, ale bez ďalšej kyslíkatej funkcie, ich anhydridy, halogenidy, peroxidy a peroxokyseliny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29183000'),
('29183000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29183000:2X'),
('29189100', '-- 2,4,5-T (kyselina 2,4,5-trichlórfenoxyoctová) (ISO), jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29189100'),
('291899', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_291899'),
('29189940', '--- Kyselina 2,6-dimetoxybenzoová; dicamba (ISO); fenoxyacetát sodný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29189940'),
('29189990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29189990'),
('29189990:2X', 'VIII. ESTERY ANORGANICKÝCH KYSELÍN NEKOVOV A ICH SOLI, A ICH HALOGÉN-, SULFO-, NITRO- ALEBO NITRÓZODERIVÁTY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29189990:2X'),
('2919', 'Estery kyseliny fosforečnej a ich soli, vrátane laktofosfátov; ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2919'),
('29191000', '- Tris(2,3-dibrómpropyl) fosfát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29191000'),
('29199000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29199000'),
('2920', 'Estery ostatných anorganických kyselín nekovov (okrem esterov halogénvodíkov) a ich soli; ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2920'),
('2920:2X', '- Estery kyseliny tiofosforečnej (fosfortioáty) a ich soli; ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2920:2X'),
('29201100', '-- Paratión (ISO) a paratiónmetyl (ISO) (metylparatión)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29201100'),
('29201900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29201900'),
('292090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292090'),
('29209010', '-- Estery kyseliny sírovej a estery kyseliny uhličitej a ich soli, ich halogén-, sulfo-, nitro- alebo nitrózoderiváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29209010'),
('29209020', '-- Dimetylfosfonát (dimetyl fosfit)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29209020'),
('29209030', '-- Trimetylfosfit (trimetoxy fosfín)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29209030'),
('29209040', '-- Trietylfosfit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29209040'),
('29209050', '-- Dietylfosfonát (dietylhydrogénfosfit) (dietyl fosfit)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29209050'),
('29209085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29209085'),
('29209085:2X', 'IX. ZLÚČENINY S DUSÍKATOU FUNKCIOU', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29209085:2X'),
('2921', 'Zlúčeniny s amínovou funkciou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2921'),
('2921:2X', '- Acyklické monoamíny a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2921:2X'),
('29211100', '-- Metylamín, di- alebo trimetylamín a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KMA'), 'SK_29211100'),
('292119', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292119'),
('29211940', '--- 1,1,3,3-tetrametylbutylamín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29211940'),
('29211950', '--- Dietylamín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29211950'),
('29211960', '--- 2-(N,N-dietylamino)etyl chlorid-hydrochlorid, 2-(N,N-diizopropylamino)etyl chlorid-hydrochlorid, a 2-(N,N-dimetylamino)etyl chlorid-hydrochlorid', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29211960'),
('29211999', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29211999'),
('29211999:2X', '- Acyklické polyamíny a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29211999:2X'),
('29212100', '-- Etyléndiamín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29212100'),
('29212200', '-- Hexametyléndiamín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29212200'),
('29212900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29212900'),
('292130', '- Cykloalkanické, cykloalkénické alebo cykloterpenické mono- alebo polyamíny, a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292130'),
('29213010', '-- Cyklohexylamín a cyklohexyldimetylamín a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29213010'),
('29213091', '-- 1,3-cyklohexyléndiamín (1,3-diaminocyklohexán)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29213091'),
('29213099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29213099'),
('29213099:2X', '- Aromatické monoamíny a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29213099:2X'),
('29214100', '-- Anilín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29214100'),
('29214200', '-- Deriváty anilínu a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29214200'),
('29214300', '-- Toluidíny a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29214300'),
('29214400', '-- Difenylamín a jeho deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29214400'),
('29214500', '-- 1-naftylamín (alfa-naftylamín), 2-naftylamín (beta-naftylamín) a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29214500'),
('29214600', '-- Amfetamín (INN), benzfetamín (INN), dexamfetamín (INN), etilamfetamín (INN), fenkamfamín (INN), lefetamín (INN), levamfetamín (INN), mefenorex (INN) a fentermín (INN); ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29214600'),
('29214900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29214900'),
('29214900:2X', '- Aromatické polyamíny a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29214900:2X'),
('292151', '-- o-, m-, p-fenyléndiamín, diaminotoluény, a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292151'),
('292151:2X', '--- o-, m-, p-fenyléndiamín, diaminotoluény a ich halogén-, sulfo-, nitro- alebo nitrózoderiváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292151:2X'),
('29215111', '---- m-fenyléndiamín s čistotou v hmotnosti 99 % alebo viac a obsahujúci:- 1 % alebo menej hmotnosti vody,- 200 mg/kg alebo menej o-fenyléndiamínu a- 450 mg/kg alebo menej p-fenyléndiamínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29215111'),
('29215119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29215119'),
('29215190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29215190'),
('292159', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292159'),
('29215950', '--- m-fenylénbismetylamín; 2,2''-dichlór-4,4''-metyléndianilín; 4,4''-bi-o-toluidín; 1,8-naftyléndiamín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29215950'),
('29215990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29215990'),
('2922', 'Aminozlúčeniny s kyslíkatou funkciou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2922'),
('2922:2X', '- Aminoalkoholy, iné ako tie, ktoré obsahujú viac ako jeden druh kyslíkatej funkcie, ich étery a estery; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2922:2X'),
('29221100', '-- Monoetanolamín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221100'),
('29221200', '-- Dietanolamín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221200'),
('292213', '-- Trietanolamín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292213'),
('29221310', '--- Trietanolamín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221310'),
('29221390', '--- Soli trietanolamínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221390'),
('29221400', '-- Dextropropoxyfén (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221400'),
('292219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292219'),
('29221910', '--- N-etyldietanolamín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221910'),
('29221920', '--- 2,2''-metyliminodietanol (N-metyldietanolamín)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221920'),
('29221930', '--- 2-(N,N-diizopropylamino)etanol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221930'),
('29221985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221985'),
('29221985:2X', '- Aminonaftoly a ostatné aminofenoly, iné ako tie, ktoré obsahujú viac ako jeden druh kyslíkatej funkcie, ich étery a estery; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29221985:2X'),
('29222100', '-- Aminohydroxynaftalénsulfónové kyseliny a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29222100'),
('29222900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29222900'),
('29222900:2X', '- Aminoaldehydy, aminoketóny a aminochinóny, iné ako tie, ktoré obsahujú viac ako jeden druh kyslíkatej funkcie; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29222900:2X'),
('29223100', '-- Amfepramón (INN), metadón (INN) a normetadón (INN); ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29223100'),
('29223900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29223900'),
('29223900:2X', '- Aminokyseliny, iné ako tie, ktoré obsahujú viac ako jeden druh kyslíkatej funkcie a ich estery; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29223900:2X'),
('29224100', '-- Lyzín a jeho estery; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29224100'),
('29224200', '-- Kyselina glutamová a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29224200'),
('29224300', '-- Kyselina antranilová a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29224300'),
('29224400', '-- Tilidín (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29224400'),
('292249', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292249'),
('29224920', '--- ß-alanín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29224920'),
('29224985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29224985'),
('29225000', '- Aminoalkoholfenoly, aminokyselinofenoly a ostatné aminozlúčeniny s kyslíkatou funkciou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29225000'),
('2923', 'Kvartérne amónne soli a hydroxidy; lecitíny a ostatné fosfoaminolipidy, tiež chemicky definované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2923'),
('29231000', '- Cholín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29231000'),
('29232000', '- Lecitíny a ostatné fosfoaminolipidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29232000'),
('29239000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29239000'),
('2924', 'Zlúčeniny s karboxyamidovou funkciou; zlúčeniny kyseliny uhličitej s amidovou funkciou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2924'),
('2924:2X', '- Acyklické amidy (vrátane acyklických karbamátov) a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2924:2X'),
('29241100', '-- Meprobamát (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29241100'),
('29241200', '-- Fluóracetamid (ISO), monokrotofos (ISO) a fosfamidón (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29241200'),
('29241900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29241900'),
('29241900:2X', '- Cyklické amidy (vrátane cyklických karbamátov) a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29241900:2X'),
('29242100', '-- Ureíny a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29242100'),
('29242300', '-- Kyselina 2-acetamidobenzoová (kyselina N-acetantranilová) a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29242300'),
('29242400', '-- Etinamát (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29242400'),
('292429', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292429'),
('29242910', '--- Lidokaín (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29242910'),
('29242998', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29242998'),
('2925', 'Zlúčeniny s karboxyimidovou funkciou (vrátane sacharínu a jeho solí) a zlúčeniny s imínovou funkciou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2925'),
('2925:2X', '- Imidy a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2925:2X'),
('29251100', '-- Sacharín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29251100'),
('29251200', '-- Glutetimid (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29251200'),
('292519', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292519'),
('29251920', '--- 3,3'',4,4'',5,5'',6,6''-oktabróm-N,N''-etyléndiftalimid; N,N''-etylénbis(4,5-dibrómhexahydro-3,6-metánftalimid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29251920'),
('29251995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29251995'),
('29251995:2X', '- Imíny a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29251995:2X'),
('29252100', '-- Chlórdimeform (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29252100'),
('29252900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29252900'),
('2926', 'Zlúčeniny s nitrilovou funkciou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2926'),
('29261000', '- Akrylonitril', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29261000'),
('29262000', '- 1-kyanoguanidín (dikyándiamid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29262000'),
('29263000', '- Fenproporex (INN) a jeho soli; medziprodukt metadón (INN) (4-kyano-2-dimetylamino-4,4-difenylbután)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29263000'),
('292690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292690'),
('29269020', '-- Izoftalonitril', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29269020'),
('29269095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29269095'),
('29270000', 'Diazo-, azo- alebo azoxyzlúčeniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29270000'),
('292800', 'Organické deriváty hydrazínu alebo hydroxylamínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_292800'),
('29280010', '- N,N-bis(2-metoxyetyl) hydroxylamín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29280010'),
('29280090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29280090'),
('2929', 'Zlúčeniny s ďalšou dusíkatou funkciou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2929'),
('29291000', '- Izokyanáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29291000'),
('29299000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29299000'),
('29299000:2X', 'X. ORGANO-ANORGANICKÉ ZLÚČENINY, HETEROCYKLICKÉ ZLÚČENINY, NUKLEOVÉ KYSELINY A ICH SOLI, A SULFÓNAMIDY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29299000:2X'),
('2930', 'Organické zlúčeniny síry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2930'),
('29302000', '- Tiokarbamáty a ditiokarbamáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29302000'),
('29303000', '- Tiuram mono-, di- alebo tetrasulfidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29303000'),
('293040', '- Metionín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293040'),
('29304010', '-- Metionín (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29304010'),
('29304090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29304090'),
('29305000', '- Kaptafol (ISO) a metamidofos (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29305000'),
('293090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293090'),
('29309013', '-- Cysteín a cystín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29309013'),
('29309016', '-- Deriváty cysteínu alebo cystínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29309016'),
('29309020', '-- Tiodiglykol (INN) (2,2''-tiodietanol)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29309020'),
('29309030', '-- Kyselina DL-2-hydroxy-4-(metyltio) butánová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29309030'),
('29309040', '-- 2,2''-tiodietylbis[3-(3,5-di-terc-butyl-4-hydroxyfenyl)propionát]', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29309040'),
('29309050', '-- Zmes izomérov zložená 4-metyl-2,6-bis(metyltio)-m-fenyléndiamínu a 2-metyl-4,6-bis(metyltio)-m-fenyléndiamínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29309050'),
('29309060', '-- 2-(N,N-dietylamino)etántiol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29309060'),
('29309099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29309099'),
('2931', 'Ostatné organo-anorganické zlúčeniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2931'),
('29311000', '- Tetrametylolovo a tetraetylolovo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29311000'),
('29312000', '- Zlúčeniny tributylstania', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29312000'),
('293190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293190'),
('29319010', '-- Dimetyl metylfosfonát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29319010'),
('29319020', '-- Metylfosfonyldifluorid (metylfosforitandifluorid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29319020'),
('29319030', '-- Metylfosfonyldichlorid (metylfosforitandichlorid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29319030'),
('29319040', '-- (5-etyl-2-metyl-2-oxido-1,3,2-dioxafosfínan-5-yl)metyl metyl-metylfosfonát; bis[(5-etyl-2-metyl-2-oxido-1,3,2-dioxafosfínan-5-yl)metyl] metylfosfonát; 2,4,6-tripropyl-1,3,5,2,4,6-trioxatrifosfínan 2,4,6-trioxid; dimetyl propylfosfonát; dietyl etylfosf', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29319040'),
('29319090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29319090'),
('2932', 'Heterocyklické zlúčeniny len s kyslíkatým(-i) heteroatómom(-mami)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2932'),
('2932:2X', '- Zlúčeniny obsahujúce v štruktúre nekondenzovaný furánový kruh (tiež hydrogenovaný)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2932:2X'),
('29321100', '-- Tetrahydrofurán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29321100'),
('29321200', '-- 2-furaldehyd (furfural)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29321200'),
('29321300', '-- Furfurylalkohol a tetrahydrofurfurylalkohol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29321300'),
('29321900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29321900'),
('293220', '- Laktóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293220'),
('29322010', '-- Fenolftaleín; Kyselina 1-hydroxy-4-[1-(4-hydroxy-3-metoxykarbonyl-1-naftyl)-3-oxo-1H,3H-benzo[de]izochromén-1-yl]-6-oktadecyloxy-2-naftoová; 3''-chlór-6''-cyklohexylaminospiro[izobenzofurán-1(3H),9''-xantén]-3-ón; 6''-(N-etyl-p-toluidín)-2''-metylspiro[iz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29322010'),
('29322020', '-- gama-Butyrolaktón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29322020'),
('29322090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29322090'),
('29322090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29322090:2X'),
('29329100', '-- Izosafrol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29329100'),
('29329200', '-- 1-(1,3-benzodioxol-5-yl) propán-2-ón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29329200'),
('29329300', '-- Piperonal', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29329300'),
('29329400', '-- Safrol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29329400'),
('29329500', '-- Tetrahydrokannabinoly (všetky izoméry)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29329500'),
('29329900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29329900'),
('2933', 'Heterocyklické zlúčeniny len s dusíkatým(-i) heteroatómom(-mami)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2933'),
('2933:2X', '- Zlúčeniny obsahujúce v štruktúre nekondenzovaný pyrazolový kruh (tiež hydrogenovaný)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2933:2X'),
('293311', '-- Fenazón (antipyrín) a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293311'),
('29331110', '--- Propyfenazón (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29331110'),
('29331190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29331190'),
('293319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293319'),
('29331910', '--- Fenylbutazón (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29331910'),
('29331990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29331990'),
('29331990:2X', '- Zlúčeniny obsahujúce v štruktúre nekondenzovaný imidazolový kruh (tiež hydrogenovaný)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29331990:2X'),
('29332100', '-- Hydantoín a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29332100'),
('293329', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293329'),
('29332910', '--- Nafazolín hydrochlorid (INNM) a nafazolín nitrát (INNM); fentolalmín (INN); tolazolín hydrochlorid (INNM)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29332910'),
('29332990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29332990'),
('29332990:2X', '- Zlúčeniny obsahujúce v štruktúre nekondenzovaný pyridínový kruh (tiež hydrogenovaný)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29332990:2X'),
('29333100', '-- Pyridín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333100'),
('29333200', '-- Pyperidín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333200'),
('29333300', '-- Alfentanil (INN), anileridín (INN), bezitramid (INN), brómazepam (INN), difenoxín (INN), difenoxylát (INN), dipipanón (INN), fentanyl (INN), ketobemidón (INN), metylfenidát (INN), pentazocín (INN), petidín (INN), petidín medziprodukt A (INN), fencykli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333300'),
('293339', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293339'),
('29333910', '--- Iproniazid (INN); ketobemidónhydrochlorid (INNM); pyridostigmínbromid (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333910'),
('29333920', '--- 2,3,5,6-tetrachlórpyridín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333920'),
('29333925', '--- Kyselina 3,6-dichlórpyridín-2-karboxylová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333925'),
('29333935', '--- 2-hydroxyetylamónium-3,6-dichlórpyridín-2-karboxylát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333935'),
('29333940', '--- 2-butoxyetyl(3,5,6-trichlór-2-pyridyloxy) acetát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333940'),
('29333945', '--- 3,5-dichlór-2,4,6-trifluórpyridín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333945'),
('29333950', '--- Fluóroxypyr (ISO), metyl ester', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333950'),
('29333955', '--- 4-metylpyridín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333955'),
('29333999', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333999'),
('29333999:2X', '- Zlúčeniny obsahujúce v štruktúre chinolínový alebo izochinolínový kruhový systém (tiež hydrogenovaný), ďalej nekondenzovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29333999:2X'),
('29334100', '-- Levorfanol (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29334100'),
('293349', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293349'),
('29334910', '--- Halogénderiváty chinolínu; deriváty kyseliny chinolínkarboxylovej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29334910'),
('29334930', '--- Dextrometorfan (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29334930'),
('29334990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29334990'),
('29334990:2X', '- Zlúčeniny obsahujúce v štruktúre pyrimidínový kruh (tiež hydrogenovaný) alebo piperazínový kruh', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29334990:2X'),
('29335200', '-- Malonylmočovina (kyselina barbiturová) a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29335200'),
('293353', '-- Allobarbital (INN), amobarbital (INN), barbital (INN), butalbital (INN), butobarbital, cyklobarbital (INN), metylfenobarbital (INN), pentobarbital (INN), fenobarbital (INN), sekbutabarbital (INN), sekobarbital (INN) a vinylbital (INN); ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293353'),
('29335310', '--- Fenobarbital (INN), barbital (INN) a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29335310'),
('29335390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29335390'),
('29335400', '-- Ostatné deriváty malonylmočoviny (kyseliny barbiturovej); ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29335400'),
('29335500', '-- Loprazolam (INN), mecloqualón (INN), metaqualón (INN) a zipeprol (INN); ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29335500'),
('293359', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293359'),
('29335910', '--- Diazinón (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29335910'),
('29335920', '--- 1,4-diazabicyklo[2.2.2]oktán (trietyléndiamín)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29335920'),
('29335995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29335995'),
('29335995:2X', '- Zlúčeniny obsahujúce v štruktúre nekondenzovaný triazínový kruh (tiež hydrogenovaný)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29335995:2X'),
('29336100', '-- Melamín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29336100'),
('293369', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293369'),
('29336910', '--- Atrazín (ISO); propazín (ISO); simazín (ISO); hexahydro-1,3,5-trinitro-1,3,5-triazín (hexogén, trimetyléntrinitramín)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29336910'),
('29336940', '--- Meténamín (INN) (hexametyléntetramín); 2,6-di-terc-butyl-4-[4,6-bis(oktyltio)-1,3,5-triazín-2-ylamino]fenol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29336940'),
('29336980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29336980'),
('29336980:2X', '- Lactámy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29336980:2X'),
('29337100', '-- 6-hexánlaktám (epsilon-kaprolaktám)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29337100'),
('29337200', '-- Klobazam (INN) a metyprylon (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29337200'),
('29337900', '-- Ostatné laktámy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29337900'),
('29337900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29337900:2X'),
('293391', '-- Alprazolam (INN), kamazepam (INN), chlordiazepoxid (INN), klonazepam (INN), klorazepát, delorazepam (INN), diazepam (INN), estazolam (INN), etyl loflazepát (INN), fludiazepam (INN), flunitrazepam (INN), flurazepam (INN), halazepam (INN), lorazepam (IN', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293391'),
('29339110', '--- Chlórdiazepoxid (INN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29339110'),
('29339190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29339190'),
('293399', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293399'),
('29339920', '--- Indol, 3-metylindol (skatol), 6-alyl-6,7-dihydro-5H-dibenz[c,e]azepin (azapetín), fenindamín (INN) a ich soli; imipramín hydrochlorid (INNM)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29339920'),
('29339950', '--- 2,4-di-terc-butyl-6-(5-chlórbenzotriazol-2-yl)fenol', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29339950'),
('29339980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29339980'),
('2934', 'Kyseliny nukleové a ich soli, tiež chemicky definované; ostatné heterocyklické zlúčeniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2934'),
('29341000', '- Zlúčeniny obsahujúce v štruktúre nekondenzovaný tiazolový kruh (tiež hydrogenovaný)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29341000'),
('293420', '- Zlúčeniny obsahujúce benzotiazolový kruh (tiež hydrogenovaný), ďalej nekondenzovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293420'),
('29342020', '-- Di(benzotiazol-2-yl) disulfid; benzotiazol-2-tiol (merkaptobenzotiazol) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29342020'),
('29342080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29342080'),
('293430', '- Zlúčeniny obsahujúce v štruktúre fenotiazínový kruh (tiež hydrogenovaný), ďalej nekondenzovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293430'),
('29343010', '-- Tietylperazín (INN); tioridazín (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29343010'),
('29343090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29343090'),
('29343090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29343090:2X'),
('29349100', '-- Aminorex (INN), brotizolam (INN), klotiazepam (INN), kloxazolam (INN), dextromoramid (INN), haloxazolam (INN), ketazolam (INN), mezokarb (INN), oxazolam (INN), pemolín (INN), fendimetrazín (INN), fenmetrazín (INN) a sufentanil (INN); ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29349100'),
('293499', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293499'),
('29349960', '--- Chlórprotixén (INN); tenalidín (INN) a jeho vínany a maleínany; furazolidón (INN); kyselina 7-aminocefalosporánová; soli a estery kyseliny (6R,7R)-3-acetoxymetyl-7[(R)-2-formyloxy-2-fenylacetamido)]-8-oxo-5-tia-1-azabicyklo[4.2.0]okt-2-én-2-karboxylo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29349960'),
('29349990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29349990'),
('293500', 'Sulfónamidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293500'),
('29350030', '- 3-{1-[7-hexadecylsulfonylamino)-1H-indol-3-yl]-3-oxo-1H,3H-nafto[1,8-cd]pyrán-1-yl}-N,N-dimetyl-1H-indol-7-sulfonamid; metosulam (ISO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29350030'),
('29350090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29350090'),
('29350090:2X', 'XI. PROVITAMÍNY, VITAMÍNY A HORMÓNY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29350090:2X'),
('2936', 'Provitamíny a vitamíny, prírodné alebo vyrobené syntézou (vrátane prírodných koncentrátov), ich deriváty používané hlavne ako vitamíny, a ich zmesi, tiež v akomkoľvek rozpúšťadle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2936'),
('2936:2X', '- Vitamíny a ich deriváty, nezmiešané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2936:2X'),
('29362100', '-- Vitamín A a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29362100'),
('29362200', '-- Vitamín B1 a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29362200'),
('29362300', '-- Vitamín B2 a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29362300'),
('29362400', '-- Kyselina D- alebo DL-pantoténová (vitamín B3 alebo vitamín B5) a jej deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29362400'),
('29362500', '-- Vitamín B6 a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29362500'),
('29362600', '-- Vitamín B12 a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29362600'),
('29362700', '-- Vitamín C a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29362700'),
('29362800', '-- Vitamín E a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29362800'),
('29362900', '-- Ostatné vitamíny a ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29362900'),
('29369000', '- Ostatné, vrátane prírodných koncentrátov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29369000'),
('2937', 'Hormóny, prostaglandíny, tromboxány a leukotriény, prírodné alebo vyrobené syntézou; ich deriváty a štruktúrne analógy, vrátane reťazovo modifikovaných polypeptidov, používané hlavne ako hormóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2937'),
('2937:2X', '- Polypeptidové hormóny, proteínové hormóny a glykoproteínové hormóny, ich deriváty a štruktúrne analógy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2937:2X'),
('29371100', '-- Somatotropín, jeho deriváty a štruktúrne analógy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_29371100'),
('29371200', '-- Inzulín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_29371200'),
('29371900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_29371900'),
('29371900:2X', '- Steroidné hormóny, ich deriváty a štruktúrlne analógy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29371900:2X'),
('29372100', '-- Kortizón, hydrokortizón, prednizón (dehydrokortizón) a prednizolón (dehydrohydrokortizón)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_29372100'),
('29372200', '-- Halogénderiváty hormónov kôry nadobličiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_29372200'),
('29372300', '-- Estrogény a progestogény', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_29372300'),
('29372900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_29372900'),
('29375000', '- Prostaglandíny, tromboxány a leukotriény, ich deriváty a štruktúrne analógy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_29375000'),
('29379000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_29379000'),
('29379000:2X', 'XII. GLYKOZIDY A RASTLINNÉ ALKALOIDY, PRÍRODNÉ ALEBO VYROBENÉ SYNTÉZOU, A ICH SOLI, ÉTERY, ESTERY A OSTATNÉ DERIVÁTY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29379000:2X'),
('2938', 'Glykozidy, prírodné alebo vyrobené syntézou, a ich soli, étery, estery a ostatné deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2938'),
('29381000', '- Rutín (rutoside) a jeho deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29381000'),
('293890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_293890'),
('29389010', '-- Glykozidy náprstníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29389010'),
('29389030', '-- Kyselina glycyrizínová a glycyrizáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29389030'),
('29389090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29389090'),
('2939', 'Rastlinné alkaloidy, prírodné alebo vyrobené syntézou, a ich soli, étery, estery a ostatné deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2939'),
('2939:2X', '- Alkaloidy ópia a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2939:2X'),
('29391100', '-- Koncentráty z makovej slamy; buprenorfín (INN), kodeín, dihydrokodeín (INN), etylmorfín, etorfín (INN), heroín, hydrokodón (INN), hydromorfón (INN), morfín, nikomorfín (INN), oxykodón (INN), oxymorfón (INN), folkodín (INN), tebakon (INN) a tebaín; ich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29391100'),
('29391900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29391900'),
('29392000', '- Alkaloidy chinínovníka a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29392000'),
('29393000', '- Kofeín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29393000'),
('29393000:2X', '- Efedríny a ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29393000:2X'),
('29394100', '-- Efedrín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29394100'),
('29394200', '-- Pseudoefedrín (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29394200'),
('29394300', '-- Katín (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29394300'),
('29394400', '-- Norefedrín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29394400'),
('29394900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29394900'),
('29394900:2X', '- Teofylín a aminofylín (teofylín-etyléndiamín) a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29394900:2X'),
('29395100', '-- Fenetylín (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29395100'),
('29395900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29395900'),
('29395900:2X', '- Alkaloidy ražového námela a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29395900:2X'),
('29396100', '-- Ergometrín (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29396100'),
('29396200', '-- Ergotamín (INN) a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29396200'),
('29396300', '-- Kyselina lysergová a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29396300'),
('29396900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29396900'),
('29396900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29396900:2X'),
('29399100', '-- Kokaín, ekgonín, levometamfetamín, metamfetamín (INN), metamfetamínový racemát; ich soli, estery a ostatné deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29399100'),
('29399900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29399900'),
('29399900:2X', 'XIII. OSTATNÉ ORGANICKÉ ZLÚČENINY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29399900:2X'),
('29400000', 'Cukry, chemicky čisté, iné ako sacharóza, laktóza, maltóza, glukóza a fruktóza; étery cukrov, acetály cukrov a estery cukrov, a ich soli, iné ako výrobky položiek 2937, 2938 alebo 2939', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29400000'),
('2941', 'Antibiotiká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_2941'),
('29411000', '- Penicilíny a ich deriváty obsahujúce v štruktúre kyselinu penicilánovú; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29411000'),
('294120', '- Streptomycíny a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_294120'),
('29412030', '-- Dihydrostreptomycín, jeho soli, estery a hydráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29412030'),
('29412080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29412080'),
('29413000', '- Tetracyklíny a ich deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29413000'),
('29414000', '- Chlóramfenikol a jeho deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29414000'),
('29415000', '- Erytromycín a jeho deriváty; ich soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29415000'),
('29419000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29419000'),
('29420000', 'Ostatné organické zlúčeniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_29420000'),
('3001', 'Žľazy a ostatné orgány na organoterapeutické účely, sušené, tiež v prášku; výťažky zo žliaz alebo ostatných orgánov alebo z ich výlučkov na organoterapeutické účely; heparín a jeho soli; ostatné ľudské alebo živočíšne látky pripravené na terapeutické al', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3001'),
('300120', '- Výťažky zo žliaz alebo z ostatných orgánov, alebo z ich výlučkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_300120'),
('30012010', '-- Ľudského pôvodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30012010'),
('30012090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30012090'),
('300190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_300190'),
('30019020', '-- Ľudského pôvodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30019020'),
('30019020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30019020:2X'),
('30019091', '--- Heparín a jeho soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30019091'),
('30019098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30019098'),
('3002', 'Ľudská krv; zvieracia krv pripravená na terapeutické, profylaktické alebo diagnostické účely; antiséra a ostatné krvné zložky a imunologické výrobky, tiež modifikované alebo získané biotechnologickými procesmi; očkovacie látky (vakcíny), toxíny, kultúry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3002'),
('300210', '- Antiséra, ostatné krvné zložky a imunologické výrobky, tiež modifikované alebo získané biotechnologickými procesmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_300210'),
('30021010', '-- Antiséra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30021010'),
('30021010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30021010:2X'),
('30021091', '--- Hemoglobín, krvné globulíny a sérové globulíny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30021091'),
('30021091:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30021091:2X'),
('30021095', '---- Ľudského pôvodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30021095'),
('30021099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30021099'),
('30022000', '- Očkovacie látky pre humánne lekárstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30022000'),
('30023000', '- Očkovacie látky pre zverolekárstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30023000'),
('300290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_300290'),
('30029010', '-- Ľudská krv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30029010'),
('30029030', '-- Krv zvierat pripravená na terapeutické, profylaktické alebo diagnostické účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30029030'),
('30029050', '-- Kultúry mikroorganizmov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30029050'),
('30029090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30029090'),
('3003', 'Lieky (okrem tovaru položiek 3002, 3005 alebo 3006) zložené z dvoch alebo viacerých zložiek navzájom zmiešaných na terapeutické alebo profylaktické účely, ktoré nie sú v odmeraných dávkach alebo vo formách alebo baleniach na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3003'),
('30031000', '- Obsahujúce penicilíny alebo ich deriváty so štruktúrou kyseliny penicilánovej, alebo streptomycíny alebo ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30031000'),
('30032000', '- Obsahujúce ostatné antibiotiká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30032000'),
('30032000:2X', '- Obsahujúce hormóny alebo ostatné výrobky položky 2937, ale neobsahujúce antibiotiká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30032000:2X'),
('30033100', '-- Obsahujúce inzulín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30033100'),
('30033900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30033900'),
('30034000', '- Obsahujúce alkaloidy alebo ich deriváty, ale neobsahujúce hormóny alebo ostatné výrobky položky 2937 alebo antibiotiká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30034000'),
('30039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30039000'),
('3004', 'Lieky (okrem tovaru položiek 3002, 3005 alebo 3006) zložené zo zmiešaných alebo nezmiešaných výrobkov na terapeutické alebo profylaktické účely, v odmeraných dávkach (vrátane takých, ktoré sú vo forme systémov na podávanie cez kožu) alebo vo formách, al', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3004'),
('30041000', '- Obsahujúce penicilíny alebo ich deriváty so štruktúrou kyseliny penicilánovej, alebo streptomycíny, alebo ich deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30041000'),
('30042000', '- Obsahujúce ostatné antibiotiká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30042000'),
('30042000:2X', '- Obsahujúce hormóny alebo ostatné výrobky položky 2937, ale neobsahujúce antibiotiká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30042000:2X'),
('30043100', '-- Obsahujúce inzulín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30043100'),
('30043200', '-- Obsahujúce kortikosteroidné hormóny, ich deriváty alebo štruktúrne analógy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30043200'),
('30043900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30043900'),
('30044000', '- Obsahujúce alkaloidy alebo ich deriváty, ale neobsahujúce hormóny, ostatné výrobky položky 2937 alebo antibiotiká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30044000'),
('30045000', '- Ostatné lieky obsahujúce vitamíny alebo ostatné výrobky položky 2936', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30045000'),
('30049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30049000'),
('3005', 'Vata, gáza, ovínadlá a podobný tovar (napríklad obväzy, náplasti, obklady), impregnované alebo potiahnuté farmaceutickými látkami alebo vo formách alebo baleniach na predaj v malom na lekárske, chirurgické, zubolekárske alebo zverolekárske účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3005'),
('30051000', '- Náplasti a ostatný tovar s priľnavou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30051000'),
('300590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_300590'),
('30059010', '-- Vata a tovar z vaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30059010'),
('30059010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30059010:2X'),
('30059010:3X', '--- Z textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30059010:3X'),
('30059031', '---- Gáza a tovar z gázy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30059031'),
('30059050', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30059050'),
('30059099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30059099'),
('3006', 'Farmaceutické výrobky špecifikované v poznámke 4 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3006'),
('300610', '- Sterilný chirurgický katgut, podobný sterilný materiál na zošívanie (vrátane sterilných absorbovateľných nití používaných v chirurgii alebo v zubnom lekárstve) a sterilné tkaninové náplasti používané v chirurgii na uzatváranie rán; sterilné lamináriá a', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_300610'),
('30061010', '-- Sterilný chirurgický katgut', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30061010'),
('30061030', '-- Sterilné prostriedky na zabránenie vzniku zrastov používané v chirurgii alebo v zubnom lekárstve, tiež absorbovateľné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30061030'),
('30061090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30061090'),
('30062000', '- Reagencie na zisťovanie krvných skupín alebo krvných faktorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30062000'),
('30063000', '- Kontrastné prípravky na rőntgenové vyšetrenia; diagnostické reagencie určené na podanie pacientovi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30063000'),
('30064000', '- Zubné cementy a ostatné zubné výplne; kostné rekonštrukčné cementy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30064000'),
('30065000', '- Lekárničky a súpravy prvej pomoci', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30065000'),
('30066000', '- Chemické antikoncepčné prípravky na základe hormónov, ostatných výrobkov položky 2937 alebo spermicídov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30066000'),
('30067000', '- Gélové preparáty navrhnuté na použitie v humánnom alebo veterinárnom lekárstve ako lubrikanty na časti tela pri chirurgických zákrokoch alebo fyzických vyšetreniach alebo ako spojovací prostriedok medzi telom a lekárskym nástrojom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30067000'),
('30067000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30067000:2X'),
('30069100', '-- Pomôcky určené pre použitie pri stómiách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30069100'),
('30069200', '-- Farmaceutický odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_30069200'),
('31010000', 'Živočíšne alebo rastlinné hnojivá, tiež navzájom zmiešané alebo chemicky upravené; hnojivá získané zmiešaním alebo chemickou úpravou živočíšnych alebo rastlinných produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31010000'),
('3102', 'Minerálne alebo chemické hnojivá dusíkaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3102'),
('310210', '- Močovina, tiež vo vodnom roztoku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_310210'),
('31021010', '-- Močovina s obsahom dusíka viac ako 45 % hmotnosti v suchom bezvodom výrobku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31021010'),
('31021090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31021090'),
('31021090:2X', '- Síran amónny; podvojné soli a zmesi síranu amónneho a dusičnanu amónneho', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31021090:2X'),
('31022100', '-- Síran amónny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31022100'),
('31022900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31022900'),
('310230', '- Dusičnan amónny, tiež vo vodnom roztoku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_310230'),
('31023010', '-- Vo vodnom roztoku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31023010'),
('31023090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31023090'),
('310240', '- Zmesi dusičnanu amónneho s uhličitanom vápenatým alebo s ostatnými anorganickými nehnojivými látkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_310240'),
('31024010', '-- S obsahom dusíka nepresahujúcim 28 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31024010'),
('31024090', '-- S obsahom dusíka presahujúcim 28 % hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31024090'),
('310250', '- Dusičnan sodný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_310250'),
('31025010', '-- Prírodný dusičnan sodný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31025010'),
('31025090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31025090'),
('31026000', '- Podvojné soli a zmesi dusičnanu vápenatého a dusičnanu amónneho', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31026000'),
('31028000', '- Zmesi močoviny a dusičnanu amónneho vo vodnom alebo v amoniakálnom roztoku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31028000'),
('31029000', '- Ostatné, vrátane zmesí neuvedených v predchádzajúcich podpoložkách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KNI'), 'SK_31029000'),
('3103', 'Minerálne alebo chemické hnojivá fosforečné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3103'),
('310310', '- Superfosfáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_310310'),
('31031010', '-- Obsahujúce viac ako 35 % hmotnosti oxidu fosforečného', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPP'), 'SK_31031010'),
('31031090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPP'), 'SK_31031090'),
('31039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPP'), 'SK_31039000'),
('3104', 'Minerálne alebo chemické hnojivá draselné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3104'),
('310420', '- Chlorid draselný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_310420'),
('31042010', '-- S obsahom draslíka vyjadreného ako K2O nepresahujúcim 40 % hmotnosti v suchom bezvodom produkte', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPO'), 'SK_31042010'),
('31042050', '-- S obsahom draslíka vyjadreného ako K2O presahujúcim 40 %, ale nepresahujúcim 62 % hmotnosti v suchom bezvodom produkte', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPO'), 'SK_31042050'),
('31042090', '-- S obsahom draslíka vyjadreného ako K2O presahujúcim 62 % hmotnosti v suchom bezvodom produkte', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPO'), 'SK_31042090'),
('31043000', '- Síran draselný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPO'), 'SK_31043000'),
('31049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KPO'), 'SK_31049000'),
('3105', 'Minerálne alebo chemické hnojivá obsahujúce dva alebo tri z hnojivých prvkov dusík, fosfor alebo draslík; ostatné hnojivá; výrobky tejto kapitoly v tabletách alebo podobných formách alebo baleniach s hrubou hmotnosťou nepresahujúcou 10 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3105'),
('31051000', '- Výrobky tejto kapitoly v tabletách alebo podobných formách alebo baleniach s hrubou hmotnosťou nepresahujúcou 10 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31051000'),
('310520', '- Minerálne alebo chemické hnojivá obsahujúce tri hnojivé prvky dusík, fosfor a draslík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_310520'),
('31052010', '-- S obsahom dusíka presahujúcim 10 % hmotnosti v suchom bezvodom produkte', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31052010'),
('31052090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31052090'),
('31053000', '- Hydrogénfosforečnan amónny (fosfát diamónny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31053000'),
('31054000', '- Dihydrogénfosforečnan amónny (fosfát amónny) a jeho zmesi s hydrogénfosforečnanom amónnym (fosfátom diamónnym)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31054000'),
('31054000:2X', '- Ostatné minerálne alebo chemické hnojivá obsahujúce dva hnojivé prvky dusík a fosfor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31054000:2X'),
('31055100', '-- Obsahujúce dusičnany a fosforečnany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31055100'),
('31055900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31055900'),
('31056000', '- Minerálne alebo chemické hnojivá obsahujúce dva hnojivé prvky fosfor a draslík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31056000'),
('310590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_310590'),
('31059010', '-- Prírodný dusičnan sodno-draselný, pozostávajúci z prírodnej zmesi dusičnanu sodného a dusičnanu draselného (podiel dusičnanu draselného môže byť až 44 %) s celkovým obsahom dusíka nepresahujúcim 16,3 % hmotnosti v suchom bezvodom výrobku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31059010'),
('31059010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31059010:2X'),
('31059091', '--- S obsahom dusíka presahujúcim 10 % hmotnosti v suchom bezvodom výrobku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31059091'),
('31059099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_31059099'),
('3201', 'Trieslovinové výťažky rastlinného pôvodu; taníny a ich soli, étery, estery a ostatné deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3201'),
('32011000', '- Kebračový výťažok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32011000'),
('32012000', '- Akáciový výťažok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32012000'),
('320190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_320190'),
('32019020', '-- Výťažok zo sumachu, výťažok z valóniek, dubový výťažok alebo gaštanový výťažok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32019020'),
('32019090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32019090'),
('3202', 'Syntetické organické trieslovinové látky; anorganické trieslovinové látky; trieslovinové prípravky, tiež obsahujúce prírodné trieslovinové látky; enzymatické prípravky na predčinenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3202'),
('32021000', '- Syntetické organické trieslovinové látky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32021000'),
('32029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32029000'),
('320300', 'Farbivá rastlinného alebo živočíšneho pôvodu (vrátane farbiacich výťažkov, ale okrem živočíšnej černe), tiež chemicky definované; prípravky špecifikované poznámkou 3 k tejto kapitole na základe farbiva rastlinného alebo živočíšneho pôvodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_320300'),
('32030010', '- Farbivá rastlinného pôvodu a prípravky na ich základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32030010'),
('32030090', '- Farbivá živočíšneho pôvodu a prípravky na ich základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32030090'),
('3204', 'Syntetické organické farbivá, tiež chemicky definované; prípravky špecifikované poznámkou 3 k tejto kapitole na základe syntetických organických farbív; syntetické organické výrobky používané ako fluorescenčné zjasňovacie prostriedky alebo ako luminofór', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3204'),
('3204:2X', '- Syntetické organické farbivá a prípravky na ich základe, špecifikované poznámkou 3 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3204:2X'),
('32041100', '-- Disperzné farbivá a prípravky na ich základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32041100'),
('32041200', '-- Kyslé farbivá, tiež predmetalizované, a prípravky na ich základe; moridlové farbivá a prípravky na ich základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32041200'),
('32041300', '-- Zásadité farbivá a prípravky na ich základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32041300'),
('32041400', '-- Priame farbivá a prípravky na ich základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32041400'),
('32041500', '-- Kypové farbivá (vrátane farbív využiteľných v tomto stave ako pigmenty) a prípravky na ich základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32041500'),
('32041600', '-- Reaktívne farbivá a prípravky na ich základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32041600'),
('32041700', '-- Pigmenty a prípravky na ich základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32041700'),
('32041900', '-- Ostatné, vrátane zmesí farbív dvoch alebo viacerých podpoložiek 3204 11 až 3204 19', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32041900'),
('32042000', '- Syntetické organické výrobky používané ako fluorescenčné zjasňovacie prostriedky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32042000'),
('32049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32049000'),
('32050000', 'Farebné laky; prípravky špecifikované poznámkou 3 k tejto kapitole na základe farebných lakov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32050000'),
('3206', 'Ostatné farbivá; prípravky špecifikované poznámkou 3 k tejto kapitole, iné ako položiek 3203, 3204 alebo 3205; anorganické výrobky druhov používaných ako luminofóry, tiež chemicky definované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3206'),
('3206:2X', '- Pigmenty a prípravky na základe oxidu titaničitého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3206:2X'),
('32061100', '-- Obsahujúce 80 % hmotnosti alebo viac oxidu titaničitého, počítaného na suchú hmotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32061100'),
('32061900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32061900'),
('32062000', '- Pigmenty a prípravky na základe zlúčenín chrómu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32062000'),
('32062000:2X', '- Ostatné farbivá a ostatné prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32062000:2X'),
('32064100', '-- Ultramarín a prípravky na jeho základe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32064100'),
('32064200', '-- Litopón a ostatné pigmenty a prípravky na základe sulfidu zinočnatého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32064200'),
('320649', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_320649'),
('32064910', '--- Magnetit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32064910'),
('32064970', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32064970'),
('32065000', '- Anorganické výrobky druhov používaných ako luminofóry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32065000'),
('3207', 'Pripravené pigmenty, pripravené kalivá a pripravené farby, sklotvorné emaily (smalty) a glazúry, engoby, tekuté listre a podobné prípravky používané v keramickom priemysle, smaltovniach alebo sklárňach; sklenené frity a ostatné sklo vo forme prášku, gra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3207'),
('32071000', '- Pripravené pigmenty, pripravené kalivá a pripravené farby a podobné prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32071000'),
('320720', '- Sklotvorné emaily (smalty) a glazúry, engoby a podobné prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_320720'),
('32072010', '-- Engoby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32072010'),
('32072090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32072090'),
('32073000', '- Tekuté listre a podobné prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32073000'),
('320740', '- Sklenené frity a ostatné sklo vo forme prášku, granúl alebo šupiniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_320740'),
('32074040', '-- Sklo vo forme šupiniek s dĺžkou 0,1 mm alebo viac, ale nepresahujúcou 3,5 mm, a s hrúbkou 2 mikrometre alebo viac, ale nepresahujúcou 5 mikrometrov; sklo vo forme prášku alebo granúl obsahujúce v hmotnosti 99 % alebo viac oxidu kremičitého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32074040'),
('32074085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32074085'),
('3208', 'Náterové farby a laky (vrátane emailov a jemných lakov) na základe syntetických polymérov alebo chemicky modifikovaných prírodných polymérov, rozptýlené alebo rozpustené v nevodnom prostredí; roztoky definované poznámkou 4 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3208'),
('320810', '- Na základe polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_320810'),
('32081010', '-- Roztoky definované poznámkou 4 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32081010'),
('32081090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32081090'),
('320820', '- Na základe akrylových alebo vinylových polymérov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_320820'),
('32082010', '-- Roztoky definované poznámkou 4 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32082010'),
('32082090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32082090'),
('320890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_320890'),
('320890:2X', '-- Roztoky definované poznámkou 4 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_320890:2X'),
('32089011', '--- Polyuretán z 2,2''-(terc-butylimino)dietanolu a 4,4''-metyléndicyklohexyldiizocyanátu vo forme roztoku v N,N-dimetylacetamide obsahujúceho v hmotnosti 48 % alebo viac polyméru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32089011'),
('32089013', '--- Kopolymér z p-krezolu a divinylbenzénu vo forme roztoku v N,N-dimetylacetamide obsahujúceho v hmotnosti 48 % alebo viac polyméru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32089013'),
('32089019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32089019'),
('32089019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32089019:2X'),
('32089091', '--- Na základe syntetických polymérov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32089091'),
('32089099', '--- Na základe chemicky modifikovaných prírodných polymérov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32089099'),
('3209', 'Náterové farby a laky (vrátane emailov a jemných lakov) na základe syntetických polymérov alebo chemicky modifikovaných prírodných polymérov, rozptýlené alebo rozpustené vo vodnom prostredí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3209'),
('32091000', '- Na základe akrylových alebo vinylových polymérov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32091000'),
('32099000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32099000'),
('321000', 'Ostatné náterové farby a laky (vrátane emailov a jemných lakov a temperových farieb); pripravené vodné pigmenty druhov používaných na konečnú úpravu kože', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_321000'),
('32100010', '- Olejové náterové farby a laky (vrátane emailov a jemných lakov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32100010'),
('32100090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32100090'),
('32110000', 'Pripravené vysušovadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32110000'),
('3212', 'Pigmenty (vrátane kovových práškov a šupiniek) rozptýlené v nevodnom prostredí, v tekutej alebo pastovitej forme, používané na výrobu náterových farieb (vrátane emailov); razbové fólie; farby a ostatné farbivá vo formách alebo baleniach na predaj v malo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3212'),
('32121000', '- Razbové fólie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32121000'),
('32129000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32129000'),
('3213', 'Farby na umeleckú maľbu, školské farby, plagátové farby, tónovacie farby, farby na zábavné účely a podobné farby v tabletách, tubách, téglikoch, fľaštičkách, miskách alebo v podobných formách alebo baleniach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3213'),
('32131000', '- Farby v súpravách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32131000'),
('32139000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32139000'),
('3214', 'Sklenársky tmel, štepársky tmel, živicové spojivo, tesniace zmesi a ostatné tmely; maliarske tmely; nežiaruvzdorné prípravky na povrchovú úpravu fasád, vnútorných stien, podláh alebo podobné prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3214'),
('321410', '- Sklenársky tmel, štepársky tmel, živicové spojivo, tesniace zmesi a ostatné tmely; maliarske tmely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_321410'),
('32141010', '-- Sklenársky tmel, štepársky tmel, živicové spojivo, tesniace zmesi a ostatné tmely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32141010'),
('32141090', '-- Maliarske tmely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32141090'),
('32149000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32149000'),
('3215', 'Tlačiarenské farby, atramenty na písanie a rysovanie a ostatné atramenty (tuše), tiež koncentrované alebo tuhé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3215'),
('3215:2X', '- Tlačiarenská farba', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3215:2X'),
('32151100', '-- Čierna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32151100'),
('32151900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32151900'),
('32159000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_32159000'),
('3301', 'Silice (tiež deterpénované), vrátane pevných a absolútnych; rezinoidy; extrahované olejoživice; koncentráty silíc v tukoch, v nevysychateľných olejoch, vo voskoch alebo podobne, získané napustením alebo maceráciou týchto výrobkov; terpenické vedľajšie p', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3301'),
('3301:2X', '- Silice z citrusového ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3301:2X'),
('330112', '-- Pomarančová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330112'),
('33011210', '--- Nedeterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33011210'),
('33011290', '--- Deterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33011290'),
('330113', '-- Citrónová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330113'),
('33011310', '--- Nedeterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33011310'),
('33011390', '--- Deterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33011390'),
('330119', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330119'),
('33011920', '--- Nedeterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33011920'),
('33011980', '--- Deterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33011980'),
('33011980:2X', '- Silice iné ako z citrusového ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33011980:2X'),
('330124', '-- Pepermitová z mäty priepornej (Mentha piperita)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330124'),
('33012410', '--- Nedeterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012410'),
('33012490', '--- Deterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012490'),
('330125', '-- Z ostatných druhov mäty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330125'),
('33012510', '--- Nedeterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012510'),
('33012590', '--- Deterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012590'),
('330129', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330129'),
('330129:2X', '--- Klinčeková, niaouliová a ylan-ylangová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330129:2X'),
('33012911', '---- Nedeterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012911'),
('33012931', '---- Deterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012931'),
('33012931:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012931:2X'),
('33012941', '---- Nedeterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012941'),
('33012941:2X', '---- Deterpénovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012941:2X'),
('33012971', '----- Geraniová; jazmínová; vetiverová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012971'),
('33012979', '----- Levanduľová alebo lavandinová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012979'),
('33012991', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33012991'),
('33013000', '- Rezinoidy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33013000'),
('330190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330190'),
('33019010', '-- Produkty terpénické vedľajšie produkty z deterpenácie silíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33019010'),
('33019010:2X', '-- Extrahované olejoživice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33019010:2X'),
('33019021', '--- Zo sladkého drievka a chmeľu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33019021'),
('33019030', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33019030'),
('33019090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33019090'),
('3302', 'Zmesi vonných látok a zmesi (vrátane alkoholových roztokov) na základe jednej alebo niekoľkých týchto látok druhov používaných ako suroviny v priemysle; ostatné prípravky na základe vonných látok druhov používaných na výrobu nápojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3302'),
('330210', '- Druhy používané v potravinárskom alebo nápojovom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330210'),
('330210:2X', '-- Druhy používané v nápojovom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330210:2X'),
('330210:3X', '--- Prípravky obsahujúce všetky ochucujúce prísady charakterizujúce nápoj', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330210:3X'),
('33021010', '---- S objemovým alkoholometrickým titrom presahujúcim 0,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33021010'),
('33021010:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33021010:2X'),
('33021021', '----- Neobsahujúce mliečne tuky, sacharózu, izoglukózu alebo škrob, alebo obsahujúce v hmotnosti menej ako 1,5 % mliečnych tukov, 5 % sacharózy alebo izoglukózy, 5 % glukózy alebo škrobu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33021021'),
('33021029', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33021029'),
('33021040', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33021040'),
('33021090', '-- Druhy používané v potravinárskom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33021090'),
('330290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330290'),
('33029010', '-- Alkoholové roztoky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33029010'),
('33029090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33029090'),
('330300', 'Parfumy a toaletné vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_330300'),
('33030010', '- Parfumy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33030010'),
('33030090', '- Toaletné vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33030090'),
('3304', 'Kozmetické prípravky alebo líčidlá a prípravky na starostlivosť o pokožku (iné ako lieky), vrátane opaľovacích ochranných prípravkov alebo prípravkov na opaľovanie; prípravky na manikúru alebo pedikúru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3304'),
('33041000', '- Líčidlá na pery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33041000'),
('33042000', '- Prípravky na líčenie očí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33042000'),
('33043000', '- Prípravky na manikúru alebo pedikúru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33043000'),
('33043000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33043000:2X'),
('33049100', '-- Púdre, tiež kompaktné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33049100'),
('33049900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33049900'),
('3305', 'Prípravky na vlasy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3305'),
('33051000', '- Šampóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33051000'),
('33052000', '- Prípravky na trvalú onduláciu alebo na vyrovnávanie vlasov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33052000'),
('33053000', '- Laky na vlasy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33053000'),
('33059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33059000'),
('3306', 'Prípravky na ústnu alebo zubnú hygienu, vrátane zubných fixačných pást a práškov; vlákna na čistenie medzizubných medzier (dentálne nite) v samostatnom balení na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3306'),
('33061000', '- Prípravky na čistenie zubov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33061000'),
('33062000', '- Dentálne nite', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33062000'),
('33069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33069000'),
('3307', 'Prípravky používané pred holením, pri alebo po holení, osobné dezodoranty, kúpeľové prípravky, depilátory a ostatné voňavkárske, kozmetické alebo toaletné prípravky, inde nešpecifikované ani nezahrnuté; pripravené izbové dezodoranty, tiež parfumované al', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3307'),
('33071000', '- Prípravky používané pred holením, pri alebo po holení', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33071000'),
('33072000', '- Osobné dezodoranty a prípravky proti poteniu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33072000'),
('33073000', '- Parfumované kúpeľové soli a ostatné kúpeľové prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33073000'),
('33073000:2X', '- Prípravky na parfumovanie alebo dezodoráciu miestnosti, vrátane vonných prípravkov používaných pri náboženských obradoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33073000:2X'),
('33074100', '-- "Agarbati" a ostatné vonné prípravky pôsobiace pri horení', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33074100'),
('33074900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33074900'),
('33079000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_33079000'),
('3401', 'Mydlo; organické povrchovo aktívne výrobky a prípravky používané ako mydlo, v tvare tyčiniek, tehličiek, vylisovaných kusov alebo podobných tvarov, tiež obsahujúce mydlo; organické povrchovo aktívne výrobky a prípravky na umývanie pokožky vo forme kvapa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3401'),
('3401:2X', '- Mydlo a organické povrchovo aktívne výrobky a prípravky v tvare tyčiniek, tehličiek, vylisovaných kusov alebo podobných tvarov a papier, vata, plsť a netkané textílie, impregnované, potiahnuté alebo pokryté mydlom alebo detergentom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3401:2X'),
('34011100', '-- Na toaletné použitie (vrátane medicinálnych výrobkov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34011100'),
('34011900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34011900'),
('340120', '- Mydlo v ostatných formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_340120'),
('34012010', '-- šupinky, doštičky granuly alebo prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34012010'),
('34012090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34012090'),
('34013000', '- Organické povrchovo aktívne výrobky a prípravky na umývanie pokožky vo forme kvapaliny alebo krému a balené na predaj v malom, tiež obsahujúce mydlo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34013000'),
('3402', 'Organické povrchovo aktívne látky (iné ako mydlo); povrchovo aktívne prípravky, pracie prípravky (vrátane pomocných pracích prípravkov) a čistiace prípravky, tiež obsahujúce mydlo, iné ako položky 3401', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3402'),
('3402:2X', '- Organické povrchovo aktívne látky, tiež upravené na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3402:2X'),
('340211', '-- Aniónové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_340211'),
('34021110', '--- Vodný roztok obsahujúci v hmotnosti 30 % alebo viac, ale nnajviac 50 % alkylu [oxydi(benzénsulfonátu)] disodného', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34021110'),
('34021190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34021190'),
('34021200', '-- Katiónové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34021200'),
('34021300', '-- Neiónové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34021300'),
('34021900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34021900'),
('340220', '- Prípravky upravené na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_340220'),
('34022020', '-- Povrchovo aktívne prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34022020'),
('34022090', '-- Pracie prípravky a čistiace prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34022090'),
('340290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_340290'),
('34029010', '-- Povrchovo aktívne prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34029010'),
('34029090', '-- Pracie prípravky a čistiace prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34029090'),
('3403', 'Mastiace prípravky (vrátane rezných olejov, prípravkov na uvoľňovanie skrutiek alebo matíc, prípravkov proti hrdzi alebo korózii a prípravkov na uvoľňovanie foriem, na základe mazadiel) a prípravky používané na olejovanie alebo mazanie textilných materi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3403'),
('3403:2X', '- Obsahujúce ropné oleje alebo oleje získané z bitúmenových nerastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3403:2X'),
('34031100', '-- Prípravky na úpravu textilných materiálov, kože, kožušín alebo ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34031100'),
('340319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_340319'),
('34031910', '--- Obsahujúce 70 % hmotnosti alebo viac ropných olejov alebo olejov získaných z bitúmenových nerastov, ale ktoré nie sú ich základnou zložkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34031910'),
('34031990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34031990'),
('34031990:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34031990:2X'),
('34039100', '-- Prípravky na úpravu textilných materiálov, kože, kožušín alebo ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34039100'),
('34039900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34039900'),
('3404', 'Umelé vosky a pripravené vosky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3404'),
('34042000', '- Z poly(oxyetylénu) (polyetylénglykolu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34042000'),
('34049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34049000'),
('3405', 'Leštidlá a krémy na obuv, nábytok, podlahy, karosérie, sklo alebo kov, čistiace pasty a prášky a podobné prípravky (tiež vo forme papiera, vaty, plsti, netkaných textílií, ľahčených plastov alebo ľahčeného kaučuku, impregnovaných, potiahnutých alebo pok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3405'),
('34051000', '- Leštidlá, krémy a podobné prípravky na obuv alebo kožu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34051000'),
('34052000', '- Leštidlá, krémy a podobné prípravky na údržbu dreveného nábytku, podláh alebo ostatných drevených výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34052000'),
('34053000', '- Leštidlá a podobné prípravky na karosérie, iné ako na kovy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34053000'),
('34054000', '- Čistiace pasty a prášky a ostatné čistiace prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34054000'),
('340590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_340590'),
('34059010', '-- Leštidlá na kovy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34059010'),
('34059090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34059090'),
('34060000', 'Sviečky, tenké sviečky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34060000'),
('34070000', 'Modelovacie pasty, vrátane pást upravených pre zábavu detí; prípravky známe ako "zubolekársky vosk" alebo "zubné odtlačovacie zmesi", balené v sadách, v baleniach na predaj v malom alebo v tvare tabuliek, podkov, tyčiniek alebo v podobných tvaroch; osta', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_34070000'),
('3501', 'Kazeín, kazeináty a ostatné deriváty kazeínu; kazeínové gleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3501'),
('350110', '- Kazeín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350110'),
('35011010', '-- Na výrobu regenerovaných textilných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35011010'),
('35011050', '-- Na priemyselné použitie, iné ako na výrobu potravín alebo krmív', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35011050'),
('35011090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35011090'),
('350190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350190'),
('35019010', '-- Kazeínové gleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35019010'),
('35019090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35019090'),
('3502', 'Albumíny (vrátane koncentrátov z dvoch alebo viacerých srvátkových proteínov obsahujúcich v hmotnosti viac ako 80 % srvátkových proteínov počítaných na sušinu), albumináty a ostatné deriváty albumínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3502'),
('3502:2X', '- Vaječný albumín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3502:2X'),
('350211', '-- Sušený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350211'),
('35021110', '--- Nevhodný alebo nespôsobilý na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35021110'),
('35021190', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35021190'),
('350219', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350219'),
('35021910', '--- Nevhodný alebo nespôsobilý na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35021910'),
('35021990', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35021990'),
('350220', '- Mliečny albumín, vrátane koncentrátov z dvoch alebo viacerých srvátkových proteínov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350220'),
('35022010', '-- Nevhodný alebo nespôsobilý na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35022010'),
('35022010:2X', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35022010:2X'),
('35022091', '--- Sušený (napríklad v plátoch, vločkách, šupinkách, prášku)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35022091'),
('35022099', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35022099'),
('350290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350290'),
('350290:2X', '-- Albumíny, iné ako vaječný albumín a mliečny albumín (laktalbumín)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350290:2X'),
('35029020', '--- Nevhodné alebo nespôsobilé na ľudskú konzumáciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35029020'),
('35029070', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35029070'),
('35029090', '-- Albumináty a ostatné deriváty albumínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35029090'),
('350300', 'Želatína (vrátane želatíny v pravouhlých (vrátane štvorcových) plátoch, tiež povrchovo upravené alebo farbené) a deriváty želatíny; vyzina; ostatné gleje živočíšneho pôvodu, okrem kazeínových glejov položky 3501', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350300'),
('35030010', '- Želatína a jej deriváty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35030010'),
('35030080', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35030080'),
('350400', 'Peptóny a ich deriváty; ostatné proteínové látky a ich deriváty, inde nešpecifikované ani nezahrnuté; kožný prášok, tiež chrómovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350400'),
('35040010', '- Koncentrované mliečne proteíny špecifikované v doplnkovej poznámke 1 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35040010'),
('35040090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35040090'),
('3505', 'Dextríny a ostatné modifikované škroby (napríklad predželatinované alebo esterifikované škroby); gleje na základe škrobov alebo dextrínov alebo ostatných modifikovaných škrobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3505'),
('350510', '- Dextríny a ostatné modifikované škroby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350510'),
('35051010', '-- Dextríny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35051010'),
('35051010:2X', '-- Ostatné modifikované škroby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35051010:2X'),
('35051050', '--- Esterifikované alebo éterifikované škroby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35051050'),
('35051090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35051090'),
('350520', '- Gleje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350520'),
('35052010', '-- Obsahujúce v hmotnosti menej ako 25 % škrobov alebo dextrínov alebo ostatných modifikovaných škrobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35052010'),
('35052030', '-- Obsahujúce v hmotnosti 25 % alebo viac, ale menej ako 55 % škrobov alebo dextrínov alebo ostatných modifikovaných škrobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35052030'),
('35052050', '-- Obsahujúce v hmotnosti 55 % alebo viac, ale menej ako 80 % škrobov alebo dextrínov alebo ostatných modifikovaných škrobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35052050'),
('35052090', '-- Obsahujúce v hmotnosti 80 % alebo viac škrobov alebo dextrínov alebo ostatných modifikovaných škrobov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35052090'),
('3506', 'Pripravené gleje a ostatné pripravené lepidlá, inde nešpecifikované ani nezahrnuté; výrobky vhodné na použitie ako gleje alebo lepidlá, upravené na predaj v malom, s čistou hmotnosťou nepresahujúcou 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3506'),
('35061000', '- Výrobky vhodné na použitie ako gleje alebo lepidlá, upravené na predaj v malom, s čistou hmotnosťou nepresahujúcou 1 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35061000'),
('35061000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35061000:2X'),
('35069100', '-- Lepidlá na základe polymérov položiek 3901 až 3913 alebo kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35069100'),
('35069900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35069900'),
('3507', 'Enzýmy; pripravené enzýmy inde nešpecifikované alebo nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3507'),
('35071000', '- Syridlo a jeho koncentráty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35071000'),
('350790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_350790'),
('35079030', '-- Lipoproteínová lipáza; aspergilová alkalická proteáza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35079030'),
('35079090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_35079090'),
('36010000', 'Výbušniny výmetné, práškové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36010000'),
('36020000', 'Pripravené výbušniny, iné ako práškové výmetné výbušniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36020000'),
('360300', 'Zápalnice; bleskovice; roznetky alebo rozbušky; zapaľovače; elektrické rozbušky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_360300'),
('36030010', '- Zápalnice; bleskovice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36030010'),
('36030090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36030090'),
('3604', 'Ohňostroje, signalizačné rakety, dažďové rakety, hmlové signály a ostatné pyrotechnické výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3604'),
('36041000', '- Ohňostroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36041000'),
('36049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36049000'),
('36050000', 'Zápalky, iné ako pyrotechnické výrobky položky 3604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36050000'),
('3606', 'Ferocér a ostatné pyroforické zliatiny vo všetkých formách; výrobky z horľavých materiálov uvedených v poznámke 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3606'),
('36061000', '- Tekuté palivá alebo palivá zo skvapalneného plynu v nádobách používaných na plnenie alebo doplnenie cigaretových alebo podobných zapaľovačov s objemom nepresahujúcim 300 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36061000'),
('360690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_360690'),
('36069010', '-- Ferocér a ostatné pyroforické zliatiny vo všetkých formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36069010'),
('36069090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_36069090'),
('3701', 'Fotografické dosky a ploché filmy, scitlivené, neexponované, z materiálu iného ako z papiera, lepenky alebo textílií; ploché filmy na okamžitú fotografiu, scitlivené, neexponované, tiež v kazetách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3701'),
('37011000', '- Citlivé na röntgenové lúče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_37011000'),
('37012000', '- Filmy na okamžitú fotografiu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_37012000'),
('37013000', '- Ostatné dosky a filmy, s ktoroukoľvek stranou presahujúcou 255 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_37013000'),
('37013000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37013000:2X'),
('37019100', '-- Na farebnú fotografiu (polychrómnu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37019100'),
('37019900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37019900'),
('3702', 'Fotografické filmy vo zvitkoch, scitlivené, neexponované, z materiálu iného ako z papiera, lepenky alebo textílií; filmy na okamžitú fotografiu vo zvitkoch, scitlivené, neexponované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3702'),
('37021000', '- Citlivé na röntgenové lúče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_37021000'),
('37021000:2X', '- Ostatné filmy, bez perforácie, so šírkou nepresahujúcou 105 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37021000:2X'),
('370231', '-- Na farebnú fotografiu (polychrómnu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370231'),
('37023191', '--- Farebné negatívne filmy:- so šírkou 75 mm alebo viac, ale nepresahujúcou 105 mm a- s dĺžkou 100 m alebo viacna výrobu kazetových filmov (filmpakov) na okamžitú fotografiu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_37023191'),
('37023197', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_37023197'),
('370232', '-- Ostatné, s emulziou halogenidov striebra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370232'),
('370232:2X', '--- So šírkou nepresahujúcou 35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370232:2X'),
('37023210', '---- Mikrofilmy; filmy na grafické umenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37023210'),
('37023220', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37023220'),
('37023285', '--- So šírkou presahujúcou 35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37023285'),
('37023900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37023900'),
('37023900:2X', '- Ostatné filmy, bez perforácie, so šírkou presahujúcou 105 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37023900:2X'),
('37024100', '-- So šírkou presahujúcou 610 mm a s dĺžkou presahujúcou 200 m, na farebnú fotografiu (polychrómnu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_37024100'),
('37024200', '-- So šírkou presahujúcou 610 mm a s dĺžkou presahujúcou 200 m, iné ako na farebnú fotografiu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_37024200'),
('37024300', '-- So šírkou presahujúcou 610 mm a s dĺžkou nepresahujúcou 200 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_37024300'),
('37024400', '-- So šírkou presahujúcou 105 mm, ale nepresahujúcou 610 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_37024400'),
('37024400:2X', '- Ostatné filmy na farebnú fotografiu (polychrómnu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37024400:2X'),
('37025200', '-- So šírkou nepresahujúcou 16 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37025200'),
('37025300', '-- So šírkou presahujúcou 16 mm, ale nepresahujúcou 35 mm a s dĺžkou nepresahujúcou 30 m, na diapozitívy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_37025300'),
('37025400', '-- So šírkou presahujúcou 16 mm, ale nepresahujúcou 35 mm a s dĺžkou nepresahujúcou 30 m, iné ako na diapozitívy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_37025400'),
('37025500', '-- So šírkou presahujúcou 16 mm, ale nepresahujúcou 35 mm a s dĺžkou presahujúcou 30 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_37025500'),
('37025600', '-- So šírkou presahujúcou 35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37025600'),
('37025600:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37025600:2X'),
('370296', '-- So šírkou nepresahujúcou 35 mm a s dĺžkou nepresahujúcou 30 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370296'),
('37029610', '--- Mikrofilmy; filmy na grafické umenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37029610'),
('37029690', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_37029690'),
('370297', '-- So šírkou nepresahujúcou 35 mm a s dĺžkou presahujúcou 30 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370297'),
('37029710', '--- Mikrofilmy; filmy na grafické umenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37029710'),
('37029790', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_37029790'),
('37029800', '-- So šírkou presahujúcou 35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37029800'),
('3703', 'Fotografický papier, lepenka a textílie, scitlivené, neexponované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3703'),
('37031000', '- Vo zvitkoch, so šírkou presahujúcou 610 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37031000'),
('37032000', '- Ostatné, na farebnú fotografiu (polychrómnu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37032000'),
('37039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37039000'),
('370400', 'Fotografické dosky, filmy, papier, lepenka a textílie, exponované, ale nevyvolané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370400'),
('37040010', '- Dosky a filmy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37040010'),
('37040090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37040090'),
('3705', 'Fotografické dosky a filmy, exponované a vyvolané, iné ako kinematografický film', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3705'),
('37051000', '- Na ofsetovú reprodukciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37051000'),
('370590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370590'),
('37059010', '-- Mikrofilmy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37059010'),
('37059090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37059090'),
('3706', 'Kinematografické filmy, exponované a vyvolané, tiež obsahujúce zvukový záznam alebo len zvukový záznam', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3706'),
('370610', '- So šírkou 35 mm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370610'),
('37061020', '-- Obsahujúce len zvukový záznam; negatívy; pomocné pozitívy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_37061020'),
('37061099', '-- Ostatné pozitívy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_37061099'),
('370690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370690'),
('37069052', '-- Obsahujúce len zvukový záznam; negatívy; pomocné pozitívy; aktuality, filmové týždenníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_37069052'),
('37069052:2X', '-- Ostatné so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37069052:2X'),
('37069091', '--- Menej ako 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_37069091'),
('37069099', '--- 10 mm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_37069099'),
('3707', 'Chemické prípravky na fotografické účely (iné ako laky, gleje, lepidlá a podobné prípravky); nezmiešané výrobky na fotografické použitie, v odmeraných dávkach alebo upravené na predaj v malom, vo forme pripravenej na okamžité použitie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3707'),
('37071000', '- Citlivé emulzie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37071000'),
('370790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_370790'),
('37079020', '-- Vývojky a ustaľovače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37079020'),
('37079090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_37079090'),
('3801', 'Umelý grafit; koloidný alebo semikoloidný grafit; prípravky na základe grafitu alebo iného uhlíka vo forme pást, blokov, platní alebo ostatných polotovarov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3801'),
('38011000', '- Umelý grafit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38011000'),
('380120', '- Koloidný alebo semikoloidný grafit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380120'),
('38012010', '-- Koloidný grafit v olejovej suspenzii; semikoloidný grafit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38012010'),
('38012090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38012090'),
('38013000', '- Uhlíkaté pasty na elektródy a podobné pasty na výmurovky pecí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38013000'),
('38019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38019000'),
('3802', 'Aktívne uhlie; aktívne prírodné minerálne produkty; živočíšne uhlie, vrátane použitého živočíšneho uhlia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3802'),
('38021000', '- Aktívne uhlie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38021000'),
('38029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38029000'),
('380300', 'Tallový olej, tiež rafinovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380300'),
('38030010', '- Surový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38030010'),
('38030090', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38030090'),
('38040000', 'Odpadné výluhy z výroby drevnej buničiny, tiež koncentrované, odcukornené alebo chemicky upravené, vrátane lignínsulfónanov, ale okrem tallového oleja položky 3803', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38040000'),
('3805', 'Živicový, borovicový alebo sulfátový terpentín a ostatné terpenické silice vyrobené destiláciou alebo iným spracovaním ihličnatého dreva; surový dipentén; sulfitový terpentín a ostatný surový paracymén; borovicový olej obsahujúci alfaterpinol ako hlavnú', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3805'),
('380510', '- Živicový, borovicový alebo sulfátový terpentín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380510'),
('38051010', '-- Živicový terpentín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38051010'),
('38051030', '-- Borovicový terpentín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38051030'),
('38051090', '-- Sulfátový terpentín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38051090'),
('380590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380590'),
('38059010', '-- Borovicový olej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38059010'),
('38059090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38059090'),
('3806', 'Kolofónia a živicové kyseliny a ich deriváty; živicový lieh a živicové oleje; tavené gumy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3806'),
('38061000', '- Kolofónia a živicové kyseliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38061000'),
('38062000', '- Soli kolofónie, živicových kyselín alebo soli derivátov kolofónie alebo živicových kyselín, iné ako soli aduktov kolofónie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38062000'),
('38063000', '- Estery živíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38063000'),
('38069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38069000'),
('380700', 'Drevný decht; oleje z drevného dechtu; drevný kreozot; drevný lieh; rastlinná smola; pivovarská smola a podobné prípravky na základe kolofónie, živicových kyselín alebo rastlinnej smoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380700'),
('38070010', '- Drevný decht', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38070010'),
('38070090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38070090'),
('3808', 'Insekticídy, rodenticídy, fungicídy, herbicídy, prípravky proti klíčeniu a regulátory rastu rastlín, dezinfekčné prostriedky a podobné výrobky, vo formách alebo baleniach na predaj v malom alebo ako prípravky alebo výrobky (napríklad sírne pásy, knôty a', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3808'),
('38085000', '- Tovary uvedené v poznámke 1 k podpoložkám tejto kapitoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38085000'),
('38085000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38085000:2X'),
('380891', '-- Insekticídy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380891'),
('38089110', '--- Na základe pyretroidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089110'),
('38089120', '--- Na základe chlórovaných uhľovodíkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089120'),
('38089130', '--- Na základe karbamátov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089130'),
('38089140', '--- Na základe organofosforečných zlúčenín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089140'),
('38089190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089190'),
('380892', '-- Fungicídy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380892'),
('380892:2X', '--- Anorganické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380892:2X'),
('38089210', '---- Prípravky na základe zlúčenín medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089210'),
('38089220', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089220'),
('38089220:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089220:2X'),
('38089230', '---- Na základe ditiokarbamátov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089230'),
('38089240', '---- Na základe benzimidazolov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089240'),
('38089250', '---- Na základe diazolov alebo triazolov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089250'),
('38089260', '---- Na základe diazínov alebo morfolínov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089260'),
('38089290', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089290'),
('380893', '-- Herbicídy, prípravky proti klíčeniu a regulátory rastu rastlín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380893'),
('380893:2X', '--- Herbicídy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380893:2X'),
('38089311', '---- Na základe fenoxy-fytohormónov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089311'),
('38089313', '---- Na základe triazínov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089313'),
('38089315', '---- Na základe amidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089315'),
('38089317', '---- Na základe karbamátov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089317'),
('38089321', '---- Na základe derivátov dinitroanilínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089321'),
('38089323', '---- Na základe derivátov močoviny, uracilu alebo tiomočoviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089323'),
('38089327', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089327'),
('38089330', '--- Prípravky proti klíčeniu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089330'),
('38089390', '--- Regulátory rastu rastlín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089390'),
('380894', '-- Dezinfekčné prostriedky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380894'),
('38089410', '--- Na základe kvartérnych amónnych solí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089410'),
('38089420', '--- Na základe halogenovaných zlúčenín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089420'),
('38089490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089490'),
('380899', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380899'),
('38089910', '--- Rodenticídy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089910'),
('38089990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38089990'),
('3809', 'Prípravky na úpravu povrchu alebo apretovanie, prípravky urýchlujúce farbenia alebo ustálenie farbív a ostatné výrobky a prípravky (napríklad apretúry a moridlá), používané v textilnom, papierenskom, kožiarskom a podobnom priemysle, inde nešpecifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3809'),
('380910', '- Na základe škrobových látok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_380910'),
('38091010', '-- Obsahujúce v hmotnosti menej ako 55 % takýchto látok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38091010'),
('38091030', '-- Obsahujúce v hmotnosti 55 % alebo viac, ale menej ako 70 % takýchto látok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38091030'),
('38091050', '-- Obsahujúce v hmotnosti 70 % alebo viac, ale menej ako 83 % takýchto látok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38091050'),
('38091090', '-- Obsahujúce v hmotnosti 83 % alebo viac takýchto látok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38091090'),
('38091090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38091090:2X'),
('38099100', '-- Druhov používaných v textilnom alebo podobnom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38099100'),
('38099200', '-- Druhov používaných v papierenskom alebo podobnom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38099200'),
('38099300', '-- Druhov používaných v kožiarskom alebo podobnom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38099300'),
('3810', 'Prípravky na čistenie kovových povrchov; tavidlá a ostatné pomocné prípravky na spájkovanie na tvrdo alebo mäkko alebo zváranie; prášky a pasty na spájkovanie alebo zváranie zložené z kovu a ostatných materiálov; prípravky druhov používaných na výplň zv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3810'),
('38101000', '- Prípravky na čistenie kovových povrchov; prášky a pasty na spájkovanie alebo zváranie zložené z kovu a ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38101000'),
('381090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381090'),
('38109010', '-- Prípravky druhov používaných ako výplň alebo na oplášťovanie zváracích elektród a tyčí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38109010'),
('38109090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38109090'),
('3811', 'Antidetonačné prípravky (prípravky proti klepaniu motora), oxidačné inhibítory, živicové inhibítory, prípravky na zlepšenie viskozity, antikorózne prípravky a ostatné pripravené aditíva do minerálnych olejov (vrátane benzínov) alebo do ostatných kvapalí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3811'),
('3811:2X', '- Antidetonačné prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3811:2X'),
('381111', '-- Na základe zlúčenín z olova', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381111'),
('38111110', '--- Na základe tetraetylolova', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38111110'),
('38111190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38111190'),
('38111900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38111900'),
('38111900:2X', '- Aditíva do mazacích olejov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38111900:2X'),
('38112100', '-- Obsahujúce minerálne oleje alebo oleje získané z bitúmenových nerastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38112100'),
('38112900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38112900'),
('38119000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38119000'),
('3812', 'Pripravené urýchľovače vulkanizácie; zložené plastifikátory pre kaučuk alebo plasty, inde nešpecifikované ani nezahrnuté; antioxidačné prípravky a ostatné zmesné stabilizátory pre kaučuk alebo plasty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3812'),
('38121000', '- Pripravené urýchľovače vulkanizácie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38121000'),
('381220', '- Zložené plastifikátory pre kaučuk alebo plasty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381220'),
('38122010', '-- Reakčná zmes obsahujúca benzyl 3-izobutyryloxy-1-izopropyl-2,2-dimetylpropylftalát a benzyl 3-izobutyryloxy-2,2,4-trimetylpentylftalát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38122010'),
('38122090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38122090'),
('381230', '- Antioxidačné prípravky a ostatné zmesné stabilizátory pre kaučuk alebo plasty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381230'),
('381230:2X', '-- Antioxidačné prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381230:2X'),
('38123021', '--- Zmesi oligomérov 1,2-dihydro-2,2,4-trimetylchinolínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38123021'),
('38123029', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38123029'),
('38123080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38123080'),
('38130000', 'Prípravky a náplne do hasiacich prístrojov; naplnené hasiace granáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38130000'),
('381400', 'Zložené organické rozpúšťadlá a riedidlá, inde nešpecifikované ani nezahrnuté; prípravky na odstraňovanie náterov a lakov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381400'),
('38140010', '- Na základe butylacetátu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38140010'),
('38140090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38140090'),
('3815', 'Iniciátory reakcie, urýchľovače reakcie a katalytické prípravky, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3815'),
('3815:2X', '- Katalyzátory na nosiči', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3815:2X'),
('38151100', '-- S niklom alebo so zlúčeninou niklu ako aktívnou látkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38151100'),
('38151200', '-- S drahým kovom alebo so zlúčeninou drahého kovu ako aktívnou látkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38151200'),
('381519', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381519'),
('38151910', '--- Katalyzátory vo forme zŕn, z ktorých 90 % alebo viac hmotnosti má veľkosť častice nepresahujúcu 10 mikrometrov, zložené zo zmesi oxidov nanesenej na podložke z kremičitanu horečnatého, obsahujúcej v hmotnosti:- 20 % alebo viac, ale najviac 35 % medi,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38151910'),
('38151990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38151990'),
('381590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381590'),
('38159010', '-- Katalyzátory pozostávajúce z acetátu etyltrifenylfosforečného vo forme roztoku v metanole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38159010'),
('38159090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38159090'),
('38160000', 'Ohňovzdorné cementy, malty, betóny a podobné zmesi, iné ako výrobky položky 3801', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38160000'),
('381700', 'Zmesi alkylbenzénov a zmesi alkylnaftalénov, iné ako položky 2707 alebo 2902', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381700'),
('38170050', '- Lineárne alkylbenzény', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38170050'),
('38170080', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38170080'),
('381800', 'Chemické prvky dopované na použitie v elektronike, v tvare diskov, doštičiek alebo v podobných tvaroch; chemické zlúčeniny dopované na použitie v elektronike', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_381800'),
('38180010', '- Dopovaný kremík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38180010'),
('38180090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38180090'),
('38190000', 'Kvapaliny do hydraulických bŕzd a ostatné pripravené kvapaliny do hydraulických prevodov, tiež obsahujúce menej ako 70 % hmotnosti ropných olejov alebo olejov získaných z bitúmenových nerastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38190000'),
('38200000', 'Prípravky proti zamŕzaniu a prípravky na odmrazovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38200000'),
('38210000', 'Pripravené živné pôdy na rast alebo udržiavanie mikroorganizmov (vrátane vírusov a podobných organizmov) alebo rastlinných, ľudských alebo živočíšnych buniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38210000'),
('38220000', 'Diagnostické alebo laboratórne reagencie na podložke, pripravené diagnostické alebo laboratórne reagencie, tiež na podložke, iné ako položky 3002 alebo 3006; certifikované referenčné materiály', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38220000'),
('3823', 'Technické monokarboxylové mastné kyseliny; kyslé oleje z rafinácie; technické mastné alkoholy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3823'),
('3823:2X', '- Technické monokarboxylové mastné kyseliny; kyslé oleje z rafinácie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3823:2X'),
('38231100', '-- Kyselina stearová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38231100'),
('38231200', '-- Kyselina olejová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38231200'),
('38231300', '-- Mastné kyseliny z tallového oleja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38231300'),
('382319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_382319'),
('38231910', '--- Destilované mastné kyseliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38231910'),
('38231930', '--- Destiláty mastných kyselín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38231930'),
('38231990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38231990'),
('38237000', '- Technické mastné alkoholy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38237000'),
('3824', 'Pripravené spojivá na odlievacie formy alebo jadrá; chemické výrobky a prípravky chemického priemyslu alebo príbuzných priemyselných odvetví (vrátane takých, ktoré pozostávajú zo zmesí prírodných produktov), inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3824'),
('38241000', '- Pripravené spojivá pre odlievacie formy alebo jadrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38241000'),
('38243000', '- Neaglomerované karbidy kovov zmiešané navzájom alebo s kovovým spojivom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38243000'),
('38244000', '- Pripravené prísady do cementov, mált alebo betónov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38244000'),
('382450', '- Malty a betóny, iné ako ohňovzdorné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_382450'),
('38245010', '-- Betón pripravený na liatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38245010'),
('38245090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38245090'),
('382460', '- Sorbitol, iný ako podpoložky 2905 44', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_382460'),
('382460:2X', '-- Vo vodných roztokoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_382460:2X'),
('38246011', '--- Obsahujúci D-manitol 2 % hmotnosti alebo menej, počítaného na obsah D-glucitolu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38246011'),
('38246019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38246019'),
('38246019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38246019:2X'),
('38246091', '--- Obsahujúci D-manitol 2 % hmotnosti alebo menej, počítaného na obsah D-glucitolu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38246091'),
('38246099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38246099'),
('38246099:2X', '- Zmesi obsahujúce halogénované deriváty metánu, etánu alebo propánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38246099:2X'),
('38247100', '-- Obsahujúce chlórfluórované uhľovodíky (CFC), tiež obsahujúce hydrochlórfluórované uhľovodíky (HCFC), perfluórované uhľovodíky (PFC) alebo hydrofluórované uhľovodíky (HFC)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247100'),
('38247200', '-- Obsahujúce brómchlórdifluórmetán, brómtrifluórmetán alebo dibrómtetrafluóretány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247200'),
('38247300', '-- Obsahujúce hydrobrómfluórované uhľovodíky (HBFC)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247300'),
('38247400', '-- Obsahujúce hydrochlórfluórované uhľovodíky (HCFC), tiež obsahujúce perfluórované uhľovodíky (PFC) alebo hydrofluórované uhľovodíky (HFC), ale neobsahujúce chlórfluórované uhľovodíky (CFC)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247400'),
('38247500', '-- Obsahujúce tetrachlórmetán (chlorid uhličitý)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247500'),
('38247600', '-- Obsahujúce 1,1,1-trichlóretán (metylchloroform)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247600'),
('38247700', '-- Obsahujúce brómmetán (metylbromid) alebo brómchlórmetán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247700'),
('38247800', '-- Obsahujúce perfluórované uhľovodíky (PFC) alebo hydrofluórované uhľovodíky (HFC), ale neobsahujúce chlórfluórované uhľovodíky (CFC) alebo hydrochlórfluórované uhľovodíky (HCFC)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247800'),
('38247900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247900'),
('38247900:2X', '- Zmesi a prípravky obsahujúce oxirán (etylénoxid), polybrómované bifenyly (PBB), polychlórované bifenyly (PCB), polychlórované terfenyly (PCT) alebo tris(2,3-dibrómpropyl) fosfát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38247900:2X'),
('38248100', '-- Obsahujúce oxirán (etylénoxid)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38248100'),
('38248200', '-- Obsahujúce polychlórované bifenyly (PCB), polychlórované terfenyly (PCT) alebo polybrómované bifenyly (PBB)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38248200'),
('38248300', '-- Obsahujúce tris(2, 3-dibrómpropyl) fosfát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38248300'),
('382490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_382490'),
('38249010', '-- Ropné sulfónany, okrem ropných sulfónanov alkalických kovov, amónia alebo etanolamínov; tiofénované sulfónované kyseliny olejov získaných z bitúmenových nerastov a ich solí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249010'),
('38249015', '-- Iónomeniče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249015'),
('38249020', '-- Getry (pohlcovače plynov) pre vákuové trubice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249020'),
('38249025', '-- Pyrolignity (napríklad vápnika); surový vínan (tartaran) vápenatý; surový citran vápenatý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249025'),
('38249030', '-- Kyseliny nafténové, ich vo vode nerozpustné soli a ich estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249030'),
('38249035', '-- Antikorózne prípravky, obsahujúce amíny ako aktívnu zložku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249035'),
('38249040', '-- Anorganické zložené rozpúšťadlá a riedidlá do lakov a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249040'),
('38249040:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249040:2X'),
('38249045', '--- Zmesi zabraňujúce tvorbe kameňa a podobné zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249045'),
('38249050', '--- Prípravky na elektrolytické pokovovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249050'),
('38249055', '--- Zmesi mono-, di- a triesterov mastných kyselín glycerolu (emulgátory tukov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249055'),
('38249058', '--- Nikotínové náplasti (transdermálne systémy), ktoré majú pomôcť fajčiarom prestať fajčiť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249058'),
('38249058:2X', '--- Výrobky a prípravky na farmaceutické alebo chirurgické použitie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249058:2X'),
('38249061', '---- Medziprodukty z výroby antibiotík získané z fermentácie Streptomyces tenebrarius, tiež sušené na použitie vo výrobe liekov pre ľudí položky 3004', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249061'),
('38249062', '---- Medziprodukty z výroby monenzinových solí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249062'),
('38249064', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249064'),
('38249065', '--- Pomocné produkty pre zlievarne (iné ako podpoložky 3824 10 00)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249065'),
('38249070', '--- Ohňovzdorné, vodovzdorné a podobné ochranné prípravky, používané v stavebníctve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249070'),
('38249070:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249070:2X'),
('38249075', '---- Doštičky niobnanu lítneho, nedopované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249075'),
('38249080', '---- Zmesi amínov získavaných z dimerizovaných mastných kyselín s priemernou molekulovou hmotnosťou 520 alebo viac, ale nepresahujúcou 550', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249080'),
('38249085', '---- 3-(1-etyl-1-metylpropyl)izoxazol-5-ylamín vo forme roztoku v toluéne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249085'),
('38249087', '---- Zmesi obsahujúce najmä (5-etyl-2-metyl-2-oxido-1,3,2-dioxafosfínan-5-yl)metyl metyl-metylfosfonáty a bis[(5-etyl-2-metyl-2-oxido-1,3,2-dioxafosfínan-5-yl)metyl] metylfosfonátov, a zmesi obsahujúce najmä dimetyl metylfosfonát, oxirán a oxid fosforečn', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249087'),
('38249097', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38249097'),
('3825', 'Zvyškové produkty chemického priemyslu alebo príbuzných priemyselných odvetví, inde nešpecifikované ani nezahrnuté; komunálny odpad; kal z čističiek odpadových vôd; ostatné odpady uvedené v poznámke 6 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3825'),
('38251000', '- Komunálny odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38251000'),
('38252000', '- Kal z čističiek odpadových vôd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38252000'),
('38253000', '- Klinický odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38253000'),
('38253000:2X', '- Odpadové organické rozpúšťadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38253000:2X'),
('38254100', '-- Halogenované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38254100'),
('38254900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38254900'),
('38255000', '- Odpadové kvapaliny z roztokov moridiel kovov, odpad z hydraulických kvapalín, brzdových a nemrznúcich kvapalín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38255000'),
('38255000:2X', '- Ostatné odpady z chemického priemyslu alebo príbuzných priemyselných odvetví', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38255000:2X'),
('38256100', '-- Obsahujúce hlavne organické zložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38256100'),
('38256900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38256900'),
('382590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_382590'),
('38259010', '-- Alkalické oxidy železa na čistenie plynov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38259010'),
('38259090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38259090'),
('382600', 'Bionafta a jej zmesi, tiež obsahujúce menej ako 70 % hmotnosti ropných olejov alebo olejov získaných z bitúmenových nerastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_382600'),
('38260010', '- Monoalkylestery mastných kyselín, s obsahom esterov v bojeme 96,5 % alebo viac (FAMAE)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38260010'),
('38260090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38260090'),
('38260090:2X', 'I. PRIMÁRNE FORMY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_38260090:2X'),
('3901', 'Polyméry etylénu v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3901'),
('390110', '- Polyetylén so špecifickou hmotnosťou menej ako 0,94', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390110'),
('39011010', '-- Lineárny polyetylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39011010'),
('39011090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39011090'),
('390120', '- Polyetylén so špecifickou hmotnosťou 0,94 alebo vyššou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390120'),
('39012010', '-- Polyetylén v jednej z foriem uvedených v poznámke 6 b) k tejto kapitole, so špecifickou hmotnosťou 0,958 alebo viac pri 23 °C, obsahujúci: - 50 mg/kg alebo menej hliníka, - 2 mg/kg alebo menej vápnika, - 2 mg/kg alebo menej chrómu, - 2 mg/kg alebo men', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39012010'),
('39012090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39012090'),
('39013000', '- Etylén-vinylacetátové kopolyméry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39013000'),
('390190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390190'),
('39019030', '-- Ionomérna živica tvorená soľou terpolyméru etylénu s izobutyl akrylátom a kyselinou metakrylovou; A-B-A blokový kopolymér polystyrénu, kopolymér etylénbutylénu a polystyrénu obsahujúci v hmotnosti 35 % alebo menej styrénu, v jednej z foriem uvedených', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39019030'),
('39019090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39019090'),
('3902', 'Polyméry propylénu alebo ostatných olefínov v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3902'),
('39021000', '- Polypropylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39021000'),
('39022000', '- Polyizobutylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39022000'),
('39023000', '- Kopolyméry propylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39023000'),
('390290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390290'),
('39029010', '-- A-B-A blokový kopolymér polystyrénu, kopolymér etylénbutylénu a polystyrénu obsahujúci v hmotnosti 35 % alebo menej styrénu, v jednej z foriem uvedených v poznámke 6 b) k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39029010'),
('39029020', '-- Poly-1-butén, kopolymér 1-buténu s etylénom obsahujúci v hmotnosti 10 % alebo menej etylénu, alebo zmes poly-1-buténu s polyetylénom a/alebo polypropylénom obsahujúca v hmotnosti 10 % alebo menej polyetylénu a/alebo 25 % alebo menej polypropylénu, v j', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39029020'),
('39029090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39029090'),
('3903', 'Polyméry styrénu v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3903'),
('3903:2X', '- Polystyrén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3903:2X'),
('39031100', '-- Expandovateľný (rozpínavý)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39031100'),
('39031900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39031900'),
('39032000', '- Styrén-akrylonitrilové kopolyméry (SAN)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39032000'),
('39033000', '- Akrylonitril-butadién-styrénové kopolyméry (ABS)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39033000'),
('390390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390390'),
('39039010', '-- Kopolymér, výlučne zo styrénu s alylalkoholom, s acetylovým čislom 175 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39039010'),
('39039020', '-- Brómovaný polystyrén obsahujúci v hmotnosti 58 % alebo viac, ale najviac 71 % brómu, v jednej z foriem uvedených v poznámke 6 b) k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39039020'),
('39039090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39039090'),
('3904', 'Polyméry vinylchloridu alebo ostatných halogénovaných olefínov, v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3904'),
('39041000', '- Polyvinylchlorid, nezmiešaný s ostatnými látkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39041000'),
('39041000:2X', '- Ostatný polyvinylchlorid', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39041000:2X'),
('39042100', '-- Nemäkčený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39042100'),
('39042200', '-- Mäkčený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39042200'),
('39043000', '- Vinylchlorid-vinylacetátové kopolyméry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39043000'),
('39044000', '- Ostatné vinylchloridové kopolyméry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39044000'),
('390450', '- Vinylidénchloridové polyméry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390450'),
('39045010', '-- Kopolymér vinylidénchloridu s akrylonitrilom, vo forme rozpínavých kvapiek s priemerom 4 mikrometre alebo viac, ale najviac 20 mikrometrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39045010'),
('39045090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39045090'),
('39045090:2X', '- Fluórované polyméry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39045090:2X'),
('39046100', '-- Polytetrafluóretylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39046100'),
('390469', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390469'),
('39046910', '--- Polyvinylfluorid v jednej z foriem uvedených v poznámke 6 b) k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39046910'),
('39046920', '--- Fluórelastoméry FKM', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39046920'),
('39046980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39046980'),
('39049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39049000'),
('3905', 'Polyméry vinylacetátu alebo ostatných vinylesterov, v primárnych formách; ostatné vinylové polyméry v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3905'),
('3905:2X', '- Polyvinylacetát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3905:2X'),
('39051200', '-- Vo vodnej disperzii', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39051200'),
('39051900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39051900'),
('39051900:2X', '- Kopolyméry vinylacetátu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39051900:2X'),
('39052100', '-- Vo vodnej disperzii', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39052100'),
('39052900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39052900'),
('39053000', '- Polyvinylalkohol, tiež obsahujúci nehydrolyzované acetátové skupiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39053000'),
('39053000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39053000:2X'),
('39059100', '-- Kopolyméry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39059100'),
('390599', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390599'),
('39059910', '--- Polyvinylformal, v jednej z foriem uvedených v poznámke 6 b) k tejto kapitole, s molekulovou hmotnosťou 10 000 alebo viac, ale nepresahujúcou 40 000 a obsahujúci v hmotnosti:- 9,5 % alebo viac, ale najviac 13 % acetylových skupín vyjadrených ako viny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39059910'),
('39059990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39059990'),
('3906', 'Akrylové polyméry v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3906'),
('39061000', '- Polymetylmetakrylát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39061000'),
('390690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390690'),
('39069010', '-- Poly[N-(3-hydroxyimino-1,1-dimetylbutyl) akrylamid]', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39069010'),
('39069020', '-- Kopolymér 2-diizopropylaminoetyl metakrylátu s decylmetakrylátom, vo forme roztoku v N,N-dimetylacetamid obsahujúci v hmotnosti 55 % alebo viac kopolyméru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39069020'),
('39069030', '-- Kopolymér kyseliny akrylovej s 2-etylhexylakrylátom obsahujúci v hmotnosti 10 % alebo viac, ale najviac11 % 2-etylhexylakrylátu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39069030'),
('39069040', '-- Kopolymér akrylonitrilu s metylakrylátom, modifikovaný s polybutadiénakrylonitrilom (NBR)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39069040'),
('39069050', '-- Polymerizačný produkt kyseliny akrylovej s alkylmetakrylátom a malého množstva ostatných monomérov, na použitie ako zahusťovadlo vo výrobe textilných tlačiarenských pást', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39069050'),
('39069060', '-- Kopolymér metylakrylátu s etylénom a monomérom obsahujúcim ako substituent nekoncovú karboxylovú skupinu, obsahujúci v hmotnosti 50 % alebo viac metylakrylátu, tiež zmiešaný s oxidom kremičitým', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39069060'),
('39069090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39069090'),
('3907', 'Polyacetály, ostatné polyétery a epoxidové živice, v primárnych formách; polyuhličitany, alkydové živice, polyalylové estery a ostatné polyestery v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3907'),
('39071000', '- Polyacetály', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39071000'),
('390720', '- Ostatné polyétery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390720'),
('390720:2X', '-- Polyéteralkoholy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390720:2X'),
('39072011', '--- Polyetylénglykoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39072011'),
('39072020', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39072020'),
('39072020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39072020:2X'),
('39072091', '--- Kopolymér 1-chlór-2,3-epoxypropánu s etylénoxidom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39072091'),
('39072099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39072099'),
('39073000', '- Epoxidové živice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39073000'),
('39074000', '- Polyuhličitany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39074000'),
('39075000', '- Alkydové živice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39075000'),
('390760', '- Polyetyléntereftalát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390760'),
('39076020', '-- S číslom viskozity 78 ml/g alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39076020'),
('39076080', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39076080'),
('39077000', '- Kyselina polylaktónová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39077000'),
('39077000:2X', '- Ostatné polyestery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39077000:2X'),
('390791', '-- Nenasýtené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390791'),
('39079110', '--- Kvapalné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39079110'),
('39079190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39079190'),
('390799', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390799'),
('39079910', '--- Polyetylénnaftalén-2,6-dikarboxylát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39079910'),
('39079990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39079990'),
('3908', 'Polyamidy v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3908'),
('39081000', '- Polyamid-6, -11, -12, -6,6, -6,9, -6,10 alebo -6,12', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39081000'),
('39089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39089000'),
('3909', 'Amínové živice, fenolové živice a polyuretány, v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3909'),
('39091000', '- Močovinové živice; tiomočovinové živice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39091000'),
('39092000', '- Melamínové živice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39092000'),
('39093000', '- Ostatné amínové živice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39093000'),
('39094000', '- Fenolové živice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39094000'),
('390950', '- Polyuretány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_390950'),
('39095010', '-- Polyuretán z 2,2''-(terc-butylimino)dietanolu a 4,4''-metyléndicyklohexyldiizokyanátu, vo forme roztoku v N,N-dimetylacetamide, obsahujúci v hmotnosti 50 % alebo viac polyméru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39095010'),
('39095090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39095090'),
('39100000', 'Silikóny v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39100000'),
('3911', 'Ropné živice, kumarón-indénové živice, polyterpény, polysulfidy, polysulfóny a ostatné výrobky uvedené v poznámke 3 k tejto kapitole, inde nešpecifikované ani nezahrnuté, v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3911'),
('39111000', '- Ropné živice, kumarónové živice, indénové živice alebo kumarón-indénové živice a polyterpény', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39111000'),
('391190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391190'),
('391190:2X', '-- Kondenzačné alebo preskupené polymerizačné produkty, tiež chemicky modifikované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391190:2X'),
('39119011', '--- Poly(oxy-1,4-fenylénsulfonyl-1,4-fenylénoxy-1,4-fenylénizopropylidén-1,4-fenylén), v jednej z foriem uvedených v poznámke 6 b) k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39119011'),
('39119013', '--- Polytio-1,4-fenylén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39119013'),
('39119019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39119019'),
('39119019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39119019:2X'),
('39119092', '--- Kopolymér z p-krezolu a divinylbenzénu, vo forme roztoku v N,N-dimetylacetamide obsahujúci v hmotnosti 50 % alebo viac polyméru; hydrogenované kopolyméry vinyltoluénu a alfa-metylstyrénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39119092'),
('39119099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39119099'),
('3912', 'Celulóza a jej chemické deriváty, inde nešpecifikované ani nezahrnuté, v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3912'),
('3912:2X', '- Acetáty celulózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3912:2X'),
('39121100', '-- Nemäkčené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39121100'),
('39121200', '-- Mäkčené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39121200'),
('391220', '- Nitráty celulózy (vrátane kolódií)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391220'),
('391220:2X', '-- Nemäkčené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391220:2X'),
('39122011', '--- Kolódiá a celoidin', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39122011'),
('39122019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39122019'),
('39122090', '-- Mäkčené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39122090'),
('39122090:2X', '- Étery celulózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39122090:2X'),
('39123100', '-- Karboxymetylcelulóza a jej soli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39123100'),
('391239', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391239'),
('39123920', '--- Hydroxypropylcelulóza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39123920'),
('39123985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39123985'),
('391290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391290'),
('39129010', '-- Estery celulózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39129010'),
('39129090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39129090'),
('3913', 'Prírodné polyméry (napríklad kyselina algová) a modifikované prírodné polyméry (napríklad tvrdené bielkoviny, chemické deriváty prírodného kaučuku), inde nešpecifikované ani nezahrnuté v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3913'),
('39131000', '- Kyselina algová, jej soli a estery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39131000'),
('39139000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39139000'),
('39140000', 'Ionomeniče na základe polymérov položiek 3901 až 3913, v primárnych formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39140000'),
('39140000:2X', 'II. ODPADY, ÚLOMKY A ODREZKY; POLOTOVARY; VÝROBKY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39140000:2X'),
('3915', 'Odpady, úlomky a odrezky, z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3915'),
('39151000', '- Z polymérov etylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39151000'),
('39152000', '- Z polymérov styrénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39152000'),
('39153000', '- Z polymérov vinylchloridu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39153000'),
('391590', '- Z ostatných plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391590'),
('39159011', '-- Z polymérov propylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39159011'),
('39159080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39159080'),
('3916', 'Monofil, ktorého akýkoľvek rozmer prierezu presahuje 1 mm, prúty, tyčinky a profily, tiež povrchovo upravené, ale inak neopracované, z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3916'),
('39161000', '- Z polymérov etylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39161000'),
('39162000', '- Z polymérov vinylchloridu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39162000'),
('391690', '- Z ostatných plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391690'),
('39169010', '-- Z kondenzačných alebo preskupených polymerizačných produktov, tiež chemicky modifikovaných', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39169010'),
('39169050', '-- Z adičných polymerizačných produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39169050'),
('39169090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39169090'),
('3917', 'Rúry, rúrky a hadice, a ich príslušenstvo (napríklad spojky, kolená, príruby), z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3917'),
('391710', '- Umelé črevá (črievka párkov a salám) z tvrdených bielkovín alebo z celulózových materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391710'),
('39171010', '-- Z tvrdených bielkovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39171010'),
('39171090', '-- Z celulózových materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39171090'),
('39171090:2X', '- Rúry, rúrky a hadice, neohybné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39171090:2X'),
('391721', '-- Z polymérov etylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391721'),
('39172110', '--- Bezošvé a s dĺžkou presahujúcou maximálny prierezový rozmer, tiež povrchovo upravené, ale inak neopracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39172110'),
('39172190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39172190'),
('391722', '-- Z polymérov propylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391722'),
('39172210', '--- Bezošvé a s dĺžkou presahujúcou maximálny prierezový rozmer, tiež povrchovo upravené, ale inak neopracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39172210'),
('39172290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39172290'),
('391723', '-- Z polymérov vinylchloridu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391723'),
('39172310', '--- Bezošvé a s dĺžkou presahujúcou maximálny prierezový rozmer, tiež povrchovo upravené, ale inak neopracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39172310'),
('39172390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39172390'),
('39172900', '-- Z ostatných plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39172900'),
('39172900:2X', '- Ostatné rúry, rúrky a hadice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39172900:2X'),
('39173100', '-- Ohybné rúry, rúrky a hadice s minimálnym tlakom prasknutia 27,6 MPa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39173100'),
('39173200', '-- Ostatné, nespevnené alebo nekombinované s ostatnými materiálmi, bez príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39173200'),
('39173300', '-- Ostatné, nespevnené alebo nekombinované s ostatnými materiálmi, s príslušenstvom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39173300'),
('39173900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39173900'),
('39174000', '- Príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39174000'),
('3918', 'Podlahové krytiny z plastov, tiež samolepiace, vo zvitkoch alebo vo forme dlaždíc; obklady na steny alebo stropy, z plastov, definované v poznámke 9 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3918'),
('391810', '- Z polymérov vinylchloridu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391810'),
('39181010', '-- Pozostávajúce z podložky impregnovanej, potiahnutej alebo pokrytej poly(vinylchloridom)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_39181010'),
('39181090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_39181090'),
('39189000', '- Z ostatných plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_39189000'),
('3919', 'Samolepiace platne, listy, fólie, filmy, pásy, pásky a ostatné ploché tvary, z plastov, tiež vo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3919'),
('391910', '- Vo zvitkoch, so šírkou nepresahujúcou 20 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391910'),
('391910:2X', '-- Pásky, ktorých poťah pozostáva z nevulkanizovaného prírodného alebo syntetického kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_391910:2X'),
('39191012', '--- Z polyvinylchloridu alebo polyetylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39191012'),
('39191015', '--- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39191015'),
('39191019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39191019'),
('39191080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39191080'),
('39199000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39199000'),
('3920', 'Ostatné platne, listy, fólie, filmy, pásy, pásky, z plastov, neľahčené a nezosilené, nelaminované, nevystužené alebo podobne nekombinované s ostatnými materiálmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3920'),
('392010', '- Z polymérov etylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392010'),
('392010:2X', '-- S hrúbkou nepresahujúcou 0,125 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392010:2X'),
('392010:3X', '--- Z polyetylénu so špecifickou hmotnosťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392010:3X'),
('392010:4X', '---- Menej ako 0,94', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392010:4X'),
('39201023', '----- Polyetylénové filmy s hrúbkou 20 mikrometrov alebo viac, ale nepresahujúcou 40 mikrometrov, na výrobu svetlostálych filmov používaných pri výrobe polovodičov alebo tlačených obvodov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39201023'),
('39201024', '----- Pružný film, nepotlačený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39201024'),
('39201025', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39201025'),
('39201028', '---- 0,94 alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39201028'),
('39201040', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39201040'),
('39201040:2X', '-- S hrúbkou presahujúcou 0,125 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39201040:2X'),
('39201081', '--- Syntetická papierovina, vo forme vlhkých hárkov z nespojených jemne rozvetvených polyetylénových vlákien, tiež zmiešaná s celulózovými vláknami v množstve nepresahujúcom 15 %, obsahujúca polyvinylalkohol rozpustený vo vode ako vlhčiace činidlo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39201081'),
('39201089', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39201089'),
('392020', '- Z polymérov propylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392020'),
('392020:2X', '-- S hrúbkou nepresahujúcou 0,10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392020:2X'),
('39202021', '--- Biaxiálne orientované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39202021'),
('39202029', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39202029'),
('39202080', '-- S hrúbkou presahujúcou 0,10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39202080'),
('39203000', '- Z polymérov styrénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39203000'),
('39203000:2X', '- Z polymérov vinylchloridu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39203000:2X'),
('392043', '-- Obsahujúce v hmotnosti najmenej 6 % hmotnosti plastifikátorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392043'),
('39204310', '--- S hrúbkou nepresahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39204310'),
('39204390', '--- S hrúbkou presahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39204390'),
('392049', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392049'),
('39204910', '--- S hrúbkou nepresahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39204910'),
('39204990', '--- S hrúbkou presahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39204990'),
('39204990:2X', '- Z akrylových polymérov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39204990:2X'),
('39205100', '-- Z polymetylmetakrylátu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39205100'),
('392059', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392059'),
('39205910', '--- Kopolymér z akrylových a metakrylových esterov, vo forme filmu s hrúbkou nepresahujúcou 150 mikrometrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39205910'),
('39205990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39205990'),
('39205990:2X', '- Z polyuhličitanov, alkydových živíc, polyalylových esterov alebo ostatných polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39205990:2X'),
('39206100', '-- Z polyuhličitanov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39206100'),
('392062', '-- Z polyetylénteraftalátu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392062'),
('392062:2X', '--- S hrúbkou nepresahujúcou 0,35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392062:2X'),
('39206212', '---- Polyetyléntereftálové filmy s hrúbkou 72 mikrometrov alebo viac, ale nepresahujúcou 79 mikrometrov, na výrobu pružných magnetických diskov; polyetyléntereftálové filmy s hrúbkou 100 mikrometrov alebo viac, ale nepresahujúcou 150 mikrometrov, na výro', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39206212'),
('39206219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39206219'),
('39206290', '--- S hrúbkou presahujúcou 0,35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39206290'),
('39206300', '-- Z nenasýtených polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39206300'),
('39206900', '-- Z ostatných polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39206900'),
('39206900:2X', '- Z celulózy alebo jej chemických derivátov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39206900:2X'),
('39207100', '-- Z regenerovanej celulózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39207100'),
('392073', '-- Z acetátu celulózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392073'),
('39207310', '--- Filmy vo zvitkoch alebo pásoch, na fotografie a kinematografiu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39207310'),
('39207380', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39207380'),
('392079', '-- Z ostatných derivátov celulózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392079'),
('39207910', '--- Z vulkanizovaného vlákna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39207910'),
('39207990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39207990'),
('39207990:2X', '- Z ostatných plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39207990:2X'),
('39209100', '-- Z polyvinylbutyralu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209100'),
('39209200', '-- Z polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209200'),
('39209300', '-- Z amínových živíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209300'),
('39209400', '-- Z fenolových živíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209400'),
('392099', '-- Z ostatných plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392099'),
('392099:2X', '--- Z kondenzačných alebo preskupených polymerizačných produktov, tiež chemicky modifikovaných', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392099:2X'),
('39209921', '---- Polyimidové fólie a pásky, tiež potiahnuté, alebo pokryté len plastmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209921'),
('39209928', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209928'),
('39209928:2X', '--- Z adičných polymerizačných produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209928:2X'),
('39209952', '---- Polyvinylfluoridové fólie; biaxiálne orientovaný polyvinylalkoholový film obsahujúci v hmotnosti 97 % alebo viac polyvinylalkoholu, nepotiahnutý, s hrúbkou nepresahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209952'),
('39209953', '---- Ionomeničové membrány z fluórovaných plastových materiálov, na použitie v chlóralkalických elektrolytických článkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209953'),
('39209959', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209959'),
('39209990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39209990'),
('3921', 'Ostatné platne, listy, filmy, fólie, pásy a pásky, z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3921'),
('3921:2X', '- Ľahčené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3921:2X'),
('39211100', '-- Z polymérov styrénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39211100'),
('39211200', '-- Z polymérov vinylchloridu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39211200'),
('392113', '-- Z polyuretánov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392113'),
('39211310', '--- Ohybné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39211310'),
('39211390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39211390'),
('39211400', '-- Z regenerovanej celulózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39211400'),
('39211900', '-- Z ostatných plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39211900'),
('392190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392190'),
('392190:2X', '-- Z kondenzačných alebo preskupených polymerizačných produktov, tiež chemicky modifikovaných', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392190:2X'),
('39219010', '--- Z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219010'),
('39219030', '--- Z fenolových živíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219030'),
('39219030:2X', '--- Z aminoživíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219030:2X'),
('39219030:3X', '---- Laminované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219030:3X'),
('39219041', '----- Vysokotlakové lamináty s dekoratívnym povrchom na jednej alebo oboch stranách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219041'),
('39219043', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219043'),
('39219049', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219049'),
('39219055', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219055'),
('39219060', '-- Z adičných polymerizačných produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219060'),
('39219090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39219090'),
('3922', 'Kúpacie vane, sprchy, výlevky, umývadlá, bidety, záchodové misy, sedadlá a kryty, splachovacie nádrže a podobné sanitárne výrobky, z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3922'),
('39221000', '- Kúpacie vane, sprchy, výlevky a umývadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39221000'),
('39222000', '- Záchodové sedadlá a kryty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39222000'),
('39229000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39229000'),
('3923', 'Výrobky z plastov na prepravu alebo balenie tovaru; zátky, viečka, uzávery fliaš a ostatné uzávery, z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3923'),
('39231000', '- Škatule, debny, prepravky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39231000'),
('39231000:2X', '- Vrecia a vrecká (vrátane kornútov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39231000:2X'),
('39232100', '-- Z polymérov etylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39232100'),
('392329', '-- Z ostatných plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392329'),
('39232910', '--- Z polyvinylchloridu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39232910'),
('39232990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39232990'),
('392330', '- Demižóny, fľaše, flakóny a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392330'),
('39233010', '-- S obsahom nepresahujúcim 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_39233010'),
('39233090', '-- S obsahom presahujúcim 2 litre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_39233090'),
('392340', '- Cievky, dutinky, potáče a podobné nosiče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392340'),
('39234010', '-- Cievky, navíjacie bubny a podobné nosiče na fotografické a kinematografické filmy alebo na pásky, filmy a podobné výrobky položky 8523', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39234010'),
('39234090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39234090'),
('392350', '- Zátky, viečka, uzávery fliaš a ostatné uzávery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392350'),
('39235010', '-- Uzávery a čiapočky na fľaše', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39235010'),
('39235090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39235090'),
('39239000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39239000'),
('3924', 'Stolový riad, kuchynský riad a ostatné potreby pre domácnosť a hygienické alebo toaletné potreby, z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3924'),
('39241000', '- Stolový a kuchynský riad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39241000'),
('39249000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39249000'),
('3925', 'Stavebné výrobky z plastov, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3925'),
('39251000', '- Nádrže, zásobníky, sudy a podobné nádoby, s obsahom presahujúcim 300 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39251000'),
('39252000', '- Dvere, okná a ich rámy a prahy do dverí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_39252000'),
('39253000', '- Okenice, rolety (vrátane žalúzií) a podobné výrobky a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39253000'),
('392590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392590'),
('39259010', '-- Príslušenstvo a kovanie, určené na trvalé upevnenie do alebo na dvere, okná, schodiská, steny alebo ostatné časti budov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39259010'),
('39259020', '-- Káblové profily, potrubie a nosiče káblov pre elektrické obvody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39259020'),
('39259080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39259080'),
('3926', 'Ostatné výrobky z plastov a výrobky z ostatných materiálov položiek 3901 až 3914', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_3926'),
('39261000', '- Kancelárske alebo školské potreby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39261000'),
('39262000', '- Odevy a odevné doplnky (vrátane prstových rukavíc, palčiakov a rukavíc bez prstov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39262000'),
('39263000', '- Príslušenstvo k nábytku, karosériám alebo podobným výrobkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39263000'),
('39264000', '- Sošky a ostatné ozdobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39264000'),
('392690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_392690'),
('39269050', '-- Perforované koše a podobné výrobky používané na filtráciu vody pri vstupe do odtokových kanálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39269050'),
('39269050:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39269050:2X'),
('39269092', '--- Vyrábané z fólií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39269092'),
('39269097', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_39269097'),
('4001', 'Prírodný kaučuk, balata, gutaperča, guajal, tropická živica (chicle) a podobné prírodné gumy v primárnych formách alebo v platniach, listoch alebo pásoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4001'),
('40011000', '- Latex z prírodného kaučuku, tiež predvulkanizovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40011000'),
('40011000:2X', '- Prírodný kaučuk v ostatných formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40011000:2X'),
('40012100', '-- Údený kaučuk v listoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40012100'),
('40012200', '-- Technicky špecifikovaný prírodný kaučuk (TSNR)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40012200'),
('40012900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40012900'),
('40013000', '- Balata, gutaperča, guajal, tropická živica (chicle) a podobné prírodné gumy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40013000'),
('4002', 'Syntetický kaučuk a faktis získaný z olejov, v primárnych formách alebo platniach, listoch alebo pásoch; zmesi výrobkov položky 4001 s výrobkami tejto položky, v primárnych formách alebo platniach, listoch, platniach alebo pásoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4002'),
('4002:2X', '- Styrén-butadiénový kaučuk (SBR); karboxylovaný styrén-butadiénový kaučuk (XSBR)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4002:2X'),
('40021100', '-- Latex', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40021100'),
('400219', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_400219'),
('40021910', '--- Styrén-butadiénový kaučuk vyrobený emulznou polymerizáciou (E-SBR), v baloch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40021910'),
('40021920', '--- Styrén-butadién-styrénové blokové kopolyméry vyrobené roztokovou polymerizáciou (SBS, termoplastické elastoméry) v granuliach, drvine alebo prášku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40021920'),
('40021930', '--- Styrén-butadiénový kaučuk vyrobený roztokovou polymerizáciou (S-SBR), v baloch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40021930'),
('40021990', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40021990'),
('40022000', '- Butadiénový kaučuk (BR)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40022000'),
('40022000:2X', '- Izobutén-izoprénový (butylový) kaučuk (IIR); halogénovaný izobutén- izoprénový kaučuk (CIIR alebo BIIR)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40022000:2X'),
('40023100', '-- Izobutén-izoprénový (butylový) kaučuk (IIR)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40023100'),
('40023900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40023900'),
('40023900:2X', '- Chlóroprénový (chlórbutadiénový) kaučuk (CR)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40023900:2X'),
('40024100', '-- Latex', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40024100'),
('40024900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40024900'),
('40024900:2X', '- Akrylonitril-butadiénový kaučuk (NBR)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40024900:2X'),
('40025100', '-- Latex', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40025100'),
('40025900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40025900'),
('40026000', '- Izoprénový kaučuk (IR)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40026000'),
('40027000', '- Nekonjugovaný etylén-propylén-diénový kaučuk (EDPM)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40027000'),
('40028000', '- Zmesi akéhokoľvek výrobku položky 4001 s akýmkoľvek výrobkom tejto položky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40028000'),
('40028000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40028000:2X'),
('40029100', '-- Latex', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40029100'),
('400299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_400299'),
('40029910', '--- Výrobky modifikované zakomponovaním plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40029910'),
('40029990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40029990'),
('40030000', 'Regenerovaný kaučuk v primárnych formách alebo platniach, listoch alebo pásoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40030000'),
('40040000', 'Odpady, úlomky a odrezky kaučuku (iné ako z tvrdeného kaučuku) a prášky a granuly z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40040000'),
('4005', 'Zmiešané kaučuky, nevulkanizované, v primárnych formách alebo platniach, listoch alebo pásoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4005'),
('40051000', '- Zmiešané so sadzami alebo oxidom kremičitým', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40051000'),
('40052000', '- Roztoky; disperzie, iné ako podpoložky 4005 10', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40052000'),
('40052000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40052000:2X'),
('40059100', '-- Platne, listy a pásy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40059100'),
('40059900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40059900'),
('4006', 'Ostatné formy (napríklad tyče, rúrky a profily) a výrobky (napríklad kotúče a krúžky) z nevulkanizovaného kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4006'),
('40061000', '- Pásy "camel - back" používané na protektorovanie pneumatík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40061000'),
('40069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40069000'),
('40070000', 'Nite a kordy, z vulkanizovaného kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40070000'),
('4008', 'Platne, listy, pásy, tyče a profily z vulkanizovaného kaučuku, iného ako tvrdeného kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4008'),
('4008:2X', '- Z ľahčeného kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4008:2X'),
('40081100', '-- Platne, listy a pásy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40081100'),
('40081900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40081900'),
('40081900:2X', '- Z neľahčeného kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40081900:2X'),
('400821', '-- Platne, listy a pásy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_400821'),
('40082110', '--- Podlahové krytiny a rohože', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_40082110'),
('40082190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40082190'),
('40082900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40082900'),
('4009', 'Rúry, rúrky a hadice z vulkanizovaného kaučuku, iného ako tvrdeného kaučuku, tiež s príslušenstvom (napríklad spojmi, kolenami, prírubami)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4009'),
('4009:2X', '- Nespevnené alebo inak nekombinované s ostatnými materiálmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4009:2X'),
('40091100', '-- Bez príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40091100'),
('40091200', '-- S príslušenstvom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40091200'),
('40091200:2X', '- Spevnené alebo inak kombinované len s kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40091200:2X'),
('40092100', '-- Bez príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40092100'),
('40092200', '-- S príslušenstvom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40092200'),
('40092200:2X', '- Spevnené alebo inak kombinované len s textilnými materiálmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40092200:2X'),
('40093100', '-- Bez príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40093100'),
('40093200', '-- S príslušenstvom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40093200'),
('40093200:2X', '- Spevnené alebo inak kombinované s ostatnými materiálmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40093200:2X'),
('40094100', '-- Bez príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40094100'),
('40094200', '-- S príslušenstvom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40094200'),
('4010', 'Dopravníkové alebo hnacie pásy alebo remene, z vulkanizovaného kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4010'),
('4010:2X', '- Dopravníkové pásy alebo remene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4010:2X'),
('40101100', '-- Spevnené len kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40101100'),
('40101200', '-- Spevnené len textilnými materiálmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40101200'),
('40101900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40101900'),
('40101900:2X', '- Hnacie pásy alebo remene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40101900:2X'),
('40103100', '-- Nekonečné hnacie pásy s lichobežníkovým prierezom (V-pásy), V-drážkované s vonkajším obvodom presahujúcim 60 cm, ale nepresahujúcim 180 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40103100'),
('40103200', '-- Nekonečné hnacie pásy s lichobežníkovým prierezom (V-pásy), iné ako V-drážkované s vonkajším obvodom presahujúcim 60 cm, ale nepresahujúcim 180 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40103200'),
('40103300', '-- Nekonečné hnacie pásy s lichobežníkovým prierezom (V-pásy), V-drážkované s vonkajším obvodom presahujúcim 180 cm, ale nepresahujúcim 240 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40103300'),
('40103400', '-- Nekonečné hnacie pásy s lichobežníkovým prierezom (V-pásy), iné ako V-drážkované, s vonkajším obvodom presahujúcim 180 cm, ale nepresahujúcim 240 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40103400'),
('40103500', '-- Nekonečné synchrónne pásy, s vonkajším obvodom presahujúcim 60 cm, ale nepresahujúcim 150 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40103500'),
('40103600', '-- Nekonečné synchrónne pásy, s vonkajším obvodom presahujúcim 150 cm, ale nepresahujúcim 198 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40103600'),
('40103900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40103900'),
('4011', 'Nové pneumatiky, z kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4011'),
('40111000', '- Druhov používaných na osobné motorové vozidlá (vrátane dodávkových automobilov a pretekárskych automobilov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40111000'),
('401120', '- Druhov používaných na autobusy alebo nákladné automobily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_401120'),
('40112010', '-- S indexom zaťaženia nepresahujúcim 121', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40112010'),
('40112090', '-- S indexom zaťaženia presahujúcim 121', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40112090'),
('40113000', '- Druhov používaných na lietadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40113000'),
('40114000', '- Druhov používaných na motocykle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40114000'),
('40115000', '- Druhov používaných na bicykle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40115000'),
('40115000:2X', '- Ostatné, so vzorom "rybia kosť" alebo podobným dezénom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40115000:2X'),
('40116100', '-- Druhov používaných na poľnohospodárske alebo lesné vozidlá a stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40116100'),
('40116200', '-- Druhov používaných na stavebné alebo priemyselné manipulačné vozidlá a stroje s priemerom ráfika nepresahujúcim 61 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40116200'),
('40116300', '-- Druhov používaných na stavebné alebo priemyselné manipulačné vozidlá a stroje s priemerom ráfika presahujúcim 61 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40116300'),
('40116900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40116900'),
('40116900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40116900:2X'),
('40119200', '-- Druhov používaných na poľnohospodárske alebo lesné vozidlá a stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40119200'),
('40119300', '-- Druhov používaných na stavebné alebo priemyselné manipulačné vozidlá a stroje s priemerom ráfika nepresahujúcim 61 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40119300'),
('40119400', '-- Druhov používaných na stavebné alebo priemyselné manipulačné vozidlá a stroje s priemerom ráfika presahujúcim 61 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40119400'),
('40119900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40119900'),
('4012', 'Protektorované alebo použité pneumatiky z kaučuku; plné obruče alebo komorové obruče, behúne plášťa pneumatiky a ochranné vložky do ráfika pneumatiky, z kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4012'),
('4012:2X', '- Protektorované pneumatiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4012:2X'),
('40121100', '-- Druhov používaných na osobné automobily (vrátane dodávkových a pretekárskych automobilov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40121100'),
('40121200', '-- Druhov používaných na osobné autobusy alebo nákladné automobily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40121200'),
('40121300', '-- Druhov používaných na lietadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40121300'),
('40121900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40121900'),
('40122000', '- Použité pneumatiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40122000'),
('401290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_401290'),
('40129020', '-- Plné alebo komorové obruče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40129020'),
('40129030', '-- Behúne plášťov pneumatík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40129030'),
('40129090', '-- Ochranné vložky do ráfika pneumatiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40129090'),
('4013', 'Duše pneumatík, z kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4013'),
('40131000', '- Druhov používaných na osobné motorové vozidlá (vrátane dodávkových a pretekárskych automobilov), na autobusy alebo nákladné automobily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40131000'),
('40132000', '- Druhov používaných na bicykle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40132000'),
('40139000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_40139000'),
('4014', 'Hygienický alebo farmaceutický tovar (vrátane cumlíkov), z vulkanizovaného kaučuku iného ako tvrdeného kaučuku, tiež s príslušenstvom z tvrdeného kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4014'),
('40141000', '- Antikoncepčné ochranné prostriedky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40141000'),
('40149000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40149000'),
('4015', 'Odevy a odevné doplnky (vrátane prstových rukavíc, palčiakov a rukavíc bez prstov), z vulkanizovaného kaučuku iného ako tvrdená guma, na akékoľvek účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4015'),
('4015:2X', '- Prstové rukavice, palčiaky a rukavice bez prstov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4015:2X'),
('40151100', '-- Chirurgické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_40151100'),
('40151900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_40151900'),
('40159000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40159000'),
('4016', 'Ostatné výrobky z vulkanizovaného kaučuku iného ako tvrdená guma', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4016'),
('40161000', '- Z ľahčeného kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40161000'),
('40161000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40161000:2X'),
('40169100', '-- Podlahové krytiny a rohože', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169100'),
('40169200', '-- Gumy na vymazávanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169200'),
('40169300', '-- Ploché tesnenia, podložky a ostatné krúžky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169300'),
('40169400', '-- Nárazníky na pristávanie lodí a člnov, tiež nafukovacie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169400'),
('40169500', '-- Ostatné nafukovacie výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169500'),
('401699', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_401699'),
('401699:2X', '--- Na motorové vozidlá položiek 8701 až 8705', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_401699:2X'),
('40169952', '---- Z kaučuku spájaného s kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169952'),
('40169957', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169957'),
('40169957:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169957:2X'),
('40169991', '---- Z kauťuku spájaného s kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169991'),
('40169997', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40169997'),
('40170000', 'Tvrdený kaučuk (napríklad ebonit) vo všetkých formách, vrátane odpadu a zvyškov; výrobky z tvrdeného kaučuk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_40170000'),
('4101', 'Surové kože a kožky z hovädzích zvierat (vrátane byvolov) alebo koňovitých zvierat (čerstvé alebo solené, sušené, vápnené, piklované alebo inak konzervované, ale nevyčinené, nespracované na pergamen ani inak neupravené), tiež odchlpené alebo štiepané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4101'),
('410120', '- Celé kože a kožky, neštiepané, s jednotkovou hmotnosťou nepresahujúcou 8 kg, ak sú sušené jednoduchým spôsobom, 10 kg, ak sú suchosolené, alebo 16 kg , ak sú čerstvé, mokrosolené alebo inak konzervované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410120'),
('41012010', '-- Čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41012010'),
('41012030', '-- Mokrosolené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41012030'),
('41012050', '-- Suché alebo suchosolené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41012050'),
('41012080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41012080'),
('410150', '- Celé kože a kožky, s hmotnosťou presahujúcou 16 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410150'),
('41015010', '-- Čerstvé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41015010'),
('41015030', '-- Mokrosolené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41015030'),
('41015050', '-- Suché alebo suchosolené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41015050'),
('41015090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41015090'),
('41019000', '- Ostatné, vrátane krupónov, polokrupónov a krajín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41019000'),
('4102', 'Surové kožky z oviec alebo jahniat (čerstvé alebo solené, sušené, vápnené, piklované alebo inak konzervované, ale nevyčinené, nespracované na pergamen ani inak neupravené), tiež odchlpené alebo štiepané, iné ako kožky vylúčené poznámkou 1 c) k tejto kap', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4102'),
('410210', '- S vlnou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410210'),
('41021010', '-- Z jahniat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41021010'),
('41021090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41021090'),
('41021090:2X', '- Bez vlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41021090:2X'),
('41022100', '-- Piklované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41022100'),
('41022900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41022900'),
('4103', 'Ostatné surové kože a kožky (čerstvé alebo solené, sušené, vápnené, piklované alebo inak konzervované, ale nevyčinené, nespracované na pergamen ani inak neupravené), tiež odchlpené alebo štiepané, iné ako kože a kožky vylúčené poznámkou 1 b) alebo 1 c)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4103'),
('41032000', '- Z plazov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41032000'),
('41033000', '- Zo svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41033000'),
('41039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41039000'),
('4104', 'Činené alebo krustované kože a kožky z hovädzích zvierat (vrátane byvolov) alebo koňovitých zvierat, odchlpené, tiež štiepané, ale inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4104'),
('4104:2X', '- V mokrom stave (vrátane wet-blue)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4104:2X'),
('410411', '-- Plné lícové, neštiepané; lícové štiepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410411'),
('41041110', '--- Celé kože a kožky z hovädzích zvierat (vrátane byvolov), s povrchovou plochou nepresahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41041110'),
('41041110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41041110:2X'),
('41041110:3X', '---- Z hovädzích zvierat (vrátane byvolov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41041110:3X'),
('41041151', '----- Celé kože a kožky, s povrchovou plochou presahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41041151'),
('41041159', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41041159'),
('41041190', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41041190'),
('410419', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410419'),
('41041910', '--- Celé kože a kožky z hovädzích zvierat (vrátane byvolov), s povrchovou plochou nepresahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41041910'),
('41041910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41041910:2X'),
('41041910:3X', '---- Z hovädzích zvierat (vrátane byvolov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41041910:3X'),
('41041951', '----- Celé kože a kožky, s povrchovou plochou presahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41041951'),
('41041959', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41041959'),
('41041990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41041990'),
('41041990:2X', '- V suchom stave (krustované)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41041990:2X'),
('410441', '-- Plné lícové, neštiepané; lícové štiepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410441'),
('410441:2X', '--- Celé kože a kožky z hovädzích zvierat (vrátane byvolov), s povrchovou plochou nepresahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410441:2X'),
('41044111', '---- Východoindický kip, celý, tiež ak boli odstránené hlavy a nohy, ktorého čistá hmotnosť každej kože nie je väčšia ako 4,5 kg, ďalej upravené len činením rastlinným činidlom, tiež ďalej opracované, avšak zrejme nepoužiteľné na bezprostrednú výrobu pre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044111'),
('41044119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044119'),
('41044119:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41044119:2X'),
('41044119:3X', '---- Z hovädzích zvierat (vrátane byvolov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41044119:3X'),
('41044151', '----- Celé kože a kožky, s povrchovou plochou presahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044151'),
('41044159', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044159'),
('41044190', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044190'),
('410449', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410449'),
('410449:2X', '--- Celé kože a kožky z hovädzích zvierat (vrátane byvolov), s povrchovou plochou nepresahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410449:2X'),
('41044911', '---- Východoindický kip, celý, tiež ak boli odstránené hlavy a nohy, ktorého čistá hmotnosť každej kože nie je väčšia ako 4,5 kg, ďalej upravené len činením rastlinným činidlom, tiež ďalej opracované, avšak zrejme nepoužiteľné na bezprostrednú výrobu pre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044911'),
('41044919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044919'),
('41044919:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41044919:2X'),
('41044919:3X', '---- Z hovädzích zvierat (vrátane byvolov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41044919:3X'),
('41044951', '----- Celé kože a kožky, s povrchovou plochou presahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044951'),
('41044959', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044959'),
('41044990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41044990'),
('4105', 'Činené alebo krustované kože z oviec alebo jahniat, bez vlny, tiež štiepané, ale inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4105'),
('41051000', '- V mokrom stave (vrátane wet-blue)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41051000'),
('410530', '- V suchom stave (krustované)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410530'),
('41053010', '-- Z indických jemnovlnných oviec, predčinené rastlinnými činidlami, tiež opracované, avšak zrejme nepoužiteľné na bezprostrednú výrobu predmetov z usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41053010'),
('41053090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41053090'),
('4106', 'Činené alebo krustované kože a kožky z ostatných zvierat, odchlpené, tiež štiepané, ale inak neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4106'),
('4106:2X', '- Z kôz alebo kozliat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4106:2X'),
('41062100', '-- V mokrom stave (vrátane wet-blue)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41062100'),
('410622', '-- V suchom stave (krustované)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410622'),
('41062210', '--- Z indických jemnovlnných kôz alebo kozliat, predčinené rastlinnými činidlami, tiež opracované, avšak zrejme nepoužiteľné na bezprostrednú výrobu predmetov z usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41062210'),
('41062290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41062290'),
('41062290:2X', '- Zo svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41062290:2X'),
('41063100', '-- V mokrom stave (vrátane wet-blue)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41063100'),
('41063200', '-- V suchom stave (krustované)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41063200'),
('410640', '- Z plazov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410640'),
('41064010', '-- Predčinené rastlinnými činidlami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41064010'),
('41064090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41064090'),
('41064090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41064090:2X'),
('41069100', '-- V mokrom stave (vrátane wet-blue)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41069100'),
('41069200', '-- V suchom stave (krustované)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41069200'),
('4107', 'Usne ďalej upravené po činení alebo krustovaní, vrátane pergamenových usní, z hovädzích zvierat (vrátane byvolov) alebo koňovitých zvierat, odchlpené, tiež štiepané, iné ako usne položky 4114', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4107'),
('4107:2X', '- Celé usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4107:2X'),
('410711', '-- Plné lícové, neštiepané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410711'),
('410711:2X', '--- Hovädzie usne (vrátane byvolích), s povrchovou plochou nepresahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410711:2X'),
('41071111', '---- Teľacinový box', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41071111'),
('41071119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41071119'),
('41071190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41071190'),
('410712', '-- Lícové štiepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410712'),
('410712:2X', '--- Hovädzie usne (vrátane byvolích), s povrchovou plochou nepresahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410712:2X'),
('41071211', '---- Teľacinový box', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41071211'),
('41071219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41071219'),
('41071219:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41071219:2X'),
('41071291', '---- Hovädzie usne (vrátane byvolích)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41071291'),
('41071299', '---- Konské usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41071299'),
('410719', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410719'),
('41071910', '--- Hovädzie usne (vrátane byvolích), s povrchovou plochou nepresahujúcou 28 štvorcových stôp (2,6 m2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41071910'),
('41071990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41071990'),
('41071990:2X', '- Ostatné, vrátane bokov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41071990:2X'),
('410791', '-- Plné lícové, neštiepané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410791'),
('41079110', '--- Podrážkové usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41079110'),
('41079190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41079190'),
('410792', '-- Lícové štiepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410792'),
('41079210', '--- Hovädzie usne (vrátane byvolích)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41079210'),
('41079290', '--- Konské usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41079290'),
('410799', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_410799'),
('41079910', '--- Hovädzie usne (vrátane byvolích)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41079910'),
('41079990', '--- Konské usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41079990'),
('41120000', 'Usne ďalej upravené po činení alebo krustovaní, vrátane pergamenových usní, z oviec alebo jahniat, odchlpené, tiež štiepané, iné ako usne položky 4114', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41120000'),
('4113', 'Usne ďalej upravené po činení alebo krustovaní, vrátane pergamenových usní, z ostatných zvierat, bez vlny alebo odchlpené, tiež štiepané, iné ako usne položky 4114', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4113'),
('41131000', '- Z kôz alebo kozliat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41131000'),
('41132000', '- Zo svíň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41132000'),
('41133000', '- Z plazov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41133000'),
('41139000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41139000'),
('4114', 'Semišové usne (vrátane kombinovaného semiša); lakové usne a lakové laminované usne; metalizované usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4114'),
('411410', '- Semišové usne (vrátane kombinovaného semišu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_411410'),
('41141010', '-- Z oviec alebo jahniat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41141010'),
('41141090', '-- Z ostatných zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_41141090'),
('41142000', '- Lakové usne a lakové laminované usne; metalizované usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_41142000'),
('4115', 'Kompozitné usne na základe usní alebo usňových vlákien, v doskách, listoch alebo pásoch, tiež vo zvitkoch; odrezky a ostatné zvyšky z usní alebo kompozitných usní, nepoužiteľné na výrobu predmetov z usní; kožené piliny, prach a múčka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4115'),
('41151000', '- Kompozitné usne na základe usní alebo usňových vlákien, v doskách, listoch alebo pásoch, tiež vo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41151000'),
('41152000', '- Odrezky a ostané zvyšky z usní alebo z kompozitných usní, nepoužiteľné na výrobu predmetov z usní; kožené piliny, prach a múčka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_41152000'),
('42010000', 'Sedlárske a remenárske výrobky pre akékoľvek zviera (vrátane postranníc, vodidiel, nákolenníc, náhubkov, pokrývok pod sedlá, sedlových puzdier, pokrývok na psov a podobných výrobkov), z akéhokoľvek materiálu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42010000'),
('4202', 'Lodné kufre, cestovné kufre, puzdrá na toaletné potreby, diplomatky, aktovky, školské tašky, puzdrá na okuliare, puzdrá na ďalekohľady, puzdrá na divadelné ďalekohľady, puzdrá na fotografické prístroje a kamery, puzdrá na hudobné nástroje, puzdrá na puš', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4202'),
('4202:2X', '- Lodné kufre, cestovné kufre, puzdrá na toaletné potreby, diplomatky, aktovky, školské tašky a podobné schránky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4202:2X'),
('420211', '-- S vonkajším povrchom z usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420211'),
('42021110', '--- Diplomatky, aktovky, školské tašky a podobné schránky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_42021110'),
('42021190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42021190'),
('420212', '-- S vonkajším povrchom z plastov alebo textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420212'),
('420212:2X', '--- Vo forme plastových fólií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420212:2X'),
('42021211', '---- Diplomatky, aktovky, školské tašky a podobné schránky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_42021211'),
('42021219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42021219'),
('42021250', '--- Z tvarovaných plastových materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42021250'),
('42021250:2X', '--- Z ostatných materiálov, vrátane vulkánfíbra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42021250:2X'),
('42021291', '---- Diplomatky, aktovky, školské tašky a podobné schránky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_42021291'),
('42021299', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42021299'),
('420219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420219'),
('42021910', '--- Z hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42021910'),
('42021990', '--- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42021990'),
('42021990:2X', '- Kabely a kabelky, tiež so závesným remeňom, vrátane kabeliek bez držadla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42021990:2X'),
('42022100', '-- S vonkajším povrchom z usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_42022100'),
('420222', '-- S vonkajším povrchom z plastových fólií alebo textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420222'),
('42022210', '--- Z plastových fólií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_42022210'),
('42022290', '--- Z textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_42022290'),
('42022900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_42022900'),
('42022900:2X', '- Výrobky druhov nosených obvykle vo vrecku alebo v kabelke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42022900:2X'),
('42023100', '-- S vonkajším povrchom z usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42023100'),
('420232', '-- S vonkajším povrchom z plastových fólií alebo textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420232'),
('42023210', '--- Z plastových fólií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42023210'),
('42023290', '--- Z textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42023290'),
('42023900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42023900'),
('42023900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42023900:2X'),
('420291', '-- S vonkajším povrchom z usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420291'),
('42029110', '--- Cestovné tašky, tašky na toaletné potreby, plecniaky a športové tašky a vaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42029110'),
('42029180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42029180'),
('420292', '-- S vonkajším povrchom z plastových fólií alebo textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420292'),
('420292:2X', '--- Z plastových fólií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420292:2X'),
('42029211', '---- Cestovné tašky, tašky na toaletné potreby, plecniaky a športové tašky a vaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42029211'),
('42029215', '---- Puzdrá na hudobné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42029215'),
('42029219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42029219'),
('42029219:2X', '--- Z textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42029219:2X'),
('42029291', '---- Cestovné tašky, tašky na toaletné potreby, plecniaky a športové tašky a vaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42029291'),
('42029298', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42029298'),
('42029900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42029900'),
('4203', 'Odevy a odevné doplnky, z usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4203'),
('42031000', '- Odevy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42031000'),
('42031000:2X', '- Prstové rukavice, rukavice bez prstov a palčiaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42031000:2X'),
('42032100', '-- Špeciálne určené na použitie v športe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_42032100'),
('420329', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420329'),
('42032910', '--- Ochranné pre všetky profesie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_42032910'),
('42032990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_42032990'),
('42033000', '- Pásy, opasky a závesné remene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42033000'),
('42034000', '- Ostatné odevné doplnky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42034000'),
('420500', 'Ostatné výrobky z usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420500'),
('420500:2X', '- Druhov používaných v strojoch, prístrojoch alebo mechanických zariadeniach alebo na ostatné technické použitie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_420500:2X'),
('42050011', '-- Dopravníkové alebo hnacie pásy alebo remene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42050011'),
('42050019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42050019'),
('42050090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42050090'),
('42060000', 'Výrobky z čriev (iné ako mesinský vlas), zo zlatotepeckej blany, z mechúrov alebo zo šliach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_42060000'),
('4301', 'Surové kožušiny (vrátane hláv, chvostov, nôžok a ostatných kúskov alebo odrezkov, vhodných na použitie v kožušníctve), iné ako surové kože a kožky položky 4101, 4102 alebo 4103', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4301'),
('43011000', '- Z noriek, celé, tiež bez hláv, chvostov alebo nôžok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43011000'),
('43013000', '- Z nasledujúcich jahniat: astrachánskych, broadtailových, karakulských, perziánových a podobných jahniat, jahniat indických, čínskych, mongolských alebo tibetských, celé, tiež bez hláv, chvostov alebo nôžok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43013000'),
('43016000', '- Z líšok, celé, tiež bez hláv, chvostov alebo nôžok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43016000'),
('43018000', '- Ostatné kožušiny, celé, tiež bez hláv, chvostov alebo nôžok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43018000'),
('43019000', '- Hlavy, chvosty, nôžky a ostatné kúsky alebo odrezky, vhodné na použitie v kožušníctve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43019000'),
('4302', 'Vyčinené alebo upravené kožušiny (vrátane hláv, chvostov, nôžok a ostatných kúskov alebo odrezkov), nespájané alebo spájané (bez pridania ostatných materiálov), iné ako kožušiny položky 4303', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4302'),
('4302:2X', '- Celé kožušiny, tiež bez hláv, chvostov alebo nôžok, nespájané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4302:2X'),
('43021100', '-- Z noriek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43021100'),
('430219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_430219'),
('43021915', '--- Z bobrov, ondatier alebo líšok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43021915'),
('43021935', '--- Z králikov alebo zajacov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43021935'),
('43021935:2X', '--- Z tuleňov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43021935:2X'),
('43021941', '---- Z mláďat tuleňov grónskych alebo mláďat tuleňov krúžkovaných', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43021941'),
('43021949', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43021949'),
('43021949:2X', '--- Z oviec alebo jahniat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43021949:2X'),
('43021975', '---- Z nasledujúcich jahniat: astrachánskych, broadtailových, karakulských, perziánových a podobných jahniat, jahniat indických, čínskych, mongolských alebo tibetských', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43021975'),
('43021980', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43021980'),
('43021999', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43021999'),
('43022000', '- Hlavy, chvosty, nôžky a ostatné kúsky alebo odrezky, nespájané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43022000'),
('430230', '- Celé kožušiny a kúsky alebo odrezky z nich, spájané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_430230'),
('43023010', '-- "Vypúšťané" kožušiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43023010'),
('43023010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43023010:2X'),
('43023025', '--- Z králikov alebo zajacov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43023025'),
('43023025:2X', '--- Z tuleňov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43023025:2X'),
('43023051', '---- Z mláďat tuleňov grónskych alebo mláďat tuleňov krúžkovaných', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43023051'),
('43023055', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_43023055'),
('43023099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43023099'),
('4303', 'Odevy, odevné doplnky a ostatné výrobky z kožušín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4303'),
('430310', '- Odevy a odevné doplnky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_430310'),
('43031010', '-- Z kožušín mláďat tuleňov grónskych alebo mláďat tuleňov krúžkovaných', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43031010'),
('43031090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43031090'),
('43039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43039000'),
('43040000', 'Umelé kožušiny a výrobky z nich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_43040000'),
('4401', 'Palivové drevo, v polenách, klátoch, konároch, viazaniciach alebo podobných formách; štiepky alebo triesky z dreva; piliny, zvyšky a odpad z dreva, tiež aglomerované v tvare klátov, brikiet, peliet alebo podobných formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4401'),
('44011000', '- Palivové drevo, v polenách, klátoch, konároch, viazaniciach alebo podobných formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44011000'),
('44011000:2X', '- Štiepky alebo triesky z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44011000:2X'),
('44012100', '-- Ihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44012100'),
('44012200', '-- Neihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44012200'),
('44012200:2X', '- Piliny, zvyšky a odpad z dreva, tiež aglomerované v tvare klátov, brikiet, peliet alebo podobných formách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44012200:2X'),
('44013100', '-- Drevené pelety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44013100'),
('440139', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440139'),
('44013910', '--- Piliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44013910'),
('44013990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44013990'),
('4402', 'Drevné uhlie (vrátane uhlia zo škrupín alebo orechov), tiež aglomerované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4402'),
('44021000', '- Z bambusu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44021000'),
('44029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44029000'),
('4403', 'Surové drevo, tiež odkôrnené alebo zbavené drevnej beli, alebo hrubo opracované do štvorcových tvarov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4403'),
('44031000', '- Natierané alebo impregnované farbou, moridlom, kreozotom alebo ostatnými ochrannými prostriedkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44031000'),
('440320', '- Ostatné, ihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440320'),
('440320:2X', '-- Smrekové drevo druhu "Picea abies Karst." alebo drevo z jedle striebornej (Abies alba Mill.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440320:2X'),
('44032011', '--- Píliarska guľatina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44032011'),
('44032019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44032019'),
('44032019:2X', '-- Borovicové drevo druhu "Pinus sylvestris L."', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44032019:2X'),
('44032031', '--- Píliarska guľatina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44032031'),
('44032039', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44032039'),
('44032039:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44032039:2X'),
('44032091', '--- Píliarska guľatina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44032091'),
('44032099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44032099'),
('44032099:2X', '- Ostatné, z druhov tropického dreva špecifikovaných v poznámke k podpoložkám 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44032099:2X'),
('44034100', '-- Tmavočervené meranti, svetločervené meranti a meranti bakau', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44034100'),
('440349', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440349'),
('44034910', '--- Acajou d''Afrique, iroko a sapelli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44034910'),
('44034935', '--- Okoumé a sipo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44034935'),
('44034995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44034995'),
('44034995:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44034995:2X'),
('440391', '-- Z duba (Quercus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440391'),
('44039110', '--- Píliarska guľatina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44039110'),
('44039190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44039190'),
('440392', '-- Z buka (Fagus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440392'),
('44039210', '--- Píliarska guľatina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44039210'),
('44039290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44039290'),
('440399', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440399'),
('44039910', '--- Z topoľa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44039910'),
('44039930', '--- Z eukalyptu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44039930'),
('44039930:2X', '--- Z brezy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44039930:2X'),
('44039951', '---- Píliarska guľatina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44039951'),
('44039959', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44039959'),
('44039995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44039995'),
('4404', 'Drevo na obruče; štiepané tyče; drevené koly, kolíky a stĺpiky, zašpicatené, pozdĺžne nerozrezané; drevené tyče, hrubo opracované, ale nesústružené, neohýbané ani inak opracované, vhodné na výrobu vychádzkových palíc, dáždnikov, násad nástrojov alebo po', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4404'),
('44041000', '- Ihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44041000'),
('44042000', '- Neihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44042000'),
('44050000', 'Drevitá vlna; drevitá múčka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44050000'),
('4406', 'Železničné alebo električkové podvaly (pražce) z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4406'),
('44061000', '- Neimpregnovamé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44061000'),
('44069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44069000'),
('4407', 'Drevo rezané alebo štiepané pozdĺžne, krájané alebo lúpané, tiež hobľované, brúsené pieskom alebo spájané na koncoch, s hrúbkou presahujúcou 6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4407'),
('440710', '- Ihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440710'),
('44071015', '-- Brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44071015'),
('44071015:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44071015:2X'),
('44071015:3X', '--- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44071015:3X'),
('44071031', '---- Smrekové drevo druhu "Picea abies Karst." alebo drevo zo striebornej jedle (Abies alba Mill.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44071031'),
('44071033', '---- Borovicové drevo druhu "Pinus sylvestris L."', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44071033'),
('44071038', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44071038'),
('44071038:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44071038:2X'),
('44071091', '---- Smrekové drevo druhu "Picea abies Karst." alebo drevo zo striebornej jedle (Abies alba Mill.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44071091'),
('44071093', '---- Borovicové drevo druhu "Pinus sylvestris L."', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44071093'),
('44071098', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44071098'),
('44071098:2X', '- Z druhov tropického dreva špecifikovaných v poznámke k podpoložkám 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44071098:2X'),
('440721', '-- Mahagónovník (Swietenia spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440721'),
('44072110', '--- Brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072110'),
('44072110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072110:2X'),
('44072191', '---- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072191'),
('44072199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072199'),
('440722', '-- Virola, imbuia a balsa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440722'),
('44072210', '--- Brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072210'),
('44072210:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072210:2X'),
('44072291', '---- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072291'),
('44072299', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072299'),
('440725', '-- Tmavočervené meranti, svetločervené meranti a meranti bakau', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440725'),
('44072510', '--- Spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072510'),
('44072510:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072510:2X'),
('44072530', '---- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072530'),
('44072550', '---- Brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072550'),
('44072590', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072590'),
('440726', '-- Biele lauan, biele meranti, biele seraya, žlté meranti a alan', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440726'),
('44072610', '--- Spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072610'),
('44072610:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072610:2X'),
('44072630', '---- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072630'),
('44072650', '---- Brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072650'),
('44072690', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072690'),
('440727', '-- Sapelli', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440727'),
('44072710', '--- Brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072710'),
('44072710:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072710:2X'),
('44072791', '---- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072791'),
('44072799', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072799'),
('440728', '-- Iroko', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440728'),
('44072810', '--- Brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072810'),
('44072810:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072810:2X'),
('44072891', '---- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072891'),
('44072899', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072899'),
('440729', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440729'),
('44072915', '--- Spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072915'),
('44072915:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072915:2X'),
('44072915:3X', '---- Acajou d''Afrique, azobé, dibétou, ilomba, jelutong, jongkong, kapur, kempas, keruing, limba, makoré, mansonia, merbau, obeche, okoumé, palissandre de Para, palissandre de Rio, palissandre de Rose, ramin, sipo, teak a tiama', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072915:3X'),
('44072915:4X', '----- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072915:4X'),
('44072920', '------ Palissandre de Para, palissandre de Rio a palissandre de Rose', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072920'),
('44072925', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072925'),
('44072945', '----- Brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072945'),
('44072960', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072960'),
('44072960:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072960:2X'),
('44072983', '----- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072983'),
('44072985', '----- Brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072985'),
('44072995', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44072995'),
('44072995:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44072995:2X'),
('440791', '-- Z duba (Quercus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440791'),
('44079115', '--- Brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079115'),
('44079115:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44079115:2X'),
('44079115:3X', '---- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44079115:3X'),
('44079131', '----- Parketové prírezy, doštičky a vlysy alebo drevené prírezy na podlahy, nezostavené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_44079131'),
('44079139', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079139'),
('44079190', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079190'),
('44079200', '-- Z buka (Fagus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079200'),
('440793', '-- Z javora (Acer spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440793'),
('44079310', '--- Hobľované; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079310'),
('44079310:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44079310:2X'),
('44079391', '---- Brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079391'),
('44079399', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079399'),
('440794', '-- Z čerešne alebo višne (Prunus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440794'),
('44079410', '--- Hobľované; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079410'),
('44079410:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44079410:2X'),
('44079491', '---- Brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079491'),
('44079499', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079499'),
('440795', '-- Z jaseňa (Fraxinus spp.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440795'),
('44079510', '--- Hobľované; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079510'),
('44079510:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44079510:2X'),
('44079591', '---- Brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079591'),
('44079599', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079599'),
('440799', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440799'),
('44079927', '--- Hobľované; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079927'),
('44079927:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44079927:2X'),
('44079940', '---- Brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079940'),
('44079940:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44079940:2X'),
('44079991', '----- Z topoľa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079991'),
('44079996', '----- Z tropického dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079996'),
('44079998', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44079998'),
('4408', 'Listy na dyhy (vrátane tých, ktoré boli získané lúpaním vrstveného dreva), listy na preglejky alebo na podobné vrstvené dosky a ostatné drevo, pozdĺžne rezané, krájané alebo lúpané, tiež hobľované, brúsené pieskom, pozdĺžne spájané alebo spájané na konc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4408'),
('440810', '- Ihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440810'),
('44081015', '-- Hobľované; brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44081015'),
('44081015:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44081015:2X'),
('44081091', '--- Ceruzkárske doštičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44081091'),
('44081098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44081098'),
('44081098:2X', '- Z druhov tropického dreva špecifikovaných v poznámke k podpoložkám 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44081098:2X'),
('440831', '-- Tmavočervené meranti, svetločervené meranti a meranti bakau', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440831'),
('44083111', '--- Spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083111'),
('44083111:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44083111:2X'),
('44083121', '---- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083121'),
('44083125', '---- Brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083125'),
('44083130', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083130'),
('440839', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440839'),
('440839:2X', '--- Acajou d''Afrique, limba, mahagónovnik (Swietenia spp.), obeche, okoumé, palissandre de Para, palissandre de Rio, palissandre de Rose, sapelli, sipo, virola a biele lauan', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440839:2X'),
('44083915', '---- Brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083915'),
('44083915:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44083915:2X'),
('44083921', '----- Hobľované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083921'),
('44083930', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083930'),
('44083930:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44083930:2X'),
('44083955', '---- Hobľované; brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083955'),
('44083955:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44083955:2X'),
('44083970', '----- Ceruzkárske doštičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083970'),
('44083970:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44083970:2X'),
('44083985', '------ S hrúbkou nepresahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083985'),
('44083995', '------ S hrúbkou presahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44083995'),
('440890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440890'),
('44089015', '-- Hobľované; brúsené pieskom; spájané na koncoch, tiež hobľované alebo brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44089015'),
('44089015:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44089015:2X'),
('44089035', '--- Ceruzkárske doštičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44089035'),
('44089035:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44089035:2X'),
('44089085', '---- S hrúbkou nepresahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44089085'),
('44089095', '---- S hrúbkou presahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44089095'),
('4409', 'Drevo (vrátane nezostavených doštičiek a vlysov na parketové podlahy), profilované (drážkované, žliabkované, s perami, skosené, spojené do V, vrúbkované, zaoblené alebo podobné) pozdĺž jednej alebo niekoľkých hrán, na koncoch alebo plochách, tiež hobľov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4409'),
('440910', '- Ihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440910'),
('44091011', '-- Tvarované na rámy obrazov, fotografií, zrkadiel alebo podobných predmetov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_44091011'),
('44091018', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44091018'),
('44091018:2X', '- Neihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44091018:2X'),
('44092100', '-- Z bambusu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44092100'),
('440929', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_440929'),
('44092910', '--- Tvarované na rámy obrazov, fotografií, zrkadiel alebo podobných predmetov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_44092910'),
('44092910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44092910:2X'),
('44092991', '---- Parketové prírezy, doštičky a vlysy alebo drevené prírezy na podlahy, nezostavené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_44092991'),
('44092999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44092999'),
('4410', 'Drevotrieskové dosky, orientované trieskové dosky (OSB) a podobné dosky (napríklad trieskové dosky) z dreva alebo ostatných drevitých materiálov, tiež aglomerované živicami alebo ostatnými organickými spojivami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4410'),
('4410:2X', '- Z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4410:2X'),
('441011', '-- Drevotrieskové dosky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441011'),
('44101110', '--- Neopracované alebo len brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44101110'),
('44101130', '--- Povrchovo upravené papierom impregnovaným melamínovou živicou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44101130'),
('44101150', '--- Povrchovo upravené dekoratívnymi laminátmi z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44101150'),
('44101190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44101190'),
('441012', '-- Orientované trieskové dosky (OSB)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441012'),
('44101210', '--- Neopracované alebo len brúsené pieskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44101210'),
('44101290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44101290'),
('44101900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44101900'),
('44109000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44109000'),
('4411', 'Drevovláknité dosky alebo vláknité dosky z ostatných drevitých materiálov, tiež spájané živicami alebo ostatnými organickými spojivami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4411'),
('4411:2X', '- Stredne tvrdé vláknité dosky (MDF)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4411:2X'),
('441112', '-- S hrúbkou nepresahujúcou 5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441112'),
('44111210', '--- Mechanicky neopracované alebo na povrchu nepokryté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44111210'),
('44111290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44111290'),
('441113', '-- S hrúbkou presahujúcou 5 mm, ale nepresahujúcou 9 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441113'),
('44111310', '--- Mechanicky neopracované alebo na povrchu nepokryté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44111310'),
('44111390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44111390'),
('441114', '-- S hrúbkou presahujúcou 9 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441114'),
('44111410', '--- Mechanicky neopracované alebo na povrchu nepokryté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44111410'),
('44111490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44111490'),
('44111490:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44111490:2X'),
('441192', '-- S hustotou presahujúcou 0,8 g/cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441192'),
('44119210', '--- Mechanicky neopracované alebo na povrchu nepokryté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44119210'),
('44119290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44119290'),
('441193', '-- S hustotou presahujúcou 0,5 g/cm3, ale nepresahujúcou 0,8 g/cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441193'),
('44119310', '--- Mechanicky neopracované alebo na povrchu nepokryté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44119310'),
('44119390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44119390'),
('441194', '-- S hustotou nepresahujúcou 0,5 g/cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441194'),
('44119410', '--- Mechanicky neopracované alebo na povrchu nepokryté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44119410'),
('44119490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44119490'),
('4412', 'Preglejky, dyhované dosky a podobné vrstvené dosky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4412'),
('44121000', '- Z bambusu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44121000'),
('44121000:2X', '- Ostatné preglejky pozostávajúce výlučne z drevených (okrem bambusových) listov, s každou vrstvou nepresahujúcou 6 mm hrúbky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44121000:2X'),
('441231', '-- Aspoň s jednou vonkajšou vrstvou z tropického dreva špecifikovaného v poznámke k podpoložkám 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441231'),
('44123110', '--- Z acajou d''Afrique, tmavočervené meranti, svetločervené meranti, limba, mahagónovnik (Swietenia spp.), obeche, okoumé, palissandre de Para, palissandre de Rio, palissandre de Rose, sapelli, sipo, virola alebo biele lauan', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44123110'),
('44123190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44123190'),
('441232', '-- Ostatné, aspoň s jednou vonkajšou vrstvou z iného ako ihličnatého dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441232'),
('44123210', '--- Z jelše, jaseňa, buka, brezy, čerešne alebo višne, gaštana, bresta, hikórie, hraba, pagaštana, lipy, javora, duba, platana, topoľa, agáta, orecha vlašského alebo ľaliovníka tulipánokvetého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44123210'),
('44123290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44123290'),
('44123900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44123900'),
('44123900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44123900:2X'),
('441294', '-- Latovky a spárovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441294'),
('44129410', '--- Aspoň s jednou vonkajšou vrstvou z iného ako ihličnatého dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44129410'),
('44129490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44129490'),
('441299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441299'),
('44129930', '--- Obsahujúce aspoň jednu vrstvu z drevotrieskovej dosky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44129930'),
('44129930:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44129930:2X'),
('44129930:3X', '---- Aspoň s jednou vonkajšou vrstvou z iného ako ihličnatého dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44129930:3X'),
('44129940', '----- Z jelše, jaseňa, buka, brezy, čerešne alebo višne, gaštana, bresta, hikórie, hraba, pagaštana, lipy, javora, duba, platana, topoľa, agáta, orecha vlašského alebo ľaliovníka tulipánokvetého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44129940'),
('44129950', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44129950'),
('44129985', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44129985'),
('44130000', 'Tzv. zhutnené drevo, v tvare klátov, dosiek, doštičiek alebo profilov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44130000'),
('441400', 'Drevené rámy na obrazy, fotografie, zrkadlá alebo podobné predmety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441400'),
('44140010', '- Z tropického dreva špecifikovaného v doplnkovej poznámke 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44140010'),
('44140090', '- Z ostatného dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44140090'),
('4415', 'Debny, debničky, klietky, bubny a podobné obaly, z dreva; káblové bubny z dreva; jednoduché palety, skriňové palety a ostatné nakladacie plošiny, z dreva; nástavné rámy paliet z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4415'),
('441510', '- Debny, debničky, klietky, bubny a podobné obaly; káblové bubny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441510'),
('44151010', '-- Debny, debničky, klietky, bubny a podobné obaly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44151010'),
('44151090', '-- Káblové bubny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44151090'),
('441520', '- Jednoduché palety, skriňové palety a ostatné nakladacie plošiny; nástavné rámy paliet', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441520'),
('44152020', '-- Ploché palety; nástavné rámy paliet', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_44152020'),
('44152090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44152090'),
('44160000', 'Sudy, kade, škopky, korytá a ostatné debnárske výrobky a ich časti, z dreva, vrátane dúh (časti steny suda)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44160000'),
('44170000', 'Nástroje, telá nástrojov, násady a rukoväte k nástrojom, násady na zmetáky, na kefy a na štetce, z dreva; formy, kopytá a napínače obuvi, z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44170000'),
('4418', 'Výrobky stavebného stolárstva a tesárstva z dreva, vrátane pórovitých (voštinových) dosiek, zostavených podlahových dosiek a šindľov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4418'),
('441810', '- Okná, francúzske okná a ich rámy a zárubne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441810'),
('44181010', '-- Z tropického dreva špecifikovaného v doplnkovej poznámke 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_44181010'),
('44181050', '-- Ihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_44181050'),
('44181090', '-- Z ostatného dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_44181090'),
('441820', '- Dvere a ich rámy, zárubne a prahy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441820'),
('44182010', '-- Z tropického dreva špecifikovaného v doplnkovej poznámke 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_44182010'),
('44182050', '-- Ihličnaté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_44182050'),
('44182080', '-- Z ostatného dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_44182080'),
('44184000', '- Debnenie na betónovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44184000'),
('44185000', '- Šindle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44185000'),
('44186000', '- Podpery a nosníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44186000'),
('44186000:2X', '- Zostavené podlahové dosky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44186000:2X'),
('44187100', '-- Na mozaikové podlahy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_44187100'),
('44187200', '-- Ostatné, viacvrstvové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_44187200'),
('44187900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_44187900'),
('441890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441890'),
('44189010', '-- Drevo povrstvené glejom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44189010'),
('44189080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44189080'),
('441900', 'Stolový a kuchynský tovar, z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_441900'),
('44190010', '- Z tropického dreva špecifikovaného v doplnkovej poznámke 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44190010'),
('44190090', '- Z ostatného dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44190090'),
('4420', 'Intarzované a inkrustované dosky z dreva; skrinky, puzdrá a kazety na šperky alebo príbory, a podobné výrobky, z dreva; sošky a ostatné ozdobné predmety, z dreva; nábytok z dreva, ktorý nepatrí do kapitoly 94', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4420'),
('442010', '- Sošky a ostatné ozdobné predmety, z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_442010'),
('44201011', '-- Z tropického dreva špecifikovaného v doplnkovej poznámke 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44201011'),
('44201019', '-- Z ostatného dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44201019'),
('442090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_442090'),
('44209010', '-- Intarzované a inkrustované drevo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTQ'), 'SK_44209010'),
('44209010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44209010:2X'),
('44209091', '--- Z tropického dreva špecifikovaného v doplnkovej poznámke 2 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44209091'),
('44209099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44209099'),
('4421', 'Ostatné výrobky z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4421'),
('44211000', '- Ramienka na šaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_44211000'),
('442190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_442190'),
('44219091', '-- Z vláknitých dosiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44219091'),
('44219098', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_44219098'),
('4501', 'Prírodný korok, surový alebo jednoducho upravený; korkový odpad; rozdrvený, granulovaný alebo zomletý korok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4501'),
('45011000', '- Prírodný korok, surový alebo jednoducho upravený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45011000'),
('45019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45019000'),
('45020000', 'Prírodný korok, odkôrnený alebo nahrubo otesaný, alebo v pravouhlých (vrátane štvorcových) blokoch, doskách, listoch alebo pásoch (vrátane polotovarov s ostrými hranami určených na uzávery alebo zátky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45020000'),
('4503', 'Výrobky z prírodného korku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4503'),
('450310', '- Uzávery a zátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_450310'),
('45031010', '-- Valcovité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45031010'),
('45031090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45031090'),
('45039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45039000'),
('4504', 'Aglomerovaný korok (tiež so spojivom) a výrobky z aglomerovaného korku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4504'),
('450410', '- Bloky, dosky, listy a pásy; dlaždice akéhokoľvek tvaru; plné valce, vrátane kotúčov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_450410'),
('450410:2X', '-- Uzávery a zátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_450410:2X'),
('45041011', '--- Na šumivé vína, vrátane tých s kotúčom z prírodného korku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45041011'),
('45041019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45041019'),
('45041019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45041019:2X'),
('45041091', '--- So spojivom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45041091'),
('45041099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45041099'),
('450490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_450490'),
('45049020', '-- Uzávery a zátky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45049020'),
('45049080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_45049080'),
('4601', 'Pletence a podobné výrobky z pletacích materiálov, tiež spojené do prúžkov; pletacie materiály, pletence a podobné výrobky z pletacích materiálov, navzájom zväzované v rovnobežných prameňoch alebo navzájom pretkané, vo forme listov, tiež v konečnej úpra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4601'),
('4601:2X', '- Rohože, rohožky a košiny z rastlinných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4601:2X'),
('460121', '-- Z bambusu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_460121'),
('46012110', '--- Z pletencov alebo podobných výrobkov z pletacích materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46012110'),
('46012190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46012190'),
('460122', '-- Z ratanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_460122'),
('46012210', '--- Z pletencov alebo podobných výrobkov z pletacích materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46012210'),
('46012290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46012290'),
('460129', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_460129'),
('46012910', '--- Z pletencov alebo podobných výrobkov z pletacích materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46012910'),
('46012990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46012990'),
('46012990:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46012990:2X'),
('460192', '-- Z bambusu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_460192'),
('46019205', '--- Pletence a podobné výrobky z pletacích materiálov, tiež spájané do prúžkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019205'),
('46019205:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019205:2X'),
('46019210', '---- Z pletencov alebo podobných výrobkov z pletacích materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019210'),
('46019290', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019290'),
('460193', '-- Z ratanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_460193'),
('46019305', '--- Pletence a podobné výrobky z pletacích materiálov, tiež spájané do prúžkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019305'),
('46019305:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019305:2X'),
('46019310', '---- Z pletencov alebo podobných výrobkov z pletacích materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019310'),
('46019390', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019390'),
('460194', '-- Z ostatných rastlinných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_460194'),
('46019405', '--- Pletence alebo podobné výrobky z pletacích materiálov, tiež spájané do prúžkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019405'),
('46019405:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019405:2X'),
('46019410', '---- Z pletencov a podobných výrobkov z pletacích materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019410'),
('46019490', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019490'),
('460199', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_460199'),
('46019905', '--- Pletence alebo podobné výrobky z pletacích materiálov, tiež spájané do prúžkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019905'),
('46019905:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019905:2X'),
('46019910', '---- Z pletencov a podobných výrobkov z pletacích materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019910'),
('46019990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46019990'),
('4602', 'Košikársky tovar, výrobky z prútia a ostatné výrobky, vyrobené priamo do tvaru z pletacích materiálov alebo celkom dohotovené z tovaru položky 4601; výrobky z lufy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4602'),
('4602:2X', '- Z rastlinných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4602:2X'),
('46021100', '-- Z bambusu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46021100'),
('46021200', '-- Z ratanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46021200'),
('460219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_460219'),
('46021910', '--- Slamené obaly na fľaše', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46021910'),
('46021990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46021990'),
('46029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_46029000'),
('470100', 'Drevovina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_470100'),
('47010010', '- Termomechanická drevovina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47010010'),
('47010090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47010090'),
('47020000', 'Chemická drevná buničina, druhov na rozpúšťanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47020000'),
('4703', 'Chemická drevná buničina, nátronová alebo sulfátová, iná ako druhov na rozpúšťanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4703'),
('4703:2X', '- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4703:2X'),
('47031100', '-- Ihličnanová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47031100'),
('47031900', '-- Neihličnanová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47031900'),
('47031900:2X', '- Polobielená alebo bielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47031900:2X'),
('47032100', '-- Ihličnanová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47032100'),
('47032900', '-- Neihličnanová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47032900'),
('4704', 'Chemická drevná buničina, sulfitová, iná ako druhov na rozpúšťanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4704'),
('4704:2X', '- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4704:2X'),
('47041100', '-- Ihličnanová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47041100'),
('47041900', '-- Neihličnanová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47041900'),
('47041900:2X', '- Polobielená alebo bielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47041900:2X'),
('47042100', '-- Ihličnanová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47042100'),
('47042900', '-- Neihličnanová', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47042900'),
('47050000', 'Drevná buničina získaná kombináciou mechanického a chemického rozvlákňovacieho procesu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47050000'),
('4706', 'Vláknina z vlákien získaných zo zberového (odpadu a výmetu) papiera alebo lepenky alebo ostatných vlákninových celulózových materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4706'),
('47061000', '- Buničina z bavlneného lintersu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47061000'),
('47062000', '- Vláknina z vlákien získaných zo zberového (odpadu a výmetu) papiera alebo lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47062000'),
('47063000', '- Ostatná, z bambusu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47063000'),
('47063000:2X', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47063000:2X'),
('47069100', '-- Získaná mechanicky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47069100'),
('47069200', '-- Získaná chemicky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47069200'),
('47069300', '-- Získaná kombináciou mechanického a chemického postupu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_KSD'), 'SK_47069300'),
('4707', 'Zberový (odpad a výmet) papier alebo lepenka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4707'),
('47071000', '- Nebielený kraft papier alebo lepenka alebo vlnitý papier alebo lepenka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47071000'),
('47072000', '- Ostatný papier alebo lepenka, vyrobené hlavne z bielenej chemickej buničiny, nefarbené v hmote', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47072000'),
('470730', '- Papier alebo lepenka vyrobené hlavne z drevoviny (napríklad noviny, časopisy a podobné tlačoviny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_470730'),
('47073010', '-- Staré a nepredané noviny a časopisy, telefónne zoznamy, brožúry a tlačený reklamný materiál', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47073010'),
('47073090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47073090'),
('470790', '- Ostatný, vrátane netriedeného odpadu a výmetu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_470790'),
('47079010', '-- Netriedený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47079010'),
('47079090', '-- Triedený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_47079090'),
('48010000', 'Novinový papier, v kotúčoch alebo listoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48010000'),
('4802', 'Nenatieraný papier a lepenka, druhov používaných na písanie, tlač alebo na ostatné grafické účely, a neperforované dierne štítky a dierne pásky, v kotúčoch alebo v pravouhlých (vrátane štvorcových) listoch, akéhokoľvek rozmeru, iný ako papier položky 48', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4802'),
('48021000', '- Ručný papier a lepenka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48021000'),
('48022000', '- Papier a lepenka druhov používaných ako podklad na svetlocitlivý, teplocitlivý alebo elektrocitlivý papier alebo lepenku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48022000'),
('480240', '- Surový tapetový papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480240'),
('48024010', '-- Neobsahujúci vlákninu získanú mechanickým postupom alebo obsahujúci z celkového obsahu vlákniny najviac 10 % hmotnosti tejto vlákniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48024010'),
('48024090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48024090'),
('48024090:2X', '- Ostatný papier a lepenka, neobsahujúce vlákninu získanú mechanickým alebo chemicko-mechanickým postupom, alebo obsahujúce z celkového obsahu vlákniny najviac 10 % hmotnosti tejto vlákniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48024090:2X'),
('48025400', '-- S plošnou hmotnosťou menej ako 40 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025400'),
('480255', '-- S plošnou hmotnosťou 40 g/m2 alebo viac, ale menej ako 150 g/m2, v kotúčoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480255'),
('48025515', '--- S plošnou hmotnosťou 40 g/m2 alebo viac, ale menej ako 60 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025515'),
('48025525', '--- S plošnou hmotnosťou 60 g/m2 alebo viac, ale menej ako 75 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025525'),
('48025530', '--- S plošnou hmotnosťou 75 g/m2 alebo viac, ale menej ako 80 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025530'),
('48025590', '--- S plošnou hmotnosťou 80 g/m2 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025590'),
('480256', '-- S plošnou hmotnosťou 40 g/m2 alebo viac, ale najviac 150 g/m2, v listoch s jednou stranou nepresahujúcou 435 mm a druhou stranou nepresahujúcou 297 mm v nepreloženom stave', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480256'),
('48025620', '--- S dĺžkou jednej strany 297 mm a dĺžkou druhej strany 210 mm (formát A4)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025620'),
('48025680', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025680'),
('48025700', '-- Ostatné, s plošnou hmotnosťou 40 g/m2 alebo viac, ale najviac 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025700'),
('480258', '-- S plošnou hmotnosťou viac ako 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480258'),
('48025810', '--- V kotúčoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025810'),
('48025890', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025890'),
('48025890:2X', '- Ostatný papier a lepenka, obsahujúce z celkového obsahu vlákniny viac ako 10 % hmotnosti vlákniny získanej mechanickým alebo chemicko-mechanickým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48025890:2X'),
('480261', '-- V kotúčoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480261'),
('48026115', '--- S plošnou hmotnosťou menej ako 72 g/m2 a obsahujúce z celkového obsahu vlákniny viac ako 50 % hmotnosti vlákniny získanej mechanickým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48026115'),
('48026180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48026180'),
('48026200', '-- V listoch s jednou stranou nepresahujúcou 435 mm a druhou stranou nepresahujúcou 297 mm v nepreloženom stave', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48026200'),
('48026900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48026900'),
('480300', 'Základný toaletný alebo tissue papier používaný na výrobu toaletného papiera alebo jemných odličovacích obrúskov, uterákov alebo servítok a podobný papier druhov používaných v domácnosti alebo na hygienické účely, buničitá vata a pásy splstených buničin', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480300'),
('48030010', '- Buničitá vata', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48030010'),
('48030010:2X', '- Krepovaný papier a pásy splstených buničinových vlákien ("tissue"), s plošnou hmotnosťou každej vrstvy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48030010:2X'),
('48030031', '-- Najviac 25 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48030031'),
('48030039', '-- Viac ako 25 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48030039'),
('48030090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48030090'),
('4804', 'Nenatieraný kraft papier a kraft lepenka, v kotúčoch alebo listoch, iné ako papier a lepenka položky 4802 alebo 4803', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4804'),
('4804:2X', '- Sulfátová krycia lepenka (tzv. "kraftliner")', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4804:2X'),
('480411', '-- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480411'),
('480411:2X', '--- Obsahujúca z celkového obsahu vlákniny minimálne 80 % hmotnosti vlákien ihličnanov získaných sulfátovým alebo nátronovým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480411:2X'),
('48041111', '---- S plošnou hmotnosťou menej ako 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48041111'),
('48041115', '---- S plošnou hmotnosťou 150 g/m2 alebo viac, ale menej ako 175 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48041115'),
('48041119', '---- S plošnou hmotnosťou 175 g/m2 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48041119'),
('48041190', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48041190'),
('480419', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480419'),
('480419:2X', '--- Obsahujúca z celkového obsahu vlákniny minimálne 80 % hmotnosti vlákien ihličnanov získaných sulfátovým alebo nátronovým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480419:2X'),
('480419:3X', '---- Pozostávajúca z jednej alebo viacerých nebielených vrstiev a z jednej vonkajšej vrstvy bielenej, polobielenej alebo farbenej, s plošnou hmotnosťou na m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480419:3X'),
('48041912', '----- Menej ako 175 g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48041912'),
('48041919', '----- 175 g alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48041919'),
('48041930', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48041930'),
('48041990', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48041990'),
('48041990:2X', '- Vrecový kraft papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48041990:2X'),
('480421', '-- Nebielený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480421'),
('48042110', '--- Obsahujúci z celkového obsahu vlákniny minimálne 80 % hmotnosti vlákien ihličnanov získaných sulfátovým alebo nátronovým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48042110'),
('48042190', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48042190'),
('480429', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480429'),
('48042910', '--- Obsahujúci z celkového obsahu vlákniny minimálne 80 % hmotnosti vlákien ihličnanov získaných sulfátovým alebo nátronovým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48042910'),
('48042990', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48042990'),
('48042990:2X', '- Ostatný kraft papier a kraft lepenka s plošnou hmotnosťou 150 g/m2 alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48042990:2X'),
('480431', '-- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480431'),
('480431:2X', '--- Obsahujúce z celkového obsahu vlákniny minimálne 80 % hmotnosti vlákien ihličnanov získaných sulfátovým alebo nátronovým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480431:2X'),
('48043151', '---- Elektrotechnický izolačný kraft papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48043151'),
('48043158', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48043158'),
('48043180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48043180'),
('480439', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480439'),
('480439:2X', '--- Obsahujúce z celkového obsahu vlákniny minimálne 80 % hmotnosti vlákien ihličnanov získaných sulfátovým alebo nátronovým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480439:2X'),
('48043951', '---- Rovnomerne bielené v hmote', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48043951'),
('48043958', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48043958'),
('48043980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48043980'),
('48043980:2X', '- Ostatný kraft papier a kraft lepenka s plošnou hmotnosťou viac ako 150 g/m2, ale menej ako 225 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48043980:2X'),
('480441', '-- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480441'),
('48044191', '--- Krycí papier a lepenka, tzv. "saturating kraft"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48044191'),
('48044198', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48044198'),
('48044200', '-- Rovnomerne bielené v hmote a obsahujúce z celkového obsahu vlákniny viac ako 95 % hmotnosti drevných vlákien získaných chemickým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48044200'),
('48044900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48044900'),
('48044900:2X', '- Ostatný kraft papier a kraft lepenka s plošnou hmotnosťou 225 g/m2 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48044900:2X'),
('48045100', '-- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48045100'),
('48045200', '-- Rovnomerne bielené v hmote a obsahujúce z celkového obsahu vlákniny viac ako 95 % hmotnosti drevných vlákien získaných chemickým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48045200'),
('480459', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480459'),
('48045910', '--- Obsahujúce z celkového obsahu vlákniny minimálne 80 % hmotnosti vlákien ihličnanov získaných sulfátovým alebo nátronovým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48045910'),
('48045990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48045990'),
('4805', 'Ostatný nenatieraný papier a lepenka, v kotúčoch alebo listoch, ďalej nespracované alebo spracované postupmi špecifikovanými v poznámke 3 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4805'),
('4805:2X', '- Papier na zvlnenú vrstvu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4805:2X'),
('48051100', '-- Polochemický papier na zvlnenú vrstvu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48051100'),
('48051200', '-- Slamový papier na zvlnenú vrstvu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48051200'),
('480519', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480519'),
('48051910', '--- Vlnitý papier (Wellenstoff)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48051910'),
('48051990', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48051990'),
('48051990:2X', '- Testliner (krycia vrstva vlnitej lepenky z recyklovaných vlákien)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48051990:2X'),
('48052400', '-- S plošnou hmotnosťou 150 g/m2 alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48052400'),
('48052500', '-- S plošnou hmotnosťou viac ako 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48052500'),
('48053000', '- Sulfitový baliaci papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48053000'),
('48054000', '- Filtračný papier a lepenka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48054000'),
('48055000', '- Plstený papier a lepenka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48055000'),
('48055000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48055000:2X'),
('48059100', '-- S plošnou hmotnosťou 150 g/m2 alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48059100'),
('48059200', '-- S plošnou hmotnosťou viac ako 150 g/m2, ale menej ako 225 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48059200'),
('480593', '-- S plošnou hmotnosťou 225 g/m2 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480593'),
('48059320', '--- Vyrobené zo zberového papiera', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48059320'),
('48059380', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48059380'),
('4806', 'Rastlinný pergamen, nepremastiteľný papier, pauzovací papier a pergamín a ostatné hladené priehľadné alebo priesvitné papiere, v kotúčoch alebo listoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4806'),
('48061000', '- Rastlinný pergamen', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48061000'),
('48062000', '- Nepremastiteľný papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48062000'),
('48063000', '- Pauzovací papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48063000'),
('480640', '- Pergamín a ostatné hladené priehľadné alebo priesvitné papiere', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480640'),
('48064010', '-- Pergamín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48064010'),
('48064090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48064090'),
('480700', 'Kompozitný papier a lepenka (vyrobené zlepením plochých vrstiev papiera alebo lepenky so spojivom), na povrchu nenatierané ani neimpregnované, tiež vnútri zosilnené, v kotúčoch alebo listoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_480700'),
('48070030', '- Vyrobené zo zberového papiera, tiež pokryté papierom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48070030'),
('48070080', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48070080'),
('4808', 'Papier a lepenka, vlnité (tiež s nalepenými plochými listami na povrchu), krepované, plisované, razené alebo perforované, v kotúčoch alebo listoch, iné ako papier druhov opísaných v položke 4803', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4808'),
('48081000', '- Vlnitý papier a lepenka, tiež perforované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48081000'),
('48084000', '- Kraft papier, krepovaný alebo plisovaný, tiež razený alebo perforovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48084000'),
('48089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48089000'),
('4809', 'Uhľový papier, samokopírovací papier a ostatné kopírovacie alebo pretlačovacie papiere (vrátane natieraného alebo impregnovaného papiera na rozmnožovacie blany alebo ofsetové matrice), tiež potlačené, v kotúčoch alebo listoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4809'),
('48092000', '- Samokopírovací papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48092000'),
('48099000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48099000'),
('4810', 'Papier a lepenka, natierané na jednej alebo oboch stranách kaolínom alebo ostatnými anorganickými látkami, tiež so spojivom, bez akéhokoľvek ďalšieho náteru, tiež na povrchu farbené, na povrchu zdobené alebo potlačené, v kotúčoch alebo pravouhlých (vrát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4810'),
('4810:2X', '- Papier a lepenka druhov používaných na písanie, tlač alebo na ostatné grafické účely, neobsahujúce vlákninu získanú mechanickým alebo chemicko-mechanickým postupom alebo obsahujúce z celkového obsahu vlákniny najviac 10 % hmotnosti tejto vlákniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4810:2X'),
('48101300', '-- V kotúčoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48101300'),
('48101400', '-- V listoch s jednou stranou nepresahujúcou 435 mm a druhou stranou nepresahujúcou 297 mm v nepreloženom stave', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48101400'),
('48101900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48101900'),
('48101900:2X', '- Papier a lepenka druhov používaných na písanie, tlač alebo na ostatné grafické účely, obsahujúce z celkového obsahu vlákniny viac ako 10 % hmotnosti vlákniny získanej mechanickým alebo chemicko-mechanickým postupom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48101900:2X'),
('48102200', '-- Ľahko natieraný papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48102200'),
('481029', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481029'),
('48102930', '--- V kotúčoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48102930'),
('48102980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48102980'),
('48102980:2X', '- Kraft papier a kraft lepenka, iné ako papier a lepenka druhov používaných na písanie, tlač alebo na ostatné grafické účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48102980:2X'),
('48103100', '-- Rovnomerne bielené v hmote a obsahujúce z celkového obsahu vlákniny viac ako 95 % hmotnosti drevných vlákien získaných chemickým postupom, s plošnou hmotnosťou 150 g/m2 alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48103100'),
('481032', '-- Rovnomerne bielené v hmote a obsahujúce z celkového obsahu vlákniny viac ako 95 % hmotnosti drevných vlákien získaných chemickým postupom, s plošnou hmotnosťou viac ako 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481032'),
('48103210', '--- Natierané kaolínom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48103210'),
('48103290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48103290'),
('48103900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48103900'),
('48103900:2X', '- Ostatný papier a lepenka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48103900:2X'),
('481092', '-- Viacvrstvové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481092'),
('48109210', '--- S každou vrstvou bielenou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48109210'),
('48109230', '--- Len s jednou bielenou vonkajšou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48109230'),
('48109290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48109290'),
('481099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481099'),
('48109910', '--- Bielený papier a lepenka, natierané kaolínom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48109910'),
('48109980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48109980'),
('4811', 'Papier, lepenka, buničitá vata a pásy splstených buničinových vlákien, potiahnuté, impregnované, pokryté, na povrchu farbené, na povrchu zdobené alebo potlačené, v kotúčoch alebo pravouhlých (vrátane štvorcových) listoch, akéhokoľvek rozmeru, iné ako to', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4811'),
('48111000', '- Dechtovaný, bitúmenovaný alebo asfaltovaný papier a lepenka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48111000'),
('48111000:2X', '- Lepiaci alebo priľnavý papier a lepenka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48111000:2X'),
('481141', '-- Samolepiace', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481141'),
('48114120', '--- So šírkou nepresahujúcou 10 cm, s náterom zloženým z nevulkanizovaného prírodného alebo syntetického kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48114120'),
('48114190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48114190'),
('48114900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48114900'),
('48114900:2X', '- Papier a lepenka, potiahnuté, impregnované alebo pokryté plastmi (okrem lepidiel)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48114900:2X'),
('48115100', '-- Bielené, s plošnou hmotnosťou viac ako 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48115100'),
('48115900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48115900'),
('48116000', '- Papier a lepenka, potiahnuté, impregnované alebo pokryté voskom, parafínovým voskom, stearínom, olejom alebo glycerolom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48116000'),
('48119000', '- Ostatný papier, lepenka, buničitá vata a pásy splstených buničinových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48119000'),
('48120000', 'Filtračné bloky a dosky, z papieroviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48120000'),
('4813', 'Cigaretový papier, tiež rezaný na určitý rozmer alebo v tvare zložiek alebo dutiniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4813'),
('48131000', '- V tvare zložiek alebo dutiniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48131000'),
('48132000', '- V kotúčikoch so šírkou nepresahujúcou 5 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48132000'),
('481390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481390'),
('48139010', '-- V kotúčikoch so šírkou presahujúcou 5 cm, ale nepresahujúcou 15 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48139010'),
('48139090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48139090'),
('4814', 'Tapetový papier a podobné krycie materiály na steny; okenný transparentný papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4814'),
('48142000', '- Tapetový papier a podobné krycie materiály na steny, pozostávajúce z papiera potiahnutého alebo pokrytého na lícnej strane zrnitou, razenou, farbenou, vzorovane potlačenou alebo inak zdobenou vrstvou z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48142000'),
('481490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481490'),
('48149010', '-- Tapetový papier a podobné krycie materiály na steny, pozostávajúce zo zrnitého, razeného, povrchovo farbeného, potlačeného vzorom alebo inak povrchovo zdobeného papiera, potiahnutého alebo pokrytého priehľadnými ochrannými vrstvami plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48149010'),
('48149070', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48149070'),
('4816', 'Uhľový papier, samokopírovací papier a ostatné kopírovacie alebo pretlačovacie papiere (iné ako papier položky 4809), rozmnožovacie blany a ofsetové matrice, z papiera, tiež predkladané v škatuliach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4816'),
('48162000', '- Samokopírovací papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48162000'),
('48169000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48169000'),
('4817', 'Obálky, zálepky, neilustrované poštové karty a korešpondenčné lístky, z papiera alebo lepenky; škatule, tašky, náprsné tašky a písacie súpravy, z papiera alebo lepenky, obsahujúce potreby na korešpondenciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4817'),
('48171000', '- Obálky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48171000'),
('48172000', '- Zálepky, neilustrované poštové karty a korešpondenčné lístky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48172000'),
('48173000', '- Škatule, tašky, náprsné tašky a písacie súpravy, z papiera alebo lepenky, obsahujúce potreby na korešpondenciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48173000'),
('4818', 'Toaletný papier a podobný papier, buničitá vata alebo pásy splstených buničinových vlákien, druhov používaných v domácnosti alebo na hygienické účely, v kotúčoch so šírkou nepresahujúcou 36 cm, alebo narezané na určité rozmery alebo do tvaru; vreckovky,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4818'),
('481810', '- Toaletný papier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481810'),
('48181010', '-- S plošnou hmotnosťou každej vrstvy 25 g/m2 alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48181010'),
('48181090', '-- S plošnou hmotnosťou každej vrstvy viac ako 25 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48181090'),
('481820', '- Vreckovky, čistiace alebo odličovacie obrúsky a uteráky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481820'),
('48182010', '-- Vreckovky a čistiace alebo odličovacie obrúsky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48182010'),
('48182010:2X', '-- Uteráky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48182010:2X'),
('48182091', '--- V kotúčoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48182091'),
('48182099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48182099'),
('48183000', '- Obrusy a obrúsky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48183000'),
('48185000', '- Odevy a odevné doplnky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48185000'),
('481890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_481890'),
('48189010', '-- Výrobky druhov používaných na chirurgické, lekárske alebo hygienické účely, neupravené na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48189010'),
('48189090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48189090'),
('4819', 'Škatule, debny, vrecia, vrecká a ostatné obaly, z papiera, lepenky, buničitej vaty alebo pásov splstených buničinových vlákien; škatuľové zaraďovače, listové zásobníky, a podobné výrobky, z papiera alebo lepenky, druhov používaných v kanceláriách, obcho', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4819'),
('48191000', '- Škatule a debny, z vlnitého papiera alebo vlnitej lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48191000'),
('48192000', '- Skladacie škatule a debny, z nevlnitého papiera alebo nevlnitej lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48192000'),
('48193000', '- Vrecia a vrecká, ktorých spodná časť má šírku 40 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48193000'),
('48194000', '- Ostatné vrecia a vrecká, vrátane kornútov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48194000'),
('48195000', '- Ostatné obaly, vrátane obalov na gramofónové platne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48195000'),
('48196000', '- Škatuľové zaraďovače, listové zásobníky, skladovacie škatule a podobné výrobky, druhov používaných v kanceláriách, obchodoch alebo podobne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48196000'),
('4820', 'Registre, účtovné knihy, poznámkové bloky, objednávkové bloky, potvrdenkové bloky, bloky listových papierov, memorandové zápisníky, diáre a podobné výrobky, zošity, bloky pijavých papierov, rýchloviazače (s voľnými listami alebo ostatné), dosky, spisové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4820'),
('482010', '- Registre, účtovné knihy, poznámkové bloky, objednávkové bloky, potvrdenkové bloky, bloky listových papierov, memorandové zápisníky, diáre a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_482010'),
('48201010', '-- Registre, účtovné knihy, objednávkové bloky a potvrdenkové bloky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48201010'),
('48201030', '-- Poznámkové bloky, bloky listových papierov a memorandové zápisníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48201030'),
('48201050', '-- Diáre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48201050'),
('48201090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48201090'),
('48202000', '- Zošity', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48202000'),
('48203000', '- Rýchloviazače (iné ako obaly na knihy), dosky a spisové mapy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48203000'),
('48204000', '- Obchodné tlačivá a sady papierov poprekladané uhľovým papierom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48204000'),
('48205000', '- Albumy na vzorky alebo na zbierky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48205000'),
('48209000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48209000'),
('4821', 'Papierové alebo lepenkové štítky alebo nálepky všetkých druhov, tiež potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4821'),
('482110', '- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_482110'),
('48211010', '-- Samolepiace', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48211010'),
('48211090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48211090'),
('482190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_482190'),
('48219010', '-- Samolepiace', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48219010'),
('48219090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48219090'),
('4822', 'Dutinky, cievky, potáče a podobné podporné telesá, z papieroviny, papiera alebo lepenky (tiež perforované alebo vytvrdzované)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4822'),
('48221000', '- Druhov používaných na navíjanie textilnej priadze', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48221000'),
('48229000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48229000'),
('4823', 'Ostatný papier, lepenka, buničitá vata a pásy splstených buničinových vlákien, narezané na určité rozmery alebo do tvaru; ostatné výrobky z papieroviny, papiera, lepenky, buničitej vaty alebo pásov splstených buničinových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4823'),
('48232000', '- Filtračný papier a lepenka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48232000'),
('48234000', '- Kotúče, listy a disky, potlačené, do registračných zariadení', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48234000'),
('48234000:2X', '- Podnosy, misy, taniere, šálky a podobné výrobky, z papiera alebo lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48234000:2X'),
('48236100', '-- Z bambusu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48236100'),
('482369', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_482369'),
('48236910', '--- Podnosy, misy a taniere', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48236910'),
('48236990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48236990'),
('482370', '- Tvarované alebo lisované výrobky z papieroviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_482370'),
('48237010', '-- Tvarované preložky a škatule na balenie vajec', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48237010'),
('48237090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48237090'),
('482390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_482390'),
('48239040', '-- Papier a lepenka, druhov požívaných na písanie, tlač alebo na ostatné grafické účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48239040'),
('48239085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_48239085'),
('4901', 'Tlačené knihy, brožúry, letáky a podobné tlačoviny, tiež v jednotlivých listoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4901'),
('49011000', '- V jednotlivých listoch, tiež skladané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49011000'),
('49011000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49011000:2X'),
('49019100', '-- Slovníky a encyklopédie, tiež v zaraďovacej úprave', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49019100'),
('49019900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49019900'),
('4902', 'Noviny, časopisy a periodiká, tiež ilustrované alebo obsahujúce reklamný materiál', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4902'),
('49021000', '- Vychádzajúce najmenej štyrikrát týždenne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49021000'),
('49029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49029000'),
('49030000', 'Detské obrázkové knihy, predlohy na kreslenie alebo maľovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49030000'),
('49040000', 'Hudobniny, tlačené alebo v rukopise, tiež viazané alebo ilustrované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49040000'),
('4905', 'Mapy a hydrografické alebo podobné mapy všetkých druhov, vrátane atlasov, nástenných máp, topografických plánov a glóbusov, tlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4905'),
('49051000', '- Glóbusy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49051000'),
('49051000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49051000:2X'),
('49059100', '-- V knižnej forme', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49059100'),
('49059900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49059900'),
('49060000', 'Plány a výkresy na stavebné, strojnícke, priemyselné, obchodné, topografické alebo podobné účely, ktorých originály boli nakreslené ručne; ručne písané texty; fotografické reprodukcie na citlivom papieri a uhľové kópie plánov, výkresov a textov uvedenýc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49060000'),
('490700', 'Nepoužité poštové, kolkové alebo podobné známky, ktoré majú alebo majú mať nominálnu hodnotu v krajine určenia; aršíky známok; bankovky; šekové tlačivá; akcie, obligácie a podobné cenné papiere', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_490700'),
('49070010', '- Poštové, kolkové a podobné známky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49070010'),
('49070030', '- Bankovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49070030'),
('49070090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49070090'),
('4908', 'Obtlačky (decalcomanias)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4908'),
('49081000', '- Obtlačky (decalcomanias), zoskloviteľné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49081000'),
('49089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49089000'),
('49090000', 'Tlačené alebo ilustrované poštové karty alebo pohľadnice; tlačené karty s osobnými pozdravmi, správami alebo oznámeniami, tiež ilustrované, tiež s obálkami alebo ozdobami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49090000'),
('49100000', 'Kalendáre akéhokoľvek druhu, tlačené, vrátane kalendárov vo forme blokov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49100000'),
('4911', 'Ostatné tlačoviny, vrátane tlačených obrazov a fotografií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_4911'),
('491110', '- Reklamné a propagačné tlačoviny, obchodné katalógy a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_491110'),
('49111010', '-- Obchodné katalógy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49111010'),
('49111090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49111090'),
('49111090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49111090:2X'),
('49119100', '-- Obrazy, ilustrácie a fotografie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49119100'),
('49119900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_49119900'),
('50010000', 'Kokóny priadky morušovej spôsobilé na zmotávanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50010000'),
('50020000', 'Surový hodváb (nesúkaný)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50020000'),
('50030000', 'Hodvábny odpad (vrátane kokónov nespôsobilých na zmotávanie, priadzového odpadu a trhaného materiálu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50030000'),
('500400', 'Hodvábna priadza (iná ako priadza spradená z hodvábneho odpadu) neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_500400'),
('50040010', '- Nebielená, praná alebo bielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50040010'),
('50040090', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50040090'),
('500500', 'Priadza spradená z hodvábneho odpadu, neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_500500'),
('50050010', '- Nebielená, praná alebo bielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50050010'),
('50050090', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50050090'),
('500600', 'Hodvábna priadza a priadza spradená z hodvábneho odpadu, upravená na predaj v malom; mesinský vlas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_500600'),
('50060010', '- Hodvábna priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50060010'),
('50060090', '- Priadza spradená z buretového alebo ostatného hodvábneho odpadu; mesinský vlas', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50060090'),
('5007', 'Tkaniny z hodvábu alebo hodvábneho odpadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5007'),
('50071000', '- Tkaniny z buretového hodvábu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50071000'),
('500720', '- Ostatné tkaniny, obsahujúce 85 % hmotnosti alebo viac hodvábu alebo hodvábneho odpadu, iného ako buretový hodváb', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_500720'),
('500720:2X', '-- Krepy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_500720:2X'),
('50072011', '--- Nebielené, prané alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072011'),
('50072019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072019'),
('50072019:2X', '-- Ponžé, habutai, honan, šantung, corah a podobné tkaniny z Ďalekého východu, celé z hodvábu (nemiešané s buretovým ani ostatným hodvábnym odpadom, ani ostatnými textilnými materiálmi)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50072019:2X'),
('50072021', '--- V plátnovej väzbe, nebielené alebo ďalej neupravené inak ako prané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072021'),
('50072021:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50072021:2X'),
('50072031', '---- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072031'),
('50072039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072039'),
('50072039:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50072039:2X'),
('50072041', '--- Priesvitné tkaniny (voľná väzba)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072041'),
('50072041:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50072041:2X'),
('50072051', '---- Nebielené, prané alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072051'),
('50072059', '---- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072059'),
('50072059:2X', '---- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_50072059:2X'),
('50072061', '----- So šírkou presahujúcou 57 cm, ale nepresahujúcou 75 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072061'),
('50072069', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072069'),
('50072071', '---- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50072071'),
('500790', '- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_500790'),
('50079010', '-- Nebielené, prané alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50079010'),
('50079030', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50079030'),
('50079050', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50079050'),
('50079090', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_50079090'),
('5101', 'Vlna, nemykaná alebo nečesaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5101'),
('5101:2X', '- Potná, vrátane vlny pranej na chrbte', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5101:2X'),
('51011100', '-- Strižná vlna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51011100'),
('51011900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51011900'),
('51011900:2X', '- Odtučnená, nekarbonizovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51011900:2X'),
('51012100', '-- Strižná vlna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51012100'),
('51012900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51012900'),
('51013000', '- Karbonizovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51013000'),
('5102', 'Jemné alebo hrubé chlpy zvierat, nemykané alebo nečesané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5102'),
('5102:2X', '- Jemné chlpy zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5102:2X'),
('51021100', '-- Z kašmírskych kôz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51021100'),
('510219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510219'),
('51021910', '--- Z angorského králika', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51021910'),
('51021930', '--- Z alpaky, lamy alebo vikune', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51021930'),
('51021940', '--- Z ťavy (vrátane dromedára) alebo jaka, alebo angorských, tibetských alebo podobných kôz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51021940'),
('51021990', '--- Z králika (iného ako angorského králika), zajaca, bobra, nutrie alebo ondatry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51021990'),
('51022000', '- Hrubé chlpy zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51022000'),
('5103', 'Odpad z vlny alebo jemných alebo hrubých chlpov zvierat, vrátane odpadu z priadze, okrem trhaného materiálu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5103'),
('510310', '- Výčesky z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510310'),
('51031010', '-- Nekarbonizované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51031010'),
('51031090', '-- Karbonizované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51031090'),
('51032000', '- Ostatný odpad z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51032000'),
('51033000', '- Odpad z hrubých chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51033000'),
('51040000', 'Trhaný materiál z vlny alebo jemných alebo hrubých chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51040000'),
('5105', 'Vlna a jemné alebo hrubé chlpy zvierat, mykané alebo česané (vrátane útržkov česanej vlny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5105'),
('51051000', '- Mykaná vlna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51051000'),
('51051000:2X', '- Vlnené česance a ostatná česaná vlna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51051000:2X'),
('51052100', '-- Útržky česanej vlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51052100'),
('51052900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51052900'),
('51052900:2X', '- Jemné chlpy zvierat, mykané alebo česané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51052900:2X'),
('51053100', '-- Z kašmírskych kôz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51053100'),
('51053900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51053900'),
('51054000', '- Hrubé chlpy zvierat, mykané alebo česané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51054000'),
('5106', 'Priadza z mykanej vlny, neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5106'),
('510610', '- Obsahujúca 85 % hmotnosti alebo viac vlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510610'),
('51061010', '-- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51061010'),
('51061090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51061090'),
('510620', '- Obsahujúca menej ako 85 % hmotnosti vlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510620'),
('51062010', '-- Obsahujúca 85 % hmotnosti alebo viac vlny a jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51062010'),
('51062010:2X', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51062010:2X'),
('51062091', '--- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51062091'),
('51062099', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51062099'),
('5107', 'Priadza z česanej vlny, neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5107'),
('510710', '- Obsahujúca 85 % hmotnosti alebo viac vlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510710'),
('51071010', '-- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51071010'),
('51071090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51071090'),
('510720', '- Obsahujúca menej ako 85 % hmotnosti vlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510720'),
('510720:2X', '-- Obsahujúca 85 % hmotnosti alebo viac vlny a jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510720:2X'),
('51072010', '--- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51072010'),
('51072030', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51072030'),
('51072030:2X', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51072030:2X'),
('51072030:3X', '--- V zmesi výlučne alebo hlavne so syntetickými strižovými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51072030:3X'),
('51072051', '---- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51072051'),
('51072059', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51072059'),
('51072059:2X', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51072059:2X'),
('51072091', '---- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51072091'),
('51072099', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51072099'),
('5108', 'Priadza z jemných chlpov zvierat (mykaná alebo česaná), neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5108'),
('510810', '- Mykaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510810'),
('51081010', '-- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51081010'),
('51081090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51081090'),
('510820', '- Česaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510820'),
('51082010', '-- Nebielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51082010'),
('51082090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51082090'),
('5109', 'Priadza z vlny alebo jemných chlpov zvierat, upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5109'),
('510910', '- Obsahujúca 85 % hmotnosti alebo viac vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_510910'),
('51091010', '-- V klbkách, pradenách alebo pradienkach, s hmotnosťou presahujúcou 125 g, ale nepresahujúcou 500 g', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51091010'),
('51091090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51091090'),
('51099000', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51099000'),
('51100000', 'Priadza z hrubých chlpov zvierat alebo vlásia (vrátane opradenej priadze z vlásia), tiež upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51100000'),
('5111', 'Tkaniny z mykanej vlny alebo mykaných jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5111'),
('5111:2X', '- Obsahujúce 85 % hmotnosti alebo viac vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5111:2X'),
('51111100', '-- S plošnou hmotnosťou nepresahujúcou 300 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51111100'),
('511119', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_511119'),
('51111910', '--- S plošnou hmotnosťou presahujúcou 300 g/m2, ale nepresahujúcou 450 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51111910'),
('51111990', '--- S plošnou hmotnosťou presahujúcou 450 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51111990'),
('51112000', '- Ostatné, v zmesi hlavne alebo výlučne s chemickými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51112000'),
('511130', '- Ostatné, v zmesi hlavne alebo výlučne s chemickými strižnými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_511130'),
('51113010', '-- S plošnou hmotnosťou nepresahujúcou 300 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51113010'),
('51113030', '-- S plošnou hmotnosťou presahujúcou 300 g/m2, ale nepresahujúcou 450 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51113030'),
('51113090', '-- S plošnou hmotnosťou presahujúcou 450 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51113090'),
('511190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_511190'),
('51119010', '-- Obsahujúce viac ako 10 % celkovej hmotnosti textilných materiálov kapitoly 50', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51119010'),
('51119010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51119010:2X'),
('51119091', '--- S plošnou hmotnosťou nepresahujúcou 300 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51119091'),
('51119093', '--- S plošnou hmotnosťou presahujúcou 300 g/m2, ale nepresahujúcou 450 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51119093'),
('51119099', '--- S plošnou hmotnosťou presahujúcou 450 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51119099'),
('5112', 'Tkaniny z česanej vlny alebo česaných jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5112'),
('5112:2X', '- Obsahujúce 85 % hmotnosti alebo viac vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5112:2X'),
('51121100', '-- S plošnou hmotnosťou nepresahujúcou 200 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51121100'),
('511219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_511219'),
('51121910', '--- S plošnou hmotnosťou presahujúcou 200 g/m2, ale nepresahujúcou 375 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51121910'),
('51121990', '--- S plošnou hmotnosťou presahujúcou 375 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51121990'),
('51122000', '- Ostatné, v zmesi hlavne alebo výlučne s chemickými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51122000'),
('511230', '- Ostatné, v zmesi hlavne alebo výlučne s chemickými strižnými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_511230'),
('51123010', '-- S plošnou hmotnosťou nepresahujúcou 200 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51123010'),
('51123030', '-- S plošnou hmotnosťou presahujúcou 200 g/m2, ale nepresahujúcou 375 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51123030'),
('51123090', '-- S plošnou hmotnosťou presahujúcou 375 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51123090'),
('511290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_511290'),
('51129010', '-- Obsahujúce viac ako 10 % celkovej hmotnosti textilných materiálov kapitoly 50', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51129010'),
('51129010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_51129010:2X'),
('51129091', '--- S plošnou hmotnosťou nepresahujúcou 200 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51129091'),
('51129093', '--- S plošnou hmotnosťou presahujúcou 200 g/m2, ale nepresahujúcou 375 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51129093'),
('51129099', '--- S plošnou hmotnosťou presahujúcou 375 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51129099'),
('51130000', 'Tkaniny z hrubých chlpov zvierat alebo vlásia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_51130000'),
('520100', 'Bavlna, nemykaná alebo nečesaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520100'),
('52010010', '- Upravená na absorbovateľnosť alebo bielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52010010'),
('52010090', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52010090'),
('5202', 'Bavlnený odpad (vrátane priadzového odpadu a trhaného materiálu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5202'),
('52021000', '- Priadzový odpad (vrátane niťového odpadu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52021000'),
('52021000:2X', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52021000:2X'),
('52029100', '-- Trhaný materiál', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52029100'),
('52029900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52029900'),
('52030000', 'Bavlna, mykaná alebo česaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52030000'),
('5204', 'Bavlnená šijacia niť, tiež upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5204'),
('5204:2X', '- Neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5204:2X'),
('52041100', '-- Obsahujúca 85 % hmotnosti alebo viac bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52041100'),
('52041900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52041900'),
('52042000', '- Upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52042000'),
('5205', 'Bavlnená priadza (iná ako šijacia niť), obsahujúca 85 % hmotnosti alebo viac bavlny, neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5205'),
('5205:2X', '- Jednoduchá priadza, z nečesaných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5205:2X'),
('52051100', '-- S dĺžkovou hmotnosťou 714,29 decitexov alebo viac (metrické číslo nepresahujúce 14)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52051100'),
('52051200', '-- S dĺžkovou hmotnosťou menej ako 714,29 decitexov, ale najmenej 232,56 decitexov (metrické číslo presahujúce 14, ale nepresahujúce 43)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52051200'),
('52051300', '-- S dĺžkovou hmotnosťou menej ako 232,56 decitexov, ale najmenej 192,31 decitexov (metrické číslo presahujúce 43, ale nepresahujúce 52)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52051300'),
('52051400', '-- S dĺžkovou hmotnosťou menej ako 192,31 decitexov, ale najmenej 125 decitexov (metrické číslo presahujúce 52, ale nepresahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52051400'),
('520515', '-- S dĺžkovou hmotnosťou menej ako 125 decitexov (metrické číslo presahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520515'),
('52051510', '--- S dĺžkovou hmotnosťou menej ako 125 decitexov, ale najmenej 83,33 decitexov (metrické číslo presahujúce 80, ale nepresahujúce 120)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52051510'),
('52051590', '--- S dĺžkovou hmotnosťou menej ako 83,33 decitexov (metrické číslo presahujúce 120)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52051590'),
('52051590:2X', '- Jednoduchá priadza, z česaných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52051590:2X'),
('52052100', '-- S dĺžkovou hmotnosťou 714,29 decitexov alebo viac (metrické číslo nepresahujúce 14)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52052100'),
('52052200', '-- S dĺžkovou hmotnosťou menej ako 714,29 decitexov, ale najmenej 232,56 decitexov (metrické číslo presahujúce 14, ale nepresahujúce 43)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52052200'),
('52052300', '-- S dĺžkovou hmotnosťou menej ako 232,56 decitexov, ale najmenej 192,31 decitexov (metrické číslo presahujúce 43, ale nepresahujúce 52)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52052300'),
('52052400', '-- S dĺžkovou hmotnosťou menej ako 192,31 decitexov, nie však menej ako 125 decitexov (metrické číslo presahujúce 52, ale nepresahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52052400'),
('52052600', '-- S dĺžkovou hmotnosťou menej ako 125 decitexov, ale najmenej 106,38 decitexov (metrické číslo presahujúce 80, ale nepresahujúce 94)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52052600'),
('52052700', '-- S dĺžkovou hmotnosťou menej ako 106,38 decitexov, ale najmenej 83,33 decitexov (metrické číslo presahujúce 94, ale nepresahujúce 120)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52052700'),
('52052800', '-- S dĺžkovou hmotnosťou menej ako 83,33 decitexov (metrické číslo presahujúce 120)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52052800'),
('52052800:2X', '- Násobná (súkaná) alebo káblovaná priadza, z nečesaných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52052800:2X'),
('52053100', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou 714,29 decitexov alebo viac (metrické číslo jednoduchej priadze nepresahujúce 14)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52053100'),
('52053200', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 714,29 decitexov, ale najmenej ako 232,56 decitexov (metrické číslo jednoduchej priadze presahujúce 14, ale nepresahujúce 43)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52053200'),
('52053300', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 232,56 decitexov, ale najmenej 192,31 decitexov (metrické číslo jednoduchej priadze presahujúce 43, ale nepresahujúce 52)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52053300'),
('52053400', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 192,31 decitexov, ale najmenej 125 decitexov (metrické číslo jednoduchej priadze presahujúce 52, ale nepresahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52053400'),
('52053500', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 125 decitexov (metrické číslo jednoduchej priadze presahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52053500'),
('52053500:2X', '- Násobná (súkaná) alebo káblovaná priadza, z česaných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52053500:2X'),
('52054100', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou 714,29 decitexov alebo viac (metrické číslo jednoduchej priadze nepresahujúce 14)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52054100'),
('52054200', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 714,29 decitexov, ale najmenej 232,56 decitexov (metrické číslo jednoduchej priadze presahujúce 14, ale nepresahujúce 43)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52054200'),
('52054300', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 232,56 decitexov, ale najmenej 192,31 decitexov (metrické číslo jednoduchej priadze presahujúce 43, ale nepresahujúce 52)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52054300'),
('52054400', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 192,31 decitexov, ale najmenej 125 decitexov (metrické číslo jednoduchej priadze presahujúce 52, ale nepresahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52054400'),
('52054600', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 125 decitexov, ale najmenej 106,38 decitexov (metrické číslo jednoduchej priadze presahujúce 80, ale nepresahujúce 94)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52054600'),
('52054700', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 106,38 decitexov,ale najmenej 83,33 decitexov (metrické číslo jednoduchej priadze presahujúce 94, ale nepresahujúce 120)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52054700'),
('52054800', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 83,33 decitexov (metrické číslo jednoduchej priadze presahujúce 120)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52054800'),
('5206', 'Bavlnená priadza (iná ako šijacia niť), obsahujúca menej ako 85 % hmotnosti bavlny, neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5206'),
('5206:2X', '- Jednoduchá priadza, z nečesaných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5206:2X'),
('52061100', '-- S dĺžkovou hmotnosťou 714,29 decitexov alebo viac (metrické číslo nepresahujúce 14)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52061100'),
('52061200', '-- S dĺžkovou hmotnosťou menej ako 714,29 decitexov, ale najmenej 232,56 decitexov (metrické číslo presahujúce 14, ale nepresahujúce 43)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52061200'),
('52061300', '-- S dĺžkovou hmotnosťou menej ako 232,56 decitexov, ale najmenej 192,31 decitexov (metrické číslo presahujúce 43, ale nepresahujúce 52)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52061300'),
('52061400', '-- S dĺžkovou hmotnosťou menej ako 192,31 decitexov,ale najmenej 125 decitexov (metrické číslo presahujúce 52, ale nepresahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52061400'),
('52061500', '-- S dĺžkovou hmotnosťou menej ako 125 decitexov (metrické číslo presahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52061500'),
('52061500:2X', '- Jednoduchá priadza, z česaných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52061500:2X'),
('52062100', '-- S dĺžkovou hmotnosťou 714,29 decitexov alebo viac (metrické číslo nepresahujúce 14)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52062100'),
('52062200', '-- S dĺžkovou hmotnosťou menej ako 714,29 decitexov,ale najmenej 232,56 decitexov (metrické číslo presahujúce 14, ale nepresahujúce 43)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52062200'),
('52062300', '-- S dĺžkovou hmotnosťou menšou ako 232,56 decitexov,ale najmenej 192,31 decitexov (metrické číslo presahujúce 43, ale nepresahujúce 52)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52062300'),
('52062400', '-- S dĺžkovou hmotnosťou menšou ako 192,31 decitexov, ale najmenej 125 decitexov (metrické číslo presahujúce 52, ale nepresahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52062400'),
('52062500', '-- S dĺžkovou hmotnosťou menej ako 125 decitexov (metrické číslo presahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52062500'),
('52062500:2X', '- Násobná (súkaná) alebo káblovaná priadza, z nečesaných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52062500:2X'),
('52063100', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou 714,29 decitexov alebo viac (metrické číslo jednoduchej priadze nepresahujúce 14)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52063100'),
('52063200', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 714,29 decitexov, ale najmenej 232,56 decitexov (metrické číslo jednoduchej priadze presahujúce 14, ale nepresahujúce 43)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52063200'),
('52063300', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 232,56 decitexov, ale najmenej 192,31 decitexov (metrické číslo jednoduchej priadze presahujúce 43, ale nepresahujúce 52)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52063300'),
('52063400', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 192,31 decitexov, ale najmenej 125 decitexov (metrické číslo jednoduchej priadze presahujúce 52, ale nepresahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52063400'),
('52063500', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 125 decitexov (metrické číslo jednoduchej priadze presahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52063500'),
('52063500:2X', '- Násobná (súkaná) alebo káblovaná priadza, z česaných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52063500:2X'),
('52064100', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou 714,29 decitexov alebo viac (metrické číslo jednoduchej priadze nepresahujúce 14)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52064100'),
('52064200', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 714,29 decitexov, ale najmenej 232,56 decitexov (metrické číslo jednoduchej priadze presahujúce 14, ale nepresahujúce 43)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52064200'),
('52064300', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 232,56 decitexov, ale najmenej 192,31 decitexov (metrické číslo jednoduchej priadze presahujúce 43, ale nepresahujúce 52)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52064300'),
('52064400', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 192,31 decitexov, ale najmenej 125 decitexov (metrické číslo jednoduchej priadze presahujúce 52, ale nepresahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52064400'),
('52064500', '-- Z jednoduchej priadze s dĺžkovou hmotnosťou menej ako 125 decitexov (metrické číslo jednoduchej priadze presahujúce 80)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52064500'),
('5207', 'Bavlnená priadza (iná ako šijacia niť) upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5207'),
('52071000', '- Obsahujúca 85 % hmotnosti alebo viac bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52071000'),
('52079000', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52079000'),
('5208', 'Bavlnené tkaniny, obsahujúce 85 % hmotnosti alebo viac bavlny, s plošnou hmotnosťou najviac 200 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5208'),
('5208:2X', '- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5208:2X'),
('520811', '-- V plátnovej väzbe, s plošnou hmotnosťou najviac 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520811'),
('52081110', '--- Tkaniny na výrobu bandáží, obväzov a lekárskych gáz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52081110'),
('52081190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52081190'),
('520812', '-- V plátnovej väzbe, s plošnou hmotnosťou viac ako 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520812'),
('520812:2X', '--- V plátnovej väzbe, s plošnou hmotnosťou viac ako 100 g/m2, ale najviac 130 g/m2 a so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520812:2X'),
('52081216', '---- Nepresahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52081216'),
('52081219', '---- Presahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52081219'),
('52081219:2X', '--- V plátnovej väzbe, s plošnou hmotnosťou viac ako 130 g/m2 a so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52081219:2X'),
('52081296', '---- Nepresahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52081296'),
('52081299', '---- Presahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52081299'),
('52081300', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52081300'),
('52081900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52081900'),
('52081900:2X', '- Bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52081900:2X'),
('520821', '-- V plátnovej väzbe, s plošnou hmotnosťou najviac 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520821'),
('52082110', '--- Tkaniny na výrobu bandáží, obväzov a lekárskych gáz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52082110'),
('52082190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52082190'),
('520822', '-- V plátnovej väzbe, s plošnou hmotnosťou viac 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520822'),
('520822:2X', '--- V plátnovej väzbe, s plošnou hmotnosťou viac ako 100 g/m2, ale najviac 130 g/m2 a so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520822:2X'),
('52082216', '---- Nepresahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52082216'),
('52082219', '---- Presahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52082219'),
('52082219:2X', '--- V plátnovej väzbe, s plošnou hmotnosťou viac ako 130 g/m2 a so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52082219:2X'),
('52082296', '---- Nepresahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52082296'),
('52082299', '---- Presahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52082299'),
('52082300', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52082300'),
('52082900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52082900'),
('52082900:2X', '- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52082900:2X'),
('52083100', '-- V plátnovej väzbe, s plošnou hmotnosťou najviac 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52083100'),
('520832', '-- V plátnovej väzbe, s plošnou hmotnosťou viac ako 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520832'),
('520832:2X', '--- V plátnovej väzbe, s plošnou hmotnosťou viac ako 100 g/m2, ale najviac 130 g/m2 a so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520832:2X'),
('52083216', '---- Nepresahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52083216'),
('52083219', '---- Presahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52083219'),
('52083219:2X', '--- V plátnovej väzbe, s plošnou hmotnosťou viac ako 130 g/m2 a so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52083219:2X'),
('52083296', '---- Nepresahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52083296'),
('52083299', '---- Presahujúcou 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52083299'),
('52083300', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52083300'),
('52083900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52083900'),
('52083900:2X', '- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52083900:2X'),
('52084100', '-- V plátnovej väzbe, s plošnou hmotnosťou najviac 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52084100'),
('52084200', '-- V plátnovej väzbe, s plošnou hmotnosťou viac ako 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52084200'),
('52084300', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52084300'),
('52084900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52084900'),
('52084900:2X', '- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52084900:2X'),
('52085100', '-- V plátnovej väzbe, s plošnou hmotnosťou najviac 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52085100'),
('52085200', '-- V plátnovej väzbe, s plošnou hmotnosťou viac ako 100 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52085200'),
('520859', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_520859'),
('52085910', '--- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52085910'),
('52085990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52085990'),
('5209', 'Bavlnené tkaniny, obsahujúce 85 % hmotnosti alebo viac bavlny, s plošnou hmotnosťou viac ako 200 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5209'),
('5209:2X', '- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5209:2X'),
('52091100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52091100'),
('52091200', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52091200'),
('52091900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52091900'),
('52091900:2X', '- Bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52091900:2X'),
('52092100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52092100'),
('52092200', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52092200'),
('52092900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52092900'),
('52092900:2X', '- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52092900:2X'),
('52093100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52093100'),
('52093200', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52093200'),
('52093900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52093900'),
('52093900:2X', '- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52093900:2X'),
('52094100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52094100'),
('52094200', '-- Tkaniny nazývané "denim"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52094200'),
('52094300', '-- Ostatné tkaniny vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52094300'),
('52094900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52094900'),
('52094900:2X', '- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52094900:2X'),
('52095100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52095100'),
('52095200', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52095200'),
('52095900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52095900'),
('5210', 'Bavlnené tkaniny, obsahujúce menej ako 85 % hmotnosti bavlny, v zmesi hlavne alebo výlučne s chemickými vláknami, s plošnou hmotnosťou najviac 200 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5210'),
('5210:2X', '- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5210:2X'),
('52101100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52101100'),
('52101900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52101900'),
('52101900:2X', '- Bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52101900:2X'),
('52102100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52102100'),
('52102900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52102900'),
('52102900:2X', '- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52102900:2X'),
('52103100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52103100'),
('52103200', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52103200'),
('52103900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52103900'),
('52103900:2X', '- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52103900:2X'),
('52104100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52104100'),
('52104900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52104900'),
('52104900:2X', '- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52104900:2X'),
('52105100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52105100'),
('52105900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52105900'),
('5211', 'Bavlnené tkaniny, obsahujúce menej ako 85 % hmotnosti bavlny, v zmesi hlavne alebo výlučne s chemickými vláknami, s plošnou hmotnosťou viac ako 200 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5211'),
('5211:2X', '- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5211:2X'),
('52111100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52111100'),
('52111200', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52111200'),
('52111900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52111900'),
('52112000', '- Bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52112000'),
('52112000:2X', '- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52112000:2X'),
('52113100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52113100'),
('52113200', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52113200'),
('52113900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52113900'),
('52113900:2X', '- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52113900:2X'),
('52114100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52114100'),
('52114200', '-- Tkaniny nazývané "denim"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52114200'),
('52114300', '-- Ostatné tkaniny vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52114300'),
('521149', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521149'),
('52114910', '--- Žakárové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52114910'),
('52114990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52114990'),
('52114990:2X', '- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52114990:2X'),
('52115100', '-- V plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52115100'),
('52115200', '-- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52115200'),
('52115900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52115900'),
('5212', 'Ostatné bavlnené tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5212'),
('5212:2X', '- S plošnou hmotnosťou najviac 200 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5212:2X'),
('521211', '-- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521211'),
('52121110', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121110'),
('52121190', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121190'),
('521212', '-- Bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521212'),
('52121210', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121210'),
('52121290', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121290'),
('521213', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521213'),
('52121310', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121310'),
('52121390', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121390'),
('521214', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521214'),
('52121410', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121410'),
('52121490', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121490'),
('521215', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521215'),
('52121510', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121510'),
('52121590', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52121590'),
('52121590:2X', '- S plošnou hmotnosťou viac ako 200 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_52121590:2X'),
('521221', '-- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521221'),
('52122110', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122110'),
('52122190', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122190'),
('521222', '-- Bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521222'),
('52122210', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122210'),
('52122290', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122290'),
('521223', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521223'),
('52122310', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122310'),
('52122390', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122390'),
('521224', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521224'),
('52122410', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122410'),
('52122490', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122490'),
('521225', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_521225'),
('52122510', '--- V zmesi hlavne alebo výlučne s ľanom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122510'),
('52122590', '--- Inak v zmesi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_52122590'),
('5301', 'Ľan, surový alebo spracovaný, ale nespradený; ľanová kúdeľ a ľanový odpad (vrátane odpadu z priadze a trhaného materiálu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5301'),
('53011000', '- Ľan, surový alebo máčaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53011000'),
('53011000:2X', '- Ľan, lámaný, trepaný, vyčesaný alebo inak spracovaný, ale nespradený', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53011000:2X'),
('53012100', '-- Lámaný alebo trepaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53012100'),
('53012900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53012900'),
('53013000', '- Ľanová kúdeľ a ľanový odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53013000'),
('5302', 'Pravé konope (Cannabis sativa L.), surové alebo spracované, ale nespradené; kúdeľ a odpad z pravého konope (vrátane odpadu z priadze a trhaného materiálu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5302'),
('53021000', '- Pravé konope, surové alebo máčané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53021000'),
('53029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53029000'),
('5303', 'Juta a ostatné textilné lykové vlákna (okrem ľanu, pravého konope a ramie), surové alebo spracované, ale nespradené; kúdeľ a odpad z týchto vlákien (vrátane odpadu z priadze a trhaného materiálu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5303'),
('53031000', '- Juta a ostatné textilné lykové vlákna, surové alebo máčané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53031000'),
('53039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53039000'),
('53050000', 'Kokosové, abakové (manilské konope alebo Musa textilis Nee), ramiové a ostatné rastlinné textilné vlákna, inde nešpecifikované ani nezahrnuté, surové alebo spracované, ale nespradené; kúdeľ, výčesky a odpad z týchto vlákien (vrátane odpadu z priadze a t', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53050000'),
('5306', 'Ľanova priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5306'),
('530610', '- Jednoduchá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_530610'),
('530610:2X', '-- Neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_530610:2X'),
('53061010', '--- S dĺžkovou hmotnosťou 833,3 decitexov alebo viac (metrické číslo nepresahujúce 12)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53061010'),
('53061030', '--- S dĺžkovou hmotnosťou menej ako 833,3 decitexov, ale najmenej 277,8 decitexov (metrické číslo presahujúce 12, ale nepresahujúce 36)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53061030'),
('53061050', '--- S dĺžkovou hmotnosťou menej ako 277,8 decitexov (metrické číslo presahujúce 36)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53061050'),
('53061090', '-- Upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53061090'),
('530620', '- Násobná (súkaná) alebo káblovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_530620'),
('53062010', '-- Neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53062010'),
('53062090', '-- Upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53062090'),
('5307', 'Priadza z jutových alebo ostatných textilných lykových vlákien položky 5303', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5307'),
('53071000', '- Jednoduchá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53071000'),
('53072000', '- Násobná (súkaná) alebo káblovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53072000'),
('5308', 'Priadza z ostatných rastlinných textilných vlákien; papierová priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5308'),
('53081000', '- Kokosová priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53081000'),
('530820', '- Priadza z pravého konope', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_530820'),
('53082010', '-- Neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53082010'),
('53082090', '-- Upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53082090'),
('530890', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_530890'),
('530890:2X', '-- Rámiová priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_530890:2X'),
('53089012', '--- S dĺžkovou hmotnosťou 277,8 decitexov alebo viac (metrické číslo nepresahujúce 36)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53089012'),
('53089019', '--- S dĺžkovou hmotnosťou menej ako 277,8 decitexov (metrické číslo presahujúce 36)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53089019'),
('53089050', '-- Papierová priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53089050'),
('53089090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53089090'),
('5309', 'Ľanové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5309'),
('5309:2X', '- Obsahujúce 85 % hmotnosti alebo viac ľanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5309:2X'),
('530911', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_530911'),
('53091110', '--- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53091110'),
('53091190', '--- Bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53091190'),
('53091900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53091900'),
('53091900:2X', '- Obsahujúce menej ako 85 % hmotnosti ľanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_53091900:2X'),
('53092100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53092100'),
('53092900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53092900'),
('5310', 'Tkaniny z jutových alebo ostatných textilných lykových vlákien položky 5303', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5310'),
('531010', '- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_531010'),
('53101010', '-- So šírkou nepresahujúcou 150 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53101010'),
('53101090', '-- So šírkou presahujúcou 150 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53101090'),
('53109000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53109000'),
('531100', 'Tkaniny z ostatných rastlinných textilných vlákien; tkaniny z papierovej priadze', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_531100'),
('53110010', '- Z ramie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53110010'),
('53110090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_53110090'),
('5401', 'Šijacia niť z chemických vlákien, tiež upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5401'),
('540110', '- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540110'),
('540110:2X', '-- Neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540110:2X'),
('540110:3X', '--- Jadrová priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540110:3X'),
('54011012', '---- Polyesterové vlákno ovinuté bavlnenými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54011012'),
('54011014', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54011014'),
('54011014:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54011014:2X'),
('54011016', '---- Textúrovaná priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54011016'),
('54011018', '---- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54011018'),
('54011090', '-- Upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54011090'),
('540120', '- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540120'),
('54012010', '-- Neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54012010'),
('54012090', '-- Upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54012090'),
('5402', 'Priadza zo syntetických vlákien (iná ako šijacia niť), neupravená na predaj v malom, vrátane syntetického monofilu s dĺžkovou hmotnosťou menej ako 67 decitexov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5402'),
('5402:2X', '- Vysokopevnostná priadza z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5402:2X'),
('54021100', '-- Z aromatických polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54021100'),
('54021900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54021900'),
('54022000', '- Vysokopevnostná priadza z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54022000'),
('54022000:2X', '- Tvarovaná priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54022000:2X'),
('54023100', '-- Z nylonu alebo ostatných polyamidov, s dĺžkovou hmotnosťou jednotlivého vlákna najviac 50 texov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54023100'),
('54023200', '-- Z nylonu alebo ostatných polyamidov, s dĺžkovou hmotnosťou jednotlivého vlákna viac ako 50 texov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54023200'),
('54023300', '-- Z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54023300'),
('54023400', '-- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54023400'),
('54023900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54023900'),
('54023900:2X', '- Ostatná priadza, jednoduchá, nekrútená alebo krútená so zákrutom nepresahujúcim 50 otáčok na meter', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54023900:2X'),
('54024400', '-- Elastomerná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54024400'),
('54024500', '-- Ostatná, z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54024500'),
('54024600', '-- Ostatná, z polyesterov, čiastočne orientovaných', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54024600'),
('54024700', '-- Ostatná, z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54024700'),
('54024800', '-- Ostatná, z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54024800'),
('54024900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54024900'),
('54024900:2X', '- Ostatná priadza, jednoduchá, krútená so zákrutom presahujúcim 50 otáčok na meter', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54024900:2X'),
('54025100', '-- Z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54025100'),
('54025200', '-- Z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54025200'),
('540259', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540259'),
('54025910', '--- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54025910'),
('54025990', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54025990'),
('54025990:2X', '- Ostatná priadza, násobná (súkaná) alebo káblovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54025990:2X'),
('54026100', '-- Z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54026100'),
('54026200', '-- Z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54026200'),
('540269', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540269'),
('54026910', '--- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54026910'),
('54026990', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54026990'),
('5403', 'Priadza z umelých vlákien (iná ako šijacia niť), neupravená na predaj v malom, vrátane umelého monofilu s dĺžkovou hmotnosťou menej ako 67 decitexov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5403'),
('54031000', '- Vysokopevnostná priadza z viskózového vlákna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54031000'),
('54031000:2X', '- Ostatná priadza, jednoduchá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54031000:2X'),
('54033100', '-- Z viskózového vlákna, nekrútená alebo krútená so zákrutom nepresahujúcim 120 otáčok na meter', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54033100'),
('54033200', '-- Z viskózového vlákna, krútená so zákrutom presahujúcim 120 otáčok na meter', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54033200'),
('54033300', '-- Z acetátu celulózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54033300'),
('54033900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54033900'),
('54033900:2X', '- Ostatná priadza, násobná (súkaná) alebo káblovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54033900:2X'),
('54034100', '-- Z viskózového vlákna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54034100'),
('54034200', '-- Z acetátu celulózy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54034200'),
('54034900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54034900'),
('5404', 'Syntetický monofil s dĺžkovou hmotnosťou 67 decitexov alebo viac, ktorého žiadny rozmer v priereze nepresahuje 1 mm; pásiky a podobné tvary (napríklad umelá slama), zo syntetických textilných materiálov, so zdanlivou šírkou nepresahujúcou 5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5404'),
('5404:2X', '- Monofil', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5404:2X'),
('54041100', '-- Elastomerný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54041100'),
('54041200', '-- Ostatný, z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54041200'),
('54041900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54041900'),
('540490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540490'),
('54049010', '-- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54049010'),
('54049090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54049090'),
('54050000', 'Umelý monofil s dĺžkovou hmotnosťou 67 decitexov alebo viac, ktorého žiadny rozmer v priereze nepresahuje 1 mm; pásiky a podobné tvary (napríklad umelá slama), z umelých textilných materiálov, so zdanlivou šírkou nepresahujúcou 5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54050000'),
('54060000', 'Priadza z chemických vlákien (iná ako šijacia niť), upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54060000'),
('5407', 'Tkaniny z priadze zo syntetických vlákien, vrátane tkanín vyrobených z materiálov položky 5404', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5407'),
('54071000', '- Tkaniny vyrobené z vysokopevnostnej priadze z nylonu alebo ostatných polyamidov alebo polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54071000'),
('540720', '- Tkaniny vyrobené z pásikov alebo podobných tvarov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540720'),
('540720:2X', '-- Z polyetylénu alebo polypropylénu, so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540720:2X'),
('54072011', '--- Menej ako 3 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54072011'),
('54072019', '--- 3 m alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54072019'),
('54072090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54072090'),
('54073000', '- Tkaniny uvedené v poznámke 9 k triede XI', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54073000'),
('54073000:2X', '- Ostatné tkaniny, obsahujúce 85 % hmotnosti alebo viac vlákien z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54073000:2X'),
('54074100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54074100'),
('54074200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54074200'),
('54074300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54074300'),
('54074400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54074400'),
('54074400:2X', '- Ostatné tkaniny, obsahujúce 85 % hmotnosti alebo viac tvarovaných polyesterových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54074400:2X'),
('54075100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54075100'),
('54075200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54075200'),
('54075300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54075300'),
('54075400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54075400'),
('54075400:2X', '- Ostatné tkaniny, obsahujúce 85 % hmotnosti alebo viac polyesterových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54075400:2X'),
('540761', '-- Obsahujúce 85 % hmotnosti alebo viac netvarovaných polyesterových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540761'),
('54076110', '--- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54076110'),
('54076130', '--- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54076130'),
('54076150', '--- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54076150'),
('54076190', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54076190'),
('540769', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540769'),
('54076910', '--- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54076910'),
('54076990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54076990'),
('54076990:2X', '- Ostatné tkaniny, obsahujúce 85 % hmotnosti alebo viac syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54076990:2X'),
('54077100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54077100'),
('54077200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54077200'),
('54077300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54077300'),
('54077400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54077400'),
('54077400:2X', '- Ostatné tkaniny, obsahujúce menej ako 85 % hmotnosti syntetických vlákien, v zmesi hlavne alebo výlučne s bavlnou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54077400:2X'),
('54078100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54078100'),
('54078200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54078200'),
('54078300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54078300'),
('54078400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54078400'),
('54078400:2X', '- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54078400:2X'),
('54079100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54079100'),
('54079200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54079200'),
('54079300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54079300'),
('54079400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54079400'),
('5408', 'Tkaniny z priadze z umelých vlákien, vrátane tkanín vyrobených z materiálov položky 5405', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5408'),
('54081000', '- Tkaniny vyrobené z vysokopevnostnej priadze z viskózových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54081000'),
('54081000:2X', '- Ostatné tkaniny, obsahujúce 85 % hmotnosti alebo viac umelých vlákien alebo pásikov alebo podobných tvarov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54081000:2X'),
('54082100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54082100'),
('540822', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_540822'),
('54082210', '--- So šírkou presahujúcou 135 cm, ale nepresahujúcou 155 cm, v plátnovej väzbe, keprovej väzbe, krížovej keprovej väzbe alebo atlasovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54082210'),
('54082290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54082290'),
('54082300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54082300'),
('54082400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54082400'),
('54082400:2X', '- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_54082400:2X'),
('54083100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54083100'),
('54083200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54083200'),
('54083300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54083300'),
('54083400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_54083400'),
('5501', 'Kábel zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5501'),
('55011000', '- Z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55011000'),
('55012000', '- Z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55012000'),
('55013000', '- Z akrylu alebo modakrylu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55013000'),
('55014000', '- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55014000'),
('55019000', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55019000'),
('550200', 'Kábel z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_550200'),
('55020010', '- Z viskózového vlákna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55020010'),
('55020040', '- Z acetátu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55020040'),
('55020080', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55020080'),
('5503', 'Syntetické strižné vlákna, nemykané, nečesané ani inak nespracované na spriadanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5503'),
('5503:2X', '- Z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5503:2X'),
('55031100', '-- Z aromatických polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55031100'),
('55031900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55031900'),
('55032000', '- Z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55032000'),
('55033000', '- Z akrylu alebo modakrylu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55033000'),
('55034000', '- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55034000'),
('55039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55039000'),
('5504', 'Umelé strižné vlákna, nemykané, nečesané ani inak nespracované na spriadanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5504'),
('55041000', '- Viskózové vlákna', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55041000'),
('55049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55049000'),
('5505', 'Odpad (vrátane výčeskov, odpadu z priadze a trhaného materiálu) z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5505'),
('550510', '- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_550510'),
('55051010', '-- Z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55051010'),
('55051030', '-- Z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55051030'),
('55051050', '-- Z akrylu alebo modakrylu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55051050'),
('55051070', '-- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55051070'),
('55051090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55051090'),
('55052000', '- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55052000'),
('5506', 'Syntetické strižné vlákna, mykané, česané alebo inak spracované na spriadanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5506'),
('55061000', '- Z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55061000'),
('55062000', '- Z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55062000'),
('55063000', '- Z akrylu alebo modakrylu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55063000'),
('55069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55069000'),
('55070000', 'Umelé strižné vlákna, mykané, česané alebo inak spracované na spriadanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55070000'),
('5508', 'Šijacia niť z chemických strižných vlákien, tiež upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5508'),
('550810', '- Zo syntetických strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_550810'),
('55081010', '-- Neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55081010'),
('55081090', '-- Upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55081090'),
('550820', '- Z umelých strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_550820'),
('55082010', '-- Neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55082010'),
('55082090', '-- Upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55082090'),
('5509', 'Priadza (iná ako šijacia niť) zo syntetických strižných vlákien, neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5509'),
('5509:2X', '- Obsahujúca 85 % hmotnosti alebo viac strižných vlákien z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5509:2X'),
('55091100', '-- Jednoduchá priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55091100'),
('55091200', '-- Násobná (súkaná) alebo káblovaná priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55091200'),
('55091200:2X', '- Obsahujúca 85 % hmotnosti alebo viac polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55091200:2X'),
('55092100', '-- Jednoduchá priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55092100'),
('55092200', '-- Násobná (súkaná) alebo káblovaná priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55092200'),
('55092200:2X', '- Obsahujúca 85 % hmotnosti alebo viac akrylových alebo modakrylových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55092200:2X'),
('55093100', '-- Jednoduchá priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55093100'),
('55093200', '-- Násobná (súkaná) alebo káblovaná priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55093200'),
('55093200:2X', '- Ostatná priadza, obsahujúca 85 % hmotnosti alebo viac syntetických strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55093200:2X'),
('55094100', '-- Jednoduchá priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55094100'),
('55094200', '-- Násobná (súkaná) alebo káblovaná priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55094200'),
('55094200:2X', '- Ostatná priadza, z polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55094200:2X'),
('55095100', '-- V zmesi hlavne alebo výlučne s umelými strižnými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55095100'),
('55095200', '-- V zmesi hlavne alebo výlučne s vlnou alebo jemnými chlpmi zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55095200'),
('55095300', '-- V zmesi hlavne alebo výlučne s bavlnou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55095300'),
('55095900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55095900'),
('55095900:2X', '- Ostatná priadza, z akrylových alebo modakrylových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55095900:2X'),
('55096100', '-- V zmesi hlavne alebo výlučne s vlnou alebo jemnými chlpmi zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55096100'),
('55096200', '-- V zmesi hlavne alebo výlučne s bavlnou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55096200'),
('55096900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55096900'),
('55096900:2X', '- Ostatná priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55096900:2X'),
('55099100', '-- V zmesi hlavne alebo výlučne s vlnou alebo jemnými chlpmi zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55099100'),
('55099200', '-- V zmesi hlavne alebo výlučne s bavlnou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55099200'),
('55099900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55099900'),
('5510', 'Priadza (iná ako šijacia niť) z umelých strižných vlákien, neupravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5510'),
('5510:2X', '- Obsahujúca 85 % hmotnosti alebo viac umelých strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5510:2X'),
('55101100', '-- Jednoduchá priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55101100'),
('55101200', '-- Násobná (súkaná) alebo káblovaná priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55101200'),
('55102000', '- Ostatná priadza, v zmesi hlavne alebo výlučne s vlnou alebo jemnými chlpmi zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55102000'),
('55103000', '- Ostatná priadza, v zmesi hlavne alebo výlučne s bavlnou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55103000'),
('55109000', '- Ostatná priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55109000'),
('5511', 'Priadza (iná ako šijacia niť) z chemických strižných vlákien, upravená na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5511'),
('55111000', '- Zo syntetických strižných vlákien, obsahujúca 85 % hmotnosti alebo viac týchto vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55111000'),
('55112000', '- Zo syntetických strižných vlákien, obsahujúca menej ako 85 % hmotnosti týchto vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55112000'),
('55113000', '- Z umelých strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55113000'),
('5512', 'Tkaniny zo syntetických strižných vlákien, obsahujúce 85 % hmotnosti alebo viac syntetických strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5512'),
('5512:2X', '- Obsahujúce 85 % hmotnosti alebo viac polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5512:2X'),
('55121100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55121100'),
('551219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551219'),
('55121910', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55121910'),
('55121990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55121990'),
('55121990:2X', '- Obsahujúce 85 % hmotnosti alebo viac akrylových alebo modakrylových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55121990:2X'),
('55122100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55122100'),
('551229', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551229'),
('55122910', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55122910'),
('55122990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55122990'),
('55122990:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55122990:2X'),
('55129100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55129100'),
('551299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551299'),
('55129910', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55129910'),
('55129990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55129990'),
('5513', 'Tkaniny zo syntetických strižných vlákien, obsahujúce menej ako 85 % hmotnosti týchto vlákien, v zmesi hlavne alebo výlučne s bavlnou, s plošnou hmotnosťou nepresahujúcou 170 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5513'),
('5513:2X', '- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5513:2X'),
('551311', '-- Z polyesterových strižných vlákien, v plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551311'),
('55131120', '--- So šírkou 165 cm alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55131120'),
('55131190', '--- So šírkou viac ako 165 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55131190'),
('55131200', '-- Z polyesterových strižných vlákien, vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55131200'),
('55131300', '-- Ostatné tkaniny z polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55131300'),
('55131900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55131900'),
('55131900:2X', '- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55131900:2X'),
('55132100', '-- Z polyesterových strižných vlákien, v plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55132100'),
('551323', '-- Ostatné tkaniny z polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551323'),
('55132310', '--- Vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby kríženého kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55132310'),
('55132390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55132390'),
('55132900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55132900'),
('55132900:2X', '- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55132900:2X'),
('55133100', '-- Z polyesterových strižných vlákien, v plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55133100'),
('55133900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55133900'),
('55133900:2X', '- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55133900:2X'),
('55134100', '-- Z polyesterových strižných vlákien, v plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55134100'),
('55134900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55134900'),
('5514', 'Tkaniny zo syntetických strižných vlákien, obsahujúce menej ako 85 % hmotnosti týchto vlákien, v zmesi hlavne alebo výlučne s bavlnou, s plošnou hmotnosťou presahujúcou 170 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5514'),
('5514:2X', '- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5514:2X'),
('55141100', '-- Z polyesterových strižných vlákien, v plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55141100'),
('55141200', '-- Z polyesterových strižných vlákien, vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby kríženého kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55141200'),
('551419', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551419'),
('55141910', '--- Z polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55141910'),
('55141990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55141990'),
('55141990:2X', '- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55141990:2X'),
('55142100', '-- Z polyesterových strižných vlákien, v plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55142100'),
('55142200', '-- Z polyesterových strižných vlákien, vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55142200'),
('55142300', '-- Ostatné tkaniny z polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55142300'),
('55142900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55142900'),
('551430', '- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551430'),
('55143010', '-- Z polyesterových strižných vlákien, v plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55143010'),
('55143030', '-- Z polyesterových strižných vlákien, vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55143030'),
('55143050', '-- Ostatné tkaniny z polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55143050'),
('55143090', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55143090'),
('55143090:2X', '- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55143090:2X'),
('55144100', '-- Z polyesterových strižných vlákien, v plátnovej väzbe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55144100'),
('55144200', '-- Z polyesterových strižných vlákien, vo väzbe trojväzbový alebo štvorväzbový keper, vrátane väzby krížového kepra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55144200'),
('55144300', '-- Ostatné tkaniny z polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55144300'),
('55144900', '-- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55144900'),
('5515', 'Ostatné tkaniny zo syntetických strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5515'),
('5515:2X', '- Z polyesterových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5515:2X'),
('551511', '-- V zmesi hlavne alebo výlučne s viskózovými strižnými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551511'),
('55151110', '--- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151110'),
('55151130', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151130'),
('55151190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151190'),
('551512', '-- V zmesi hlavne alebo výlučne s chemickými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551512'),
('55151210', '--- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151210'),
('55151230', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151230'),
('55151290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151290'),
('551513', '-- V zmesi hlavne alebo výlučne s vlnou alebo jemnými chlpmi zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551513'),
('551513:2X', '--- V zmesi hlavne alebo výlučne s mykanou vlnou alebo jemnými chlpmi zvierat (mykaná priadza)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551513:2X'),
('55151311', '---- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151311'),
('55151319', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151319'),
('55151319:2X', '--- V zmesi hlavne alebo výlučne s česanou vlnou alebo jemnými chlpmi zvierat (česaná priadza)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55151319:2X'),
('55151391', '---- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151391'),
('55151399', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151399'),
('551519', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551519'),
('55151910', '--- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151910'),
('55151930', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151930'),
('55151990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55151990'),
('55151990:2X', '- Z akrylových alebo modakrylových strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55151990:2X'),
('551521', '-- V zmesi hlavne alebo výlučne s chemickými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551521'),
('55152110', '--- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55152110'),
('55152130', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55152130'),
('55152190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55152190'),
('551522', '-- V zmesi hlavne alebo výlučne s vlnou alebo jemnými chlpmi zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551522'),
('551522:2X', '--- V zmesi hlavne alebo výlučne s mykanou vlnou alebo jemnými chlpmi zvierat (mykaná priadza)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551522:2X'),
('55152211', '---- Nebielená alebo bielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55152211'),
('55152219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55152219'),
('55152219:2X', '--- V zmesi hlavne alebo výlučne s česanou vlnou alebo jemnými chlpmi zvierat (česaná priadza)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55152219:2X'),
('55152291', '---- Nebielená alebo bielená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55152291'),
('55152299', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55152299'),
('55152900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55152900'),
('55152900:2X', '- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55152900:2X'),
('551591', '-- V zmesi hlavne alebo výlučne s chemickými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551591'),
('55159110', '--- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55159110'),
('55159130', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55159130'),
('55159190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55159190'),
('551599', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551599'),
('55159920', '--- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55159920'),
('55159940', '--- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55159940'),
('55159980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55159980'),
('5516', 'Tkaniny z umelých strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5516'),
('5516:2X', '- Obsahujúce 85 % hmotnosti alebo viac umelých strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5516:2X'),
('55161100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55161100'),
('55161200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55161200'),
('55161300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55161300'),
('55161400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55161400'),
('55161400:2X', '- Obsahujúce menej ako 85 % hmotnosti umelých strižných vlákien, v zmesi hlavne alebo výlučne s chemickými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55161400:2X'),
('55162100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55162100'),
('55162200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55162200'),
('551623', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_551623'),
('55162310', '--- Žakárové tkaniny so šírkou 140 cm alebo viac (matracové poťahy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55162310'),
('55162390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55162390'),
('55162400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55162400'),
('55162400:2X', '- Obsahujúce menej ako 85 % hmotnosti umelých strižných vlákien, v zmesi hlavne alebo výlučne s vlnou alebo jemnými chlpmi zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55162400:2X'),
('55163100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55163100'),
('55163200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55163200'),
('55163300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55163300'),
('55163400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55163400'),
('55163400:2X', '- Obsahujúce menej ako 85 % hmotnosti umelých strižných vlákien, v zmesi hlavne alebo výlučne s bavlnou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55163400:2X'),
('55164100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55164100'),
('55164200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55164200'),
('55164300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55164300'),
('55164400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55164400'),
('55164400:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_55164400:2X'),
('55169100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55169100'),
('55169200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55169200'),
('55169300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55169300'),
('55169400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_55169400'),
('5601', 'Vata z textilných materiálov a výrobky z nej; textilné vlákna, nepresahujúce dĺžku 5 mm (vločka), textilný prach a nopky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5601'),
('5601:2X', '- Vata; ostatné výrobky z vaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5601:2X'),
('560121', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560121'),
('56012110', '--- Absorpčné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56012110'),
('56012190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56012190'),
('560122', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560122'),
('56012210', '--- Náviny s priemerom nepresahujúcim 8 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56012210'),
('56012290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56012290'),
('56012900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56012900'),
('56013000', '- Textilné vločky a prach a nopky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56013000'),
('5602', 'Plsť, tiež impregnovaná, potiahnutá, pokrytá alebo laminovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5602'),
('560210', '- Vpichovaná plsť a textílie preplietané vlastnými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560210'),
('560210:2X', '-- Neimpregnované, nepotiahnuté, nepokryté ani nelaminované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560210:2X'),
('560210:3X', '--- Vpichovaná plsť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560210:3X'),
('56021011', '---- Z juty alebo ostatných textilných lykových vlákien položky 5303', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56021011'),
('56021019', '---- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56021019'),
('56021019:2X', '--- Textílie preplietané vlastnými vláknami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56021019:2X'),
('56021031', '---- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56021031'),
('56021038', '---- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56021038'),
('56021090', '-- Impregnované, potiahnuté, pokryté alebo laminované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56021090'),
('56021090:2X', '- Ostatná plsť, neimpregnovaná, nepokrytá, nepotiahnutá ani nelaminovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56021090:2X'),
('56022100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56022100'),
('56022900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56022900'),
('56029000', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56029000'),
('5603', 'Netkané textílie, tiež impregnované, potiahnuté, pokryté alebo laminované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5603'),
('5603:2X', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5603:2X'),
('560311', '-- S plošnou hmotnosťou najviac 25 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560311'),
('56031110', '--- Pokryté alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56031110'),
('56031190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56031190'),
('560312', '-- S plošnou hmotnosťou viac ako 25 g/m2, ale najviac 70 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560312'),
('56031210', '--- Pokryté alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56031210'),
('56031290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56031290'),
('560313', '-- S plošnou hmotnosťou viac ako 70 g/m2, ale najviac 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560313'),
('56031310', '--- Pokryté alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56031310'),
('56031390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56031390'),
('560314', '-- S plošnou hmotnosťou viac ako 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560314'),
('56031410', '--- Pokryté alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56031410'),
('56031490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56031490'),
('56031490:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56031490:2X'),
('560391', '-- S plošnou hmotnosťou najviac 25 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560391'),
('56039110', '--- Pokryté alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56039110'),
('56039190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56039190'),
('560392', '-- S plošnou hmotnosťou viac ako 25 g/m2, ale najviac 70 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560392'),
('56039210', '--- Pokryté alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56039210'),
('56039290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56039290'),
('560393', '-- S plošnou hmotnosťou viac ako 70 g/m2, ale najviac 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560393'),
('56039310', '--- Pokryté alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56039310'),
('56039390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56039390'),
('560394', '-- S plošnou hmotnosťou viac ako 150 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560394'),
('56039410', '--- Pokryté alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56039410'),
('56039490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56039490'),
('5604', 'Kaučukové nite a kordy, pokryté textíliou; textilná priadza a pásiky a podobné tvary položky 5404 alebo 5405, impregnované, potiahnuté, pokryté alebo oplášťované kaučukom alebo plastmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5604'),
('56041000', '- Kaučukové nite a kordy, pokryté textíliou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56041000'),
('560490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560490'),
('56049010', '-- Vysokopevnostná priadza z polyesterov, nylonu alebo ostatných polyamidov alebo viskózových vlákien, impregnovaná alebo potiahnutá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56049010'),
('56049090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56049090'),
('56050000', 'Metalizovaná priadza, tiež opradená, s určením ako textilná priadza alebo pásiky alebo podobné tvary položky 5404 alebo 5405, kombinované s kovom vo forme nite, pásika alebo prášku alebo pokrytá kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56050000'),
('560600', 'Opradená priadza, pásiky a podobné tvary položky 5404 alebo 5405, opradené (iné ako výrobky položky 5605 a iné ako opradená priadza z vlásia); ženilková priadza (vrátane povločkovanej ženilkovej priadze); slučková priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560600'),
('56060010', '- Slučková pletená priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56060010'),
('56060010:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56060010:2X'),
('56060091', '-- Opradená priadza', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56060091'),
('56060099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56060099'),
('5607', 'Motúzy, šnúry, povrazy a laná, tiež splietané alebo oplietané a tiež impregnované, potiahnuté, pokryté alebo oplášťované plastmi alebo kaučukom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5607'),
('5607:2X', '- Zo sisalových alebo ostatných textilných vlákien rodu Agáve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5607:2X'),
('56072100', '-- Motúz na viazanie alebo balenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56072100'),
('56072900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56072900'),
('56072900:2X', '- Z polyetylénu alebo polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56072900:2X'),
('56074100', '-- Motúz na viazanie alebo balenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56074100'),
('560749', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560749'),
('560749:2X', '--- S dĺžkovou hmotnosťou viac ako 50 000 decitexov (5 g/m)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560749:2X'),
('56074911', '---- Splietané alebo oplietané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56074911'),
('56074919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56074919'),
('56074990', '--- S dĺžkovou hmotnosťou 50 000 decitexov (5 g/m) alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56074990'),
('560750', '- Z ostatných syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560750'),
('560750:2X', '-- Z nylonu alebo ostatných polyamidov alebo polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560750:2X'),
('560750:3X', '--- S dĺžkovou hmotnosťou viac ako 50 000 decitexov (5 g/m)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560750:3X'),
('56075011', '---- Splietané alebo oplietané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56075011'),
('56075019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56075019'),
('56075030', '--- S dĺžkovou hmotnosťou 50 000 decitexov (5 g/m) alebo menej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56075030'),
('56075090', '-- Z ostatných syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56075090'),
('560790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560790'),
('56079020', '-- Z abakových vlákien (manilské konope alebo Musa textilis Nee) alebo ostatných tvrdých (listových) vlákien; z jutových alebo ostatných textilných lykových vlákien položky 5303', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56079020'),
('56079090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56079090'),
('5608', 'Viazané sieťoviny z motúzov, šnúr alebo povrazov; celkom dohotovené rybárske siete a ostatné celkom dohotovené siete, z textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5608'),
('5608:2X', '- Z chemických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5608:2X'),
('560811', '-- Celkom dohotovené rybárske siete', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560811'),
('56081120', '--- Z motúzov, šnúr, povrazov alebo lán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56081120'),
('56081180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56081180'),
('560819', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560819'),
('560819:2X', '--- Celkom dohotovené siete', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560819:2X'),
('560819:3X', '---- Z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_560819:3X'),
('56081911', '----- Z motúzov, šnúr, povrazov alebo lán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56081911'),
('56081919', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56081919'),
('56081930', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56081930'),
('56081990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56081990'),
('56089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56089000'),
('56090000', 'Výrobky z priadze, pásikov alebo podobných tvarov položky 5404 alebo 5405, motúzov, šnúr, povrazov alebo lán, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_56090000'),
('5701', 'Koberce a ostatné textilné podlahové krytiny, uzlíkovité, tiež celkom dohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5701'),
('570110', '- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570110'),
('57011010', '-- Obsahujúce celkovo viac ako 10 % hmotnosti prírodného hodvábu alebo hodvábneho odpadu iného ako výčeskov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57011010'),
('57011090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57011090'),
('570190', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570190'),
('57019010', '-- Z prírodného hodvábu, hodvábneho odpadu iného ako výčeskov, zo syntetických vlákien, z priadze položky 5605 alebo textilných materiálov obsahujúcich kovové nite', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57019010'),
('57019090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57019090'),
('5702', 'Koberce a ostatné textilné podlahové krytiny, tkané, nevšívané ani nepovločkované, tiež celkom dohotovené, vrátane druhu "Kelem", "Schumacks", "Karamanie" a podobných ručne tkaných kobercov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5702'),
('57021000', '- "Kelem", "Schumacks", "Karamanie" a podobné ručne tkané koberce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57021000'),
('57022000', '- Podlahové krytiny z kokosových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57022000'),
('57022000:2X', '- Ostatné, s vlasovým povrchom, celkom nedohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_57022000:2X'),
('570231', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570231'),
('57023110', '--- Axminsterské koberce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57023110'),
('57023180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57023180'),
('570232', '-- Z chemických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570232'),
('57023210', '--- Axminsterské koberce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57023210'),
('57023290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57023290'),
('57023900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57023900'),
('57023900:2X', '- Ostatné, s vlasovým povrchom, celkom dohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_57023900:2X'),
('570241', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570241'),
('57024110', '--- Axminsterské koberce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57024110'),
('57024190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57024190'),
('570242', '-- Z chemických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570242'),
('57024210', '--- Axminsterské koberce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57024210'),
('57024290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57024290'),
('57024900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57024900'),
('570250', '- Ostatné, bez vlasového povrchu, celkom nedohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570250'),
('57025010', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57025010'),
('57025010:2X', '-- Z chemických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_57025010:2X'),
('57025031', '--- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57025031'),
('57025039', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57025039'),
('57025090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57025090'),
('57025090:2X', '- Ostatné, bez vlasového povrchu, celkom dohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_57025090:2X'),
('57029100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57029100'),
('570292', '-- Z chemických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570292'),
('57029210', '--- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57029210'),
('57029290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57029290'),
('57029900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57029900'),
('5703', 'Koberce a ostatné textilné podlahové krytiny, všívané, tiež celkom dohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5703'),
('57031000', '- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57031000'),
('570320', '- Z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570320'),
('570320:2X', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570320:2X'),
('57032012', '--- Dlaždice, s maximálnou plochou povrchu 1 m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57032012'),
('57032018', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57032018'),
('57032018:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_57032018:2X'),
('57032092', '--- Dlaždice, s maximálnou plochou povrchu 1 m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57032092'),
('57032098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57032098'),
('570330', '- Z ostatných chemických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570330'),
('570330:2X', '-- Z polypropylénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570330:2X'),
('57033012', '--- Dlaždice, s maximálnou plochou povrchu 1 m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57033012'),
('57033018', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57033018'),
('57033018:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_57033018:2X'),
('57033082', '--- Dlaždice, s maximálnou plochou povrchu 1 m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57033082'),
('57033088', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57033088'),
('570390', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570390'),
('57039020', '-- Dlaždice, s maximálnou plochou povrchu 1 m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57039020'),
('57039080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57039080'),
('5704', 'Koberce a ostatné textilné podlahové krytiny, z plsti, nevšívané ani nepovločkované, tiež celkom dohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5704'),
('57041000', '- Dlaždice, s maximálnou plochou povrchu 0,3 m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57041000'),
('57049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57049000'),
('570500', 'Ostatné koberce a ostatné textilné podlahové krytiny, tiež celkom dohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_570500'),
('57050030', '- Z chemických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57050030'),
('57050080', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_57050080'),
('5801', 'Vlasové tkaniny a ženilkové tkaniny, iné ako tkaniny položky 5802 alebo 5806', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5801'),
('58011000', '- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58011000'),
('58011000:2X', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58011000:2X'),
('58012100', '-- Nerezané útkové vlasové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58012100'),
('58012200', '-- Rezaný menčester', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58012200'),
('58012300', '-- Ostatné útkové vlasové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58012300'),
('58012600', '-- Ženilkové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58012600'),
('58012700', '-- Osnovné vlasové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58012700'),
('58012700:2X', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58012700:2X'),
('58013100', '-- Nerezané útkové vlasové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58013100'),
('58013200', '-- Rezaný menčester', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58013200'),
('58013300', '-- Ostatné útkové vlasové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58013300'),
('58013600', '-- Ženilkové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58013600'),
('58013700', '-- Osnovné vlasové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58013700'),
('580190', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_580190'),
('58019010', '-- Z ľanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58019010'),
('58019090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58019090'),
('5802', 'Slučkové uterákoviny (froté) a podobné slučkové tkaniny, iné ako stuhy položky 5806; všívané textílie, iné ako výrobky položky 5703', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5802'),
('5802:2X', '- Slučkové uterákoviny (froté) a podobné slučkové tkaniny, z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5802:2X'),
('58021100', '-- Nebielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58021100'),
('58021900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58021900'),
('58022000', '- Slučkové uterákoviny (froté) a podobné slučkové tkaniny, z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58022000'),
('58023000', '- Všívané textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58023000'),
('580300', 'Perlinkové tkaniny, iné ako stuhy položky 5806', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_580300'),
('58030010', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58030010'),
('58030030', '- Z prírodného hodvábu alebo hodvábneho odpadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58030030'),
('58030090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58030090'),
('5804', 'Tyly a ostatné sieťové textílie, okrem tkaných, pletených alebo háčkovaných textílií; čipka v metráži, pásoch alebo motívoch, iná ako textílie položiek 6002 až 6006', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5804'),
('580410', '- Tyly a ostatné sieťové textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_580410'),
('58041010', '-- Hladké', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58041010'),
('58041090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58041090'),
('58041090:2X', '- Strojovo vyrobená čipka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58041090:2X'),
('580421', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_580421'),
('58042110', '--- Vyrobená na čipkových paličkovacích strojoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58042110'),
('58042190', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58042190'),
('580429', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_580429'),
('58042910', '--- Vyrobená na čipkových paličkovacích strojoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58042910'),
('58042990', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58042990'),
('58043000', '- Ručne vyrobená čipka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58043000'),
('58050000', 'Ručne tkané tapisérie druhu gobelín, flanderský gobelín, Aubusson, Beauvais a podobné, a ihlou robené tapisérie (napríklad stehom nazývaným "petit point" alebo krížovým stehom), tiež celkom dohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58050000'),
('5806', 'Stuhy, iné ako tovar položky 5807; stuhy bez útku zhotovené z osnovných nití spojených lepidlom (bolduky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5806'),
('58061000', '- Vlasové tkaniny (vrátane slučkových uterákovín a podobných slučkových tkanín) a ženilkové tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58061000'),
('58062000', '- Ostatné tkaniny, obsahujúce 5 % hmotnosti alebo viac elastomernej priadze alebo kaučukovej nite', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58062000'),
('58062000:2X', '- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58062000:2X'),
('58063100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58063100'),
('580632', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_580632'),
('58063210', '--- S pravými okrajmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58063210'),
('58063290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58063290'),
('58063900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58063900'),
('58064000', '- Textílie bez útku zhotovené z osnovných nití spojených lepidlom (bolduky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58064000'),
('5807', 'Štítky, odznaky a podobné výrobky z textilných materiálov, v metráži, pásoch alebo narezané na určitý rozmer alebo do tvaru, nevyšívané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5807'),
('580710', '- Tkané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_580710'),
('58071010', '-- S vtkaným nápisom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58071010'),
('58071090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58071090'),
('580790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_580790'),
('58079010', '-- Z plsti alebo netkaných textílií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58079010'),
('58079090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58079090'),
('5808', 'Prámiky v metráži; ozdobné lemovky a podobné výrobky v metráži, bez výšiviek, iné ako pletené alebo háčkované; strapce, brmbolce a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5808'),
('58081000', '- Prámiky, v metráži', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58081000'),
('58089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58089000'),
('58090000', 'Tkaniny z kovových nití a tkaniny z pokovovanej priadze položky 5605, druhov používaných v odievaní, ako dekoračné tkaniny alebo na podobné účely, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58090000'),
('5810', 'Výšivky v metráži, pásoch alebo ako motívy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5810'),
('581010', '- Výšivky bez viditeľného podkladu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_581010'),
('58101010', '-- V hodnote presahujúcej 35 EUR/kg (čistá hmotnosť)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58101010'),
('58101090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58101090'),
('58101090:2X', '- Ostatné výšivky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58101090:2X'),
('581091', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_581091'),
('58109110', '--- V hodnote presahujúcej 17,50 EUR/kg (čistá hmotnosť)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58109110'),
('58109190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58109190'),
('581092', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_581092'),
('58109210', '--- V hodnote presahujúcej 17,50 EUR/kg (čistá hmotnosť)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58109210'),
('58109290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58109290'),
('581099', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_581099'),
('58109910', '--- V hodnote presahujúcej 17,50 EUR/kg (čistá hmotnosť)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58109910'),
('58109990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_58109990'),
('58110000', 'Prešívané textilné výrobky v metráži, zložené z jednej alebo niekoľkých vrstiev textilných materiálov spojených s výplňovým materiálom šitím, prešívaním alebo inak, iné ako výšivky položky 5810', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_58110000'),
('5901', 'Textílie potiahnuté lepidlom alebo škrobovými látkami, druhov používaných na vonkajšie obaly kníh alebo na podobné účely; kopírovacie priesvitné plátno; pripravené maliarske plátno; stužené plátno a podobné stužené textílie druhov používaných ako klobuč', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5901'),
('59011000', '- Textílie potiahnuté lepidlom alebo škrobovými látkami, druhov používaných na vonkajšie obaly kníh alebo na podobné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59011000'),
('59019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59019000'),
('5902', 'Pneumatikové kordové textílie z vysokopevnostnej priadze z nylonu alebo ostatných polyamidov, polyesterov alebo viskózových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5902'),
('590210', '- Z nylonu alebo ostatných polyamidov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_590210'),
('59021010', '-- Impregnované kaučukom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59021010'),
('59021090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59021090'),
('590220', '- Z polyesterov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_590220'),
('59022010', '-- Impregnované kaučukom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59022010'),
('59022090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59022090'),
('590290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_590290'),
('59029010', '-- Impregnované kaučukom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59029010'),
('59029090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59029090'),
('5903', 'Textílie impregnované, potiahnuté, pokryté alebo laminované plastmi, iné ako textílie položky 5902', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5903'),
('590310', '- Polyvinylchloridom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_590310'),
('59031010', '-- Impregnované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59031010'),
('59031090', '-- Potiahnuté, pokryté alebo laminované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59031090'),
('590320', '- Polyuretánom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_590320'),
('59032010', '-- Impregnované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59032010'),
('59032090', '-- Potiahnuté, pokryté alebo laminované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59032090'),
('590390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_590390'),
('59039010', '-- Impregnované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59039010'),
('59039010:2X', '-- Potiahnuté, pokryté alebo laminované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59039010:2X'),
('59039091', '--- Derivátmi celulózy alebo ostatnými plastmi, s textíliou tvoriacou lícnu stranu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59039091'),
('59039099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59039099'),
('5904', 'Linoleum, tiež rezané do tvaru; podlahové krytiny pozostávajúce z nánosu alebo povlaku aplikovaného na textilnom podklade, tiež rezané do tvaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5904'),
('59041000', '- Linoleum', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59041000'),
('59049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59049000'),
('590500', 'Textilné tapety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_590500'),
('59050010', '- Pozostávajúce z paralelne položených priadzí, pripevnených na podklade z akéhokoľvek materiálu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59050010'),
('59050010:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59050010:2X'),
('59050030', '-- Z ľanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59050030'),
('59050050', '-- Z juty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59050050'),
('59050070', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59050070'),
('59050090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59050090'),
('5906', 'Pogumované textílie, iné ako textílie položky 5902', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5906'),
('59061000', '- Lepiaca páska so šírkou nepresahujúcou 20 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59061000'),
('59061000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59061000:2X'),
('59069100', '-- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59069100'),
('590699', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_590699'),
('59069910', '--- Textílie uvedené v poznámke 4 c) k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59069910'),
('59069990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59069990'),
('59070000', 'Textílie inak impregnované, potiahnuté alebo pokryté; maľované plátno na divadelnú scénu, textílie na vytvorenie pozadia v štúdiách alebo podobné textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59070000'),
('59080000', 'Textilné knôty, tkané, splietané alebo pletené, do lámp, varičov, zapaľovačov, sviečok alebo podobných výrobkov; žiarové plynové pančušky a duté pleteniny na výrobu žiarových plynových pančušiek, tiež impregnované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59080000'),
('590900', 'Textilné hadice a podobné textilné rúrky, tiež s vyložením, armatúrou alebo príslušenstvom z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_590900'),
('59090010', '- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59090010'),
('59090090', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59090090'),
('59100000', 'Hnacie alebo dopravníkové pásy alebo remene, z textilného materiálu, tiež impregnované, potiahnuté, pokryté alebo laminované plastmi, alebo zosilnené kovom alebo ostatným materiálom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59100000'),
('5911', 'Textilné výrobky a tovar, na technické účely, špecifikované v poznámke 7 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_5911'),
('59111000', '- Textílie, plsti a tkaniny s plstenou podšívkou, potiahnuté, pokryté alebo laminované kaučukom, usňou alebo ostatným materiálom, druhov používaných na mykacie povlaky, a podobné textílie druhov používaných na ostatné technické účely, vrátane velúrových', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59111000'),
('59112000', '- Mlynárske plátno, tiež celkom dohotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59112000'),
('59112000:2X', '- Textílie a plsti, nekonečné alebo vybavené spojovacími časťami, druhov používaných v papierenských alebo podobných strojoch (napríklad na buničinu alebo azbestocement)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59112000:2X'),
('591131', '-- S plošnou hmotnosťou menej ako 650 g/m2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_591131'),
('591131:2X', '--- Z prírodného hodvábu alebo chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_591131:2X'),
('59113111', '---- Tkaniny, druhov používaných v papierenských strojoch (napríklad tvarovacie tkaniny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59113111'),
('59113119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59113119'),
('59113190', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59113190'),
('591132', '-- S plošnou hmotnosťou 650 g/m2 alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_591132'),
('591132:2X', '--- Z prírodného hodvábu alebo chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_591132:2X'),
('59113211', '---- Tkaniny s vpichovanou plstenou vrstvou, druhov používaných v papierenských strojoch (napríklad lisovacie plsti)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59113211'),
('59113219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_59113219'),
('59113290', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59113290'),
('59114000', '- Filtračné plachtičky druhov používaných v olejových lisoch alebo podobných zariadeniach, vrátane plachtičiek z ľudských vlasov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59114000'),
('591190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_591190'),
('59119010', '-- Z plsti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59119010'),
('59119090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_59119090'),
('6001', 'Vlasové textílie, vrátane textílií s "dlhým vlasom" a slučkových textílií, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6001'),
('60011000', '- Textílie s "dlhým vlasom"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60011000'),
('60011000:2X', '- Slučkové vlasové textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60011000:2X'),
('60012100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60012100'),
('60012200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60012200'),
('60012900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60012900'),
('60012900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60012900:2X'),
('60019100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60019100'),
('60019200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60019200'),
('60019900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60019900'),
('6002', 'Pletené alebo háčkované textílie so šírkou nepresahujúcou 30 cm, obsahujúce 5 % hmotnosti alebo viac elastomernej priadze alebo kaučukovej nite, iné ako textílie položky 6001', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6002'),
('60024000', '- Obsahujúce 5 % hmotnosti alebo viac elastomernej priadze, ale neobsahujúce kaučukovú niť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60024000'),
('60029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60029000'),
('6003', 'Pletené alebo háčkované textílie so šírkou nepresahujúcou 30 cm, iné ako textílie položky 6001 alebo 6002', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6003'),
('60031000', '- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60031000'),
('60032000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60032000'),
('600330', '- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600330'),
('60033010', '-- Rašlová čipka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60033010'),
('60033090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60033090'),
('60034000', '- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60034000'),
('60039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60039000'),
('6004', 'Pletené alebo háčkované textílie so šírkou presahujúcou 30 cm, obsahujúce 5 % hmotnosti alebo viac elestomernej priadze alebo kaučukovej nite, iné ako textílie položky 6001', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6004'),
('60041000', '- Obsahujúce 5 % hmotnosti alebo viac elastomernej priadze, ale neobsahujúce kaučukovú niť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60041000'),
('60049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60049000'),
('6005', 'Textílie z osnovných pletenín (vrátane textílií vyrobených na galónových pletacích strojoch), iné ako textílie položiek 6001 až 6004', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6005'),
('6005:2X', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6005:2X'),
('60052100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60052100'),
('60052200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60052200'),
('60052300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60052300'),
('60052400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60052400'),
('60052400:2X', '- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60052400:2X'),
('600531', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600531'),
('60053110', '--- Na záclony, vrátane sieťových záclonovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053110'),
('60053150', '--- Rašlová čipka, iná ako na záclony alebo sieťové záclonoviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053150'),
('60053190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053190'),
('600532', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600532'),
('60053210', '--- Na záclony, vrátane sieťových záclonovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053210'),
('60053250', '--- Rašlová čipka, iná ako na záclony alebo sieťové záclonoviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053250'),
('60053290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053290'),
('600533', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600533'),
('60053310', '--- Na záclony, vrátane sieťových záclonovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053310'),
('60053350', '--- Rašlová čipka, iná ako na záclony alebo sieťové záclonoviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053350'),
('60053390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053390'),
('600534', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600534'),
('60053410', '--- Na záclony, vrátane sieťových záclonovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053410'),
('60053450', '--- Rašlová čipka, iná ako na záclony alebo sieťové záclonoviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053450'),
('60053490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053490'),
('60053490:2X', '- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60053490:2X'),
('60054100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60054100'),
('60054200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60054200'),
('60054300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60054300'),
('60054400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60054400'),
('600590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600590'),
('60059010', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60059010'),
('60059090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60059090'),
('6006', 'Ostatné pletené alebo háčkované textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6006'),
('60061000', '- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60061000'),
('60061000:2X', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60061000:2X'),
('60062100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60062100'),
('60062200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60062200'),
('60062300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60062300'),
('60062400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60062400'),
('60062400:2X', '- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60062400:2X'),
('600631', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600631'),
('60063110', '--- Na záclony, vrátane sieťových záclonovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60063110'),
('60063190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60063190'),
('600632', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600632'),
('60063210', '--- Na záclony, vrátane sieťových záclonovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60063210'),
('60063290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60063290'),
('600633', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600633'),
('60063310', '--- Na záclony, vrátane sieťových záclonovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60063310'),
('60063390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60063390'),
('600634', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_600634'),
('60063410', '--- Na záclony, vrátane sieťových záclonovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60063410'),
('60063490', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60063490'),
('60063490:2X', '- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60063490:2X'),
('60064100', '-- Nebielené alebo bielené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60064100'),
('60064200', '-- Farbené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60064200'),
('60064300', '-- Z rôznofarebných priadzí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60064300'),
('60064400', '-- Potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60064400'),
('60069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_60069000'),
('6101', 'Pánske alebo chlapčenské zvrchníky, plášte, peleríny, kabáty, bundy (vrátane lyžiarskych), vetrovky a podobné výrobky, pletené alebo háčkované, iné ako výrobky položky 6103', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6101'),
('610120', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610120'),
('61012010', '-- Zvrchníky, plášte, peleríny , kabáty a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61012010'),
('61012090', '-- Bundy (vrátane lyžiarskych), vetrovky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61012090'),
('610130', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610130'),
('61013010', '-- Zvrchníky, plášte, peleríny, kabáty a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61013010'),
('61013090', '-- Bundy (vrátane lyžiarskych), vetrovky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61013090'),
('610190', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610190'),
('61019020', '-- Zvrchníky, plášte, peleríny, kabáty a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61019020'),
('61019080', '-- Bundy (vrátane lyžiarskych), vetrovky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61019080'),
('6102', 'Dámske alebo dievčenské zvrchníky, plášte, peleríny, kabáty, bundy (vrátane lyžiarskych), vetrovky a podobné výrobky, pletené alebo háčkované, iné ako výrobky položky 6104', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6102'),
('610210', '- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610210'),
('61021010', '-- Zvrchníky, plášte, peleríny, kabáty a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61021010'),
('61021090', '-- Bundy (vrátane lyžiarskych), vetrovky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61021090'),
('610220', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610220'),
('61022010', '-- Zvrchníky, plášte, peleríny, kabáty a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61022010'),
('61022090', '-- Bundy (vrátane lyžiarskych), vetrovky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61022090'),
('610230', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610230'),
('61023010', '-- Zvrchníky, plášte, peleríny, kabáty a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61023010'),
('61023090', '-- Bundy (vrátane lyžiarskych), vetrovky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61023090'),
('610290', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610290'),
('61029010', '-- Zvrchníky, plášte, peleríny, kabáty a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61029010'),
('61029090', '-- Bundy (vrátane lyžiarskych), vetrovky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61029090'),
('6103', 'Pánske alebo chlapčenské obleky, komplety, saká, blejzre, nohavice, nohavice s náprsenkou a plecnicami, lýtkové a krátke nohavice (iné ako plavky), pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6103'),
('610310', '- Obleky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610310'),
('61031010', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61031010'),
('61031090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61031090'),
('61031090:2X', '- Komplety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61031090:2X'),
('61032200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61032200'),
('61032300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61032300'),
('61032900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61032900'),
('61032900:2X', '- Saká a blejzre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61032900:2X'),
('61033100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61033100'),
('61033200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61033200'),
('61033300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61033300'),
('61033900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61033900'),
('61033900:2X', '- Nohavice, nohavice s náprsenkou a plecnicami, lýtkové a krátke nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61033900:2X'),
('61034100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61034100'),
('61034200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61034200'),
('61034300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61034300'),
('61034900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61034900'),
('6104', 'Dámske alebo dievčenské kostýmy, komplety, kabátiky, blejzre, šaty, sukne, nohavicové sukne, nohavice, nohavice s náprsenkou a plecnicami, lýtkové a krátke nohavice (iné ako plavky), pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6104'),
('6104:2X', '- Kostýmy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6104:2X'),
('61041300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61041300'),
('610419', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610419'),
('61041920', '--- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61041920'),
('61041990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61041990'),
('61041990:2X', '- Komplety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61041990:2X'),
('61042200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61042200'),
('61042300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61042300'),
('610429', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610429'),
('61042910', '--- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61042910'),
('61042990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61042990'),
('61042990:2X', '- Kabátiky a blejzre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61042990:2X'),
('61043100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61043100'),
('61043200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61043200'),
('61043300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61043300'),
('61043900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61043900'),
('61043900:2X', '- Šaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61043900:2X'),
('61044100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61044100'),
('61044200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61044200'),
('61044300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61044300'),
('61044400', '-- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61044400'),
('61044900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61044900'),
('61044900:2X', '- Sukne a nohavicové sukne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61044900:2X'),
('61045100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61045100'),
('61045200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61045200'),
('61045300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61045300'),
('61045900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61045900'),
('61045900:2X', '- Nohavice, nohavice s náprsenkou a plecnicami, lýtkové a krátke nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61045900:2X'),
('61046100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61046100'),
('61046200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61046200'),
('61046300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61046300'),
('61046900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61046900'),
('6105', 'Pánske alebo chlapčenské košele, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6105'),
('61051000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61051000'),
('610520', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610520'),
('61052010', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61052010'),
('61052090', '-- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61052090'),
('610590', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610590'),
('61059010', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61059010'),
('61059090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61059090'),
('6106', 'Dámske alebo dievčenské blúzky, košele a košeľové blúzky, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6106'),
('61061000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61061000'),
('61062000', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61062000'),
('610690', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610690'),
('61069010', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61069010'),
('61069030', '-- Z prírodného hodvábu alebo hodvábneho odpadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61069030'),
('61069050', '-- Z ľanu alebo ramie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61069050'),
('61069090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61069090'),
('6107', 'Pánske alebo chlapčenské spodky, slipy, nočné košele, pyžamy, kúpacie plášte, župany a podobné výrobky, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6107'),
('6107:2X', '- Spodky a slipy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6107:2X'),
('61071100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61071100'),
('61071200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61071200'),
('61071900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61071900'),
('61071900:2X', '- Nočné košele a pyžamy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61071900:2X'),
('61072100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61072100'),
('61072200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61072200'),
('61072900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61072900'),
('61072900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61072900:2X'),
('61079100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61079100'),
('61079900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61079900'),
('6108', 'Dámske alebo dievčenské kombiné, spodničky, nohavičky krátke a dlhé, nočné košele, pyžamy, negližé, kúpacie plášte, župany a podobné výrobky, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6108'),
('6108:2X', '- Kombiné a spodničky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6108:2X'),
('61081100', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61081100'),
('61081900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61081900'),
('61081900:2X', '- Krátke a dlhé nohavičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61081900:2X'),
('61082100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61082100'),
('61082200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61082200'),
('61082900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61082900'),
('61082900:2X', '- Nočné košele a pyžamy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61082900:2X'),
('61083100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61083100'),
('61083200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61083200'),
('61083900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61083900'),
('61083900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61083900:2X'),
('61089100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61089100'),
('61089200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61089200'),
('61089900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61089900'),
('6109', 'Vrchné tričká (T-shirts), tielka a ostatné tričká, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6109'),
('61091000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61091000'),
('610990', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_610990'),
('61099020', '-- Z vlny alebo jemných chlpov zvierat alebo chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61099020'),
('61099090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61099090'),
('6110', 'Pulóvre, svetre, vesty (tiež zapínacie) a podobné výrobky, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6110'),
('6110:2X', '- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6110:2X'),
('611011', '-- Z vlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611011'),
('61101110', '--- Svetre a pulóvre, obsahujúce najmenej 50 % hmotnosti vlny a s hmotnosťou každého kusa 600 g alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61101110'),
('61101110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61101110:2X'),
('61101130', '---- Pánske alebo chlapčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61101130'),
('61101190', '---- Dámske alebo dievčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61101190'),
('611012', '-- Z kašmírskej kozy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611012'),
('61101210', '--- Pánske alebo chlapčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61101210'),
('61101290', '--- Dámske alebo dievčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61101290'),
('611019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611019'),
('61101910', '--- Pánske alebo chlapčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61101910'),
('61101990', '--- Dámske alebo dievčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61101990'),
('611020', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611020'),
('61102010', '-- Ľahké jemne pletené rolákové svetre a pulóvre ("roláky")', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61102010'),
('61102010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61102010:2X'),
('61102091', '--- Pánske alebo chlapčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61102091'),
('61102099', '--- Dámske alebo dievčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61102099'),
('611030', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611030'),
('61103010', '-- Ľahké jemne pletené rolákové svetre a pulóvre ("roláky")', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61103010'),
('61103010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61103010:2X'),
('61103091', '--- Pánske alebo chlapčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61103091'),
('61103099', '--- Dámske alebo dievčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61103099'),
('611090', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611090'),
('61109010', '-- Z ľanu alebo ramie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61109010'),
('61109090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61109090'),
('6111', 'Dojčenské odevy a odevné doplnky, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6111'),
('611120', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611120'),
('61112010', '-- Prstové rukavice, palčiaky a rukavice bez prstov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61112010'),
('61112090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61112090'),
('611130', '- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611130'),
('61113010', '-- Prstové rukavice, palčiaky a rukavice bez prstov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61113010'),
('61113090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61113090'),
('611190', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611190'),
('611190:2X', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611190:2X'),
('61119011', '--- Prstové rukavice, palčiaky a rukavice bez prstov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61119011'),
('61119019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61119019'),
('61119090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61119090'),
('6112', 'Teplákové súpravy, lyžiarske odevy a plavky, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6112'),
('6112:2X', '- Teplákové súpravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6112:2X'),
('61121100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61121100'),
('61121200', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61121200'),
('61121900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61121900'),
('61122000', '- Lyžiarske odevy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61122000'),
('61122000:2X', '- Pánske alebo chlapčenské plavky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61122000:2X'),
('611231', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611231'),
('61123110', '--- Obsahujúce 5 % hmotnosti alebo viac kaučukovej nite', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61123110'),
('61123190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61123190'),
('611239', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611239'),
('61123910', '--- Obsahujúce 5 % hmotnosti alebo viac kaučukovej nite', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61123910'),
('61123990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61123990'),
('61123990:2X', '- Dámske alebo dievčenské plavky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61123990:2X'),
('611241', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611241'),
('61124110', '--- Obsahujúce 5 % hmotnosti alebo viac kaučukovej nite', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61124110'),
('61124190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61124190'),
('611249', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611249'),
('61124910', '--- Obsahujúce 5 % hmotnosti alebo viac kaučukovej nite', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61124910'),
('61124990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61124990'),
('611300', 'Odevy, celkom dohotovené z pletených alebo háčkovaných textílií položky 5903, 5906 alebo 5907', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611300'),
('61130010', '- Z pletených alebo háčkovaných textílií položky 5906', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61130010'),
('61130090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61130090'),
('6114', 'Ostatné odevy, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6114'),
('61142000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61142000'),
('61143000', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61143000'),
('61149000', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61149000'),
('6115', 'Pančuchové nohavice, pančuchy, podkolienky, ponožky a ostatný pančuchový tovar, vrátane pančuchového tovaru s odstupňovanou kompresiou (napríklad pančúch na kŕčové žily) a obuvi bez podrážok, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6115'),
('611510', '- Pančuchový tovar s odstupňovanou kompresiou (napríklad pančuchy na kŕčové žily)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611510'),
('61151010', '-- Pančuchy na kŕčové žily zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61151010'),
('61151090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61151090'),
('61151090:2X', '- Ostatné pančuchové nohavice a pančuchy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61151090:2X'),
('61152100', '-- Zo syntetických vlákien, s dĺžkovou hmotnosťou jednoduchej priadze menej ako 67 decitexov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61152100'),
('61152200', '-- Zo syntetických vlákien, s dĺžkovou hmotnosťou jednoduchej priadze 67 decitexov alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61152200'),
('61152900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_61152900'),
('611530', '- Ostatné dámske dlhé pančuchy alebo podkolienky, z vlákien s dĺžkovou hmotnosťou jednoduchej priadze menej ako 67 decitexov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611530'),
('611530:2X', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611530:2X'),
('61153011', '--- Podkolienky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61153011'),
('61153019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61153019'),
('61153090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61153090'),
('61153090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61153090:2X'),
('61159400', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61159400'),
('61159500', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61159500'),
('611596', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611596'),
('61159610', '--- Podkolienky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61159610'),
('61159610:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61159610:2X'),
('61159691', '---- Dámske pančuchy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61159691'),
('61159699', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61159699'),
('61159900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61159900'),
('6116', 'Prstové rukavice, palčiaky a rukavice bez prstov, pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6116'),
('611610', '- Impregnované, potiahnuté alebo pokryté plastmi alebo kaučukom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611610'),
('61161020', '-- Prstové rukavice, impregnované, potiahnuté alebo pokryté kaučukom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61161020'),
('61161080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61161080'),
('61161080:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61161080:2X'),
('61169100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61169100'),
('61169200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61169200'),
('61169300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61169300'),
('61169900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_61169900'),
('6117', 'Ostatné celkom dohotovené odevné doplnky, pletené alebo háčkované; pletené alebo háčkované časti odevov alebo odevných doplnkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6117'),
('61171000', '- Plédy, šatky, šály, mantily, závoje a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61171000'),
('611780', '- Ostatné doplnky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_611780'),
('61178010', '-- Pletené alebo háčkované, elastické alebo vrstvené kaučukom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61178010'),
('61178080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61178080'),
('61179000', '- Časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_61179000'),
('6201', 'Pánske alebo chlapčenské zvrchníky, plášte, peleríny, kabáty, bundy (vrátane lyžiarskych), vetrovky a podobné výrobky, iné ako výrobky položky 6203', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6201'),
('6201:2X', '- Zvrchníky, plášte do dažďa, kabáty, plášte, peleríny a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6201:2X'),
('62011100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62011100'),
('620112', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620112'),
('62011210', '--- S hmotnosťou nepresahujúcou 1 kg na odevný kus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62011210'),
('62011290', '--- S hmotnosťou presahujúcou 1 kg na odevný kus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62011290'),
('620113', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620113'),
('62011310', '--- S hmotnosťou nepresahujúcou 1 kg na odevný kus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62011310'),
('62011390', '--- S hmotnosťou presahujúcou 1 kg na odevný kus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62011390'),
('62011900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62011900'),
('62011900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62011900:2X'),
('62019100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62019100'),
('62019200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62019200'),
('62019300', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62019300'),
('62019900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62019900'),
('6202', 'Dámske alebo dievčenské zvrchníky, plášte, peleríny, kabáty, bundy (vrátane lyžiarskych), vetrovky a podobné výrobky, iné ako výrobky položky 6204', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6202'),
('6202:2X', '- Zvrchníky, plášte do dažďa, kabáty, plášte, peleríny a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6202:2X'),
('62021100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62021100'),
('620212', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620212'),
('62021210', '--- S hmotnosťou nepresahujúcou 1 kg na odevný kus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62021210'),
('62021290', '--- S hmotnosťou presahujúcou 1 kg na odevný kus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62021290'),
('620213', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620213'),
('62021310', '--- S hmotnosťou nepresahujúcou 1 kg na odevný kus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62021310'),
('62021390', '--- S hmotnosťou presahujúcou 1 kg na odevný kus', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62021390'),
('62021900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62021900'),
('62021900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62021900:2X'),
('62029100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62029100'),
('62029200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62029200'),
('62029300', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62029300'),
('62029900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62029900'),
('6203', 'Pánske alebo chlapčenské obleky, komplety, saká, blejzre, nohavice, nohavice s náprsenkou a plecnicami, lýtkové a krátke nohavice (iné ako plavky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6203'),
('6203:2X', '- Obleky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6203:2X'),
('62031100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62031100'),
('62031200', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62031200'),
('620319', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620319'),
('62031910', '--- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62031910'),
('62031930', '--- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62031930'),
('62031990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62031990'),
('62031990:2X', '- Komplety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62031990:2X'),
('620322', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620322'),
('62032210', '--- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62032210'),
('62032280', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62032280'),
('620323', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620323'),
('62032310', '--- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62032310'),
('62032380', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62032380'),
('620329', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620329'),
('620329:2X', '--- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620329:2X'),
('62032911', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62032911'),
('62032918', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62032918'),
('62032930', '--- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62032930'),
('62032990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62032990'),
('62032990:2X', '- Saká a blejzre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62032990:2X'),
('62033100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62033100'),
('620332', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620332'),
('62033210', '--- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62033210'),
('62033290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62033290'),
('620333', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620333'),
('62033310', '--- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62033310'),
('62033390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62033390'),
('620339', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620339'),
('620339:2X', '--- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620339:2X'),
('62033911', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62033911'),
('62033919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62033919'),
('62033990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62033990'),
('62033990:2X', '- Nohavice, nohavice s náprsenkou a plecnicami, lýtkové a krátke nohavice (iné ako plavky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62033990:2X'),
('620341', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620341'),
('62034110', '--- Nohavice a lýtkové nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034110'),
('62034130', '--- Nohavice s náprsenkou a plecnicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034130'),
('62034190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034190'),
('620342', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620342'),
('620342:2X', '--- Nohavice a lýtkové nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620342:2X'),
('62034211', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034211'),
('62034211:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62034211:2X'),
('62034231', '----- Z denimu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034231'),
('62034233', '----- Z rezaného menčestru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034233'),
('62034235', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034235'),
('62034235:2X', '--- Nohavice s náprsenkou a plecnicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62034235:2X'),
('62034251', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034251'),
('62034259', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034259'),
('62034290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034290'),
('620343', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620343'),
('620343:2X', '--- Nohavice a lýtkové nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620343:2X'),
('62034311', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034311'),
('62034319', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034319'),
('62034319:2X', '--- Nohavice s náprsenkou a plecnicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62034319:2X'),
('62034331', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034331'),
('62034339', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034339'),
('62034390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034390'),
('620349', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620349'),
('620349:2X', '--- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620349:2X'),
('620349:3X', '---- Nohavice a lýtkové nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620349:3X'),
('62034911', '----- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034911'),
('62034919', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034919'),
('62034919:2X', '---- Nohavice s náprsenkou a plecnicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62034919:2X'),
('62034931', '----- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034931'),
('62034939', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034939'),
('62034950', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034950'),
('62034990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62034990'),
('6204', 'Dámske alebo dievčenské kostýmy, komplety, kabátiky, blejzre, šaty, sukne, nohavicové sukne, nohavice, nohavice s náprsenkou a plecnicami, lýtkové a krátke nohavice (iné ako plavky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6204'),
('6204:2X', '- Kostýmy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6204:2X'),
('62041100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62041100'),
('62041200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62041200'),
('62041300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62041300'),
('620419', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620419'),
('62041910', '--- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62041910'),
('62041990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62041990'),
('62041990:2X', '- Komplety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62041990:2X'),
('62042100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62042100'),
('620422', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620422'),
('62042210', '--- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62042210'),
('62042280', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62042280'),
('620423', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620423'),
('62042310', '--- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62042310'),
('62042380', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62042380'),
('620429', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620429'),
('620429:2X', '--- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620429:2X'),
('62042911', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62042911'),
('62042918', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62042918'),
('62042990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62042990'),
('62042990:2X', '- Kabátiky a blejzre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62042990:2X'),
('62043100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62043100'),
('620432', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620432'),
('62043210', '--- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62043210'),
('62043290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62043290'),
('620433', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620433'),
('62043310', '--- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62043310'),
('62043390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62043390'),
('620439', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620439'),
('620439:2X', '--- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620439:2X'),
('62043911', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62043911'),
('62043919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62043919'),
('62043990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62043990'),
('62043990:2X', '- Šaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62043990:2X'),
('62044100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62044100'),
('62044200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62044200'),
('62044300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62044300'),
('62044400', '-- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62044400'),
('620449', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620449'),
('62044910', '--- Z prírodného hodvábu alebo hodvábneho odpadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62044910'),
('62044990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62044990'),
('62044990:2X', '- Sukne a nohavicové sukne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62044990:2X'),
('62045100', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62045100'),
('62045200', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62045200'),
('62045300', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62045300'),
('620459', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620459'),
('62045910', '--- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62045910'),
('62045990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62045990'),
('62045990:2X', '- Nohavice, nohavice s náprsenkou a plecnicami, lýtkové a krátke nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62045990:2X'),
('620461', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620461'),
('62046110', '--- Nohavice a lýtkové nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046110'),
('62046185', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046185'),
('620462', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620462'),
('620462:2X', '--- Nohavice a lýtkové nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620462:2X'),
('62046211', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046211'),
('62046211:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62046211:2X'),
('62046231', '----- Z denimu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046231'),
('62046233', '----- Z rezaného menčestru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046233'),
('62046239', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046239'),
('62046239:2X', '--- Nohavice s náprsenkou a plecnicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62046239:2X'),
('62046251', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046251'),
('62046259', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046259'),
('62046290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046290'),
('620463', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620463'),
('620463:2X', '--- Nohavice a lýtkové nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620463:2X'),
('62046311', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046311'),
('62046318', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046318'),
('62046318:2X', '--- Nohavice s náprsenkou a plecnicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62046318:2X'),
('62046331', '---- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046331'),
('62046339', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046339'),
('62046390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046390'),
('620469', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620469'),
('620469:2X', '--- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620469:2X'),
('620469:3X', '---- Nohavice a lýtkové nohavice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620469:3X'),
('62046911', '----- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046911'),
('62046918', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046918'),
('62046918:2X', '---- Nohavice s náprsenkou a plecnicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62046918:2X'),
('62046931', '----- Pracovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046931'),
('62046939', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046939'),
('62046950', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046950'),
('62046990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62046990'),
('6205', 'Pánske alebo chlapčenské košele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6205'),
('62052000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62052000'),
('62053000', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62053000'),
('620590', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620590'),
('62059010', '-- Z ľanu alebo ramie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62059010'),
('62059080', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62059080'),
('6206', 'Dámske alebo dievčenské blúzky, košele a košeľové blúzky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6206'),
('62061000', '- Z prírodného hodvábu alebo hodvábneho odpadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62061000'),
('62062000', '- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62062000'),
('62063000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62063000'),
('62064000', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62064000'),
('620690', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620690'),
('62069010', '-- Z ľanu alebo ramie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62069010'),
('62069090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62069090'),
('6207', 'Pánske alebo chlapčenské tielka a ostatné tričká, spodky, slipy, nočné košele, pyžamy, kúpacie plášte, župany a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6207'),
('6207:2X', '- Spodky a slipy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6207:2X'),
('62071100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62071100'),
('62071900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62071900'),
('62071900:2X', '- Nočné košele a pyžamy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62071900:2X'),
('62072100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62072100'),
('62072200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62072200'),
('62072900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62072900'),
('62072900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62072900:2X'),
('62079100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62079100'),
('620799', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620799'),
('62079910', '--- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62079910'),
('62079990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62079990'),
('6208', 'Dámske alebo dievčenské tielka a ostatné tričká, kombiné, spodničky, nohavičky krátke a dlhé, nočné košele, pyžamy, negližé, kúpacie plášte, župany a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6208'),
('6208:2X', '- Kombiné a spodničky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6208:2X'),
('62081100', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62081100'),
('62081900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62081900'),
('62081900:2X', '- Nočné košele a pyžamy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62081900:2X'),
('62082100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62082100'),
('62082200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62082200'),
('62082900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62082900'),
('62082900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62082900:2X'),
('62089100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62089100'),
('62089200', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62089200'),
('62089900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62089900'),
('6209', 'Dojčenské odevy a odevné doplnky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6209'),
('62092000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62092000'),
('62093000', '- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62093000'),
('620990', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_620990'),
('62099010', '-- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62099010'),
('62099090', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62099090'),
('6210', 'Odevy, celkom dohotovené z textílií položky 5602, 5603, 5903, 5906 alebo 5907', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6210'),
('621010', '- Z textílií položky 5602 alebo 5603', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_621010'),
('62101010', '-- Z textílií položky 5602', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62101010'),
('62101010:2X', '-- Z textílií položky 5603', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62101010:2X'),
('62101092', '--- Jednorazové plášte druhov, ktoré používajú pacienti alebo chirurgovia počas chirurgických zákrokov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62101092'),
('62101098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62101098'),
('62102000', '- Ostatné odevy, druhov uvedených v podpoložkách 6201 11 až 6201 19', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62102000'),
('62103000', '- Ostatné odevy, druhov uvedených v podpoložkách 6202 11 až 6202 19', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62103000'),
('62104000', '- Ostatné pánske alebo chlapčenské odevy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62104000'),
('62105000', '- Ostatné dámske alebo dievčenské odevy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62105000'),
('6211', 'Teplákové súpravy, lyžiarske odevy a plavky; ostatné odevy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6211'),
('6211:2X', '- Plavky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6211:2X'),
('62111100', '-- Pánske alebo chlapčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62111100'),
('62111200', '-- Dámske alebo dievčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62111200'),
('62112000', '- Lyžiarske odevy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62112000'),
('62112000:2X', '- Ostatné odevy, pánske alebo chlapčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62112000:2X'),
('621132', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_621132'),
('62113210', '--- Pracovné odevy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113210'),
('62113210:2X', '--- Teplákové súpravy s podšívkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113210:2X'),
('62113231', '---- Z rovnakej jedinej vonkajšej textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62113231'),
('62113231:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113231:2X'),
('62113241', '----- Horné časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62113241'),
('62113242', '----- Dolné časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62113242'),
('62113290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113290'),
('621133', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_621133'),
('62113310', '--- Pracovné odevy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113310'),
('62113310:2X', '--- Teplákové súpravy s podšívkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113310:2X'),
('62113331', '---- Z rovnakej jedinej vonkajšej textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62113331'),
('62113331:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113331:2X'),
('62113341', '----- Horné časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62113341'),
('62113342', '----- Dolné časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62113342'),
('62113390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113390'),
('62113900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113900'),
('62113900:2X', '- Ostatné odevy, dámske alebo dievčenské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62113900:2X'),
('621142', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_621142'),
('62114210', '--- Zástery, kombinézy, plášte so zapínaním vzadu a ostatné pracovné odevy (tiež vhodné na používanie v domácnosti)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62114210'),
('62114210:2X', '--- Teplákové súpravy s podšívkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62114210:2X'),
('62114231', '---- Z rovnakej jedinej vonkajšej textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62114231'),
('62114231:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62114231:2X'),
('62114241', '----- Horné časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62114241'),
('62114242', '----- Dolné časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62114242'),
('62114290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62114290'),
('621143', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_621143'),
('62114310', '--- Zástery, kombinézy, plášte so zapínaním vzadu a ostatné pracovné odevy (tiež vhodné na používanie v domácnosti)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62114310'),
('62114310:2X', '--- Teplákové súpravy s podšívkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62114310:2X'),
('62114331', '---- Z rovnakej jedinej vonkajšej textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62114331'),
('62114331:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62114331:2X'),
('62114341', '----- Horné časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62114341'),
('62114342', '----- Dolné časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62114342'),
('62114390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62114390'),
('62114900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62114900'),
('6212', 'Podprsenky, podväzkové pásy, korzety, plecnice, podväzky a podobné výrobky a ich časti, tiež pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6212'),
('621210', '- Podprsenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_621210'),
('62121010', '-- V súprave na predaj v malom obsahujúcej podprsenku a jedny nohavičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62121010'),
('62121090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62121090'),
('62122000', '- Podväzkové pásy a podväzkové nohavičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62122000'),
('62123000', '- Korzety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62123000'),
('62129000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62129000'),
('6213', 'Vreckovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6213'),
('62132000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62132000'),
('62139000', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62139000'),
('6214', 'Plédy, šatky, šály, mantily, závoje a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6214'),
('62141000', '- Z prírodného hodvábu alebo hodvábneho odpadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62141000'),
('62142000', '- Z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62142000'),
('62143000', '- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62143000'),
('62144000', '- Z umelých vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62144000'),
('62149000', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62149000'),
('6215', 'Viazanky, motýliky a kravaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6215'),
('62151000', '- Z prírodného hodvábu alebo hodvábneho odpadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62151000'),
('62152000', '- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62152000'),
('62159000', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_62159000'),
('62160000', 'Prstové rukavice, palčiaky a rukavice bez prstov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_62160000'),
('6217', 'Ostatné celkom dohotovené odevné doplnky; časti odevov alebo odevných doplnkov, iné ako výrobky položky 6212', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6217'),
('62171000', '- Doplnky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62171000'),
('62179000', '- Časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62179000'),
('62179000:2X', 'I. OSTATNÉ CELKOM DOHOTOVENÉ TEXTILNÉ VÝROBKY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_62179000:2X'),
('6301', 'Prikrývky a cestovné koberčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6301'),
('63011000', '- Elektricky vyhrievané prikrývky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63011000'),
('630120', '- Prikrývky (iné ako elektricky vyhrievané) a cestovné koberčeky, z vlny alebo jemných chlpov zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630120'),
('63012010', '-- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63012010'),
('63012090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63012090'),
('630130', '- Prikrývky (iné ako elektricky vyhrievané) a cestovné koberčeky, z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630130'),
('63013010', '-- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63013010'),
('63013090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63013090'),
('630140', '- Prikrývky (iné ako elektricky vyhrievané) a cestovné koberčeky, zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630140'),
('63014010', '-- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63014010'),
('63014090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63014090'),
('630190', '- Ostatné prikrývky a cestovné koberčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630190'),
('63019010', '-- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63019010'),
('63019090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63019090'),
('6302', 'Posteľná bielizeň, stolová bielizeň, toaletná bielizeň a kuchynská bielizeň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6302'),
('63021000', '- Posteľná bielizeň, pletená alebo háčkovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63021000'),
('63021000:2X', '- Ostatná posteľná bielizeň, potlačená', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63021000:2X'),
('63022100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63022100'),
('630222', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630222'),
('63022210', '--- Netkané textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63022210'),
('63022290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63022290'),
('630229', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630229'),
('63022910', '--- Z ľanu alebo ramie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63022910'),
('63022990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63022990'),
('63022990:2X', '- Ostatná posteľná bielizeň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63022990:2X'),
('63023100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63023100'),
('630232', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630232'),
('63023210', '--- Netkané textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63023210'),
('63023290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63023290'),
('630239', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630239'),
('63023920', '--- Z ľanu alebo ramie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63023920'),
('63023990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63023990'),
('63024000', '- Stolová bielizeň, pletená alebo háčkovaná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63024000'),
('63024000:2X', '- Ostatná stolová bielizeň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63024000:2X'),
('63025100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63025100'),
('630253', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630253'),
('63025310', '--- Netkané textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63025310'),
('63025390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63025390'),
('630259', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630259'),
('63025910', '--- Z ľanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63025910'),
('63025990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63025990'),
('63026000', '- Toaletná bielizeň a kuchynská bielizeň, zo slučkovej uterákoviny (froté) alebo podobných slučkových textílií, z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63026000'),
('63026000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63026000:2X'),
('63029100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63029100'),
('630293', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630293'),
('63029310', '--- Netkané textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63029310'),
('63029390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63029390'),
('630299', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630299'),
('63029910', '--- Z ľanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63029910'),
('63029990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63029990'),
('6303', 'Záclony, závesy (vrátane drapérií) a interiérové rolety a žalúzie; záclonové alebo posteľové drapérie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6303'),
('6303:2X', '- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6303:2X'),
('63031200', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_63031200'),
('63031900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_63031900'),
('63031900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63031900:2X'),
('63039100', '-- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_63039100'),
('630392', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630392'),
('63039210', '--- Netkané textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_63039210'),
('63039290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_63039290'),
('630399', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630399'),
('63039910', '--- Netkané textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_63039910'),
('63039990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_63039990'),
('6304', 'Ostatné interiérové textílie, okrem výrobkov položky 9404', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6304'),
('6304:2X', '- Posteľné prikrývky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6304:2X'),
('63041100', '-- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63041100'),
('630419', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630419'),
('63041910', '--- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63041910'),
('63041930', '--- Z ľanu alebo ramie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63041930'),
('63041990', '--- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63041990'),
('63041990:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63041990:2X'),
('63049100', '-- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63049100'),
('63049200', '-- Iné ako pletené alebo háčkované, z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63049200'),
('63049300', '-- Iné ako pletené alebo háčkované, zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63049300'),
('63049900', '-- Iné ako pletené alebo háčkované, z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63049900'),
('6305', 'Vrecia a vrecká, druhov používaných na balenie tovaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6305'),
('630510', '- Z juty alebo ostatných textilných lykových vlákien položky 5303', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630510'),
('63051010', '-- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63051010'),
('63051090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63051090'),
('63052000', '- Z bavlny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63052000'),
('63052000:2X', '- Z chemických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63052000:2X'),
('630532', '-- Pružné obaly na voľne ložený materiál', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630532'),
('630532:2X', '--- Z polyetylénových alebo polypropylénových pásikov alebo podobných tvarov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630532:2X'),
('63053211', '---- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63053211'),
('63053219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63053219'),
('63053290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63053290'),
('630533', '-- Ostatné, z polyetylénových alebo polypropylénových pásikov alebo podobných tvarov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630533'),
('63053310', '--- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63053310'),
('63053390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63053390'),
('63053900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63053900'),
('63059000', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63059000'),
('6306', 'Nepremokavé plachty, ochranné a tieniace plachty; stany; plachty na lode a člny, na dosky na plachtenie na vode alebo na súši; kempingový tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6306'),
('6306:2X', '- Nepremokavé plachty, ochranné a tieniace plachty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6306:2X'),
('63061200', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63061200'),
('63061900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63061900'),
('63061900:2X', '- Stany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63061900:2X'),
('63062200', '-- Zo syntetických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63062200'),
('63062900', '-- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63062900'),
('63063000', '- Plachty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63063000'),
('63064000', '- Nafukovacie matrace', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_63064000'),
('63069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63069000'),
('6307', 'Ostatné celkom dohotovené výrobky, vrátane strihových šablón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6307'),
('630710', '- Handry na umývanie dlážky, handry na umývanie riadu, prachovky a podobné handry na čistenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630710'),
('63071010', '-- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63071010'),
('63071030', '-- Netkané textílie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63071030'),
('63071090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63071090'),
('63072000', '- Záchranné vesty a záchranné pásy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63072000'),
('630790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_630790'),
('63079010', '-- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63079010'),
('63079010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63079010:2X'),
('63079091', '--- Z plsti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63079091'),
('63079091:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63079091:2X'),
('63079092', '---- Jednorazové krycie plachty vyrobené z textílií položky 5603, druhov používaných počas chirurgických zákrokoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63079092'),
('63079098', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63079098'),
('63079098:2X', 'II. SÚPRAVY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63079098:2X'),
('63080000', 'Súpravy pozostávajúce z tkaníny a priadze, tiež s doplnkami, na výrobu koberčekov, tapisérií, vyšívaných stolových obrusov alebo obrúskov, alebo podobných textilných výrobkov, v balení na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63080000'),
('63080000:2X', 'III. OBNOSENÉ ODEVY A OPOTREBOVANÉ TEXTILNÉ VÝROBKY; HANDRY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63080000:2X'),
('63090000', 'Obnosené odevy a ostatné opotrebované výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63090000'),
('6310', 'Použité alebo nové handry, odpady z motúzov, šnúr, povrazov a lán a opotrebované výrobky z motúzov, šnúr, povrazov alebo lán, z textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6310'),
('63101000', '- Triedené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63101000'),
('63109000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_63109000'),
('6401', 'Nepremokavá obuv s vonkajšou podrážkou a zvrškom z kaučuku alebo plastov, ktorej zvršok nie je k podrážke pripevnený ani s ňou spojený šitím, prinitovaním, pribitím klinčekmi, priskrutkovaním, pribitím kolíkmi alebo podobným spôsobom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6401'),
('64011000', '- Obuv so zabudovanou ochrannou kovovou špičkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64011000'),
('64011000:2X', '- Ostatná obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64011000:2X'),
('640192', '-- Zakrývajúca členok, ale nezekrývajúca koleno', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640192'),
('64019210', '--- So zvrškom z kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64019210'),
('64019290', '--- So zvrškom z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64019290'),
('64019900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64019900'),
('6402', 'Ostatná obuv s vonkajšou podrážkou a zvrškom z kaučuku alebo plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6402'),
('6402:2X', '- Športová obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6402:2X'),
('640212', '-- Lyžiarska obuv, lyžiarska bežecká obuv a obuv na snowboard', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640212'),
('64021210', '--- Lyžiarska obuv a lyžiarska bežecká obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64021210'),
('64021290', '--- Obuv na snowboard', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64021290'),
('64021900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64021900'),
('64022000', '- Obuv so zvrškom z remienkov alebo pásikov pripevnených k podrážke kolíkmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64022000'),
('64022000:2X', '- Ostatná obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64022000:2X'),
('640291', '-- Zakrývajúca členok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640291'),
('64029110', '--- So zabudovanou ochrannou kovovou špičkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029110'),
('64029190', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029190'),
('640299', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640299'),
('64029905', '--- So zabudovanou ochrannou kovovou špičkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029905'),
('64029905:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64029905:2X'),
('64029910', '---- So zvrškom z kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029910'),
('64029910:2X', '---- So zvrškom z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64029910:2X'),
('64029910:3X', '----- Obuv s priehlavkom vyrobeným z remienkov alebo s jedným alebo niekoľkými výrezmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64029910:3X'),
('64029931', '------ S podrážkou kombinovanou s podpätkom s výškou viac ako 3 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029931'),
('64029939', '------ Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029939'),
('64029950', '----- Šľapky a ostatná domáca obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029950'),
('64029950:2X', '----- Ostatná, so stielkou s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64029950:2X'),
('64029991', '------ Menej ako 24 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029991'),
('64029991:2X', '------ 24 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64029991:2X'),
('64029993', '------- Obuv, pri ktorej nie je možné určiť, či ide o pánsku alebo dámsku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029993'),
('64029993:2X', '------- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64029993:2X'),
('64029996', '-------- Pánska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029996'),
('64029998', '-------- Dámska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64029998'),
('6403', 'Obuv s vonkajšou podrážkou z kaučuku, plastov, usne alebo kompozitnej usne a so zvrškom z usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6403'),
('6403:2X', '- Športová obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6403:2X'),
('64031200', '-- Lyžiarska obuv, lyžiarska bežecká obuv a obuv na snowboard', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64031200'),
('64031900', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64031900'),
('64032000', '- Obuv s vonkajšou podrážkou z usne a zvrškom pozostávajúcim z remienkov z usne vedených cez priehlavok a okolo palca', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64032000'),
('64034000', '- Ostatná obuv, so zabudovanou ochrannou kovovou špičkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64034000'),
('64034000:2X', '- Ostatná obuv s vonkajšou podrážkou z usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64034000:2X'),
('640351', '-- Zakrývajúca členok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640351'),
('64035105', '--- Na drevenom základe alebo platforme, bez vnútornej podrážky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035105'),
('64035105:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035105:2X'),
('64035105:3X', '---- Zakrývajúca členok, ale žiadnu časť lýtka, so stielkou s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035105:3X'),
('64035111', '----- Menej ako 24 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035111'),
('64035111:2X', '----- 24 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035111:2X'),
('64035115', '------ Pánska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035115'),
('64035119', '------ Dámska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035119'),
('64035119:2X', '---- Ostatná, so stielkou s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035119:2X'),
('64035191', '----- Menej ako 24 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035191'),
('64035191:2X', '----- 24 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035191:2X'),
('64035195', '------ Pánska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035195'),
('64035199', '------ Dámska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035199'),
('640359', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640359'),
('64035905', '--- Na drevenom základe alebo platforme, bez vnútornej podrážky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035905'),
('64035905:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035905:2X'),
('64035905:3X', '---- Obuv s priehlavkom vyrobeným z remienkov alebo s jedným alebo niekoľkými výrezmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035905:3X'),
('64035911', '----- S podrážkou kombinovanou s podpätkom s výškou viac ako 3 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035911'),
('64035911:2X', '----- Ostatná, so stielkou s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035911:2X'),
('64035931', '------ Menej ako 24 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035931'),
('64035931:2X', '------ 24 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035931:2X'),
('64035935', '------- Pánska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035935'),
('64035939', '------- Dámska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035939'),
('64035950', '---- Šľapky a ostatná domáca obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035950'),
('64035950:2X', '---- Ostatná, so stielkou s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035950:2X'),
('64035991', '----- Menej ako 24 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035991'),
('64035991:2X', '----- 24 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035991:2X'),
('64035995', '------ Pánska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035995'),
('64035999', '------ Dámska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64035999'),
('64035999:2X', '- Ostatná obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64035999:2X'),
('640391', '-- Zakrývajúca členok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640391'),
('64039105', '--- Na drevenom základe alebo platforme, bez vnútornej podrážky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039105'),
('64039105:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039105:2X'),
('64039105:3X', '---- Zakrývajúca členok, ale žiadnu časť lýtka, so stielkou s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039105:3X'),
('64039111', '----- Menej ako 24 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039111'),
('64039111:2X', '----- 24 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039111:2X'),
('64039113', '------ Obuv, pri ktorej nie je možné určiť, či ide o pánsku alebo dámsku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039113'),
('64039113:2X', '------ Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039113:2X'),
('64039116', '------- Pánska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039116'),
('64039118', '------- Dámska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039118'),
('64039118:2X', '---- Ostatná, so stielkou s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039118:2X'),
('64039191', '----- Menej ako 24 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039191'),
('64039191:2X', '----- 24 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039191:2X'),
('64039193', '------ Obuv, pri ktorej nie je možné určiť, či ide o pánsku alebo dámsku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039193'),
('64039193:2X', '------ Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039193:2X'),
('64039196', '------- Pánska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039196'),
('64039198', '------- Dámska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039198'),
('640399', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640399'),
('64039905', '--- Na drevenom základe alebo platforme, bez vnútornej podrážky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039905'),
('64039905:2X', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039905:2X'),
('64039905:3X', '---- Obuv s priehlavkom vyrobeným z remienkov alebo s jedným alebo niekoľkými výrezmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039905:3X'),
('64039911', '----- S podrážkou kombinovanou s podpätkom s výškou viac ako 3 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039911'),
('64039911:2X', '----- Ostatná, so stielkou s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039911:2X'),
('64039931', '------ Menej ako 24 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039931'),
('64039931:2X', '------ 24 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039931:2X'),
('64039933', '------- Obuv, pri ktorej nie je možné určiť, či ide o pánsku alebo dámsku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039933'),
('64039933:2X', '------- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039933:2X'),
('64039936', '-------- Pánska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039936'),
('64039938', '-------- Dámska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039938'),
('64039950', '---- Šľapky a ostatná domáca obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039950'),
('64039950:2X', '---- Ostatná, so stielkou s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039950:2X'),
('64039991', '----- Menej ako 24 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039991'),
('64039991:2X', '----- 24 cm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039991:2X'),
('64039993', '------ Obuv, pri ktorej nie je možné určiť, či ide o pánsku alebo dámsku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039993'),
('64039993:2X', '------ Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64039993:2X'),
('64039996', '------- Pánska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039996'),
('64039998', '------- Dámska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64039998'),
('6404', 'Obuv s vonkajšou podrážkou z kaučuku, plastov, usne alebo kompozitnej usne a zvrškom z textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6404'),
('6404:2X', '- Obuv s vonkajšou podrážkou z kaučuku alebo plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6404:2X'),
('64041100', '-- Športová obuv; obuv na tenis, obuv na basketbal, obuv na gymnastiku, obuv na cvičenie a podobne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64041100'),
('640419', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640419'),
('64041910', '--- Šľapky a ostatná domáca obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64041910'),
('64041990', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64041990'),
('640420', '- Obuv s vonkajšou podrážkou z usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640420'),
('64042010', '-- Šľapky a ostatná domáca obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64042010'),
('64042090', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64042090'),
('6405', 'Ostatná obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6405'),
('64051000', '- So zvrškom z usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64051000'),
('640520', '- So zvrškom z textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640520'),
('64052010', '-- S vonkajšou podrážkou z dreva alebo korku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64052010'),
('64052010:2X', '-- S vonkajšou podrážkou z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64052010:2X'),
('64052091', '--- Šľapky a ostatná domáca obuv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64052091'),
('64052099', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64052099'),
('640590', '- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640590'),
('64059010', '-- S vonkajšou podrážkou z kaučuku, plastov, usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64059010'),
('64059090', '-- S vonkajšou podrážkou z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64059090'),
('6406', 'Časti obuvi (vrátane zvrškov, tiež spojených s podrážkami, inými ako vonkajšími podrážkami); vymeniteľné vložky do topánok, pružné podpätníky a podobné výrobky; gamaše, kožené ochranné návleky na nohy a podobné výrobky, a ich súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6406'),
('640610', '- Zvršky a ich časti, iné ako výstužky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640610'),
('64061010', '-- Z usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64061010'),
('64061090', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64061090'),
('640620', '- Vonkajšie podrážky a podpätky, z kaučuku alebo plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640620'),
('64062010', '-- Z kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64062010'),
('64062090', '-- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64062090'),
('640690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_640690'),
('64069030', '-- Zvršky spojené s vnútornou podrážkou alebo ostatnými časťami podrážky, ale bez vonkajšej podrážky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_64069030'),
('64069050', '-- Vymeniteľné vložky do topánok a ostatné vymeniteľné príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64069050'),
('64069060', '-- Vonkajšie podrážky z usne alebo kompozitnej usne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64069060'),
('64069090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_64069090'),
('65010000', 'Klobúkové šišiaky alebo formy, nesformované do tvaru hlavy, bez vytvoreného okraja; šišiakové ploché kotúče (plateaux) a tzv. manchons (valcovitého tvaru, tiež rozrezané na výšku), z plsti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65010000'),
('65020000', 'Klobúkové šišiaky alebo formy, splietané alebo zhotovené spojením pásov z akýchkoľvek materiálov, nesformované do tvaru hlavy, bez vytvoreného okraja, nepodšívané ani nezdobené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65020000'),
('65040000', 'Klobúky a ostatné pokrývky hlavy, splietané alebo zhotovené spojením pásov z akýchkoľvek materiálov, tiež podšívané alebo zdobené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65040000'),
('650500', 'Klobúky a ostatné pokrývky hlavy, pletené alebo háčkované, alebo celkom dohotovené z čipky, plsti alebo ostatnej textílie, v metráži (nie však v pásoch), tiež podšívané alebo zdobené; sieťky na vlasy z akéhokoľvek materiálu, tiež podšívané alebo zdobené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_650500'),
('65050010', '- Z plsti z chlpov alebo z plsti z vlny a chlpov, zhotovené z klobúkových šišiakov alebo šišiakových plochých kotúčov (plateaux) položky 6501', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65050010'),
('65050010:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_65050010:2X'),
('65050030', '-- Čapice so štítkom (šiltom)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65050030'),
('65050090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_65050090'),
('6506', 'Ostatné pokrývky hlavy, tiež podšívané alebo zdobené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6506'),
('650610', '- Ochranné pokrývky hlavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_650610'),
('65061010', '-- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65061010'),
('65061080', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65061080'),
('65061080:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_65061080:2X'),
('65069100', '-- Z kaučuku alebo plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65069100'),
('650699', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_650699'),
('65069910', '--- Z plsti z chlpov alebo z plsti z vlny a chlpov, zhotovené z klobúkových šišiakov alebo šišiakových plochých kotúčov (plateaux) položky 6501', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65069910'),
('65069990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_65069990'),
('65070000', 'Potné vložky, podšívky, povlaky, klobúkové podložky, klobúkové kostry, štitky (šilty) a podbradné remienky, na pokrývky hlavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_65070000'),
('6601', 'Dáždniky a slnečníky (vrátane vychádzkových palíc s dáždnikom, záhradných dáždnikov a slnečníkov a podobných výrobkov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6601'),
('66011000', '- Záhradné alebo podobné dáždniky a slnečníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_66011000'),
('66011000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_66011000:2X'),
('66019100', '-- So zásuvnou palicou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_66019100'),
('660199', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_660199'),
('66019920', '--- S poťahom z tkaných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_66019920'),
('66019990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_66019990'),
('66020000', 'Vychádzkové palice, palice so sedadielkom, biče, jazdecké bičíky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_66020000'),
('6603', 'Časti, ozdoby a príslušenstvo výrobkov položky 6601 alebo 6602', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6603'),
('66032000', '- Dáždnikové a slnečníkové kostry, vrátane kostier namontovaných na paliciach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_66032000'),
('660390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_660390'),
('66039010', '-- Rukoväte a gombíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_66039010'),
('66039090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_66039090'),
('67010000', 'Kože a ostatné časti vtákov s perím alebo páperím, perie, časti peria, páperie a výrobky z nich (iné ako tovar položky 0505 a opracované brká a kostrnky pier)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_67010000'),
('6702', 'Umelé kvetiny, lístie a ovocie a ich časti; výrobky zhotovené z umelých kvetín, lístia alebo ovocia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6702'),
('67021000', '- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_67021000'),
('67029000', '- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_67029000'),
('67030000', 'Ľudské vlasy, rovnobežne zrovnané, stenčené, odfarbené alebo inak spracované; vlna alebo ostatné chlpy zvierat alebo ostatné textilné materiály, upravené na výrobu parochní alebo podobných výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_67030000'),
('6704', 'Parochne, nepravé fúzy (brady), obočia a mihalnice, príčesky a podobné výrobky, z ľudských vlasov alebo chlpov zvierat alebo textilných materiálov; výrobky z ľudských vlasov inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6704'),
('6704:2X', '- Zo syntetických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6704:2X'),
('67041100', '-- Celé parochne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_67041100'),
('67041900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_67041900'),
('67042000', '- Z ľudských vlasov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_67042000'),
('67049000', '- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_67049000'),
('68010000', 'Dlažbové kocky, obrubníky a dlažbové dosky, z prírodného kameňa (okrem bridlice)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68010000'),
('6802', 'Opracované kamene na výtvarné alebo stavebné účely (okrem bridlice) a výrobky z nich, iné ako tovar položky 6801; kamienky na mozaiky a podobné účely, z prírodného kameňa (vrátane bridlice), tiež na podložkách; umelo farbené granuly, odštiepky a prach,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6802'),
('68021000', '- Dlaždice, kocky a podobné výrobky, tiež pravouhlého (vrátane štvorcového) tvaru, ktorých najväčšiu plochu možno zahrnúť do štvorca so stranou menej ako 7 cm; umelo farbené granuly, odštiepky a prach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68021000'),
('68021000:2X', '- Ostatné kamene na výtvarné alebo stavebné účely a výrobky z nich, jednoducho obrúsené alebo rozrezané, s plochým alebo rovným povrchom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68021000:2X'),
('68022100', '-- Mramor, travertín a alabaster', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68022100'),
('68022300', '-- Žula', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68022300'),
('68022900', '-- Ostatné kamene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68022900'),
('68022900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68022900:2X'),
('68029100', '-- Mramor, travertín, alabaster', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68029100'),
('68029200', '-- Ostatné vápenaté kamene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68029200'),
('680293', '-- Žula', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_680293'),
('68029310', '--- Leštená, zdobená alebo inak opracovaná, nie však vyrezávaná, s čistou hmotnosťou 10 kg alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68029310'),
('68029390', '--- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68029390'),
('680299', '-- Ostatné kamene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_680299'),
('68029910', '--- Leštené, zdobené alebo inak opracované, nie však vyrezávané, s čistou hmotnosťou 10 kg alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68029910'),
('68029990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68029990'),
('680300', 'Opracovaná bridlica a výrobky z bridlice alebo aglomerovanej bridlice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_680300'),
('68030010', '- Strešné a nástenné bridlice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68030010'),
('68030090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68030090'),
('6804', 'Mlynské kamene, brúsne kamene, brúsne kotúče a podobné výrobky, bez rámových konštrukcií, používané na mletie, brúsenie, ostrenie, leštenie, tvarové opracovanie alebo rezanie, kamene na ručné ostrenie alebo leštenie a ich časti, z prírodného kameňa, agl', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6804'),
('68041000', '- Mlynské kamene a brúsne kamene, používané na mletie, brúsenie alebo rozvlákňovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68041000'),
('68041000:2X', '- Ostatné mlynské kamene, brúsne kamene, brúsne kotúče a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68041000:2X'),
('68042100', '-- Z aglomerovaného syntetického alebo prírodného diamantu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68042100'),
('680422', '-- Z ostatných aglomerovaných brúsiv alebo keramiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_680422'),
('680422:2X', '--- Z umelých brúsiv, so spojivom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_680422:2X'),
('680422:3X', '---- Zo syntetickej alebo umelej živice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_680422:3X'),
('68042212', '----- Nevystužené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68042212'),
('68042218', '----- Vystužené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68042218'),
('68042230', '---- Z keramiky alebo silikátov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68042230'),
('68042250', '---- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68042250'),
('68042290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68042290'),
('68042300', '-- Z prírodného kameňa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68042300'),
('68043000', '- Kamene na ručné ostrenie alebo leštenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68043000'),
('6805', 'Prírodný alebo umelý brúsny prášok alebo brúsne zrno, na podložke z textilného materiálu, papiera, lepenky alebo ostatných materiálov, tiež rezané do tvaru alebo zošité alebo inak zhotovené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6805'),
('68051000', '- Len na podložke z textilnej tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68051000'),
('68052000', '- Len na podložke z papiera alebo lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68052000'),
('68053000', '- Na podložke z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68053000'),
('6806', 'Trosková vlna, horninová vlna a podobné nerastné vlny; expandovaný vermikulit, expandované íly, penová troska a podobné expandované nerastné materiály; zmesi a výrobky z nerastných materiálov používaných na tepelnú alebo zvukovú izoláciu alebo zvukovú a', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6806'),
('68061000', '- Trosková vlna, horninová vlna a podobné nerastné vlny (vrátane ich zmesí), voľne ložené, v tvare listov alebo kotúčov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68061000'),
('680620', '- Expandovaný vermikulit, expandované íly, penová troska a podobné expandované nerastné materiály (vrátane ich zmesí)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_680620'),
('68062010', '-- Expandované hliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68062010'),
('68062090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68062090'),
('68069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68069000'),
('6807', 'Výrobky z asfaltu alebo podobných materiálov (napríklad z petrolejového bitúmenu alebo zo smoly čiernouhoľného dechtu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6807'),
('68071000', '- V kotúčoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_68071000'),
('68079000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68079000'),
('68080000', 'Dosky, tabule, dlaždice, bloky a podobné výrobky z rastlinných vlákien, slamy, hoblín, drevených triesok, pilín alebo ostatných drevených odpadov, aglomerované cementom, sadrou alebo ostatnými minerálnymi spojivami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68080000'),
('6809', 'Výrobky zo sadry alebo zo zmesi na základe sadry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6809'),
('6809:2X', '- Dosky, tabule, panely, dlaždice a podobné výrobky, nezdobené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6809:2X'),
('68091100', '-- Potiahnuté alebo vystužené len papierom alebo lepenkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_68091100'),
('68091900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_68091900'),
('68099000', '- Ostatné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68099000'),
('6810', 'Výrobky z cementu, betónu alebo umelého kameňa, tiež vystužené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6810'),
('6810:2X', '- Krytinová škridla, obkladové dosky, dlaždice, tehly a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6810:2X'),
('681011', '-- Tvárnice a tehly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_681011'),
('68101110', '--- Z ľahkého betónu (so základom z rozdrvenej pemzy, granulovanej trosky atď.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68101110'),
('68101190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68101190'),
('68101900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68101900'),
('68101900:2X', '- Ostatné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68101900:2X'),
('68109100', '-- Montované konštrukčné dielce na stavby alebo pre stavebné inžinierstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68109100'),
('68109900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68109900'),
('6811', 'Výrobky z azbestocementu, celulózocementu alebo podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6811'),
('68114000', '- Obsahujúce azbest', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68114000'),
('68114000:2X', '- Neobsahujúce azbest', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68114000:2X'),
('68118100', '-- Vlnité dosky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68118100'),
('68118200', '-- Ostatné dosky, tabule, dlaždice a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68118200'),
('68118900', '-- Ostatné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68118900'),
('6812', 'Spracované azbestové vlákna; zmesi na základe azbestu alebo na základe azbestu a uhličitanu horečnatého; výrobky z týchto zmesí alebo azbestu (napríklad nite, tkaniny, odevy, pokrývky hlavy, obuv, tesniace vložky), tiež vystužené, iné ako tovar položky ', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6812'),
('681280', '- Z krokydolitu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_681280'),
('68128010', '-- Spracované vlákna; zmesi na základe azbestu alebo na základe azbestu a uhličitanu horečnatého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68128010'),
('68128090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68128090'),
('68128090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68128090:2X'),
('68129100', '-- Odevy, odevné doplnky, obuv a pokrývky hlavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68129100'),
('68129200', '-- Papier, lepenka a plsť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68129200'),
('68129300', '-- Lisovaný tesniaci materiál z azbestových vlákien, v listoch alebo kotúčoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68129300'),
('681299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_681299'),
('68129910', '--- Spracované azbestové vlákna; zmesi na základe azbestu alebo na základe azbestu a uhličitanu horečnatého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68129910'),
('68129990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68129990'),
('6813', 'Trecí materiál a výrobky z neho (napríklad dosky, kotúče, pásy, segmenty, disky, podložky, vložky), nenamontované, na brzdové obloženia, obloženia spojok alebo podobné použitie, vyrobené na základe azbestu, ostatných nerastnych látok alebo celulózy, tie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6813'),
('68132000', '- Obsahujúce azbest', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68132000'),
('68132000:2X', '- Neobsahujúce azbest', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68132000:2X'),
('68138100', '-- Brzdové obloženia a podložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68138100'),
('68138900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68138900'),
('6814', 'Spracovaná sľuda a výrobky zo sľudy, vrátane aglomerovanej alebo rekonštituovanej sľudy, tiež na podložke z papiera, lepenky alebo ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6814'),
('68141000', '- Dosky, tabule a pásy z aglomerovanej alebo rekonštituovanej sľudy, tiež na podložke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68141000'),
('68149000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68149000'),
('6815', 'Výrobky z kameňa alebo ostatných nerastnych látok (vrátane uhlíkových vlákien, výrobkov z uhlíkových vlákien a výrobkov z rašeliny), inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6815'),
('681510', '- Iné ako elektrické výrobky z grafitu alebo ostatného uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_681510'),
('68151010', '-- Uhlíkové vlákna a výrobky z uhlikových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68151010'),
('68151090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68151090'),
('68152000', '- Výrobky z rašeliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68152000'),
('68152000:2X', '- Ostatné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68152000:2X'),
('68159100', '-- Obsahujúce magnezit, dolomit alebo chromit', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68159100'),
('68159900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68159900'),
('68159900:2X', 'I. TOVAR Z KREMIČITÝCH INFUZÓRIOVÝCH HLINIEK ALEBO PODOBNÝCH KREMIČITÝCH HLINIEK, A ŽIARUVZDORNÝ TOVAR', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_68159900:2X'),
('69010000', 'Tehly, kvádre, dlaždice, obkladačky a ostatný keramický tovar z kremičitých infuzóriových hliniek (napríklad kremeliny, tripolitu alebo diatomitu) alebo podobných kremičitých hliniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69010000'),
('6902', 'Žiaruvzdorné tehly, kvádre, dlaždice, obkladačky a podobné žiaruvzdorné keramické stavebniny, iné ako výrobky z kremičitých infuzóriových hliniek alebo podobných kremičitých hliniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6902'),
('69021000', '- Obsahujúce viac ako 50 % hmotnosti prvkov Mg, Ca alebo Cr, vyjadrené ako MgO, CaO alebo Cr2O3, jednotlivo alebo spolu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69021000'),
('690220', '- Obsahujúce viac ako 50 % hmotnosti oxidu hlinitého (Al2O3), oxidu kremičitého (SiO2) alebo zmesi alebo zlúčeniny týchto produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_690220'),
('69022010', '-- Obsahujúce 93 % hmotnosti alebo viac oxidu kremičitého (SiO2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69022010'),
('69022010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69022010:2X'),
('69022091', '--- Obsahujúce viac ako 7 % hmotnosti, ale menej ako 45 % hmotnosti oxidu hlinitého (Al2O3)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69022091'),
('69022099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69022099'),
('69029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69029000'),
('6903', 'Ostatný žiaruvzdorný keramický tovar (napríklad retorty, taviace tégliky, mufle, dýzy, zátky, podpery, skúšobné tégliky, rúry, rúrky, puzdrá a tyče), iný ako tovar z kremičitých infuzóriových hliniek alebo podobných kremičitých hliniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6903'),
('69031000', '- Obsahujúci viac ako 50 % hmotnosti grafitu alebo ostatného uhlíka, alebo zmesi týchto produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69031000'),
('690320', '- Obsahujúci viac ako 50 % hmotnosti oxidu hlinitého (Al2O3) alebo zmesi alebo zlúčeniny oxidu hlinitého a oxidu kremičitého (SiO2)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_690320'),
('69032010', '-- Obsahujúci menej ako 45 % hmotnosti oxidu hlinitého (Al2O3)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69032010'),
('69032090', '-- Obsahujúci 45 % hmotnosti alebo viac oxidu hlinitého (Al2O3)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69032090'),
('690390', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_690390'),
('69039010', '-- Obsahujúci viac ako 25 % hmotnosti, ale najviac 50 % hmotnosti grafitu alebo ostatného uhlíka alebo zmesi týchto produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69039010'),
('69039090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69039090'),
('69039090:2X', 'II. OSTATNÉ KERAMICKÉ VÝROBKY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69039090:2X'),
('6904', 'Keramické tehly, podlahové tvárnice, nosné tvarovky alebo výplňové vložky a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6904'),
('69041000', '- Tehly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_69041000'),
('69049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69049000'),
('6905', 'Krytinové škridly, rúrkové komínové nadstavce, komínové výmurovky, architektonické ozdoby a ostatná stavebná keramika', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6905'),
('69051000', '- Krytinová škridla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_69051000'),
('69059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69059000'),
('69060000', 'Keramické rúry a rúrky, žliabky, odkvapové žľaby a potrubná armatúra', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69060000'),
('6907', 'Neglazúrované keramické dlaždice a dlažbové kocky, obkladové dosky alebo obkladačky; neglazúrovaná keramická mozaika a podobné výrobky, tiež na podložke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6907'),
('69071000', '- Obkladačky, dlaždice, kocky a podobné výrobky, tiež pravouhlé, ktorých najväčšiu plochu možno zahrnúť do štvorca so stranou menej ako 7 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69071000'),
('690790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_690790'),
('69079020', '-- Kameninový tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69079020'),
('69079080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69079080'),
('6908', 'Glazúrované keramické dlaždice a dlažbové kocky, obkladové dosky alebo obkladačky; glazúrovaná keramická mozaika a podobné výrobky, tiež na podložke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6908'),
('69081000', '- Obkladačky, dlaždice, kocky a podobné výrobky, tiež pravouhlé, ktorých najväčšiu plochu možno zahrnúť do štvorca so stranou menej ako 7 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69081000'),
('690890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_690890'),
('690890:2X', '-- Obyčajný hrnčiarsky tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_690890:2X'),
('69089011', '--- Dvojité obkladačky typu "Spaltplatten"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69089011'),
('69089020', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69089020'),
('69089020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69089020:2X'),
('69089031', '--- Dvojité obkladačky typu "Spaltplatten"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69089031'),
('69089031:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69089031:2X'),
('69089051', '---- S lícovou plochou najviac 90 cm2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69089051'),
('69089051:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69089051:2X'),
('69089091', '----- Kameninový tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69089091'),
('69089093', '----- Pórovina alebo jemný hrnčiarsky tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69089093'),
('69089099', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_69089099'),
('6909', 'Keramický tovar na laboratórne, chemické alebo ostatné technické účely; keramické žľaby, kade a podobné nádrže druhov používaných v poľnohospodárstve; keramické hrnce, džbány a podobné výrobky druhov používaných na prepravu alebo balenie tovaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6909'),
('6909:2X', '- Keramický tovar na laboratórne, chemické alebo technické účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6909:2X'),
('69091100', '-- Z porcelánu alebo jemného porcelánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69091100'),
('69091200', '-- Výrobky s tvrdosťou 9 alebo viac podľa Mohsovej stupnice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69091200'),
('69091900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69091900'),
('69099000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69099000'),
('6910', 'Keramické výlevky, umývadlá, bidety, podstavce pod umývadlá, kúpacie vane, záchodové misy, splachovacie nádrže, záchodové mušle a podobné sanitárne príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6910'),
('69101000', '- Z porcelánu alebo jemného porcelánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69101000'),
('69109000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69109000'),
('6911', 'Kuchynský a stolový riad, ostatné predmety do domácnosti a toaletné predmety, z porcelánu alebo jemného porcelánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6911'),
('69111000', '- Stolový a kuchynský riad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69111000'),
('69119000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69119000'),
('691200', 'Keramický kuchynský a stolový riad, ostatné predmety do domácnosti a toaletné predmety, iné ako z porcelánu alebo jemného porcelánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_691200'),
('69120010', '- Obyčajný hrnčiarsky tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69120010'),
('69120030', '- Kameninový tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69120030'),
('69120050', '- Pórovina alebo jemný hrnčiarsky tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69120050'),
('69120090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69120090'),
('6913', 'Sošky a ostatné ozdobné keramické predmety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6913'),
('69131000', '- Z porcelánu alebo jemného porcelánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69131000'),
('691390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_691390'),
('69139010', '-- Obyčajný hrnčiarsky tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69139010'),
('69139010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69139010:2X'),
('69139093', '--- Pórovina alebo jemný hrnčiarsky tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69139093'),
('69139098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69139098'),
('6914', 'Ostatné keramické predmety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_6914'),
('69141000', '- Z porcelánu alebo jemného porcelánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69141000'),
('69149000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_69149000'),
('700100', 'Sklené črepy a ostatný odpad a úlomky zo skla; masívne sklo v kusoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700100'),
('70010010', '- Sklené črepy a ostatný odpad a úlomky zo skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70010010'),
('70010010:2X', '- Masívne sklo v kusoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70010010:2X'),
('70010091', '-- Optické sklo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70010091'),
('70010099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70010099'),
('7002', 'Sklo v guľôčkach (okrem mikroguľôčok položky 7018), tyčiach alebo rúrach, nespracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7002'),
('70021000', '- Guľôčky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70021000'),
('700220', '- Tyče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700220'),
('70022010', '-- Z optického skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70022010'),
('70022090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70022090'),
('70022090:2X', '- Rúry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70022090:2X'),
('70023100', '-- Z taveného kremeňa alebo ostatného kremenného skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70023100'),
('70023200', '-- Z ostatného skla s lineárnym koeficientom teplotnej rozťažnosti nepresahujúcim 5 × 10-6 na Kelvin v rozmedzí teplôt od 0 °C do 300 °C', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70023200'),
('70023900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70023900'),
('7003', 'Liate sklo a valcované sklo, tabuľové alebo v profiloch, tiež s absorpčnou, reflexnou alebo nereflexnou vrstvou, inak však nespracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7003'),
('7003:2X', '- Tabuľové sklo bez drôtenej vložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7003:2X'),
('700312', '-- Farbené v hmote, zakalené, vrstvené alebo s absorpčnou, reflexnou alebo nereflexnou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700312'),
('70031210', '--- Z optického skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70031210'),
('70031210:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70031210:2X'),
('70031291', '---- S nereflexnou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70031291'),
('70031299', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70031299'),
('700319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700319'),
('70031910', '--- Z optického skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70031910'),
('70031990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70031990'),
('70032000', '- Tabuľové sklo s drôtenou vložkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70032000'),
('70033000', '- Profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70033000'),
('7004', 'Ťahané sklo a fúkané sklo, tabuľové, tiež s absorpčnou, reflexnou alebo nereflexnou vrstvou, inak však nespracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7004'),
('700420', '- Sklo, farbené v hmote, zakalené, vrstvené alebo s absorpčnou, reflexnou alebo nereflexnou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700420'),
('70042010', '-- Optické sklo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70042010'),
('70042010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70042010:2X'),
('70042091', '--- S nereflexnou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70042091'),
('70042099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70042099'),
('700490', '- Ostatné sklo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700490'),
('70049010', '-- Optické sklo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70049010'),
('70049080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70049080'),
('7005', 'Plavené sklo a sklo na povrchu brúsené alebo leštené, tabuľové, tiež s absorpčnou, reflexnou alebo nereflexnou vrstvou, inak však nespracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7005'),
('700510', '- Sklo bez drôtenej vložky, s absorpčnou, reflexnou alebo nereflexnou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700510'),
('70051005', '-- S nereflexnou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70051005'),
('70051005:2X', '-- Ostatné, s hrúbkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70051005:2X'),
('70051025', '--- Nepresahujúcou 3,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70051025'),
('70051030', '--- Presahujúcou 3,5 mm, ale nepresahujúcou 4,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70051030'),
('70051080', '--- Presahujúcou 4,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70051080'),
('70051080:2X', '- Ostatné sklo bez drôtenej vložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70051080:2X'),
('700521', '-- Farbené v hmote, zakalené, vrstvené alebo len na povrchu brúsené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700521'),
('70052125', '--- S hrúbkou nepresahujúcou 3,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70052125'),
('70052130', '--- S hrúbkou presahujúcou 3,5 mm, ale nepresahujúcou 4,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70052130'),
('70052180', '--- S hrúbkou presahujúcou 4,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70052180'),
('700529', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700529'),
('70052925', '--- S hrúbkou nepresahujúcou 3,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70052925'),
('70052935', '--- S hrúbkou presahujúcou 3,5 mm, ale nepresahujúcou 4,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70052935'),
('70052980', '--- S hrúbkou presahujúcou 4,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70052980'),
('70053000', '- Sklo s drôtenou vložkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70053000'),
('700600', 'Sklo položky 7003, 7004 alebo 7005, ohýbané, s opracovanými hranami, ryté, vŕtané, smaltované alebo inak opracované, ale nezarámované ani nevybavené ostatnými materiálmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700600'),
('70060010', '- Optické sklo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70060010'),
('70060090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70060090'),
('7007', 'Bezpečnostné sklo, pozostávajúce z tvrdeného alebo vrstveného skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7007'),
('7007:2X', '- Tvrdené bezpečnostné sklo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7007:2X'),
('700711', '-- V rozmeroch a tvaroch vhodných na zabudovanie do dopravných prostriedkov, lietadiel, kozmických lodí alebo plavidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700711'),
('70071110', '--- V rozmeroch a tvaroch vhodných na zabudovanie do motorových vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70071110'),
('70071190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70071190'),
('700719', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700719'),
('70071910', '--- Smaltované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70071910'),
('70071920', '--- Farbené v hmote, zakalené, vrstvené alebo s absorpčnou alebo reflexnou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70071920'),
('70071980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70071980'),
('70071980:2X', '- Vrstvené bezpečnostné sklo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70071980:2X'),
('700721', '-- V rozmeroch a tvaroch vhodných na zabudovanie do dopravných prostriedkov, lietadiel, kozmických lodí alebo plavidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700721'),
('70072120', '--- V rozmeroch a tvaroch vhodných na zabudovanie do motorových vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70072120'),
('70072180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70072180'),
('70072900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70072900'),
('700800', 'Izolačné jednotky z niekoľkých sklenených tabúľ', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_700800'),
('70080020', '- Farbené v hmote, zakalené, vrstvené alebo s absorpčnou alebo reflexnou vrstvou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70080020'),
('70080020:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70080020:2X'),
('70080081', '-- Pozostávajúce sa z dvoch sklenených tabúľ vzduchotesne utesnených okolo hrán a oddelených vrstvou vzduchu, ostatných plynov alebo vákua', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70080081'),
('70080089', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70080089'),
('7009', 'Sklenené zrkadlá, tiež zarámované, vrátane spätných zrkadielok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7009'),
('70091000', '- Spätné zrkadielka pre dopravné prostriedky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70091000'),
('70091000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70091000:2X'),
('70099100', '-- Nezarámované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70099100'),
('70099200', '-- Zarámované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70099200'),
('7010', 'Demižóny, fľaše, banky, poháre, tégliky, fioly, ampuly a ostatné nádoby, zo skla, druhov používaných na prepravu alebo balenie tovaru; sklenené poháre na zaváranie; zátky, viečka a ostatné uzávery, zo skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7010'),
('70101000', '- Ampuly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70101000'),
('70102000', '- Zátky, viečka a ostatné uzávery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70102000'),
('701090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701090'),
('70109010', '-- Poháre na zaváranie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109010'),
('70109010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109010:2X'),
('70109021', '--- Vyrobené z rúrkového skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109021'),
('70109021:2X', '--- Ostatné, s nominálnym objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109021:2X'),
('70109031', '---- 2,5 l alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109031'),
('70109031:2X', '---- Menej ako 2,5 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109031:2X'),
('70109031:3X', '----- Na nápoje a potraviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109031:3X'),
('70109031:4X', '------ Fľaše', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109031:4X'),
('70109031:5X', '------- Z bezfarebného skla, s nominálnym objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109031:5X'),
('70109041', '-------- 1 l alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109041'),
('70109043', '-------- Viac ako 0,33 l, ale menej ako 1 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109043'),
('70109045', '-------- 0,15 l alebo viac, ale najviac 0,33 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109045'),
('70109047', '-------- Menej ako 0,15 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109047'),
('70109047:2X', '------- Z farebného skla, s nominálnym objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109047:2X'),
('70109051', '-------- 1 l alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109051'),
('70109053', '-------- Viac ako 0,33 l, ale menej ako 1 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109053'),
('70109055', '-------- 0,15 l alebo viac, ale najviac 0,33 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109055'),
('70109057', '-------- Menej ako 0,15 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109057'),
('70109057:2X', '------ Ostatné, s nominálnym objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109057:2X'),
('70109061', '------- 0,25 l alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109061'),
('70109067', '------- Menej ako 0,25 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109067'),
('70109067:2X', '----- Na farmaceutické výrobky, s nominálnym objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109067:2X'),
('70109071', '------ Presahujúcim 0,055 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109071'),
('70109079', '------ Nepresahujúcim 0,055 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109079'),
('70109079:2X', '----- Na ostatné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70109079:2X'),
('70109091', '------ Z bezfarebného skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109091'),
('70109099', '------ Z farebného skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70109099'),
('7011', 'Sklenené plášte (vrátane baniek a trubíc), otvorené, a ich sklenené časti, bez vybavenia, na žiarovky, obrazovky alebo podobne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7011'),
('70111000', '- Na elektrické osvetlenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70111000'),
('70112000', '- Na obrazovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70112000'),
('70119000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70119000'),
('7013', 'Sklenený tovar druhov používaných ako stolové sklo, kuchynské sklo, toaletné sklo, kancelárske sklo, sklo na výzdobu miestností alebo na podobné účely (iné ako sklo položky 7010 alebo 7018)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7013'),
('70131000', '- Zo sklokeramiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70131000'),
('70131000:2X', '- Kalíškové nápojové sklo (na nožičke), iné ako zo sklokeramiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70131000:2X'),
('701322', '-- Z olovnatého krištáľu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701322'),
('70132210', '--- Ručne naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70132210'),
('70132290', '--- Mechanicky naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70132290'),
('701328', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701328'),
('70132810', '--- Ručne naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70132810'),
('70132890', '--- Mechanicky naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70132890'),
('70132890:2X', '- Ostatné nápojové sklo, iné ako zo sklokeramiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70132890:2X'),
('701333', '-- Z olovnatého krištáľu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701333'),
('701333:2X', '--- Ručne naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701333:2X'),
('70133311', '---- Brúsené alebo inak zdobené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70133311'),
('70133319', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70133319'),
('70133319:2X', '--- Mechanicky naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70133319:2X'),
('70133391', '---- Brúsené alebo inak zdobené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70133391'),
('70133399', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70133399'),
('701337', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701337'),
('70133710', '--- Tvrdené sklo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70133710'),
('70133710:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70133710:2X'),
('70133710:3X', '---- Ručne naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70133710:3X'),
('70133751', '----- Brúsené alebo inak zdobené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70133751'),
('70133759', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70133759'),
('70133759:2X', '---- Mechanicky naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70133759:2X'),
('70133791', '----- Brúsené alebo inak zdobené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70133791'),
('70133799', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70133799'),
('70133799:2X', '- Sklenený tovar druhov používaných ako stolové sklo (iné ako nápojové sklo) alebo ako kuchynské sklo, iné ako zo sklokeramiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70133799:2X'),
('701341', '-- Z olovnatého krištáľu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701341'),
('70134110', '--- Ručne naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70134110'),
('70134190', '--- Mechanicky naberané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70134190'),
('70134200', '-- Zo skla s lineárnym koeficientom teplotnej rozťažnosti nepresahujúcim 5 × 10-6 na Kelvin v rozmedzí teplôt od 0 °C do 300 °C', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70134200'),
('701349', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701349'),
('70134910', '--- Z tvrdeného skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70134910'),
('70134910:2X', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70134910:2X'),
('70134991', '---- Ručne naberaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70134991'),
('70134999', '---- Mechanicky naberaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70134999'),
('70134999:2X', '- Ostatný sklenený tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70134999:2X'),
('701391', '-- Z olovnatého krištáľu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701391'),
('70139110', '--- Ručne naberaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70139110'),
('70139190', '--- Mechanicky naberaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70139190'),
('70139900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_70139900'),
('70140000', 'Signálne sklo a optické prvky zo skla (iné ako výrobky položky 7015), opticky neopracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70140000'),
('7015', 'Hodinové alebo hodinkové sklá a podobné sklá, sklá do korekčných alebo nekorekčných okuliarov, vypuklé, ohýbané, duté alebo podobné, opticky neopracované; duté sklenené gule a ich segmenty, na výrobu takýchto skiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7015'),
('70151000', '- Sklá do korekčných okuliarov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70151000'),
('70159000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70159000'),
('7016', 'Dlažbové kocky, dosky, tehly, dlaždice, obkladačky a ostatné výrobky z lisovaného alebo tvarovaného skla, tiež s drôtenou vložkou, druhov používaných na stavebné alebo konštrukčné účely; sklenené kocky a ostatný drobný sklenený tovar, tiež na podložke,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7016'),
('70161000', '- Sklenené kocky a ostatný drobný sklený tovar, tiež na podložke, na mozaiky alebo podobné dekoratívne účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70161000'),
('701690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701690'),
('70169010', '-- Okenné tabuľky vsadené do olova a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTK'), 'SK_70169010'),
('70169040', '-- Kocky a tehly, druhov používaných na stavebné alebo konštrukčné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70169040'),
('70169070', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70169070'),
('7017', 'Laboratórny, hygienický alebo farmaceutický sklenený tovar, tiež so stupnicami alebo kalibrovaný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7017'),
('70171000', '- Z taveného kremeňa alebo ostatného kremenného skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70171000'),
('70172000', '- Z ostatného skla s lineárnym koeficientom teplotnej rozťažnosti nepresahujúcim 5 × 10-6 na Kelvin v rozmedzí teplôt od 0 °C do 300 °C', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70172000'),
('70179000', '- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70179000'),
('7018', 'Sklenené perly, imitácie perál, imitácie drahokamov alebo polodrahokamov a podobný drobný sklenený tovar, a výrobky z nich iné ako bižutéria; sklenené oči iné ako protetické výrobky; sošky a ostatné ozdobné predmety zo skla tvarovaného na kahane, iné ak', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7018'),
('701810', '- Sklenené perly, imitácie perál, imitácie drahokamov alebo polodrahokamov a podobný drobný sklenený tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701810'),
('701810:2X', '-- Sklenené perly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701810:2X'),
('70181011', '--- Brúsené a mechanicky leštené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70181011'),
('70181019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70181019'),
('70181030', '-- Imitácie perál', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70181030'),
('70181030:2X', '-- Imitácie drahokamov alebo polodrahokamov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70181030:2X'),
('70181051', '--- Brúsené a mechanicky leštené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70181051'),
('70181059', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70181059'),
('70181090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70181090'),
('70182000', '- Sklenené mikroguľôčky s priemerom nepresahujúcim 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70182000'),
('701890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701890'),
('70189010', '-- Sklenené oči; výrobky z drobného skleneného tovaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70189010'),
('70189090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70189090'),
('7019', 'Sklenené vlákna (vrátane sklenenej vlny) a výrobky z nich (napríklad priadza, tkaniny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7019'),
('7019:2X', '- Predpriadza, pramene, priadza a striž', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7019:2X'),
('70191100', '-- Striž, s dĺžkou najviac 50 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70191100'),
('70191200', '-- Pramene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70191200'),
('701919', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701919'),
('70191910', '--- Z nekonečných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70191910'),
('70191990', '--- Zo strižných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70191990'),
('70191990:2X', '- Tenké platne (voály), rúno, rohože, matrace, dosky a podobné netkané výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70191990:2X'),
('701931', '-- Rohože', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701931'),
('70193110', '--- Z nekonečných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70193110'),
('70193190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70193190'),
('701932', '-- Tenké platne (voály)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_701932'),
('70193210', '--- Z nekonečných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70193210'),
('70193290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70193290'),
('70193900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70193900'),
('70194000', '- Tkaniny z prameňov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70194000'),
('70194000:2X', '- Ostatné tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70194000:2X'),
('70195100', '-- So šírkou nepresahujúcou 30 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70195100'),
('70195200', '-- So šírkou presahujúcou 30 cm, v plátnovej väzbe, s plošnou hmotnosťou menej ako 250 g/m2, z nekonečných vlákien s dĺžkovou hmotnosťou jednoduchej priadze najviac 136 texov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70195200'),
('70195900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70195900'),
('70199000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70199000'),
('702000', 'Ostatné predmety zo skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_702000'),
('70200005', '- Kremenné reaktorové rúrky a držiaky konštruované na vloženie do difúznych a oxidačných pecí na výrobu polovodičových materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70200005'),
('70200005:2X', '- Sklenené vnútra do termosiek alebo ostatných druhov izolačných nádob', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70200005:2X'),
('70200007', '-- Nedokončené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70200007'),
('70200008', '-- Dokončené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70200008'),
('70200008:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70200008:2X'),
('70200010', '-- Z taveného kremeňa alebo ostatného kremenného skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70200010'),
('70200030', '-- Zo skla s lineárnym koeficientom teplotnej rozťažnosti nepresahujúcim 5 × 10-6 na Kelvin v rozmedzí teplôt od 0 °C do 300 °C', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70200030'),
('70200080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70200080'),
('70200080:2X', 'I. PRÍRODNÉ ALEBO UMELO PESTOVANÉ PERLY A DRAHOKAMY ALEBO POLODRAHOKAMY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_70200080:2X'),
('7101', 'Perly, prírodné alebo umelo pestované, tiež opracované alebo triedené, ale nenavlečené, nemontované ani nezasadené; perly, prírodné alebo umelo pestované, dočasne navlečené na niť na uľahčenie prepravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7101'),
('71011000', '- Prírodné perly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71011000'),
('71011000:2X', '- Umelo pestované perly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71011000:2X'),
('71012100', '-- Neopracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71012100'),
('71012200', '-- Opracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71012200'),
('7102', 'Diamanty, tiež opracované, ale nemontované ani nezasadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7102'),
('71021000', '- Netriedené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CTM'), 'SK_71021000'),
('71021000:2X', '- Priemyselné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71021000:2X'),
('71022100', '-- Neopracované alebo jednoducho rezané, štiepané alebo nahrubo brúsené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CTM'), 'SK_71022100'),
('71022900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CTM'), 'SK_71022900'),
('71022900:2X', '- Iné ako priemyselné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71022900:2X'),
('71023100', '-- Neopracované alebo jednoducho rezané, štiepané alebo nahrubo brúsené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CTM'), 'SK_71023100'),
('71023900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CTM'), 'SK_71023900'),
('7103', 'Drahokamy (iné ako diamanty) a polodrahokamy, tiež opracované alebo triedené, ale nenavlečené, nemontované ani nezasadené; netriedené drahokamy (iné ako diamanty) a polodrahokamy, dočasne navlečené na niť na uľahčenie prepravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7103'),
('71031000', '- Neopracované alebo jednoducho rezané alebo hrubo tvarované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71031000'),
('71031000:2X', '- Inak opracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71031000:2X'),
('71039100', '-- Rubíny, zafíry a smaragdy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71039100'),
('71039900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71039900'),
('7104', 'Umelé alebo rekonštituované drahokamy alebo polodrahokamy, tiež opracované alebo triedené, ale nenavlečené, nemontované ani nezasadené; netriedené umelé alebo rekonštituované drahokamy alebo polodrahokamy, dočasne navlečené na niť na uľahčenie prepravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7104'),
('71041000', '- Piezoelektrický kremeň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71041000'),
('71042000', '- Ostatné, neopracované alebo jednoducho rezané alebo hrubo tvarované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71042000'),
('71049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71049000'),
('7105', 'Drvina a prach z prírodných alebo umelých drahokamov alebo polodrahokamov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7105'),
('71051000', '- Z diamantov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71051000'),
('71059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71059000'),
('71059000:2X', 'II. DRAHÉ KOVY A KOVY PLÁTOVANÉ DRAHÝMI KOVMI', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71059000:2X'),
('7106', 'Striebro (vrátane striebra plátovaného zlatom alebo platinou), netepané alebo vo forme polotovaru, alebo vo forme prachu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7106'),
('71061000', '- Prach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71061000'),
('71061000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71061000:2X'),
('71069100', '-- Netepané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71069100'),
('71069200', '-- Polotovary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71069200'),
('71070000', 'Základné kovy plátované striebrom, ale nespracované viac ako na polotovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71070000'),
('7108', 'Zlato (vrátane zlata plátovaného platinou), netepané alebo vo forme polotovarov, alebo vo forme prachu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7108'),
('7108:2X', '- Iné ako na monetárne účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7108:2X'),
('71081100', '-- Prach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71081100'),
('71081200', '-- Ostatné netepané formy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71081200'),
('710813', '-- Ostatné polotovary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_710813'),
('71081310', '--- Tyče, prúty, drôty a profily; dosky; plechy a pásy s hrúbkou presahujúcou 0,15 mm bez podložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71081310'),
('71081380', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71081380'),
('71082000', '- Na monetárne účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71082000'),
('71090000', 'Základné kovy alebo striebro, plátované zlatom, ale nespracované viac ako na polotovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71090000'),
('7110', 'Platina, netepaná alebo vo forme polotovarov, alebo vo forme prachu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7110'),
('7110:2X', '- Platina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7110:2X'),
('71101100', '-- Netepaná alebo vo forme prachu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71101100'),
('711019', '-- Ostatná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_711019'),
('71101910', '--- Tyče, prúty, drôty a profily; dosky; plechy a pásy s hrúbkou presahujúcou 0,15 mm bez podložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71101910'),
('71101980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71101980'),
('71101980:2X', '- Paládium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71101980:2X'),
('71102100', '-- Netepané alebo vo forme prachu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71102100'),
('71102900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71102900'),
('71102900:2X', '- Ródium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71102900:2X'),
('71103100', '-- Netepané alebo vo forme prachu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71103100'),
('71103900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71103900'),
('71103900:2X', '- Irídium, osmium a ruténium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71103900:2X'),
('71104100', '-- Netepané alebo vo forme prachu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71104100'),
('71104900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71104900'),
('71110000', 'Základné kovy, striebro alebo zlato, plátované platinou, ale nespracované viac ako na polotovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71110000'),
('7112', 'Odpad a zvyšky drahých kovov alebo kovov plátovaných drahými kovmi; ostatný odpad a zvyšky obsahujúce drahé kovy alebo zlúčeniny drahých kovov, druhov používaných hlavne na rekuperáciu drahých kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7112'),
('71123000', '- Popol obsahujúci drahé kovy alebo zlúčeniny drahých kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71123000'),
('71123000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71123000:2X'),
('71129100', '-- Zo zlata, vrátane kovov plátovaných zlatom, avšak okrem odpadov obsahujúcich ostatné drahé kovy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71129100'),
('71129200', '-- Z platiny, vrátane kovov plátovaných platinou, avšak okrem odpadov obsahujúcich ostatné drahé kovy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71129200'),
('71129900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71129900'),
('71129900:2X', 'III. ŠPERKY, ZLATNÍCKY A STRIEBORNÍCKY TOVAR A OSTATNÉ PREDMETY', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71129900:2X'),
('7113', 'Klenotnícke predmety a ich časti, z drahých kovov alebo kovov plátovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7113'),
('7113:2X', '- Z drahých kovov, tiež plátovaných alebo pokovovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7113:2X'),
('71131100', '-- Zo striebra, tiež plátovaného alebo pokovovaného ostatnými drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71131100'),
('71131900', '-- Z ostatných drahých kovov, tiež plátovaných alebo pokovovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71131900'),
('71132000', '- Zo základných kovov plátovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71132000'),
('7114', 'Zlatnícky a striebornícky tovar a ich časti, z drahých kovov alebo kovov plátovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7114'),
('7114:2X', '- Z drahých kovov, tiež plátovaných alebo pokovovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7114:2X'),
('71141100', '-- Zo striebra, tiež plátovaného alebo pokovovaného ostatnými drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71141100'),
('71141900', '-- Z ostatných drahých kovov, tiež plátovaných alebo pokovovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71141900'),
('71142000', '- Zo základných kovov plátovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71142000'),
('7115', 'Ostatné predmety z drahých kovov alebo kovov plátovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7115'),
('71151000', '- Katalyzátory vo forme drôteného sita alebo mriežky, z platiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71151000'),
('71159000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71159000'),
('7116', 'Predmety z prírodných alebo umelo pestovaných perál, drahokamov alebo polodrahokamov (prírodných, umelých alebo rekonštituovaných)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7116'),
('71161000', '- Z prírodných alebo umelo pestovaných perál', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71161000'),
('711620', '- Z drahokamov alebo polodrahokamov (prírodných, umelých alebo rekonštituovaných)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_711620'),
('71162011', '-- Náhrdelníky, náramky a ostatné predmety úplne vyrobené z prírodných drahokamov alebo polodrahokamov, jednoducho navlečené, bez uzáveru alebo podobného príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71162011'),
('71162080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71162080'),
('7117', 'Bižutéria', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7117'),
('7117:2X', '- Zo základných kovov, tiež plátovaných drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7117:2X'),
('71171100', '-- Manžetové gombíky a ozdobné gombíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71171100'),
('71171900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71171900'),
('71179000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71179000'),
('7118', 'Mince', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7118'),
('71181000', '- Mince (iné ako zlaté mince), ktoré nie sú zákonnými platidlom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71181000'),
('71189000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GRM'), 'SK_71189000'),
('71189000:2X', 'I. ZÁKLADNÉ MATERIÁLY; VÝROBKY VO FORME GRANÚL ALEBO PRÁŠKU', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_71189000:2X'),
('7201', 'Surové železo a vysokopecná zrkadlovina v bochníkoch, v blokoch alebo ostatných základných tvaroch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7201'),
('720110', '- Nelegované surové železo obsahujúce v hmotnosti 0,5 % alebo menej fosforu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720110'),
('720110:2X', '-- Obsahujúce v hmotnosti nie menej ako 0,4 % mangánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720110:2X'),
('72011011', '--- Obsahujúce v hmotnosti 1 % alebo menej kremíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72011011'),
('72011019', '--- Obsahujúce v hmotnosti viac ako 1 % kremíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72011019'),
('72011030', '-- Obsahujúce v hmotnosti nie menej ako 0,1 %, ale menej ako 0,4 % mangánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72011030'),
('72011090', '-- Obsahujúce v hmotnosti menej ako 0,1 % mangánu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72011090'),
('72012000', '- Nelegované surové železo obsahujúce v hmotnosti viac ako 0,5 % fosforu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72012000'),
('720150', '- Legované surové železo; vysokopecná zrkadlovina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720150'),
('72015010', '-- Legované surové železo obsahujúce v hmotnosti nie menej ako 0,3 %, ale nie viac ako 1 % titanu, a nie menej ako 0,5 %, ale nie viac ako 1 % vanádu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72015010'),
('72015090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72015090'),
('7202', 'Ferozliatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7202'),
('7202:2X', '- Feromangán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7202:2X'),
('720211', '-- Obsahujúci v hmotnosti viac ako 2 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720211'),
('72021120', '--- Granulometricky nepresahujúci 5 mm a s obsahom mangánu v hmotnosti presahujúcim 65 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72021120'),
('72021180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72021180'),
('72021900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72021900'),
('72021900:2X', '- Ferosilícium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72021900:2X'),
('72022100', '-- Obsahujúci v hmotnosti viac ako 55 % kremíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72022100'),
('720229', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720229'),
('72022910', '--- Obsahujúce v hmotnosti viac ako 4 %, ale nie viac ako 10 % horčíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72022910'),
('72022990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72022990'),
('72023000', '- Ferosilikomangán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72023000'),
('72023000:2X', '- Ferochróm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72023000:2X'),
('720241', '-- Obsahujúci v hmotnosti viac ako 4 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720241'),
('72024110', '--- Obsahujúci v hmotnosti viac ako 4 %, ale nie viac ako 6 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72024110'),
('72024190', '--- Obsahujúci v hmotnosti viac ako 6 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72024190'),
('720249', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720249'),
('72024910', '--- Obsahujúci v hmotnosti nie viac ako 0,05 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72024910'),
('72024950', '--- Obsahujúci v hmotnosti viac ako 0,05 %, ale nie viac ako 0,5 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72024950'),
('72024990', '--- Obsahujúci v hmotnosti viac ako 0,5 %, ale nie viac ako 4 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72024990'),
('72025000', '- Ferosilikochróm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72025000'),
('72026000', '- Feronikel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72026000'),
('72027000', '- Feromolybdén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72027000'),
('72028000', '- Ferovolfrám a ferosilikovolfrám', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72028000'),
('72028000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72028000:2X'),
('72029100', '-- Ferotitán a ferosilikotitán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72029100'),
('72029200', '-- Ferovanád', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72029200'),
('72029300', '-- Feroniób', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72029300'),
('720299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720299'),
('72029910', '--- Ferofosfor', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72029910'),
('72029930', '--- Ferosilikomagnézium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72029930'),
('72029980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72029980'),
('7203', 'Výrobky zo železa získané priamou redukciou železnej rudy a ostatné hubovité železo, v kusoch, v peletách alebo podobných tvaroch; železo, ktorého rýdzosť je najmenej 99,94 % hmotnosti v kusoch, peletách alebo podobných tvaroch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7203'),
('72031000', '- Výrobky zo železa získané priamou redukciou železnej rudy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72031000'),
('72039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72039000'),
('7204', 'Železné a oceľové odpady a šrot; pretavené odpady zo železa alebo ocele v ingotoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7204'),
('72041000', '- Liatinové odpady a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72041000'),
('72041000:2X', '- Odpady a šrot z legovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72041000:2X'),
('720421', '-- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720421'),
('72042110', '--- Obsahujúce v hmotnosti 8 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72042110'),
('72042190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72042190'),
('72042900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72042900'),
('72043000', '- Odpady a šrot z pocínovaného železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72043000'),
('72043000:2X', '- Ostatné kovové odpady a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72043000:2X'),
('720441', '-- Triesky po sústružení, hobliny, odrezky, triesky, piliny, odstrižky a odpady z razenia, tiež v balíkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720441'),
('72044110', '--- Odpady zo sústruženia, hobľovania, frézovania, rezania a pilovania, vrátane triesok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72044110'),
('72044110:2X', '--- Zvyšky z razenia a odstrižky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72044110:2X'),
('72044191', '---- Paketované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72044191'),
('72044199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72044199'),
('720449', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720449'),
('72044910', '--- Drvené (rozstrihané)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72044910'),
('72044910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72044910:2X'),
('72044930', '---- Paketované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72044930'),
('72044990', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72044990'),
('72045000', '- Pretavené odpady v ingotoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72045000'),
('7205', 'Granuly a prášok zo surového železa, vysokopecnej zrkadloviny, železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7205'),
('72051000', '- Granuly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72051000'),
('72051000:2X', '- Prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72051000:2X'),
('72052100', '-- Z legovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72052100'),
('72052900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72052900'),
('72052900:2X', 'II. ŽELEZO A NELEGOVANÁ OCEĽ', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72052900:2X'),
('7206', 'Železo a nelegovaná oceľ v ingotoch alebo ostatných základných tvaroch (okrem železa položky 7203)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7206'),
('72061000', '- Ingoty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72061000'),
('72069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72069000'),
('7207', 'Polotovary zo železa alebo z nelegovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7207'),
('7207:2X', '- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7207:2X'),
('720711', '-- S pravouhlým (tiež štvorcovým) prierezom, ktorého šírka je menšia ako dvojnásobok hrúbky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720711'),
('720711:2X', '--- Valcované alebo vyrobené kontinuálnym liatím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720711:2X'),
('72071111', '---- Z dobre obrábateľnej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071111'),
('72071111:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071111:2X'),
('72071114', '----- S hrúbkou nepresahujúcou 130 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071114'),
('72071116', '----- S hrúbkou presahujúcou 130 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071116'),
('72071190', '--- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071190'),
('720712', '-- Ostatné, s pravouhlým (iným ako štvorcovým) prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720712'),
('72071210', '--- Valcované alebo vyrobené kontinuálnym liatím (ESUO)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071210'),
('72071290', '--- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071290'),
('720719', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720719'),
('720719:2X', '--- S kruhovým alebo mnohouholníkovým prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720719:2X'),
('72071912', '---- Valcované alebo vyrobené kontinuálnym liatím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071912'),
('72071919', '---- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071919'),
('72071980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72071980'),
('720720', '- Obsahujúce v hmotnosti 0,25 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720720'),
('720720:2X', '-- S pravouhlým (tiež štvorcovým) prierezom, ktorého šírka je menšia ako dvojnásobok hrúbky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720720:2X'),
('720720:3X', '--- Valcované alebo vyrobené kontinuálnym liatím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720720:3X'),
('72072011', '---- Z dobre obrábateľnej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072011'),
('72072011:2X', '---- Ostatné, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072011:2X'),
('72072015', '----- 0,25 % alebo viac, ale menej ako 0,6 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072015'),
('72072017', '----- 0,6 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072017'),
('72072019', '--- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072019'),
('72072019:2X', '-- Ostatné, s pravouhlým (iným ako štvorcovým) prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072019:2X'),
('72072032', '--- Valcované alebo vyrobené kontinuálnym liatím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072032'),
('72072039', '--- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072039'),
('72072039:2X', '-- S kruhovým alebo mnohouholníkovým prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072039:2X'),
('72072052', '--- Valcované alebo vyrobené kontinuálnym liatím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072052'),
('72072059', '--- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072059'),
('72072080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72072080'),
('7208', 'Ploché valcované výrobky zo železa alebo nelegovanej ocele, so šírkou 600 mm alebo väčšou, valcované za tepla, neplátované, nepokovované alebo nepotiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7208'),
('72081000', '- Vo zvitkoch, po valcovaní za tepla ďalej neupravené, so vzorkou na reliéfe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72081000'),
('72081000:2X', '- Ostatné vo zvitkoch, po valcovaní za tepla ďalej neupravené, morené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72081000:2X'),
('72082500', '-- S hrúbkou 4,75 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72082500'),
('72082600', '-- S hrúbkou 3 mm alebo väčšou, ale menšou ako 4,75 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72082600'),
('72082700', '-- S hrúbkou menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72082700'),
('72082700:2X', '- Ostatné vo zvitkoch, po valcovaní za tepla ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72082700:2X'),
('72083600', '-- S hrúbkou presahujúcou 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72083600'),
('72083700', '-- S hrúbkou 4,75 mm alebo väčšou, ale nepresahujúcej 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72083700'),
('72083800', '-- S hrúbkou 3 mm alebo väčšou, ale menšou ako 4,75 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72083800'),
('72083900', '-- S hrúbkou menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72083900'),
('72084000', '- Nie vo zvitkoch, po valcovaní za tepla už ďalej neupravené, so vzorkou na reliéfe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72084000'),
('72084000:2X', '- Ostatné, nie vo zvitkoch, po valcovaní za tepla už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72084000:2X'),
('720851', '-- S hrúbkou presahujúcou 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720851'),
('72085120', '--- S hrúbkou presahujúcou 15 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085120'),
('72085120:2X', '--- V hrúbke presahujúcou 10 mm, ale nepresahujúcou 15 mm, a so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085120:2X'),
('72085191', '---- 2 050 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085191'),
('72085198', '---- Menšou ako 2 050 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085198'),
('720852', '-- S hrúbkou 4,75 mm alebo väčšou, ale nepresahujúcou 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720852'),
('72085210', '--- Valcované zo štyroch strán alebo v uzavretom obdĺžnikovom kalibri, so šírkou nepresahujúcou 1 250 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085210'),
('72085210:2X', '--- Ostatné so šírkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085210:2X'),
('72085291', '---- 2 050 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085291'),
('72085299', '---- Menšou ako 2 050 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085299'),
('720853', '-- S hrúbkou 3 mm alebo väčšou, ale menšou ako 4,75 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720853'),
('72085310', '--- Valcované zo štyroch strán alebo v uzavretom obdĺžnikovom kalibri, so šírkou nepresahujúcou 1 250 mm, a s hrúbkou 4 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085310'),
('72085390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085390'),
('72085400', '-- S hrúbkou menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72085400'),
('720890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720890'),
('72089020', '-- Perforované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72089020'),
('72089080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72089080'),
('7209', 'Ploché valcované výrobky zo železa alebo z nelegovanej ocele, so šírkou 600 mm alebo väčšou, valcované za studena (úberom za studena), neplátované, nepokovované alebo nepotiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7209'),
('7209:2X', '- Vo zvitkoch, po valcovaní za studena (úberom za studena), ďalej už neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7209:2X'),
('72091500', '-- S hrúbkou 3 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091500'),
('720916', '-- S hrúbkou presahujúcou 1 mm, ale menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720916'),
('72091610', '--- "Elektrické"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091610'),
('72091690', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091690'),
('720917', '-- S hrúbkou 0,5 mm alebo väčšou, ale nepresahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720917'),
('72091710', '--- "Elektrické"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091710'),
('72091790', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091790'),
('720918', '-- S hrúbkou menšou ako 0,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720918'),
('72091810', '--- "Elektrické"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091810'),
('72091810:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091810:2X'),
('72091891', '---- S hrúbkou 0,25 mm alebo väčšou, ale menšou ako 0,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091891'),
('72091899', '---- S hrúbkou menšou ako 0,35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091899'),
('72091899:2X', '- Nie vo zvitkoch, po valcovaní za studena (úberom za studena), ďalej už neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72091899:2X'),
('72092500', '-- S hrúbkou 3 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72092500'),
('720926', '-- S hrúbkou presahujúcou 1 mm, ale menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720926'),
('72092610', '--- "Elektrické"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72092610'),
('72092690', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72092690'),
('720927', '-- S hrúbkou 0,5 mm alebo väčšou, ale nepresahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720927'),
('72092710', '--- "Elektrické"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72092710'),
('72092790', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72092790'),
('720928', '-- S hrúbkou menšou ako 0,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720928'),
('72092810', '--- "Elektrické"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72092810'),
('72092890', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72092890'),
('720990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_720990'),
('72099020', '-- Perforované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72099020'),
('72099080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72099080'),
('7210', 'Ploché valcované výrobky zo železa alebo z nelegovanej ocele, v šírke 600 mm alebo väčšej, plátované, pokovované alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7210'),
('7210:2X', '- Pokovované alebo potiahnuté cínom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7210:2X'),
('72101100', '-- S hrúbkou 0,5 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72101100'),
('721012', '-- S hrúbkou menšou ako 0,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721012'),
('72101220', '--- Pocínované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72101220'),
('72101280', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72101280'),
('72102000', '- Pokovované alebo potiahnuté olovom, vrátane matného bieleho plechu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72102000'),
('72103000', '- Elektrolyticky pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72103000'),
('72103000:2X', '- Inak pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72103000:2X'),
('72104100', '-- Vlnité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72104100'),
('72104900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72104900'),
('72105000', '- Pokovované alebo potiahnuté oxidmi chrómu alebo chrómom a oxidmi chrómu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72105000'),
('72105000:2X', '- Pokovované alebo potiahnuté hliníkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72105000:2X'),
('72106100', '-- Pokovované alebo potiahnuté zliatinami hliník-zinok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72106100'),
('72106900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72106900'),
('721070', '- Natierané, lakované alebo potiahnuté plastmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721070'),
('72107010', '-- Pocínované, lakované; výrobky pokovované alebo potiahnuté buď oxidmi chrómu alebo chrómom a oxidmi chromu, lakované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72107010'),
('72107080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72107080'),
('721090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721090'),
('72109030', '-- Plátované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72109030'),
('72109040', '-- Pocínované a potlačené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72109040'),
('72109080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72109080'),
('7211', 'Ploché valcované výrobky zo železa alebo z nelegovanej ocele, so šírkou menšou ako 600 mm, neplátované, nepokovované ani nepotiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7211'),
('7211:2X', '- Po valcovaní za tepla už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7211:2X'),
('72111300', '-- Valcované zo štyroch strán alebo v uzavretom kalibre, so šírkou presahujúcou 150 mm a s hrúbkou nie menšou ako 4 mm, nie vo zvitkoch bez vzorky na reliéfe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72111300'),
('72111400', '-- Ostatné, s hrúbkou 4,75 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72111400'),
('72111900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72111900'),
('72111900:2X', '- Po valcovaní za studena (úberom za studena) už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72111900:2X'),
('721123', '-- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721123'),
('72112320', '--- "Elektrické"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72112320'),
('72112320:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72112320:2X'),
('72112330', '---- S hrúbkou 0,35 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72112330'),
('72112380', '---- S hrúbkou menšou ako 0,35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72112380'),
('72112900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72112900'),
('721190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721190'),
('72119020', '-- Perforované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72119020'),
('72119080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72119080'),
('7212', 'Ploché valcované výrobky zo železa alebo z nelegovanej ocele, so šírkou menšou ako 600 mm, plátované, pokovované alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7212'),
('721210', '- Pokovované alebo potiahnuté cínom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721210'),
('72121010', '-- Pocínované, po povrchovej úprave už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72121010'),
('72121090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72121090'),
('72122000', '- Elektrolyticky pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72122000'),
('72123000', '- Inak pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72123000'),
('721240', '- Natierané, lakované alebo potiahnuté plastmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721240'),
('72124020', '-- Pocínované, po lakovaní už ďalej neopracované; výrobky pokovované alebo potiahnuté oxidmi chrómu alebo chrómom a oxidmi chrómu, lakované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72124020'),
('72124080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72124080'),
('721250', '- Inak pokovované alebo potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721250'),
('72125020', '-- Pokovované alebo potiahnuté oxidmi chrómu alebo chrómom a oxidmi chrómu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72125020'),
('72125030', '-- Pokovované alebo potiahnuté chrómom alebo niklom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72125030'),
('72125040', '-- Pokovované alebo potiahnuté meďou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72125040'),
('72125040:2X', '-- Pokovované alebo potiahnuté hliníkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72125040:2X'),
('72125061', '--- Pokovované alebo potiahnuté zliatinami hliník-zinok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72125061'),
('72125069', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72125069'),
('72125090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72125090'),
('72126000', '- Plátované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72126000'),
('7213', 'Tyče a prúty, valcované za tepla, zo železa alebo z nelegovanej ocele, v nepravidelne navinutých zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7213'),
('72131000', '- Majúce vrúbky, žliabky, rebrá alebo ostatné deformácie vzniknuté počas valcovania', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72131000'),
('72132000', '- Ostatné, z automatovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72132000'),
('72132000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72132000:2X'),
('721391', '-- Kruhového prierezu s priemerom menším ako 14 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721391'),
('72139110', '--- Používané na betónové výstuže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72139110'),
('72139120', '--- Používané na kordové pneumatiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72139120'),
('72139120:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72139120:2X'),
('72139141', '---- Obsahujúce v hmotnosti 0,06 % alebo menej uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72139141'),
('72139149', '---- Obsahujúce v hmotnosti viac ako 0,06 %, ale menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72139149'),
('72139170', '---- Obsahujúce v hmotnosti 0,25 % alebo viac, ale najviac 0,75 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72139170'),
('72139190', '---- Obsahujúce v hmotnosti viac ako 0,75 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72139190'),
('721399', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721399'),
('72139910', '--- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72139910'),
('72139990', '--- Obsahujúce v hmotnosti 0,25 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72139990'),
('7214', 'Ostatné tyče a prúty zo železa alebo nelegovanej ocele, neupravené inak ako kovaním za tepla, valcovaním za tepla, ťahaním za tepla alebo pretláčaním za tepla, prípadne po valcovaní ešte krútené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7214'),
('72141000', '- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72141000'),
('72142000', '- Majúce vrúbky, žliabky, rebrá alebo ostatné deformácie vzniknuté počas valcovania alebo krútením po valcovaní', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72142000'),
('72143000', '- Ostatné, z automatovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72143000'),
('72143000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72143000:2X'),
('721491', '-- S pravouhlým (iným ako štvorcovým) prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721491'),
('72149110', '--- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149110'),
('72149190', '--- Obsahujúce v hmotnosti 0,25 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149190'),
('721499', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721499'),
('721499:2X', '--- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721499:2X'),
('72149910', '---- Používané na betónové výstuže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149910'),
('72149910:2X', '---- Ostatné, s kruhovým prierezom s priemerom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149910:2X'),
('72149931', '----- 80 mm alebo väčším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149931'),
('72149939', '----- Menším ako 80 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149939'),
('72149950', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149950'),
('72149950:2X', '--- Obsahujúce v hmotnosti 0,25 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149950:2X'),
('72149950:3X', '---- S kruhovým prierezom s priemerom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149950:3X'),
('72149971', '----- 80 mm alebo väčším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149971'),
('72149979', '----- Menším ako 80 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149979'),
('72149995', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72149995'),
('7215', 'Ostatné tyče a prúty zo železa alebo nelegovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7215'),
('72151000', '- Z automatovej ocele, po tvarovaní za studena alebo dokončené za studena už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72151000'),
('721550', '- Ostatné, po tvarovaní za studena alebo dokončené za studena už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721550'),
('721550:2X', '-- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721550:2X'),
('72155011', '--- S pravouhlým (iným ako štvorcovým) prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72155011'),
('72155019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72155019'),
('72155080', '-- Obsahujúce v hmotnosti 0,25 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72155080'),
('72159000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72159000'),
('7216', 'Uholníky, tvarovky a profily zo železa alebo z nelegovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7216'),
('72161000', '- Profily v tvare U, I alebo H, po valcovaní za tepla, ťahaní za tepla alebo pretláčaní za tepla už ďalej neupravené, s výškou menšou ako 80 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72161000'),
('72161000:2X', '- Profily v tvare L alebo T, po valcovaní za tepla, ťahaní za tepla alebo pretláčaní za tepla už ďalej neupravené, s výškou menšou ako 80 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72161000:2X'),
('72162100', '-- Profily v tvare L', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72162100'),
('72162200', '-- Profily v tvare T', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72162200'),
('72162200:2X', '- Profily v tvare U, I alebo H, po valcovaní za tepla, ťahaní za tepla alebo pretláčaní za tepla už ďalej neupravené, s výškou 80 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72162200:2X'),
('721631', '-- Profily v tvare U', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721631'),
('72163110', '--- S výškou 80 mm alebo väčšou, ale nepresahujúcou 220 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72163110'),
('72163190', '--- S výškou presahujúcou 220 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72163190'),
('721632', '-- Profily v tvare I', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721632'),
('721632:2X', '--- S výškou 80 mm alebo väčšou, ale nepresahujúcou 220 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721632:2X'),
('72163211', '---- S rovnobežnými plochami ramien uholníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72163211'),
('72163219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72163219'),
('72163219:2X', '--- S výškou presahujúcou 220 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72163219:2X'),
('72163291', '---- S rovnobežnými plochami ramien uholníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72163291'),
('72163299', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72163299'),
('721633', '-- Profily v tvare H', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721633'),
('72163310', '--- S výškou 80 mm alebo väčšou, ale nepresahujúcou 180 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72163310'),
('72163390', '--- S výškou presahujúcou 180 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72163390'),
('721640', '- Profily v tvare L alebo T, po valcovaní za tepla, ťahaní za tepla alebo pretláčaní za tepla už ďalej neupravené, s výškou 80 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721640'),
('72164010', '-- Profily v tvare L', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72164010'),
('72164090', '-- Profily v tvare T', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72164090'),
('721650', '- Ostatné uholníky, tvarovky a profily, po valcovaní za tepla, ťahaní za tepla alebo pretláčaní za tepla už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721650'),
('72165010', '-- S prierezom, ktorý sa dá uzavrieť do štvorca so stranou 80 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72165010'),
('72165010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72165010:2X'),
('72165091', '--- Hlavičkové ploché', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72165091'),
('72165099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72165099'),
('72165099:2X', '- Uholníky, tvarovky a profily, po tvarovaní za studena alebo dokončené za studena už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72165099:2X'),
('721661', '-- Vyrobené z plochých valcovaných výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721661'),
('72166110', '--- Profily v tvare C, L, U, Z, omega alebo otvorené profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72166110'),
('72166190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72166190'),
('72166900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72166900'),
('72166900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72166900:2X'),
('721691', '-- Tvarované za studena alebo dokončené za studena z plochých valcovaných výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721691'),
('72169110', '--- Rebrované plechy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72169110'),
('72169180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72169180'),
('72169900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72169900'),
('7217', 'Drôty zo železa alebo nelegovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7217'),
('721710', '- Nepokovované alebo nepotiahnuté, tiež leštené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721710'),
('721710:2X', '-- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721710:2X'),
('72171010', '--- S maximálnym priečnym rozmerom menším ako 0,8 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72171010'),
('72171010:2X', '--- S maximálnym priečnym rozmerom 0,8 mm alebo väčším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72171010:2X'),
('72171031', '---- Majúce vrúbky, žliabky, rebrá alebo ostatné deformácie vzniknuté počas valcovania', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72171031'),
('72171039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72171039'),
('72171050', '-- Obsahujúce v hmotnosti 0,25 % alebo viac, ale menej ako 0,6 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72171050'),
('72171090', '-- Obsahujúce v hmotnosti 0,6 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72171090'),
('721720', '- Pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721720'),
('721720:2X', '-- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721720:2X'),
('72172010', '--- S maximálnym priečnym rozmerom menším ako 0,8 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72172010'),
('72172030', '--- S maximálnym priečnym rozmerom 0,8 mm alebo väčším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72172030'),
('72172050', '-- Obsahujúce v hmotnosti 0,25 % alebo viac, ale menej ako 0,6 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72172050'),
('72172090', '-- Obsahujúce v hmotnosti 0,6 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72172090'),
('721730', '- Pokovované alebo potiahnuté ostatnými základnými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721730'),
('721730:2X', '-- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721730:2X'),
('72173041', '--- Potiahnuté meďou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72173041'),
('72173049', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72173049'),
('72173050', '-- Obsahujúce v hmotnosti 0,25 % alebo viac, ale menej ako 0,6 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72173050'),
('72173090', '-- Obsahujúce v hmotnosti 0,6 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72173090'),
('721790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721790'),
('72179020', '-- Obsahujúce v hmotnosti menej ako 0,25 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72179020'),
('72179050', '-- Obsahujúce v hmotnosti 0,25 % alebo viac, ale menej ako 0,6 % uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72179050'),
('72179090', '-- Obsahujúce v hmotnosti 0,6 % alebo viac uhlíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72179090'),
('72179090:2X', 'III. NEHRDZAVEJÚCA OCEĽ', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72179090:2X'),
('7218', 'Nehrdzavejúca oceľ v ingotoch alebo v ostatných základných tvaroch; polotovary z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7218'),
('72181000', '- Ingoty alebo ostatné základné tvary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72181000'),
('72181000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72181000:2X'),
('721891', '-- S pravouhlým (iným ako štvorcovým) prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721891'),
('72189110', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72189110'),
('72189180', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72189180'),
('721899', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721899'),
('721899:2X', '--- So štvorcovým prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721899:2X'),
('72189911', '---- Valcované alebo vyrobené kontinuálnym liatím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72189911'),
('72189919', '---- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72189919'),
('72189919:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72189919:2X'),
('72189920', '---- Valcované alebo vyrobené kontinuálnym liatím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72189920'),
('72189980', '---- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72189980'),
('7219', 'Ploché valcované výrobky z nehrdzavejúcej ocele so šírkou 600 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7219'),
('7219:2X', '- Po valcovaní za tepla už ďalej neupravené, vo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7219:2X'),
('72191100', '-- S hrúbkou presahujúcou 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72191100'),
('721912', '-- S hrúbkou 4,75 mm alebo väčšou, ale nepresahujúcou 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721912'),
('72191210', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72191210'),
('72191290', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72191290'),
('721913', '-- S hrúbkou 3 mm alebo väčšou, ale menšou ako 4,75 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721913'),
('72191310', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72191310'),
('72191390', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72191390'),
('721914', '-- S hrúbkou menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721914'),
('72191410', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72191410'),
('72191490', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72191490'),
('72191490:2X', '- Po valcovaní za tepla už ďalej neupravené, nie vo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72191490:2X'),
('721921', '-- S hrúbkou presahujúcou 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721921'),
('72192110', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72192110'),
('72192190', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72192190'),
('721922', '-- S hrúbkou 4,75 mm alebo väčšou, ale nepresahujúcou 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721922'),
('72192210', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72192210'),
('72192290', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72192290'),
('72192300', '-- S hrúbkou 3 mm alebo väčšou, ale menšou ako 4,75 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72192300'),
('72192400', '-- S hrúbkou menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72192400'),
('72192400:2X', '- Po valcovaní za studena (úberom za studena) už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72192400:2X'),
('72193100', '-- S hrúbkou 4,75 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72193100'),
('721932', '-- S hrúbkou 3 mm alebo väčšou, ale menšou ako 4,75 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721932'),
('72193210', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72193210'),
('72193290', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72193290'),
('721933', '-- S hrúbkou presahujúcou 1 mm, ale menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721933'),
('72193310', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72193310'),
('72193390', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72193390'),
('721934', '-- S hrúbkou 0,5 mm alebo väčšou, ale nepresahujúcou 1 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721934'),
('72193410', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72193410'),
('72193490', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72193490'),
('721935', '-- S hrúbkou menšou ako 0,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721935'),
('72193510', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72193510'),
('72193590', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72193590'),
('721990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_721990'),
('72199020', '-- Perforované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72199020'),
('72199080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72199080'),
('7220', 'Ploché valcované výrobky z nehrdzavejúcej ocele so šírkou menšou ako 600 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7220'),
('7220:2X', '- Po valcovaní za tepla už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7220:2X'),
('72201100', '-- V hrúbkou 4,75 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72201100'),
('72201200', '-- S hrúbkou menšou ako 4,75 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72201200'),
('722020', '- Po valcovaní za studena (úberom za studena) už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722020'),
('722020:2X', '-- S hrúbkou 3 mm alebo väčšou, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722020:2X'),
('72202021', '--- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72202021'),
('72202029', '--- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72202029'),
('72202029:2X', '-- S hrúbkou presahujúcou 0,35 mm alebo menšou ako 3 mm a obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72202029:2X'),
('72202041', '--- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72202041'),
('72202049', '--- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72202049'),
('72202049:2X', '-- S hrúbkou presahujúcou 0,35 mm, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72202049:2X'),
('72202081', '--- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72202081'),
('72202089', '--- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72202089'),
('722090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722090'),
('72209020', '-- Perforované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72209020'),
('72209080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72209080'),
('722100', 'Tyče a prúty, valcované za tepla, v nepravidelne navinutých cievkach, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722100'),
('72210010', '- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72210010'),
('72210090', '- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72210090'),
('7222', 'Ostatné tyče a prúty z nehrdzavejúcej ocele; uholníky, tvarovky a profily z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7222'),
('7222:2X', '- Tyče a prúty, po valcovaní za tepla, ťahaní za tepla alebo pretláčaní už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7222:2X'),
('722211', '-- S kruhovým prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722211'),
('722211:2X', '--- S priemerom 80 mm alebo väčším, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722211:2X'),
('72221111', '---- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72221111'),
('72221119', '---- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72221119'),
('72221119:2X', '--- S priemerom menším ako 80 mm, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72221119:2X'),
('72221181', '---- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72221181'),
('72221189', '---- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72221189'),
('722219', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722219'),
('72221910', '--- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72221910'),
('72221990', '--- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72221990'),
('722220', '- Tyče a prúty, po tvarovaní za studena alebo dokončené za studena už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722220'),
('722220:2X', '-- S kruhovým prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722220:2X'),
('722220:3X', '--- S priemerom 80 mm alebo väčším, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722220:3X'),
('72222011', '---- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222011'),
('72222019', '---- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222019'),
('72222019:2X', '--- S priemerom 25 mm alebo väčším, ale menším ako 80 mm, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222019:2X'),
('72222021', '---- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222021'),
('72222029', '---- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222029'),
('72222029:2X', '--- S priemerom menším ako 25 mm, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222029:2X'),
('72222031', '---- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222031'),
('72222039', '---- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222039'),
('72222039:2X', '-- Ostatné, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222039:2X'),
('72222081', '--- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222081'),
('72222089', '--- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72222089'),
('722230', '- Ostatné tyče a prúty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722230'),
('722230:2X', '-- Kované, obsahujúce v hmotnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722230:2X'),
('72223051', '--- 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72223051'),
('72223091', '--- Menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72223091'),
('72223097', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72223097'),
('722240', '- Uholníky, tvarovky a profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722240'),
('72224010', '-- Po valcovaní alebo ťahaní za tepla alebo pretláčaní už ďalej neopracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72224010'),
('72224050', '-- Po tvarovaní za studena alebo dokončené za studena už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72224050'),
('72224090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72224090'),
('722300', 'Drôty z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722300'),
('722300:2X', '- Obsahujúce v hmotnosti 2,5 % alebo viac niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722300:2X'),
('72230011', '-- Obsahujúce v hmotnosti 28 % alebo viac, ale nie viac ako 31 % niklu, a 20 % alebo viac, ale nie viac ako 22 % chrómu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72230011'),
('72230019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72230019'),
('72230019:2X', '- Obsahujúce v hmotnosti menej ako 2,5 % niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72230019:2X'),
('72230091', '-- Obsahujúce v hmotnosti 13 % alebo viac, ale nie viac ako 25 % chrómu, a 3,5 % alebo viac, ale nie viac ako 6 % hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72230091'),
('72230099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72230099'),
('72230099:2X', 'IV. OSTATNÁ LEGOVANÁ OCEĽ; DUTÉ VRTNÉ TYČE A PRÚTY Z LEGOVANEJ ALEBO NELEGOVANEJ OCELE', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72230099:2X'),
('7224', 'Ostatná legovaná oceľ v ingotoch alebo v ostatných základných tvaroch; polotovary z ostatnej legovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7224'),
('722410', '- Ingoty alebo ostatné základné tvary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722410'),
('72241010', '-- Z nástrojovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72241010'),
('72241090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72241090'),
('722490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722490'),
('72249002', '-- Z nástrojovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249002'),
('72249002:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249002:2X'),
('72249002:3X', '--- S pravouhlým (tiež štvorcovým) prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249002:3X'),
('72249002:4X', '---- Valcované za tepla alebo vyrobené kontinuálnym liatím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249002:4X'),
('72249002:5X', '----- Ktorých šírka je menšia ako dvojnásobná hrúbka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249002:5X'),
('72249003', '------ Z rýchloreznej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249003'),
('72249005', '------ Obsahujúce v hmotnosti nie viac ako 0,7 % uhlíka, 0,5 % alebo viac, ale nie viac ako 1,2 % mangánu, a 0,6 % alebo viac, ale nie viac ako 2,3 % kremíka; obsahujúce v hmotnosti 0,0008 % alebo viac bóru, s akýmkoľvek ostatným prvkom, ktorého obsah je', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249005'),
('72249007', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249007'),
('72249014', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249014'),
('72249018', '---- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249018'),
('72249018:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249018:2X'),
('72249018:3X', '---- Valcované za tepla alebo vyrobené kontinuálnym liatím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249018:3X'),
('72249031', '----- Obsahujúce v hmotnosti nie menej ako 0,9 %, nie však viac ako 1,15 % uhlíka, nie menej ako 0,5 %, nie však viac ako 2 % chrómu, a ak obsahuje molybdén, tak nie viac ako 0,5 %', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249031'),
('72249038', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249038'),
('72249090', '---- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72249090'),
('7225', 'Ploché valcované výrobky z ostatnej legovanej ocele so šírkou 600 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7225'),
('7225:2X', '- Z kremíkovej elektroocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7225:2X'),
('72251100', '-- S orientovanou štruktúrou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72251100'),
('722519', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722519'),
('72251910', '--- Valcované za tepla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72251910'),
('72251990', '--- Valcované za studena', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72251990'),
('722530', '- Ostatné, po valcovaní za tepla už ďalej neupravené, vo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722530'),
('72253010', '-- Z nástrojovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72253010'),
('72253030', '-- Z rýchloreznej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72253030'),
('72253090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72253090'),
('722540', '- Ostatné, po valcovaní za tepla už ďalej neupravené, nie vo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722540'),
('72254012', '-- Z nástrojovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72254012'),
('72254015', '-- Z rýchloreznej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72254015'),
('72254015:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72254015:2X'),
('72254040', '--- S hrúbkou presahujúcou 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72254040'),
('72254060', '--- S hrúbkou 4,75 mm alebo väčšou, ale nepresahujúcou 10 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72254060'),
('72254090', '--- S hrúbkou menšou ako 4,75 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72254090'),
('722550', '- Ostatné, po valcovaní za studena (úberom za studena) už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722550'),
('72255020', '-- Z rýchloreznej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72255020'),
('72255080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72255080'),
('72255080:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72255080:2X'),
('72259100', '-- Elektrolyticky pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72259100'),
('72259200', '-- Inak pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72259200'),
('72259900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72259900'),
('7226', 'Ploché valcované výrobky z ostatnej legovanej ocele so šírkou menšou ako 600 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7226'),
('7226:2X', '- Z kremíkovej elektroocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7226:2X'),
('72261100', '-- S orientovanou štruktúrou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72261100'),
('722619', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722619'),
('72261910', '--- Po valcovaní za tepla už ďalej neopracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72261910'),
('72261980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72261980'),
('72262000', '- Z rýchloreznej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72262000'),
('72262000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72262000:2X'),
('722691', '-- Po valcovaní za tepla už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722691'),
('72269120', '--- Z nástrojovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72269120'),
('72269120:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72269120:2X'),
('72269191', '---- S hrúbkou 4,75 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72269191'),
('72269199', '---- S hrúbkou menšou ako 4,75 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72269199'),
('72269200', '-- Po valcovaní za studena (úberom za studena) už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72269200'),
('722699', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722699'),
('72269910', '--- Elektrolyticky pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72269910'),
('72269930', '--- Inak pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72269930'),
('72269970', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72269970'),
('7227', 'Tyče a prúty, valcované za tepla, v nepravidelne navinutých cievkach, z ostatnej legovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7227'),
('72271000', '- Z rýchloreznej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72271000'),
('72272000', '- Z kremíkomangánovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72272000'),
('722790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722790'),
('72279010', '-- Obsahujúce v hmotnosti 0,0008 % alebo viac bóru, spolu s akýmkoľvek ostatným prvkom, ktorého obsah je menší ako minimálny obsah uvedený v poznámke 1 písm. f) k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72279010'),
('72279050', '-- Obsahujúce v hmotnosti 0,9 % alebo viac, ale nie viac ako 1,15 % uhlíka, najmenej 0,5 %, ale nie viac ako 2 % chrómu a, ak ho obsahuje, tak nie viac ako 0,5 % molybdénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72279050'),
('72279095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72279095'),
('7228', 'Ostatné tyče a prúty z ostatnej legovanej ocele; uholníky, tvarovky a profily z ostatnej legovanej ocele; duté vrtné tyče a prúty na vrtáky z legovanej alebo nelegovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7228'),
('722810', '- Tyče a prúty z rýchloreznej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722810'),
('72281020', '-- Inak neopracované ako valcované za tepla, ťahané za tepla alebo pretláčané, ďalej neopracované inak ako plátovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72281020'),
('72281050', '-- Kované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72281050'),
('72281090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72281090'),
('722820', '- Tyče a prúty z kremíkomangánovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722820'),
('72282010', '-- S pravouhlým (iným ako štvorcovým) prierezom, valcované zo štyroch strán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72282010'),
('72282010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72282010:2X'),
('72282091', '--- Inak neopracované ako valcované za tepla, ťahané za tepla alebo pretláčané, ďalej neopracované inak ako plátovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72282091'),
('72282099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72282099'),
('722830', '- Ostatné tyče a prúty, neupravené inak ako valcovaním za tepla, ťahaním za tepla alebo pretláčaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722830'),
('72283020', '-- Z nástrojovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283020'),
('72283020:2X', '-- Obsahujúce v hmotnosti 0,9 % alebo viac, ale nie viac ako 1,15 % uhlíka, najmenej 0,5 %, ale nie viac ako 2 % chrómu a, ak ho obsahuje, tak nie viac ako 0,5 % molybdénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283020:2X'),
('72283041', '--- S kruhovým prierezom s priemerom 80 mm alebo väčším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283041'),
('72283049', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283049'),
('72283049:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283049:2X'),
('72283049:3X', '--- S kruhovým prierezom s priemerom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283049:3X'),
('72283061', '---- 80 mm alebo väčším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283061'),
('72283069', '---- Menším ako 80 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283069'),
('72283070', '--- S pravouhlým (iným ako štvorcovým) prierezom, valcované za tepla zo štyroch strán', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283070'),
('72283089', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72283089'),
('722840', '- Ostatné tyče a prúty, neupravené inak ako kovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722840'),
('72284010', '-- Z nástrojovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72284010'),
('72284090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72284090'),
('722850', '- Ostatné tyče a prúty, neupravené inak ako tvarovaním za studena alebo povrchovou úpravou za studena', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722850'),
('72285020', '-- Z nástrojovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72285020'),
('72285040', '-- Obsahujúce v hmotnosti 0,9 % alebo viac, ale nie viac ako 1,15 % uhlíka, najmenej 0,5 %, ale nie viac ako 2 % chrómu a, ak ho obsahuje, tak nie viac ako 0,5 % molybdénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72285040'),
('72285040:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72285040:2X'),
('72285040:3X', '--- S kruhovým prierezom s priemerom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72285040:3X'),
('72285061', '---- 80 mm alebo viac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72285061'),
('72285069', '---- Menším ako 80 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72285069'),
('72285080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72285080'),
('722860', '- Ostatné tyče a prúty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722860'),
('72286020', '-- Z nástrojovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72286020'),
('72286080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72286080'),
('722870', '- Uholníky, tvarovky a profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722870'),
('72287010', '-- Po valcovaní za tepla alebo ťahaní za tepla, alebo po pretláčaní už ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72287010'),
('72287090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72287090'),
('72288000', '- Duté vrtné tyče a prúty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72288000'),
('7229', 'Drôty z ostatnej legovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7229'),
('72292000', '- Z kremíkomangánovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72292000'),
('722990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_722990'),
('72299020', '-- Z rýchloreznej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72299020'),
('72299050', '-- Obsahujúce v hmotnosti 0,9 % alebo viac, ale nie viac ako 1,15 % uhlíka, najmenej 0,5 %, ale nie viac ako 2 % chrómu a, ak ho obsahuje, tak nie viac ako 0,5 % molybdénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72299050'),
('72299090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_72299090'),
('7301', 'Štetovnice zo železa alebo ocele, tiež vŕtané, razené alebo vyrobené zo zostavených prvkov; zvárané uholníky, tvarovky a profily zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7301'),
('73011000', '- Štetovnice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73011000'),
('73012000', '- Uholníky, tvarovky a profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73012000'),
('7302', 'Konštrukčný materiál železničných alebo električkových tratí, zo železa alebo ocele: koľajnice, prídržné koľajnice a ozubnice, hrotnice, srdcovky, výhybky, prestavné tyče, výmeny a ostatné priecestné zariadenia, podvaly (priečne podvaly), koľajnicové sp', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7302'),
('730210', '- Koľajnice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730210'),
('73021010', '-- Na vedenie prúdu, s časťami z neželezných kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73021010'),
('73021010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73021010:2X'),
('73021010:3X', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73021010:3X'),
('73021010:4X', '---- Symetrické železničné koľajnice s plochým spodkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73021010:4X'),
('73021022', '----- S hmotnosťou na meter 36 kg alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73021022'),
('73021028', '----- S hmotnosťou na meter menšou ako 36 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73021028'),
('73021040', '---- Žliabkové koľajnice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73021040'),
('73021050', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73021050'),
('73021090', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73021090'),
('73023000', '- Hrotnice, výhybky, prestavné tyče výmeny a ostatné priecestné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73023000'),
('73024000', '- Koľajnicové spojky a podkladnice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73024000'),
('73029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73029000'),
('730300', 'Rúry, rúrky a duté profily z liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730300'),
('73030010', '- Rúry a rúrky vhodné na tlakové zaťaženie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73030010'),
('73030090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73030090'),
('7304', 'Rúry, rúrky a duté profily, bezšvové, zo železa (z iného ako liatiny) alebo z ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7304'),
('7304:2X', '- Rúry, rúrky používané na ropovody alebo plynovody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7304:2X'),
('73041100', '-- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73041100'),
('730419', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730419'),
('73041910', '--- S vonkajším priemerom nepresahujúcim 168,3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73041910'),
('73041930', '--- S vonkajším priemerom presahujúcim 168,3 mm, ale nie väčším ako 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73041930'),
('73041990', '--- S vonkajším priemerom presahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73041990'),
('73041990:2X', '- Pažnice, čerpacie a vrtné rúrky používané na ropných alebo plynových vrtoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73041990:2X'),
('73042200', '-- Vrtné rúrky z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73042200'),
('73042300', '-- Ostatné vrtné rúrky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73042300'),
('73042400', '-- Ostatné, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73042400'),
('730429', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730429'),
('73042910', '--- S vonkajším priemerom nepresahujúcim 168,3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73042910'),
('73042930', '--- S vonkajším priemerom presahujúcim 168,3 mm, ale nepresahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73042930'),
('73042990', '--- S vonkajším priemerom presahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73042990'),
('73042990:2X', '- Ostatné, kruhového prierezu, zo železa alebo nelegovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73042990:2X'),
('730431', '-- Ťahané za studena alebo valcované za studena (úberom za studena)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730431'),
('73043120', '--- Presné rúrky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043120'),
('73043180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043180'),
('730439', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730439'),
('73043910', '--- Neopracované, rovné a s rovnomernou hrúbkou steny, určené len na výrobu rúr a rúrok s odlišným prierezom a hrúbkou steny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043910'),
('73043910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043910:2X'),
('73043910:3X', '---- Rúrky so závitmi alebo vhodné na rezanie závitov (plynové rúrky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043910:3X'),
('73043952', '----- Pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043952'),
('73043958', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043958'),
('73043958:2X', '---- Ostatné s vonkajším priemerom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043958:2X'),
('73043992', '----- Nepresahujúcim 168,3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043992'),
('73043993', '----- Presahujúcim 168,3 mm, ale nepresahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043993'),
('73043998', '----- Presahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043998'),
('73043998:2X', '- Ostatné, kruhového prierezu, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73043998:2X'),
('73044100', '-- Ťahané za studena alebo valcované za studena (úberom za studena)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73044100'),
('730449', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730449'),
('73044910', '--- Neopracované, rovné a s rovnomernou hrúbkou steny určené len na výrobu rúr a rúrok s odlišným prierezom a hrúbkou steny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73044910'),
('73044910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73044910:2X'),
('73044993', '---- S vonkajším priemerom nepresahujúcim 168,3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73044993'),
('73044995', '---- S vonkajším priemerom presahujúcim 168,3 mm, ale nepresahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73044995'),
('73044999', '---- S vonkajším priemerom presahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73044999'),
('73044999:2X', '- Ostatné, kruhového prierezu, z ostatnej legovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73044999:2X'),
('730451', '-- Ťahané za studena alebo valcované za studena (úberom za studena)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730451'),
('730451:2X', '--- Rovné a s rovnomernou hrúbkou steny, z legovanej ocele, obsahujúce v hmotnosti nie menej ako 0,9 %, ale nie viac ako 1,15 % uhlíka, nie menej ako 0,5 %, ale nie viac ako 2 % chrómu, a ak obsahuje molybdén, 0,5 % alebo menej molybdénu, s dĺžkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730451:2X'),
('73045112', '---- Nepresahujúcou 0,5 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045112'),
('73045118', '---- Presahujúcou 0,5 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045118'),
('73045118:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045118:2X'),
('73045181', '---- Presné rúrky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045181'),
('73045189', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045189'),
('730459', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730459'),
('73045910', '--- Neopracované, rovné a s rovnomernou hrúbkou steny určené len na výrobu rúr a rúrok s odlišným prierezom a hrúbkou steny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045910'),
('73045910:2X', '--- Ostatné, rovné a s rovnomernou hrúbkou steny, z legovanej ocele, obsahujúce v hmotnosti nie menej ako 0,9 %, ale nie viac ako 1,15 % uhlíka a nie menej ako 0,5 %, ale nie viac ako 2 % chrómu, a ak obsahuje molybdén, 0,5 % alebo menej molybdénu, s dĺž', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045910:2X'),
('73045932', '---- Nepresahujúcou 0,5 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045932'),
('73045938', '---- Presahujúcou 0,5 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045938'),
('73045938:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045938:2X'),
('73045992', '---- S vonkajším priemerom nepresahujúcim 168,3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045992'),
('73045993', '---- S vonkajším priemerom presahujúcim 168,3 mm, ale nepresahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045993'),
('73045999', '---- S vonkajším priemerom presahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73045999'),
('73049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73049000'),
('7305', 'Ostatné rúry a rúrky (napríklad zvárané, nitované alebo podobne uzavierané), s kruhovými prierezmi, vonkajším priemerom presahujúcim 406,4 mm, zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7305'),
('7305:2X', '- Rúry, rúrky druhov používaných na ropovody alebo plynovody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7305:2X'),
('73051100', '-- Pozdĺžne oblúkovo zvárané pod tavivom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73051100'),
('73051200', '-- Ostatné, pozdĺžne zvárané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73051200'),
('73051900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73051900'),
('73052000', '- Pažnice, používané pri ropných alebo plynových vrtoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73052000'),
('73052000:2X', '- Ostatné, zvárané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73052000:2X'),
('73053100', '-- Pozdĺžne zvárané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73053100'),
('73053900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73053900'),
('73059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73059000'),
('7306', 'Ostatné rúry, rúrky a duté profily (napríklad zvárané, nitované, spájané sponou [open seam] alebo podobne uzavierané), zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7306'),
('7306:2X', '- Rúry, rúrky druhov používaných na ropovody alebo plynovody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7306:2X'),
('730611', '-- Zvárané, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730611'),
('73061110', '--- Pozdĺžne zvárané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73061110'),
('73061190', '--- Špirálovite zvárané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73061190'),
('730619', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730619'),
('73061910', '--- Pozdĺžne zvárané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73061910'),
('73061990', '--- Špirálovite zvárané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73061990'),
('73061990:2X', '- Pažnice používané pri ropných alebo plynových vrtoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73061990:2X'),
('73062100', '-- Zvárané, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73062100'),
('73062900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73062900'),
('730630', '- Ostatné, zvárané, kruhového prierezu, zo železa alebo nelegovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730630'),
('730630:2X', '-- Presné rúrky, s hrúbkou steny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730630:2X'),
('73063011', '--- Nepresahujúcou 2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063011'),
('73063019', '--- Presahujúcou 2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063019'),
('73063019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063019:2X'),
('73063019:3X', '--- Rúrky so závitmi alebo vhodné na rezanie závitov (plynové rúrky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063019:3X'),
('73063041', '---- Pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063041'),
('73063049', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063049'),
('73063049:2X', '--- Ostatné, s vonkajším priemerom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063049:2X'),
('73063049:3X', '---- Nepresahujúcim 168,3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063049:3X'),
('73063072', '----- Pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063072'),
('73063077', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063077'),
('73063080', '---- Presahujúcim 168,3 mm, ale nepresahujúcim 406,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73063080'),
('730640', '- Ostatné, zvárané, kruhového prierezu, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730640'),
('73064020', '-- Ťahané za studena alebo valcované za studena (úberom za studena)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73064020'),
('73064080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73064080'),
('730650', '- Ostatné, zvárané, kruhového prierezu, z ostatnej legovanej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730650'),
('73065020', '-- Presné rúrky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73065020'),
('73065080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73065080'),
('73065080:2X', '- Ostatné, zvárané, s prierezom iným ako kruhovým', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73065080:2X'),
('730661', '-- So štvorcovým alebo pravouhlým prierezom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730661'),
('73066110', '--- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73066110'),
('73066110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73066110:2X'),
('73066192', '---- S hrúbkou steny nepresahujúcou 2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73066192'),
('73066199', '---- S hrúbkou steny presahujúcou 2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73066199'),
('730669', '-- S iným prierezom ako kruhovým', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730669'),
('73066910', '--- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73066910'),
('73066990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73066990'),
('73069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73069000'),
('7307', 'Príslušenstvo na rúry alebo rúrky (napríklad spojky, kolená, nátrubky), zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7307'),
('7307:2X', '- Liate príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7307:2X'),
('730711', '-- Z nekujnej liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730711'),
('73071110', '--- Druhov vhodných na tlakové systémy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73071110'),
('73071190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73071190'),
('730719', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730719'),
('73071910', '--- Z kujnej liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73071910'),
('73071990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73071990'),
('73071990:2X', '- Ostatné, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73071990:2X'),
('73072100', '-- Príruby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73072100'),
('730722', '-- Kolená, ohyby a nátrubky, so závitom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730722'),
('73072210', '--- Nátrubky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73072210'),
('73072290', '--- Kolená a ohyby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73072290'),
('730723', '-- Príslušenstvo na zváranie na tupo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730723'),
('73072310', '--- Kolená a ohyby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73072310'),
('73072390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73072390'),
('730729', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730729'),
('73072910', '--- So závitom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73072910'),
('73072980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73072980'),
('73072980:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73072980:2X'),
('73079100', '-- Príruby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079100'),
('730792', '-- Kolená, ohyby a nátrubky, so závitom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730792'),
('73079210', '--- Nátrubky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079210'),
('73079290', '--- Kolená a ohyby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079290'),
('730793', '-- Príslušenstvo na zváranie na tupo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730793'),
('730793:2X', '--- S najväčším vonkajším priemerom nepresahujúcim 609,6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730793:2X'),
('73079311', '---- Kolená a ohyby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079311'),
('73079319', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079319'),
('73079319:2X', '--- S najväčším vonkajším priemerom presahujúcim 609,6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079319:2X'),
('73079391', '---- Kolená a ohyby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079391'),
('73079399', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079399'),
('730799', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730799'),
('73079910', '--- So závitom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079910'),
('73079980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73079980'),
('7308', 'Konštrukcie (okrem montovaných stavieb položky 9406) a časti konštrukcií (napríklad mosty, časti mostov, stavidlá, veže, stožiare, stĺpy, piliere, strechy a strešné rámové konštrukcie, dvere a okná a ich rámy, prahy dverí, okenice, stĺpkové zábradlie),', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7308'),
('73081000', '- Mosty a časti mostov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73081000'),
('73082000', '- Veže, stožiare, stĺpy, piliere', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73082000'),
('73083000', '- Dvere, okná a ich rámy a prahy dverí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73083000'),
('73084000', '- Zariadenie na lešenie, debnenie, vzpery alebo výstuže do baní', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73084000'),
('730890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730890'),
('730890:2X', '-- Výhradne alebo hlavne z plechu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730890:2X'),
('73089051', '--- Panely pozostávajúce z dvoch stien profilového (rebrovaného) plechu s izolačnou výplňou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73089051'),
('73089059', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73089059'),
('73089098', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73089098'),
('730900', 'Nádrže, cisterny, dieže a podobné zásobníky na akýkoľvek materiál (okrem stlačeného alebo skvapalneného plynu), zo železa alebo ocele, s objemom presahujúcim 300 l, tiež s vnútorným obložením alebo tepelnou izoláciou, ale bez mechanického alebo tepelnéh', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_730900'),
('73090010', '- Na plyny (iné ako stlačené alebo skvapalnené plyny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73090010'),
('73090010:2X', '- Na kvapaliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73090010:2X'),
('73090030', '-- S vnútorným obložením alebo tepelne izolované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73090030'),
('73090030:2X', '-- Ostatné, s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73090030:2X'),
('73090051', '--- Presahujúcim 100 000 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73090051'),
('73090059', '--- Nepresahujúcim 100 000 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73090059'),
('73090090', '- Na pevné látky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73090090'),
('7310', 'Cisterny, sudy, bubny, kade, plechovky, škatule a podobné zásobníky, na akýkoľvek materiál (okrem stlačeného alebo skvapalneného plynu) zo železa alebo ocele, s objemom nepresahujúcim 300 l, tiež s vnútorným obložením alebo tepelnou izoláciou, ale bez m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7310'),
('73101000', '- S objemom 50 l alebo väčším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73101000'),
('73101000:2X', '- S objemom menším ako 50 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73101000:2X'),
('731021', '-- Plechovky uzavierané spájkovaním alebo lemovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731021'),
('73102111', '--- Plechovky určené na konzervovanie potravín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73102111'),
('73102119', '--- Plechovky určené na konzervovanie nápojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73102119'),
('73102119:2X', '--- Ostatné, z plechov alebo fólií s hrúbkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73102119:2X'),
('73102191', '---- Menšou ako 0,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73102191'),
('73102199', '---- 0,5 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73102199'),
('731029', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731029'),
('73102910', '--- Z plechov alebo z fólií s hrúbkou menšou ako 0,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73102910'),
('73102990', '--- Z plechov alebo z fólií s hrúbkou 0,5 mm alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73102990'),
('731100', 'Tlakové nádoby na stlačený alebo skvapalnený plyn, zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731100'),
('731100:2X', '- Bezšvové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731100:2X'),
('731100:3X', '-- Pre tlak 165 a viac barov s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731100:3X'),
('73110011', '--- Menším ako 20 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73110011'),
('73110013', '--- 20 l alebo väčším, ale nepresahujúcim 50 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73110013'),
('73110019', '--- Presahujúcim 50 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73110019'),
('73110030', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73110030'),
('73110030:2X', '- Ostatné, s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73110030:2X'),
('73110091', '-- Menším ako 1 000 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73110091'),
('73110099', '-- 1 000 l alebo väčším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73110099'),
('7312', 'Splietané lanká, laná, káble, splietané pásy, slučky a podobné výrobky zo železa alebo ocele, elektricky neizolované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7312'),
('731210', '- Splietané lanká, laná a káble', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731210'),
('73121020', '-- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121020'),
('73121020:2X', '-- Ostatné, s maximálnym prierezovým rozmerom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121020:2X'),
('73121020:3X', '--- Nepresahujúcim 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121020:3X'),
('73121041', '---- Pokovované alebo potiahnuté medeno-zinkovými zliatinami (mosadzou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121041'),
('73121049', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121049'),
('73121049:2X', '--- Presahujúcim 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121049:2X'),
('73121049:3X', '---- Splietané lanká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121049:3X'),
('73121061', '----- Bez povrchovej úpravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121061'),
('73121061:2X', '----- Povrchovo upravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121061:2X'),
('73121065', '------ Pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121065'),
('73121069', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121069'),
('73121069:2X', '---- Laná a káble (vrátane uzavretých lán)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121069:2X'),
('73121069:3X', '----- Nepotiahnuté alebo len pokovované alebo potiahnuté zinkom, s maximálnym rozmerom prierezu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121069:3X'),
('73121081', '------ Presahujúcim 3 mm, ale nepresahujúcim 12 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121081'),
('73121083', '------ Presahujúcim 12 mm, ale nepresahujúcim 24 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121083'),
('73121085', '------ Presahujúcim 24 mm, ale nepresahujúcim 48 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121085'),
('73121089', '------ Presahujúcim 48 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121089'),
('73121098', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73121098'),
('73129000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73129000'),
('73130000', 'Ostnatý drôt zo železa alebo ocele; krútený guľatý drôt alebo jednoduchý plochý drôt, tiež s ostňami a voľne krútený dvojitý drôt druhov, používaných na oplotenie, zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73130000'),
('7314', 'Tkaniny (vrátane nekonečných pásov), rošty, sieťovina a pletivo, zo železného alebo oceľového drôtu; plechová mriežkovina zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7314'),
('7314:2X', '- Tkaniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7314:2X'),
('73141200', '-- Nekonečné pásy pre stroje, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73141200'),
('73141400', '-- Ostatné tkaniny, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73141400'),
('73141900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73141900'),
('731420', '- Rošty, sieťovina a pletivo, zvárané v miestach križovania drôtov, z drôtu s maximálnym rozmerom prierezu 3 mm alebo väčším a s veľkosťou ôk 100 cm2 alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731420'),
('73142010', '-- Z rebrovaného drôtu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73142010'),
('73142090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73142090'),
('73142090:2X', '- Ostatné rošty, sieťovina a pletivo, zvárané v miestach križovania drôtov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73142090:2X'),
('73143100', '-- Pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73143100'),
('73143900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73143900'),
('73143900:2X', '- Ostatné tkaniny, rošty, sieťovina a pletivo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73143900:2X'),
('73144100', '-- Pokovované alebo potiahnuté zinkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73144100'),
('73144200', '-- Potiahnuté plastmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73144200'),
('73144900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73144900'),
('73145000', '- Plechová mriežkovina', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73145000'),
('7315', 'Reťaze a ich časti, zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7315'),
('7315:2X', '- Kĺbové reťaze a ich časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7315:2X'),
('731511', '-- Valčekové reťaze', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731511'),
('73151110', '--- Druhy používané na bicykle a motocykle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73151110'),
('73151190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73151190'),
('73151200', '-- Ostatné reťaze', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73151200'),
('73151900', '-- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73151900'),
('73152000', '- Protišmykové reťaze', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73152000'),
('73152000:2X', '- Ostatné reťaze', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73152000:2X'),
('73158100', '-- Článkové reťaze a reťaze s mostíkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73158100'),
('73158200', '-- Ostatné reťaze a reťaze so zváranými článkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73158200'),
('73158900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73158900'),
('73159000', '- Ostatné časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73159000'),
('73160000', 'Kotvy, lodné háky a ich časti, zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73160000'),
('731700', 'Klince, cvočky, pripináčiky, spony vlnité aj skosené, svorky, sponky (okrem patriacich do položky 8305) a podobné výrobky, zo železa alebo ocele, tiež s hlavičkou z ostatného materiálu, okrem výrobkov s hlavičkami z medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731700'),
('731700:2X', '- Lisované z drôtu za studena', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731700:2X'),
('73170020', '-- Klince v pruhoch alebo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73170020'),
('73170060', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73170060'),
('73170080', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73170080'),
('7318', 'Skrutky, svorníky (skrutky s maticou), matice, vrtule (do podvalov), skrutky s hákom, nity, priečne kliny, závlačky, podložky (vrátane pružných) a podobné výrobky, zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7318'),
('7318:2X', '- Výrobky so závitmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7318:2X'),
('73181100', '-- Vrtule (do podvalov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181100'),
('731812', '-- Ostatné skrutky do dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731812'),
('73181210', '--- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181210'),
('73181290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181290'),
('73181300', '-- Skrutky s hákom a skrutky s okom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181300'),
('731814', '-- Samorezné skrutky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731814'),
('73181410', '--- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181410'),
('73181410:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181410:2X'),
('73181491', '---- Skrutky s priestorovým závitom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181491'),
('73181499', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181499'),
('731815', '-- Ostatné skrutky a svorníky, tiež s maticami alebo podložkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731815'),
('73181510', '--- Skrutky sústružené z tyčí, prútov a profilov alebo z drôtov s hrúbkou drieku v pevnej časti nepresahujúcou 6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181510'),
('73181510:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181510:2X'),
('73181520', '---- Na upevňovanie konštrukčných materiálov železničných tratí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181520'),
('73181520:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181520:2X'),
('73181520:3X', '----- Bez hlavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181520:3X'),
('73181530', '------ Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181530'),
('73181530:2X', '------ Ostatné, s pevnosťou v ťahu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181530:2X'),
('73181541', '------- Menšou ako 800 MPa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181541'),
('73181549', '------- 800 MPa alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181549'),
('73181549:2X', '----- S hlavou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181549:2X'),
('73181549:3X', '------ Skrutky so zárezom a priečnym vybraním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181549:3X'),
('73181551', '------- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181551'),
('73181559', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181559'),
('73181559:2X', '------ Skrutky s vnútorným šesťhranom v hlave (imbusové skrutky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181559:2X'),
('73181561', '------- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181561'),
('73181569', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181569'),
('73181569:2X', '------ Skrutky so šesťhrannou hlavou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181569:2X'),
('73181570', '------- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181570'),
('73181570:2X', '------- Ostatné, s pevnosťou v ťahu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181570:2X'),
('73181581', '-------- Menšou ako 800 MPa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181581'),
('73181589', '-------- 800 MPa alebo väčšou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181589'),
('73181590', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181590'),
('731816', '-- Matice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731816'),
('73181610', '--- Sústružené z tyčí, prútov, profilov alebo drôtov, s otvorom v pevnej časti nepresahujúcim 6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181610'),
('73181610:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181610:2X'),
('73181630', '---- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181630'),
('73181630:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181630:2X'),
('73181650', '----- Samosvorné matice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181650'),
('73181650:2X', '----- Ostatné, s vnútorným priemerom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181650:2X'),
('73181691', '------ Nepresahujúcim 12 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181691'),
('73181699', '------ Presahujúcim 12 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181699'),
('73181900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181900'),
('73181900:2X', '- Výrobky bez závitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73181900:2X'),
('73182100', '-- Pružné podložky a ostatné poistné podložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73182100'),
('73182200', '-- Ostatné podložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73182200'),
('73182300', '-- Nity', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73182300'),
('73182400', '-- Závlačky a priečne kliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73182400'),
('73182900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73182900'),
('7319', 'Šijacie ihly, pletacie ihlice, šnurovacie ihly, háčiky, bodce na vyšívanie a podobné výrobky, určené na ručné práce, zo železa alebo ocele; zatváracie a ostatné špendlíky, zo železa alebo ocele, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7319'),
('73194000', '- Zatváracie špendlíky a ostatné špendlíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73194000'),
('731990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_731990'),
('73199010', '-- Šijacie, plátacie alebo vyšívacie ihly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73199010'),
('73199090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73199090'),
('7320', 'Pružiny a listy pružín, zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7320'),
('732010', '- Listové pružiny a ich listy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_732010'),
('732010:2X', '-- Spracované za tepla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_732010:2X'),
('73201011', '--- Listové pružiny a ich listy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73201011'),
('73201019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73201019'),
('73201090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73201090'),
('732020', '- Skrutkové (špirálové) pružiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_732020'),
('73202020', '-- Spracované za tepla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73202020'),
('73202020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73202020:2X'),
('73202081', '--- Špirálové tlačné pružiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73202081'),
('73202085', '--- Špirálové ťažné pružiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73202085'),
('73202089', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73202089'),
('732090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_732090'),
('73209010', '-- Ploché špirálové pružiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73209010'),
('73209030', '-- Diskové pružiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73209030'),
('73209090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73209090'),
('7321', 'Kachle, kotly s ohniskom, sporáky, kozuby (tiež s pomocnými kotlíkmi na ústredné kúrenie), ražne, koksové koše, plynové variče, ohrievače tanierov a podobné neelektrické výrobky, používané v domácnostiach, ich časti a súčasti, zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7321'),
('7321:2X', '- Zariadenia na prípravu stravy a ohrievače tanierov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7321:2X'),
('732111', '-- Na plynné palivo alebo na plyn a súčasne ostatné palivo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_732111'),
('73211110', '--- S kúreniskom, vrátane samostatných kúrenísk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73211110'),
('73211190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73211190'),
('73211200', '-- Na kvapalné palivá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73211200'),
('73211900', '-- Ostatné, vrátane zariadení na pevné palivá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73211900'),
('73211900:2X', '- Ostatné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73211900:2X'),
('73218100', '-- Na plynné palivo alebo na plyn a súčasne ostatné palivo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73218100'),
('73218200', '-- Na kvapalné palivá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73218200'),
('73218900', '-- Ostatné, vrátane zariadení na pevné palivá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73218900'),
('73219000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73219000'),
('7322', 'Radiátory ústredného kúrenia, vykurované neelektricky, a ich časti a súčasti, zo železa alebo ocele; ohrievače vzduchu a rozvádzače horúceho vzduchu (vrátane rozvádzačov, ktoré môžu distribuovať čerstvý alebo upravený vzduch), elektricky nevykurované, s', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7322'),
('7322:2X', '- Radiátory a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7322:2X'),
('73221100', '-- Z liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73221100'),
('73221900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73221900'),
('73229000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73229000'),
('7323', 'Výrobky na stolovanie, kuchynské alebo ostatné výrobky pre domácnosť a ich časti a súčasti, zo železa alebo ocele; vlna zo železa alebo ocele; drôtiky na čistenie riadu a drôtené vankúšiky na čistenie alebo leštenie, rukavice a podobné výrobky zo železa', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7323'),
('73231000', '- Vlna zo železa alebo ocele; drôtiky na čistenie riadu a drôtené vankúšiky na čistenie alebo leštenie, rukavice a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73231000'),
('73231000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73231000:2X'),
('73239100', '-- Z liatiny, nesmaltované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73239100'),
('73239200', '-- Z liatiny, smaltované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73239200'),
('73239300', '-- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73239300'),
('73239400', '-- Zo železa (okrem liatiny) alebo ocele, smaltované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73239400'),
('73239900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73239900'),
('7324', 'Sanitárny tovar a jeho časti a súčasti, zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7324'),
('73241000', '- Výlevky, umývadlá a drezy, z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73241000'),
('73241000:2X', '- Vane', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73241000:2X'),
('73242100', '-- Z liatiny, tiež smaltované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73242100'),
('73242900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73242900'),
('73249000', '- Ostatné, vrátane častí a súčastí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73249000'),
('7325', 'Ostatné liate výrobky zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7325'),
('732510', '- Z nekujnej liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_732510'),
('73251050', '-- Padacie poklopy a telesá ventilov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_73251050'),
('73251050:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73251050:2X'),
('73251092', '--- Výrobky na splaškové, vodné a podobné systémy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73251092'),
('73251099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73251099'),
('73251099:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73251099:2X'),
('73259100', '-- Mlecie gule a podobné výrobky do drvičov a mlynov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73259100'),
('732599', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_732599'),
('73259910', '--- Z kujnej liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73259910'),
('73259990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73259990'),
('7326', 'Ostatné výrobky zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7326'),
('7326:2X', '- Kované alebo razené, ale ďalej nespracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7326:2X'),
('73261100', '-- Mlecie gule a podobné výrobky do drvičov a mlynov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73261100'),
('732619', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_732619'),
('73261910', '--- Kované v otvorenej zápustke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73261910'),
('73261990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73261990'),
('73262000', '- Výrobky zo železného alebo oceľového drôtu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73262000'),
('732690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_732690'),
('73269030', '-- Rebríky a schody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73269030'),
('73269040', '-- Palety a podobné plošiny na manipuláciu s tovarom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73269040'),
('73269050', '-- Bubny a cievky na káble, hadice a podobne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73269050'),
('73269060', '-- Nemechanické vetráky, žľaby, háky a podobné výrobky používané v stavebnom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73269060'),
('73269060:2X', '-- Ostatné výrobky zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73269060:2X'),
('73269092', '--- Kované v otvorenej zápustke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73269092'),
('73269094', '--- Kované v uzatvorenej zápustke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73269094'),
('73269096', '--- Sintrované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73269096'),
('73269098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_73269098'),
('74010000', 'Medený kamienok (medený lech); cementová meď (zrážaná meď)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74010000'),
('74020000', 'Nerafinovaná meď; medené anódy na elektrolytickú rafináciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74020000'),
('7403', 'Rafinovaná meď a zliatiny medi, surové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7403'),
('7403:2X', '- Rafinovaná meď', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7403:2X'),
('74031100', '-- Katódy a časti katód', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74031100'),
('74031200', '-- Predliatky na valcovanie drôtu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74031200'),
('74031300', '-- Predliatky (sochory)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74031300'),
('74031900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74031900'),
('74031900:2X', '- Zliatiny medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74031900:2X'),
('74032100', '-- Zliatiny na základe medi a zinku (mosadze)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74032100'),
('74032200', '-- Zliatiny na základe medi a cínu (bronz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74032200'),
('74032900', '-- Ostatné zliatiny medi (okrem predzliatin položky 7405)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74032900'),
('740400', 'Medený odpad a medený šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_740400'),
('74040010', '- Z rafinovanej medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74040010'),
('74040010:2X', '- Zo zliatin medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74040010:2X'),
('74040091', '-- Zo zliatin na základe medi a zinku (mosadz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74040091'),
('74040099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74040099'),
('74050000', 'Predzliatiny medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74050000'),
('7406', 'Medený prášok a medené šupiny (vločky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7406'),
('74061000', '- Prášok s nelamelárnou štruktúrou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74061000'),
('74062000', '- Prášok s lamelárnou štruktúrou; vločky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74062000'),
('7407', 'Medené tyče, prúty a profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7407'),
('74071000', '- Z rafinovanej medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74071000'),
('74071000:2X', '- Zo zliatin medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74071000:2X'),
('740721', '-- Zo zliatin na základe medi a zinku (mosadz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_740721'),
('74072110', '--- Tyče a prúty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74072110'),
('74072190', '--- Profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74072190'),
('74072900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74072900'),
('7408', 'Medené drôty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7408'),
('7408:2X', '- Z rafinovanej medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7408:2X'),
('74081100', '-- S prierezom, ktorého maximálny rozmer presahuje 6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74081100'),
('740819', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_740819'),
('74081910', '--- S prierezom ktorého maximálny rozmer presahuje 0,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74081910'),
('74081990', '--- S prierezom ktorého maximálny rozmer nepresahuje 0,5 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74081990'),
('74081990:2X', '- Zo zliatin medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74081990:2X'),
('74082100', '-- Zo zliatin na základe medi a zinku (mosadz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74082100'),
('74082200', '-- Zo zliatin na základe medi a niklu (kupronikel) alebo zliatin na základe medi, niklu a zinku (niklová mosadz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74082200'),
('74082900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74082900'),
('7409', 'Medené dosky, plechy a pásy, s hrúbkou presahujúcou 0,15 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7409'),
('7409:2X', '- Z rafinovanej medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7409:2X'),
('74091100', '-- Vo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74091100'),
('74091900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74091900'),
('74091900:2X', '- Zo zliatin na základe medi a zinku (mosadz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74091900:2X'),
('74092100', '-- Vo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74092100'),
('74092900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74092900'),
('74092900:2X', '- Zo zliatin na základe medi a cínu (bronz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74092900:2X'),
('74093100', '-- Vo zvitkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74093100'),
('74093900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74093900'),
('74094000', '- Zo zliatin na základe medi a niklu (kupronikel) alebo zliatin na základe medi, niklu a zinku (niklová mosadz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74094000'),
('74099000', '- Z ostatných zliatin medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74099000'),
('7410', 'Medené fólie (tiež potlačené alebo podložené papierom, lepenkou, plastmi alebo podobnými podkladovými materiálmi) s hrúbkou (bez podložky) nepresahujúcou 0,15 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7410'),
('7410:2X', '- Bez podložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7410:2X'),
('74101100', '-- Z rafinovanej medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74101100'),
('74101200', '-- Zo zliatin medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74101200'),
('74101200:2X', '- Na podložke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74101200:2X'),
('74102100', '-- Z rafinovanej medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74102100'),
('74102200', '-- Zo zliatin medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74102200'),
('7411', 'Medené rúry a rúrky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7411'),
('741110', '- Z rafinovanej medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_741110'),
('74111010', '-- Rovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74111010'),
('74111090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74111090'),
('74111090:2X', '- Zo zliatin medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74111090:2X'),
('741121', '-- Zo zliatin na základe medi a zinku (mosadz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_741121'),
('74112110', '--- Rovné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74112110'),
('74112190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74112190'),
('74112200', '-- Zo zliatin na základe medi a niklu (kupronikel) alebo zo zliatin na základe medi, niklu a zinku (niklová mosadz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74112200'),
('74112900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74112900'),
('7412', 'Medené príslušenstvo k rúram a rúrkam (napríklad spojky, kolená, nátrubky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7412'),
('74121000', '- Z rafinovanej medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74121000'),
('74122000', '- Zo zliatin medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74122000'),
('74130000', 'Medené splietané lanká, káble, splietané pásy a podobné výrobky, elektricky neizolované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74130000'),
('7415', 'Klince, cvočky, pripináčiky, skoby, sponky (okrem výrobkov položky 8305) a podobné predmety, z medi alebo železa alebo ocele s medenými hlavičkami; skrutky, svorníky, matice, háčiky so závitom, nity, závlačky, priečne kliny, podložky (vrátane pružných p', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7415'),
('74151000', '- Klince a cvočky, pripináčiky, skoby a podobné predmety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74151000'),
('74151000:2X', '- Ostatné predmety, bez závitu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74151000:2X'),
('74152100', '-- Podložky (vrátane pružných podložiek)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74152100'),
('74152900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74152900'),
('74152900:2X', '- Ostatné predmety so závitom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74152900:2X'),
('74153300', '-- Skrutky; svorníky a matice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74153300'),
('74153900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74153900'),
('7418', 'Stolové, kuchynské alebo ostatné predmety pre domácnosť a ich časti a súčasti, z medi; drôtiky na čistenie riadu a drôtené vankúšiky na čistenie a leštenie, rukavice a podobné predmety, z medi; sanitárny tovar a jeho časti a súčasti, z medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7418'),
('741810', '- Stolové, kuchynské alebo ostatné predmety pre domácnosť a ich časti a súčasti; drôtiky na čistenie riadu a drôtené vankúšiky na čistenie alebo leštenie, rukavice a podobné predmety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_741810'),
('74181010', '-- Zariadenia na varenie alebo kúrenie druhov používaných na domáce účely, neelektrické, ich časti a súčasti, z medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74181010'),
('74181090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74181090'),
('74182000', '- Sanitárny tovar a jeho časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74182000'),
('7419', 'Ostatné predmety z medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7419'),
('74191000', '- Reťaze, ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74191000'),
('74191000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74191000:2X'),
('74199100', '-- Liate, tvarované, razené alebo kované, ďalej však neopracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74199100'),
('741999', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_741999'),
('74199910', '--- Tkaniny (vrátane nekonečných pásov), rošty a sieťovina, z drôtu, ktorého žiaden rozmer v priereze nepresahuje 6 mm; plechová mriežkovina z medi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74199910'),
('74199930', '--- Medené pružiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74199930'),
('74199990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_74199990'),
('7501', 'Niklový kamienok (lech), spekaný oxid nikelnatý a ostatné medziprodukty metalurgie niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7501'),
('75011000', '- Niklový kamienok (lech)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75011000'),
('75012000', '- Spekaný oxid nikelnatý a ostatné medziprodukty metalurgie niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75012000'),
('7502', 'Surový nikel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7502'),
('75021000', '- Nelegovaný nikel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75021000'),
('75022000', '- Zliatiny niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75022000'),
('750300', 'Niklový odpad a niklový šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_750300'),
('75030010', '- Z nelegovaného niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75030010'),
('75030090', '- Zo zliatin niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75030090'),
('75040000', 'Niklový prášok a niklové vločky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75040000'),
('7505', 'Niklové tyče, prúty, profily a drôty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7505'),
('7505:2X', '- Tyče, prúty a profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7505:2X'),
('75051100', '-- Z nelegovaného niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75051100'),
('75051200', '-- Zo zliatin niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75051200'),
('75051200:2X', '- Drôty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75051200:2X'),
('75052100', '-- Z nelegovaného niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75052100'),
('75052200', '-- Zo zliatin niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75052200'),
('7506', 'Niklové dosky, plechy, pásy a fólie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7506'),
('75061000', '- Z nelegovaného niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75061000'),
('75062000', '- Zo zliatin niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75062000'),
('7507', 'Niklové rúry, rúrky a príslušenstvo k nim (napríklad spojky, kolená, nátrubky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7507'),
('7507:2X', '- Rúry a rúrky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7507:2X'),
('75071100', '-- Z nelegovaného niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75071100'),
('75071200', '-- Zo zliatin niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75071200'),
('75072000', '- Príslušenstvo k rúram a rúrkam', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75072000'),
('7508', 'Ostatné predmety z niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7508'),
('75081000', '- Tkaniny, mriežky a sieťovina, z niklového drôtu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75081000'),
('75089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_75089000'),
('7601', 'Surový hliník', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7601'),
('76011000', '- Nelegovaný hliník', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76011000'),
('760120', '- Zliatiny hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760120'),
('76012010', '-- Primárne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76012010'),
('76012010:2X', '-- Sekundárne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76012010:2X'),
('76012091', '--- V ingotoch alebo kvapalnom stave', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76012091'),
('76012099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76012099'),
('760200', 'Hliníkový odpad a hliníkový šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760200'),
('760200:2X', '- Odpad', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760200:2X'),
('76020011', '-- Zo sústruženia, obrážania, brúsenia, frézovania, piliny z rezania a pilovania; odpady z farebných, povrchovo upravených alebo lepených plechov a fólií s hrúbkou nepresahujúcou 0,2 mm (bez podložky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76020011'),
('76020019', '-- Ostatné (vrátane továrenských nepodarkov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76020019'),
('76020090', '- Šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76020090'),
('7603', 'Hliníkový prášok a hliníkové vločky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7603'),
('76031000', '- Prášok s nelamelárnou štruktúrou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76031000'),
('76032000', '- Prášok s lamelárnou štruktúrou; vločky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76032000'),
('7604', 'Hliníkové tyče, prúty a profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7604'),
('760410', '- Z nelegovaného hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760410'),
('76041010', '-- Tyče a prúty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76041010'),
('76041090', '-- Profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76041090'),
('76041090:2X', '- Zo zliatin hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76041090:2X'),
('76042100', '-- Duté profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76042100'),
('760429', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760429'),
('76042910', '--- Tyče a prúty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76042910'),
('76042990', '--- Profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76042990'),
('7605', 'Hliníkové drôty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7605'),
('7605:2X', '- Z nelegovaného hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7605:2X'),
('76051100', '-- S maximálnym prierezom presahujúcim 7 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76051100'),
('76051900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76051900'),
('76051900:2X', '- Zo zliatin hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76051900:2X'),
('76052100', '-- S maximálnym prierezom presahujúcim 7 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76052100'),
('76052900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76052900'),
('7606', 'Hliníkové dosky, plechy a pásy, s hrúbkou presahujúcou 0,2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7606'),
('7606:2X', '- Pravouhlé (vrátane štvorcových)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7606:2X'),
('760611', '-- Z nelegovaného hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760611'),
('76061110', '--- Farbené, lakované alebo potiahnuté plastmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061110'),
('76061110:2X', '--- Ostatné s hrúbkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061110:2X'),
('76061191', '---- Menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061191'),
('76061193', '---- Nie menšou ako 3 mm, ale menšou ako 6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061193'),
('76061199', '---- Nie menšou ako 6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061199'),
('760612', '-- Zo zliatin hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760612'),
('76061220', '--- Farbené, lakované alebo potiahnuté plastmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061220'),
('76061220:2X', '--- Ostatné s hrúbkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061220:2X'),
('76061292', '---- Menšou ako 3 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061292'),
('76061293', '---- Nie menšou ako 3 mm, ale menšou ako 6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061293'),
('76061299', '---- Nie menšou ako 6 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061299'),
('76061299:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76061299:2X'),
('76069100', '-- Z nelegovaného hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76069100'),
('76069200', '-- Zo zliatin hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76069200'),
('7607', 'Hliníkové fólie (tiež potlačené alebo podložené papierom, lepenkou, plastmi alebo podobnými podkladovými materiálmi) s hrúbkou (bez podložky) nepresahujúcou 0,2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7607'),
('7607:2X', '- Bez podložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7607:2X'),
('760711', '-- Valcované, ale ďalej neupravené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760711'),
('760711:2X', '--- S hrúbkou menšou ako 0,021 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760711:2X'),
('76071111', '---- Vo zvitkoch s plošnou hmotnosťou nepresahujúcou 10 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76071111'),
('76071119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76071119'),
('76071190', '--- S hrúbkou nie menšou ako 0,021 mm, ale nie väčšou ako 0,2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76071190'),
('760719', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760719'),
('76071910', '--- S hrúbkou menšou ako 0,021 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76071910'),
('76071990', '--- S hrúbkou nie menšou ako 0,021 mm, ale nie väčšou ako 0,2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76071990'),
('760720', '- S podložkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760720'),
('76072010', '-- S hrúbkou menšou ako 0,021 mm (bez podložky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76072010'),
('76072090', '-- S hrúbkou (bez podložky) nie menšou ako 0,021 mm, ale nie väčšou ako 0,2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76072090'),
('7608', 'Hliníkové rúry a rúrky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7608'),
('76081000', '- Z nelegovaného hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76081000'),
('760820', '- Zo zliatin hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_760820'),
('76082020', '-- Zvárané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76082020'),
('76082020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76082020:2X'),
('76082081', '--- Po pretláčaní ďalej neopracované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76082081'),
('76082089', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76082089'),
('76090000', 'Hliníkové príslušenstvo k rúram a rúrkam (napríklad spojky, kolená, nátrubky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76090000'),
('7610', 'Hliníkové konštrukcie (okrem montovaných stavieb položky 9406) a časti konštrukcií, mosty, časti mostov, veže, stožiare, sťažne, stĺpy, piliere, strechy, strešné rámové konštrukcie, dvere, okná a ich rámy, zárubne, dverové prahy, stĺpové zábradlia, pili', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7610'),
('76101000', '- Dvere, okná a ich rámy, prahy do dverí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_76101000'),
('761090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_761090'),
('76109010', '-- Mosty a ich časti, veže a stožiare', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76109010'),
('76109090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76109090'),
('76110000', 'Hliníkové nádrže, cisterny, kade a podobné zásobníky na akýkoľvek materiál (iný ako stlačený alebo skvapalnený plyn), s objemom presahujúcim 300 l, tiež s vnútorným obložením alebo tepelnou izoláciou, ale bez mechanického alebo tepelného zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76110000'),
('7612', 'Hliníkové sudy, barely, plechovky, škatule alebo podobné obaly (vrátane pevných alebo stlačiteľných valcovitých zásobníkov) na akýkoľvek materiál (iný ako stlačený alebo skvapalnený plyn), s objemom nepresahujúcim 300 l, tiež s vnútorným obložením alebo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7612'),
('76121000', '- Stlačiteľné valcovité zásobníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76121000'),
('761290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_761290'),
('76129020', '-- Nádoby druhov používaných na aerosóly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_76129020'),
('76129090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76129090'),
('76130000', 'Hliníkové nádoby na stlačený alebo skvapalnený plyn', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76130000'),
('7614', 'Hliníkové splietané lanká, laná, káble, splietané pásy a podobné výrobky, bez elektrickej izolácie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7614'),
('76141000', '- S oceľovým jadrom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76141000'),
('76149000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76149000'),
('7615', 'Stolové, kuchynské alebo ostatné predmety pre domácnosť a ich časti a súčasti, z hliníka; drôtiky na čistenie riadu a drôtené vankúšiky na čistenie a leštenie, rukavice a podobné predmety, z hliníka; sanitárny tovar a jeho časti a súčasti, z hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7615'),
('761510', '- Stolové, kuchynské alebo ostatné predmety pre domácnosť a ich časti a súčasti; drôtiky na čistenie riadu a drôtené vankúšiky na čistenie alebo leštenie, rukavice a podobné predmety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_761510'),
('76151010', '-- Odlievané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76151010'),
('76151090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76151090'),
('76152000', '- Sanitárny tovar a jeho časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76152000'),
('7616', 'Ostatné predmety z hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7616'),
('76161000', '- Klince, pripináčiky, skoby, sponky (okrem výrobkov položky 8305), skrutky, svorníky, matice, háky so závitom, nity, priečne kliny, závlačky, podložky a podobné predmety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76161000'),
('76161000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76161000:2X'),
('76169100', '-- Tkaniny, mriežky, sieťovina a pletivo z hliníkového drôtu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76169100'),
('761699', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_761699'),
('76169910', '--- Odlievané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76169910'),
('76169990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_76169990'),
('7801', 'Surové olovo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7801'),
('78011000', '- Rafinované olovo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78011000'),
('78011000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78011000:2X'),
('78019100', '-- Obsahujúce v hmotnosti antimón ako hlavný z ostatných prvkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78019100'),
('780199', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_780199'),
('78019910', '--- Na rafináciu, obsahujúce v hmotnosti 0,02 % alebo viac striebra (bullion lead)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78019910'),
('78019990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78019990'),
('78020000', 'Olovený odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78020000'),
('7804', 'Olovené dosky, plechy, pásy a fólie; olovený prášok a vločky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7804'),
('7804:2X', '- Dosky, plechy, pásy a fólie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7804:2X'),
('78041100', '-- Plechy, pásy a fólie s hrúbkou (bez podložky) nepresahujúcou 0,2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78041100'),
('78041900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78041900'),
('78042000', '- Prášok a vločky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78042000'),
('780600', 'Ostatné predmety z olova', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_780600'),
('78060010', '- Kontajnery s olovenou ochrannou vrstvou proti radiácii, na dopravu alebo uskladnenie rádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78060010'),
('78060080', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_78060080'),
('7901', 'Surový zinok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7901'),
('7901:2X', '- Nelegovaný zinok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7901:2X'),
('79011100', '-- Obsahujúci v hmotnosti 99,99 % alebo viac zinku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79011100'),
('790112', '-- Obsahujúci v hmotnosti menej ako 99,99 % zinku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_790112'),
('79011210', '--- Obsahujúci v hmotnosti 99,95 % alebo viac, ale menej ako 99,99 % zinku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79011210'),
('79011230', '--- Obsahujúci v hmotnosti 98,5 % alebo viac, ale menej ako 99,95 % zinku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79011230'),
('79011290', '--- Obsahujúci v hmotnosti 97,5 % alebo viac, ale menej ako 98,5 % zinku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79011290'),
('79012000', '- Zliatiny zinku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79012000'),
('79020000', 'Zinkový odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79020000'),
('7903', 'Zinkový prach, prášok a vločky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_7903'),
('79031000', '- Zinkový prach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79031000'),
('79039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79039000'),
('79040000', 'Zinkové tyče, prúty, profily a drôty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79040000'),
('79050000', 'Zinkové dosky, plechy, pásy a fólie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79050000'),
('79070000', 'Ostatné predmety zo zinku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_79070000'),
('8001', 'Surový cín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8001'),
('80011000', '- Nelegovaný cín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_80011000'),
('80012000', '- Zliatiny cínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_80012000'),
('80020000', 'Cínový odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_80020000'),
('80030000', 'Cínové tyče, prúty, profily a drôty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_80030000'),
('800700', 'Ostatné predmety z cínu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_800700'),
('80070010', '- Dosky, plechy a pásy, s hrúbkou presahujúcou 0,2 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_80070010'),
('80070080', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_80070080'),
('8101', 'Volfrám a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8101'),
('81011000', '- Prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81011000'),
('81011000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81011000:2X'),
('81019400', '-- Surový volfrám, vrátane tyčí a prútov získaných jednoduchým spekaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81019400'),
('81019600', '-- Drôty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81019600'),
('81019700', '-- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81019700'),
('810199', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_810199'),
('81019910', '--- Tyče a prúty, iné ako získané jednoduchým spekaním, profily, dosky, plechy, pásy a fólie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81019910'),
('81019990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81019990'),
('8102', 'Molybdén a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8102'),
('81021000', '- Prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81021000'),
('81021000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81021000:2X'),
('81029400', '-- Surový molybdén, vrátane tyčí a prútov získaných jednoduchým spekaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81029400'),
('81029500', '-- Tyče a prúty, iné ako získané jednoduchým spekaním, profily, dosky, plechy, pásy a fólie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81029500'),
('81029600', '-- Drôty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81029600'),
('81029700', '-- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81029700'),
('81029900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81029900'),
('8103', 'Tantal a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8103'),
('81032000', '- Surový tantal, vrátane tyčí a prútov získaných jednoduchým spekaním; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81032000'),
('81033000', '- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81033000'),
('810390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_810390'),
('81039010', '-- Tyče a prúty, iné ako získané jednoduchým spekaním, profily, drôty, dosky, plechy, pásy a fólie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81039010'),
('81039090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81039090'),
('8104', 'Horčík a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8104'),
('8104:2X', '- Surový horčík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8104:2X'),
('81041100', '-- Obsahujúci najmenej 99,8 % hmotnosti horčíka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81041100'),
('81041900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81041900'),
('81042000', '- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81042000'),
('81043000', '- Piliny, triesky a granuly, triedené podľa veľkosti; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81043000'),
('81049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81049000'),
('8105', 'Kobaltový kamienok (lech) a ostatné medziprodukty metalurgie kobaltu; kobalt a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8105'),
('81052000', '- Kobaltový kamienok (lech) a ostatné medziprodukty metalurgie kobaltu; surový kobalt; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81052000'),
('81053000', '- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81053000'),
('81059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81059000'),
('810600', 'Bizmut a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_810600'),
('81060010', '- Surový bizmut; odpad a šrot; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81060010'),
('81060090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81060090'),
('8107', 'Kadmium a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8107'),
('81072000', '- Surové kadmium; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81072000'),
('81073000', '- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81073000'),
('81079000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81079000'),
('8108', 'Titán a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8108'),
('81082000', '- Surový titán; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81082000'),
('81083000', '- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81083000'),
('810890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_810890'),
('81089030', '-- Tyče, prúty, drôty a profily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81089030'),
('81089050', '-- Dosky, plechy, pásy a fólie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81089050'),
('81089060', '-- Rúry a rúrky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81089060'),
('81089090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81089090'),
('8109', 'Zirkónium a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8109'),
('81092000', '- Surové zirkónium; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81092000'),
('81093000', '- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81093000'),
('81099000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81099000'),
('8110', 'Antimón a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8110'),
('81101000', '- Surový antimón; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81101000'),
('81102000', '- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81102000'),
('81109000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81109000'),
('811100', 'Mangán a predmety z neho, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_811100'),
('811100:2X', '- Surový mangán; odpad a šrot; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_811100:2X'),
('81110011', '-- Surový mangán; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81110011'),
('81110019', '-- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81110019'),
('81110090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81110090'),
('8112', 'Berýlium, chróm, germánium, vanád, gálium, hafnium, indium, niób (columbium), rénium a tálium, a predmety z týchto kovov, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8112'),
('8112:2X', '- Berýlium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8112:2X'),
('81121200', '-- Surové; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81121200'),
('81121300', '-- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81121300'),
('81121900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81121900'),
('81121900:2X', '- Chróm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81121900:2X'),
('811221', '-- Surový; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_811221'),
('81122110', '--- Zliatiny obsahujúce viac ako 10 % hmotnosti niklu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81122110'),
('81122190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81122190'),
('81122200', '-- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81122200'),
('81122900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81122900'),
('81122900:2X', '- Tálium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81122900:2X'),
('81125100', '-- Surové; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81125100'),
('81125200', '-- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81125200'),
('81125900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81125900'),
('81125900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81125900:2X'),
('811292', '-- Surové; odpad a šrot; prášok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_811292'),
('81129210', '--- Hafnium (celtium)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129210'),
('81129210:2X', '--- Niób (columbium); rénium; gálium; indium; vanád; germánium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129210:2X'),
('81129221', '---- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129221'),
('81129221:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129221:2X'),
('81129231', '----- Niób (columbium); rénium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129231'),
('81129281', '----- Indium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129281'),
('81129289', '----- Gálium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129289'),
('81129291', '----- Vanád', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129291'),
('81129295', '----- Germánium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129295'),
('811299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_811299'),
('81129920', '--- Hafnium (celtium); germánium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129920'),
('81129930', '--- Niób (columbium); rénium', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129930'),
('81129970', '--- Gálium; indium; vanád', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81129970'),
('811300', 'Cermety a predmety z nich, vrátane odpadu a šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_811300'),
('81130020', '- Surové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81130020'),
('81130040', '- Odpad a šrot', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81130040'),
('81130090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_81130090'),
('8201', 'Ručné nástroje; rýle, lopaty, čakany, škrabky, motyky, vidly a hrable; sekery, lesné sekáče a podobné nástroje na sekanie; záhradnícke nožnice, prerezávače stromov všetkých druhov; kosy, kosáky, dlhé nože na rezanie sena alebo slamy, nožnice na strihani', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8201'),
('82011000', '- Rýle a lopaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_82011000'),
('82013000', '- Čakany, škrabky, motyky a hrable', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82013000'),
('82014000', '- Sekery, lesné sekáče a podobné nástroje na sekanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82014000'),
('82015000', '- Záhradnícke nožnice a podobné jednou rukou ovládané prerezávače a nožnice (vrátane nožníc na hydinu)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_82015000'),
('82016000', '- Nožnice na pristrihovanie živých plotov, prerezávacie a podobné nožnice ovládané oboma rukami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82016000'),
('82019000', '- Ostatné ručné nástroje druhov používaných v poľnohospodárstve, záhradníctve alebo lesníctve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82019000'),
('8202', 'Ručné píly; pílové listy všetkých druhov (vrátane prerezávacích, drážkovacích alebo neozubených pílových listov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8202'),
('82021000', '- Ručné píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82021000'),
('82022000', '- Listy pásových píl', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82022000'),
('82022000:2X', '- Listy do kotúčových píl (vrátane prerezávacích alebo drážkovacích pílových listov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82022000:2X'),
('82023100', '-- S oceľovou pracovnou časťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82023100'),
('82023900', '-- Ostatné, vrátane častí a súčastí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82023900'),
('82024000', '- Listy reťazových píl', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82024000'),
('82024000:2X', '- Ostatné rezacie listy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82024000:2X'),
('82029100', '-- Rovné rezacie listy, na rezanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82029100'),
('820299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820299'),
('82029920', '--- Na opracovanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82029920'),
('82029980', '--- Na opracovanie ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82029980'),
('8203', 'Pilníky, rašple, kliešte všetkých druhov (vrátane štikacích), pinzety, nožnice na plech, rezače rúr, čapov, dierkovacie kliešte a priebojníky a podobné ručné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8203'),
('82031000', '- Pilníky, rašple a podobné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82031000'),
('82032000', '- Kliešte všetkých druhov (vrátane štikacích), štípacie klieštiky, pinzety a podobné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82032000'),
('82033000', '- Nožnice na plech a podobné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82033000'),
('82034000', '- Rezače rúr, čapov, dierkovacie kliešte a priebojníky a podobné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82034000'),
('8204', 'Ručné maticové a napínacie kľúče (vrátane dynamometrických kľúčov, iné ako vratidlá na závitníky); výmenné kľúčové nástrčné hlavice, tiež s rukoväťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8204'),
('8204:2X', '- Ručné maticové a napínacie kľúče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8204:2X'),
('82041100', '-- Nenastaviteľné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82041100'),
('82041200', '-- Nastaviteľné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82041200'),
('82042000', '- Výmenné hlavice kľúčov nástrčkových, tiež s rukoväťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82042000'),
('8205', 'Ručné nástroje (vrátane sklenárskych diamantov), inde nešpecifikované ani nezahrnuté; spájkovacie lampy; zveráky, úpinky a podobné nástroje, iné ako príslušenstvo, časti a súčasti obrábacích strojov; nákovy; prenosné vyhne; ručne alebo pedálmi ovládané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8205'),
('82051000', '- Nástroje na vŕtanie a nástroje na rezanie vonkajších alebo vnútorných závitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82051000'),
('82052000', '- Kladivá a mlaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82052000'),
('82053000', '- Hoblíky, dláta, žliabkové (duté) dláta a podobné rezacie nástroje používané na opracovanie dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82053000'),
('82054000', '- Skrutkovače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82054000'),
('82054000:2X', '- Ostatné ručné nástroje (vrátane sklenárskych vsadených diamantov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82054000:2X'),
('82055100', '-- Nástroje používané v domácnosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82055100'),
('820559', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820559'),
('82055910', '--- Náradie pre murárov, formovačov, betonárov, štukatérov a natieračov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82055910'),
('82055980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82055980'),
('82056000', '- Spájkovacie lampy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82056000'),
('82057000', '- Zveráky, úpinky a podobné náradie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82057000'),
('820590', '- Ostatné, vrátane súpravy nástrojov z dvoch alebo viacerých podpoložiek tejto položky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820590'),
('82059010', '-- Nákovy; prenosné vyhne; ručne alebo pedálmi ovládané brúsne kotúče s rámovou konštrukciou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82059010'),
('82059090', '-- Súpravy nástrojov z dvoch alebo viacerých podpoložiek tejto položky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82059090'),
('82060000', 'Dva alebo niekoľko nástrojov položiek 8202 až 8205, zostavené do súprav na predaj v malom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82060000'),
('8207', 'Vymeniteľné nástroje na ručné náradie, tiež mechanicky poháňané alebo na obrábacie stroje (napríklad na lisovanie, razenie, dierovanie, rezanie vonkajších a vnútorných závitov, vŕtanie, vyvŕtavanie, preťahovanie, frézovanie, sústruženie alebo upevňovani', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8207'),
('8207:2X', '- Nástroje na vŕtanie skál alebo zemnú sondáž', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8207:2X'),
('82071300', '-- S pracovnou časťou z cermetov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82071300'),
('820719', '-- Ostatné, vrátane častí a súčastí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820719'),
('82071910', '--- S pracovnou časťou z diamantu alebo aglomerovaného diamantu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82071910'),
('82071990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82071990'),
('820720', '- Zápustky na ťahanie alebo vytláčanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820720'),
('82072010', '-- S pracovnou časťou z diamantu alebo aglomerovaného diamantu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82072010'),
('82072090', '-- S pracovnou časťou z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82072090'),
('820730', '- Nástroje na lisovanie, razenie alebo dierovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820730'),
('82073010', '-- Na obrábanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82073010'),
('82073090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82073090'),
('820740', '- Nástroje na rezanie vnútorných alebo vonkajších závitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820740'),
('820740:2X', '-- Na obrábanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820740:2X'),
('82074010', '--- Nástroje na rezanie vnútorných závitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82074010'),
('82074030', '--- Nástroje na rezanie vonkajších závitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82074030'),
('82074090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82074090'),
('820750', '- Nástroje na vŕtanie, iné ako na vŕtanie skál', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820750'),
('82075010', '-- S pracovnou časťou z diamantu alebo aglomerovaného diamantu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82075010'),
('82075010:2X', '-- S pracovnou časťou z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82075010:2X'),
('82075030', '--- Vrtáky do muriva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82075030'),
('82075030:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82075030:2X'),
('82075030:3X', '---- Na obrábanie kovov s pracovnou časťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82075030:3X'),
('82075050', '----- Z cermetov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82075050'),
('82075060', '----- Z rýchloreznej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82075060'),
('82075070', '----- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82075070'),
('82075090', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82075090'),
('820760', '- Nástroje na vyvrtávanie alebo preťahovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820760'),
('82076010', '-- S pracovnou časťou z diamantu alebo aglomerovaného diamantu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82076010'),
('82076010:2X', '-- S pracovnou časťou z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82076010:2X'),
('82076010:3X', '--- Nástroje na vyvŕtavanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82076010:3X'),
('82076030', '---- Na obrábanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82076030'),
('82076050', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82076050'),
('82076050:2X', '--- Nástroje na preťahovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82076050:2X'),
('82076070', '---- Na obrábanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82076070'),
('82076090', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82076090'),
('820770', '- Nástroje na frézovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820770'),
('820770:2X', '-- Na obrábanie kovov s pracovnou časťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820770:2X'),
('82077010', '--- Z cermetov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82077010'),
('82077010:2X', '--- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82077010:2X'),
('82077031', '---- So stopkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82077031'),
('82077037', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82077037'),
('82077090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82077090'),
('820780', '- Nástroje na sústruženie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820780'),
('820780:2X', '-- Na obrábanie kovov s pracovnou časťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820780:2X'),
('82078011', '--- Z cermetov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82078011'),
('82078019', '--- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82078019'),
('82078090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82078090'),
('820790', '- Ostatné vymeniteľné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820790'),
('82079010', '-- S pracovnou časťou z diamantu alebo aglomerovaného diamantu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079010'),
('82079010:2X', '-- S pracovnou časťou z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079010:2X'),
('82079030', '--- Nástavce skrutkovačov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079030'),
('82079050', '--- Nástroje na rezanie ozubenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079050'),
('82079050:2X', '--- Ostatné, s pracovnou časťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079050:2X'),
('82079050:3X', '---- Z cermetov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079050:3X'),
('82079071', '----- Na obrábanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079071'),
('82079078', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079078'),
('82079078:2X', '---- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079078:2X'),
('82079091', '----- Na obrábanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079091'),
('82079099', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82079099'),
('8208', 'Nože a rezacie čepele na stroje alebo mechanické zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8208'),
('82081000', '- Na opracovanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82081000'),
('82082000', '- Na opracovanie dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82082000'),
('82083000', '- Na kuchynské zariadenia alebo na stroje používané v potravinárskom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82083000'),
('82084000', '- Na stroje používané v poľnohospodárstve, záhradníctve alebo lesníctve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82084000'),
('82089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82089000'),
('820900', 'Doštičky, tyčinky, hroty a podobné časti nástrojov, nemontované, z cermetov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_820900'),
('82090020', '- Otočné rezacie vložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82090020'),
('82090080', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82090080'),
('82100000', 'Ručne poháňané mechanické zariadenia, s hmotnosťou 10 kg alebo menšou, používané na pripravovanie, upravovanie alebo podávanie jedál alebo nápojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82100000'),
('8211', 'Nože s hladkou alebo zúbkovanou rezacou čepeľou (vrátane štepárskych nožov), iné ako nože položky 8208, a ich čepele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8211'),
('82111000', '- Súpravy zostavených výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82111000'),
('82111000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82111000:2X'),
('82119100', '-- Jedálenské nože s pevnou čepeľou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82119100'),
('82119200', '-- Ostatné nože s pevnou čepeľou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82119200'),
('82119300', '-- Nože iné ako s pevnou čepeľou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82119300'),
('82119400', '-- Čepele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82119400'),
('82119500', '-- Rukoväte zo základného kovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82119500'),
('8212', 'Britvy, holiace strojčeky a holiace žiletky (vrátane polotovarov žiletiek v pásoch)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8212'),
('821210', '- Britvy a holiace strojčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_821210'),
('82121010', '-- Holiace strojčeky s nevymeniteľnými žiletkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_82121010'),
('82121090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_82121090'),
('82122000', '- Žiletky do holiacich strojčekov, vrátane polotovarov žiletiek v pásoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MIL'), 'SK_82122000'),
('82129000', '- Ostatné časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82129000'),
('82130000', 'Nožnice, krajčírske nožnice a podobné nožnice, a ich čepele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82130000'),
('8214', 'Ostatné nožiarske predmety (napríklad strihače vlasov, mäsiarske alebo kuchynské sekáče, kolískové nože na jemné alebo hrubé krájanie, nože na papier); súpravy a náčinie na manikúru alebo pedikúru (vrátane pilníčkov na nechty)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8214'),
('82141000', '- Nože na papier, nože na otváranie obálok, vyškrabovacie nožíky, orezávače na ceruzky a ich čepele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82141000'),
('82142000', '- Súpravy a náradie na manikúru alebo pedikúru (vrátane pilníčkov na nechty)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82142000'),
('82149000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82149000'),
('8215', 'Lyžice, vidličky, zberačky, naberačky, cukrárske lyžice, nože na ryby, nože na maslo, klieštiky na cukor a podobný kuchynský alebo jedálenský tovar', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8215'),
('821510', '- Súpravy obsahujúce aspoň jeden predmet plátovaný drahým kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_821510'),
('82151020', '-- Obsahujúce iba predmety plátované drahým kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82151020'),
('82151020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82151020:2X'),
('82151030', '--- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82151030'),
('82151080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82151080'),
('821520', '- Ostatné súpravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_821520'),
('82152010', '-- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82152010'),
('82152090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82152090'),
('82152090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82152090:2X'),
('82159100', '-- Plátované drahým kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82159100'),
('821599', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_821599'),
('82159910', '--- Z nehrdzavejúcej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82159910'),
('82159990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_82159990'),
('8301', 'Visacie zámky a zámky (na kľúč, na kombináciu alebo elektrické), zo základných kovov; uzávery a uzáverové rámy so vstavanými zámkami, zo základných kovov; kľúče na všetky druhy vyššie uvedených zámkov, zo základného kovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8301'),
('83011000', '- Visacie zámky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83011000'),
('83012000', '- Zámky do motorových vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83012000'),
('83013000', '- Zámky druhov používaných na nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83013000'),
('830140', '- Ostatné zámky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_830140'),
('830140:2X', '-- Zámky druhov používaných do dvier budov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_830140:2X'),
('83014011', '--- Valcové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83014011'),
('83014019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83014019'),
('83014090', '-- Ostatné zámky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83014090'),
('83015000', '- Uzávery a uzáverové rámy so vstavanými zámkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83015000'),
('83016000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83016000'),
('83017000', '- Kľúče predkladané samostatne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83017000'),
('8302', 'Príchytky, kovanie a podobné výrobky, zo základných kovov, vhodné na nábytok, dvere, schodištia, okná, rolety, karosérie, na sedlársky tovar, kufre, truhly alebo puzdrá alebo podobne; vešiaky a háčiky na odevy, klobúky, konzoly a podobné výrobky, zo zák', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8302'),
('83021000', '- Závesy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83021000'),
('83022000', '- Riadiace kolieska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83022000'),
('83023000', '- Ostatné príchytky, kovanie a podobné výrobky vhodné na motorové vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83023000'),
('83023000:2X', '- Ostatné príchytky, kovanie a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83023000:2X'),
('830241', '-- Vhodné pre stavebníctvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_830241'),
('83024110', '--- Na dvere', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83024110'),
('83024150', '--- Na okná a francúzske okná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83024150'),
('83024190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83024190'),
('83024200', '-- Ostatné, vhodné na nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83024200'),
('83024900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83024900'),
('83025000', '- Vešiaky a háčiky na odevy, klobúky, konzoly a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83025000'),
('83026000', '- Zariadenia na automatické zatváranie dverí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83026000'),
('830300', 'Pancierové alebo spevnené bezpečnostné schránky (sejfy), zosilnené skrinky a dvere a depozitné skrinky do trezorov, pokladne alebo schránky na listiny a podobné, zo základných kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_830300'),
('83030040', '- Pancierové alebo spevnené bezpečnostné schránky (sejfy), zosilnené skrinky a dvere a depozitné skrinky do trezorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83030040'),
('83030090', '- Pokladne alebo schránky na listiny a podobné schránky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83030090'),
('83040000', 'Kartotékové skrine, zoraďovače spisov, schránky na ukladanie papierov alebo písacích pier, zásuvky na pečiatky a podobné vybavenie kancelárií alebo písacích stolov, zo základných kovov, okrem kancelárskeho nábytku položky 9403', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83040000'),
('8305', 'Mechaniky na zoraďovače spisov, rýchloviazače alebo dosky s voľnými listami, listové spony, listové sponky, zošívacie drôtiky, štítky na registre a podobný kancelársky tovar zo základných kovov; zošívacie spinky v pásoch (napríklad na kancelárske potreb', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8305'),
('83051000', '- Mechaniky na zoraďovače spisov, rýchloviazače alebo dosky s voľnými listami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83051000'),
('83052000', '- Zošívacie spinky v pásoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83052000'),
('83059000', '- Ostatné, vrátane častí a súčastí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83059000'),
('8306', 'Zvony, gongy a podobné výrobky, neelektrické, zo základných kovov; sošky a ostatné ozdobné predmety, zo základných kovov; rámiky na fotografie a obrazy alebo podobné rámy, zo základných kovov; zrkadlá zo základných kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8306'),
('83061000', '- Zvony, gongy a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83061000'),
('83061000:2X', '- Sošky a ostatné ozdobné predmety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83061000:2X'),
('83062100', '-- Plátované drahými kovmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83062100'),
('83062900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83062900'),
('83063000', '- Rámiky na fotografie alebo obrazy alebo podobné rámy; zrkadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83063000'),
('8307', 'Hadice zo základných kovov, tiež s príslušenstvom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8307'),
('83071000', '- Zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83071000'),
('83079000', '- Z ostatných základných kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83079000'),
('8308', 'Uzávery, rámy alebo obruby s uzávermi, pracky, spony, svorky, háčiky, očká a podobné výrobky, zo základných kovov, druhov používaných na odevy, obuv, plachty, kabely a kabelky, cestovnú batožinu alebo ostatné celkom dohotovené výrobky, duté nity alebo n', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8308'),
('83081000', '- Svorky, háčiky a očká', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83081000'),
('83082000', '- Duté nity a nity s rozštiepeným driekom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83082000'),
('83089000', '- Ostatné, vrátane častí a súčastí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83089000'),
('8309', 'Zátky, viečka a uzávery fliaš (vrátane korunkových uzáverov, korunkových čapov so závitom a nalievacích zátok), odtrhovacie kapsle (na uzávery fliaš), vrchnáky so závitom, plomby a ostatné príslušenstvo obalov, zo základných kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8309'),
('83091000', '- Korunkové uzávery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83091000'),
('830990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_830990'),
('83099010', '-- Kapsle z olova; kapsle z hliníka s priemerom presahujúcim 21 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83099010'),
('83099090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83099090'),
('83100000', 'Dosky, doštičky, s orientačnými nápismi, menovkami, adresami a podobné, číslice, písmená a ostatné značky, zo základných kovov, iné ako položky 9405', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83100000'),
('8311', 'Drôty, tyčky, rúrky, dosky, elektródy a podobné výrobky, zo základného kovu alebo z karbidov kovov, potiahnuté alebo plnené rozpúšťadlami alebo tavidlami, druhov používaných na spájkovanie, zváranie alebo na nanášanie kovov alebo karbidov kovov; drôty a', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8311'),
('83111000', '- Potiahnuté elektródy zo základných kovov, na zváranie elektrickým oblúkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83111000'),
('83112000', '- Jadrový drôt zo základného kovu, na zváranie elektrickým oblúkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83112000'),
('83113000', '- Potiahnuté tyče a jadrové drôty zo základného kovu, s náplňou na spájkovanie alebo zváranie plameňom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83113000'),
('83119000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_83119000'),
('8401', 'Jadrové reaktory; nevyhorené palivové články (kazety) do jadrových reaktorov; stroje, prístroje a zariadenia na separáciu izotopov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8401'),
('84011000', '- Jadrové reaktory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84011000'),
('84012000', '- Stroje, prístroje a zariadenia na separáciu izotopov, ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84012000'),
('84013000', '- Nevyhorené palivové články (kazety)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_GFI'), 'SK_84013000'),
('84014000', '- Časti a súčasti jadrových reaktorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84014000'),
('8402', 'Kotly na výrobu vodnej alebo ostatnej pary - parné kotly (iné ako nízkotlakové kotly na ústredné kúrenie schopné dodávať tak teplú vodu, ako aj paru); kotly na "prehriatu" vodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8402'),
('8402:2X', '- Kotly na výrobu vodnej alebo ostatnej pary (parné kotly)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8402:2X'),
('84021100', '-- Vodorúrové kotly s produkciou pary presahujúcou 45 t pary za hodinu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84021100'),
('84021200', '-- Vodorúrové kotly s produkciou pary nepresahujúcou 45 t pary za hodinu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84021200'),
('840219', '-- Ostatné parné kotly, vrátane hybridných kotlov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840219'),
('84021910', '--- Kotly s ohňovzdornými rúrkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84021910'),
('84021990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84021990'),
('84022000', '- Kotly na prehriatu vodu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84022000'),
('84029000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84029000'),
('8403', 'Kotly na ústredné kúrenie, iné ako položky 8402', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8403'),
('840310', '- Kotly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840310'),
('84031010', '-- Z liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84031010'),
('84031090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84031090'),
('840390', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840390'),
('84039010', '-- Z liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84039010'),
('84039090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84039090'),
('8404', 'Pomocné stroje a zariadenia na kotly položky 8402 alebo 8403 (napríklad ohrievače vody, tzv. ekonomizéry, prehrievače pary, odstraňovače sadzí, zariadenia na rekuperáciu plynov); parné kondenzátory alebo kondenzátory pre ostatné parné pohonné jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8404'),
('84041000', '- Pomocné stroje a zariadenia na kotly položky 8402 alebo 8403', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84041000'),
('84042000', '- Parné kondenzátory alebo kondenzátory pre ostatné parné pohonné jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84042000'),
('84049000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84049000'),
('8405', 'Plynové generátory na generátorový alebo vodný plyn, tiež vybavené čističmi plynov; vyvíjače acetylénu a podobné generátory na vyvíjanie plynu mokrou cestou, tiež vybavené čističmi plynov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8405'),
('84051000', '- Plynové generátory na generátorový alebo vodný plyn, tiež vybavené čističmi plynov; vyvíjače acetylénu a podobné generátory na vyvíjanie plynu mokrou cestou, tiež vybavené čističmi plynov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84051000'),
('84059000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84059000'),
('8406', 'Turbíny na vodnú a ostatnú paru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8406'),
('84061000', '- Turbíny na pohon lodí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84061000'),
('84061000:2X', '- Ostatné turbíny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84061000:2X'),
('84068100', '-- S výkonom presahujúcim 40 MW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84068100'),
('84068200', '-- S výkonom nepresahujúcim 40 MW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84068200'),
('840690', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840690'),
('84069010', '-- Statorové lopatky, rotory a ich lopatky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84069010'),
('84069090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84069090'),
('8407', 'Vratné alebo rotačné zážihové piestové spaľovacie motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8407'),
('84071000', '- Letecké motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84071000'),
('84071000:2X', '- Motory na pohon lodí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84071000:2X'),
('840721', '-- Závesné motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840721'),
('84072110', '--- S objemom valcov nepresahujúcim 325 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84072110'),
('84072110:2X', '--- S objemom valcov presahujúcim 325 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84072110:2X'),
('84072191', '---- S výkonom nepresahujúcim 30 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84072191'),
('84072199', '---- S výkonom presahujúcim 30 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84072199'),
('84072900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84072900'),
('84072900:2X', '- Vratné piestové motory druhov používaných na pohon vozidiel kapitoly 87', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84072900:2X'),
('84073100', '-- S objemom valcov nepresahujúcim 50 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84073100'),
('840732', '-- S objemom valcov presahujúcim 50 cm3, ale nepresahujúcim 250 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840732'),
('84073210', '--- S objemom valcov presahujúcim 50 cm3, ale nepresahujúcim 125 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84073210'),
('84073290', '--- S objemom valcov presahujúcim 125 cm3, ale nepresahujúcim 250 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84073290'),
('84073300', '-- S objemom valcov presahujúcim 250 cm3, ale nepresahujúcim 1 000 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84073300'),
('840734', '-- S objemom valcov presahujúcim 1 000 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840734'),
('84073410', '--- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; motorových vozidiel položky 8703; motorových vozidiel položky 8704 s motorom s objemom valcov menším ako 2 800 cm3; motorových vozidiel položky 8705', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84073410'),
('84073410:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84073410:2X'),
('84073430', '---- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84073430'),
('84073430:2X', '---- Nové, s objemom valcov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84073430:2X'),
('84073491', '----- Nepresahujúcim 1 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84073491'),
('84073499', '----- Presahujúcim 1 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84073499'),
('840790', '- Ostatné motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840790'),
('84079010', '-- S objemom valcov nepresahujúcim 250 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84079010'),
('84079010:2X', '-- S objemom valcov presahujúcim 250 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84079010:2X'),
('84079050', '--- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; motorových vozidiel položky 8703; motorových vozidiel položky 8704 s motorom s objemom valcov menším ako 2 800 cm3; motorových vozidiel položky 8705', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84079050'),
('84079050:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84079050:2X'),
('84079080', '---- S výkonom nepresahujúcim 10 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84079080'),
('84079090', '---- S výkonom presahujúcim 10 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84079090'),
('8408', 'Vznetové piestové spaľovacie motory (dieselové motory alebo motory so žiarovou hlavou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8408'),
('840810', '- Motory na pohon lodí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840810'),
('840810:2X', '-- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840810:2X'),
('84081011', '--- Na námorné plavidlá položiek 8901 až 8906, ťažné lode podpoložky 8904 00 10 a vojnové lode podpoložky 8906 10 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081011'),
('84081019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081019'),
('84081019:2X', '-- Nové, s výkonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84081019:2X'),
('84081019:3X', '--- Nepresahujúcim 50 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84081019:3X'),
('84081023', '---- Na námorné plavidlá položiek 8901 až 8906, ťažné lode podpoložky 8904 00 10 a vojnové lode podpoložky 8906 10 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081023'),
('84081027', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081027'),
('84081027:2X', '--- Presahujúcim 50 kW, ale nepresahujúcim 100 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84081027:2X'),
('84081031', '---- Na námorné plavidlá položiek 8901 až 8906, ťažné lode podpoložky 8904 00 10 a vojnové lode podpoložky 8906 10 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081031'),
('84081039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081039'),
('84081039:2X', '--- Presahujúcim 100 kW, ale nepresahujúcim 200 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84081039:2X'),
('84081041', '---- Na námorné plavidlá položiek 8901 až 8906, ťažné lode podpoložky 8904 00 10 a vojnové lode podpoložky 8906 10 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081041'),
('84081049', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081049'),
('84081049:2X', '--- Presahujúcim 200 kW, ale nepresahujúcim 300 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84081049:2X'),
('84081051', '---- Na námorné plavidlá položiek 8901 až 8906, ťažné lode podpoložky 8904 00 10 a vojnové lode podpoložky 8906 10 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081051'),
('84081059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081059'),
('84081059:2X', '--- Presahujúcim 300 kW, ale nepresahujúcim 500 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84081059:2X'),
('84081061', '---- Na námorné plavidlá položiek 8901 až 8906, ťažné lode podpoložky 8904 00 10 a vojnové lode podpoložky 8906 10 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081061'),
('84081069', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081069'),
('84081069:2X', '--- Presahujúcim 500 kW, ale nepresahujúcim 1 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84081069:2X'),
('84081071', '---- Na námorné plavidlá položiek 8901 až 8906, ťažné lode podpoložky 8904 00 10 a vojnové lode podpoložky 8906 10 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081071'),
('84081079', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081079'),
('84081079:2X', '--- Presahujúcim 1 000 kW, ale nepresahujúcim 5 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84081079:2X'),
('84081081', '---- Na námorné plavidlá položiek 8901 až 8906, ťažné lode podpoložky 8904 00 10 a vojnové lode podpoložky 8906 10 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081081'),
('84081089', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081089'),
('84081089:2X', '--- Presahujúcim 5 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84081089:2X'),
('84081091', '---- Na námorné plavidlá položiek 8901 až 8906, ťažné lode podpoložky 8904 00 10 a vojnové lode podpoložky 8906 10 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081091'),
('84081099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84081099'),
('840820', '- Motory druhov používaných na pohon vozidiel kapitoly 87', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840820'),
('84082010', '-- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; motorových vozidiel položky 8703; motorových vozidiel položky 8704 s motorom s objemom valcov menším ako 2 500 cm3; motorových vozidiel položky 8705', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84082010'),
('84082010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84082010:2X'),
('84082010:3X', '--- Na kolesové poľnohospodárske alebo lesné traktorya tahače, s výkonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84082010:3X'),
('84082031', '---- Nepresahujúcim 50 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84082031'),
('84082035', '---- Presahujúcim 50 kW, ale nepresahujúcim 100 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84082035'),
('84082037', '---- Presahujúcim 100 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84082037'),
('84082037:2X', '--- Na ostatné vozidlá kapitoly 87 s výkonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84082037:2X'),
('84082051', '---- Nepresahujúcim 50 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84082051'),
('84082055', '---- Presahujúcim 50 kW, ale nepresahujúcim 100 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84082055'),
('84082057', '---- Presahujúcim 100 kW, ale nepresahujúcim 200 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84082057'),
('84082099', '---- Presahujúcim 200 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84082099'),
('840890', '- Ostatné motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_840890'),
('84089021', '-- Na koľajové trakcie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089021'),
('84089021:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84089021:2X'),
('84089027', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089027'),
('84089027:2X', '--- Nové, s výkonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84089027:2X'),
('84089041', '---- Nepresahujúcim 15 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089041'),
('84089043', '---- Presahujúcim 15 kW, ale nepresahujúcim 30 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089043'),
('84089045', '---- Presahujúcim 30 kW, ale nepresahujúcim 50 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089045'),
('84089047', '---- Presahujúcim 50 kW, ale nepresahujúcim 100 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089047'),
('84089061', '---- Presahujúcim 100 kW, ale nepresahujúcim 200 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089061'),
('84089065', '---- Presahujúcim 200 kW, ale nepresahujúcim 300 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089065'),
('84089067', '---- Presahujúcim 300 kW, ale nepresahujúcim 500 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089067'),
('84089081', '---- Presahujúcim 500 kW, ale nepresahujúcim 1 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089081'),
('84089085', '---- Presahujúcim 1 000 kW, ale nepresahujúcim 5 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089085'),
('84089089', '---- Presahujúcim 5 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84089089'),
('8409', 'Časti a súčasti vhodné na použitie výhradne alebo hlavne na motory položky 8407 alebo 8408', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8409'),
('84091000', '- Na letecké motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84091000'),
('84091000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84091000:2X'),
('84099100', '-- Vhodné na použitie výhradne alebo hlavne na zážihové piestové spaľovacie motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84099100'),
('84099900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84099900'),
('8410', 'Vodné turbíny, vodné kolesá a ich regulátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8410'),
('8410:2X', '- Vodné turbíny a vodné kolesá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8410:2X'),
('84101100', '-- S výkonom nepresahujúcim 1 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84101100'),
('84101200', '-- S výkonom presahujúcim 1 000 kW, ale nepresahujúcim 10 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84101200'),
('84101300', '-- S výkonom presahujúcim 10 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84101300'),
('84109000', '- Časti a súčasti, vrátane regulátorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84109000'),
('8411', 'Prúdové motory, turbovrtuľové pohony a ostatné plynové turbíny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8411'),
('8411:2X', '- Prúdové motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8411:2X'),
('84111100', '-- S ťahom nepresahujúcim 25 kN', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84111100'),
('841112', '-- S ťahom presahujúcim 25 kN', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841112'),
('84111210', '--- S ťahom presahujúcim 25 kN, ale nepresahujúcim 44 kN', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84111210'),
('84111230', '--- S ťahom presahujúcim 44 kN, ale nepresahujúcim 132 kN', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84111230'),
('84111280', '--- S ťahom presahujúcim 132 kN', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84111280'),
('84111280:2X', '- Turbovrtuľové pohony', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84111280:2X'),
('84112100', '-- S výkonom nepresahujúcim 1 100 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84112100'),
('841122', '-- S výkonom presahujúcim 1 100 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841122'),
('84112220', '--- S výkonom presahujúcim 1 100 kW, ale nepresahujúcim 3 730 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84112220'),
('84112280', '--- S výkonom presahujúcim 3 730 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84112280'),
('84112280:2X', '- Ostatné plynové turbíny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84112280:2X'),
('84118100', '-- S výkonom nepresahujúcim 5 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84118100'),
('841182', '-- S výkonom presahujúcim 5 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841182'),
('84118220', '--- S výkonom presahujúcim 5 000 kW, ale nepresahujúcim 20 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84118220'),
('84118260', '--- S výkonom presahujúcim 20 000 kW, ale nepresahujúcim 50 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84118260'),
('84118280', '--- S výkonom presahujúcim 50 000 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84118280'),
('84118280:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84118280:2X'),
('84119100', '-- Prúdových motorov alebo turbovrtuľových pohonov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84119100'),
('84119900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84119900'),
('8412', 'Ostatné motory a pohony', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8412'),
('84121000', '- Reaktívne motory, iné ako prúdové motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84121000'),
('84121000:2X', '- Hydraulické motory a pohony', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84121000:2X'),
('841221', '-- S lineárnym pohybom (valca)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841221'),
('84122120', '--- Hydraulické systémy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84122120'),
('84122180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84122180'),
('841229', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841229'),
('84122920', '--- Hydraulické systémy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84122920'),
('84122920:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84122920:2X'),
('84122981', '---- Hydraulické kvapalinové motory a pohony', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84122981'),
('84122989', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84122989'),
('84122989:2X', '- Pneumatické motory a pohony', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84122989:2X'),
('84123100', '-- S lineárnym pohybom (valca)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84123100'),
('84123900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84123900'),
('841280', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841280'),
('84128010', '-- Parné stroje poháňané vodnou alebo ostatnou parou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84128010'),
('84128080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84128080'),
('841290', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841290'),
('84129020', '-- Reaktívnych motorov, iných ako prúdových', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84129020'),
('84129040', '-- Hydraulických motorov a pohonov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84129040'),
('84129080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84129080'),
('8413', 'Čerpadlá na kvapaliny, tiež vybavené meracím zariadením; výťahy na kvapaliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8413'),
('8413:2X', '- Čerpadlá vybavené meracím zariadením alebo konštruované na vybavenie týmto zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8413:2X'),
('84131100', '-- Čerpadlá na výdaj pohonných látok alebo mazadiel používané na čerpacích staniciach alebo v garážach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84131100'),
('84131900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84131900'),
('84132000', '- Ručné čerpadlá, iné ako čerpadlá podpoložky 8413 11 alebo 8413 19', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84132000'),
('841330', '- Čerpadlá pohonných hmôt, mazadiel alebo chladiacich tekutín, používané na piestové spaľovacie motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841330'),
('84133020', '-- Vstrekovacie čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84133020'),
('84133080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84133080'),
('84134000', '- Čerpadlá na betón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84134000'),
('841350', '- Ostatné objemové čerpadlá s kmitavým pohybom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841350'),
('84135020', '-- Hydraulické jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84135020'),
('84135040', '-- Dávkovacie čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84135040'),
('84135040:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84135040:2X'),
('84135040:3X', '--- Piestové čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84135040:3X'),
('84135061', '---- Na hydraulický kvapalinový pohon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84135061'),
('84135069', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84135069'),
('84135080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84135080'),
('841360', '- Ostatné objemové rotačné čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841360'),
('84136020', '-- Hydraulické jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84136020'),
('84136020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84136020:2X'),
('84136020:3X', '--- Zubové čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84136020:3X'),
('84136031', '---- Na hydraulický kvapalinový pohon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84136031'),
('84136039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84136039'),
('84136039:2X', '--- Lopatkové čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84136039:2X'),
('84136061', '---- Na hydraulický kvapalinový pohon', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84136061'),
('84136069', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84136069'),
('84136070', '--- Závitovkové čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84136070'),
('84136080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84136080'),
('841370', '- Ostatné odstredivé čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841370'),
('841370:2X', '-- Ponorné čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841370:2X'),
('84137021', '--- Jednostupňové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137021'),
('84137029', '--- Viacstupňové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137029'),
('84137030', '-- Bezupchávkové odstredivé čerpadlá na vykurovacie systémy a dodávku teplej vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137030'),
('84137030:2X', '-- Ostatné, s priemerom výstupného potrubia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84137030:2X'),
('84137035', '--- Nepresahujúcim 15 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137035'),
('84137035:2X', '--- Presahujúcim 15 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84137035:2X'),
('84137045', '---- Odstredivé čerpadlá priame a s bočným vtokom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137045'),
('84137045:2X', '---- Radiálne odstredivé čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84137045:2X'),
('84137045:3X', '----- Jednostupňové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84137045:3X'),
('84137045:4X', '------ S jedným vstupným obežným kolesom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84137045:4X'),
('84137051', '------- Monobloky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137051'),
('84137059', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137059'),
('84137065', '------ S viac ako jedným vstupným obežným kolesom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137065'),
('84137075', '----- Viacstupňové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137075'),
('84137075:2X', '---- Ostatné odstredivé čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84137075:2X'),
('84137081', '----- Jednostupňové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137081'),
('84137089', '----- Viacstupňové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84137089'),
('84137089:2X', '- Ostatné čerpadlá; výťahy na kvapaliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84137089:2X'),
('84138100', '-- Čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84138100'),
('84138200', '-- Výťahy na kvapaliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84138200'),
('84138200:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84138200:2X'),
('84139100', '-- Čerpadiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84139100'),
('84139200', '-- Výťahov na kvapaliny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84139200'),
('8414', 'Vzduchové čerpadlá alebo vákuové čerpadlá, kompresory, ventilátory a dúchadlá na vzduch alebo iný plyn; ventilačné alebo recirkulačné odsávače s ventilátorom, tiež so vstavaným filtrom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8414'),
('841410', '- Vákuové čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841410'),
('84141020', '-- Na použitie vo výrobe polovodičov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84141020'),
('84141020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84141020:2X'),
('84141025', '--- Rotačné piestové čerpadlá, lopatkové čerpadlá rotačné, molekulárne vývevy a Rootsove čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84141025'),
('84141025:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84141025:2X'),
('84141081', '---- Difúzne čerpadlá, kryogénne čerpadlá a adsorpčné čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84141081'),
('84141089', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84141089'),
('841420', '- Vzduchové čerpadlá s ručnou alebo nožnou obsluhou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841420'),
('84142020', '-- Ručné pumpy na pneumatiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84142020'),
('84142080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84142080'),
('841430', '- Kompresory používané v chladiacich zariadeniach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841430'),
('84143020', '-- S výkonom nepresahujúcim 0,4 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84143020'),
('84143020:2X', '-- S výkonom presahujúcim 0,4 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84143020:2X'),
('84143081', '--- Hermetické alebo polohermetické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84143081'),
('84143089', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84143089'),
('841440', '- Vzduchové kompresory upevnené na podvozku s kolesami upravenom na ťahanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841440'),
('84144010', '-- S prietokom nepresahujúcim 2 m3 za minútu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84144010'),
('84144090', '-- S prietokom presahujúcim 2 m3 za minútu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84144090'),
('84144090:2X', '- Ventilátory a dúchadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84144090:2X'),
('84145100', '-- Stolové, podlahové, nástenné, okenné, stropné alebo strešné ventilátory a dúchadlá, s vlastným elektrickým motorom s výkonom nepresahujúcim 125 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84145100'),
('841459', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841459'),
('84145920', '--- Axiálne ventilátory a dúchadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84145920'),
('84145940', '--- Odstredivé ventilátory a dúchadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84145940'),
('84145980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84145980'),
('84146000', '- Odsávače s najdlhšou vodorovnou stranou nepresahujúcou 120 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84146000'),
('841480', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841480'),
('841480:2X', '-- Turbokompresory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841480:2X'),
('84148011', '--- Jednostupňové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148011'),
('84148019', '--- Viacstupňové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148019'),
('84148019:2X', '-- Objemové kompresory s vratným pohybom pracujúce s merným pretlakom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84148019:2X'),
('84148019:3X', '--- Nepresahujúcim 15 barov, s prietokom za hodinu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84148019:3X'),
('84148022', '---- Nepresahujúcim 60 m3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148022'),
('84148028', '---- Presahujúcim 60 m3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148028'),
('84148028:2X', '--- Presahujúcim 15 barov, s prietokom za hodinu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84148028:2X'),
('84148051', '---- Nepresahujúcim 120 m3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148051'),
('84148059', '---- Presahujúcim 120 m3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148059'),
('84148059:2X', '-- Rotačné objemové kompresory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84148059:2X'),
('84148073', '--- S jedným hriadeľom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148073'),
('84148073:2X', '--- S viacerými hriadeľmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84148073:2X'),
('84148075', '---- Závitovkové kompresory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148075'),
('84148078', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148078'),
('84148080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84148080'),
('84149000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84149000'),
('8415', 'Klimatizačné stroje a prístroje skladajúce sa z ventilátorov so vstavaným motorom a zo strojov a prístrojov na zmenu teploty a vlhkosti, vrátane strojov a prístrojov, v ktorých nemôže byť vlhkosť regulovaná oddelene', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8415'),
('841510', '- Okenného alebo nástenného typu, samostatné alebo delené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841510'),
('84151010', '-- Samostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84151010'),
('84151090', '-- Delené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84151090'),
('84152000', '- Druhu používaného pre osoby v priestoroch motorových vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84152000'),
('84152000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84152000:2X'),
('84158100', '-- S chladiacou jednotkou a ventilom na striedanie chladiaceho/vykurovacieho cyklu (reverzibilné tepelné čerpadlá)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84158100'),
('84158200', '-- Ostatné, so vstavanou chladiacou jednotkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84158200'),
('84158300', '-- Bez vstavanej chladiacej jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84158300'),
('84159000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84159000'),
('8416', 'Horáky na kúreniská na tekuté, práškové alebo plynné palivá; mechanické prikladacie zariadenia, vrátane ich mechanických roštov, mechanické zariadenia na odstraňovanie popola a podobné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8416'),
('841610', '- Horáky na kúreniská na tekuté palivá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841610'),
('84161010', '-- So vstavaným automatickým ovládacím zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84161010'),
('84161090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84161090'),
('841620', '- Ostatné horáky na kúreniská, vrátane kombinovaných horákov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841620'),
('84162010', '-- Plynové, vcelku s ventilátorom a s kontrolným prístrojom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84162010'),
('84162010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84162010:2X'),
('84162020', '--- Horáky kombinované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84162020'),
('84162080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84162080'),
('84163000', '- Mechanické prikladacie zariadenia, vrátane ich mechanických roštov, mechanické zariadenia na odstraňovanie popola a podobné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84163000'),
('84169000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84169000'),
('8417', 'Priemyselné alebo laboratórne kúreniská a pece, vrátane spaľovacích, neelektrické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8417'),
('84171000', '- Kúreniská a pece na praženie, tavenie alebo na ostatné tepelné spracovanie rúd, pyritov alebo kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84171000'),
('841720', '- Pece na pekárske výrobky, vrátane pecí na výrobu sušienok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841720'),
('84172010', '-- Tunelové pece', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84172010'),
('84172090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84172090'),
('841780', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841780'),
('84178030', '-- Pece a kúreniská na vypaľovanie keramických výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84178030'),
('84178050', '-- Pece a kúreniská na vypaľovanie cementu, skla alebo chemických výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84178050'),
('84178070', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84178070'),
('84179000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84179000'),
('8418', 'Chladničky, mraziace boxy a ostatné chladiace alebo mraziace zariadenia, elektrické alebo ostatné; tepelné čerpadlá, iné ako klimatizačné stroje a prístroje položky 8415', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8418'),
('841810', '- Kombinované chladiace a mraziace zariadenia vybavené samostatnými vonkajšími dverami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841810'),
('84181020', '-- S objemom presahujúcim 340 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84181020'),
('84181080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84181080'),
('84181080:2X', '- Chladničky používané v domácnostiach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84181080:2X'),
('841821', '-- Kompresorového typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841821'),
('84182110', '--- S objemom presahujúcim 340 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84182110'),
('84182110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84182110:2X'),
('84182151', '---- Stolového typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84182151'),
('84182159', '---- Vstavaného typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84182159'),
('84182159:2X', '---- Ostatné, s objemom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84182159:2X'),
('84182191', '----- Nepresahujúcim 250 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84182191'),
('84182199', '----- Presahujúcim 250 litrov, ale nepresahujúcim 340 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84182199'),
('84182900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84182900'),
('841830', '- Mrazničky pultového typu s objemom nepresahujúcim 800 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841830'),
('84183020', '-- S objemom nepresahujúcim 400 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84183020'),
('84183080', '-- S objemom presahujúcim 400 litrov, ale nepresahujúcim 800 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84183080'),
('841840', '- Mrazničky skriňového typu s objemom nepresahujúcim 900 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841840'),
('84184020', '-- S objemom nepresahujúcim 250 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84184020'),
('84184080', '-- S objemom presahujúcim 250 litrov, ale nepresahujúcim 900 litrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84184080'),
('841850', '- Ostatný chladiaci alebo mraziaci nábytok, (skrine, vitríny, pulty, výklady a podobný chladiaci alebo mraziaci nábytok) na skladovanie a vystavovanie, so vstavaným chladiacim alebo mraziacim príslušenstvom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841850'),
('841850:2X', '-- Chladiace vitríny a pulty (so vstavanou chladiacou jednotkou alebo výparníkom)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841850:2X'),
('84185011', '--- Na skladovanie zmrazených potravín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84185011'),
('84185019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84185019'),
('84185090', '-- Ostatný mraziaci nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84185090'),
('84185090:2X', '- Ostatné chladiace alebo mraziace zariadenia; tepelné čerpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84185090:2X'),
('84186100', '-- Tepelné čerpadlá, iné ako klimatizačné stroje a prístroje položky 8415', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84186100'),
('84186900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84186900'),
('84186900:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84186900:2X'),
('84189100', '-- Nábytok upravený na vstavanie mraziaceho alebo chladiaceho zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84189100'),
('841899', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841899'),
('84189910', '--- Výparníky a kondenzátory (výmenníky tepla), okrem tých, ktoré sú určené na chladničky používané v domácnostiach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84189910'),
('84189990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84189990'),
('8419', 'Prístroje, stroje alebo laboratórne zariadenia, tiež s elektrickým ohrevom (okrem pecí, rúr a zariadení položky 8514), na spracovávanie materiálu postupmi zakladajúcimi sa na zmene teploty ako je ohrievanie, varenie, praženie, destilácia, rektifikácia,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8419'),
('8419:2X', '- Neelektrické prietokové alebo zásobníkové ohrievače vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8419:2X'),
('84191100', '-- Prietokové plynové ohrievače vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84191100'),
('84191900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84191900'),
('84192000', '- Lekárske, chirurgické alebo laboratórne sterilizačné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84192000'),
('84192000:2X', '- Sušiarne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84192000:2X'),
('84193100', '-- Na sušenie poľnohospodárskych výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84193100'),
('84193200', '-- Na sušenie dreva, buničiny, papiera alebo lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84193200'),
('84193900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84193900'),
('84194000', '- Destilačné alebo rektifikačné prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84194000'),
('84195000', '- Výmenníky tepla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84195000'),
('84196000', '- Stroje a zariadenia na skvapalňovanie vzduchu alebo ostatných plynov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84196000'),
('84196000:2X', '- Ostatné stroje, prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84196000:2X'),
('841981', '-- Na výrobu teplých nápojov alebo na varenie alebo ohrievanie jedál', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841981'),
('84198120', '--- Perkolátory a ostatné zariadenia na výrobu kávy alebo ostatných teplých nápojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84198120'),
('84198180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84198180'),
('841989', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841989'),
('84198910', '--- Chladiace veže a podobné stroje a zariadenia na priame chladenie (bez prepážky) pomocou recirkulácie vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84198910'),
('84198930', '--- Stroje a zariadenia na nanášanie kovov zrážaním pár vo vákuu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84198930'),
('84198998', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84198998'),
('841990', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_841990'),
('84199015', '-- Sterilizátorov podpoložky 8419 20 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84199015'),
('84199085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84199085'),
('8420', 'Kalandre alebo ostatné valcovacie stroje, iné ako stroje na valcovanie kovov alebo skla a valce na tieto stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8420'),
('842010', '- Kalandre alebo ostatné valcovacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842010'),
('84201010', '-- Používané v textilnom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84201010'),
('84201030', '-- Používané v papierenskom priemysle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84201030'),
('84201080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84201080'),
('84201080:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84201080:2X'),
('842091', '-- Valce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842091'),
('84209110', '--- Z liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84209110'),
('84209180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84209180'),
('84209900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84209900'),
('8421', 'Odstredivky, vrátane odstredivých sušičiek; stroje, prístroje a zariadenia na filtrovanie alebo na čistenie tekutín alebo plynov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8421'),
('8421:2X', '- Odstredivky, vrátane odstredivých sušičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8421:2X'),
('84211100', '-- Separátory smotany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84211100'),
('84211200', '-- Odstredivé sušičky bielizne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84211200'),
('842119', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842119'),
('84211920', '--- Druhy odstrediviek používané v laboratóriách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84211920'),
('84211970', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84211970'),
('84211970:2X', '- Stroje, prístroje a zariadenia na filtrovanie alebo čistenie tekutín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84211970:2X'),
('84212100', '-- Na filtrovanie alebo čistenie vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84212100'),
('84212200', '-- Na filtrovanie alebo čistenie nápojov iných ako voda', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84212200'),
('84212300', '-- Olejové alebo benzínové filtre na spaľovacie motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84212300'),
('84212900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84212900'),
('84212900:2X', '- Stroje, prístroje a zariadenia na filtrovanie alebo na čistenie plynov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84212900:2X'),
('84213100', '-- Sacie vzduchové filtre na spaľovacie motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84213100'),
('842139', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842139'),
('84213920', '--- Stroje, prístroje a zariadenia na filtrovanie alebo na čistenie vzduchu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84213920'),
('84213920:2X', '--- Stroje, prístroje a zariadenia na filtrovanie alebo na čistenie ostatných plynov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84213920:2X'),
('84213960', '---- Katalytickým procesom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84213960'),
('84213980', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84213980'),
('84213980:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84213980:2X'),
('84219100', '-- Odstrediviek, vrátane odstredivých sušičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84219100'),
('84219900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84219900'),
('8422', 'Umývačky riadu; stroje a prístroje na čistenie alebo sušenie fliaš alebo ostatných obalov; stroje a prístroje na plnenie, uzatváranie, pečatenie alebo označovanie fliaš, plechoviek, škatúľ, vriec alebo ostatných obalov; stroje a prístroje na uzatváranie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8422'),
('8422:2X', '- Umývačky riadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8422:2X'),
('84221100', '-- Pre domácnosť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84221100'),
('84221900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84221900'),
('84222000', '- Stroje a prístroje na čistenie alebo sušenie fliaš alebo ostatných obalov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84222000'),
('84223000', '- Stroje a prístroje na plnenie, uzatváranie, pečatenie alebo označovanie fliaš, plechoviek, škatúľ, vriec alebo ostatných obalov; stroje a prístroje na uzatváranie fliaš, pohárov, túb a podobných obalov s kapsľami; stroje a prístroje na prevzdušňovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84223000'),
('84224000', '- Ostatné baliace stroje a prístroje (vrátane strojov na balenie tepelným zmrašťovaním)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84224000'),
('842290', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842290'),
('84229010', '-- Umývačiek riadu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84229010'),
('84229090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84229090'),
('8423', 'Stroje a prístroje na váženie (okrem váh s citlivosťou 5 centigramov alebo lepšou), vrátane váh spojených s počítacími alebo kontrolnými prístrojmi; závažia na váhy všetkých druhov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8423'),
('842310', '- Osobné váhy, vrátane detských váh; váhy pre domácnosť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842310'),
('84231010', '-- Váhy pre domácnosť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84231010'),
('84231090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84231090'),
('84232000', '- Váhy na priebežné váženie tovaru na dopravníkoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84232000'),
('84233000', '- Váhy na konštantné váženie a vážiace zariadenie na plnenie stanoveného množstva materiálov do vriec alebo ostatných obalov, vrátane násypných váh', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84233000'),
('84233000:2X', '- Ostatné stroje a prístroje na váženie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84233000:2X'),
('842381', '-- S maximálnym zaťažením nepresahujúcim 30 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842381'),
('84238110', '--- Kontrolné váhy a automaticky riadené zariadenia na váženie pracujúce na základe porovnávania s vopred určenou hmotnosťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84238110'),
('84238130', '--- Stroje a prístroje na váženie a označovanie vopred zabaleného tovaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84238130'),
('84238150', '--- Váhy používané v predajniach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84238150'),
('84238190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84238190'),
('842382', '-- So zaťažením presahujúcim 30 kg, ale nepresahujúcim 5 000 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842382'),
('84238210', '--- Kontrolné váhy a automaticky riadené zariadenia na váženie pracujúce na základe porovnávania s vopred určenou hmotnosťou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84238210'),
('84238290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84238290'),
('84238900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84238900'),
('84239000', '- Závažia na váhy všetkých druhov; časti a súčasti strojov a prístrojov na váženie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84239000'),
('8424', 'Mechanické prístroje (tiež ručné) na striekanie, rozstrekovanie alebo rozprašovanie tekutín alebo práškov; hasiace prístroje, tiež s náplňou; striekacie pištole a podobné prístroje; dúchadlá na vrhanie piesku alebo na vháňanie pary a podobné vstrekovaci', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8424'),
('84241000', '- Hasiace prístroje, tiež s náplňou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84241000'),
('84242000', '- Striekacie pištole a podobné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84242000'),
('842430', '- Dúchadlá na vrhanie piesku alebo na vháňanie pary a podobné vstrekovacie prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842430'),
('842430:2X', '-- Vodné umývacie zariadenia so vstavaným motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842430:2X'),
('84243001', '--- S vyhrievačom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84243001'),
('84243008', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84243008'),
('84243008:2X', '-- Ostatné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84243008:2X'),
('84243010', '--- Na stlačený vzduch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84243010'),
('84243090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84243090'),
('84243090:2X', '- Ostatné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84243090:2X'),
('842481', '-- Poľnohospodárske alebo záhradnícke', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842481'),
('84248110', '--- Zavlažovacie zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84248110'),
('84248110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84248110:2X'),
('84248130', '---- Prenosné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84248130'),
('84248130:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84248130:2X'),
('84248191', '----- Rozstrekovače a rozprašovače určené na umiestnenie na traktory a ťahače alebo určené na ťahanie traktormi a ťahačmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84248191'),
('84248199', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84248199'),
('84248900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84248900'),
('84249000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84249000'),
('8425', 'Kladkostroje a zdvíhacie zariadenia iné ako skipové výťahy; navijaky a vratidlá; zdviháky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8425'),
('8425:2X', '- Kladkostroje a zdvíhacie zariadenia iné ako skipové výťahy alebo zariadenia druhov používaných na zdvíhanie vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8425:2X'),
('84251100', '-- Poháňané elektrickým motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84251100'),
('84251900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84251900'),
('84251900:2X', '- Navijaky; vratidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84251900:2X'),
('84253100', '-- Poháňané elektrickým motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84253100'),
('84253900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84253900'),
('84253900:2X', '- Zdviháky; zdvíhacie zariadenia druhov používaných na zdvíhanie vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84253900:2X'),
('84254100', '-- Fixné zdvíhacie zariadenia používané v garážach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84254100'),
('84254200', '-- Ostatné hydraulické zdvíhacie zariadenia a zdviháky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84254200'),
('84254900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84254900'),
('8426', 'Lodné otočné stĺpové žeriavy; žeriavy vrátane lanových žeriavov; mobilné zdvíhacie rámy, zdvižné obkročné vozíky, portálové nízkozdvižné vozíky a žeriavové vozíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8426'),
('8426:2X', '- Pojazdné mostové žeriavy, prepravné žeriavy, portálové žeriavy, mostové žeriavy, mobilné zdvíhacie rámy, zdvižné obkročné vozíky a portálové nízkozdvižné vozíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8426:2X'),
('84261100', '-- Pojazdné mostové žeriavy s pevnou podperou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84261100'),
('84261200', '-- Mobilné zdvíhacie rámy pohybujúce sa na pneumatikách a zdvíhacie obkročné vozíky alebo portálové nízkozdvižné vozíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84261200'),
('84261900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84261900'),
('84262000', '- Vežové žeriavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84262000'),
('84263000', '- Portálové alebo otočné stĺpové žeriavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84263000'),
('84263000:2X', '- Ostatné stroje a zariadenia, s vlastným pohonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84263000:2X'),
('84264100', '-- Na pneumatikách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84264100'),
('84264900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84264900'),
('84264900:2X', '- Ostatné stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84264900:2X'),
('842691', '-- Určené na namontovanie na cestné vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842691'),
('84269110', '--- Hydraulické žeriavy určené na nakladanie a vykladanie vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84269110'),
('84269190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84269190'),
('84269900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84269900'),
('8427', 'Vidlicové stohovacie vozíky; ostatné vozíky vybavené zdvíhacím alebo manipulačným zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8427'),
('842710', '- Samohybné vozíky poháňané elektrickým motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842710'),
('84271010', '-- So zdvihom do výšky 1 m alebo vyšším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84271010'),
('84271090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84271090'),
('842720', '- Ostatné samohybné vozíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842720'),
('842720:2X', '-- So zdvihom do výšky 1 m alebo vyšším', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842720:2X'),
('84272011', '--- Terénne vidlicové zdvíhacie vozíky a ostatné stohovacie vozíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84272011'),
('84272019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84272019'),
('84272090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84272090'),
('84279000', '- Ostatné vozíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84279000'),
('8428', 'Ostatné zdvíhacie, manipulačné, nakladacie alebo vykladacie stroje a zariadenia (napríklad výťahy, eskalátory, dopravníky, lanovky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8428'),
('842810', '- Výťahy a skipové výťahy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842810'),
('84281020', '-- Poháňané elektrickým motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84281020'),
('84281080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84281080'),
('842820', '- Pneumatické elevátory a dopravníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842820'),
('84282020', '-- Na sypké materiály', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84282020'),
('84282080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84282080'),
('84282080:2X', '- Ostatné elevátory a dopravníky na nepretržité premiestňovanie tovarov alebo materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84282080:2X'),
('84283100', '-- Špeciálne konštruované na použitie pod zemou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84283100'),
('84283200', '-- Ostatné, korčekového typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84283200'),
('84283300', '-- Ostatné, pásového typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84283300'),
('842839', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842839'),
('84283920', '--- Valčekové dopravníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84283920'),
('84283990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84283990'),
('84284000', '- Eskalátory a pohyblivé chodníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84284000'),
('84286000', '- Lanovky, sedačkové výťahy, lyžiarske vleky; trakčné zariadenia na pozemné lanovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84286000'),
('842890', '- Ostatné stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842890'),
('842890:2X', '-- Nakladače špeciálne určené na použitie v poľnohospodárstve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842890:2X'),
('84289071', '--- Určené na pripojenie k poľnohospodárskym traktorom a ťahačom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84289071'),
('84289079', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84289079'),
('84289090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84289090'),
('8429', 'Buldozéry, angledozéry, zrovnávače, stroje na planírovanie terénu, škrabače, mechanické lopaty, rýpadlá, lopatové nakladače, ubíjadlá a cestné valce, s vlastným pohonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8429'),
('8429:2X', '- Buldozéry a angledozéry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8429:2X'),
('84291100', '-- Pásové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84291100'),
('84291900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84291900'),
('84292000', '- Zrovnávače a stroje na planírovanie terénu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84292000'),
('84293000', '- Škrabače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84293000'),
('842940', '- Ubíjadlá a cestné valce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842940'),
('842940:2X', '-- Cestné valce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842940:2X'),
('84294010', '--- Vibračné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84294010'),
('84294030', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84294030'),
('84294090', '-- Ubíjacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84294090'),
('84294090:2X', '- Mechanické lopaty, rýpadlá a lopatové nakladače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84294090:2X'),
('842951', '-- Čelné lopatové nakladače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842951'),
('84295110', '--- Nakladače určené špeciálne na práce pod zemou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84295110'),
('84295110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84295110:2X'),
('84295191', '---- Pásové lopatové nakladače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84295191'),
('84295199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84295199'),
('842952', '-- Stroje a zariadenia s nadstavbou otočnou o 360°', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_842952'),
('84295210', '--- Pásové rýpadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84295210'),
('84295290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84295290'),
('84295900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84295900'),
('8430', 'Ostatné stroje a zariadenia zrovnávacie, planírovacie, škrabacie, hĺbiace, utĺkacie, zhutňovacie, stroje a zariadenia na ťažbu alebo vŕtanie zeme, nerastov alebo rúd; baranidlá a vyťahovače pilót; snehové pluhy a snehové frézy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8430'),
('84301000', '- Baranidlá a vyťahovače pilót', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84301000'),
('84302000', '- Snehové pluhy a snehové frézy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84302000'),
('84302000:2X', '- Stroje a zariadenia na ťažbu uhlia alebo hornín a na razenie tunelov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84302000:2X'),
('84303100', '-- S vlastným pohonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84303100'),
('84303900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84303900'),
('84303900:2X', '- Ostatné hĺbiace alebo vŕtacie stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84303900:2X'),
('84304100', '-- S vlastným pohonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84304100'),
('84304900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84304900'),
('84305000', '- Ostatné stroje a zariadenia, s vlastným pohonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84305000'),
('84305000:2X', '- Ostatné stroje a zariadenia, bez vlastného pohonu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84305000:2X'),
('84306100', '-- Utĺkacie alebo zhutňovacie stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84306100'),
('84306900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84306900'),
('8431', 'Časti a súčasti vhodné na použitie výhradne alebo hlavne na stroje a zariadenia položiek 8425 až 8430', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8431'),
('84311000', '- Na stroje a zariadenia položky 8425', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84311000'),
('84312000', '- Na stroje a zariadenia položky 8427', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84312000'),
('84312000:2X', '- Na stroje a zariadenia položky 8428', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84312000:2X'),
('84313100', '-- Na výťahy, skipové výťahy alebo na eskalátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84313100'),
('84313900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84313900'),
('84313900:2X', '- Na stroje a zariadenia položiek 8426, 8429 alebo 8430', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84313900:2X'),
('84314100', '-- Korčeky, lopaty, drapáky a upínadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84314100'),
('84314200', '-- Radlice buldozérov alebo anglodozérov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84314200'),
('84314300', '-- Časti a súčasti vŕtacích alebo hĺbiacich strojov a zariadení podpoložky 8430 41 alebo 8430 49', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84314300'),
('843149', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843149'),
('84314920', '--- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84314920'),
('84314980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84314980'),
('8432', 'Stroje a zariadenia pre poľnohospodárstvo, záhradníctvo alebo lesníctvo, na prípravu alebo na obrábanie pôdy; valce na úpravu trávnikov alebo športových plôch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8432'),
('84321000', '- Pluhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84321000'),
('84321000:2X', '- Brány, rozrývače (skarifikátory), kultivátory, prútové brány a plečky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84321000:2X'),
('84322100', '-- Tanierové brány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84322100'),
('843229', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843229'),
('84322910', '--- Rozrývače (skarifikátory) a kultivátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84322910'),
('84322930', '--- Brány', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84322930'),
('84322950', '--- Pôdne frézy (rotavátory)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84322950'),
('84322990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84322990'),
('843230', '- Stroje na siatie a sadenie a stroje na jednotenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843230'),
('843230:2X', '-- Stroje na siatie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843230:2X'),
('84323011', '--- Presne nastaviteľné stroje na siatie s centrálnym pohonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84323011'),
('84323019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84323019'),
('84323090', '-- Stroje na sadenie a stroje na jednotenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84323090'),
('843240', '- Rozmetače hnoja a umelých hnojív', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843240'),
('84324010', '-- Rozmetače minerálnych alebo chemických hnojív', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84324010'),
('84324090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84324090'),
('84328000', '- Ostatné stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84328000'),
('84329000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84329000'),
('8433', 'Žacie alebo mlátiace stroje a zariadenia, vrátane strojov na lisovanie suchej slamy alebo krmiva; kosačky na trávu alebo seno; stroje na čistenie, triedenie vajec, ovocia alebo ostatných poľnohospodárskych produktov, iné ako stroje položky 8437', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8433'),
('8433:2X', '- Kosačky na úpravu trávnikov, parkov alebo športových plôch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8433:2X'),
('843311', '-- S motorom, so sekacím zariadením otáčajúcim sa v horizontálnej polohe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843311'),
('84331110', '--- Elektrické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84331110'),
('84331110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84331110:2X'),
('84331110:3X', '---- Samohybné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84331110:3X'),
('84331151', '----- So sedadlom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84331151'),
('84331159', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84331159'),
('84331190', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84331190'),
('843319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843319'),
('843319:2X', '--- S motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843319:2X'),
('84331910', '---- Elektrickým', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84331910'),
('84331910:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84331910:2X'),
('84331910:3X', '----- Samohybné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84331910:3X'),
('84331951', '------ So sedadlom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84331951'),
('84331959', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84331959'),
('84331970', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84331970'),
('84331990', '--- Bez motora', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84331990'),
('843320', '- Ostatné žacie stroje, vrátane žacích líšt na pripevnenie na traktory a ťahače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843320'),
('84332010', '-- S motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84332010'),
('84332010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84332010:2X'),
('84332050', '--- Konštruované na ťahanie alebo na vezenie traktorom a ťahačom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84332050'),
('84332090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84332090'),
('84333000', '- Ostatné stroje a zariadenia na spracovanie sena', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84333000'),
('84334000', '- Stroje na balenie slamy alebo suchého krmiva, vrátane zberacích lisov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84334000'),
('84334000:2X', '- Ostatné stroje a zariadenia na žatevné práce; stroje a zariadenia na mlátenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84334000:2X'),
('84335100', '-- Kombajny na žatie a mlátenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84335100'),
('84335200', '-- Ostatné stroje a zariadenia na mlátenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84335200'),
('843353', '-- Stroje na zber koreňov alebo hľúz', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843353'),
('84335310', '--- Vyorávače zemiakov a kombajny na zber zemiakov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84335310'),
('84335330', '--- Stroje na orezávanie cukrovej repy a kombajny na zber cukrovej repy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84335330'),
('84335390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84335390'),
('843359', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843359'),
('843359:2X', '--- Kombajny na zber krmív', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843359:2X'),
('84335911', '---- Samohybné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84335911'),
('84335919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84335919'),
('84335985', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84335985'),
('84336000', '- Stroje na čistenie alebo triedenie vajec, ovocia alebo ostatných poľnohospodárskych produktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84336000'),
('84339000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84339000'),
('8434', 'Dojacie stroje a mliekárenské stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8434'),
('84341000', '- Dojacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84341000'),
('84342000', '- Mliekárenské stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84342000'),
('84349000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84349000'),
('8435', 'Lisy, drviče a podobné stroje a zariadenia na výrobu vína, jablčných muštov, ovocných štiav alebo podobných nápojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8435'),
('84351000', '- Stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84351000'),
('84359000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84359000'),
('8436', 'Ostatné stroje a zariadenia pre poľnohospodárstvo, záhradníctvo, lesníctvo, hydinárstvo alebo včelárstvo, vrátane zariadení na klíčenie rastlín s mechanickým alebo tepelným vybavením; umelé liahne a kvočky pre hydinárstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8436'),
('84361000', '- Stroje a zariadenia na prípravu krmív pre zvieratá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84361000'),
('84361000:2X', '- Stroje a zariadenia pre hydinárstvo; umelé liahne a kvočky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84361000:2X'),
('84362100', '-- Umelé liahne a umelé kvočky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84362100'),
('84362900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84362900'),
('843680', '- Ostatné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843680'),
('84368010', '-- Lesné stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84368010'),
('84368090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84368090'),
('84368090:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84368090:2X'),
('84369100', '-- Strojov a zariadení pre hydinárstvo alebo umelých liahní a kvočiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84369100'),
('84369900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84369900'),
('8437', 'Stroje na čistenie, triedenie alebo na preosievanie semien, zŕn alebo sušených strukovín; stroje používané v mlynárstve alebo pri spracovaní obilia alebo suchých strukovín, iné ako stroje a zariadenia poľnohospodárskeho typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8437'),
('84371000', '- Stroje na čistenie, triedenie alebo preosievanie semien, zŕn alebo suchých strukovín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84371000'),
('84378000', '- Ostatné stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84378000'),
('84379000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84379000'),
('8438', 'Stroje a zariadenia na priemyselnú prípravu alebo na výrobu potravín alebo nápojov, v tejto kapitole inde nešpecifikované ani nezahrnuté, iné ako stroje a zariadenia na extrakciu alebo prípravu živočišných alebo stužených rastlinných alebo živočíšnych s', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8438'),
('843810', '- Pekárske stroje a zariadenia a stroje a zariadenia na výrobu makarónov, špagiet alebo podobných výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843810'),
('84381010', '-- Pekárske stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84381010'),
('84381090', '-- Stroje a zariadenia na výrobu makarónov, špagiet alebo podobných výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84381090'),
('84382000', '- Stroje a zariadenia na výrobu cukroviniek, kakaa alebo čokolády', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84382000'),
('84383000', '- Stroje a zariadenia pre cukrovary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84383000'),
('84384000', '- Stroje a zariadenia pre pivovary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84384000'),
('84385000', '- Stroje a zariadenia na spracovanie mäsa alebo hydiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84385000'),
('84386000', '- Stroje a zariadenia na spracovanie ovocia, orechov alebo zeleniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84386000'),
('843880', '- Ostatné stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_843880'),
('84388010', '-- Na prípravu čaju alebo kávy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84388010'),
('84388010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84388010:2X'),
('84388091', '--- Na prípravu alebo výrobu nápojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84388091'),
('84388099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84388099'),
('84389000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84389000'),
('8439', 'Stroje a zariadenia na výrobu vlákniny z vlákninových celulózových materiálov alebo na výrobu alebo konečnú úpravu papiera alebo lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8439'),
('84391000', '- Stroje a zariadenia na výrobu vlákniny z vlákninových celulózových materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84391000'),
('84392000', '- Stroje a zariadenia na výrobu papiera alebo lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84392000'),
('84393000', '- Stroje a zariadenia na konečnú úpravu papiera alebo lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84393000'),
('84393000:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84393000:2X'),
('84399100', '-- Strojov a zariadení na výrobu vlákniny z vlákninových celulózových materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84399100'),
('84399900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84399900'),
('8440', 'Stroje na väzbu kníh, vrátane strojov na brožovanú väzbu kníh', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8440'),
('844010', '- Stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844010'),
('84401010', '-- Skladacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84401010'),
('84401020', '-- Znášacie stroje a kompletovacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84401020'),
('84401030', '-- Zošívacie stroje na šitie drôtom a stroje na zošívanie sponkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84401030'),
('84401040', '-- Stroje na viazanie inak ako šitím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84401040'),
('84401090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84401090'),
('84409000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84409000'),
('8441', 'Ostatné stroje a zariadenia na spracovanie papieroviny, papiera alebo lepenky, vrátane rezačiek všetkých druhov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8441'),
('844110', '- Rezačky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844110'),
('84411010', '-- Kombinované pozdĺžne rezačky so strojmi na odvíjanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84411010'),
('84411020', '-- Ostatné pozdĺžne a priečne rezacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84411020'),
('84411030', '-- Priamobežné nožnice (gilotíny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84411030'),
('84411070', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84411070'),
('84412000', '- Stroje na výrobu vriec, vrecúšok alebo obálok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84412000'),
('84413000', '- Stroje na výrobu škatúľ, debien, puzdier, túb, súdkov alebo podobných obalov okrem tých, ktoré obaly vyrábajú tvarovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84413000'),
('84414000', '- Stroje na výrobu predmetov z papieroviny, papiera alebo lepenky tvarovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84414000'),
('84418000', '- Ostatné stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84418000'),
('844190', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844190'),
('84419010', '-- Rezačiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84419010'),
('84419090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84419090'),
('8442', 'Stroje a zariadenia, prístroje a príslušenstvo (iné ako obrábacie a tvárniace stroje položiek 8456 až 8465) na prípravu alebo zhotovenie štočkov, dosiek, valcov alebo ostatných tlačiarenskych komponentov; štočky, dosky, valce a ostatné tlačiarenské komp', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8442'),
('844230', '- Stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844230'),
('84423010', '-- Fotosádzacie a sádzacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84423010'),
('84423010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84423010:2X'),
('84423091', '--- Na odlievanie a sádzanie typov (napríklad linotypov, monotypov, intertypov), so zariadením na odlievanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84423091'),
('84423099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84423099'),
('84424000', '- Časti a súčasti vyššie uvedených strojov, prístrojov, zariadení alebo príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84424000'),
('844250', '- Štočky, dosky, valce a ostatné tlačiarenské komponenty; litografické kamene, upravené na tlačiarske účely (napríklad hladené, zrnené alebo leštené)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844250'),
('84425020', '-- S tlačiarenskými znakmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84425020'),
('84425080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84425080'),
('8443', 'Tlačiarenské stroje používané na tlač pomocou štočkov, dosiek, valcov a ostatných tlačiarenských komponentov položky 8442; ostatné tlačiarne, kopírovacie stroje a faxové prístroje (faxy), tiež kombinované; ich časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8443'),
('8443:2X', '- Tlačiarenské stroje používané na tlač pomocou štočkov, dosiek, valcov a ostatných tlačiarenských komponentov položky 8442', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8443:2X'),
('84431100', '-- Ofsetové tlačiarenské stroje, kotúčové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431100'),
('84431200', '-- Ofsetové tlačiarenské stroje na hárkovú tlač, kancelárskeho typu (formát hárku nepresahuje 22 x 36 cm v rozloženom stave)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431200'),
('844313', '-- Ostatné ofsetové tlačiarenské stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844313'),
('844313:2X', '--- Na hárkovú tlač', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844313:2X'),
('84431310', '---- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431310'),
('84431310:2X', '---- Nové, na hárky s rozmermi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84431310:2X'),
('84431331', '----- Nepresahujúcimi 52 × 74 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431331'),
('84431335', '----- Presahujúcimi 52 × 74 cm, ale nepresahujúcimi 74 × 107 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431335'),
('84431339', '----- Presahujúcimi 74 × 107 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431339'),
('84431390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431390'),
('84431400', '-- Kníhtlačiarenské stroje, kotúčové, okrem strojov na flexografickú tlač', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431400'),
('84431500', '-- Kníhtlačiarenské stroje, iné ako kotúčové, okrem strojov na flexografickú tlač', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431500'),
('84431600', '-- Stroje na flexografickú tlač', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431600'),
('84431700', '-- Hĺbkotlačové stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431700'),
('844319', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844319'),
('84431920', '--- Na potlač textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431920'),
('84431940', '--- Na použitie vo výrobe polovodičov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431940'),
('84431970', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84431970'),
('84431970:2X', '- Ostatné tlačiarne, kopírovacie stroje, faxové prístroje (faxy), tiež kombinované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84431970:2X'),
('844331', '-- Stroje vykonávajúce dve alebo viac funkcií ako tlač, kopírovanie alebo faxovanie, schopné pripojenia k stroju na automatické spracovanie údajov alebo do siete', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844331'),
('84433120', '--- Stroje majúce digitálne kopírovanie ako hlavnú funkciu, keď sa kopírovanie vykonáva skenovaním originálu a tlačením kópií pomocou elektrostatickej tlačiarne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433120'),
('84433180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433180'),
('844332', '-- Ostatné, schopné pripojenia k stroju na automatické spracovanie údajov alebo do siete', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844332'),
('84433210', '--- Tlačiarne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433210'),
('84433230', '--- Faxové prístroje (faxy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433230'),
('84433230:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84433230:2X'),
('84433291', '---- Stroje vykonávajúce kopírovaciu funkciu skenovaním originálu a tlačením kópií prostredníctvom elektrostatickej tlačiarne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433291'),
('84433293', '---- Ostatné stroje vykonávajúce kopírovaciu funkciu zabudovaným optickým systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433293'),
('84433299', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433299'),
('844339', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844339'),
('84433910', '--- Stroje vykonávajúce kopírovaciu funkciu skenovaním originálu a tlačením kópií prostredníctvom elektrostatickej tlačiarne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433910'),
('84433910:2X', '--- Ostatné kopírovacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84433910:2X'),
('84433931', '---- So zabudovaným optickým systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433931'),
('84433939', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433939'),
('84433990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84433990'),
('84433990:2X', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84433990:2X'),
('844391', '-- Časti, súčasti a príslušenstvo tlačiarenských strojov používaných na tlač pomocou štočkov, dosiek, valcov a ostatných tlačiarenských komponentov položky 8442', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844391'),
('84439110', '--- Prístrojov podpoložky 8443 19 40', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84439110'),
('84439110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84439110:2X'),
('84439191', '---- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84439191'),
('84439199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84439199'),
('844399', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844399'),
('84439910', '--- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84439910'),
('84439990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84439990'),
('844400', 'Stroje na vytláčanie, preťahovanie, tvarovanie alebo strihanie chemických textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844400'),
('84440010', '- Stroje na vytláčanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84440010'),
('84440090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84440090'),
('8445', 'Stroje na prípravu textilných vlákien; spriadacie a dopriadacie, zdvojovacie alebo zakrucovacie stroje a ostatné stroje a zariadenia na výrobu textilných priadzí; stroje na navíjanie alebo súkanie (vrátane útkových súkacích strojov) a stroje na prípravu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8445'),
('8445:2X', '- Stroje na prípravu textilných vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8445:2X'),
('84451100', '-- Mykacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84451100'),
('84451200', '-- Česacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84451200'),
('84451300', '-- Preťahovacie alebo predpriadacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84451300'),
('84451900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84451900'),
('84452000', '- Textilné spriadacie a dopriadacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84452000'),
('84453000', '- Stroje na zdvojovanie alebo zakrucovanie vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84453000'),
('84454000', '- Súkacie stroje (vrátane útkových súkacích strojov) alebo navíjacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84454000'),
('84459000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84459000'),
('8446', 'Tkáčske krosná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8446'),
('84461000', '- Na tkanie textílií so šírkou nepresahujúcou 30 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84461000'),
('84461000:2X', '- Na tkanie textílií so šírkou presahujúcou 30 cm, člnkové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84461000:2X'),
('84462100', '-- Mechanické krosná', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84462100'),
('84462900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84462900'),
('84463000', '- Na tkanie textílií so šírkou presahujúcou 30 cm, bezčlnkové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84463000'),
('8447', 'Pletacie stroje, stroje na spevnenie prešitím a stroje na výrobu opradenej priadze, tylu, čipiek, výšiviek, lemoviek, prámikov alebo sieťoviny a strojov na všívanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8447'),
('8447:2X', '- Kruhové pletacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8447:2X'),
('84471100', '-- S priemerom valca nepresahujúcim 165 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84471100'),
('84471200', '-- S priemerom valca presahujúcim 165 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84471200'),
('844720', '- Ploché pletacie stroje; stroje na spevnenie prešitím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844720'),
('84472020', '-- Osnovné pletacie stroje (vrátane rašlových strojov); ihlové stroje na spevnenie prešitím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84472020'),
('84472080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84472080'),
('84479000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84479000'),
('8448', 'Pomocné strojové zariadenia na stroje položiek 8444, 8445, 8446 alebo 8447 (napríklad listovky, žakárové stroje, osnovné zarážky, zariadenia na člnkovú výmenu); časti, súčasti a príslušenstvo, vhodné výhradne alebo hlavne na stroje tejto položky alebo p', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8448'),
('8448:2X', '- Pomocné strojové zariadenia na stroje položky 8444, 8445, 8446 alebo 8447', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8448:2X'),
('84481100', '-- Listovky a žakárové stroje; stroje na redukciu, kopírovanie alebo dierovanie štítkov (kariet); stroje na spojovanie štítkov (kariet) po ich dierovaní', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84481100'),
('84481900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84481900'),
('84482000', '- Časti, súčasti a príslušenstvo strojov položky 8444 alebo ich pomocného strojového zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84482000'),
('84482000:2X', '- Časti, súčasti a príslušenstvo strojov položky 8445 alebo ich pomocného strojového zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84482000:2X'),
('84483100', '-- Mykacie povlaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84483100'),
('84483200', '-- Strojov na prípravu textilných vlákien, iné ako mykacie povlaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84483200'),
('84483300', '-- Vretená, krídla, dopriadacie prstence a bežce prstencového spriadacieho stroja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84483300'),
('84483900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84483900'),
('84483900:2X', '- Časti, súčasti a príslušenstvo tkáčskych krosien alebo ich pomocného strojového zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84483900:2X'),
('84484200', '-- Dostavy na krosná, niteľnice a brdové listy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84484200'),
('84484900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84484900'),
('84484900:2X', '- Časti, súčasti a príslušenstvo strojov položky 8447 alebo ich pomocného strojového zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84484900:2X'),
('844851', '-- Platiny, ihly a ostatné výrobky používané na vytváranie ôk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_844851'),
('84485110', '--- Platiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84485110'),
('84485190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84485190'),
('84485900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84485900'),
('84490000', 'Stroje a zariadenia na výrobu alebo zušľachťovanie plsti alebo netkaných textílií v metráži alebo kusoch, vrátane strojov a zariadení na výrobu plstených klobúkov; formy na výrobu klobúkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84490000'),
('8450', 'Práčky pre domácnosť alebo práčovne, vrátane práčok so sušičkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8450'),
('8450:2X', '- Práčky s kapacitou nepresahujúcou 10 kg suchej bielizne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8450:2X'),
('845011', '-- Plnoautomatické práčky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845011'),
('845011:2X', '--- S jednotkovou kapacitou nepresahujúcou 6 kg suchej bielizne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845011:2X'),
('84501111', '---- S plnením spredu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84501111'),
('84501119', '---- S plnením zhora', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84501119'),
('84501190', '--- S jednotkovou kapacitou presahujúcou 6 kg, ale nepresahujúcou 10 kg suchej bielizne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84501190'),
('84501200', '-- Ostatné práčky so vstavanou odstredivou sušičkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84501200'),
('84501900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84501900'),
('84502000', '- Práčky s kapacitou presahujúcou 10 kg suchej bielizne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84502000'),
('84509000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84509000'),
('8451', 'Stroje a zariadenia (iné ako stroje a zariadenia položky 8450) na pranie, čistenie, žmýkanie, sušenie, žehlenie (vrátane žehliacich strojov a mangľov), bielenie, farbenie, apretovanie zušľachťovanie, poťahovanie alebo impregnovanie textilných priadzí, t', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8451'),
('84511000', '- Stroje na chemické čistenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84511000'),
('84511000:2X', '- Sušičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84511000:2X'),
('84512100', '-- S kapacitou nepresahujúcou 10 kg suchej bielizne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84512100'),
('84512900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84512900'),
('84513000', '- Žehliace stroje (vrátane mangľov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84513000'),
('84514000', '- Práčky, stroje na bielenie alebo farbenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84514000'),
('84515000', '- Stroje na navíjanie, odvíjanie, skladanie, plisovanie, strihanie alebo zúbkovanie textílií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84515000'),
('845180', '- Ostatné stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845180'),
('84518010', '-- Stroje používané pri výrobe linolea alebo ostatných podlahových krytín na nanášanie spojív na textilný podklad alebo ostatné podložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84518010'),
('84518030', '-- Stroje na apretovanie alebo zušľachťovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84518030'),
('84518080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84518080'),
('84519000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84519000'),
('8452', 'Šijacie stroje okrem strojov na väzbu a zošívanie kníh položky 8440; nábytok, podstavce a kryty zvlášť upravené na šijacie stroje; ihly do šijacích strojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8452'),
('845210', '- Šijacie stroje pre domácnosť', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845210'),
('845210:2X', '-- Šijacie stroje (iba s prešívacím stehom) s hlavou s hmotnosťou nepresahujúcou 16 kg bez motora alebo 17 kg vrátane motora; hlavy šijacích strojov (iba s prešívacím stehom) s hmotnosťou nepresahujúcou 16 kg bez motora alebo 17 kg vrátane motora', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845210:2X'),
('84521011', '--- Šijacie stroje (bez rámu, stolčeka alebo ostatného nábytku) s hodnotou každého kusa väčšou ako 65 EUR', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84521011'),
('84521019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84521019'),
('84521090', '-- Ostatné šijacie stroje a hlavy šijacích strojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84521090'),
('84521090:2X', '- Ostatné šijacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84521090:2X'),
('84522100', '-- Automatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84522100'),
('84522900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84522900'),
('84523000', '- Ihly do šijacích strojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MIL'), 'SK_84523000'),
('84529000', '- Nábytok, podstavce a kryty na šijacie stroje a ich časti a súčasti; ostatné časti a súčasti šijacích strojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84529000'),
('8453', 'Stroje a zariadenia na prípravu, vyčiňovanie alebo spracovanie koží, kožiek alebo usní, alebo na výrobu alebo opravy obuvi alebo výrobkov z koží, kožiek alebo usní, iné ako šijacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8453'),
('84531000', '- Stroje a zariadenia na prípravu, vyčiňovanie alebo spracovanie koží, kožiek alebo usní', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84531000'),
('84532000', '- Stroje a zariadenia na výrobu alebo opravu obuvi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84532000'),
('84538000', '- Ostatné stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84538000'),
('84539000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84539000'),
('8454', 'Konvertory, lejacie panvy, ingotové kokily a odlievacie stroje, druhov používaných pre metalurgiu alebo zlievarne kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8454'),
('84541000', '- Konvertory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84541000'),
('84542000', '- Ingotové kokily a lejacie panvy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84542000'),
('845430', '- Odlievacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845430'),
('84543010', '-- Na odlievanie pod tlakom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84543010'),
('84543090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84543090'),
('84549000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84549000'),
('8455', 'Valcovacie stolice a valcovacie trate a ich valce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8455'),
('84551000', '- Valcovacie stolice a valcovacie trate na rúrky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84551000'),
('84551000:2X', '- Ostatné valcovacie stolice a valcovacie trate', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84551000:2X'),
('84552100', '-- Pracujúce za tepla alebo kombinovane za tepla a za studena', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84552100'),
('84552200', '-- Pracujúce za studena', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84552200'),
('845530', '- Valce pre valcovacie stolice a valcovacie trate', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845530'),
('84553010', '-- Z liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84553010'),
('84553010:2X', '-- Z kovanej zápustkovej ocele (open-die)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84553010:2X'),
('84553031', '--- Pracovné valce pre valcovanie za tepla; oporné valce pre valcovanie za tepla a za studena', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84553031'),
('84553039', '--- Pracovné valce pre valcovanie za studena', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84553039'),
('84553090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84553090'),
('84559000', '- Ostatné časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84559000'),
('8456', 'Obrábacie stroje na opracovanie akýchkoľvek materiálov ich úberom pomocou lasera alebo pomocou ostatných svetelných alebo fotónových zväzkov, ultrazvuku, elektroerózie, elektrochemických reakcií, elektrónových zväzkov ionizujúceho žiarenia alebo oblúkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8456'),
('84561000', '- Pracujúce pomocou lasera alebo pomocou ostatných svetelných alebo fotónových zväzkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84561000'),
('84562000', '- Pracujúce pomocou ultrazvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84562000'),
('845630', '- Pracujúce pomocou elektroerózie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845630'),
('845630:2X', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845630:2X'),
('84563011', '--- Na delenie drôtov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84563011'),
('84563019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84563019'),
('84563090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84563090'),
('845690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845690'),
('84569020', '-- Stroje na opracovávanie pomocou vodnej trysky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84569020'),
('84569080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84569080'),
('8457', 'Obrábacie centrá, stavebnicové obrábacie stroje (jednopolohové) a viacpolohové, na obrábanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8457'),
('845710', '- Obrábacie centrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845710'),
('84571010', '-- Horizontálne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84571010'),
('84571090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84571090'),
('84572000', '- Stavebnicové stroje (jednopolohové)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84572000'),
('845730', '- Stavebnicové stroje viacpolohové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845730'),
('84573010', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84573010'),
('84573090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84573090'),
('8458', 'Sústruhy (vrátane sústružníckych obrábacích centier), na obrábanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8458'),
('8458:2X', '- Horizontálne sústruhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8458:2X'),
('845811', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845811'),
('84581120', '--- Sústružnícke obrábacie centrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84581120'),
('84581120:2X', '--- Automatické sústruhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84581120:2X'),
('84581141', '---- Jednovretenové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84581141'),
('84581149', '---- Viacvretenové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84581149'),
('84581180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84581180'),
('84581900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84581900'),
('84581900:2X', '- Ostatné sústruhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84581900:2X'),
('845891', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845891'),
('84589120', '--- Sústružnícke obrábacie centrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84589120'),
('84589180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84589180'),
('84589900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84589900'),
('8459', 'Obrábacie stroje (vrátane strojov s pohyblivou hlavou) na vŕtanie, vyvrtávanie, frézovanie, rezanie vonkajčích závitov alebo na rezanie vnútorných závitov úberom kovu, iné ako sústruhy (vrátane sústružníckych obrábacích centier) položky 8458', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8459'),
('84591000', '- Stroje s pohyblivou hlavou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84591000'),
('84591000:2X', '- Ostatné stroje na vŕtanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84591000:2X'),
('84592100', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84592100'),
('84592900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84592900'),
('84592900:2X', '- Ostatné vyvŕtavaco-frézovacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84592900:2X'),
('84593100', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84593100'),
('84593900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84593900'),
('845940', '- Ostatné vyvŕtavacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845940'),
('84594010', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84594010'),
('84594090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84594090'),
('84594090:2X', '- Konzolové frézky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84594090:2X'),
('84595100', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84595100'),
('84595900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84595900'),
('84595900:2X', '- Ostatné frézky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84595900:2X'),
('845961', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845961'),
('84596110', '--- Nástrojové frézky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84596110'),
('84596190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84596190'),
('845969', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_845969'),
('84596910', '--- Nástrojové frézky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84596910'),
('84596990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84596990'),
('84597000', '- Ostatné stroje na rezanie vonkajších alebo vnútorných závitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84597000'),
('8460', 'Obrábacie stroje na odstraňovanie rozstrapatenia (ostrapkov), ostrenie, brúsenie, honovanie, lapovanie, dohladzovanie povrchu, leštenie alebo na inú konečnú úpravu kovov alebo cermetov, pomocou brúsnych kameňov (brúsiv) alebo leštiacich prostriedkov, in', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8460'),
('8460:2X', '- Brúsky rovinné, nastaviteľné v ľubovoľnej osi s presnosťou najmenej 0,01 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8460:2X'),
('84601100', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84601100'),
('84601900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84601900'),
('84601900:2X', '- Ostatné brúsky, nastaviteľné v ľubovoľnej osi s presnosťou najmenej 0,01 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84601900:2X'),
('846021', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846021'),
('846021:2X', '--- Na valcové povrchy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846021:2X'),
('84602111', '---- Brúsky na brúsenie vnútorných valcových plôch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84602111'),
('84602115', '---- Brúsky na bezhrotové brúsenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84602115'),
('84602119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84602119'),
('84602190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84602190'),
('846029', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846029'),
('84602910', '--- Na valcové povrchy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84602910'),
('84602990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84602990'),
('84602990:2X', '- Stroje používané na ostrenie (brúsky nástrojov alebo obrábacích nožov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84602990:2X'),
('84603100', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84603100'),
('84603900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84603900'),
('846040', '- Stroje na honovanie alebo lapovanie (dohladzovanie)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846040'),
('84604010', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84604010'),
('84604090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84604090'),
('846090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846090'),
('84609010', '-- Vybavené mikrometrickým nastavovacím systémom umožňujúcim nastavenie v ľubovoľnej osi s presnosťou najmenej 0,01 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84609010'),
('84609090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84609090'),
('8461', 'Obrábacie stroje na hobľovanie, obrážanie, drážkovanie, preťahovanie, obrábanie ozubení, brúsenie ozubení alebo ich konečné úpravy, strojové píly, odrezávacie stroje a ostatné stroje pracujúce metódou úberu kovov alebo cermetov, inde nešpecifikované ani', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8461'),
('84612000', '- Vodorovné alebo zvislé obrážačky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84612000'),
('846130', '- Preťahovacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846130'),
('84613010', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84613010'),
('84613090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84613090'),
('846140', '- Stroje na obrábanie, brúsenie alebo na konečnú úpravu ozubení', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846140'),
('846140:2X', '-- Stroje na obrábanie ozubení (vrátane strojov na brúsenie ozubení pomocou brúsiv)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846140:2X'),
('846140:3X', '--- Na zhotovovanie čelného ozubenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846140:3X'),
('84614011', '---- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84614011'),
('84614019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84614019'),
('84614019:2X', '--- Na zhotovovanie ostatných ozubení', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84614019:2X'),
('84614031', '---- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84614031'),
('84614039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84614039'),
('84614039:2X', '-- Stroje na konečnú úpravu ozubení', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84614039:2X'),
('84614039:3X', '--- Vybavené mikrometrickým nastavovacím systémom umožňujúcim nastavenie ľubovoľnej osi s presnosťou najmenej 0,01 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84614039:3X'),
('84614071', '---- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84614071'),
('84614079', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84614079'),
('84614090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84614090'),
('846150', '- Strojové píly alebo odrezávacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846150'),
('846150:2X', '-- Strojové píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846150:2X'),
('84615011', '--- Kotúčové píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84615011'),
('84615019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84615019'),
('84615090', '-- Odrezávacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84615090'),
('84619000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84619000'),
('8462', 'Tvarovacie stroje (vrátane lisov) na opracovanie kovov kovaním, razením alebo lisovaním v zápustke, padacie buchary, pákové buchary a ostatné buchary; obrábacie stroje (vrátane lisov) používané na tvarovanie kovov ohýbaním, drážkovaním (plechu) a prekla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8462'),
('846210', '- Stroje na kovanie alebo lisovanie v zápustke (vrátane lisov) a buchary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846210'),
('84621010', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84621010'),
('84621090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84621090'),
('84621090:2X', '- Stroje na tvarovanie kovov ohýbaním, drážkovaním (plechu) a prekladaním, vyrovnávaním alebo rovnaním a rozkutím (vrátane lisov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84621090:2X'),
('846221', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846221'),
('84622110', '--- Na opracovávanie plochých výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84622110'),
('84622180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84622180'),
('846229', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846229'),
('84622910', '--- Na opracovávanie plochých výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84622910'),
('84622910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84622910:2X'),
('84622991', '---- Hydraulické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84622991'),
('84622998', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84622998'),
('84622998:2X', '- Strihacie stroje (vrátane lisov), iné ako kombinované strihacie a prebíjacie, dierovacie, narezávacie a nastrihovacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84622998:2X'),
('84623100', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84623100'),
('846239', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846239'),
('84623910', '--- Na opracovávanie plochých výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84623910'),
('84623910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84623910:2X'),
('84623991', '---- Hydraulické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84623991'),
('84623999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84623999'),
('84623999:2X', '- Dierovacie, prebíjacie, narezávacie, nastrihovacie alebo vrúbkovacie stroje (vrátane lisov), vrátane kombinovaných strihacích a prebíjacích, dierovacích, narezávacích a nastrihovacích strojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84623999:2X'),
('846241', '-- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846241'),
('84624110', '--- Na opracovávanie plochých výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84624110'),
('84624190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84624190'),
('846249', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846249'),
('84624910', '--- Na opracovávanie plochých výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84624910'),
('84624990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84624990'),
('84624990:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84624990:2X'),
('846291', '-- Hydraulické lisy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846291'),
('84629120', '--- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84629120'),
('84629180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84629180'),
('846299', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846299'),
('84629920', '--- Číslicovo riadené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84629920'),
('84629980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84629980'),
('8463', 'Ostatné obrábacie stroje na opracovanie kovov alebo cermetov, pracujúcich inak ako úberom materiálu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8463'),
('846310', '- Ťažné stolice na výrobu tyčí, rúrok, profilov, drôtov alebo podobných tovarov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846310'),
('84631010', '-- Ťažné stolice na výrobu drôtov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84631010'),
('84631090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84631090'),
('84632000', '- Valcovačky na závity', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84632000'),
('84633000', '- Stroje na ťahanie drôtov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84633000'),
('84639000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84639000'),
('8464', 'Obrábacie stroje na opracovanie kameňa, keramiky, betónu, azbestového cementu alebo podobných nerastných materiálov alebo stroje na opracovanie skla za studena', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8464'),
('84641000', '- Strojové píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84641000'),
('846420', '- Brúsiace alebo leštiace stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846420'),
('846420:2X', '-- Na opracovanie skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846420:2X'),
('84642011', '--- Optického skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84642011'),
('84642019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84642019'),
('84642080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84642080'),
('84649000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84649000'),
('8465', 'Obrábacie stroje (vrátane strojov na pribíjanie klincov, spájanie sponkami, glejenie alebo ostatné spájanie), na opracovanie dreva, korku, kostí, tvrdeného kaučuku, tvrdých plastov alebo podobných tvrdých materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8465'),
('846510', '- Stroje na rôzne druhy obrábania bez nutnosti meniť nástroje pri ich vykonávaní', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846510'),
('84651010', '-- S ručným prenosom obrobku medzi jednotlivými operáciami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84651010'),
('84651090', '-- S automatickým prenosom obrobku medzi jednotlivými operáciami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84651090'),
('84651090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84651090:2X'),
('846591', '-- Strojové píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846591'),
('84659110', '--- Pásové píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84659110'),
('84659120', '--- Kotúčové píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84659120'),
('84659190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84659190'),
('84659200', '-- Stroje na hobľovanie, frézovanie alebo tvarovanie (rezaním)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84659200'),
('84659300', '-- Stroje na brúsenie, hladenie alebo leštenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84659300'),
('84659400', '-- Ohýbacie alebo spájacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84659400'),
('84659500', '-- Vŕtačky alebo obrážačky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84659500'),
('84659600', '-- Stroje na štiepanie, krájanie alebo lúpanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84659600'),
('84659900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84659900'),
('8466', 'Časti a súčasti a príslušenstvo výhradne alebo hlavne na stroje a zariadenia položiek 8456 až 8465, vrátane upínacích prípravkov alebo nástrojových (nožových) držiakov, samočinných závitorezných hláv, deliacich hláv a ostatných špeciálnych prídavných za', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8466'),
('846610', '- Držiaky náradia a samočinné závitorezné hlavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846610'),
('846610:2X', '-- Nástrojové (nožové) držiaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846610:2X'),
('84661020', '--- Upínacie tŕne, upínacie puzdrá a objímky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84661020'),
('84661020:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84661020:2X'),
('84661031', '---- Na sústruhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84661031'),
('84661038', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84661038'),
('84661080', '-- Samočinné závitorezné hlavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84661080'),
('846620', '- Upínacie prípravky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846620'),
('84662020', '-- Upínacie prípravky na špecifické použitie; sady štandardných upínacích prípravkov a fixačných komponentov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84662020'),
('84662020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84662020:2X'),
('84662091', '--- Na sústruhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84662091'),
('84662098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84662098'),
('84663000', '- Deliace hlavy a ostatné špeciálne prídavné zariadenia k obrábacím strojom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84663000'),
('84663000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84663000:2X'),
('846691', '-- Na stroje položky 8464', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846691'),
('84669120', '--- Z liatiny alebo z liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84669120'),
('84669195', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84669195'),
('846692', '-- Na stroje položky 8465', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846692'),
('84669220', '--- Z liatiny alebo z liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84669220'),
('84669280', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84669280'),
('846693', '-- Na stroje položiek 8456 až 8461', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846693'),
('84669330', '--- Na stroje podpoložky 8456 90 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84669330'),
('84669370', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84669370'),
('84669400', '-- Na stroje položiek 8462 alebo 8463', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84669400'),
('8467', 'Ručné nástroje a náradie pneumatické, hydraulické alebo s vlastným zabudovaným elektrickým alebo neelektrickým motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8467'),
('8467:2X', '- Pneumatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8467:2X'),
('846711', '-- Rotačného typu, tiež kombinované rotačno-príklepové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846711'),
('84671110', '--- Na opracovanie kovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84671110'),
('84671190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84671190'),
('84671900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84671900'),
('84671900:2X', '- S vlastným zabudovaným elektrickým motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84671900:2X'),
('846721', '-- Vŕtačky všetkých druhov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846721'),
('84672110', '--- Schopné prevádzky bez vonkajšieho zdroja energie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672110'),
('84672110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84672110:2X'),
('84672191', '---- Elektropneumatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672191'),
('84672199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672199'),
('846722', '-- Píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846722'),
('84672210', '--- Reťazové píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672210'),
('84672230', '--- Kotúčové píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672230'),
('84672290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672290'),
('846729', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846729'),
('84672920', '--- Schopné prevadzky bez vonkajšieho zdroja energie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672920'),
('84672920:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84672920:2X'),
('84672920:3X', '---- Brúsky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84672920:3X'),
('84672951', '----- Uhlové brúsky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672951'),
('84672953', '----- Pásové brúsky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672953'),
('84672959', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672959'),
('84672970', '---- Hoblíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672970'),
('84672980', '---- Strihače živých plotov a trávnikov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672980'),
('84672985', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84672985'),
('84672985:2X', '- Ostatné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84672985:2X'),
('84678100', '-- Reťazové píly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84678100'),
('84678900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84678900'),
('84678900:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84678900:2X'),
('84679100', '-- Reťazových píl', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84679100'),
('84679200', '-- Pneumatického náradia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84679200'),
('84679900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84679900'),
('8468', 'Stroje a prístroje na spájkovanie na tvrdo alebo mäkko alebo na zváranie, tiež na rezanie, iné ako položky 8515; plynové stroje a prístroje na povrchové kalenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8468'),
('84681000', '- Ručné spájkovacie horáky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84681000'),
('84682000', '- Ostatné plynové stroje a prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84682000'),
('84688000', '- Ostatné stroje a prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84688000'),
('84689000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84689000'),
('846900', 'Písacie stroje iné ako tlačiarne položky 8443; stroje na spracovanie textu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_846900'),
('84690010', '- Stroje na spracovanie textu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84690010'),
('84690010:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84690010:2X'),
('84690091', '-- Elektrické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84690091'),
('84690099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84690099'),
('8470', 'Počítacie stroje a vreckové prístroje na záznam, vyvolanie a zobrazenie údajov s výpočtovými funkciami; účtovacie stroje, frankovacie stroje, stroje na vydávanie lístkov a podobné stroje, vybavené počítacím zariadením; registračné pokladnice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8470'),
('84701000', '- Elektronické kalkulačky pracujúce bez vonkajšieho zdroja energie a vreckové prístroje na záznam, vyvolanie a zobrazenie údajov s výpočtovými funkciami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84701000'),
('84701000:2X', '- Ostatné elektronické počítacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84701000:2X'),
('84702100', '-- Vybavené tlačiarňou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84702100'),
('84702900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84702900'),
('84703000', '- Ostatné počítacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84703000'),
('84705000', '- Registračné pokladnice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84705000'),
('84709000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84709000'),
('8471', 'Stroje na automatické spracovanie údajov a ich jednotky; magnetické alebo optické snímače, stroje na prepis údajov v kódovanej forme na pamäťové médiá a stroje spracovávajúce tieto údaje, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8471'),
('84713000', '- Prenosné stroje na automatické spracovanie údajov s hmotnosťou nie väčšou ako 10 kg skladajúce sa najmenej z centrálnej spracovateľskej jednotky, klávesnice a displeja', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84713000'),
('84713000:2X', '- Ostatné stroje na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84713000:2X'),
('84714100', '-- Obsahujúce pod spoločným krytom najmenej centrálnu spracovateľskú jednotku, vstupnú a výstupnú jednotku, tiež kombinované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84714100'),
('84714900', '-- Ostatné, predkladané vo forme systému', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84714900'),
('84715000', '- Spracovateľské jednotky, iné ako podpoložky 8471 41 alebo 8471 49, tiež obsahujúce pod spoločným krytom jednu alebo dve z nasledujúcich jednotiek: pamäťové jednotky, vstupné jednotky, výstupné jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84715000'),
('847160', '- Vstupné alebo výstupné jednotky, tiež obsahujúce pod spoločným krytom aj pamäťové jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847160'),
('84716060', '-- Klávesnice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84716060'),
('84716070', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84716070'),
('847170', '- Pamäťové jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847170'),
('84717020', '-- Centrálne pamäťové jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84717020'),
('84717020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84717020:2X'),
('84717020:3X', '--- Diskové pamäťové jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84717020:3X'),
('84717030', '---- Optické, vrátane magnetooptických', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84717030'),
('84717030:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84717030:2X'),
('84717050', '----- Diskové jednotky s pevným diskom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84717050'),
('84717070', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84717070'),
('84717080', '--- Magnetické páskové pamäťové jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84717080'),
('84717098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84717098'),
('84718000', '- Ostatné jednotky strojov na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84718000'),
('84719000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84719000'),
('8472', 'Ostatné kancelárske stroje a prístroje (napríklad rozmnožovacie stroje hektografické alebo blanové, adresovacie stroje, automatické rozdeľovače bankoviek, stroje na triedenie, počítanie alebo na balenie mincí, prístroje na orezávanie ceruziek, dierkovac', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8472'),
('84721000', '- Rozmnožovacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84721000'),
('84723000', '- Stroje na triedenie alebo skladanie korešpondencie alebo na vkladanie do obálok alebo balíkov, stroje na otváranie, zatváranie alebo pečatenie korešpondencie a stroje na lepenie alebo pečiatkovanie poštových známok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84723000'),
('847290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847290'),
('84729010', '-- Stroje na triedenie, počítanie alebo balenie mincí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84729010'),
('84729030', '-- Automatické bankové stroje (bankomaty)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84729030'),
('84729070', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84729070'),
('8473', 'Časti, súčasti a príslušenstvo (iné ako kryty, kufríky a podobné výrobky) používané výhradne alebo hlavne na stroje položiek 8469 až 8472', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8473'),
('847310', '- Časti, súčasti a príslušenstvo na stroje položky 8469', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847310'),
('847310:2X', '-- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847310:2X'),
('84731011', '--- Strojov podpoložky 8469 00 10', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84731011'),
('84731019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84731019'),
('84731090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84731090'),
('84731090:2X', '- Časti, súčasti a príslušenstvo na stroje položky 8470', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84731090:2X'),
('847321', '-- K elektronickým počítacím strojom podpoložiek 8470 10, 8470 21 alebo 8470 29', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847321'),
('84732110', '--- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84732110'),
('84732190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84732190'),
('847329', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847329'),
('84732910', '--- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84732910'),
('84732990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84732990'),
('847330', '- Časti, súčasti a príslušenstvo na stroje položky 8471', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847330'),
('84733020', '-- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84733020'),
('84733080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84733080'),
('847340', '- Časti, súčasti a príslušenstvo na stroje položky 8472', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847340'),
('847340:2X', '-- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847340:2X'),
('84734011', '--- Strojov podpoložky 8472 90 30', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84734011'),
('84734018', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84734018'),
('84734080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84734080'),
('847350', '- Časti, súčasti a príslušenstvo vhodné na použitie k strojom alebo zariadeniam dvoch alebo viacerých položiek 8469 až 8472', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847350'),
('84735020', '-- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84735020'),
('84735080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84735080'),
('8474', 'Stroje a prístroje na triedenie, preosievanie, oddeľovanie, pranie, drvenie, mletie, miešanie alebo hnetenie zemín, kameňov, rúd alebo ostatných nerastných látok v pevnom stave (vrátane prášku alebo pasty); stroje a prístroje na aglomerovanie, tvarovani', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8474'),
('84741000', '- Stroje a prístroje na triedenie, preosievanie, oddeľovanie alebo na pranie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84741000'),
('84742000', '- Stroje na drvenie alebo mletie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84742000'),
('84742000:2X', '- Stroje na miešanie alebo hnetenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84742000:2X'),
('84743100', '-- Miešačky betónu alebo malty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84743100'),
('84743200', '-- Miešačky nerastnych látok s bitúmenom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84743200'),
('84743900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84743900'),
('847480', '- Ostatné stroje a prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847480'),
('84748010', '-- Stroje a prístroje na aglomerovanie, tvarovanie alebo lisovanie keramických látok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84748010'),
('84748090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84748090'),
('847490', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847490'),
('84749010', '-- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84749010'),
('84749090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84749090'),
('8475', 'Stroje a zariadenia na montáž žiaroviek alebo elektrónových svietidiel, trubíc, elektrónok, alebo výbojok, alebo bleskových žiariviek, v sklenených puzdrách; stroje na výrobu alebo na opracovanie skla alebo sklenených výrobkov za tepla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8475'),
('84751000', '- Stroje a zariadenia na montáž žiaroviek alebo elektrónových svietidiel, trubíc, elektrónok, alebo výbojok, alebo bleskových žiariviek, v sklenených puzdrách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84751000'),
('84751000:2X', '- Stroje na výrobu alebo na opracovanie skla alebo sklenených výrobkov za tepla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84751000:2X'),
('84752100', '-- Stroje na výrobu optických vlákien a ich predliskov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84752100'),
('84752900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84752900'),
('84759000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84759000'),
('8476', 'Predajné automaty (napríklad na predaj poštových známok, cigariet, potravín alebo nápojov), vrátane automatov na rozmieňanie mincí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8476'),
('8476:2X', '- Automaty na predaj nápojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8476:2X'),
('84762100', '-- So zabudovaným ohrievacím alebo chladiacim zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84762100'),
('84762900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84762900'),
('84762900:2X', '- Ostatné stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84762900:2X'),
('84768100', '-- So zabudovaným ohrievacím alebo chladiacim zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84768100'),
('84768900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84768900'),
('84769000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84769000'),
('8477', 'Stroje a zariadenia na spracovanie kaučuku alebo plastov alebo na výrobu výrobkov z týchto materiálov, v tejto kapitole inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8477'),
('84771000', '- Vstrekovacie lisy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84771000'),
('84772000', '- Vytláčacie lisy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84772000'),
('84773000', '- Stroje na tvarovanie vyfukovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84773000'),
('84774000', '- Stroje na tvarovanie podtlakom a ostatné stroje na tvarovanie za tepla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84774000'),
('84774000:2X', '- Ostatné stroje a zariadenia na lisovanie alebo ostatné tvarovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84774000:2X'),
('84775100', '-- Na lisovanie pneumatík alebo na obnovovanie (protektorovanie) pneumatík alebo na lisovanie alebo ostatné tvarovanie duší pneumatík', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84775100'),
('847759', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847759'),
('84775910', '--- Lisy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84775910'),
('84775980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84775980'),
('847780', '- Ostatné stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847780'),
('847780:2X', '-- Stroje na zhotovovanie penových výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847780:2X'),
('84778011', '--- Stroje na spracovanie reaktivovaných živíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84778011'),
('84778019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84778019'),
('84778019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84778019:2X'),
('84778091', '--- Zariadenia na redukciu veľkosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84778091'),
('84778093', '--- Mixéry, miesiče a miešače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84778093'),
('84778095', '--- Rezacie, štiepacie a šúpacie stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84778095'),
('84778099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84778099'),
('847790', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847790'),
('84779010', '-- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84779010'),
('84779080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84779080'),
('8478', 'Stroje a zariadenia na prípravu alebo na spracovanie tabaku, v tejto kapitole inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8478'),
('84781000', '- Stroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84781000'),
('84789000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84789000'),
('8479', 'Stroje a mechanické zariadenia s vlastnou individuálnou funkciou, v tejto kapitole inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8479'),
('84791000', '- Stroje a zariadenia na verejné práce, stavebníctvo alebo podobné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84791000'),
('84792000', '- Stroje a zariadenia na extrakciu alebo na prípravu živočíšnych alebo stužených rastlinných tukov alebo olejov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84792000'),
('847930', '- Lisy na výrobu drevotrieskových dosiek alebo vláknitých dosiek z dreva alebo ostatných drevitých materiálov a ostatné stroje a zariadenia na spracovanie dreva alebo korku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847930'),
('84793010', '-- Lisy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84793010'),
('84793090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84793090'),
('84794000', '- Stroje na výrobu lán, povrazov alebo káblov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84794000'),
('84795000', '- Priemyslové roboty, inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84795000'),
('84796000', '- Zariadenia na ochladzovanie vzduchu odparovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84796000'),
('84796000:2X', '- Nástupné mostíky pre cestujúcich', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84796000:2X'),
('84797100', '-- Používané na letiskách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84797100'),
('84797900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84797900'),
('84797900:2X', '- Ostatné stroje a mechanické zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84797900:2X'),
('84798100', '-- Na spracovanie kovov, vrátane navíjačiek elektrických vodičov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84798100'),
('84798200', '-- Stroje na zmiešavanie, hnetenie, drvenie, mletie, triedenie, preosievanie, homogenizovanie, emulgovanie alebo miešanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84798200'),
('847989', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847989'),
('84798930', '--- Pojazdné hydraulicky ovládané výstuže banských chodieb', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84798930'),
('84798960', '--- Centrálne mazacie systémy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84798960'),
('84798997', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84798997'),
('847990', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_847990'),
('84799020', '-- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84799020'),
('84799080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84799080'),
('8480', 'Formovacie rámy pre zlievarne kovov; formovacie základne; modely na formy; formy na kovy (iné ako ingotové kokily), karbidy kovov, sklo, nerastné materiály, kaučuk alebo plasty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8480'),
('84801000', '- Formovacie rámy pre zlievárne kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84801000'),
('84802000', '- Formovacie základne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84802000'),
('848030', '- Modely na formy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848030'),
('84803010', '-- Z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84803010'),
('84803090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84803090'),
('84803090:2X', '- Formy na kovy alebo karbidy kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84803090:2X'),
('84804100', '-- Vstrekovacieho alebo kompresného typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84804100'),
('84804900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84804900'),
('84805000', '- Formy na sklo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84805000'),
('84806000', '- Formy na nerastné materiály', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84806000'),
('84806000:2X', '- Formy na kaučuk alebo plasty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84806000:2X'),
('84807100', '-- Vstrekovacieho alebo kompresného typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84807100'),
('84807900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84807900'),
('8481', 'Kohútiky, ventily a podobné zariadenia na potrubia, kotly, nádrže, vane alebo podobné kade, vrátane redukčných ventilov a ventilov riadených termostatom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8481'),
('848110', '- Redukčné ventily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848110'),
('84811005', '-- Kombinované s filtrami alebo maznicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84811005'),
('84811005:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84811005:2X'),
('84811019', '--- Z liatiny alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84811019'),
('84811099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84811099'),
('848120', '- Ventily na olejohydraulické alebo pneumatické prevodovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848120'),
('84812010', '-- Ventily na riadenie výkonu olejohydraulickej prevodovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84812010'),
('84812090', '-- Ventily na riadenie výkonu pneumatickej prevodovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84812090'),
('848130', '- Bezpečnostné spätné (jednosmerné) ventily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848130'),
('84813091', '-- Z liatiny alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84813091'),
('84813099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84813099'),
('848140', '- Poistné alebo odvzdušňovacie ventily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848140'),
('84814010', '-- Z liatiny alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84814010'),
('84814090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84814090'),
('848180', '- Ostatné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848180'),
('848180:2X', '-- Vodovodné kohútiky a ventily na drezy, umývadlá, bidety, vodné nádrže, vane, a podobné armatúry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848180:2X'),
('84818011', '--- Mixážne ventily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818011'),
('84818019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818019'),
('84818019:2X', '-- Ventily radiátorov ústredného kúrenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818019:2X'),
('84818031', '--- Termostatické ventily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818031'),
('84818039', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818039'),
('84818040', '-- Ventily na pneumatiky a duše', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818040'),
('84818040:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818040:2X'),
('84818040:3X', '--- Regulačné ventily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818040:3X'),
('84818051', '---- Regulátory teploty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818051'),
('84818059', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818059'),
('84818059:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818059:2X'),
('84818059:3X', '---- Uzatváracie ventily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818059:3X'),
('84818061', '----- Z liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818061'),
('84818063', '----- Z ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818063'),
('84818069', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818069'),
('84818069:2X', '---- Ventily guľové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818069:2X'),
('84818071', '----- Z liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818071'),
('84818073', '----- Z ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818073'),
('84818079', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818079'),
('84818081', '---- Guľové a kužeľové ventily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818081'),
('84818085', '---- Škrtiace ventily (klapky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818085'),
('84818087', '---- Membránové ventily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818087'),
('84818099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84818099'),
('84819000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84819000'),
('8482', 'Guľkové alebo valčekové ložiská', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8482'),
('848210', '- Guľkové ložiská', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848210'),
('84821010', '-- S maximálnym vonkajším priemerom nepresahujúcim 30 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84821010'),
('84821090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84821090'),
('84822000', '- Kuželíkové ložiská, vrátane zostáv kužeľových a kuželíkových ložísk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84822000'),
('84823000', '- Súdočkové ložiská', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84823000'),
('84824000', '- Ihlové ložiská', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84824000'),
('84825000', '- Ostatné valčekové ložiská', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84825000'),
('84828000', '- Ostatné, vrátane kombinovaných guľkových a valčekových ložísk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84828000'),
('84828000:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84828000:2X'),
('848291', '-- Guľôčky, ihly a valčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848291'),
('84829110', '--- Kužeľové valčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84829110'),
('84829190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84829190'),
('84829900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84829900'),
('8483', 'Prevodové hriadele (vrátane vačkových hriadeľov a kľukových hriadeľov) a kľuky; ložiskové puzdrá a klzné ložiská; ozubené súkolesie a ozubené prevody; pohybové skrutky s guľkovou alebo valčekovou maticou; prevodovky, prevodové skrine a ostatné meniče rý', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8483'),
('848310', '- Prevodové hriadele (vrátane vačkových hriadeľov a kľukových hriadeľov) a kľuky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848310'),
('848310:2X', '-- Kľuky a kľukové hriadele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848310:2X'),
('84831021', '--- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84831021'),
('84831025', '--- Z kovanej zápustkovej ocele (open-die)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84831025'),
('84831029', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84831029'),
('84831050', '-- Kĺbové hriadele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84831050'),
('84831095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84831095'),
('84832000', '- Ložiskové puzdrá, s guľkovými alebo valčekovými ložiskami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84832000'),
('848330', '- Ložiskové puzdrá, bez guľkových alebo valčekových ložísk; klzné ložiská', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848330'),
('848330:2X', '-- Ložiskové puzdrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848330:2X'),
('84833032', '--- Na guľkové alebo valčekové ložiská', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84833032'),
('84833038', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84833038'),
('84833080', '-- Klzné ložiská', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84833080'),
('848340', '- Ozubené súkolesie a ozubené prevody iné ako ozubené kolesá, reťazové kolesá a ostatné súčasti prevodov predkladané samostatne; pohybové skrutky s guľkovou alebo valčekovou maticou; prevodovky, prevodové skrine a ostatné meniče rýchlosti, vrátane meničo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848340'),
('848340:2X', '-- Ozubené súkolesie a ozubené prevody (iné ako trecie prevody)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848340:2X'),
('84834021', '--- Čelné šikmé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84834021'),
('84834023', '--- Kužeľové a kužeľové/čelné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84834023'),
('84834025', '--- Závitovové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84834025'),
('84834029', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84834029'),
('84834030', '-- Pohybové skrutky s guľkovou alebo valčekovou maticou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84834030'),
('84834030:2X', '-- Prevodovky, prevodové skrine a ostatné meniče rýchlosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84834030:2X'),
('84834051', '--- Prevodovky a prevodové skrine', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84834051'),
('84834059', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84834059'),
('84834090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84834090'),
('848350', '- Zotrvačníky a remenice, vrátane kladníc na kladkostroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848350'),
('84835020', '-- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84835020'),
('84835080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84835080'),
('848360', '- Spojky a hriadeľové spojky (vrátane kardanových kĺbov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848360'),
('84836020', '-- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84836020'),
('84836080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84836080'),
('848390', '- Ozubené kolesá, reťazové kolesá a ostatné súčastí prevodov predkladané samostatne; časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848390'),
('84839020', '-- Častí a súčastí ložiskových puzdier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84839020'),
('84839020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84839020:2X'),
('84839081', '--- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84839081'),
('84839089', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84839089'),
('8484', 'Tesnenia a podobné spojenia z kovových fólií kombinovaných s ostatným materiálom alebo s dvoma alebo viacerými vrstvami z kovu; súbory alebo zostavy tesnení a podobných spojení rôzneho zloženia, balené vo vrecúškach, obálkach alebo v podobných obaloch;', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8484'),
('84841000', '- Tesnenia a podobné spojenia z kovových fólií kombinovaných s ostatným materiálom alebo s dvoma alebo viacerými vrstvami z kovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84841000'),
('84842000', '- Mechanické upchávky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84842000'),
('84849000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84849000'),
('8486', 'Stroje a prístroje druhu používaného výhradne alebo hlavne na výrobu polovodičových kryštálov alebo doštičiek, polovodičových zariadení, elektronických integrovaných obvodov alebo plochých panelových displejov; stroje a prístroje špecifikované v poznámk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8486'),
('84861000', '- Stroje a prístroje na výrobu polovodičových kryštálov alebo doštičiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84861000'),
('848620', '- Stroje a prístroje na výrobu polovodičových zariadení alebo elektronických integrovaných obvodov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848620'),
('84862010', '-- Obrábacie stroje pracujúce pomocou ultrazvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84862010'),
('84862090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84862090'),
('848630', '- Stroje a prístroje na výrobu plochých panelových displejov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848630'),
('84863010', '-- Prístroje na chemické pokovovanie podložiek s tekutými kryštálmi (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84863010'),
('84863030', '-- Prístroje na suché leptanie predlôh na podložky s tekutými kryštálmi (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84863030'),
('84863050', '-- Prístroje na fyzikálne pokovovanie podložiek s tekutými kryštálmi (LCD) rozprašovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84863050'),
('84863090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84863090'),
('84864000', '- Stroje a prístroje špecifikované v poznámke 9 C) k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84864000'),
('848690', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848690'),
('84869010', '-- Držiaky náradia a samočinné závitorezné hlavy; upínacie zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84869010'),
('84869010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84869010:2X'),
('84869020', '--- Časti a súčasti odstrediviek na nanášanie fotografických emulzií na podložky s tekutými kryštálmi (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84869020'),
('84869030', '--- Časti a súčasti tryskacích strojov na čistenie a odstraňovanie nečistôt z kovových plôch polovodičových obalov pred elektrickým pokovovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84869030'),
('84869040', '--- Časti a súčasti prístrojov na fyzikálne pokovovanie podložiek s tekutými kryštálmi (LCD) rozprašovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84869040'),
('84869050', '--- Časti, súčasti a príslušenstvo prístrojov na suché leptanie predlôh na podložky s tekutými kryštálmi (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84869050'),
('84869060', '--- Časti, súčasti a príslušenstvo prístrojov na chemické pokovovanie podložiek s tekutými kryštálmi (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84869060'),
('84869070', '--- Časti, súčasti a príslušenstvo obrábacích strojov pracujúcich pomocou ultrazvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84869070'),
('84869090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84869090'),
('8487', 'Časti a súčasti strojov a zariadení, neobsahujúce elektrické svorky, izolácie, cievky, kontakty alebo ostatné elektrické prvky, v tejto kapitole inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8487'),
('848710', '- Lodné vrtule a ich lopatky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848710'),
('84871010', '-- Z bronzu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84871010'),
('84871090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_84871090'),
('848790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_848790'),
('84879040', '-- Z liatiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84879040'),
('84879040:2X', '-- Zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84879040:2X'),
('84879051', '--- Z liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84879051'),
('84879057', '--- Z kovanej zápustkovej ocele alebo železa (open-die, closed-die)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84879057'),
('84879059', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84879059'),
('84879090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_84879090'),
('8501', 'Elektrické motory a generátory (okrem generátorových agregátov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8501'),
('850110', '- Motory s výkonom nepresahujúcim 37,5 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850110'),
('85011010', '-- Synchrónne motory s výkonom nepresahujúcim 18 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85011010'),
('85011010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85011010:2X'),
('85011091', '--- Univerzálne motory na jednosmerný aj striedavý prúd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85011091'),
('85011093', '--- Motory na striedavý prúd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85011093'),
('85011099', '--- Motory na jednosmerný prúd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85011099'),
('85012000', '- Univerzálne motory na jednosmerný aj striedavý prúd, s výkonom presahujúcim 37,5 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85012000'),
('85012000:2X', '- Ostatné motory na jednosmerný prúd; dynamá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85012000:2X'),
('85013100', '-- S výkonom nepresahujúcim 750 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85013100'),
('85013200', '-- S výkonom presahujúcim 750 W, ale nepresahujúcim 75 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85013200'),
('85013300', '-- S výkonom presahujúcim 75 kW, ale nepresahujúcim 375 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85013300'),
('85013400', '-- S výkonom presahujúcim 375 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85013400'),
('850140', '- Ostatné jednofázové motory na striedavý prúd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850140'),
('85014020', '-- S výkonom nepresahujúcim 750 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85014020'),
('85014080', '-- S výkonom presahujúcim 750 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85014080'),
('85014080:2X', '- Ostatné viacfázové motory na striedavý prúd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85014080:2X'),
('85015100', '-- S výkonom nepresahujúcim 750 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85015100'),
('850152', '-- S výkonom presahujúcim 750 W, ale nepresahujúcim 75 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850152'),
('85015220', '--- S výkonom presahujúcim 750 W, ale nepresahujúcim 7,5 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85015220'),
('85015230', '--- S výkonom presahujúcim 7,5 kW, ale nepresahujúcim 37 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85015230'),
('85015290', '--- S výkonom presahujúcim 37 kW, ale nepresahujúcim 75 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85015290'),
('850153', '-- S výkonom presahujúcim 75 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850153'),
('85015350', '--- Trakčné motory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85015350'),
('85015350:2X', '--- Ostatné, s výkonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85015350:2X'),
('85015381', '---- Presahujúcim 75 kW, ale nepresahujúcim 375 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85015381'),
('85015394', '---- Presahujúcim 375 kW, ale nepresahujúcim 750 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85015394'),
('85015399', '---- Presahujúcim 750 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85015399'),
('85015399:2X', '- Generátory na striedavý prúd (alternátory)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85015399:2X'),
('850161', '-- S výkonom nepresahujúcim 75 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850161'),
('85016120', '--- S výkonom nepresahujúcim 7,5 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85016120'),
('85016180', '--- S výkonom presahujúcim 7,5 kVA, ale nepresahujúcim 75 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85016180'),
('85016200', '-- S výkonom presahujúcim 75 kVA, ale nepresahujúcim 375 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85016200'),
('85016300', '-- S výkonom presahujúcim 375 kVA, ale nepresahujúcim 750 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85016300'),
('85016400', '-- S výkonom presahujúcim 750 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85016400'),
('8502', 'Elektrické generátorové agregáty a rotačné meniče (konvertory)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8502'),
('8502:2X', '- Elektrické generátorové agregáty so vznetovým piestovým spaľovacím motorom (dieselové motory alebo motory so žiarovou hlavou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8502:2X'),
('850211', '-- S výkonom nepresahujúcim 75 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850211'),
('85021120', '--- S výkonom nepresahujúcim 7,5 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85021120'),
('85021180', '--- S výkonom presahujúcim 7,5 kVA, ale nepresahujúcim 75 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85021180'),
('85021200', '-- S výkonom presahujúcim 75 kVA, ale nepresahujúcim 375 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85021200'),
('850213', '-- S výkonom presahujúcim 375 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850213'),
('85021320', '--- S výkonom presahujúcim 375 kVA, ale nepresahujúcim 750 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85021320'),
('85021340', '--- S výkonom presahujúcim 750 kVA, ale nepresahujúcim 2 000 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85021340'),
('85021380', '--- S výkonom presahujúcim 2 000 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85021380'),
('850220', '- Generátorové agregáty so zážihovými piestovým spaľovacím motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850220'),
('85022020', '-- S výkonom nepresahujúcim 7,5 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85022020'),
('85022040', '-- S výkonom presahujúcim 7,5 kVA, ale nepresahujúcim 375 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85022040'),
('85022060', '-- S výkonom presahujúcim 375 kVA, ale nepresahujúcim 750 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85022060'),
('85022080', '-- S výkonom presahujúcim 750 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85022080'),
('85022080:2X', '- Ostatné generátorové agregáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85022080:2X'),
('85023100', '-- Na veternú energiu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85023100'),
('850239', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850239'),
('85023920', '--- Turbogenerátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85023920'),
('85023980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85023980'),
('85024000', '- Elektrické rotačné meniče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85024000'),
('850300', 'Časti a súčasti určené výhradne alebo hlavne na stroje položky 8501 alebo 8502', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850300'),
('85030010', '- Nemagnetické prídržné krúžky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85030010'),
('85030010:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85030010:2X'),
('85030091', '-- Z liatiny alebo z liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85030091'),
('85030099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85030099'),
('8504', 'Elektrické transformátory, statické meniče (napríklad usmerňovače) a induktory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8504'),
('850410', '- Odpory (predradníky) na výbojky alebo výbojkové trubice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850410'),
('85041020', '-- Induktory, tiež spojené s kondenzátorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85041020'),
('85041080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85041080'),
('85041080:2X', '- Transformátory s kvapalinovým dielektrikom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85041080:2X'),
('85042100', '-- S výkonom nepresahujúcim 650 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85042100'),
('850422', '-- S výkonom presahujúcim 650 kVA, ale nepresahujúcim 10 000 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850422'),
('85042210', '--- S výkonom presahujúcim 650 kVA, ale nepresahujúcim 1 600 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85042210'),
('85042290', '--- S výkonom presahujúcim 1 600 kVA, ale nepresahujúcim 10 000 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85042290'),
('85042300', '-- S výkonom presahujúcim 10 000 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85042300'),
('85042300:2X', '- Ostatné transformátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85042300:2X'),
('850431', '-- S výkonom nepresahujúcim 1 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850431'),
('850431:2X', '--- Meracie transformátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850431:2X'),
('85043121', '---- Na meranie napätia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85043121'),
('85043129', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85043129'),
('85043180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85043180'),
('85043200', '-- S výkonom presahujúcim 1 kVA, ale nepresahujúcim 16 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85043200'),
('85043300', '-- S výkonom presahujúcim 16 kVA, ale nepresahujúcim 500 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85043300'),
('85043400', '-- S výkonom presahujúcim 500 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85043400'),
('850440', '- Statické meniče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850440'),
('85044030', '-- Druhy používané s telekomunikačnými prístrojmi, strojmi na automatické spracovanie údajov a ich jednotkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85044030'),
('85044030:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85044030:2X'),
('85044055', '--- Nabíjače akumulátorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85044055'),
('85044055:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85044055:2X'),
('85044082', '---- Usmerňovače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85044082'),
('85044082:2X', '---- Invertory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85044082:2X'),
('85044084', '----- S výkonom nepresahujúcim 7,5 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85044084'),
('85044088', '----- S výkonom presahujúcim 7,5 kVA', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85044088'),
('85044090', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85044090'),
('850450', '- Ostatné induktory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850450'),
('85045020', '-- Druhy používané s telekomunikačným prístrojmi a s napájacími zdrojmi pre stroje na automatické spracovanie údajov a ich jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85045020'),
('85045095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85045095'),
('850490', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850490'),
('850490:2X', '-- Transformátorov a induktorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850490:2X'),
('85049005', '--- Elektronické zostavy pre výrobky podpoložky 8504 50 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85049005'),
('85049005:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85049005:2X'),
('85049011', '---- Feritové jadrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85049011'),
('85049018', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85049018'),
('85049018:2X', '-- Statických meničov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85049018:2X'),
('85049091', '--- Elektronické zostavy pre výrobky podpoložky 8504 40 30', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85049091'),
('85049099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85049099'),
('8505', 'Elektromagnety; permanentné magnety a výrobky určené na zmagnetizovanie na permanentné magnety; upínacie dosky, skľučovadlá a ostatné podobné upínacie zariadenia, s elektromagnetmi alebo permanentnými magnetmi; elektromagnetické spojky a brzdy; elektrom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8505'),
('8505:2X', '- Permanentné magnety a výrobky určené na zmagnetizovanie na permanentné magnety', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8505:2X'),
('85051100', '-- Kovové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85051100'),
('850519', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850519'),
('85051910', '--- Permanentné magnety z aglomerovaných feritov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85051910'),
('85051990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85051990'),
('85052000', '- Elektromagnetické spojky a brzdy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85052000'),
('850590', '- Ostatné, vrátane častí a súčastí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850590'),
('85059020', '-- Elektromagnety; upínacie dosky, skľučovadlá a ostatné podobné upínacie zariadenia, s elektromagnetmi alebo permanentnými magnetmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85059020'),
('85059050', '-- Elektromagnetické zdvíhacie hlavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85059050'),
('85059090', '-- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85059090'),
('8506', 'Galvanické články a batérie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8506'),
('850610', '- Na báze oxidu manganičitého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850610'),
('850610:2X', '-- Alkalické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850610:2X'),
('85061011', '--- Valcové články', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85061011'),
('85061018', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85061018'),
('85061018:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85061018:2X'),
('85061091', '--- Valcové články', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85061091'),
('85061098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85061098'),
('85063000', '- Na báze oxidu ortuťnatého', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85063000'),
('85064000', '- Na báze oxidu strieborného', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85064000'),
('850650', '- Lítiové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850650'),
('85065010', '-- Valcové články', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85065010'),
('85065030', '-- Gombíkové články', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85065030'),
('85065090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85065090'),
('85066000', '- Zinkovovzdušné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85066000'),
('850680', '- Ostatné galvanické články a batérie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850680'),
('85068005', '-- Suché zinko-uhlíkové články s napätím 5,5 V alebo viac, ale nepresahujúcim 6,5 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85068005'),
('85068080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85068080'),
('85069000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85069000'),
('8507', 'Elektrické akumulátory, vrátane ich separátorov, tiež pravouhlé (vrátane štvorcových)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8507'),
('850710', '- Olovené, používané na štartovanie piestových motorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850710'),
('85071020', '-- Na báze tekutého elektrolytu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85071020'),
('85071080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85071080'),
('850720', '- Ostatné olovené akumulátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850720'),
('85072020', '-- Na báze tekutého elektrolytu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NCL'), 'SK_85072020'),
('85072080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NCL'), 'SK_85072080'),
('850730', '- Niklo-kadmiové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850730'),
('85073020', '-- Hermeticky uzavreté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85073020'),
('85073080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NCL'), 'SK_85073080'),
('85074000', '- Niklo-železné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85074000'),
('85075000', '- Niklo-kovové hydridové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85075000'),
('85076000', '- Na báze lítiových iónov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85076000'),
('85078000', '- Ostatné akumulátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85078000'),
('850790', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_850790'),
('85079030', '-- Separátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85079030'),
('85079080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85079080'),
('8508', 'Vysávače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8508'),
('8508:2X', '- So vstavaným elektrickým motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8508:2X'),
('85081100', '-- S výkonom nepresahujúcim 1 500 W a v ktorých objemová kapacita vrecka na prach alebo iného zásobníka nepresahuje 20 l', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85081100'),
('85081900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85081900'),
('85086000', '- Ostatné vysávače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85086000'),
('85087000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85087000'),
('8509', 'Elektromechanické zariadenia pre domácnosť, so vstavaným elektrickým motorom, iné ako vysávače položky 8508', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8509'),
('85094000', '- Zariadenia na mletie potravín a mixéry potravín; odšťavovače ovocia alebo zeleniny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85094000'),
('85098000', '- Ostatné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85098000'),
('85099000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85099000'),
('8510', 'Holiace strojčeky, strojčeky na strihanie vlasov a srsti a depilačné prístroje, so vstavaným elektrickým motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8510'),
('85101000', '- Holiace strojčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85101000'),
('85102000', '- Strojčeky na strihanie vlasov a srsti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85102000'),
('85103000', '- Depilačné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85103000'),
('85109000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85109000'),
('8511', 'Elektrické zapaľovacie alebo spúšťacie prístroje a zariadenia na zážihové alebo vznetové spaľovacie motory [(napríklad magnetické zapaľovače, magneto-dynamá, zapaľovacie cievky, zapaľovacie a žeraviace sviečky, spúšťače)]; generátory (napríklad dynamá,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8511'),
('85111000', '- Zapaľovacie sviečky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85111000'),
('85112000', '- Magnetické zapaľovače; magneto-dynamá; zotrvačníky s magnetom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85112000'),
('85113000', '- Rozdeľovače; zapaľovacie cievky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85113000'),
('85114000', '- Spúšťače, tiež pracujúce ako štartovacie generátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85114000'),
('85115000', '- Ostatné generátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85115000'),
('85118000', '- Ostatné prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85118000'),
('85119000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85119000'),
('8512', 'Elektrické prístroje osvetľovacie alebo signalizačné (okrem výrobkov položky 8539), elektrické stierače, rozmrazovače a odhmlievače, na bicykle alebo motorové vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8512'),
('85121000', '- Svetelné alebo vizuálne signalizačné prístroje na bicykle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85121000'),
('85122000', '- Ostatné svetelné alebo vizuálne signalizačné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85122000'),
('851230', '- Zvukové signalizačné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851230'),
('85123010', '-- Poplachové zariadenia na ochranu proti vlámaniu druhov používaných pre motorové vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85123010'),
('85123090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85123090'),
('85124000', '- Stierače, rozmrazovače a odhmlievače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85124000'),
('851290', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851290'),
('85129010', '-- Prístrojov podpoložky 8512 30 10', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85129010'),
('85129090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85129090'),
('8513', 'Prenosné elektrické svietidlá s vlastným zdrojom elektrickej energie (napríklad na suché články, akumulátory, dynamá), iné ako osvetľovacie prístroje položky 8512', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8513'),
('85131000', '- Svietidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85131000'),
('85139000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85139000'),
('8514', 'Elektrické pece a rúry priemyselné alebo laboratórne pece a rúry (vrátane fungujúcich s indukčnou alebo dielektrickou stratou); ostatné priemyselné alebo laboratórne zariadenia na tepelné spracovanie materiálov indukčnou alebo dielektrickou stratou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8514'),
('851410', '- Pece a rúry vyhrievané pomocou odporov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851410'),
('85141010', '-- Pekárske a cukrárske rúry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85141010'),
('85141080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85141080'),
('851420', '- Pece a rúry fungujúce s indukčnou alebo dielektrickou stratou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851420'),
('85142010', '-- Indukčné pece a rúry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85142010'),
('85142080', '-- Dielektrické pece a rúry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85142080'),
('85143000', '- Ostatné pece a rúry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85143000'),
('85144000', '- Ostatné zariadenia na tepelné spracovanie materiálov indukčnou alebo dielektrickou stratou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85144000'),
('85149000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85149000'),
('8515', 'Stroje a prístroje elektrické (vrátane tých na elektricky vyhrievaný plyn), laserové alebo využívajúce ostatné svetelné alebo fotónové zväzky, ultrazvukové, využívajúce elektrónové zväzky, magnetické impulzy alebo plazmové výboje na spájkovanie alebo zv', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8515'),
('8515:2X', '- Stroje a prístroje spájkovacie na tvrdo alebo mäkko', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8515:2X'),
('85151100', '-- Spájkovačky a spájkovacie pištole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85151100'),
('85151900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85151900'),
('85151900:2X', '- Stroje a prístroje na odporové zváranie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85151900:2X'),
('85152100', '-- Plno alebo čiastočne automatizované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85152100'),
('85152900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85152900'),
('85152900:2X', '- Stroje a prístroje na oblúkové zváranie (vrátane plazmového výboja) kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85152900:2X'),
('85153100', '-- Plno alebo čiastočne automatizované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85153100'),
('851539', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851539'),
('851539:2X', '--- Na ručné zváranie pomocou potiahnutých elektród, v spojení so zváracím alebo rezacím zariadením a dodávané s', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851539:2X'),
('85153913', '---- Transformátormi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85153913'),
('85153918', '---- Generátormi alebo rotačnými alebo statickými meničmi, usmerňovačmi alebo usmerňovacími prístrojmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85153918'),
('85153990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85153990'),
('851580', '- Ostatné stroje a prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851580'),
('85158010', '-- Na opracovanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85158010'),
('85158090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85158090'),
('85159000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85159000'),
('8516', 'Elektrické prietokové alebo zásobníkové ohrievače vody a ponorné ohrievače; elektrické zariadenia na vykurovanie priestorov a pôdy; elektrotepelné zariadenia na úpravu vlasov (napríklad sušiče vlasov, kulmy na vlasy, prístroje na trvalú onduláciu) a suš', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8516'),
('851610', '- Elektrické prietokové alebo zásobníkové ohrievače vody a ponorné ohrievače vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851610'),
('85161011', '-- Prietokové ohrievače vody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85161011'),
('85161080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85161080'),
('85161080:2X', '- Elektrické zariadenia na vykurovanie priestorov a pôdy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85161080:2X'),
('85162100', '-- Akumulačné radiátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85162100'),
('851629', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851629'),
('85162910', '--- Radiátory plnené kvapalinou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85162910'),
('85162950', '--- Konvektory na vykurovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85162950'),
('85162950:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85162950:2X'),
('85162991', '---- So zabudovaným ventilátorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85162991'),
('85162999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85162999'),
('85162999:2X', '- Elektrotepelné zariadenia na úpravu vlasov alebo sušenie rúk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85162999:2X'),
('85163100', '-- Sušiče vlasov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85163100'),
('85163200', '-- Ostatné zariadenia na úpravu vlasov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85163200'),
('85163300', '-- Sušiče rúk', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85163300'),
('85164000', '- Elektrické žehličky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85164000'),
('85165000', '- Mikrovlnné rúry a pece', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85165000'),
('851660', '- Ostatné rúry a pece; variče, sporáky, varné dosky, varné telieska; grily a opekače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851660'),
('85166010', '-- Sporáky (aspoň s rúrou a špirálou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85166010'),
('85166050', '-- Varné dosky, varné telieska a špirály', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85166050'),
('85166070', '-- Grily a opekače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85166070'),
('85166080', '-- Rúry a pece na zabudovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85166080'),
('85166090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85166090'),
('85166090:2X', '- Ostatné elektrotepelné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85166090:2X'),
('85167100', '-- Kávovary alebo čajovary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85167100'),
('85167200', '-- Opekače hrianok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85167200'),
('851679', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851679'),
('85167920', '--- Ponorné fritézy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85167920'),
('85167970', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85167970'),
('851680', '- Elektrické vykurovacie odpory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851680'),
('85168020', '-- Spojené s izolovaným rámom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85168020'),
('85168080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85168080'),
('85169000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85169000'),
('8517', 'Telefónne súpravy, vrátane telefónov pre celulárnu sieť alebo pre ostatné bezdrôtové siete; ostatné prístroje na prenos alebo príjem hlasu, obrazu alebo ostatných dát, vrátane prístrojov na komunikáciu v drôtovej alebo bezdrôtovej sieti [ako v lokálnej', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8517'),
('8517:2X', '- Telefónne súpravy, vrátane telefónov pre celulárnu sieť alebo pre ostatné bezdrôtové siete', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8517:2X'),
('85171100', '-- Linkové telefónne súpravy s bezdrôtovými mikrotelefónmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85171100'),
('85171200', '-- Telefóny pre celulárne siete alebo pre ostatné bezdrôtové siete', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85171200'),
('85171800', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85171800'),
('85171800:2X', '- Ostatné prístroje na prenos alebo príjem hlasu, obrazu alebo ostatných údajov, vrátane prístrojov na komunikáciu v drôtovej alebo bezdrôtovej sieti [ako v lokálnej (LAN), tak aj v rozsiahlej (WAN)]', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85171800:2X'),
('85176100', '-- Základné stanice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85176100'),
('85176200', '-- Prístroje na príjem, konverziu a prenos alebo obnovenie hlasu, obrazu alebo ostatných dát, vrátane prístrojov na prepájanie, spájanie a smerovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85176200'),
('851769', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851769'),
('85176910', '--- Videotelefóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85176910'),
('85176920', '--- Vstupné telefonické systémy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85176920'),
('85176920:2X', '--- Prijímacie prístroje na rádiotelefóniu alebo rádiotelegrafiu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85176920:2X'),
('85176931', '---- Prenosné prijímače na volanie, signalizáciu alebo vyhľadávanie osôb', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85176931'),
('85176939', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85176939'),
('85176990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85176990'),
('851770', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851770'),
('851770:2X', '-- Antény a parabolické antény všetkých druhov; časti a súčasti vhodné na použitie s nimi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851770:2X'),
('85177011', '--- Antény pre rádiotelegrafické alebo rádiotelefonické prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85177011'),
('85177015', '--- Teleskopické a prútové antény na prenosné prístroje alebo na prístroje určené na zabudovanie do motorových vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85177015'),
('85177019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85177019'),
('85177090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85177090'),
('8518', 'Mikrofóny a ich stojany; reproduktory, tiež vstavané; slúchadlá všetkých druhov, tiež kombinované s mikrofónom, a súpravy pozostávajúce z mikrofónu a jedného alebo viacerých reproduktorov; elektrické nízkofrekvenčné zosilňovače; súpravy elektrických zos', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8518'),
('851810', '- Mikrofóny a ich stojany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851810'),
('85181030', '-- Mikrofóny s frekvenciou v rozsahu od 300 Hz do 3,4 kHz, s priemerom nepresahujúcim 10 mm a výškou nepresahujúcou 3 mm, druhov používaných v telekomunikáciách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85181030'),
('85181095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85181095'),
('85181095:2X', '- Reproduktory, tiež vstavané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85181095:2X'),
('85182100', '-- Jednoduché reproduktory, vstavané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85182100'),
('85182200', '-- Zložené reproduktory, vstavané v jednej skrini', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85182200'),
('851829', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851829'),
('85182930', '--- Reproduktory s frekvenciou rozsahu v od 300 Hz do 3,4 kHz, s priemerom nepresahujúcim 50 mm, druhov používaných v telekomunikáciách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85182930'),
('85182995', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85182995'),
('851830', '- Slúchadlá všetkých druhov, tiež kombinované s mikrofónom, a súpravy pozostávajúce z mikrofónu a jedného alebo viacerých reproduktorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851830'),
('85183020', '-- Drôtové telefonné slúchadlá (mikrotelefóny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85183020'),
('85183095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85183095'),
('851840', '- Elektrické nízkofrekvenčné zosilňovače (audiofrekvenčné)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851840'),
('85184030', '-- Telefónne a meracie zosilňovače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85184030'),
('85184080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85184080'),
('85185000', '- Súpravy elektrických zosilňovačov zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85185000'),
('85189000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85189000'),
('8519', 'Prístroje na záznam alebo reprodukciu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8519'),
('851920', '- Prístroje fungujúce po vložení mince, bankovky, bankovej karty, známky alebo ostatných platidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851920'),
('85192010', '-- Prehrávače platní spúšťané mincou alebo známkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85192010'),
('85192010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85192010:2X'),
('85192091', '--- S laserovým snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85192091'),
('85192099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85192099'),
('85193000', '- Gramofónové šasi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85193000'),
('85195000', '- Prístroje odpovedajúce na telefonáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85195000'),
('85195000:2X', '- Ostatné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85195000:2X'),
('851981', '-- Používajúce magnetické, optické alebo polovodičové médiá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851981'),
('851981:2X', '--- Zvukové reprodukčné prístroje (vrátane kazetových prehrávačov), bez zariadenia na záznam zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851981:2X'),
('85198111', '---- Prístroje na prepis záznamu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198111'),
('85198111:2X', '---- Ostatné prístroje na reprodukciu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85198111:2X'),
('85198115', '----- Vreckové kazetové prehrávače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198115'),
('85198115:2X', '----- Ostatné prístroje kazetového typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85198115:2X'),
('85198121', '------ S analógovým a digitálnym snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198121'),
('85198125', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198125'),
('85198125:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85198125:2X'),
('85198125:3X', '------ S laserovým snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85198125:3X'),
('85198131', '------- Určené na zabudovanie do motorových vozidiel, používajúce kompaktné disky s priemerom nepresahujúcim 6,5 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198131'),
('85198135', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198135'),
('85198145', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198145'),
('85198145:2X', '--- Ostatné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85198145:2X'),
('85198151', '---- Diktafóny, schopné prevádzky len s vonkajším zdrojom energie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198151'),
('85198151:2X', '---- Ostatné prístroje na záznam zvuku na magnetickú pásku, so zabudovaným zariadením na reprodukciu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85198151:2X'),
('85198151:3X', '----- Kazetového typu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85198151:3X'),
('85198151:4X', '------ So vstavaným zosilňovačom a s jedným alebo niekoľkými zabudovanými reproduktormi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85198151:4X'),
('85198155', '------- Schopné prevádzky bez vonkajšieho zdroja energie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198155'),
('85198161', '------- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198161'),
('85198165', '------ Vreckových rozmerov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198165'),
('85198175', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198175'),
('85198175:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85198175:2X'),
('85198181', '------ Používajúce magnetické pásky na cievkach, umožňujúce záznam alebo reprodukciu zvuku buď pri jedinej rýchlosti 19 cm za sekundu, alebo pri niekoľkých rýchlostiach, a to 19 cm za sekundu a nižších', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198181'),
('85198185', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198185'),
('85198195', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198195'),
('851989', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851989'),
('851989:2X', '--- Zvukové reprodukčné prístroje, bez zariadenia na záznam zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_851989:2X'),
('85198911', '---- Prehrávače platní, iné ako položky 8519 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198911'),
('85198915', '---- Prístroje na prepis záznamu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198915'),
('85198919', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198919'),
('85198990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85198990'),
('8521', 'Videofonické prístroje na záznam alebo reprodukciu, tiež so zabudovaným videotunerom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8521'),
('852110', '- Používajúce magnetické pásky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852110'),
('85211020', '-- Používajúce magnetické pásky so šírkou nepresahujúcou 1,3 cm a umožňujúce záznam alebo reprodukciu pri rýchlosti posuvu pásky nepresahujúcej 50 mm za sekundu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85211020'),
('85211095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85211095'),
('85219000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85219000'),
('8522', 'Časti, súčasti a príslušenstvo vhodné na použitie výhradne alebo hlavne s prístrojmi položiek 8519 alebo 8521', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8522'),
('85221000', '- Prenosky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85221000'),
('852290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852290'),
('85229030', '-- Hroty; diamanty, zafíry a ostatné drahokamy alebo polodrahokamy (prírodné, syntetické alebo rekonštruované) na hroty, tiež namontované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85229030'),
('85229030:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85229030:2X'),
('85229030:3X', '--- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85229030:3X'),
('85229041', '---- Prístrojov podpoložky 8519 50 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85229041'),
('85229049', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85229049'),
('85229070', '--- Jednoduché kazetové zostavy s celkovou hrúbkou nepresahujúcou 53 mm, druhu používaného pri výrobe prístrojov na záznam a reprodukciu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85229070'),
('85229080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85229080'),
('8523', 'Disky, pásky, pevné energeticky nezávislé pamäťové zariadenia, "smart karty" a ostatné médiá na záznam zvuku alebo podobný záznam, tiež nahraté, vrátane matríc a galvanických odtlačkov na výrobu diskov, okrem výrobkov kapitoly 37', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8523'),
('8523:2X', '- Magnetické médiá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8523:2X'),
('85232100', '-- Karty so zabudovaným magnetickým prúžkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85232100'),
('852329', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852329'),
('852329:2X', '--- Magnetické pásky; magnetické disky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852329:2X'),
('85232915', '---- Bez záznamu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85232915'),
('85232915:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85232915:2X'),
('85232931', '----- Na reprodukciu záznamu iného ako zvuku alebo obrazu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85232931'),
('85232933', '----- Na reprodukciu zachytených inštrukcií, údajov, zvuku a obrazu zaznamenaných v zariadení schopnom čítať binárne formy a spracovávať ich za predpokladu spolupôsobnosti užívateľa, pomocou stroja na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85232933'),
('85232939', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85232939'),
('85232990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85232990'),
('85232990:2X', '- Optické médiá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85232990:2X'),
('852341', '-- Bez záznamu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852341'),
('85234110', '--- Disky pre laserové snímacie systémy so záznamovou kapacitou nepresahujúcou 900 megabytov, iné ako vymazateľné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234110'),
('85234130', '--- Disky pre laserové snímacie systémy so záznamovou kapacitou presahujúcou 900 megabytov ale nepresahujúcou 18 gigabytov, iné ako vymazateľné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234130'),
('85234190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85234190'),
('852349', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852349'),
('852349:2X', '--- Disky pre laserové snímacie systémy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852349:2X'),
('85234925', '---- Na reprodukciu iného záznamu ako zvuku alebo obrazu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234925'),
('85234925:2X', '---- Len na reprodukciu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85234925:2X'),
('85234931', '----- S priemerom nepresahujúcim 6,5 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234931'),
('85234939', '----- S priemerom presahujúcim 6,5 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234939'),
('85234939:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85234939:2X'),
('85234945', '----- Na reprodukciu zachytených inštrukcií, údajov, zvuku a obrazu zaznamenaných v zariadení schopnom čítať binárne formy a spracovávať ich za predpokladu spolupôsobnosti užívateľa, pomocou stroja na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234945'),
('85234945:2X', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85234945:2X'),
('85234951', '------ Digitálne viacúčelové disky (DVD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234951'),
('85234959', '------ Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234959'),
('85234959:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85234959:2X'),
('85234991', '---- Na reprodukciu záznamu iného ako zvuku alebo obrazu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234991'),
('85234993', '---- Na reprodukciu zachytených inštrukcií, údajov, zvuku a obrazu zaznamenaných v zariadení schopnom čítať binárne formy a spracovávať ich za predpokladu spolupôsobnosti užívateľa, pomocou stroja na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234993'),
('85234999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85234999'),
('85234999:2X', '- Polovodičové médiá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85234999:2X'),
('852351', '-- Pevné energeticky nezávislé pamäťové zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852351'),
('85235110', '--- Bez záznamu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235110'),
('85235110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85235110:2X'),
('85235191', '---- Na reprodukciu záznamu iného ako zvuku alebo obrazu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235191'),
('85235193', '---- Na reprodukciu zachytených inštrukcií, údajov, zvuku a obrazu zaznamenaných v zariadení schopnom čítať binárne formy a spracovávať ich za predpokladu spolupôsobnosti užívateľa, pomocou stroja na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235193'),
('85235199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235199'),
('852352', '-- "Smart karty"', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852352'),
('85235210', '--- S dvoma alebo viacerými elektronickými integrovanými obvodmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235210'),
('85235290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235290'),
('852359', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852359'),
('85235910', '--- Bez záznamu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235910'),
('85235910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85235910:2X'),
('85235991', '---- Na reprodukciu záznamu iného ako zvuku alebo obrazu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235991'),
('85235993', '---- Na reprodukciu zachytených inštrukcií, údajov, zvuku a obrazu zaznamenaných v zariadení schopnom čítať binárne formy a spracovávať ich za predpokladu spolupôsobnosti užívateľa, pomocou stroja na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235993'),
('85235999', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85235999'),
('852380', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852380'),
('85238010', '-- Bez záznamu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85238010'),
('85238010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85238010:2X'),
('85238091', '--- Na reprodukciu záznamu iného ako zvuku alebo obrazu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85238091'),
('85238093', '--- Na reprodukciu zachytených inštrukcií, údajov, zvuku a obrazu zaznamenaných v zariadení schopnom čítať binárne formy a spracovávať ich za predpokladu spolupôsobnosti užívateľa, pomocou stroja na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85238093'),
('85238099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85238099'),
('8525', 'Vysielacie prístroje na rozhlasové alebo televízne vysielanie, tiež so zabudovanými prístrojmi na príjem alebo záznam alebo reprodukciu zvuku; televízne kamery, digitálne fotoaparáty a kamkordéry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8525'),
('85255000', '- Vysielacie prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85255000'),
('85256000', '- Vysielacie prístroje so zabudovaným prijímacím zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85256000'),
('852580', '- Televízne kamery, digitálne fotoaparáty a kamkordéry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852580'),
('852580:2X', '-- Televízne kamery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852580:2X'),
('85258011', '--- S tromi alebo viacerými snímacími elektrónkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85258011'),
('85258019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85258019'),
('85258030', '-- Digitálne fotoaparáty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85258030'),
('85258030:2X', '-- Kamkordéry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85258030:2X'),
('85258091', '--- Iba na záznam obrazu a zvuku, snímaných televíznou kamerou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85258091'),
('85258099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85258099'),
('8526', 'Rádiolokačné a rádiosondážne prístroje (radary), pomocné rádionavigačné prístroje a rádiové prístroje na diaľkové ovládanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8526'),
('85261000', '- Rádiolokačné a rádiosondážne prístroje (radary)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85261000'),
('85261000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85261000:2X'),
('852691', '-- Pomocné rádionavigačné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852691'),
('85269120', '--- Rádionavigačné prijímače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85269120'),
('85269180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85269180'),
('85269200', '-- Rádiové prístroje na ďiaľkové ovládanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85269200'),
('8527', 'Rozhlasové prijímače, tiež kombinované pod spoločným krytom s prístrojom na záznam alebo reprodukciu zvuku alebo s hodinami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8527'),
('8527:2X', '- Rozhlasové prijímače, schopné prevádzky bez vonkajšieho zdroja energie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8527:2X'),
('852712', '-- Vreckové rádiokazetové prehrávače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852712'),
('85271210', '--- S analógovým a digitálnym snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85271210'),
('85271290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85271290'),
('852713', '-- Ostatné prístroje kombinované s prístrojom na záznam alebo reprodukciu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852713'),
('85271310', '--- S laserovým snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85271310'),
('85271310:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85271310:2X'),
('85271391', '---- Kazetového typu s analógovým a digitálnym snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85271391'),
('85271399', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85271399'),
('85271900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85271900'),
('85271900:2X', '- Rozhlasové prijímače, schopné prevádzky len s vonkajším zdrojom energie, druhov používaných v motorových vozidlách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85271900:2X'),
('852721', '-- Kombinované s prístrojom na záznam alebo reprodukciu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852721'),
('852721:2X', '--- Schopné prijímať a dekódovať digitálne RDS (Radio Data System) signály', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852721:2X'),
('85272120', '---- S laserovým snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85272120'),
('85272120:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85272120:2X'),
('85272152', '----- Kazetového typu s analógovým a digitálnym snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85272152'),
('85272159', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85272159'),
('85272159:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85272159:2X'),
('85272170', '---- S laserovým snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85272170'),
('85272170:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85272170:2X'),
('85272192', '----- Kazetového typu s analógovým a digitálnym snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85272192'),
('85272198', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85272198'),
('85272900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85272900'),
('85272900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85272900:2X'),
('852791', '-- Kombinované s prístrojom na záznam alebo reprodukciu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852791'),
('852791:2X', '--- Umiestnené pod spoločným krytom spolu s jedným alebo s niekoľkými reproduktormi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852791:2X'),
('85279111', '---- Kazetového typu s analógovým a digitálnym snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85279111'),
('85279119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85279119'),
('85279119:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85279119:2X'),
('85279135', '---- S laserovým snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85279135'),
('85279135:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85279135:2X'),
('85279191', '----- Kazetového typu s analógovým a digitálnym snímacím systémom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85279191'),
('85279199', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85279199'),
('852792', '-- Nekombinované s prístrojom na záznam alebo reprodukciu zvuku, ale kombinované s hodinami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852792'),
('85279210', '--- Rádiá s budíkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85279210'),
('85279290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85279290'),
('85279900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85279900'),
('8528', 'Monitory a projektory, bez zabudovaných televíznych prijímačov; televízne prijímače tiež so zabudovanými rozhlasovými prijímačmi alebo prístrojmi na záznam či reprodukciu zvuku alebo obrazu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8528'),
('8528:2X', '- Monitory s katódovou trubicou (CRT)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8528:2X'),
('85284100', '-- Druhov používaných výlučne alebo hlavne v systémoch na automatické spracovanie údajov položky 8471', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85284100'),
('852849', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852849'),
('85284910', '--- Čiernobiele alebo inak monochromatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85284910'),
('85284980', '--- Farebné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85284980'),
('85284980:2X', '- Ostatné monitory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85284980:2X'),
('85285100', '-- Druhov používaných výlučne alebo hlavne v systémoch na automatické spracovanie údajov položky 8471', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85285100'),
('852859', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852859'),
('85285910', '--- Čiernobiele alebo inak monochromatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85285910'),
('85285910:2X', '--- Farebné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85285910:2X'),
('85285940', '---- S obrazovkou s technológiou na báze tekutých kryštálov (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85285940'),
('85285980', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85285980'),
('85285980:2X', '- Projektory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85285980:2X'),
('85286100', '-- Druhov používaných výlučne alebo hlavne v systémoch na automatické spracovanie údajov položky 8471', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85286100'),
('852869', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852869'),
('85286910', '--- S plochým panelovým displejom (napríklad zariadenia s tekutými kryštálmi), schopné zobrazovať digitálne informácie generované zariadením na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85286910'),
('85286910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85286910:2X'),
('85286991', '---- Čiernobiele alebo inak monochromatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85286991'),
('85286999', '---- Farebné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85286999'),
('85286999:2X', '- Televízne prijímače, tiež so zabudovanými rozhlasovými prijímačmi alebo prístrojmi na záznam či reprodukciu zvuku alebo obrazu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85286999:2X'),
('852871', '-- Neurčené na zabudovanie zobrazovacej jednotky alebo obrazovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852871'),
('852871:2X', '--- Videotunery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852871:2X'),
('85287111', '---- Elektronické zostavy určené na zabudovanie do strojov na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287111'),
('85287115', '---- Prístroje s mikroprocesorovým zariadením so zabudovaným modemom na získanie prístupu na Internet a majúce funkciu interaktívnej výmeny informácií, schopné prijímať televízny signál (tzv. "set-top boxy s komunikačnou funkciou" vrátane tých, ktoré maj', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287115'),
('85287119', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287119'),
('85287119:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85287119:2X'),
('85287191', '---- Prístroje s mikroprocesorovým zariadením so zabudovaným modemom na získanie prístupu na Internet a majúce funkciu interaktívnej výmeny informácií, schopné prijímať televízny signál (tzv. "set-top boxy s komunikačnou funkciou" vrátane tých, ktoré maj', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287191'),
('85287199', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287199'),
('852872', '-- Ostatné, farebné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852872'),
('85287210', '--- Televízne projekčné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287210'),
('85287220', '--- Prístroje so zabudovaným videorekordérom alebo videoprehrávačom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287220'),
('85287220:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85287220:2X'),
('85287230', '---- So vstavanou elektrónkovou obrazovkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287230'),
('85287240', '---- S obrazovkou s technológiou na báze tekutých kryštálov (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287240'),
('85287260', '---- S obrazovkou s technológiou plazmových zobrazovacích panelov (PDP)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287260'),
('85287280', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287280'),
('85287300', '-- Ostatné, monochromatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85287300'),
('8529', 'Časti a súčasti vhodné výlučne alebo hlavne na prístroje položiek 8525 až 8528', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8529'),
('852910', '- Antény a parabolické antény všetkých druhov; časti a súčasti vhodné na použitie s nimi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852910'),
('852910:2X', '-- Antény', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852910:2X'),
('85291011', '--- Teleskopické a prútové antény na prenosné prístroje alebo na prístroje určené na zabudovanie do motorových vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85291011'),
('85291011:2X', '--- Vonkajšie antény na rozhlasové alebo televízne prijímače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85291011:2X'),
('85291031', '---- Na príjem prostredníctvom satelitu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85291031'),
('85291039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85291039'),
('85291065', '--- Vnútorné antény na rozhlasové alebo televízne prijímače, vrátane vstavaných typov antén', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85291065'),
('85291069', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85291069'),
('85291080', '-- Anténne filtre a separátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85291080'),
('85291095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85291095'),
('852990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_852990'),
('85299020', '-- Časti a súčasti prístrojov podpoložiek 8525 60 00, 8525 80 30, 8528 41 00, 8528 51 00 a 8528 61 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85299020'),
('85299020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85299020:2X'),
('85299020:3X', '--- Skrine a puzdrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85299020:3X'),
('85299041', '---- Z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85299041'),
('85299049', '---- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85299049'),
('85299065', '--- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85299065'),
('85299065:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85299065:2X'),
('85299092', '---- Na televízne kamery podpoložiek 8525 80 11 a 8525 80 19 a prístroje položiek 8527 a 8528', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85299092'),
('85299097', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85299097'),
('8530', 'Elektrické zariadenia signalizačné, bezpečnostné alebo na riadenie železničnej, električkovej, cestnej a riečnej dopravy, na parkovacie, prístavné alebo letiskové zariadenia (iné ako položky 8608)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8530'),
('85301000', '- Zariadenia na železničnú alebo električkovú dopravu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85301000'),
('85308000', '- Ostatné zariadenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85308000'),
('85309000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85309000'),
('8531', 'Elektrické akustické alebo vizuálne signalizačné prístroje (napríklad zvončeky, sirény, návestné panely, poplachové zariadenia na ochranu proti vlámaniu alebo proti požiaru), iné ako položky 8512 alebo 8530', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8531'),
('853110', '- Poplachové zariadenia na ochranu proti vlámaniu alebo požiaru a podobné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853110'),
('85311030', '-- Na zabezpečenie budov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85311030'),
('85311095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85311095'),
('853120', '- Návestné panely so zabudovanými zariadeniami s kvapalnými kryštálmi (LCD) alebo diódami vyžarujúcimi svetlo (LED)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853120'),
('85312020', '-- So zabudovanými diódami vyžarujúcimi svetlo (LED)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85312020'),
('85312020:2X', '-- So zabudovanými zariadeniami s kvapalnými kryštálmi (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85312020:2X'),
('85312040', '--- So zabudovanými zariadeniami s kvapalnými kryštálmi s aktívnou maticou (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85312040'),
('85312095', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85312095'),
('853180', '- Ostatné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853180'),
('85318020', '-- Prístroje s plochým panelovým displejom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85318020'),
('85318095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85318095'),
('853190', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853190'),
('85319020', '-- Prístrojov podpoložiek 8531 20 a 8531 80 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85319020'),
('85319085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85319085'),
('8532', 'Elektrické kondenzátory, pevné, otočné alebo dolaďovacie (prednastavené)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8532'),
('85321000', '- Pevné kondenzátory, projektované na použitie v obvodoch s 50/60 Hz, pri ktorých je jalový výkon najmenej 0,5 kvar (silové kondenzátory)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85321000'),
('85321000:2X', '- Ostatné pevné kondenzátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85321000:2X'),
('85322100', '-- Tantalové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85322100'),
('85322200', '-- Alumíniové s elektrolytom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85322200'),
('85322300', '-- Keramické dielektrikum, jednovrstvové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85322300'),
('85322400', '-- Keramické dielektrikum, viacvrstvové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85322400'),
('85322500', '-- Papierové dielektrikum alebo dielektrikum z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85322500'),
('85322900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85322900'),
('85323000', '- Otočné alebo dolaďovacie (prednastavené) kondenzátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85323000'),
('85329000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85329000'),
('8533', 'Elektrické odpory (vrátane reostatov a potenciometrov), iné ako vykurovacie odpory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8533'),
('85331000', '- Stále uhlíkové odpory, zložené alebo vrstvené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85331000'),
('85331000:2X', '- Ostatné stále odpory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85331000:2X'),
('85332100', '-- Na výkon nepresahujúci 20 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85332100'),
('85332900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85332900'),
('85332900:2X', '- Drôtové (navíjané) premenné odpory, vrátane reostatov a potenciometrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85332900:2X'),
('85333100', '-- Na výkon nepresahujúci 20 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85333100'),
('85333900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85333900'),
('853340', '- Ostatné premenné odpory, vrátane reostatov a potenciometrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853340'),
('85334010', '-- Na výkon nepresahujúci 20 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85334010'),
('85334090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85334090'),
('85339000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85339000'),
('853400', 'Tlačené obvody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853400'),
('853400:2X', '- Skladajúce sa len z vodivých prvkov (spojov) a kontaktov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853400:2X'),
('85340011', '-- Viacnásobné obvody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85340011'),
('85340019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85340019'),
('85340090', '- S ďalšími pasívnymi prvkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85340090'),
('8535', 'Elektrické zariadenia na vypínanie, spínanie alebo na ochranu elektrických obvodov, alebo na ich spájanie, pripájanie k alebo do elektrického obvodu (napríklad prepínače, vypínače, spínače, poistky, bleskoistky, obmedzovače napätia, obmedzovače prúdovýc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8535'),
('85351000', '- Poistky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85351000'),
('85351000:2X', '- Automatické vypínače elektrických obvodov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85351000:2X'),
('85352100', '-- Na napätie nižšie ako 72,5 kV', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85352100'),
('85352900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85352900'),
('853530', '- Izolačné spinače a vypínače záťaže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853530'),
('85353010', '-- Na napätie nižšie ako 72,5 kV', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85353010'),
('85353090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85353090'),
('85354000', '- Bleskoistky, obmedzovače napätia a obmedzovače prúdových nárazov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85354000'),
('85359000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85359000'),
('8536', 'Elektrické zariadenia na vypínanie, spínanie alebo na ochranu elektrických obvodov, alebo na ich spájanie, pripájanie k alebo do elektrického obvodu (napríklad prepínače, vypínače, spínače, relé, poistky, obmedzovače prúdových nárazov, zástrčky, zásuvky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8536'),
('853610', '- Poistky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853610'),
('85361010', '-- Na intenzitu prúdu nepresahujúcu 10 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85361010'),
('85361050', '-- Na intenzitu prúdu presahujúcu 10 A, ale nepresahujúcu 63 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85361050'),
('85361090', '-- Na intenzitu prúdu presahujúcu 63 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85361090'),
('853620', '- Automatické vypínače elektrických obvodov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853620'),
('85362010', '-- Na intenzitu prúdu nepresahujúcu 63 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85362010'),
('85362090', '-- Na intenzitu prúdu presahujúcu 63 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85362090'),
('853630', '- Ostatné zariadenia na ochranu elektrických obvodov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853630'),
('85363010', '-- Na intenzitu prúdu nepresahujúcu 16 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85363010'),
('85363030', '-- Na intenzitu prúdu presahujúcu 16 A, ale nepresahujúcu 125 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85363030'),
('85363090', '-- Na intenzitu prúdu presahujúcu 125 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85363090'),
('85363090:2X', '- Relé', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85363090:2X'),
('853641', '-- Na napätie nepresahujúce 60 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853641'),
('85364110', '--- Na intenzitu prúdu nepresahujúcu 2 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85364110'),
('85364190', '--- Na intenzitu prúdu presahujúcu 2 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85364190'),
('85364900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85364900'),
('853650', '- Ostatné prepínače, vypínače a spínače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853650'),
('85365003', '-- Elektronické AC prepínače, vypínače a spínače zložené z opticky spojených vstupných a výstupných obvodov (izolované tyristorové AC prepínače, vypínače a spínače)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365003'),
('85365005', '-- Elektronické prepínače vypínače a spínače vrátane tepelne istených elektronických prepínačov, vypínačov a spínačov, zložených z tranzistora a logického integrovaného obvodu (chip-on-chip technology)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365005'),
('85365007', '-- Elektromechanické stláčacie prepínače, vypínače a spínače pre prúd s intenzitou nepresahujúcou 11 A', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365007'),
('85365007:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365007:2X'),
('85365007:3X', '--- Na napätie nepresahujúce 60 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365007:3X'),
('85365011', '---- Stláčacie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365011'),
('85365015', '---- Otočné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365015'),
('85365019', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365019'),
('85365080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365080'),
('85365080:2X', '- Objímky žiaroviek, zástrčky a zásuvky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85365080:2X'),
('853661', '-- Objímky žiaroviek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853661'),
('85366110', '--- Objímky žiaroviek so skrutkovacou päticou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85366110'),
('85366190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85366190'),
('853669', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853669'),
('85366910', '--- Pre koaxiálne káble', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85366910'),
('85366930', '--- Pre tlačené obvody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85366930'),
('85366990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85366990'),
('85367000', '- Prípojky na optické vlákna, zväzky alebo káble z optických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85367000'),
('853690', '- Ostatné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853690'),
('85369001', '-- Prefabrikované prvky na elektrické obvody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85369001'),
('85369010', '-- Prípojky a kontakty na drôty a káble', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85369010'),
('85369020', '-- Waferové sondy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85369020'),
('85369085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85369085'),
('8537', 'Rozvádzače, rozvodné panely, ovládacie (dispečerské) stoly, pulty, skrine a ostatné základne vybavené dvoma alebo viacerými zariadeniami položky 8535 alebo 8536, na elektrické riadenie alebo na rozvod elektriny, vrátane tých ktoré majú zabudované nástro', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8537'),
('853710', '- Na napätie nepresahujúce 1 000 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853710'),
('85371010', '-- Číslicovo riadené panely so zabudovaným zariadením na automatické spracovanie údajov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85371010'),
('85371010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85371010:2X'),
('85371091', '--- Programovateľné pamäťové riadiace prvky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85371091'),
('85371099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85371099'),
('853720', '- Na napätie presahujúce 1 000 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853720'),
('85372091', '-- Na napätie presahujúce 1 000 V, ale nepresahujúce 72,5 kV', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85372091'),
('85372099', '-- Na napätie presahujúce 72,5 kV', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85372099'),
('8538', 'Časti a súčasti určené výhradne alebo hlavne na použitie so zariadeniami položiek 8535, 8536 alebo 8537', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8538'),
('85381000', '- Rozvádzače, rozvodné panely, ovládacie (dispečerské) stoly, pulty, skrine a ostatné základne na výrobky položky 8537, nevybavené ich prístrojmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85381000'),
('853890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853890'),
('853890:2X', '-- Na waferové sondy podpoložky 8536 90 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853890:2X'),
('85389011', '--- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85389011'),
('85389019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85389019'),
('85389019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85389019:2X'),
('85389091', '--- Elektronické zostavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85389091'),
('85389099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85389099'),
('8539', 'Elektrické žiarovky alebo výbojky, vrátane žiaroviek do svetlometov a ultrafialové alebo infračervené žiarovky; oblúkovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8539'),
('85391000', '- Žiarovky do svetlometov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85391000'),
('85391000:2X', '- Ostatné žiarovky, okrem ultrafialových alebo infračervených', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85391000:2X'),
('853921', '-- Halogénové s volfrámovým vláknom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853921'),
('85392130', '--- Typy používané na motocykle alebo ostatné motorové vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85392130'),
('85392130:2X', '--- Ostatné, na napätie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85392130:2X'),
('85392192', '---- Presahujúce 100 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85392192'),
('85392198', '---- Nepresahujúce 100 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85392198'),
('853922', '-- Ostatné, s výkonom nepresahujúcim 200 W a na elektrické napätie presahujúce 100 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853922'),
('85392210', '--- Žiarovky do reflektorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85392210'),
('85392290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85392290'),
('853929', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853929'),
('85392930', '--- Typy používané na motocykle alebo ostatné motorové vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85392930'),
('85392930:2X', '--- Ostatné, na napätie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85392930:2X'),
('85392992', '---- Presahujúce 100 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85392992'),
('85392998', '---- Nepresahujúce 100 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85392998'),
('85392998:2X', '- Výbojky, iné ako ultrafialové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85392998:2X'),
('853931', '-- Fluoroscenčné, so žeravenou katódou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853931'),
('85393110', '--- S obojstrannou päticou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85393110'),
('85393190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85393190'),
('853932', '-- Ortuťové alebo sodíkové výbojky; kovové halogénové žiarovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853932'),
('85393220', '--- Ortuťové alebo sodíkové výbojky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85393220'),
('85393290', '--- Kovové halogénové žiarovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85393290'),
('85393900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85393900'),
('85393900:2X', '- Ultrafialové alebo infračervené žiarovky; oblúkovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85393900:2X'),
('85394100', '-- Oblúkovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85394100'),
('85394900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85394900'),
('853990', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_853990'),
('85399010', '-- Pätice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85399010'),
('85399090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85399090'),
('8540', 'Elektrónky a trubice so žeravenou katódou trubice a elektrónky so studenou katódou, alebo s fotokatódou (napríklad vákuové alebo parami alebo plynmi plnené elektrónky a trubice, ortuťové usmerňovacie elektrónky a trubice, CRT obrazovky, snímacie elektró', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8540'),
('8540:2X', '- Televízne CRT obrazovky, vrátane CRT obrazoviek pre videomonitory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8540:2X'),
('85401100', '-- Farebné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85401100'),
('85401200', '-- Monochromatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85401200'),
('854020', '- Snímacie elektrónky televíznych kamier; meniče a zosilňovače obrazu; ostatné fotokatódové elektrónky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854020'),
('85402010', '-- Snímacie elektrónky televíznych kamier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85402010'),
('85402080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85402080'),
('85404000', '- Obrazovky s data/grafickým zobrazením, monochromatické; obrazovky s data/grafickým zobrazením, farebné, s luminofórnym bodom menším ako 0,4 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85404000'),
('85406000', '- Ostatné CRT obrazovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85406000'),
('85406000:2X', '- Mikrovlnné elektrónky (napríklad magnetróny, klystróny, permaktróny, karcinotróny), okrem elektróniek s riadiacou mriežkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85406000:2X'),
('85407100', '-- Magnetróny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85407100'),
('85407900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85407900'),
('85407900:2X', '- Ostatné elektrónky a trubice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85407900:2X'),
('85408100', '-- Prijímacie alebo zosilňovacie elektrónky a trubice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85408100'),
('85408900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85408900'),
('85408900:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85408900:2X'),
('85409100', '-- Obrazoviek CRT', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85409100'),
('85409900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85409900'),
('8541', 'Diódy, tranzistory a podobné polovodičové zariadenia; fotosenzitívne polovodičové zariadenia, vrátane fotovoltických článkov, tiež zostavených do modulov alebo zabudovaných do panelov; diódy vyžarujúce svetlo (LED); zabudované piezoelektrické kryštály', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8541'),
('85411000', '- Diódy, iné ako fotosenzitívne alebo diódy vyžarujúce svetlo (LED)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85411000'),
('85411000:2X', '- Tranzistory, iné ako fotosenzitívne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85411000:2X'),
('85412100', '-- So stratovým výkonom menším ako 1 W', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85412100'),
('85412900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85412900'),
('85413000', '- Tyristory, diaky a triaky, iné ako fotosenzitívne zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85413000'),
('854140', '- Fotosenzitívne polovodičové zariadenia, vrátane fotovoltických článkov, tiež zostavených do modulov alebo zabudovaných do panelov; diódy vyžarujúce svetlo (LED)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854140'),
('85414010', '-- Diódy vyžarujúce svetlo (LED), vrátane laserových diód', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85414010'),
('85414090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85414090'),
('85415000', '- Ostatné polovodičové zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85415000'),
('85416000', '- Zabudované piezoelektrické kryštály', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85416000'),
('85419000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85419000'),
('8542', 'Elektronické integrované obvody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8542'),
('8542:2X', '- Elektronické integrované obvody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8542:2X'),
('854231', '-- Procesory a riadiace (elektronické) obvody, tiež kombinované s pamäťami, meničmi, logickými obvodmi, zosilňovačmi, hodinami, synchronizačnými obvodmi alebo ostatnými obvodmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854231'),
('85423110', '--- Výrobky špecifikované v poznámke 8 písm. b) bode 3 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423110'),
('85423190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423190'),
('854232', '-- Pamäte', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854232'),
('85423210', '--- Výrobky špecifikované v poznámke 8 písm. b) bode 3 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423210'),
('85423210:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423210:2X'),
('85423210:3X', '---- Dynamické pamäte s priamym prístupom (D-RAM)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423210:3X'),
('85423231', '----- S kapacitou pamäte nepresahujúcou 512 Mbitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85423231'),
('85423239', '----- S kapacitou pamäte presahujúcou 512 Mbitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85423239'),
('85423245', '---- Statické pamäte s priamym prístupom (S-RAM), vrátane rýchlej vyrovnávacej pamäte s priamym prístupom (cache-RAM)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85423245'),
('85423255', '---- Permanentné programovateľné pamäte, vymazateľné ultrafialovými lúčmi (EPROM)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85423255'),
('85423255:2X', '---- Permanentné programovateľné pamäte, elektricky vymazateľné (E2PROM), vrátane FLASH E2PROM', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423255:2X'),
('85423255:3X', '----- Flash E2PROM', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423255:3X'),
('85423261', '------ S kapacitou pamäte nepresahujúcou 512 Mbitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85423261'),
('85423269', '------ S kapacitou pamäte presahujúcou 512 Mbitov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85423269'),
('85423275', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85423275'),
('85423290', '---- Ostatné pamäte', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423290'),
('85423300', '-- Zosilňovače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423300'),
('854239', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854239'),
('85423910', '--- Výrobky špecifikované v poznámke 8 písm. b) bode 3 k tejto kapitole', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423910'),
('85423990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85423990'),
('85429000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85429000'),
('8543', 'Elektrické stroje, prístroje a zariadenia svlastnou individuálnou funkciou, v tejto kapitole inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8543'),
('85431000', '- Urýchľovače častíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85431000'),
('85432000', '- Signálové generátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85432000'),
('85433000', '- Stroje, prístroje a zariadenia slúžiace na galvanické pokovovanie, elektrolýzu alebo na elektroforézu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85433000'),
('854370', '- Ostatné stroje, prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854370'),
('85437010', '-- Elektrické zariadenia s prekladateľskými alebo slovníkovými funkciami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85437010'),
('85437030', '-- Anténové zosilňovače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85437030'),
('85437050', '-- Solárne lôžka, solárne svietidlá a podobné opaľovacie zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85437050'),
('85437060', '-- Elektrické zdroje pre ohrady (ploty)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85437060'),
('85437090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85437090'),
('85439000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85439000'),
('8544', 'Drôty, káble (vrátane koaxiálnych káblov), izolované (tiež s lakovým povrchom alebo s anodickým okysličením) a ostatné izolované elektrické vodiče, tiež s prípojkami; káble z optických vlákien vyrobené z jednotlivo oplášťovaných vlákien, tiež spojené s', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8544'),
('8544:2X', '- Drôty na navíjanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8544:2X'),
('854411', '-- Medené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854411'),
('85441110', '--- Lakované alebo smaltované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85441110'),
('85441190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85441190'),
('85441900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85441900'),
('85442000', '- Koaxiálne káble a ostatné koaxiálne vodiče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85442000'),
('85443000', '- Súpravy zapaľovacích káblov a ostatné súpravy drôtov používané vo vozidlách, lietadlách alebo lodiach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85443000'),
('85443000:2X', '- Ostatné elektrické vodiče na napätie nepresahujúce 1 000 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85443000:2X'),
('854442', '-- Vybavené prípojkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854442'),
('85444210', '--- Druhov používaných v telekomunikáciách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85444210'),
('85444290', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85444290'),
('854449', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854449'),
('85444920', '--- Druhov používaných v telekomunikáciách, na napätie nepresahujúce 80 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85444920'),
('85444920:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85444920:2X'),
('85444991', '---- Drôty a káble, ktorých priemer drôtu v jednotlivých vodičoch presahuje 0,51 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85444991'),
('85444991:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85444991:2X'),
('85444993', '----- Na napätie nepresahujúce 80 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85444993'),
('85444995', '----- Na napätie presahujúce 80 V, ale nepresahujúce 1 000 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85444995'),
('85444999', '----- Na napätie 1 000 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85444999'),
('854460', '- Ostatné elektrické vodiče, na napätie presahujúce 1 000 V', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854460'),
('85446010', '-- S medenými vodičmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85446010'),
('85446090', '-- S ostatnými vodičmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85446090'),
('85447000', '- Káble z optických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85447000'),
('8545', 'Uhlíkové elektródy, uhlíkové kefky, osvetľovacie uhlíky, uhlíky na elektrické batérie a ostatné výrobky zhotovené z grafitu alebo z ostatného uhlíka, tiež spojené s kovom, druhov používaných na elektrické účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8545'),
('8545:2X', '- Elektródy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8545:2X'),
('85451100', '-- Druhov používaných v peciach', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85451100'),
('85451900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85451900'),
('85452000', '- Kefky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85452000'),
('854590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854590'),
('85459010', '-- Vykurovacie odpory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85459010'),
('85459090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85459090'),
('8546', 'Elektrické izolátory z ľubovoľného materiálu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8546'),
('85461000', '- Sklenené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85461000'),
('85462000', '- Keramické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85462000'),
('854690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854690'),
('85469010', '-- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85469010'),
('85469090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85469090'),
('8547', 'Izolačné časti a súčasti na elektrické stroje, prístroje alebo zariadenia, vyrobené úplne z izolačných materiálov alebo len s jednoduchými, do materiálu vlisovanými drobnými kovovými súčasťami (napríklad s objímkami so závitom), slúžiacimi výlučne na pr', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8547'),
('85471000', '- Izolačné časti a súčasti, z keramiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85471000'),
('85472000', '- Izolačné časti a súčasti, z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85472000'),
('85479000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85479000'),
('8548', 'Odpad a zvyšky galvanických článkov, batérií a elektrických akumulátorov; nepoužiteľné galvanické články, nepoužiteľné batérie a nepoužiteľné elektrické akumulátory; elektrické časti a súčasti strojov alebo prístrojov, v tejto kapitole inde nešpecifikov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8548'),
('854810', '- Odpad a zvyšky galvanických článkov, batérií a elektrických akumulátorov; nepoužiteľné galvanické články, nepoužiteľné batérie a nepoužiteľné elektrické akumulátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854810'),
('85481010', '-- Nepoužiteľné galvanické články a nepoužiteľné batérie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_85481010'),
('85481010:2X', '-- Nepoužiteľné elektrické akumulátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85481010:2X'),
('85481021', '--- Olovené akumulátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NCL'), 'SK_85481021'),
('85481029', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NCL'), 'SK_85481029'),
('85481029:2X', '-- Odpad a zvyšky galvanických článkov, batérií a elektrických akumulátorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85481029:2X'),
('85481091', '--- Obsahujúce olovo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85481091'),
('85481099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85481099'),
('854890', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_854890'),
('85489020', '-- Pamäte v multikombinovaných formách, ako sú napr. zásobníkové D-RAM a moduly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85489020'),
('85489090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_85489090'),
('8601', 'Železničné lokomotívy poháňané vonkajším zdrojom elektrického prúdu alebo poháňané elektrickými akumulátormi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8601'),
('86011000', '- Poháňané vonkajším zdrojom elektrického prúdu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86011000'),
('86012000', '- Poháňané elektrickými akumulátormi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86012000'),
('8602', 'Ostatné železničné lokomotívy; lokomotívne tendre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8602'),
('86021000', '- Dieselelektrické lokomotívy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86021000'),
('86029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86029000'),
('8603', 'Železničné alebo električkové vozne osobné a nákladné, s vlastným pohonom, iné ako uvedené v položke 8604', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8603'),
('86031000', '- Poháňané vonkajším zdrojom elektrického prúdu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86031000'),
('86039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86039000'),
('86040000', 'Vozidlá na údržbu alebo opravy železničných alebo električkových tratí, tiež s vlastným pohonom (napríklad dielenské vozne, žeriavové vozne, vozne vybavené podbíjačkami štrkového lôžka, vyrovnávačky koľají, skúšobné vozne a kontrolné vozidlá železničnýc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86040000'),
('86050000', 'Železničné alebo električkové osobné vozne bez vlastného pohonu; batožinové vozne, poštové a ostatné špeciálne koľajové vozne, bez vlastného pohonu (okrem vozňov položky 8604)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86050000'),
('8606', 'Nákladné vagóny na železničnú alebo električkovú dopravu, bez vlastného pohonu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8606'),
('86061000', '- Cisternové a podobné vagóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86061000'),
('86063000', '- Samovýsypné vagóny, iné ako vagóny podpoložky 8606 10', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86063000'),
('86063000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86063000:2X'),
('860691', '-- Kryté a uzavreté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_860691'),
('86069110', '--- Špeciálne určené na prepravu vysokorádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86069110'),
('86069180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86069180'),
('86069200', '-- Otvorené, s nesnímateľnými bočnicami s výškou presahujúcou 60 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86069200'),
('86069900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86069900'),
('8607', 'Časti a súčasti železničných alebo električkových lokomotív alebo vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8607'),
('8607:2X', '- Podvozky, bisselové podvozky, nápravy a kolesá a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8607:2X'),
('86071100', '-- Hnacie podvozky a bisselové podvozky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86071100'),
('86071200', '-- Ostatné podvozky a bisselové podvozky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86071200'),
('860719', '-- Ostatné, vrátane častí a súčastí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_860719'),
('86071910', '--- Nápravy, tiež zmontované; kolesá a ich časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86071910'),
('86071990', '--- Časti podvozkov, bisselových podvozkov a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86071990'),
('86071990:2X', '- Brzdy a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86071990:2X'),
('860721', '-- Pneumatické brzdy a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_860721'),
('86072110', '--- Z liatiny alebo liatej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86072110'),
('86072190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86072190'),
('86072900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86072900'),
('86073000', '- Háky a ostatné spojovacie zariadenia, nárazníky, ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86073000'),
('86073000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86073000:2X'),
('860791', '-- Lokomotív', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_860791'),
('86079110', '--- Skrine ložiska náprav a ich časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86079110'),
('86079190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86079190'),
('860799', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_860799'),
('86079910', '--- Skrine ložiska náprav a ich časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86079910'),
('86079980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86079980'),
('86080000', 'Koľajový zvrškový upevňovací materiál a nepojazdné zariadenia; mechanické (tiež elektromechanické) zariadenia návestné, bezpečnostné alebo kontrolné a ovládacie na železničnú alebo električkovú dopravu, na cestnú alebo riečnu dopravu, na parkoviská, na', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_86080000'),
('860900', 'Kontajnery (vrátane kontajnerov na prepravu tekutín) osobitne určené a vybavené na jeden alebo viac druhov dopravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_860900'),
('86090010', '- Kontajnery s olovenou ochrannou vrstvou proti radiácii, na prepravu rádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86090010'),
('86090090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_86090090'),
('8701', 'Traktory a ťahače (iné ako ťahače položky 8709)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8701'),
('87011000', '- Traktory riadené chodcom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87011000'),
('870120', '- Cestné návesové ťahače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870120'),
('87012010', '-- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87012010'),
('87012090', '-- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87012090'),
('87013000', '- Pásové traktory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87013000'),
('870190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870190'),
('870190:2X', '-- Poľnohospodárske kolesové traktory (okrem traktorov riadených chodcom) a lesné kolesové traktory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870190:2X'),
('870190:3X', '--- Nové, s výkonom motora', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870190:3X'),
('87019011', '---- Nepresahujúcim 18 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87019011'),
('87019020', '---- Presahujúcim 18 kW, ale nepresahujúcim 37 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87019020'),
('87019025', '---- Presahujúcim 37 kW, ale nepresahujúcim 59 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87019025'),
('87019031', '---- Presahujúcim 59 kW, ale nepresahujúcim 75 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87019031'),
('87019035', '---- Presahujúcim 75 kW, ale nepresahujúcim 90 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87019035'),
('87019039', '---- Presahujúcim 90 kW', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87019039'),
('87019050', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87019050'),
('87019090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87019090'),
('8702', 'Motorové vozidlá na dopravu desiatich alebo viacerých osôb, vrátane vodiča', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8702'),
('870210', '- S piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo motorom so žiarovou hlavou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870210'),
('870210:2X', '-- S objemom valcov presahujúcim 2 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870210:2X'),
('87021011', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87021011'),
('87021019', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87021019'),
('87021019:2X', '-- S objemom valcov nepresahujúcim 2 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87021019:2X'),
('87021091', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87021091'),
('87021099', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87021099'),
('870290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870290'),
('870290:2X', '-- So zážihovým spaľovacím motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870290:2X'),
('870290:3X', '--- S objemom valcov presahujúcim 2 800 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870290:3X'),
('87029011', '---- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87029011'),
('87029019', '---- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87029019'),
('87029019:2X', '--- S objemom valcov nepresahujúcim 2 800 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87029019:2X'),
('87029031', '---- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87029031'),
('87029039', '---- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87029039'),
('87029090', '-- S ostatnými motormi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87029090'),
('8703', 'Osobné automobily a ostatné motorové vozidlá konštruované hlavne na prepravu osôb (vozidlá iné ako sú uvedené v položke 8702), vrátane osobných dodávkových a pretekárskych automobilov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8703'),
('870310', '- Vozidlá zvlášť konštruované na jazdu na snehu; špeciálne vozidlá na prepravu osôb na golfových ihriskách a podobné vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870310'),
('87031011', '-- Vozidlá špeciálne určené na jazdu po snehu, so vznetovým piestovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) alebo so zážihovým piestovým spaľovacím motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87031011'),
('87031018', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87031018'),
('87031018:2X', '- Ostatné vozidlá s vratným piestovým zážihovým spaľovacím motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87031018:2X'),
('870321', '-- S objemom valcov nepresahujúcim 1 000 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870321'),
('87032110', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87032110'),
('87032190', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87032190'),
('870322', '-- S objemom valcov presahujúcim 1 000 cm3, ale nepresahujúcim 1 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870322'),
('87032210', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87032210'),
('87032290', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87032290'),
('870323', '-- S objemom valcov presahujúcim 1 500 cm3, ale nepresahujúcim 3 000 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870323'),
('870323:2X', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870323:2X'),
('87032311', '---- Motorové karavany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87032311'),
('87032319', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87032319'),
('87032390', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87032390'),
('870324', '-- S objemom valcov presahujúcim 3 000 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870324'),
('87032410', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87032410'),
('87032490', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87032490'),
('87032490:2X', '- Ostatné vozidlá s vratným piestovým vznetovým spaľovacím motorom (s dieselovým motorom alebo s motorom so žiarovou hlavou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87032490:2X'),
('870331', '-- S objemom valcov nepresahujúcim 1 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870331'),
('87033110', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87033110'),
('87033190', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87033190'),
('870332', '-- S objemom valcov presahujúcim 1 500 cm3, ale nepresahujúcim 2 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870332'),
('870332:2X', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870332:2X'),
('87033211', '---- Motorové karavany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87033211'),
('87033219', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87033219'),
('87033290', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87033290'),
('870333', '-- S objemom valcov presahujúcim 2 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870333'),
('870333:2X', '--- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870333:2X'),
('87033311', '---- Motorové karavany', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87033311'),
('87033319', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87033319'),
('87033390', '--- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87033390'),
('870390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870390'),
('87039010', '-- S elektrickými motormi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87039010'),
('87039090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87039090'),
('8704', 'Motorové vozidlá na nákladnú dopravu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8704'),
('870410', '- Vyklápače (dumpry) určené na použitie mimo komunikácií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870410'),
('87041010', '-- S piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) alebo s piestovým zážihovým spaľovacím motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87041010'),
('87041090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87041090'),
('87041090:2X', '- Ostatné vozidlá s piestovým vznetovým spaľovacím motorom (s dieselovým motorom alebo s motorom so žiarovou hlavou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87041090:2X'),
('870421', '-- S celkovou hmotnosťou nepresahujúcou 5 ton', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870421'),
('87042110', '--- Špeciálne určené na prepravu vysokorádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042110'),
('87042110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87042110:2X'),
('87042110:3X', '---- S motorom s objemom valcov presahujúcim 2 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87042110:3X'),
('87042131', '----- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042131'),
('87042139', '----- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042139'),
('87042139:2X', '---- S motorom s objemom valcov nepresahujúcim 2 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87042139:2X'),
('87042191', '----- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042191'),
('87042199', '----- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042199'),
('870422', '-- S celkovou hmotnosťou presahujúcou 5 ton, ale nepresahujúcou 20 ton', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870422'),
('87042210', '--- Špeciálne určené na prepravu vysokorádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042210'),
('87042210:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87042210:2X'),
('87042291', '---- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042291'),
('87042299', '---- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042299'),
('870423', '-- S celkovou hmotnosťou presahujúcou 20 ton', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870423'),
('87042310', '--- Špeciálne určené na prepravu vysokorádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042310'),
('87042310:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87042310:2X'),
('87042391', '---- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042391'),
('87042399', '---- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87042399'),
('87042399:2X', '- Ostatné, s piestovým zážihovým spaľovacím motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87042399:2X'),
('870431', '-- S celkovou hmotnosťou nepresahujúcou 5 ton', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870431'),
('87043110', '--- Špeciálne určené na prepravu vysokorádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87043110'),
('87043110:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87043110:2X'),
('87043110:3X', '---- S motorom s objemom valcov presahujúcim 2 800 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87043110:3X'),
('87043131', '----- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87043131'),
('87043139', '----- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87043139'),
('87043139:2X', '---- S motorom s objemom valcov nepresahujúcim 2 800 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87043139:2X'),
('87043191', '----- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87043191'),
('87043199', '----- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87043199'),
('870432', '-- S celkovou hmotnosťou presahujúcou 5 ton', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870432'),
('87043210', '--- Špeciálne určené na prepravu vysokorádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87043210'),
('87043210:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87043210:2X'),
('87043291', '---- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87043291'),
('87043299', '---- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87043299'),
('87049000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87049000'),
('8705', 'Motorové vozidlá na osobitné účely, iné ako tie, ktoré sú konštruované hlavne na osobnú alebo na nákladnú dopravu (napríklad vyslobodzovacie automobily, žeriavové nákladné automobily, požiarne automobily, nákladné automobily s miešačkou na betón, zameta', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8705'),
('87051000', '- Žeriavové nákladné automobily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87051000'),
('87052000', '- Pojazdné vrtné súpravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87052000'),
('87053000', '- Požiarne automobily', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87053000'),
('87054000', '- Nákladné automobily s miešačkou na betón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87054000'),
('870590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870590'),
('87059030', '-- Automobily s čerpadlom na betón', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87059030'),
('87059080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87059080'),
('870600', 'Šasi (chassis) s motorom motorových vozidiel položiek 8701 až 8705', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870600'),
('870600:2X', '- Šasi na traktory zatriedené do položky 8701; šasi na motorové vozidlá zatriedené do položiek 8702, 8703 alebo 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov presahujúcim 2 500 ', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870600:2X'),
('87060011', '-- Na vozidlá položky 8702 alebo 8704', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87060011'),
('87060019', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87060019'),
('87060019:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87060019:2X'),
('87060091', '-- Na vozidlá položky 8703', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87060091'),
('87060099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87060099'),
('8707', 'Karosérie (vrátane kabín) motorových vozidiel položiek 8701 až 8705, vrátane kabín pre vodičov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8707'),
('870710', '- Vozidiel položky 8703', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870710'),
('87071010', '-- Na priemyselnú montáž', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87071010'),
('87071090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87071090'),
('870790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870790'),
('87079010', '-- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2 500 cm3, alebo s piesto', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87079010'),
('87079090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87079090'),
('8708', 'Časti, súčasti a príslušenstvo motorových vozidiel položiek 8701 až 8705', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8708'),
('870810', '- Nárazníky a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870810'),
('87081010', '-- Na priemyselnú montáž: vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2 500 cm3, alebo s piestovým zážihovým spaľovacím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87081010'),
('87081090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87081090'),
('87081090:2X', '- Ostatné časti, súčasti a príslušenstvo karosérií (vrátane kabín pre vodičov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87081090:2X'),
('870821', '-- Bezpečnostné pásy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870821'),
('87082110', '--- Na priemyselnú montáž: vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2 500 cm3, alebo s piestovým zážihovým spaľovacím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87082110'),
('87082190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87082190'),
('870829', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870829'),
('87082910', '--- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87082910'),
('87082990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87082990'),
('870830', '- Brzdy a servobrzdy; ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870830'),
('87083010', '-- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2 ', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87083010'),
('87083010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87083010:2X'),
('87083091', '--- Na diskové brzdy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87083091'),
('87083099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87083099'),
('870840', '- Prevodové skrine a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870840'),
('87084020', '-- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2 ', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87084020'),
('87084020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87084020:2X'),
('87084050', '--- Prevodové skrine', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87084050'),
('87084050:2X', '--- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87084050:2X'),
('87084091', '---- Z kovanej zápustkovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87084091'),
('87084099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87084099'),
('870850', '- Hnacie nápravy s diferenciálom, tiež vybavené ostatnými prevodovými mechanizmami, a hnané nápravy; ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870850'),
('87085020', '-- Na priemyselnú montáž: vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2 500 cm3, alebo s piestovým zážihovým spaľovacím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87085020'),
('87085020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87085020:2X'),
('87085035', '--- Hnacie nápravy s diferenciálom, tiež vybavené ostatnými prevodovými mechanizmami a hnané nápravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87085035'),
('87085035:2X', '--- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87085035:2X'),
('87085055', '---- Z kovanej zápustkovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87085055'),
('87085055:2X', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87085055:2X'),
('87085091', '----- Na hnané nápravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87085091'),
('87085099', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87085099'),
('870870', '- Kolesá, ich časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870870'),
('87087010', '-- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2 ', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87087010'),
('87087010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87087010:2X'),
('87087050', '--- Kolesá z hliníka; časti a súčasti a príslušenstvo kolies, z hliníka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87087050'),
('87087091', '--- Hviezdice kolies odlievané v jednom kuse zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87087091'),
('87087099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87087099'),
('870880', '- Závesné systémy a ich časti a súčasti (vrátane tlmičov perovania)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870880'),
('87088020', '-- Na priemyselnú montáž: vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2 500 cm3, alebo s piestovým zážihovým spaľovacím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87088020'),
('87088020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87088020:2X'),
('87088035', '--- Tlmiče perovania', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87088035'),
('87088055', '--- Stabilizátory; ostatné torzné tyče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87088055'),
('87088055:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87088055:2X'),
('87088091', '---- Z kovanej zápustkovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87088091'),
('87088099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87088099'),
('87088099:2X', '- Ostatné časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87088099:2X'),
('870891', '-- Chladiče a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870891'),
('87089120', '--- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089120'),
('87089120:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089120:2X'),
('87089135', '---- Chladiče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089135'),
('87089135:2X', '---- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089135:2X'),
('87089191', '----- Z kovanej zápustkovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089191'),
('87089199', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089199'),
('870892', '-- Tlmiče výfuku a výfukové rúry; ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870892'),
('87089220', '--- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089220'),
('87089220:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089220:2X'),
('87089235', '---- Tlmiče výfuku a výfukové rúry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089235'),
('87089235:2X', '---- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089235:2X'),
('87089291', '----- Z kovanej zápustkovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089291'),
('87089299', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089299'),
('870893', '-- Spojky a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870893'),
('87089310', '--- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089310'),
('87089390', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089390'),
('870894', '-- Volanty, stĺpiky a skrine riadenia; ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870894'),
('87089420', '--- Na priemyselnú montáž: vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2 500 cm3, alebo s piestovým zážihovým spaľovacím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089420'),
('87089420:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089420:2X'),
('87089435', '---- Volanty, stĺpiky a skrine riadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089435'),
('87089435:2X', '---- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089435:2X'),
('87089491', '----- Z kovanej zápustkovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089491'),
('87089499', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089499'),
('870895', '-- Airbagy s nafukovacím systémom; ich časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870895'),
('87089510', '--- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87089510'),
('87089510:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089510:2X'),
('87089591', '---- Z kovanej zápustkovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089591'),
('87089599', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089599'),
('870899', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870899'),
('87089910', '--- Na priemyselnú montáž: traktorov riadených chodcom podpoložky 8701 10; vozidiel položky 8703; vozidiel položky 8704 buď s piestovým vznetovým spaľovacím motorom (dieselovým motorom alebo s motorom so žiarovou hlavou) s objemom valcov nepresahujúcim 2', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089910'),
('87089910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089910:2X'),
('87089993', '---- Z kovanej zápustkovej ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089993'),
('87089997', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87089997'),
('8709', 'Vozíky s vlastným pohonom bez zdvíhacieho alebo manipulačného zariadenia, typov používaných v továrňach, skladoch, prístavoch alebo na letiskách na prepravu nákladu na krátke vzdialenosti; malé ťahače typov používaných na nástupištiach železničných stan', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8709'),
('8709:2X', '- Vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8709:2X'),
('870911', '-- Elektrické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870911'),
('87091110', '--- Špeciálne určené na prepravu vysokorádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87091110'),
('87091190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87091190'),
('870919', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_870919'),
('87091910', '--- Špeciálne určené na prepravu vysokorádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87091910'),
('87091990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87091990'),
('87099000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87099000'),
('87100000', 'Tanky a ostatné obrnené bojové motorové vozidlá, tiež vybavené zbraňami, ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87100000'),
('8711', 'Motocykle (vrátane mopedov) a bicykle s pomocným motorom, tiež s prívesným vozíkom; prívesné vozíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8711'),
('87111000', '- S vratným piestovým spaľovacím motorom s objemom valcov nepresahujúcim 50 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87111000'),
('871120', '- S vratným piestovým spaľovacím motorom s objemom valcov presahujúcim 50 cm3, ale nepresahujúcim 250 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871120'),
('87112010', '-- Skútre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87112010'),
('87112010:2X', '-- Ostatné, s objemom valcov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87112010:2X'),
('87112092', '--- Presahujúcim 50 cm3, ale nepresahujúcim 125 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87112092'),
('87112098', '--- Presahujúcim 125 cm3, ale nepresahujúcim 250 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87112098'),
('871130', '- S vratným piestovým spaľovacím motorom s objemom valcov presahujúcim 250 cm3, ale nepresahujúcim 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871130'),
('87113010', '-- S objemom valcov presahujúcim 250 cm3, ale nepresahujúcim 380 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87113010'),
('87113090', '-- S objemom valcov presahujúcim 380 cm3, ale nepresahujúcim 500 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87113090'),
('87114000', '- S vratným piestovým spaľovacím motorom s objemom valcov presahujúcim 500 cm3, ale nepresahujúcim 800 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87114000'),
('87115000', '- S vratným piestovým spaľovacím motorom s objemom valcov presahujúcim 800 cm3', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87115000'),
('871190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871190'),
('87119010', '-- Bicykle s pomocným elektrickým motorom s trvalým menovitým výkonom nepresahujúcim 250 wattov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87119010'),
('87119090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87119090'),
('871200', 'Cestné bicykle a ostatné bicykle (vrátane dodávkových trojkoliek), bez motora', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871200'),
('87120030', '- Cestné bicykle s guľkovými ložiskami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87120030'),
('87120070', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87120070'),
('8713', 'Vozíky pre telesne postihnuté osoby, tiež motorizované alebo s iným mechanickým pohonom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8713'),
('87131000', '- Bez mechanického pohonu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87131000'),
('87139000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87139000'),
('8714', 'Časti, súčasti a príslušenstvo vozidiel položiek 8711 až 8713', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8714'),
('87141000', '- Motocyklov (vrátane mopedov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87141000'),
('87142000', '- Vozíkov pre telesne postihnuté osoby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87142000'),
('87142000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87142000:2X'),
('871491', '-- Rámy a vidlice, a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871491'),
('87149110', '--- Rámy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87149110'),
('87149130', '--- Predné vidlice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87149130'),
('87149190', '--- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149190'),
('871492', '-- Ráfiky a špice kolies', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871492'),
('87149210', '--- Ráfiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87149210'),
('87149290', '--- Špice kolies', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149290'),
('87149300', '-- Náboje kolies (okrem stredových bŕzd) a reťazové kolesá voľnobežiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149300'),
('871494', '-- Brzdy, vrátane stredových bŕzd, a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871494'),
('87149420', '--- Brzdy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149420'),
('87149490', '--- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149490'),
('87149500', '-- Sedadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149500'),
('871496', '-- Pedále a pedálové mechanizmy a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871496'),
('87149610', '--- Pedále', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_87149610'),
('87149630', '--- Pedálové mechanizmy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149630'),
('87149690', '--- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149690'),
('871499', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871499'),
('87149910', '--- Kormidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87149910'),
('87149930', '--- Nosiče batožín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87149930'),
('87149950', '--- Vyrovnávacie prevody', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149950'),
('87149990', '--- Ostatné; časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87149990'),
('871500', 'Detské kočíky a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871500'),
('87150010', '- Detské kočíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87150010'),
('87150090', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87150090'),
('8716', 'Prívesy a návesy; ostatné vozidlá bez mechanického pohonu; ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8716'),
('871610', '- Prívesy a návesy karavánového typu na bývanie alebo kempovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871610'),
('87161092', '-- S hmotnosťou nepresahujúcou 1 600 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87161092'),
('87161098', '-- S hmotnosťou presahujúcou 1 600 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87161098'),
('87162000', '- Samonakladacie alebo samovykladacie prívesy a návesy na poľnohospodárske účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87162000'),
('87162000:2X', '- Ostatné prívesy a návesy na prepravu tovaru', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87162000:2X'),
('87163100', '-- Cisternové prívesy a návesy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87163100'),
('871639', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871639'),
('87163910', '--- Špeciálne určené na prepravu vysokorádioaktívnych materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87163910'),
('87163910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87163910:2X'),
('87163910:3X', '---- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87163910:3X'),
('87163930', '----- Návesy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87163930'),
('87163950', '----- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87163950'),
('87163980', '---- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_87163980'),
('87164000', '- Ostatné prívesy a návesy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87164000'),
('87168000', '- Ostatné vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87168000'),
('871690', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_871690'),
('87169010', '-- Šasi (chassis)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87169010'),
('87169030', '-- Karosérie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87169030'),
('87169050', '-- Nápravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87169050'),
('87169090', '-- Ostatné časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_87169090'),
('880100', 'Balóny a vzducholode; vetrone, závesné klzáky a ostatné bezmotorové prostriedky na lietanie (letúne)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_880100'),
('88010010', '- Balóny a vzducholode; vetrone a závesné klzáky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_88010010'),
('88010090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_88010090'),
('8802', 'Ostatné letúne (napríklad vrtuľníky, lietadlá); kozmické lode (vrátane družíc) a suborbitálne a kozmické nosiče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8802'),
('8802:2X', '- Vrtuľníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8802:2X'),
('88021100', '-- S vlastnou hmotnosťou nepresahujúcou 2 000 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_88021100'),
('88021200', '-- S vlastnou hmotnosťou presahujúcou 2 000 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_88021200'),
('88022000', '- Letúne a ostatné lietadlá s vlastnou hmotnosťou nepresahujúcou 2 000 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_88022000'),
('88023000', '- Letúne a ostatné lietadlá s vlastnou hmotnosťou presahujúcou 2 000 kg, ale nepresahujúcou 15 000 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_88023000'),
('88024000', '- Letúne a ostatné lietadlá s vlastnou hmotnosťou presahujúcou 15 000 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_88024000'),
('880260', '- Kozmické lode (vrátane družíc) a suborbitálne a kozmické nosiče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_880260'),
('88026010', '-- Kozmické lode (vrátane družíc)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_88026010'),
('88026090', '-- Suborbitálne a kozmické nosiče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_88026090'),
('8803', 'Časti a súčasti výrobkov položky 8801 alebo 8802', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8803'),
('88031000', '- Vrtule a rotory a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88031000'),
('88032000', '- Podvozky a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88032000'),
('88033000', '- Ostatné časti a súčasti lietadiel alebo vrtuľníkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88033000'),
('880390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_880390'),
('88039010', '-- Drakov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88039010'),
('88039020', '-- Kozmických lodí (vrátane družíc)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88039020'),
('88039030', '-- Suborbitálnych a kozmických nosičov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88039030'),
('88039090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88039090'),
('88040000', 'Padáky (vrátane riaditeľných padákov a paraglidingov) a rotujúce padáky; ich časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88040000'),
('8805', 'Letecké katapulty; palubné lapače alebo podobné prístroje a zariadenia; pozemné prístroje na letecký výcvik; ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8805'),
('880510', '- Letecké katapulty a ich časti a súčasti; palubné lapače alebo podobné zariadenia a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_880510'),
('88051010', '-- Letecké katapulty a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88051010'),
('88051090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88051090'),
('88051090:2X', '- Pozemné prístroje na letecký výcvik a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88051090:2X'),
('88052100', '-- Letecké bojové simulátory, ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88052100'),
('88052900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_88052900'),
('8901', 'Lode na osobnú dopravu, turistické lode, trajektové lode, nákladné lode, nákladné člny a podobné plavidlá na prepravu osôb alebo nákladov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8901'),
('890110', '- Lode na osobnú dopravu, turistické lode a podobné plavidlá určené prevažne na prepravu osôb; trajektové lode všetkých druhov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890110'),
('89011010', '-- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89011010'),
('89011090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89011090'),
('890120', '- Cisternové lode', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890120'),
('89012010', '-- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89012010'),
('89012090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CCT'), 'SK_89012090'),
('890130', '- Chladiarenské plavidlá, okrem uvedených v podpoložke 8901 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890130'),
('89013010', '-- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89013010'),
('89013090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CCT'), 'SK_89013090'),
('890190', '- Ostatné plavidlá na nákladnú dopravu a ostatné plavidlá na prepravu osôb a nákladu súčasne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890190'),
('89019010', '-- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89019010'),
('89019090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CCT'), 'SK_89019090'),
('890200', 'Rybárske plavidlá; plavidlá zariadené na priemyselné spracovanie, opracovanie alebo konzervovanie produktov rybolovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890200'),
('89020010', '- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89020010'),
('89020090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89020090'),
('8903', 'Jachty a ostatné plavidlá na zábavu alebo šport; veslové člny a kanoe', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8903'),
('890310', '- Nafukovacie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890310'),
('89031010', '-- S hmotnosťou každého nepresahujúcou 100 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89031010'),
('89031090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89031090'),
('89031090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_89031090:2X'),
('890391', '-- Plachetnice, tiež s pomocným motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890391'),
('89039110', '--- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89039110'),
('89039190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89039190'),
('890392', '-- Motorové člny, iné ako s prívesným motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890392'),
('89039210', '--- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89039210'),
('89039210:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_89039210:2X'),
('89039291', '---- S dĺžkou nepresahujúcou 7,5 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89039291'),
('89039299', '---- S dĺžkou presahujúcou 7,5 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89039299'),
('890399', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890399'),
('89039910', '--- S hmotnosťou každého nepresahujúcou 100 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89039910'),
('89039910:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_89039910:2X'),
('89039991', '---- S dĺžkou nepresahujúcou 7,5 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89039991'),
('89039999', '---- S dĺžkou presahujúcou 7,5 m', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89039999'),
('890400', 'Ťažné a tlačné lode', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890400'),
('89040010', '- Ťažné lode', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89040010'),
('89040010:2X', '- Tlačné lode', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_89040010:2X'),
('89040091', '-- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89040091'),
('89040099', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_89040099'),
('8905', 'Majákové plavidlá, požiarne lode, plávajúce bagre, plávajúce žeriavy a ostatné plavidlá, pri ktorých je plavba iba vedľajšou činnosťou okrem ich hlavnej funkcie; plávajúce doky; plávajúce alebo ponorné vrtné alebo ťažobné plošiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8905'),
('890510', '- Plávajúce bagre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890510'),
('89051010', '-- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89051010'),
('89051090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89051090'),
('89052000', '- Plávajúce alebo ponorné vrtné alebo ťažobné plošiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89052000'),
('890590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890590'),
('89059010', '-- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89059010'),
('89059090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89059090'),
('8906', 'Ostatné plavidlá, vrátane vojnových lodí a záchranných člnov iných ako veslových člnov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8906'),
('89061000', '- Vojnové lode', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89061000'),
('890690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_890690'),
('89069010', '-- Na námornú plavbu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89069010'),
('89069010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_89069010:2X'),
('89069091', '--- S hmotnosťou každého nepresahujúcou 100 kg', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89069091'),
('89069099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89069099'),
('8907', 'Ostatné plávajúce konštrukcie (napríklad plte, nádrže, kesóny, prístavné mostíky, bóje a výstražné svetelné plaváky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_8907'),
('89071000', '- Nafukovacie plte', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89071000'),
('89079000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_89079000'),
('89080000', 'Plavidlá a ostatné plávajúce konštrukcie určené do šrotu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_89080000'),
('9001', 'Optické vlákna a zväzky optických vlákien; káble optických vlákien, iné ako zatriedené do položky 8544; listy a dosky z polarizačného materiálu; šošovky (tiež kontaktné), hranoly, zrkadlá a ostatné optické články, z akéhokoľvek materiálu, nezasadené, in', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9001'),
('900110', '- Optické vlákna, zväzky a káble z optických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_900110'),
('90011010', '-- Káble na prenos obrazu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90011010'),
('90011090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90011090'),
('90012000', '- Listy a dosky z polarizačného materiálu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90012000'),
('90013000', '- Kontaktné šošovky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90013000'),
('900140', '- Okuliarové šošovky zo skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_900140'),
('90014020', '-- Neslúžiace na korekciu videnia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90014020'),
('90014020:2X', '-- Slúžiace na korekciu videnia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90014020:2X'),
('90014020:3X', '--- Opracované obojstranne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90014020:3X'),
('90014041', '---- Jednoohniskové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90014041'),
('90014049', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90014049'),
('90014080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90014080'),
('900150', '- Okuliarové šošovky z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_900150'),
('90015020', '-- Neslúžiace na korekciu videnia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90015020'),
('90015020:2X', '-- Slúžiace na korekciu videnia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90015020:2X'),
('90015020:3X', '--- Opracované obojstranne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90015020:3X'),
('90015041', '---- Jednoohniskové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90015041'),
('90015049', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90015049'),
('90015080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90015080'),
('90019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90019000'),
('9002', 'Šošovky, hranoly, zrkadlá a ostatné optické články, z akéhokoľvek materiálu, zasadené, tvoriace časti, súčasti a príslušenstvo nástrojov alebo prístrojov, iné ako z opticky neopracovaného skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9002'),
('9002:2X', '- Objektívy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9002:2X'),
('90021100', '-- Na kamery, projektory alebo fotografické zväčšovacie alebo zmenšovacie prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90021100'),
('90021900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90021900'),
('90022000', '- Filtre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90022000'),
('90029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90029000'),
('9003', 'Rámy a obruby na okuliare, ochranné okuliare alebo podobné výrobky, ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9003'),
('9003:2X', '- Rámy a obruby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9003:2X'),
('90031100', '-- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90031100'),
('90031900', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90031900'),
('90039000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90039000'),
('9004', 'Okuliare, ochranné a podobné okuliare, korekčné alebo ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9004'),
('900410', '- Slnečné okuliare', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_900410'),
('90041010', '-- So šošovkami opticky opracovanými', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90041010'),
('90041010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90041010:2X'),
('90041091', '--- So šošovkami z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90041091'),
('90041099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90041099'),
('900490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_900490'),
('90049010', '-- So šošovkami z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90049010'),
('90049090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90049090'),
('9005', 'Binokulárne, monokulárne ďalekohľady a ostatné optické teleskopy, ich podstavce a rámy; ostatné astronomické prístroje a ich podstavce a rámy, okrem rádioastronomických prístrojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9005'),
('90051000', '- Binokulárne ďalekohľady', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90051000'),
('90058000', '- Ostatné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90058000'),
('90059000', '- Časti, súčasti a príslušenstvo (vrátane podstavcov a rámov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90059000'),
('9006', 'Fotografické prístroje (okrem kinematografických); prístroje a žiarovky na bleskové svetlo na fotografické účely okrem výbojok položky 8539', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9006'),
('90061000', '- Fotografické prístroje druhov používaných na prípravu tlačiarskych platní alebo valcov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90061000'),
('90063000', '- Fotografické prístroje zvlášť upravené na fotografovanie pod vodou alebo letecké fotografovanie, lekárske alebo chirurgické vyšetrovanie vnútorných orgánov; komparačné fotografické prístroje na forenzné alebo kriminalistické účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90063000'),
('90064000', '- Fotografické prístroje na okamžité vyvolanie a kopírovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90064000'),
('90064000:2X', '- Ostatné fotografické prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90064000:2X'),
('90065100', '-- So zameraním cez objektív [jednooké zrkadlovky (SLR)] na zvitkové filmy so šírkou nepresahujúcou 35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90065100'),
('90065200', '-- Ostatné, na zvitkové filmy so šírkou menšou ako 35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90065200'),
('900653', '-- Ostatné, na zvitkové filmy široké 35 mm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_900653'),
('90065310', '--- Fotografické prístroje na jednorazové použitie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90065310'),
('90065380', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90065380'),
('90065900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90065900'),
('90065900:2X', '- Prístroje a žiarovky na bleskové svetlo na fotografické účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90065900:2X'),
('90066100', '-- Prístroje s výbojkou na bleskové svetlo (tzv. elektronické blesky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90066100'),
('90066900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90066900'),
('90066900:2X', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90066900:2X'),
('90069100', '-- Fotografických prístrojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90069100'),
('90069900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90069900'),
('9007', 'Kinematografické kamery a projektory, tiež so vstavanými prístrojmi na záznam alebo reprodukciu zvuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9007'),
('90071000', '- Kamery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90071000'),
('90072000', '- Projektory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90072000'),
('90072000:2X', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90072000:2X'),
('90079100', '-- Kamier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90079100'),
('90079200', '-- Projektorov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90079200'),
('9008', 'Projektory statických snímok (iné ako kinematografické); fotografické (iné ako kinematografické) prístroje zväčšovacie alebo zmenšovacie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9008'),
('90085000', '- Projektory, zväčšovacie a zmenšovacie prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90085000'),
('90089000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90089000'),
('9010', 'Prístroje a vybavenie pre fotografické (vrátane kinematografických) laboratóriá, v tejto kapitole inde nešpecifikované ani nezahrnuté; negatoskopy; projekčné plochy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9010'),
('90101000', '- Prístroje a vybavenie na automatické vyvolávanie fotografických filmov (vrátane kinematografických filmov) alebo fotografických papierov vo zvitkoch alebo na automatickú expozíciu vyvolaných filmov na zvitky fotografického papiera', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90101000'),
('90105000', '- Ostatné prístroje a vybavenie pre fotografické (vrátane kinematografických) laboratóriá; negatoskopy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90105000'),
('90106000', '- Projekčné plochy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90106000'),
('90109000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90109000'),
('9011', 'Združené optické mikroskopy, vrátane mikroskopov na mikrofotografiu, mikrokinematografiu alebo mikroprojekciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9011'),
('901110', '- Stereoskopické mikroskopy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901110'),
('90111010', '-- Vybavené zariadením zvlášť konštruovaným na manipuláciu a prepravu polovodičových doštičiek alebo mriežok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90111010'),
('90111090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90111090'),
('901120', '- Ostatné mikroskopy na mikrofotografiu, mikrokinematografiu alebo mikroprojekciu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901120'),
('90112010', '-- Mikroskopy na mikrofotografiu vybavené zariadením zvlášť konštruovaným na manipuláciu a prepravu polovodičových doštičiek alebo mriežok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90112010'),
('90112090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90112090'),
('90118000', '- Ostatné mikroskopy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90118000'),
('901190', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901190'),
('90119010', '-- Prístrojov podpoložky 9011 10 10 alebo 9011 20 10', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90119010'),
('90119090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90119090'),
('9012', 'Mikroskopy iné ako optické mikroskopy; difrakčné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9012'),
('901210', '- Mikroskopy iné ako optické mikroskopy; difrakčné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901210'),
('90121010', '-- Elektrónové mikroskopy vybavené zariadením zvlášť konštruovaným na manipuláciu a prepravu polovodičových doštičiek alebo mriežok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90121010'),
('90121090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90121090'),
('901290', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901290'),
('90129010', '-- Prístrojov podpoložky 9012 10 10', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90129010'),
('90129090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90129090'),
('9013', 'Zariadenia s tekutými kryštálmi zostavené z výrobkov, ktoré nie sú presnejšie špecifikované v ostatných položkách; lasery iné ako laserové diódy; ostatné optické prístroje a nástroje, v tejto kapitole inde nešpecifikované ani nezahrnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9013'),
('90131000', '- Zameriavacie ďalekohľady na zbrane; periskopy; ďalekohľady skonštruované ako súčasť prístrojov, strojov, zariadení alebo nástrojov tejto kapitoly alebo triedy XVI', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90131000'),
('90132000', '- Lasery, iné ako laserové diódy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90132000'),
('901380', '- Ostatné zariadenia, prístroje a nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901380'),
('901380:2X', '-- S tekutými kryštálmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901380:2X'),
('90138020', '--- S aktívnymi tekutými kryštálmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90138020'),
('90138030', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90138030'),
('90138090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90138090'),
('901390', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901390'),
('90139010', '-- Na zariadenie na báze tekutých kryštálov (LCD)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90139010'),
('90139090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90139090'),
('9014', 'Navigačné kompasy; ostatné navigačné prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9014'),
('90141000', '- Navigačné kompasy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90141000'),
('901420', '- Prístroje a zariadenia na leteckú alebo kozmickú navigáciu (iné ako kompasy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901420'),
('90142020', '-- Inerciálne navigačné systémy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90142020'),
('90142080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90142080'),
('90148000', '- Ostatné prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90148000'),
('90149000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90149000'),
('9015', 'Vymeriavacie (vrátane fotogrammetrických meraní), hydrografické, oceánografické, hydrologické, meteorologické alebo geofyzikálne prístroje a zariadenia, okrem kompasov; zameriavacie zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9015'),
('901510', '- Zameriavacie zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901510'),
('90151010', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90151010'),
('90151090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90151090'),
('901520', '- Teodolity a tachymetre (tacheometre)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901520'),
('90152010', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90152010'),
('90152090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90152090'),
('901530', '- Libely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901530'),
('90153010', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90153010'),
('90153090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90153090'),
('901540', '- Fotogrammetrické, vymeriavacie prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901540'),
('90154010', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90154010'),
('90154090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90154090'),
('901580', '- Ostatné prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901580'),
('901580:2X', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901580:2X'),
('90158011', '--- Meteorologické, hydrologické a geofyzikálne prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90158011'),
('90158019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90158019'),
('90158019:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90158019:2X'),
('90158091', '--- Prístroje a zariadenia používané v geodézii, topografii, vymeriavaní alebo nivelizácii; hydrografické prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90158091'),
('90158093', '--- Meteorologické, hydrologické a geofyzikálne prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90158093'),
('90158099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90158099'),
('90159000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90159000'),
('901600', 'Váhy s citlivosťou 5 cg alebo lepšou, tiež so závažiami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901600'),
('90160010', '- Váhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90160010'),
('90160090', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90160090'),
('9017', 'Kresliace, rysovacie alebo počítacie prístroje a nástroje (napríklad kresliace stroje, pantografy, uhlomery, rysovadlá, logaritmické pravítka a počítacie kotúče); ručné dĺžkové meradlá (napríklad metre, meracie pásma, mikrometre, posuvné meradlá a kalib', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9017'),
('901710', '- Kresliace (rysovacie) stoly a stroje, tiež automatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901710'),
('90171010', '-- Súradnicové zapisovače (plottery)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90171010'),
('90171090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90171090'),
('901720', '- Ostatné kresliace, rysovacie alebo počítacie nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901720'),
('90172005', '-- Súradnicové zapisovače (plotery)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90172005'),
('90172010', '-- Ostatné kresliace (rysovacie) prístroje a nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90172010'),
('90172039', '-- Predkresľovacie (značkovacie) nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90172039'),
('90172090', '-- Matematické počítacie prístroje a nástroje (vrátane logaritmických pravítok, kruhových logaritmických pravítok a podobne)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90172090'),
('90173000', '- Mikrometre, posuvné meradlá, kalibre a mierky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90173000'),
('901780', '- Ostatné prístroje a nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901780'),
('90178010', '-- Meracie tyče a meracie pásma a meradlá s delením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90178010'),
('90178090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90178090'),
('90179000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90179000'),
('9018', 'Lekárske, chirurgické, zubolekárske alebo zverolekárske nástroje, prístroje a zariadenia vrátane scintigrafických prístrojov, ostatné elektrolekárske prístroje, ako aj prístroje na skúšanie zraku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9018'),
('9018:2X', '- Elektrodiagnostické prístroje (vrátane prístojov na funkčné vyšetrenie alebo kontrolu fyziologických parametrov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9018:2X'),
('90181100', '-- Elektrokardiografy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90181100'),
('90181200', '-- Ultrazvukové diagnostické prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90181200'),
('90181300', '-- Diagnostické prístroje magneticko rezonančné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90181300'),
('90181400', '-- Scintigrafické prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90181400'),
('901819', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901819'),
('90181910', '--- Monitorovacie prístroje na simultánne monitorovanie dvoch alebo viacerých parametrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90181910'),
('90181990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90181990'),
('90182000', '- Prístroje na ultrafialové alebo infračervené žiarenie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90182000'),
('90182000:2X', '- Injekčné striekačky, ihly, katétre (cievkovače), kanyly a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90182000:2X'),
('901831', '-- Injekčné striekačky, tiež s ihlami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901831'),
('90183110', '--- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90183110'),
('90183190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90183190'),
('901832', '-- Kovové rúrkové ihly a zošívacie ihly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901832'),
('90183210', '--- Kovové rúrkové ihly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90183210'),
('90183290', '--- Zošívacie ihly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90183290'),
('90183900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90183900'),
('90183900:2X', '- Ostatné nástroje, prístroje a zariadenia používané v zubolekárstve', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90183900:2X'),
('90184100', '-- Zubné vŕtačky, tiež kombinované na spoločnej základni s ostatným zubolekárskym príslušenstvom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90184100'),
('901849', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901849'),
('90184910', '--- Frézy, disky, vrtáky a kefky na použitie v zubných vŕtačkách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90184910'),
('90184990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90184990'),
('901850', '- Ostatné oftalmologické nástroje a prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901850'),
('90185010', '-- Iné ako optické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90185010'),
('90185090', '-- Optické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90185090'),
('901890', '- Ostatné nástroje a prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901890'),
('90189010', '-- Nástroje a prístroje na meranie krvného tlaku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90189010'),
('90189020', '-- Endoskopy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90189020'),
('90189030', '-- Prístroje a zariadenia na dialýzu obličiek (umelé obličky, dialyzačné prístroje)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90189030'),
('90189040', '-- Prístroje na diatermiu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90189040'),
('90189050', '-- Transfúzne prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90189050'),
('90189060', '-- Prístroje, nástroje a zariadenia na anestéziu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90189060'),
('90189075', '-- Prístroje na stimuláciu nervov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90189075'),
('90189084', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90189084'),
('9019', 'Mechanoterapeutické zariadenia; masážne prístroje; prístroje na testovanie psychologickej spôsobilosti; prístroje na liečenie ozónom, kyslíkom, aerosólom, prístroje na umelé dýchanie alebo ostatné liečebné dýchacie prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9019'),
('901910', '- Mechanoterapeutické zariadenia; masážne prístroje; prístroje na testovanie psychologickej spôsobilosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_901910'),
('90191010', '-- Elektrické vibračné masážne strojčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90191010'),
('90191090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90191090'),
('90192000', '- Prístroje na liečenie ozónom, kyslíkom, aerosólom, prístroje na umelé dýchanie alebo ostatné liečebné dýchacie prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90192000'),
('90200000', 'Ostatné dýchacie prístroje a plynové masky, okrem ochranných masiek bez mechanických častí a vymeniteľných filtrov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90200000'),
('9021', 'Ortopedické pomôcky vrátane bariel, liečebných a chirurgických pásov a bandáží; dlahy a ostatné pomôcky na liečenie zlomenín; umelé časti tela; načúvacie pomôcky a ostatné zariadenia nosené alebo prenášané na tele alebo v tele implantované, na kompenzov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9021'),
('902110', '- Ortopedické pomôcky alebo pomôcky na liečenie zlomenín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902110'),
('90211010', '-- Ortopedické pomôcky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90211010'),
('90211090', '-- Dlahy a ostatné pomôcky na liečenie zlomenín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90211090'),
('90211090:2X', '- Umelé zuby a zubolekárske príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90211090:2X'),
('902121', '-- Umelé zuby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902121'),
('90212110', '--- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CEN'), 'SK_90212110'),
('90212190', '--- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_CEN'), 'SK_90212190'),
('90212900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90212900'),
('90212900:2X', '- Ostatné umelé časti tela', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90212900:2X'),
('90213100', '-- Umelé kĺby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90213100'),
('902139', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902139'),
('90213910', '--- Očné protézy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90213910'),
('90213990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90213990'),
('90214000', '- Načúvacie pomôcky, okrem ich častí, súčastí a príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90214000'),
('90215000', '- Stimulátory srdcového svalu, okrem ich častí, súčastí a príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90215000'),
('902190', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902190'),
('90219010', '-- Časti, súčasti a príslušenstvo načúvacích pomôcok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90219010'),
('90219090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90219090'),
('9022', 'Prístroje využívajúce röntgenove lúče alebo žiarenie alfa, beta alebo gama, tiež na lekárske, chirurgické, zubolekárske alebo zverolekárske účely, vrátane rádiografických alebo rádioterapeutických prístrojov, trubice vyžarujúce rőntgenove lúče a ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9022'),
('9022:2X', '- Prístroje využívajúce röntgenove lúče, tiež na lekárske, chirurgické, zubolekárske alebo zverolekárske účely, vrátane rádiografických alebo rádioterapeutických prístrojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9022:2X'),
('90221200', '-- Tomografické prístroje riadené strojom na automatické spracovanie informácií', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90221200'),
('90221300', '-- Ostatné, na zubolekárske účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90221300'),
('90221400', '-- Ostatné, na lekárske, chirurgické alebo zverolekárske účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90221400'),
('90221900', '-- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90221900'),
('90221900:2X', '- Prístroje využívajúce žiarenie alfa, beta alebo gama, tiež na lekárske, chirurgické, zubolekárske alebo zverolekárske účely, vrátane rádiografických alebo rádioterapeutických prístrojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90221900:2X'),
('90222100', '-- Na lekárske, chirurgické, zubolekárske alebo zverolekárske účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90222100'),
('90222900', '-- Na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90222900'),
('90223000', '- Trubice na röntgenove lúče', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90223000'),
('90229000', '- Ostatné, vrátane častí, súčastí a príslušenstva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90229000'),
('902300', 'Nástroje, prístroje, zariadenia a modely predurčené na predvádzacie účely (napríklad pri vyučovaní alebo na výstavách), nehodiace sa na ostatné účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902300'),
('90230010', '- Na vyučovanie fyziky, chémie alebo technických predmetov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90230010'),
('90230080', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90230080'),
('9024', 'Stroje a prístroje na skúšanie tvrdosti, pevnosti v ťahu, stlačiteľnosti, elasticity alebo ostatných mechanických vlastností materiálov (napríklad kovov, dreva, textilu, papiera, plastov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9024'),
('902410', '- Stroje a prístroje na skúšanie kovov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902410'),
('902410:2X', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902410:2X'),
('90241011', '--- Univerzálne alebo na testovanie pevnosti v ťahu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90241011'),
('90241013', '--- Na skúšanie tvrdosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90241013'),
('90241019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90241019'),
('90241090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90241090'),
('902480', '- Ostatné stroje a prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902480'),
('902480:2X', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902480:2X'),
('90248011', '--- Na skúšanie textilných materiálov, papiera alebo lepenky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90248011'),
('90248019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90248019'),
('90248090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90248090'),
('90249000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90249000'),
('9025', 'Hydrometre a podobné plávajúce prístroje, teplomery, žiaromery, barometre, vlhkomery a psychrometre, tiež registračné i navzájom kombinované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9025'),
('9025:2X', '- Teplomery a pyrometre, nekombinované s ostatnými prístrojmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9025:2X'),
('902511', '-- Kvapalinové, s priamym čítaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902511'),
('90251120', '--- Klinické alebo zverolekárske teplomery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90251120'),
('90251180', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90251180'),
('902519', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902519'),
('90251920', '--- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90251920'),
('90251980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90251980'),
('902580', '- Ostatné prístroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902580'),
('90258020', '-- Barometre, nekombinované s ostatnými prístrojmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90258020'),
('90258020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90258020:2X'),
('90258040', '--- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90258040'),
('90258080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90258080'),
('90259000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90259000'),
('9026', 'Prístroje a nástroje na meranie alebo na kontrolu prietokov, hladiny, tlaku alebo ostatných premenných charakteristík kvapalín alebo plynov (napríklad prietokomery, hladinomery, manometre, merače tepla), okrem prístrojov a nástrojov položiek 9014, 9015,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9026'),
('902610', '- Na meranie alebo kontrolu prietokov alebo hladiny kvapalín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902610'),
('902610:2X', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902610:2X'),
('90261021', '--- Prietokomery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90261021'),
('90261029', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90261029'),
('90261029:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90261029:2X'),
('90261081', '--- Prietokomery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90261081'),
('90261089', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90261089'),
('902620', '- Na meranie alebo kontrolu tlaku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902620'),
('90262020', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90262020'),
('90262020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90262020:2X'),
('90262040', '--- So špirálou alebo s kovovou membránou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90262040'),
('90262080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90262080'),
('902680', '- Ostatné prístroje a nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902680'),
('90268020', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90268020'),
('90268080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90268080'),
('90269000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90269000'),
('9027', 'Prístroje, zariadenia a nástroje na fyzikálne alebo na chemické rozbory (napríklad polarimetre, spektrometre, refraktometre, analyzátory plynov alebo dymu); nástroje, prístroje a zariadenia na meranie alebo kontrolu viskozity, pórovitosti, rozťažnosti,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9027'),
('902710', '- Analyzátory plynov alebo dymu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902710'),
('90271010', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90271010'),
('90271090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90271090'),
('90272000', '- Chromatografy a prístroje na elektroforézu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90272000'),
('90273000', '- Spektrometre, spektrofotometre a spektrografy využívajúce optické žiarenie (ultrafialové, viditeľné, infračervené)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90273000'),
('90275000', '- Ostatné nástroje, prístroje a zariadenia využívajúce optické žiarenie (ultrafialové, viditeľné, infračervené)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90275000'),
('902780', '- Ostatné nástroje, prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902780'),
('90278005', '-- Expozimetre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90278005'),
('90278005:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90278005:2X'),
('90278005:3X', '--- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90278005:3X'),
('90278011', '---- pH metre, rH metre a ostatné prístroje na meranie vodivosti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90278011'),
('90278013', '---- Prístroje na meranie fyzikálnych vlastností polovodičových materiálov alebo LCD substrátov, alebo pripojených izolačných a vodivých vrstiev počas výrobného procesu polovodičovej doštičky alebo LCD výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90278013'),
('90278017', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90278017'),
('90278017:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90278017:2X'),
('90278091', '---- Viskozimetre, porozimetre a expanzimetre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90278091'),
('90278099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90278099'),
('902790', '- Mikrotómy; časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902790'),
('90279010', '-- Mikrotómy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90279010'),
('90279010:2X', '-- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90279010:2X'),
('90279050', '--- Prístrojov podpoložiek 9027 20 až 9027 80', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90279050'),
('90279080', '--- Mikrotómov alebo analyzačných prístrojov plynov alebo dymu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90279080'),
('9028', 'Merače dodávky alebo produkcie plynov, kvapalín alebo elektrickej energie, vrátane ich kalibračných meračov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9028'),
('90281000', '- Plynomery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90281000'),
('90282000', '- Merače kvapalín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90282000'),
('902830', '- Elektromery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902830'),
('902830:2X', '-- Na striedavý prúd', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902830:2X'),
('90283011', '--- Jednofázový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90283011'),
('90283019', '--- Viacfázový', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90283019'),
('90283090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90283090'),
('902890', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902890'),
('90289010', '-- Na elektromery', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90289010'),
('90289090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90289090'),
('9029', 'Otáčkomery, počítače výrobkov, taxametre, merače ubehnutej dráhy, krokomery a podobné počítače; indikátory rýchlosti a tachometre, iné ako zatriedené do položky 9014 alebo 9015; stroboskopy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9029'),
('90291000', '- Otáčkomery, počítače výrobkov, taxametre, merače ubehnutej dráhy, krokomery a podobné počítače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90291000'),
('902920', '- Indikátory rýchlosti a tachometre; stroboskopy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902920'),
('902920:2X', '-- Indikátory rýchlosti a tachometre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_902920:2X'),
('90292031', '--- Indikátory rýchlosti na vozidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90292031'),
('90292038', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90292038'),
('90292090', '-- Stroboskopy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90292090'),
('90299000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90299000'),
('9030', 'Osciloskopy, analyzátory spektra a ostatné nástroje, prístroje a zariadenia na meranie alebo kontrolu elektrických veličín, okrem meračov položky 9028; nástroje, prístroje a zariadenia na meranie alebo zisťovanie žiarenia alfa, beta, gama, röntgenových', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9030'),
('90301000', '- Nástroje, prístroje a zariadenia na meranie alebo zisťovanie ionizujúceho žiarenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90301000'),
('903020', '- Osciloskopy a oscilografy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903020'),
('90302010', '-- Katódové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90302010'),
('90302030', '-- Ostatné, so záznamovým zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90302030'),
('90302030:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90302030:2X'),
('90302091', '--- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90302091'),
('90302099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90302099'),
('90302099:2X', '- Ostatné nástroje, prístroje a zariadenia na meranie alebo kontrolu napätia, prúdu, odporu alebo výkonu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90302099:2X'),
('90303100', '-- Univerzálne meracie nástroje, prístroje a zariadenia, bez záznamového zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90303100'),
('90303200', '-- Univerzálne meracie nástroje, prístroje a zariadenia, so záznamovým zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90303200'),
('903033', '-- Ostatné, bez záznamového zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903033'),
('90303310', '--- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90303310'),
('90303310:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90303310:2X'),
('90303391', '---- Voltmetre', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90303391'),
('90303399', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90303399'),
('90303900', '-- Ostatné, so záznamovým zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90303900'),
('90304000', '- Ostatné nástroje, prístroje a zariadenia zvlášť určené pre oznamovaciu techniku (napríklad hypsometre, merače zosilnenia, merače skreslenia, psofometre a pod.)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90304000'),
('90304000:2X', '- Ostatné nástroje, prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90304000:2X'),
('90308200', '-- Na meranie alebo kontrolu polovodičových doštičiek alebo zariadení', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90308200'),
('90308400', '-- Ostatné, so záznamovým zariadením', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90308400'),
('903089', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903089'),
('90308930', '--- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90308930'),
('90308990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90308990'),
('903090', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903090'),
('90309020', '-- Na nástroje, prístroje a zariadenia podpoložky 9030 82 00', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90309020'),
('90309085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90309085'),
('9031', 'Meracie alebo kontrolné nástroje, prístroje, zariadenia a stroje, inde nešpecifikované ani nezahrnuté v tejto kapitole; projektory na kontrolu profilov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9031'),
('90311000', '- Stroje na vyvažovanie mechanických súčastí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90311000'),
('90312000', '- Skúšobné zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90312000'),
('90312000:2X', '- Ostatné optické nástroje, prístroje a zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90312000:2X'),
('90314100', '-- Na kontrolu polovodičových doštičiek alebo polovodičových zariadení alebo na kontrolu fotomasiek alebo ohniskových doštičiek používaných na výrobu polovodičových zariadení', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90314100'),
('903149', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903149'),
('90314910', '--- Projektory na kontrolu profilov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90314910'),
('90314990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90314990'),
('903180', '- Ostatné nástroje, prístroje, zariadenia a stroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903180'),
('903180:2X', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903180:2X'),
('903180:3X', '--- Na meranie alebo kontrolu geometrických veličín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903180:3X'),
('90318032', '---- Na kontrolu polovodičových doštičiek alebo polovodičových zariadení alebo na kontrolu fotomasiek alebo ohniskových doštičiek používaných na výrobu polovodičových zariadení', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90318032'),
('90318034', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90318034'),
('90318038', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90318038'),
('90318038:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90318038:2X'),
('90318091', '--- Na meranie alebo kontrolu geometrických veličín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90318091'),
('90318098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90318098'),
('903190', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903190'),
('90319020', '-- Na prístroje podpoložky 9031 41 00 alebo na optické nástroje a prístroje na meranie povrchového znečistenia polovodičových doštičiek podpoložky 9031 49 90', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90319020'),
('90319030', '-- Na prístroje podpoložky 9031 80 32', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90319030'),
('90319085', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90319085'),
('9032', 'Automatické regulačné alebo riadiace prístroje a nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9032'),
('903210', '- Termostaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_903210'),
('90321020', '-- Elektronické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90321020'),
('90321020:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90321020:2X'),
('90321081', '--- S elektrickým prepínačom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90321081'),
('90321089', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90321089'),
('90322000', '- Manostaty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_90322000'),
('90322000:2X', '- Ostatné prístroje a nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90322000:2X'),
('90328100', '-- Hydraulické alebo pneumatické', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90328100'),
('90328900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90328900'),
('90329000', '- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90329000'),
('90330000', 'Časti a súčasti a príslušenstvo (v tejto kapitole inde nešpecifikované ani nezahrnuté) na stroje, nástroje alebo prístroje kapitoly 90', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_90330000'),
('9101', 'Náramkové hodinky, vreckové hodinky a ostatné hodinky, vrátane stopiek, s puzdrom z drahého kovu alebo z kovu plátovaného drahým kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9101'),
('9101:2X', '- Náramkové hodinky, poháňané elektricky, tiež so stopkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9101:2X'),
('91011100', '-- Len s mechanickým ciferníkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91011100'),
('91011900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91011900'),
('91011900:2X', '- Ostatné náramkové hodinky, tiež so stopkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91011900:2X'),
('91012100', '-- S automatickým naťahovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91012100'),
('91012900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91012900'),
('91012900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91012900:2X'),
('91019100', '-- Poháňané elektricky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91019100'),
('91019900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91019900'),
('9102', 'Náramkové hodinky, vreckové hodinky a ostatné hodinky, vrátane stopiek, iné ako položky 9101', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9102'),
('9102:2X', '- Náramkové hodinky, poháňané elektricky, tiež so stopkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9102:2X'),
('91021100', '-- Len s mechanickým ciferníkom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91021100'),
('91021200', '-- Len s optoelektrickým displejom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91021200'),
('91021900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91021900'),
('91021900:2X', '- Ostatné náramkové hodinky, tiež so stopkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91021900:2X'),
('91022100', '-- S automatickým naťahovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91022100'),
('91022900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91022900'),
('91022900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91022900:2X'),
('91029100', '-- Poháňané elektricky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91029100'),
('91029900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91029900'),
('9103', 'Hodiny s hodinkovým strojčekom, iné ako hodiny položky 9104', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9103'),
('91031000', '- Poháňané elektricky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91031000'),
('91039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91039000'),
('91040000', 'Hodiny do prístrojových panelov a podobné typy hodín do vozidiel, lietadiel, kozmických lodí alebo plavidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91040000'),
('9105', 'Ostatné hodiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9105'),
('9105:2X', '- Budíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9105:2X'),
('91051100', '-- Poháňané elektricky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91051100'),
('91051900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91051900'),
('91051900:2X', '- Nástenné hodiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91051900:2X'),
('91052100', '-- Poháňané elektricky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91052100'),
('91052900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91052900'),
('91052900:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91052900:2X'),
('91059100', '-- Poháňané elektricky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91059100'),
('91059900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91059900'),
('9106', 'Prístroje zaznamenávajúce denný čas a prístroje na meranie, zaznamenávanie alebo iné zobrazovanie časového intervalu, s hodinovým alebo hodinkovým strojčekom alebo synchrónnym motorom (napríklad kontrolné registračné hodiny, záznamové hodiny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9106'),
('91061000', '- Kontrolné registračné hodiny; záznamové hodiny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91061000'),
('91069000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91069000'),
('91070000', 'Časové spínače, s hodinovým alebo hodinkovým strojčekom alebo synchrónnym motorom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91070000'),
('9108', 'Hodinkové strojčeky, úplné a zmontované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9108'),
('9108:2X', '- Poháňané elektricky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9108:2X'),
('91081100', '-- Len s mechanickým ciferníkom alebo so zariadením umožňujúcim vsadiť mechanický ciferník', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91081100'),
('91081200', '-- Len s optoelektrickým displejom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91081200'),
('91081900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91081900'),
('91082000', '- S automatickým naťahovaním', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91082000'),
('91089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91089000'),
('9109', 'Hodinové strojčeky, úplné a zmontované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9109'),
('91091000', '- Poháňané elektricky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91091000'),
('91099000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91099000'),
('9110', 'Úplné hodinkové alebo hodinové strojčeky, nezmontované alebo čiastočne zmontované (súpravy); neúplné hodinkové alebo hodinové strojčeky zmontované; nedohotovené hodinkové alebo hodinové strojčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9110'),
('9110:2X', '- Hodinkové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9110:2X'),
('911011', '-- Úplné strojčeky nezmontované alebo čiastočne zmontované (súpravy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_911011'),
('91101110', '--- So zotrvačníkovým kolieskom s vláskom (kompletkou)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91101110'),
('91101190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91101190'),
('91101200', '-- Neúplné strojčeky, zmontované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91101200'),
('91101900', '-- Nedohotovené strojčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91101900'),
('91109000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91109000'),
('9111', 'Puzdrá hodiniek a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9111'),
('91111000', '- Puzdrá z drahého kovu alebo z kovu plátovaného drahým kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91111000'),
('91112000', '- Puzdrá zo základného kovu, tiež pokovované zlatom alebo striebrom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91112000'),
('91118000', '- Ostatné puzdrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91118000'),
('91119000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91119000'),
('9112', 'Puzdrá hodín a puzdrá podobného typu na ostatné výrobky tejto kapitoly a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9112'),
('91122000', '- Puzdrá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_91122000'),
('91129000', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91129000'),
('9113', 'Hodinkové remienky, hodinkové pásky, hodinkové náramky a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9113'),
('911310', '- Z drahého kovu alebo z kovu plátovaného drahým kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_911310'),
('91131010', '-- Z drahého kovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91131010'),
('91131090', '-- Z kovu plátovaného drahým kovom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91131090'),
('91132000', '- Zo základného kovu, tiež pokovované alebo striebrom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91132000'),
('91139000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91139000'),
('9114', 'Ostatné časti a súčasti hodín alebo hodiniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9114'),
('91141000', '- Perá vrátane vláskov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91141000'),
('91143000', '- Číselníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91143000'),
('91144000', '- Platiny a ložiskové mostíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91144000'),
('91149000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_91149000'),
('9201', 'Klavíry a pianína vrátane automatických; čembalá a ostatné strunové nástroje s klaviatúrou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9201'),
('920110', '- Pianína', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_920110'),
('92011010', '-- Nové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92011010'),
('92011090', '-- Použité', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92011090'),
('92012000', '- Krídla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92012000'),
('92019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92019000'),
('9202', 'Ostatné strunové hudobné nástroje (napríklad gitary, husle, harfy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9202'),
('920210', '- Sláčikové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_920210'),
('92021010', '-- Husle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92021010'),
('92021090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92021090'),
('920290', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_920290'),
('92029030', '-- Gitary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92029030'),
('92029080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92029080'),
('9205', 'Dychové hudobné nástroje (napríklad píšťalové organy s klaviatúrou, akordeóny, klarinety, trúbky, gajdy), iné ako orchestrióny a mechanické hracie skrinky (verklíky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9205'),
('92051000', '- Dychové nástroje plechové', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92051000'),
('920590', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_920590'),
('92059010', '-- Akordeóny (ťahacie harmoniky) a podobné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92059010'),
('92059030', '-- Fúkacie harmoniky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92059030'),
('92059050', '-- Píšťalové organy s klaviatúrou; harmóniá a podobné nástroje s klaviatúrou a voľnými kovovými jazýčkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92059050'),
('92059090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92059090'),
('92060000', 'Bicie hudobné nástroje (napríklad bubny, bubienky, xylofóny, činely, kastanety, marakasy)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92060000'),
('9207', 'Hudobné nástroje, ktorých zvuk sa tvorí alebo sa musí zosilniť elektricky (napríklad organy, gitary, akordeóny)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9207'),
('920710', '- Klávesové hudobné nástroje, iné ako akordeóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_920710'),
('92071010', '-- Organy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92071010'),
('92071030', '-- Digitálne klavíry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92071030'),
('92071050', '-- Syntetizátory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92071050'),
('92071080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92071080'),
('920790', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_920790'),
('92079010', '-- Gitary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_92079010'),
('92079090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92079090'),
('9208', 'Hracie skrinky, orchestrióny, mechanické hracie skrinky (verklíky), mechanické spievajúce vtáky, hracie píly a ostatné hudobné nástroje nezatriedené do ostatných položiek tejto kapitoly; vábničky všetkých druhov; píšťalky, húkačky a ostatné dychové sign', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9208'),
('92081000', '- Hracie skrinky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92081000'),
('92089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92089000'),
('9209', 'Časti, súčasti a príslušenstvo hudobných nástrojov (napríklad mechanizmy hracích skriniek, karty, kotúče a valčeky na mechanicky hrajúce prístroje); metronómy a ladičky všetkých druhov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9209'),
('92093000', '- Struny na hudobné nástroje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92093000'),
('92093000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92093000:2X'),
('92099100', '-- Časti, súčasti a príslušenstvo klavírov a pianín', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92099100'),
('92099200', '-- Časti, súčasti a príslušenstvo hudobných nástrojov položky 9202', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92099200'),
('92099400', '-- Časti, súčasti a príslušenstvo hudobných nástrojov položky 9207', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92099400'),
('920999', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_920999'),
('92099920', '--- Časti, súčasti a príslušenstvo hudobných nástrojov položky 9205', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92099920'),
('92099920:2X', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92099920:2X'),
('92099940', '---- Metronómy a ladičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92099940'),
('92099950', '---- Mechanizmy hracích skriniek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92099950'),
('92099970', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_92099970'),
('9301', 'Vojenské zbrane iné ako revolvery, pištole a zbrane položky 9307', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9301'),
('93011000', '- Delostrelecké zbrane (napríklad delá, húfnice a mínomety)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93011000'),
('93012000', '- Raketomety; plameňomety; granátomety; torpédomety a podobné vrhače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93012000'),
('93019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93019000'),
('93020000', 'Revolvery a pištole, iné ako zatriedené do položky 9303 alebo 9304', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_93020000'),
('9303', 'Ostatné strelné zbrane a zariadenia fungujúce na princípe výbuchu strelného prachu (napríklad športové brokovnice a guľovnice, strelné zbrane, ktoré možno nabíjať len ústím hlavne, pištole vystreľujúce rakety a ostatné zariadenia určené len na vypúšťani', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9303'),
('93031000', '- Strelné zbrane nabíjané ústím hlavne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_93031000'),
('930320', '- Ostatné brokovnice, športové, lovecké alebo na streľbu na terč, vrátane kombinácie brokovnica - guľovnica', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_930320'),
('93032010', '-- S jednou hladkou hlavňou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_93032010'),
('93032095', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_93032095'),
('93033000', '- Ostatné guľovnice, športové, lovecké alebo na streľbu na terč', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_93033000'),
('93039000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_93039000'),
('93040000', 'Ostatné zbrane (napríklad pušky, karabíny a pištole na pero, tlak vzduchu alebo plynu, obušky), okrem zbraní položky 9307', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93040000'),
('9305', 'Časti, súčasti a príslušenstvo výrobkov položiek 9301 až 9304', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9305'),
('93051000', '- Revolverov alebo pištolí', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93051000'),
('93052000', '- Brokovníc alebo guľovníc položky 9303', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93052000'),
('93052000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93052000:2X'),
('93059100', '-- Na vojenské zbrane položky 9301', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93059100'),
('93059900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93059900'),
('9306', 'Bomby, granáty, torpéda, míny, riadené strely a podobná vojenská výstroj a jej časti; náboje a ostatné strelivo a ich časti a súčasti vrátane brokov a nábojových krytiek (zátok)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9306'),
('9306:2X', '- Náboje do brokovníc a ich časti a súčasti; broky do vzduchoviek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9306:2X'),
('93062100', '-- Náboje', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MIL'), 'SK_93062100'),
('93062900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93062900'),
('930630', '- Ostatné náboje a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_930630'),
('93063010', '-- Do revolverov a pištolí položky 9302 a do samopalov a automatických pušiek položky 9301', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93063010'),
('93063010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93063010:2X'),
('93063030', '--- Do vojenských zbraní', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93063030'),
('93063090', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93063090'),
('930690', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_930690'),
('93069010', '-- Na vojenské účely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93069010'),
('93069090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93069090'),
('93070000', 'Meče, tesáky, bodáky, kopije a podobné sečné a bodné zbrane, ich časti, súčasti a ich pošvy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_93070000'),
('9401', 'Sedadlá (okrem sedadiel 9402), tiež premeniteľné na lôžka a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9401'),
('94011000', '- Sedadlá druhov používaných v lietadlách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94011000'),
('94012000', '- Sedadlá druhov používaných v motorových vozidlách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94012000'),
('94013000', '- Otáčacie sedadlá nastaviteľné na výšku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94013000'),
('94014000', '- Sedadlá, iné ako kempingové alebo záhradné, premeniteľné na lôžka', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94014000'),
('94014000:2X', '- Sedadlá z indického tŕstia, vŕbového prútia, bambusu alebo z podobných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94014000:2X'),
('94015100', '-- Z bambusu alebo z ratanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94015100'),
('94015900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94015900'),
('94015900:2X', '- Ostatné sedadlá s drevenou kostrou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94015900:2X'),
('94016100', '-- Čalúnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94016100'),
('94016900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94016900'),
('94016900:2X', '- Ostatné sedadlá s kovovou kostrou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94016900:2X'),
('94017100', '-- Čalúnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94017100'),
('94017900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94017900'),
('94018000', '- Ostatné sedadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94018000'),
('940190', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940190'),
('94019010', '-- Sedadiel, druhov používaných v lietadlách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94019010'),
('94019010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94019010:2X'),
('94019030', '--- Z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94019030'),
('94019080', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94019080'),
('9402', 'Lekársky, chirurgický, zubolekársky alebo zverolekársky nábytok (napríklad operačné stoly, vyšetrovacie stoly, nemocničné lôžka s mechanickým zariadením, zubolekárske kreslá); kreslá holičské a kadernícke a podobné kreslá, vybavené otočným a zároveň skl', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9402'),
('94021000', '- Zubolekárske kreslá, kreslá holičské a kadernícke alebo podobné kreslá a ich časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94021000'),
('94029000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94029000'),
('9403', 'Ostatný nábytok a jeho časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9403'),
('940310', '- Kancelársky kovový nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940310'),
('940310:2X', '-- Nepresahujúci výšku 80 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940310:2X'),
('94031051', '--- Písacie stoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94031051'),
('94031058', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94031058'),
('94031058:2X', '-- Presahujúci výšku 80 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94031058:2X'),
('94031091', '--- Skrine s dverami, žalúziami alebo so sklopnými doskami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94031091'),
('94031093', '--- Registračné skrinky, lístkovnice a ostatné kartotečné skrine', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94031093'),
('94031098', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94031098'),
('940320', '- Ostatný kovový nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940320'),
('94032020', '-- Postele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94032020'),
('94032080', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94032080'),
('940330', '- Kancelársky drevený nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940330'),
('940330:2X', '-- Nepresahujúci výšku 80 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940330:2X'),
('94033011', '--- Písacie stoly', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94033011'),
('94033019', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94033019'),
('94033019:2X', '-- Presahujúci výšku 80 cm', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94033019:2X'),
('94033091', '--- Skrine s dverami, žalúziami alebo so sklopnými doskami; registračné skrinky, lístkovnice a ostatné kartotečné skrine', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94033091'),
('94033099', '--- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94033099'),
('940340', '- Kuchynský drevený nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940340'),
('94034010', '-- Vstavané kuchynské jednotky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94034010'),
('94034090', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94034090'),
('94035000', '- Spálňový drevený nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94035000'),
('940360', '- Ostatný drevený nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940360'),
('94036010', '-- Drevený nábytok druhov používaných v bytových jedálňach a obývacích izbách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94036010'),
('94036030', '-- Drevený nábytok druhov používaných v obchodoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94036030'),
('94036090', '-- Ostatný drevený nábytok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94036090'),
('94037000', '- Nábytok z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94037000'),
('94037000:2X', '- Nábytok z ostatných materiálov, vrátane tŕstia, vŕbového prútia, bambusu alebo podobných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94037000:2X'),
('94038100', '-- Z bambusu alebo z ratanu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94038100'),
('94038900', '-- Ostatný', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94038900'),
('940390', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940390'),
('94039010', '-- Z kovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94039010'),
('94039030', '-- Z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94039030'),
('94039090', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94039090'),
('9404', 'Matracové podložky; posteľoviny a podobné výrobky (napríklad matrace, prešívané prikrývky, periny, vankúše a podhlavníky), s pružinami alebo vypchávané, alebo vnútri vyložené akýmkoľvek materiálom, alebo z ľahčeného kaučuku alebo ľahčených plastov, tiež', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9404'),
('94041000', '- Matracové podložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94041000'),
('94041000:2X', '- Matrace', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94041000:2X'),
('940421', '-- Z ľahčeného kaučuku alebo ľahčených plastov, tiež potiahnuté', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940421'),
('94042110', '--- Z kaučuku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94042110'),
('94042190', '--- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94042190'),
('940429', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940429'),
('94042910', '--- S kovovými pružinami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94042910'),
('94042990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94042990'),
('94043000', '- Spacie vaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_94043000'),
('940490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940490'),
('94049010', '-- Plnené páraným alebo prachovým perím', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94049010'),
('94049090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94049090'),
('9405', 'Svietidlá a osvetľovacie zariadenia vrátane svetlometov a reflektorov a ich časti a súčasti, inde nešpecifikované ani nezahrnuté; svetelné reklamy, svetelné znaky a značky, svetelné oznamovacie tabule a podobné výrobky, s pevným osvetľovacím zdrojom, a', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9405'),
('940510', '- Lustre a ostatné elektrické stropné alebo nástenné osvetľovacie zariadenia, okrem vonkajších osvetľovacích zariadení druhov používaných na osvetlenie verejných priestorov alebo ciest', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940510'),
('940510:2X', '-- Z plastov alebo z keramických materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940510:2X'),
('94051021', '--- Z plastov, druhov používaných so žiarovkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94051021'),
('94051040', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94051040'),
('94051050', '-- Zo skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94051050'),
('94051050:2X', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94051050:2X'),
('94051091', '--- Druhov používaných so žiarovkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94051091'),
('94051098', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94051098'),
('940520', '- Elektrické svietidlá na stôl, na písací stôl, na nočný stolík alebo svietidlá na postavenie na podlahu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940520'),
('940520:2X', '-- Z plastov alebo z keramických materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940520:2X'),
('94052011', '--- Z plastov, druhov používaných so žiarovkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94052011'),
('94052040', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94052040'),
('94052050', '-- Zo skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94052050'),
('94052050:2X', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94052050:2X'),
('94052091', '--- Druhov používaných so žiarovkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94052091'),
('94052099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94052099'),
('94053000', '- Elektrické osvetľovacie súpravy druhu používaného na vianočné stromčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94053000'),
('940540', '- Ostatné elektrické svietidlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940540'),
('94054010', '-- Svetlomety a reflektory', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054010'),
('94054010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054010:2X'),
('94054010:3X', '--- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054010:3X'),
('94054031', '---- Druhov používaných so žiarovkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054031'),
('94054035', '---- Druhov používaných so žiarovkovými trubicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054035'),
('94054039', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054039'),
('94054039:2X', '--- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054039:2X'),
('94054091', '---- Druhov používaných so žiarovkami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054091'),
('94054095', '---- Druhov používaných so žiarovkovými trubicami', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054095'),
('94054099', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94054099'),
('94055000', '- Neelektrické svietidlá a osvetľovacie zariadenia', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94055000'),
('940560', '- Svetelné reklamy, svetelné znaky a značky, svetelné oznamovacie tabule a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940560'),
('94056020', '-- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94056020'),
('94056080', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94056080'),
('94056080:2X', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94056080:2X'),
('940591', '-- Zo skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940591'),
('94059110', '--- Potreby pre elektrické osvetľovacie zariadenia (okrem svetlometov a reflektorov)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94059110'),
('94059190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94059190'),
('94059200', '-- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94059200'),
('94059900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94059900'),
('940600', 'Montované stavby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_940600'),
('94060011', '- Mobilné domy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94060011'),
('94060011:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94060011:2X'),
('94060020', '-- Z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94060020'),
('94060020:2X', '-- Zo železa alebo ocele', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94060020:2X'),
('94060031', '--- Skleníky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94060031'),
('94060038', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94060038'),
('94060080', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_94060080'),
('950300', 'Trojkolky, kolobežky, šliapacie autá a podobné detské vozidlá; kočíky pre bábiky; bábiky; ostatné hračky; zmenšené modely a podobné modely na hranie, tiež mechanické; skladačky všetkých druhov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950300'),
('95030010', '- Trojkolky, kolobežky, šliapacie autá a podobné detské vozidielka; kočíky pre bábiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030010'),
('95030010:2X', '- Bábiky predstavujúce len ľudské bytosti a ich časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030010:2X'),
('95030021', '-- Bábiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030021'),
('95030029', '-- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030029'),
('95030030', '- Elektrické vláčiky, vrátane koľajníc, signalizačného zariadenia a ostatného príslušenstva; zmenšené modely na zostavovanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030030'),
('95030030:2X', '- Ostatné súpravy stavebníc a stavebnicové hračky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030030:2X'),
('95030035', '-- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030035'),
('95030039', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030039'),
('95030039:2X', '- Hračky predstavujúce zvieratá alebo bytosti iné ako ľudské', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030039:2X'),
('95030041', '-- Vypchané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030041'),
('95030049', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030049'),
('95030055', '- Hudobné nástroje a prístroje ako hračky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030055'),
('95030055:2X', '- Skladačky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030055:2X'),
('95030061', '-- Z dreva', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030061'),
('95030069', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030069'),
('95030070', '- Ostatné hračky tvoriace súpravy alebo zbierky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030070'),
('95030070:2X', '- Ostatné motorové hračky a modely', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030070:2X'),
('95030075', '-- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030075'),
('95030079', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030079'),
('95030079:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030079:2X'),
('95030081', '-- Detské zbrane (hračky)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030081'),
('95030085', '-- Miniatúrne modely liate pod tlakom z kovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030085'),
('95030085:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030085:2X'),
('95030095', '--- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030095'),
('95030099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95030099'),
('9504', 'Konzoly a zariadenia na videohry, potreby na lunaparkové, stolné alebo spoločenské hry, vrátane mechanických hier, biliardov, špeciálnych stolov pre herne a kasína a zariadenia pre automatické kolkárske dráhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9504'),
('95042000', '- Potreby a príslušenstvo pre biliardy všetkých druhov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95042000'),
('950430', '- Ostatné hry fungujúce po vložení mince, bankovky, bankovej karty, žetóny alebo iného platidla, okrem zariadení pre automatické kolkárske dráhy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950430'),
('95043010', '-- Hry s obrazovkou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_95043010'),
('95043020', '-- Ostatné hry', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_95043020'),
('95043090', '-- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95043090'),
('95044000', '- Hracie karty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95044000'),
('95045000', '- Konzoly a zariadenia na videohry, okrem konzol a zariadení na videohry podpoložky 9504 30', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95045000'),
('950490', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950490'),
('95049010', '-- Súpravy elektrických pretekárskych autíčok, ktoré majú povahu súťažných hier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95049010'),
('95049080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95049080'),
('9505', 'Výrobky na slávnosti, karnevaly alebo na ostatné zábavy, vrátane kúzelníckych rekvizít a žartovných výrobkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9505'),
('950510', '- Vianočné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950510'),
('95051010', '-- Zo skla', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95051010'),
('95051090', '-- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95051090'),
('95059000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95059000'),
('9506', 'Výrobky a potreby na telesné cvičenie, na gymnastiku, atletiku alebo na ostatné športy (vrátane stolného tenisu) alebo na hry vonku, v tejto kapitole inde nešpecifikované ani nezahrnuté; plavecké a veslárske bazény', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9506'),
('9506:2X', '- Lyže (snehové) a ostatné lyžiarske potreby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9506:2X'),
('950611', '-- Lyže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950611'),
('95061110', '--- Bežecké lyže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_95061110'),
('95061110:2X', '--- Zjazdárske lyže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95061110:2X'),
('95061121', '---- Monolyže a snowboardy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_95061121'),
('95061129', '---- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_95061129'),
('95061180', '--- Ostatné lyže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_95061180'),
('95061200', '-- Viazanie na lyže', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95061200'),
('95061900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95061900'),
('95061900:2X', '- Vodné lyže, surfové dosky, surfové dosky s plachtou a ostatné potreby na vodné športy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95061900:2X'),
('95062100', '-- Surfové dosky s plachtou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95062100'),
('95062900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95062900'),
('95062900:2X', '- Golfové palice a ostatné golfové potreby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95062900:2X'),
('95063100', '-- Palice, úplné súpravy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_95063100'),
('95063200', '-- Loptičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_95063200'),
('950639', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950639'),
('95063910', '--- Časti golfových palíc', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95063910'),
('95063990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95063990'),
('95064000', '- Výrobky a potreby na stolný tenis', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95064000'),
('95064000:2X', '- Tenisové, badmintonové alebo podobné rakety, tiež bez výpletu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95064000:2X'),
('95065100', '-- Tenisové rakety, tiež bez výpletu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95065100'),
('95065900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95065900'),
('95065900:2X', '- Lopty a loptičky, iné ako golfové loptičky a loptičky na stolný tenis', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95065900:2X'),
('95066100', '-- Tenisové loptičky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95066100'),
('95066200', '-- Nafukovacie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95066200'),
('950669', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950669'),
('95066910', '--- Kriketové loptičky a lopty na pólo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95066910'),
('95066990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95066990'),
('950670', '- Korčule a kolieskové korčule vrátane obuvi, na ktorú sú korčule pripevnené', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950670'),
('95067010', '-- Korčule', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_95067010'),
('95067030', '-- Kolieskové korčule', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NPR'), 'SK_95067030'),
('95067090', '-- Časti, súčasti a príslušenstvo', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95067090'),
('95067090:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95067090:2X'),
('950691', '-- Výrobky a potreby na telocvik, gymnastiku alebo atletiku', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950691'),
('95069110', '--- Tréningové prístroje s mechanizmom prispôsobenia odporu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95069110'),
('95069190', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95069190'),
('950699', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950699'),
('95069910', '--- Vybavenie na kriket a pólo, iné ako lopty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95069910'),
('95069990', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95069990'),
('9507', 'Rybárske prúty, udice, rybárske háčiky a ostatné rybárske potreby na udice; podberáky, sieťky na motýle a podobné sieťky; umelé návnady (iné ako zatriedené v položke 9208 alebo 9705) a podobné lovecké alebo strelecké potreby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9507'),
('95071000', '- Rybárske prúty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95071000'),
('950720', '- Rybárske háčiky, tiež naviazané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_950720'),
('95072010', '-- Rybárske háčiky nenaviazané', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95072010'),
('95072090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95072090'),
('95073000', '- Rybárske navijaky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95073000'),
('95079000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95079000'),
('9508', 'Kolotoče, hojdačky, strelnice a ostatné jarmočné atrakcie; putovné cirkusy a putovné zverince; divadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9508'),
('95081000', '- Putovné cirkusy a putovné zverince', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95081000'),
('95089000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_95089000'),
('9601', 'Opracovaná slonovina, kosť, korytnačina, rohovina, parohy, koraly, perleť a ostatné živočíšne rezbárske materiály, a výrobky z týchto materiálov (vrátane výrobkov získaných tvarovaním)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9601'),
('96011000', '- Opracovaná slonovina a výrobky zo slonoviny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96011000'),
('96019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96019000'),
('96020000', 'Opracované rastlinné alebo nerastné rezbárske materiály a výrobky z týchto materiálov; výrobky tvarované alebo vyrezávané z vosku, stearínu, prírodného kaučuku alebo prírodných živíc alebo modelovacích pást, a ostatné tvarované alebo vyrezávané výrobky,', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96020000'),
('9603', 'Metly, zmetáky, kefy, kefky, štetky a štetce (vrátane tých, ktoré tvoria časti strojov, prístrojov alebo vozidiel), ručné mechanické metly bez motora, mopy a oprašovače z peria; pripravené zväzky na výrobu metiel alebo kief a štetcov; maliarske vankúšik', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9603'),
('96031000', '- Metly, zmetáky, kefy, kefky, štetky a štetce, pozostávajúce z prútikov alebo ostatných rastlinných materiálov zviazaných do zväzkov, tiež s násadou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96031000'),
('96031000:2X', '- Zubné kefky, kefky a štetky na holenie, kefy na vlasy, kefky na nechty, kefky na mihalnice a ostatné toaletné kefy a kefky na osobné použitie, vrátane tých, ktoré tvoria časti prístrojov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96031000:2X'),
('96032100', '-- Zubné kefky vrátane kefiek na zubné protézy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96032100'),
('960329', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_960329'),
('96032930', '--- Kefy na vlasy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96032930'),
('96032980', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96032980'),
('960330', '- Kefy a štetce pre umelcov, štetce na písanie a podobné štetce na nanášanie kozmetických prípravkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_960330'),
('96033010', '-- Kefy a štetce pre umelcov a štetce na písanie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96033010'),
('96033090', '-- Štetce na nanášanie kozmetických prípravkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96033090'),
('960340', '- Maliarske, natieračské, lakovacie alebo podobné kefy a štetce (iné ako kefy a štetce podpoložky 9603 30); maliarske vankúšiky a valčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_960340'),
('96034010', '-- Maliarske, natieračské, lakovacie alebo podobné kefy a štetce', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96034010'),
('96034090', '-- Maliarske vankúšiky a valčeky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96034090'),
('96035000', '- Ostatné kefy a kefky tvoriace časti strojov, prístrojov alebo vozidiel', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96035000'),
('960390', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_960390'),
('96039010', '-- Ručné mechanické metly, bez motora', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96039010'),
('96039010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96039010:2X'),
('96039091', '--- Zametacie kefy na čistenie ulíc; metly, zmetáky a kefy pre domácnosť, vrátane kief na obuv alebo kief na odevy; kefy na česanie alebo čistenie zvierat', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96039091'),
('96039099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96039099'),
('96040000', 'Ručné sitá a ručné riečice', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96040000'),
('96050000', 'Cestovné súpravy na osobnú toaletu, šitie alebo čistenie obuvi alebo odevov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96050000'),
('9606', 'Gombíky, stláčacie gombíky, formy na gombíky a ostatné časti a súčasti gombíkov alebo stláčacích gombíkov; gombíkové polotovary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9606'),
('96061000', '- Stláčacie gombíky a patentné gombíky a ich časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96061000'),
('96061000:2X', '- Gombíky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96061000:2X'),
('96062100', '-- Z plastov, nepokryté textilným materiálom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96062100'),
('96062200', '-- Zo základného kovu, nepokryté textilným materiálom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96062200'),
('96062900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96062900'),
('96063000', '- Formy na gombíky a ostatné časti gombíkov; gombíkové polotovary', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96063000'),
('9607', 'Zipsy a ich časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9607'),
('9607:2X', '- Zipsy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9607:2X'),
('96071100', '-- S článkami zo základného kovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_96071100'),
('96071900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_MTR'), 'SK_96071900'),
('960720', '- Časti a súčasti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_960720'),
('96072010', '-- Zo základného kovu, vrátane úzkych pásikov vybavených článkami zo základného kovu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96072010'),
('96072090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96072090'),
('9608', 'Guľôčkové perá; popisovače, značkovače a zvýrazňovače s plsteným hrotom a ostatnými pórovitými hrotmi; plniace perá, rysovacie perá a ostatné perá; rydlá na rozmnožovače; patentné ceruzky; násadky na perá, rúčky na ceruzky a podobné výrobky; časti (vrát', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9608'),
('960810', '- Guľôčkové perá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_960810'),
('96081010', '-- S tekutým atramentom', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96081010'),
('96081010:2X', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96081010:2X'),
('96081092', '--- S vymeniteľnou náplňou', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96081092'),
('96081099', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96081099'),
('96082000', '- Popisovače, značkovače a zvýrazňovače s plsteným hrotom a ostatnými pórovitými hrotmi', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96082000'),
('96083000', '- Plniace perá, rysovacie perá a ostatné perá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96083000'),
('96084000', '- Patentné ceruzky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96084000'),
('96085000', '- Súpravy výrobkov dvoch alebo viacerých predchádzajúcich podpoložiek', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96085000'),
('96086000', '- Náhradné náplne do guľôčkových pier, skladajúce sa z guľôčkového hrotu a zásobníka náplne', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96086000'),
('96086000:2X', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96086000:2X'),
('96089100', '-- Hroty a špičky pier', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96089100'),
('96089900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96089900'),
('9609', 'Ceruzky (iné ako ceruzky položky 9608), pastelky, tuhy, pastely, kresliace uhle, písacie alebo kresliace kriedy a krajčírske kriedy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9609'),
('960910', '- Ceruzky a pastelky s tuhou v pevnom plášti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_960910'),
('96091010', '-- S tuhou z grafitu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96091010'),
('96091090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96091090'),
('96092000', '- Tuhy do ceruziek, čierne alebo farebné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96092000'),
('960990', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_960990'),
('96099010', '-- Pastelky a kresliace uhle', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96099010'),
('96099090', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96099090'),
('96100000', 'Bridlicové tabuľky a tabule, na písanie alebo na kreslenie, tiež zarámované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96100000'),
('96110000', 'Dátovacie, pečatiace alebo číslovacie razidlá a podobné výrobky (vrátane strojčekov na tlač alebo na vytláčanie štítkov), ručné; ručné sádzadlá a malé ručné tlačiarenské súpravy obsahujúce takéto sádzadlá', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96110000'),
('9612', 'Pásky do písacích strojov alebo podobné pásky, napustené tlačiarenskou čerňou alebo inak pripravené na zanechanie odtlačkov, tiež na cievkach alebo v kazetách; pečiatkovacie vankúšiky, tiež napustené, tiež v škatuľkách', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9612'),
('961210', '- Písace pásky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_961210'),
('96121010', '-- Z plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96121010'),
('96121020', '-- Z chemických vlákien, so šírkou menej ako 30 mm, trvale zamontované v plastových alebo kovových kazetách druhov používaných v automatických písacích strojoch, zariadeniach na automatické spracovanie údajov a ostatných strojoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96121020'),
('96121080', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96121080'),
('96122000', '- Pečiatkovacie vankúšiky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96122000'),
('9613', 'Zapaľovače cigariet a ostatné zapaľovače, tiež mechanické alebo elektrické, a ich časti iné ako kamienky a knôty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9613'),
('96131000', '- Plynové vreckové zapaľovače, znovu nenaplniteľné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96131000'),
('96132000', '- Plynové vreckové zapaľovače, znovu naplniteľné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_NAR'), 'SK_96132000'),
('96138000', '- Ostatné zapaľovače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96138000'),
('96139000', '- Časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96139000'),
('961400', 'Fajky (vrátane fajkových hláv), cigarové alebo cigaretové špičky a ich časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_961400'),
('96140010', '- Hrubotvarované bloky (polotovary) z dreva alebo koreňa, na výrobu fajok', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96140010'),
('96140090', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96140090'),
('9615', 'Hrebene na česanie, hrebene do vlasov a podobné výrobky; vlásenky, sponky do vlasov, natáčky, pripínadlá a podobné výrobky, iné ako výrobky položky 8516, a ich časti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9615'),
('9615:2X', '- Hrebene na česanie, hrebene do vlasov a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9615:2X'),
('96151100', '-- Z tvrdeného kaučuku alebo plastov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96151100'),
('96151900', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96151900'),
('96159000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96159000'),
('9616', 'Rozprašovače voňaviek a podobné toaletné rozprašovače, ich rozprašovacie zariadenia a hlavy; labutienky a pudrovadlá na nanášanie kozmetických alebo toaletných prípravkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9616'),
('961610', '- Rozprašovače voňaviek a podobné toaletné rozprašovače, ich rozprašovacie zariadenia a hlavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_961610'),
('96161010', '-- Toaletné rozprašovače', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96161010'),
('96161090', '-- Rozprašovacie zariadenia a hlavy', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96161090'),
('96162000', '- Labutienky a pudrovadlá na nanášanie kozmetických alebo toaletných prípravkov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96162000'),
('96170000', 'Termosky a ostatné izolačné nádoby, kompletné s puzdrom; ich časti iné ako sklenené vložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96170000'),
('96180000', 'Krajčírske panny a ostatné figuríny; automaty a ostatné oživené scény do výkladných skríň', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96180000'),
('961900', 'Hygienické vložky a tampóny, detské plienky a prebaly pre deti, a podobné výrobky, z akéhokoľvek materiálu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_961900'),
('961900:2X', '- Z papieroviny, papiera, buničitej vaty alebo pásov splstených buničinových vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_961900:2X'),
('961900:3X', '-- Hygienické vložky, tampóny a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_961900:3X'),
('96190011', '--- Hygienické vložky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190011'),
('96190013', '--- Tampóny', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190013'),
('96190019', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190019'),
('96190019:2X', '-- Detské plienky a prebaly pre deti, a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190019:2X'),
('96190021', '--- Detské plienky a prebaly pre deti', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190021'),
('96190029', '--- Ostatné (napríklad výrobky na starostlivosť pri inkontinencii)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190029'),
('96190029:2X', '- Z vaty z textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190029:2X'),
('96190031', '-- Z chemických vlákien', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190031'),
('96190039', '-- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190039'),
('96190039:2X', '- Z ostatných textilných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190039:2X'),
('96190039:3X', '-- Hygienické vložky, tampóny a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190039:3X'),
('96190041', '--- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190041'),
('96190049', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190049'),
('96190049:2X', '-- Detské plienky a prebaly pre deti, a podobné výrobky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190049:2X'),
('96190051', '--- Pletené alebo háčkované', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190051'),
('96190059', '--- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190059'),
('96190090', '- Z ostatných materiálov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_96190090'),
('9701', 'Obrazy, maľby a kresby, zhotovené celkom ručne, okrem výkresov položky 4906 a ručne maľovaných alebo ozdobených priemyselných výrobkov; koláže a podobné obrázky', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9701'),
('97011000', '- Obrazy, maľby a kresby', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_97011000'),
('97019000', '- Ostatné', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_97019000'),
('97020000', 'Pôvodné rytiny, pôvodné tlače a pôvodné litografie', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_97020000'),
('97030000', 'Pôvodné sochy a súsošia, z akéhokoľvek materiálu', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_97030000'),
('97040000', 'Poštové alebo kolkové známky, odtlačky poštových pečiatok, obálky prvého dňa, poštové ceniny a podobné výrobky, použité alebo nepoužité, iné ako zatriedené do položky 4907', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_97040000'),
('97050000', 'Zbierky a zberateľské predmety zoologickej, botanickej, mineralogickej, anatomickej, historickej, archeologickej, paleontologickej, etnografickej alebo numizmatickej hodnoty', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_97050000'),
('97060000', 'Starožitnosti staršie ako 100 rokov', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_97060000'),
('9880', 'Súčasti kompletných priemyselných podnikov v rámci zahraničného obchodu (nariadenie Komisie ES č. 113/2010 zo 9.02.2010)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9880'),
('98800100', '- Zatriedené v kapitole 01', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98800100'),
('98800200', '- Zatriedené v kapitole 02', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98800200'),
('98800300', '- Zatriedené v kapitole 03', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98800300'),
('98800400', '- Zatriedené v kapitole 04', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98800400'),
('98800500', '- Zatriedené v kapitole 05', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98800500'),
('98800600', '- Zatriedené v kapitole 06', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98800600'),
('98800700', '- Zatriedené v kapitole 07', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98800700'),
('98800800', '- Zatriedené v kapitole 08', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98800800'),
('98800900', '- Zatriedené v kapitole 09', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98800900'),
('98801000', '- Zatriedené v kapitole 10', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801000'),
('98801100', '- Zatriedené v kapitole 11', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801100'),
('98801200', '- Zatriedené v kapitole 12', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801200'),
('98801300', '- Zatriedené v kapitole 13', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801300'),
('98801400', '- Zatriedené v kapitole 14', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801400'),
('98801500', '- Zatriedené v kapitole 15', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801500'),
('98801600', '- Zatriedené v kapitole 16', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801600'),
('98801700', '- Zatriedené v kapitole 17', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801700'),
('98801800', '- Zatriedené v kapitole 18', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801800'),
('98801900', '- Zatriedené v kapitole 19', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98801900'),
('98802000', '- Zatriedené v kapitole 20', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802000'),
('98802100', '- Zatriedené v kapitole 21', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802100'),
('98802200', '- Zatriedené v kapitole 22', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802200'),
('98802300', '- Zatriedené v kapitole 23', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802300'),
('98802400', '- Zatriedené v kapitole 24', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802400'),
('98802500', '- Zatriedené v kapitole 25', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802500'),
('98802600', '- Zatriedené v kapitole 26', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802600'),
('98802700', '- Zatriedené v kapitole 27', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802700'),
('98802800', '- Zatriedené v kapitole 28', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802800'),
('98802900', '- Zatriedené v kapitole 29', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98802900'),
('98803000', '- Zatriedené v kapitole 30', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803000'),
('98803100', '- Zatriedené v kapitole 31', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803100'),
('98803200', '- Zatriedené v kapitole 32', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803200'),
('98803300', '- Zatriedené v kapitole 33', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803300'),
('98803400', '- Zatriedené v kapitole 34', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803400'),
('98803500', '- Zatriedené v kapitole 35', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803500'),
('98803600', '- Zatriedené v kapitole 36', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803600'),
('98803700', '- Zatriedené v kapitole 37', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803700'),
('98803800', '- Zatriedené v kapitole 38', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803800'),
('98803900', '- Zatriedené v kapitole 39', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98803900'),
('98804000', '- Zatriedené v kapitole 40', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804000'),
('98804100', '- Zatriedené v kapitole 41', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804100'),
('98804200', '- Zatriedené v kapitole 42', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804200'),
('98804300', '- Zatriedené v kapitole 43', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804300'),
('98804400', '- Zatriedené v kapitole 44', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804400'),
('98804500', '- Zatriedené v kapitole 45', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804500'),
('98804600', '- Zatriedené v kapitole 46', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804600'),
('98804700', '- Zatriedené v kapitole 47', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804700'),
('98804800', '- Zatriedené v kapitole 48', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804800'),
('98804900', '- Zatriedené v kapitole 49', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98804900'),
('98805000', '- Zatriedené v kapitole 50', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805000'),
('98805100', '- Zatriedené v kapitole 51', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805100'),
('98805200', '- Zatriedené v kapitole 52', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805200'),
('98805300', '- Zatriedené v kapitole 53', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805300'),
('98805400', '- Zatriedené v kapitole 54', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805400'),
('98805500', '- Zatriedené v kapitole 55', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805500'),
('98805600', '- Zatriedené v kapitole 56', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805600'),
('98805700', '- Zatriedené v kapitole 57', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805700'),
('98805800', '- Zatriedené v kapitole 58', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805800'),
('98805900', '- Zatriedené v kapitole 59', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98805900'),
('98806000', '- Zatriedené v kapitole 60', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806000'),
('98806100', '- Zatriedené v kapitole 61', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806100'),
('98806200', '- Zatriedené v kapitole 62', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806200'),
('98806300', '- Zatriedené v kapitole 63', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806300'),
('98806400', '- Zatriedené v kapitole 64', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806400'),
('98806500', '- Zatriedené v kapitole 65', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806500'),
('98806600', '- Zatriedené v kapitole 66', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806600'),
('98806700', '- Zatriedené v kapitole 67', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806700'),
('98806800', '- Zatriedené v kapitole 68', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806800'),
('98806900', '- Zatriedené v kapitole 69', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98806900'),
('98807000', '- Zatriedené v kapitole 70', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98807000'),
('98807100', '- Zatriedené v kapitole 71', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98807100'),
('98807200', '- Zatriedené v kapitole 72', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98807200'),
('98807300', '- Zatriedené v kapitole 73', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98807300'),
('98807400', '- Zatriedené v kapitole 74', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98807400'),
('98807500', '- Zatriedené v kapitole 75', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98807500'),
('98807600', '- Zatriedené v kapitole 76', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98807600'),
('98807800', '- Zatriedené v kapitole 78', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98807800'),
('98807900', '- Zatriedené v kapitole 79', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98807900'),
('98808000', '- Zatriedené v kapitole 80', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808000'),
('98808100', '- Zatriedené v kapitole 81', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808100'),
('98808200', '- Zatriedené v kapitole 82', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808200'),
('98808300', '- Zatriedené v kapitole 83', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808300'),
('98808400', '- Zatriedené v kapitole 84', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808400'),
('98808500', '- Zatriedené v kapitole 85', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808500'),
('98808600', '- Zatriedené v kapitole 86', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808600'),
('98808700', '- Zatriedené v kapitole 87', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808700'),
('98808800', '- Zatriedené v kapitole 88', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808800'),
('98808900', '- Zatriedené v kapitole 89', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98808900'),
('98809000', '- Zatriedené v kapitole 90', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98809000'),
('98809100', '- Zatriedené v kapitole 91', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98809100'),
('98809200', '- Zatriedené v kapitole 92', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98809200'),
('98809300', '- Zatriedené v kapitole 93', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98809300'),
('98809400', '- Zatriedené v kapitole 94', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98809400'),
('98809500', '- Zatriedené v kapitole 95', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98809500'),
('98809600', '- Zatriedené v kapitole 96', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98809600'),
('98809700', '- Zatriedené v kapitole 97', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98809700'),
('98848419', 'Špec. kód - použitie len po schválení ŠÚ SR', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98848419'),
('98848419:2X', 'Určité druhy tovaru ustanovené v nariadení Rady (ES) č. 1186/2009 (dovoz a vývoz)', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_98848419:2X'),
('99050000', '- Osobný majetok fyzických osôb, ktoré menia miesto svojho bydliska', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_99050000'),
('99190000', '- Tieto druhy tovaru, iné ako uvedené v predchádzajúcom: - Výbava a zariadenie domácnosti patriace osobe, ktorá mení svoje bydlisko z dôvodu uzatvorenia manželstva; osobný majetok nadobudnutý dedením. - Školská výbava, študijné potreby a vybavenie domácn', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_99190000'),
('9930', 'Tovary dodávané lodiam a lietadlám', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9930'),
('99302400', '- Klasifikované do kapitol KN 1 až 24', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_99302400'),
('99302700', '- Klasifikované do kapitoly KN 27', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_99302700'),
('99309900', '- Klasifikované inde', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_99309900'),
('9931', 'Tovar dodávaný posádke inštalácií na šírom mori alebo na prevádzku motorov, zariadení a iného vybavenia inštalácií na šírom mori', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_9931'),
('99312400', '- Klasifikované do kapitol KN 1 až 24', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_99312400'),
('99312700', '- Klasifikované do kapitoly KN 27', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_99312700'),
('99319900', '- Klasifikované inde', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_99319900'),
('99500000', 'Kód používaný len na účely obchodovania medzi členskými štátmi pre individuálne transakcie, ktorých hodnota je menšia ako 200 EUR a na účely vykazovania zvyškových produktov v niektorých prípadoch', (select IdIntrMerJed from iIntrMerJed where uuid = 'SK_ZZZ'), 'SK_99500000');

-- konec slovenskeho bloku
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

------------------------------------------------------------------------------
-- Oprava plneni policek pro intrastat na vygenerovanych skladovych dokladech
------------------------------------------------------------------------------
-- Function: createdoklsklad(integer, integer, character varying)
-- DROP FUNCTION createdoklsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _doklad record; 
  _polDokl record; 
  _doklSklad record; 
  _idDoklSklad integer; 
  _cisDoklad character varying; 
  _idrada integer; 
  _rada record; 
  _sklad record; 
  _idUcetObd integer; 
  _radaRok record; 
  _typPohybuSklad character varying; 
  _idTypUcOp integer; 
  _cisloDokladuCursor refCursor; 
  _typDoklFak record; 
  _typDoklSkl record; 
  _idUcetSklad integer; 
  _idProtiUcet integer; 
  _typUcOp record; 
  _kurz numeric(19,6); 
  _idMenyTuzemsko integer; 
  _idMenySklad integer; 
  _kurzMnozstvi numeric(19,6); 
  _typVazby character varying; 
  _stavSklad character varying; 
  _typPohybuSkladK character varying; 
  _isDobropis boolean; 
  _datSklad date;  
  _ucetObdPlatiOd date; 
  _ucetObdPlatiDo date; 
begin 
  if(_modul like 'POK') then 
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad; 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenPokl'; 
  elsif (_modul like 'FAV' or _modul like 'FAP') then 
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad; 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenFakt'; 
  else 
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad; 
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl; 
    _stavSklad = 'stavSklad.vyroba'; 
  end if; 
 
  --select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu; 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl; 
 
  if(_typDoklFak.typDoklK like 'typDokladu.dobropis') then 
    _isDobropis = true; 
  else 
    _isDobropis = false; 
  end if; 
  
  if(_doklad.idTypDoklSkl is null) then  
    if((_modul like 'FAV' and _isDobropis) or (_modul like 'FAP')) then 
      --pro dobropisy vydanych faktur a prijate faktury budeme mit prijemku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem; 
    elsif((_modul like 'FAV' and not _isDobropis)) then 
      --pro dobropisy prijatych faktur a vydane faktury budeme mit vydejku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.prijem') then 
      --pro prijmovy pokladni doklad budeme mit vydejku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.vydej') then 
      --pro vydajovy pokladni doklad budeme mit prijemku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem; 
    elsif(_modul like 'SKL') then 
      -- vyroba 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    else 
      raise exception 'createdoklsklad:Nespravny modul %', _modul; 
    end if; 
    if(_typDoklSkl is null) then 
      return null; 
    end if; 
  else 
    select * into _typDoklSkl from dTypDokl where idTypDokl = _doklad.idTypDoklSkl; 
  end if; 
 
  -- urceni spravneho typu pohybu 
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then 
    _typPohybuSklad = _doklad.typPohybuK; 
  else 
    if(_doklad.typPohybuK like 'typPohybu.prijem') then 
      _typPohybuSklad = 'typPohybu.vydej'; 
    else 
      _typPohybuSklad = 'typPohybu.prijem'; 
    end if; 
  end if; 
 
  -- doplneni zbyvajicich veci zavislich na typu pohybu 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idrada = _typDoklSkl.idRadyPrijem; 
    if(_idrada is null) then 
      _idRada = _sklad.idRadyPrijem; 
    end if; 
    if(_idRada is null) then 
      raise exception 'Neni odkud natahnout dokladovou radu.'; 
    end if; 
    _idTypUcOp = _typDoklSkl.idTypUcOpP; 
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
      _typPohybuSkladK = 'typPohybuSklad.prijemPoFak'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.prijemVyrob'; 
    end if; 
  else 
    _idrada = _typDoklSkl.idRadyVydej; 
    if(_idrada is null) then 
      _idRada = _sklad.idRadyVydej; 
    end if; 
    if(_idRada is null) then 
      raise exception 'Neni odkud natahnout dokladovou radu.'; 
    end if; 
    _idTypUcOp = _typDoklSkl.idTypUcOpV; 
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
      _typPohybuSkladK = 'typPohybuSklad.vydejPoFak'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.vydejVyrob'; 
    end if; 
  end if; 
 
  _idUcetSklad = _sklad.idPrimUcet; 
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp; 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idProtiUcet = _typUcOp.idProtiucetP; 
  else 
    _idProtiUcet = _typUcOp.idProtiucetV; 
  end if; 
  if(_modul = 'FAP') then 
    _idProtiUcet = _doklad.idProtiUcet; 
  end if; 
 
  select * into _rada from drady where idRady = _idrada; 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd; 
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada; 
 
  select nextval('seq_ddoklsklad') into _idDoklSklad; 
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor; 
  fetch _cisloDokladuCursor into _cisDoklad; 
 
  -- ziskani kurzu pro menu skladu 
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz; 
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1 
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1; 
  if (_idMenyTuzemsko is null) then 
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1; 
  end if; 
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
 
  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then 
    _kurz = 0.0; 
    _kurzMnozstvi = 1; 
  else 
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny' 
      order by PlatiOdData desc limit 1; 
    if(_kurz is null) then 
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
        where idMeny = _sklad.idMeny and PlatiOdData is null and typkurzuk = 'typKurzu.obecny' 
        limit 1; 
    end if; 
    if(_kurz is null) then 
      raise exception '0001:getKurzFromSklad : neexistuje kurz!'; 
    end if; 
  end if; 
 
  /*select CURRENT_DATE into _datSklad; 
  select platiOdData, platiDoData into _ucetObdPlatiOd, _ucetObdPlatiDo from nucetobdobi where idUcetObdobi = _idUcetObd; 
  if(_datSklad < _ucetObdPlatiOd) then 
    _datSklad = _ucetObdPlatiOd; 
  elsif (_datSklad > _ucetObdPlatiDo) then 
    _datSklad = _ucetObdPlatiDo; 
  else 
    -- datSklad je v pohode 
  end if;*/ 
  _datSklad = _doklad.datVyst; 
  
  if(_isDobropis) then 
    if(_modul like 'FAV') then 
      _typPohybuSkladK = 'typPohybuSklad.prijemVratka'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.prijemVydejVratka'; 
    end if; 
  end if; 
 
  -- vytvoreni noveho skladoveho dokladu 
  insert into dDoklSklad (idDoklSklad, lastUpdate, datVyst, datSklad, datUcto, kod, modul, typPohybuK, idTypDokl, idBsp,ucetni, varSym, 
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId, 
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam, 
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi, 
         eanKod, idstatpuvod, idstatodesl, idobchtrans, iddodpodm, idzvlpoh,
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK , typPohybuSkladK, 
         idCinnost, idKontaktOsoba, idZodpOsoba 
         ) 
       values (_idDoklSklad, LOCALTIMESTAMP, _doklad.datVyst, _datSklad, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _typDoklSkl.idTypDokl, _sklad.idBsp, _typDoklSkl.ucetni, _doklad.varSym, 
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId, 
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam, 
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi, 
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl, _doklad.idobchtrans, _doklad.iddodpodm, _doklad.idzvlpoh,
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad, _typPohybuSkladK, 
         _doklad.idCinnost, _doklad.idKontaktOsoba, _doklad.idZodpOsoba 
         ); 
 
 
  if (_modul = 'SKL') then 
    _typVazby = 'typVazbyDokl.hlavaSklKus'; 
  else 
    _typVazby = 'typVazbyDokl.hlavaSkl'; 
  end if; 
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby); 
 
  return _idDoklSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 586, 't', %appVersion%, clock_timestamp());
